from google.api import annotations_pb2 as _annotations_pb2
from google.api import client_pb2 as _client_pb2
from google.api import field_behavior_pb2 as _field_behavior_pb2
from google.api import resource_pb2 as _resource_pb2
from google.longrunning import operations_pb2 as _operations_pb2
from google.protobuf import field_mask_pb2 as _field_mask_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.type import date_pb2 as _date_pb2
from google.type import dayofweek_pb2 as _dayofweek_pb2
from google.type import timeofday_pb2 as _timeofday_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Report(_message.Message):
    __slots__ = ("name", "report_id", "visibility", "report_definition", "display_name", "update_time", "create_time", "locale", "schedule_options")
    class TimePeriodColumn(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        TIME_PERIOD_COLUMN_UNSPECIFIED: _ClassVar[Report.TimePeriodColumn]
        TIME_PERIOD_COLUMN_DATE: _ClassVar[Report.TimePeriodColumn]
        TIME_PERIOD_COLUMN_WEEK: _ClassVar[Report.TimePeriodColumn]
        TIME_PERIOD_COLUMN_MONTH: _ClassVar[Report.TimePeriodColumn]
        TIME_PERIOD_COLUMN_QUARTER: _ClassVar[Report.TimePeriodColumn]
    TIME_PERIOD_COLUMN_UNSPECIFIED: Report.TimePeriodColumn
    TIME_PERIOD_COLUMN_DATE: Report.TimePeriodColumn
    TIME_PERIOD_COLUMN_WEEK: Report.TimePeriodColumn
    TIME_PERIOD_COLUMN_MONTH: Report.TimePeriodColumn
    TIME_PERIOD_COLUMN_QUARTER: Report.TimePeriodColumn
    class Dimension(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        DIMENSION_UNSPECIFIED: _ClassVar[Report.Dimension]
        ADVERTISER_DOMAIN_NAME: _ClassVar[Report.Dimension]
        ADVERTISER_EXTERNAL_ID: _ClassVar[Report.Dimension]
        ADVERTISER_ID: _ClassVar[Report.Dimension]
        ADVERTISER_LABELS: _ClassVar[Report.Dimension]
        ADVERTISER_LABEL_IDS: _ClassVar[Report.Dimension]
        ADVERTISER_NAME: _ClassVar[Report.Dimension]
        ADVERTISER_PRIMARY_CONTACT: _ClassVar[Report.Dimension]
        AD_LOCATION: _ClassVar[Report.Dimension]
        AD_LOCATION_NAME: _ClassVar[Report.Dimension]
        AD_UNIT_CODE: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_1: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_10: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_11: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_12: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_13: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_14: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_15: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_16: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_2: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_3: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_4: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_5: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_6: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_7: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_8: _ClassVar[Report.Dimension]
        AD_UNIT_CODE_LEVEL_9: _ClassVar[Report.Dimension]
        AD_UNIT_DEPTH: _ClassVar[Report.Dimension]
        AD_UNIT_ID: _ClassVar[Report.Dimension]
        AD_UNIT_ID_ALL_LEVEL: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_1: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_10: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_11: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_12: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_13: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_14: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_15: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_16: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_2: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_3: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_4: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_5: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_6: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_7: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_8: _ClassVar[Report.Dimension]
        AD_UNIT_ID_LEVEL_9: _ClassVar[Report.Dimension]
        AD_UNIT_ID_TOP_LEVEL: _ClassVar[Report.Dimension]
        AD_UNIT_NAME: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_ALL_LEVEL: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_1: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_10: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_11: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_12: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_13: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_14: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_15: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_16: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_2: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_3: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_4: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_5: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_6: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_7: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_8: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_LEVEL_9: _ClassVar[Report.Dimension]
        AD_UNIT_NAME_TOP_LEVEL: _ClassVar[Report.Dimension]
        AD_UNIT_REWARD_AMOUNT: _ClassVar[Report.Dimension]
        AD_UNIT_REWARD_TYPE: _ClassVar[Report.Dimension]
        AD_UNIT_STATUS: _ClassVar[Report.Dimension]
        AD_UNIT_STATUS_NAME: _ClassVar[Report.Dimension]
        APP_VERSION: _ClassVar[Report.Dimension]
        BACKFILL_ADVERTISER_EXTERNAL_ID: _ClassVar[Report.Dimension]
        BACKFILL_ADVERTISER_ID: _ClassVar[Report.Dimension]
        BACKFILL_ADVERTISER_LABELS: _ClassVar[Report.Dimension]
        BACKFILL_ADVERTISER_LABEL_IDS: _ClassVar[Report.Dimension]
        BACKFILL_ADVERTISER_NAME: _ClassVar[Report.Dimension]
        BACKFILL_ADVERTISER_PRIMARY_CONTACT: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_BILLING_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_BILLING_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CLICK_THROUGH_URL: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_THIRD_PARTY_VENDOR: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_ARCHIVED: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_COMPANION_DELIVERY_OPTION: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_COMPANION_DELIVERY_OPTION_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_COMPUTED_STATUS: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_COMPUTED_STATUS_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CONTRACTED_QUANTITY: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_COST_PER_UNIT: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_COST_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_COST_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CREATIVE_END_DATE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CREATIVE_ROTATION_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CREATIVE_ROTATION_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CREATIVE_START_DATE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CURRENCY_CODE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_DELIVERY_INDICATOR: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_DELIVERY_RATE_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_DELIVERY_RATE_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_DISCOUNT_ABSOLUTE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_DISCOUNT_PERCENTAGE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_END_DATE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_END_DATE_TIME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_ENVIRONMENT_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_ENVIRONMENT_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_EXTERNAL_DEAL_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_EXTERNAL_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_FREQUENCY_CAP: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_LAST_MODIFIED_BY_APP: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_LIFETIME_CLICKS: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_LIFETIME_IMPRESSIONS: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_LIFETIME_VIEWABLE_IMPRESSIONS: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_MAKEGOOD: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_NON_CPD_BOOKED_REVENUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_OPTIMIZABLE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_PRIMARY_GOAL_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_PRIMARY_GOAL_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_PRIORITY: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_RESERVATION_STATUS: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_RESERVATION_STATUS_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_START_DATE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_START_DATE_TIME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_TYPE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_TYPE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_UNLIMITED_END: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_VALUE_COST_PER_UNIT: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_WEB_PROPERTY_CODE: _ClassVar[Report.Dimension]
        BACKFILL_MASTER_COMPANION_CREATIVE_ID: _ClassVar[Report.Dimension]
        BACKFILL_MASTER_COMPANION_CREATIVE_NAME: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_AGENCY: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_AGENCY_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_BOOKED_CPC: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_BOOKED_CPM: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_DELIVERY_STATUS: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_DELIVERY_STATUS_NAME: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_END_DATE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_END_DATE_TIME: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_EXTERNAL_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_LABELS: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_LABEL_IDS: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_LIFETIME_CLICKS: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_LIFETIME_IMPRESSIONS: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_NAME: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_PO_NUMBER: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_PROGRAMMATIC: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_SALESPERSON: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_SECONDARY_SALESPEOPLE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_SECONDARY_SALESPEOPLE_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_SECONDARY_TRAFFICKERS: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_SECONDARY_TRAFFICKERS_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_START_DATE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_START_DATE_TIME: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_TRAFFICKER: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_TRAFFICKER_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_UNLIMITED_END: _ClassVar[Report.Dimension]
        BACKFILL_PROGRAMMATIC_BUYER_ID: _ClassVar[Report.Dimension]
        BACKFILL_PROGRAMMATIC_BUYER_NAME: _ClassVar[Report.Dimension]
        BRANDING_TYPE: _ClassVar[Report.Dimension]
        BRANDING_TYPE_NAME: _ClassVar[Report.Dimension]
        BROWSER_CATEGORY: _ClassVar[Report.Dimension]
        BROWSER_CATEGORY_NAME: _ClassVar[Report.Dimension]
        BROWSER_ID: _ClassVar[Report.Dimension]
        BROWSER_NAME: _ClassVar[Report.Dimension]
        CARRIER_ID: _ClassVar[Report.Dimension]
        CARRIER_NAME: _ClassVar[Report.Dimension]
        CLASSIFIED_ADVERTISER_ID: _ClassVar[Report.Dimension]
        CLASSIFIED_ADVERTISER_NAME: _ClassVar[Report.Dimension]
        CLASSIFIED_BRAND_ID: _ClassVar[Report.Dimension]
        CLASSIFIED_BRAND_NAME: _ClassVar[Report.Dimension]
        CONTENT_ID: _ClassVar[Report.Dimension]
        CONTENT_NAME: _ClassVar[Report.Dimension]
        COUNTRY_ID: _ClassVar[Report.Dimension]
        COUNTRY_NAME: _ClassVar[Report.Dimension]
        CREATIVE_BILLING_TYPE: _ClassVar[Report.Dimension]
        CREATIVE_BILLING_TYPE_NAME: _ClassVar[Report.Dimension]
        CREATIVE_CLICK_THROUGH_URL: _ClassVar[Report.Dimension]
        CREATIVE_ID: _ClassVar[Report.Dimension]
        CREATIVE_NAME: _ClassVar[Report.Dimension]
        CREATIVE_TECHNOLOGY: _ClassVar[Report.Dimension]
        CREATIVE_TECHNOLOGY_NAME: _ClassVar[Report.Dimension]
        CREATIVE_THIRD_PARTY_VENDOR: _ClassVar[Report.Dimension]
        CREATIVE_TYPE: _ClassVar[Report.Dimension]
        CREATIVE_TYPE_NAME: _ClassVar[Report.Dimension]
        DATE: _ClassVar[Report.Dimension]
        DAY_OF_WEEK: _ClassVar[Report.Dimension]
        DEMAND_CHANNEL: _ClassVar[Report.Dimension]
        DEMAND_CHANNEL_NAME: _ClassVar[Report.Dimension]
        DEMAND_SUBCHANNEL: _ClassVar[Report.Dimension]
        DEMAND_SUBCHANNEL_NAME: _ClassVar[Report.Dimension]
        DEVICE: _ClassVar[Report.Dimension]
        DEVICE_CATEGORY: _ClassVar[Report.Dimension]
        DEVICE_CATEGORY_NAME: _ClassVar[Report.Dimension]
        DEVICE_NAME: _ClassVar[Report.Dimension]
        EXCHANGE_THIRD_PARTY_COMPANY_ID: _ClassVar[Report.Dimension]
        EXCHANGE_THIRD_PARTY_COMPANY_NAME: _ClassVar[Report.Dimension]
        FIRST_LOOK_PRICING_RULE_ID: _ClassVar[Report.Dimension]
        FIRST_LOOK_PRICING_RULE_NAME: _ClassVar[Report.Dimension]
        HOUR: _ClassVar[Report.Dimension]
        INTERACTION_TYPE: _ClassVar[Report.Dimension]
        INTERACTION_TYPE_NAME: _ClassVar[Report.Dimension]
        INVENTORY_FORMAT: _ClassVar[Report.Dimension]
        INVENTORY_FORMAT_NAME: _ClassVar[Report.Dimension]
        INVENTORY_TYPE: _ClassVar[Report.Dimension]
        INVENTORY_TYPE_NAME: _ClassVar[Report.Dimension]
        IS_ADX_DIRECT: _ClassVar[Report.Dimension]
        IS_FIRST_LOOK_DEAL: _ClassVar[Report.Dimension]
        KEY_VALUES_ID: _ClassVar[Report.Dimension]
        KEY_VALUES_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_ARCHIVED: _ClassVar[Report.Dimension]
        LINE_ITEM_COMPANION_DELIVERY_OPTION: _ClassVar[Report.Dimension]
        LINE_ITEM_COMPANION_DELIVERY_OPTION_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_COMPUTED_STATUS: _ClassVar[Report.Dimension]
        LINE_ITEM_COMPUTED_STATUS_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_CONTRACTED_QUANTITY: _ClassVar[Report.Dimension]
        LINE_ITEM_COST_PER_UNIT: _ClassVar[Report.Dimension]
        LINE_ITEM_COST_TYPE: _ClassVar[Report.Dimension]
        LINE_ITEM_COST_TYPE_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_CREATIVE_END_DATE: _ClassVar[Report.Dimension]
        LINE_ITEM_CREATIVE_ROTATION_TYPE: _ClassVar[Report.Dimension]
        LINE_ITEM_CREATIVE_ROTATION_TYPE_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_CREATIVE_START_DATE: _ClassVar[Report.Dimension]
        LINE_ITEM_CURRENCY_CODE: _ClassVar[Report.Dimension]
        LINE_ITEM_DELIVERY_INDICATOR: _ClassVar[Report.Dimension]
        LINE_ITEM_DELIVERY_RATE_TYPE: _ClassVar[Report.Dimension]
        LINE_ITEM_DELIVERY_RATE_TYPE_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_DISCOUNT_ABSOLUTE: _ClassVar[Report.Dimension]
        LINE_ITEM_DISCOUNT_PERCENTAGE: _ClassVar[Report.Dimension]
        LINE_ITEM_END_DATE: _ClassVar[Report.Dimension]
        LINE_ITEM_END_DATE_TIME: _ClassVar[Report.Dimension]
        LINE_ITEM_ENVIRONMENT_TYPE: _ClassVar[Report.Dimension]
        LINE_ITEM_ENVIRONMENT_TYPE_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_EXTERNAL_DEAL_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_EXTERNAL_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_FREQUENCY_CAP: _ClassVar[Report.Dimension]
        LINE_ITEM_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_LAST_MODIFIED_BY_APP: _ClassVar[Report.Dimension]
        LINE_ITEM_LIFETIME_CLICKS: _ClassVar[Report.Dimension]
        LINE_ITEM_LIFETIME_IMPRESSIONS: _ClassVar[Report.Dimension]
        LINE_ITEM_LIFETIME_VIEWABLE_IMPRESSIONS: _ClassVar[Report.Dimension]
        LINE_ITEM_MAKEGOOD: _ClassVar[Report.Dimension]
        LINE_ITEM_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_NON_CPD_BOOKED_REVENUE: _ClassVar[Report.Dimension]
        LINE_ITEM_OPTIMIZABLE: _ClassVar[Report.Dimension]
        LINE_ITEM_PRIMARY_GOAL_TYPE: _ClassVar[Report.Dimension]
        LINE_ITEM_PRIMARY_GOAL_TYPE_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_PRIMARY_GOAL_UNITS_ABSOLUTE: _ClassVar[Report.Dimension]
        LINE_ITEM_PRIMARY_GOAL_UNITS_PERCENTAGE: _ClassVar[Report.Dimension]
        LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE: _ClassVar[Report.Dimension]
        LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_PRIORITY: _ClassVar[Report.Dimension]
        LINE_ITEM_RESERVATION_STATUS: _ClassVar[Report.Dimension]
        LINE_ITEM_RESERVATION_STATUS_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_START_DATE: _ClassVar[Report.Dimension]
        LINE_ITEM_START_DATE_TIME: _ClassVar[Report.Dimension]
        LINE_ITEM_TYPE: _ClassVar[Report.Dimension]
        LINE_ITEM_TYPE_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_UNLIMITED_END: _ClassVar[Report.Dimension]
        LINE_ITEM_VALUE_COST_PER_UNIT: _ClassVar[Report.Dimension]
        LINE_ITEM_WEB_PROPERTY_CODE: _ClassVar[Report.Dimension]
        MASTER_COMPANION_CREATIVE_ID: _ClassVar[Report.Dimension]
        MASTER_COMPANION_CREATIVE_NAME: _ClassVar[Report.Dimension]
        MOBILE_APP_FREE: _ClassVar[Report.Dimension]
        MOBILE_APP_ICON_URL: _ClassVar[Report.Dimension]
        MOBILE_APP_ID: _ClassVar[Report.Dimension]
        MOBILE_APP_NAME: _ClassVar[Report.Dimension]
        MOBILE_APP_OWNERSHIP_STATUS: _ClassVar[Report.Dimension]
        MOBILE_APP_OWNERSHIP_STATUS_NAME: _ClassVar[Report.Dimension]
        MOBILE_APP_STORE: _ClassVar[Report.Dimension]
        MOBILE_APP_STORE_NAME: _ClassVar[Report.Dimension]
        MOBILE_INVENTORY_TYPE: _ClassVar[Report.Dimension]
        MOBILE_INVENTORY_TYPE_NAME: _ClassVar[Report.Dimension]
        MOBILE_SDK_VERSION_NAME: _ClassVar[Report.Dimension]
        MONTH_YEAR: _ClassVar[Report.Dimension]
        NATIVE_AD_FORMAT_ID: _ClassVar[Report.Dimension]
        NATIVE_AD_FORMAT_NAME: _ClassVar[Report.Dimension]
        NATIVE_STYLE_ID: _ClassVar[Report.Dimension]
        NATIVE_STYLE_NAME: _ClassVar[Report.Dimension]
        OPERATING_SYSTEM_CATEGORY: _ClassVar[Report.Dimension]
        OPERATING_SYSTEM_CATEGORY_NAME: _ClassVar[Report.Dimension]
        OPERATING_SYSTEM_VERSION_ID: _ClassVar[Report.Dimension]
        OPERATING_SYSTEM_VERSION_NAME: _ClassVar[Report.Dimension]
        ORDER_AGENCY: _ClassVar[Report.Dimension]
        ORDER_AGENCY_ID: _ClassVar[Report.Dimension]
        ORDER_BOOKED_CPC: _ClassVar[Report.Dimension]
        ORDER_BOOKED_CPM: _ClassVar[Report.Dimension]
        ORDER_DELIVERY_STATUS: _ClassVar[Report.Dimension]
        ORDER_DELIVERY_STATUS_NAME: _ClassVar[Report.Dimension]
        ORDER_END_DATE: _ClassVar[Report.Dimension]
        ORDER_END_DATE_TIME: _ClassVar[Report.Dimension]
        ORDER_EXTERNAL_ID: _ClassVar[Report.Dimension]
        ORDER_ID: _ClassVar[Report.Dimension]
        ORDER_LABELS: _ClassVar[Report.Dimension]
        ORDER_LABEL_IDS: _ClassVar[Report.Dimension]
        ORDER_LIFETIME_CLICKS: _ClassVar[Report.Dimension]
        ORDER_LIFETIME_IMPRESSIONS: _ClassVar[Report.Dimension]
        ORDER_NAME: _ClassVar[Report.Dimension]
        ORDER_PO_NUMBER: _ClassVar[Report.Dimension]
        ORDER_PROGRAMMATIC: _ClassVar[Report.Dimension]
        ORDER_SALESPERSON: _ClassVar[Report.Dimension]
        ORDER_SECONDARY_SALESPEOPLE: _ClassVar[Report.Dimension]
        ORDER_SECONDARY_SALESPEOPLE_ID: _ClassVar[Report.Dimension]
        ORDER_SECONDARY_TRAFFICKERS: _ClassVar[Report.Dimension]
        ORDER_SECONDARY_TRAFFICKERS_ID: _ClassVar[Report.Dimension]
        ORDER_START_DATE: _ClassVar[Report.Dimension]
        ORDER_START_DATE_TIME: _ClassVar[Report.Dimension]
        ORDER_TRAFFICKER: _ClassVar[Report.Dimension]
        ORDER_TRAFFICKER_ID: _ClassVar[Report.Dimension]
        ORDER_UNLIMITED_END: _ClassVar[Report.Dimension]
        PLACEMENT_ID: _ClassVar[Report.Dimension]
        PLACEMENT_ID_ALL: _ClassVar[Report.Dimension]
        PLACEMENT_NAME: _ClassVar[Report.Dimension]
        PLACEMENT_NAME_ALL: _ClassVar[Report.Dimension]
        PLACEMENT_STATUS: _ClassVar[Report.Dimension]
        PLACEMENT_STATUS_ALL: _ClassVar[Report.Dimension]
        PLACEMENT_STATUS_NAME: _ClassVar[Report.Dimension]
        PLACEMENT_STATUS_NAME_ALL: _ClassVar[Report.Dimension]
        PROGRAMMATIC_BUYER_ID: _ClassVar[Report.Dimension]
        PROGRAMMATIC_BUYER_NAME: _ClassVar[Report.Dimension]
        PROGRAMMATIC_CHANNEL: _ClassVar[Report.Dimension]
        PROGRAMMATIC_CHANNEL_NAME: _ClassVar[Report.Dimension]
        RENDERED_CREATIVE_SIZE: _ClassVar[Report.Dimension]
        REQUESTED_AD_SIZES: _ClassVar[Report.Dimension]
        REQUEST_TYPE: _ClassVar[Report.Dimension]
        REQUEST_TYPE_NAME: _ClassVar[Report.Dimension]
        SITE: _ClassVar[Report.Dimension]
        TARGETING_ID: _ClassVar[Report.Dimension]
        TARGETING_NAME: _ClassVar[Report.Dimension]
        TARGETING_TYPE: _ClassVar[Report.Dimension]
        TARGETING_TYPE_NAME: _ClassVar[Report.Dimension]
        TRAFFIC_SOURCE: _ClassVar[Report.Dimension]
        TRAFFIC_SOURCE_NAME: _ClassVar[Report.Dimension]
        UNIFIED_PRICING_RULE_ID: _ClassVar[Report.Dimension]
        UNIFIED_PRICING_RULE_NAME: _ClassVar[Report.Dimension]
        VIDEO_PLCMT: _ClassVar[Report.Dimension]
        VIDEO_PLCMT_NAME: _ClassVar[Report.Dimension]
        WEEK: _ClassVar[Report.Dimension]
        YIELD_GROUP_BUYER_NAME: _ClassVar[Report.Dimension]
        YIELD_GROUP_ID: _ClassVar[Report.Dimension]
        YIELD_GROUP_NAME: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_0_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_1_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_2_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_3_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_4_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_5_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_6_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_7_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_8_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_9_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_10_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_11_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_12_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_13_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_14_OPTION_ID: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_0_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_1_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_2_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_3_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_4_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_5_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_6_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_7_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_8_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_9_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_10_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_11_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_12_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_13_VALUE: _ClassVar[Report.Dimension]
        LINE_ITEM_CUSTOM_FIELD_14_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_0_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_1_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_2_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_3_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_4_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_5_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_6_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_7_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_8_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_9_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_10_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_11_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_12_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_13_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_14_OPTION_ID: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_0_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_1_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_2_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_3_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_4_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_5_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_6_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_7_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_8_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_9_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_10_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_11_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_12_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_13_VALUE: _ClassVar[Report.Dimension]
        ORDER_CUSTOM_FIELD_14_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_0_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_1_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_2_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_3_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_4_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_5_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_6_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_7_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_8_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_9_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_10_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_11_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_12_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_13_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_14_OPTION_ID: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_0_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_1_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_2_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_3_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_4_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_5_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_6_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_7_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_8_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_9_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_10_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_11_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_12_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_13_VALUE: _ClassVar[Report.Dimension]
        CREATIVE_CUSTOM_FIELD_14_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_0_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_1_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_2_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_3_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_4_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_5_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_6_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_7_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_8_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_9_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_10_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_11_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_12_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_13_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_14_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_0_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_1_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_2_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_3_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_4_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_5_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_6_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_7_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_8_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_9_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_10_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_11_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_12_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_13_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_LINE_ITEM_CUSTOM_FIELD_14_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_0_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_1_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_2_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_3_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_4_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_5_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_6_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_7_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_8_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_9_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_10_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_11_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_12_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_13_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_14_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_0_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_1_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_2_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_3_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_4_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_5_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_6_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_7_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_8_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_9_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_10_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_11_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_12_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_13_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_ORDER_CUSTOM_FIELD_14_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_0_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_1_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_2_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_3_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_4_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_5_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_6_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_7_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_8_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_9_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_10_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_11_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_12_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_13_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_14_OPTION_ID: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_0_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_1_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_2_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_3_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_4_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_5_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_6_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_7_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_8_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_9_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_10_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_11_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_12_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_13_VALUE: _ClassVar[Report.Dimension]
        BACKFILL_CREATIVE_CUSTOM_FIELD_14_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_0_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_1_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_2_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_3_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_4_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_5_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_6_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_7_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_8_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_9_VALUE_ID: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_0_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_1_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_2_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_3_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_4_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_5_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_6_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_7_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_8_VALUE: _ClassVar[Report.Dimension]
        CUSTOM_DIMENSION_9_VALUE: _ClassVar[Report.Dimension]
    DIMENSION_UNSPECIFIED: Report.Dimension
    ADVERTISER_DOMAIN_NAME: Report.Dimension
    ADVERTISER_EXTERNAL_ID: Report.Dimension
    ADVERTISER_ID: Report.Dimension
    ADVERTISER_LABELS: Report.Dimension
    ADVERTISER_LABEL_IDS: Report.Dimension
    ADVERTISER_NAME: Report.Dimension
    ADVERTISER_PRIMARY_CONTACT: Report.Dimension
    AD_LOCATION: Report.Dimension
    AD_LOCATION_NAME: Report.Dimension
    AD_UNIT_CODE: Report.Dimension
    AD_UNIT_CODE_LEVEL_1: Report.Dimension
    AD_UNIT_CODE_LEVEL_10: Report.Dimension
    AD_UNIT_CODE_LEVEL_11: Report.Dimension
    AD_UNIT_CODE_LEVEL_12: Report.Dimension
    AD_UNIT_CODE_LEVEL_13: Report.Dimension
    AD_UNIT_CODE_LEVEL_14: Report.Dimension
    AD_UNIT_CODE_LEVEL_15: Report.Dimension
    AD_UNIT_CODE_LEVEL_16: Report.Dimension
    AD_UNIT_CODE_LEVEL_2: Report.Dimension
    AD_UNIT_CODE_LEVEL_3: Report.Dimension
    AD_UNIT_CODE_LEVEL_4: Report.Dimension
    AD_UNIT_CODE_LEVEL_5: Report.Dimension
    AD_UNIT_CODE_LEVEL_6: Report.Dimension
    AD_UNIT_CODE_LEVEL_7: Report.Dimension
    AD_UNIT_CODE_LEVEL_8: Report.Dimension
    AD_UNIT_CODE_LEVEL_9: Report.Dimension
    AD_UNIT_DEPTH: Report.Dimension
    AD_UNIT_ID: Report.Dimension
    AD_UNIT_ID_ALL_LEVEL: Report.Dimension
    AD_UNIT_ID_LEVEL_1: Report.Dimension
    AD_UNIT_ID_LEVEL_10: Report.Dimension
    AD_UNIT_ID_LEVEL_11: Report.Dimension
    AD_UNIT_ID_LEVEL_12: Report.Dimension
    AD_UNIT_ID_LEVEL_13: Report.Dimension
    AD_UNIT_ID_LEVEL_14: Report.Dimension
    AD_UNIT_ID_LEVEL_15: Report.Dimension
    AD_UNIT_ID_LEVEL_16: Report.Dimension
    AD_UNIT_ID_LEVEL_2: Report.Dimension
    AD_UNIT_ID_LEVEL_3: Report.Dimension
    AD_UNIT_ID_LEVEL_4: Report.Dimension
    AD_UNIT_ID_LEVEL_5: Report.Dimension
    AD_UNIT_ID_LEVEL_6: Report.Dimension
    AD_UNIT_ID_LEVEL_7: Report.Dimension
    AD_UNIT_ID_LEVEL_8: Report.Dimension
    AD_UNIT_ID_LEVEL_9: Report.Dimension
    AD_UNIT_ID_TOP_LEVEL: Report.Dimension
    AD_UNIT_NAME: Report.Dimension
    AD_UNIT_NAME_ALL_LEVEL: Report.Dimension
    AD_UNIT_NAME_LEVEL_1: Report.Dimension
    AD_UNIT_NAME_LEVEL_10: Report.Dimension
    AD_UNIT_NAME_LEVEL_11: Report.Dimension
    AD_UNIT_NAME_LEVEL_12: Report.Dimension
    AD_UNIT_NAME_LEVEL_13: Report.Dimension
    AD_UNIT_NAME_LEVEL_14: Report.Dimension
    AD_UNIT_NAME_LEVEL_15: Report.Dimension
    AD_UNIT_NAME_LEVEL_16: Report.Dimension
    AD_UNIT_NAME_LEVEL_2: Report.Dimension
    AD_UNIT_NAME_LEVEL_3: Report.Dimension
    AD_UNIT_NAME_LEVEL_4: Report.Dimension
    AD_UNIT_NAME_LEVEL_5: Report.Dimension
    AD_UNIT_NAME_LEVEL_6: Report.Dimension
    AD_UNIT_NAME_LEVEL_7: Report.Dimension
    AD_UNIT_NAME_LEVEL_8: Report.Dimension
    AD_UNIT_NAME_LEVEL_9: Report.Dimension
    AD_UNIT_NAME_TOP_LEVEL: Report.Dimension
    AD_UNIT_REWARD_AMOUNT: Report.Dimension
    AD_UNIT_REWARD_TYPE: Report.Dimension
    AD_UNIT_STATUS: Report.Dimension
    AD_UNIT_STATUS_NAME: Report.Dimension
    APP_VERSION: Report.Dimension
    BACKFILL_ADVERTISER_EXTERNAL_ID: Report.Dimension
    BACKFILL_ADVERTISER_ID: Report.Dimension
    BACKFILL_ADVERTISER_LABELS: Report.Dimension
    BACKFILL_ADVERTISER_LABEL_IDS: Report.Dimension
    BACKFILL_ADVERTISER_NAME: Report.Dimension
    BACKFILL_ADVERTISER_PRIMARY_CONTACT: Report.Dimension
    BACKFILL_CREATIVE_BILLING_TYPE: Report.Dimension
    BACKFILL_CREATIVE_BILLING_TYPE_NAME: Report.Dimension
    BACKFILL_CREATIVE_CLICK_THROUGH_URL: Report.Dimension
    BACKFILL_CREATIVE_ID: Report.Dimension
    BACKFILL_CREATIVE_NAME: Report.Dimension
    BACKFILL_CREATIVE_THIRD_PARTY_VENDOR: Report.Dimension
    BACKFILL_CREATIVE_TYPE: Report.Dimension
    BACKFILL_CREATIVE_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_ARCHIVED: Report.Dimension
    BACKFILL_LINE_ITEM_COMPANION_DELIVERY_OPTION: Report.Dimension
    BACKFILL_LINE_ITEM_COMPANION_DELIVERY_OPTION_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_COMPUTED_STATUS: Report.Dimension
    BACKFILL_LINE_ITEM_COMPUTED_STATUS_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_CONTRACTED_QUANTITY: Report.Dimension
    BACKFILL_LINE_ITEM_COST_PER_UNIT: Report.Dimension
    BACKFILL_LINE_ITEM_COST_TYPE: Report.Dimension
    BACKFILL_LINE_ITEM_COST_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_CREATIVE_END_DATE: Report.Dimension
    BACKFILL_LINE_ITEM_CREATIVE_ROTATION_TYPE: Report.Dimension
    BACKFILL_LINE_ITEM_CREATIVE_ROTATION_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_CREATIVE_START_DATE: Report.Dimension
    BACKFILL_LINE_ITEM_CURRENCY_CODE: Report.Dimension
    BACKFILL_LINE_ITEM_DELIVERY_INDICATOR: Report.Dimension
    BACKFILL_LINE_ITEM_DELIVERY_RATE_TYPE: Report.Dimension
    BACKFILL_LINE_ITEM_DELIVERY_RATE_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_DISCOUNT_ABSOLUTE: Report.Dimension
    BACKFILL_LINE_ITEM_DISCOUNT_PERCENTAGE: Report.Dimension
    BACKFILL_LINE_ITEM_END_DATE: Report.Dimension
    BACKFILL_LINE_ITEM_END_DATE_TIME: Report.Dimension
    BACKFILL_LINE_ITEM_ENVIRONMENT_TYPE: Report.Dimension
    BACKFILL_LINE_ITEM_ENVIRONMENT_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_EXTERNAL_DEAL_ID: Report.Dimension
    BACKFILL_LINE_ITEM_EXTERNAL_ID: Report.Dimension
    BACKFILL_LINE_ITEM_FREQUENCY_CAP: Report.Dimension
    BACKFILL_LINE_ITEM_ID: Report.Dimension
    BACKFILL_LINE_ITEM_LAST_MODIFIED_BY_APP: Report.Dimension
    BACKFILL_LINE_ITEM_LIFETIME_CLICKS: Report.Dimension
    BACKFILL_LINE_ITEM_LIFETIME_IMPRESSIONS: Report.Dimension
    BACKFILL_LINE_ITEM_LIFETIME_VIEWABLE_IMPRESSIONS: Report.Dimension
    BACKFILL_LINE_ITEM_MAKEGOOD: Report.Dimension
    BACKFILL_LINE_ITEM_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_NON_CPD_BOOKED_REVENUE: Report.Dimension
    BACKFILL_LINE_ITEM_OPTIMIZABLE: Report.Dimension
    BACKFILL_LINE_ITEM_PRIMARY_GOAL_TYPE: Report.Dimension
    BACKFILL_LINE_ITEM_PRIMARY_GOAL_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE: Report.Dimension
    BACKFILL_LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_PRIORITY: Report.Dimension
    BACKFILL_LINE_ITEM_RESERVATION_STATUS: Report.Dimension
    BACKFILL_LINE_ITEM_RESERVATION_STATUS_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_START_DATE: Report.Dimension
    BACKFILL_LINE_ITEM_START_DATE_TIME: Report.Dimension
    BACKFILL_LINE_ITEM_TYPE: Report.Dimension
    BACKFILL_LINE_ITEM_TYPE_NAME: Report.Dimension
    BACKFILL_LINE_ITEM_UNLIMITED_END: Report.Dimension
    BACKFILL_LINE_ITEM_VALUE_COST_PER_UNIT: Report.Dimension
    BACKFILL_LINE_ITEM_WEB_PROPERTY_CODE: Report.Dimension
    BACKFILL_MASTER_COMPANION_CREATIVE_ID: Report.Dimension
    BACKFILL_MASTER_COMPANION_CREATIVE_NAME: Report.Dimension
    BACKFILL_ORDER_AGENCY: Report.Dimension
    BACKFILL_ORDER_AGENCY_ID: Report.Dimension
    BACKFILL_ORDER_BOOKED_CPC: Report.Dimension
    BACKFILL_ORDER_BOOKED_CPM: Report.Dimension
    BACKFILL_ORDER_DELIVERY_STATUS: Report.Dimension
    BACKFILL_ORDER_DELIVERY_STATUS_NAME: Report.Dimension
    BACKFILL_ORDER_END_DATE: Report.Dimension
    BACKFILL_ORDER_END_DATE_TIME: Report.Dimension
    BACKFILL_ORDER_EXTERNAL_ID: Report.Dimension
    BACKFILL_ORDER_ID: Report.Dimension
    BACKFILL_ORDER_LABELS: Report.Dimension
    BACKFILL_ORDER_LABEL_IDS: Report.Dimension
    BACKFILL_ORDER_LIFETIME_CLICKS: Report.Dimension
    BACKFILL_ORDER_LIFETIME_IMPRESSIONS: Report.Dimension
    BACKFILL_ORDER_NAME: Report.Dimension
    BACKFILL_ORDER_PO_NUMBER: Report.Dimension
    BACKFILL_ORDER_PROGRAMMATIC: Report.Dimension
    BACKFILL_ORDER_SALESPERSON: Report.Dimension
    BACKFILL_ORDER_SECONDARY_SALESPEOPLE: Report.Dimension
    BACKFILL_ORDER_SECONDARY_SALESPEOPLE_ID: Report.Dimension
    BACKFILL_ORDER_SECONDARY_TRAFFICKERS: Report.Dimension
    BACKFILL_ORDER_SECONDARY_TRAFFICKERS_ID: Report.Dimension
    BACKFILL_ORDER_START_DATE: Report.Dimension
    BACKFILL_ORDER_START_DATE_TIME: Report.Dimension
    BACKFILL_ORDER_TRAFFICKER: Report.Dimension
    BACKFILL_ORDER_TRAFFICKER_ID: Report.Dimension
    BACKFILL_ORDER_UNLIMITED_END: Report.Dimension
    BACKFILL_PROGRAMMATIC_BUYER_ID: Report.Dimension
    BACKFILL_PROGRAMMATIC_BUYER_NAME: Report.Dimension
    BRANDING_TYPE: Report.Dimension
    BRANDING_TYPE_NAME: Report.Dimension
    BROWSER_CATEGORY: Report.Dimension
    BROWSER_CATEGORY_NAME: Report.Dimension
    BROWSER_ID: Report.Dimension
    BROWSER_NAME: Report.Dimension
    CARRIER_ID: Report.Dimension
    CARRIER_NAME: Report.Dimension
    CLASSIFIED_ADVERTISER_ID: Report.Dimension
    CLASSIFIED_ADVERTISER_NAME: Report.Dimension
    CLASSIFIED_BRAND_ID: Report.Dimension
    CLASSIFIED_BRAND_NAME: Report.Dimension
    CONTENT_ID: Report.Dimension
    CONTENT_NAME: Report.Dimension
    COUNTRY_ID: Report.Dimension
    COUNTRY_NAME: Report.Dimension
    CREATIVE_BILLING_TYPE: Report.Dimension
    CREATIVE_BILLING_TYPE_NAME: Report.Dimension
    CREATIVE_CLICK_THROUGH_URL: Report.Dimension
    CREATIVE_ID: Report.Dimension
    CREATIVE_NAME: Report.Dimension
    CREATIVE_TECHNOLOGY: Report.Dimension
    CREATIVE_TECHNOLOGY_NAME: Report.Dimension
    CREATIVE_THIRD_PARTY_VENDOR: Report.Dimension
    CREATIVE_TYPE: Report.Dimension
    CREATIVE_TYPE_NAME: Report.Dimension
    DATE: Report.Dimension
    DAY_OF_WEEK: Report.Dimension
    DEMAND_CHANNEL: Report.Dimension
    DEMAND_CHANNEL_NAME: Report.Dimension
    DEMAND_SUBCHANNEL: Report.Dimension
    DEMAND_SUBCHANNEL_NAME: Report.Dimension
    DEVICE: Report.Dimension
    DEVICE_CATEGORY: Report.Dimension
    DEVICE_CATEGORY_NAME: Report.Dimension
    DEVICE_NAME: Report.Dimension
    EXCHANGE_THIRD_PARTY_COMPANY_ID: Report.Dimension
    EXCHANGE_THIRD_PARTY_COMPANY_NAME: Report.Dimension
    FIRST_LOOK_PRICING_RULE_ID: Report.Dimension
    FIRST_LOOK_PRICING_RULE_NAME: Report.Dimension
    HOUR: Report.Dimension
    INTERACTION_TYPE: Report.Dimension
    INTERACTION_TYPE_NAME: Report.Dimension
    INVENTORY_FORMAT: Report.Dimension
    INVENTORY_FORMAT_NAME: Report.Dimension
    INVENTORY_TYPE: Report.Dimension
    INVENTORY_TYPE_NAME: Report.Dimension
    IS_ADX_DIRECT: Report.Dimension
    IS_FIRST_LOOK_DEAL: Report.Dimension
    KEY_VALUES_ID: Report.Dimension
    KEY_VALUES_NAME: Report.Dimension
    LINE_ITEM_ARCHIVED: Report.Dimension
    LINE_ITEM_COMPANION_DELIVERY_OPTION: Report.Dimension
    LINE_ITEM_COMPANION_DELIVERY_OPTION_NAME: Report.Dimension
    LINE_ITEM_COMPUTED_STATUS: Report.Dimension
    LINE_ITEM_COMPUTED_STATUS_NAME: Report.Dimension
    LINE_ITEM_CONTRACTED_QUANTITY: Report.Dimension
    LINE_ITEM_COST_PER_UNIT: Report.Dimension
    LINE_ITEM_COST_TYPE: Report.Dimension
    LINE_ITEM_COST_TYPE_NAME: Report.Dimension
    LINE_ITEM_CREATIVE_END_DATE: Report.Dimension
    LINE_ITEM_CREATIVE_ROTATION_TYPE: Report.Dimension
    LINE_ITEM_CREATIVE_ROTATION_TYPE_NAME: Report.Dimension
    LINE_ITEM_CREATIVE_START_DATE: Report.Dimension
    LINE_ITEM_CURRENCY_CODE: Report.Dimension
    LINE_ITEM_DELIVERY_INDICATOR: Report.Dimension
    LINE_ITEM_DELIVERY_RATE_TYPE: Report.Dimension
    LINE_ITEM_DELIVERY_RATE_TYPE_NAME: Report.Dimension
    LINE_ITEM_DISCOUNT_ABSOLUTE: Report.Dimension
    LINE_ITEM_DISCOUNT_PERCENTAGE: Report.Dimension
    LINE_ITEM_END_DATE: Report.Dimension
    LINE_ITEM_END_DATE_TIME: Report.Dimension
    LINE_ITEM_ENVIRONMENT_TYPE: Report.Dimension
    LINE_ITEM_ENVIRONMENT_TYPE_NAME: Report.Dimension
    LINE_ITEM_EXTERNAL_DEAL_ID: Report.Dimension
    LINE_ITEM_EXTERNAL_ID: Report.Dimension
    LINE_ITEM_FREQUENCY_CAP: Report.Dimension
    LINE_ITEM_ID: Report.Dimension
    LINE_ITEM_LAST_MODIFIED_BY_APP: Report.Dimension
    LINE_ITEM_LIFETIME_CLICKS: Report.Dimension
    LINE_ITEM_LIFETIME_IMPRESSIONS: Report.Dimension
    LINE_ITEM_LIFETIME_VIEWABLE_IMPRESSIONS: Report.Dimension
    LINE_ITEM_MAKEGOOD: Report.Dimension
    LINE_ITEM_NAME: Report.Dimension
    LINE_ITEM_NON_CPD_BOOKED_REVENUE: Report.Dimension
    LINE_ITEM_OPTIMIZABLE: Report.Dimension
    LINE_ITEM_PRIMARY_GOAL_TYPE: Report.Dimension
    LINE_ITEM_PRIMARY_GOAL_TYPE_NAME: Report.Dimension
    LINE_ITEM_PRIMARY_GOAL_UNITS_ABSOLUTE: Report.Dimension
    LINE_ITEM_PRIMARY_GOAL_UNITS_PERCENTAGE: Report.Dimension
    LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE: Report.Dimension
    LINE_ITEM_PRIMARY_GOAL_UNIT_TYPE_NAME: Report.Dimension
    LINE_ITEM_PRIORITY: Report.Dimension
    LINE_ITEM_RESERVATION_STATUS: Report.Dimension
    LINE_ITEM_RESERVATION_STATUS_NAME: Report.Dimension
    LINE_ITEM_START_DATE: Report.Dimension
    LINE_ITEM_START_DATE_TIME: Report.Dimension
    LINE_ITEM_TYPE: Report.Dimension
    LINE_ITEM_TYPE_NAME: Report.Dimension
    LINE_ITEM_UNLIMITED_END: Report.Dimension
    LINE_ITEM_VALUE_COST_PER_UNIT: Report.Dimension
    LINE_ITEM_WEB_PROPERTY_CODE: Report.Dimension
    MASTER_COMPANION_CREATIVE_ID: Report.Dimension
    MASTER_COMPANION_CREATIVE_NAME: Report.Dimension
    MOBILE_APP_FREE: Report.Dimension
    MOBILE_APP_ICON_URL: Report.Dimension
    MOBILE_APP_ID: Report.Dimension
    MOBILE_APP_NAME: Report.Dimension
    MOBILE_APP_OWNERSHIP_STATUS: Report.Dimension
    MOBILE_APP_OWNERSHIP_STATUS_NAME: Report.Dimension
    MOBILE_APP_STORE: Report.Dimension
    MOBILE_APP_STORE_NAME: Report.Dimension
    MOBILE_INVENTORY_TYPE: Report.Dimension
    MOBILE_INVENTORY_TYPE_NAME: Report.Dimension
    MOBILE_SDK_VERSION_NAME: Report.Dimension
    MONTH_YEAR: Report.Dimension
    NATIVE_AD_FORMAT_ID: Report.Dimension
    NATIVE_AD_FORMAT_NAME: Report.Dimension
    NATIVE_STYLE_ID: Report.Dimension
    NATIVE_STYLE_NAME: Report.Dimension
    OPERATING_SYSTEM_CATEGORY: Report.Dimension
    OPERATING_SYSTEM_CATEGORY_NAME: Report.Dimension
    OPERATING_SYSTEM_VERSION_ID: Report.Dimension
    OPERATING_SYSTEM_VERSION_NAME: Report.Dimension
    ORDER_AGENCY: Report.Dimension
    ORDER_AGENCY_ID: Report.Dimension
    ORDER_BOOKED_CPC: Report.Dimension
    ORDER_BOOKED_CPM: Report.Dimension
    ORDER_DELIVERY_STATUS: Report.Dimension
    ORDER_DELIVERY_STATUS_NAME: Report.Dimension
    ORDER_END_DATE: Report.Dimension
    ORDER_END_DATE_TIME: Report.Dimension
    ORDER_EXTERNAL_ID: Report.Dimension
    ORDER_ID: Report.Dimension
    ORDER_LABELS: Report.Dimension
    ORDER_LABEL_IDS: Report.Dimension
    ORDER_LIFETIME_CLICKS: Report.Dimension
    ORDER_LIFETIME_IMPRESSIONS: Report.Dimension
    ORDER_NAME: Report.Dimension
    ORDER_PO_NUMBER: Report.Dimension
    ORDER_PROGRAMMATIC: Report.Dimension
    ORDER_SALESPERSON: Report.Dimension
    ORDER_SECONDARY_SALESPEOPLE: Report.Dimension
    ORDER_SECONDARY_SALESPEOPLE_ID: Report.Dimension
    ORDER_SECONDARY_TRAFFICKERS: Report.Dimension
    ORDER_SECONDARY_TRAFFICKERS_ID: Report.Dimension
    ORDER_START_DATE: Report.Dimension
    ORDER_START_DATE_TIME: Report.Dimension
    ORDER_TRAFFICKER: Report.Dimension
    ORDER_TRAFFICKER_ID: Report.Dimension
    ORDER_UNLIMITED_END: Report.Dimension
    PLACEMENT_ID: Report.Dimension
    PLACEMENT_ID_ALL: Report.Dimension
    PLACEMENT_NAME: Report.Dimension
    PLACEMENT_NAME_ALL: Report.Dimension
    PLACEMENT_STATUS: Report.Dimension
    PLACEMENT_STATUS_ALL: Report.Dimension
    PLACEMENT_STATUS_NAME: Report.Dimension
    PLACEMENT_STATUS_NAME_ALL: Report.Dimension
    PROGRAMMATIC_BUYER_ID: Report.Dimension
    PROGRAMMATIC_BUYER_NAME: Report.Dimension
    PROGRAMMATIC_CHANNEL: Report.Dimension
    PROGRAMMATIC_CHANNEL_NAME: Report.Dimension
    RENDERED_CREATIVE_SIZE: Report.Dimension
    REQUESTED_AD_SIZES: Report.Dimension
    REQUEST_TYPE: Report.Dimension
    REQUEST_TYPE_NAME: Report.Dimension
    SITE: Report.Dimension
    TARGETING_ID: Report.Dimension
    TARGETING_NAME: Report.Dimension
    TARGETING_TYPE: Report.Dimension
    TARGETING_TYPE_NAME: Report.Dimension
    TRAFFIC_SOURCE: Report.Dimension
    TRAFFIC_SOURCE_NAME: Report.Dimension
    UNIFIED_PRICING_RULE_ID: Report.Dimension
    UNIFIED_PRICING_RULE_NAME: Report.Dimension
    VIDEO_PLCMT: Report.Dimension
    VIDEO_PLCMT_NAME: Report.Dimension
    WEEK: Report.Dimension
    YIELD_GROUP_BUYER_NAME: Report.Dimension
    YIELD_GROUP_ID: Report.Dimension
    YIELD_GROUP_NAME: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_0_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_1_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_2_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_3_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_4_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_5_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_6_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_7_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_8_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_9_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_10_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_11_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_12_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_13_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_14_OPTION_ID: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_0_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_1_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_2_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_3_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_4_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_5_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_6_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_7_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_8_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_9_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_10_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_11_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_12_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_13_VALUE: Report.Dimension
    LINE_ITEM_CUSTOM_FIELD_14_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_0_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_1_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_2_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_3_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_4_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_5_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_6_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_7_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_8_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_9_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_10_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_11_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_12_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_13_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_14_OPTION_ID: Report.Dimension
    ORDER_CUSTOM_FIELD_0_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_1_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_2_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_3_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_4_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_5_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_6_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_7_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_8_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_9_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_10_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_11_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_12_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_13_VALUE: Report.Dimension
    ORDER_CUSTOM_FIELD_14_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_0_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_1_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_2_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_3_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_4_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_5_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_6_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_7_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_8_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_9_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_10_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_11_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_12_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_13_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_14_OPTION_ID: Report.Dimension
    CREATIVE_CUSTOM_FIELD_0_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_1_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_2_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_3_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_4_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_5_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_6_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_7_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_8_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_9_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_10_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_11_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_12_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_13_VALUE: Report.Dimension
    CREATIVE_CUSTOM_FIELD_14_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_0_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_1_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_2_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_3_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_4_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_5_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_6_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_7_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_8_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_9_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_10_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_11_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_12_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_13_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_14_OPTION_ID: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_0_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_1_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_2_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_3_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_4_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_5_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_6_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_7_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_8_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_9_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_10_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_11_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_12_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_13_VALUE: Report.Dimension
    BACKFILL_LINE_ITEM_CUSTOM_FIELD_14_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_0_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_1_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_2_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_3_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_4_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_5_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_6_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_7_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_8_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_9_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_10_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_11_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_12_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_13_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_14_OPTION_ID: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_0_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_1_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_2_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_3_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_4_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_5_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_6_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_7_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_8_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_9_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_10_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_11_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_12_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_13_VALUE: Report.Dimension
    BACKFILL_ORDER_CUSTOM_FIELD_14_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_0_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_1_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_2_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_3_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_4_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_5_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_6_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_7_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_8_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_9_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_10_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_11_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_12_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_13_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_14_OPTION_ID: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_0_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_1_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_2_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_3_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_4_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_5_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_6_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_7_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_8_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_9_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_10_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_11_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_12_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_13_VALUE: Report.Dimension
    BACKFILL_CREATIVE_CUSTOM_FIELD_14_VALUE: Report.Dimension
    CUSTOM_DIMENSION_0_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_1_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_2_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_3_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_4_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_5_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_6_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_7_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_8_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_9_VALUE_ID: Report.Dimension
    CUSTOM_DIMENSION_0_VALUE: Report.Dimension
    CUSTOM_DIMENSION_1_VALUE: Report.Dimension
    CUSTOM_DIMENSION_2_VALUE: Report.Dimension
    CUSTOM_DIMENSION_3_VALUE: Report.Dimension
    CUSTOM_DIMENSION_4_VALUE: Report.Dimension
    CUSTOM_DIMENSION_5_VALUE: Report.Dimension
    CUSTOM_DIMENSION_6_VALUE: Report.Dimension
    CUSTOM_DIMENSION_7_VALUE: Report.Dimension
    CUSTOM_DIMENSION_8_VALUE: Report.Dimension
    CUSTOM_DIMENSION_9_VALUE: Report.Dimension
    class Metric(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        METRIC_UNSPECIFIED: _ClassVar[Report.Metric]
        ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: _ClassVar[Report.Metric]
        ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: _ClassVar[Report.Metric]
        ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        ADSENSE_ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: _ClassVar[Report.Metric]
        ADSENSE_ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: _ClassVar[Report.Metric]
        ADSENSE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        ADSENSE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        ADSENSE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        ADSENSE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        ADSENSE_AVERAGE_ECPM: _ClassVar[Report.Metric]
        ADSENSE_CLICKS: _ClassVar[Report.Metric]
        ADSENSE_CTR: _ClassVar[Report.Metric]
        ADSENSE_IMPRESSIONS: _ClassVar[Report.Metric]
        ADSENSE_PERCENT_CLICKS: _ClassVar[Report.Metric]
        ADSENSE_PERCENT_IMPRESSIONS: _ClassVar[Report.Metric]
        ADSENSE_PERCENT_REVENUE: _ClassVar[Report.Metric]
        ADSENSE_PERCENT_REVENUE_WITHOUT_CPD: _ClassVar[Report.Metric]
        ADSENSE_RESPONSES_SERVED: _ClassVar[Report.Metric]
        ADSENSE_REVENUE: _ClassVar[Report.Metric]
        AD_EXCHANGE_ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: _ClassVar[Report.Metric]
        AD_EXCHANGE_ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_EXCHANGE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_EXCHANGE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        AD_EXCHANGE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_EXCHANGE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        AD_EXCHANGE_AVERAGE_ECPM: _ClassVar[Report.Metric]
        AD_EXCHANGE_CLICKS: _ClassVar[Report.Metric]
        AD_EXCHANGE_CTR: _ClassVar[Report.Metric]
        AD_EXCHANGE_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_EXCHANGE_PERCENT_CLICKS: _ClassVar[Report.Metric]
        AD_EXCHANGE_PERCENT_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_EXCHANGE_PERCENT_REVENUE: _ClassVar[Report.Metric]
        AD_EXCHANGE_PERCENT_REVENUE_WITHOUT_CPD: _ClassVar[Report.Metric]
        AD_EXCHANGE_RESPONSES_SERVED: _ClassVar[Report.Metric]
        AD_EXCHANGE_REVENUE: _ClassVar[Report.Metric]
        AD_REQUESTS: _ClassVar[Report.Metric]
        AD_SERVER_ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: _ClassVar[Report.Metric]
        AD_SERVER_ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_SERVER_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_SERVER_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        AD_SERVER_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_SERVER_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: _ClassVar[Report.Metric]
        AD_SERVER_AVERAGE_ECPM: _ClassVar[Report.Metric]
        AD_SERVER_AVERAGE_ECPM_WITHOUT_CPD: _ClassVar[Report.Metric]
        AD_SERVER_CLICKS: _ClassVar[Report.Metric]
        AD_SERVER_CPD_REVENUE: _ClassVar[Report.Metric]
        AD_SERVER_CTR: _ClassVar[Report.Metric]
        AD_SERVER_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_SERVER_PERCENT_CLICKS: _ClassVar[Report.Metric]
        AD_SERVER_PERCENT_IMPRESSIONS: _ClassVar[Report.Metric]
        AD_SERVER_PERCENT_REVENUE: _ClassVar[Report.Metric]
        AD_SERVER_PERCENT_REVENUE_WITHOUT_CPD: _ClassVar[Report.Metric]
        AD_SERVER_RESPONSES_SERVED: _ClassVar[Report.Metric]
        AD_SERVER_REVENUE: _ClassVar[Report.Metric]
        AD_SERVER_REVENUE_WITHOUT_CPD: _ClassVar[Report.Metric]
        AUCTIONS_WON: _ClassVar[Report.Metric]
        AVERAGE_ECPM: _ClassVar[Report.Metric]
        AVERAGE_ECPM_WITHOUT_CPD: _ClassVar[Report.Metric]
        BIDS: _ClassVar[Report.Metric]
        BIDS_IN_AUCTION: _ClassVar[Report.Metric]
        CALLOUTS: _ClassVar[Report.Metric]
        CLICKS: _ClassVar[Report.Metric]
        CODE_SERVED_COUNT: _ClassVar[Report.Metric]
        CTR: _ClassVar[Report.Metric]
        GOOGLE_SOLD_AUCTION_COVIEWED_IMPRESSIONS: _ClassVar[Report.Metric]
        GOOGLE_SOLD_AUCTION_IMPRESSIONS: _ClassVar[Report.Metric]
        GOOGLE_SOLD_COVIEWED_IMPRESSIONS: _ClassVar[Report.Metric]
        GOOGLE_SOLD_IMPRESSIONS: _ClassVar[Report.Metric]
        GOOGLE_SOLD_RESERVATION_COVIEWED_IMPRESSIONS: _ClassVar[Report.Metric]
        GOOGLE_SOLD_RESERVATION_IMPRESSIONS: _ClassVar[Report.Metric]
        IMPRESSIONS: _ClassVar[Report.Metric]
        PARTNER_SALES_FILLED_POD_REQUESTS: _ClassVar[Report.Metric]
        PARTNER_SALES_FILL_RATE: _ClassVar[Report.Metric]
        PARTNER_SALES_PARTNER_MATCH_RATE: _ClassVar[Report.Metric]
        PARTNER_SALES_QUERIES: _ClassVar[Report.Metric]
        PARTNER_SALES_UNFILLED_IMPRESSIONS: _ClassVar[Report.Metric]
        PARTNER_SALES_UNMATCHED_QUERIES: _ClassVar[Report.Metric]
        PARTNER_SOLD_CODE_SERVED: _ClassVar[Report.Metric]
        PARTNER_SOLD_COVIEWED_IMPRESSIONS: _ClassVar[Report.Metric]
        PARTNER_SOLD_IMPRESSIONS: _ClassVar[Report.Metric]
        PROGRAMMATIC_ELIGIBLE_AD_REQUESTS: _ClassVar[Report.Metric]
        PROGRAMMATIC_MATCH_RATE: _ClassVar[Report.Metric]
        PROGRAMMATIC_RESPONSES_SERVED: _ClassVar[Report.Metric]
        RESPONSES_SERVED: _ClassVar[Report.Metric]
        REVENUE: _ClassVar[Report.Metric]
        REVENUE_WITHOUT_CPD: _ClassVar[Report.Metric]
        SUCCESSFUL_RESPONSES: _ClassVar[Report.Metric]
        UNFILLED_IMPRESSIONS: _ClassVar[Report.Metric]
        UNMATCHED_AD_REQUESTS: _ClassVar[Report.Metric]
        USER_MESSAGES_OFFERWALL_MESSAGES_SHOWN: _ClassVar[Report.Metric]
        USER_MESSAGES_OFFERWALL_SUCCESSFUL_ENGAGEMENTS: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_AVERAGE_INTERACTION_RATE: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_COLLAPSES: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_EXPANDS: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_FULL_SCREENS: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_MUTES: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_PAUSES: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_RESUMES: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_REWINDS: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_UNMUTES: _ClassVar[Report.Metric]
        VIDEO_INTERACTION_VIDEO_SKIPS: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_CREATIVE_SERVES: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_100_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_101_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_102_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_200_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_201_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_202_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_203_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_300_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_301_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_302_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_303_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_400_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_401_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_402_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_403_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_405_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_406_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_407_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_408_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_409_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_410_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_500_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_501_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_502_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_503_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_600_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_601_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_602_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_603_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_604_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_900_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_ERROR_901_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_IMPRESSIONS: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_MATCHED_QUERIES: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_TOTAL_ERROR_COUNT: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_TOTAL_QUERIES: _ClassVar[Report.Metric]
        VIDEO_REAL_TIME_UNMATCHED_QUERIES: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_AUTO_PLAYS: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_AVERAGE_VIEW_RATE: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_AVERAGE_VIEW_TIME: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_CLICK_TO_PLAYS: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_COMPLETES: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_COMPLETION_RATE: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_ENGAGED_VIEWS: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_FIRST_QUARTILES: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_MIDPOINTS: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_SKIP_BUTTONS_SHOWN: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_STARTS: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_THIRD_QUARTILES: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_TOTAL_ERROR_COUNT: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_TOTAL_ERROR_RATE: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_VIDEO_LENGTH: _ClassVar[Report.Metric]
        VIDEO_VIEWERSHIP_VIEW_THROUGH_RATE: _ClassVar[Report.Metric]
        YIELD_GROUP_ESTIMATED_CPM: _ClassVar[Report.Metric]
        YIELD_GROUP_ESTIMATED_REVENUE: _ClassVar[Report.Metric]
        YIELD_GROUP_IMPRESSIONS: _ClassVar[Report.Metric]
        YIELD_GROUP_MEDIATION_FILL_RATE: _ClassVar[Report.Metric]
        YIELD_GROUP_MEDIATION_MATCHED_QUERIES: _ClassVar[Report.Metric]
        YIELD_GROUP_MEDIATION_PASSBACKS: _ClassVar[Report.Metric]
        YIELD_GROUP_MEDIATION_THIRD_PARTY_ECPM: _ClassVar[Report.Metric]
    METRIC_UNSPECIFIED: Report.Metric
    ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: Report.Metric
    ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: Report.Metric
    ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: Report.Metric
    ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: Report.Metric
    ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: Report.Metric
    ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: Report.Metric
    ADSENSE_ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: Report.Metric
    ADSENSE_ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: Report.Metric
    ADSENSE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: Report.Metric
    ADSENSE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: Report.Metric
    ADSENSE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: Report.Metric
    ADSENSE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: Report.Metric
    ADSENSE_AVERAGE_ECPM: Report.Metric
    ADSENSE_CLICKS: Report.Metric
    ADSENSE_CTR: Report.Metric
    ADSENSE_IMPRESSIONS: Report.Metric
    ADSENSE_PERCENT_CLICKS: Report.Metric
    ADSENSE_PERCENT_IMPRESSIONS: Report.Metric
    ADSENSE_PERCENT_REVENUE: Report.Metric
    ADSENSE_PERCENT_REVENUE_WITHOUT_CPD: Report.Metric
    ADSENSE_RESPONSES_SERVED: Report.Metric
    ADSENSE_REVENUE: Report.Metric
    AD_EXCHANGE_ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: Report.Metric
    AD_EXCHANGE_ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: Report.Metric
    AD_EXCHANGE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: Report.Metric
    AD_EXCHANGE_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: Report.Metric
    AD_EXCHANGE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: Report.Metric
    AD_EXCHANGE_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: Report.Metric
    AD_EXCHANGE_AVERAGE_ECPM: Report.Metric
    AD_EXCHANGE_CLICKS: Report.Metric
    AD_EXCHANGE_CTR: Report.Metric
    AD_EXCHANGE_IMPRESSIONS: Report.Metric
    AD_EXCHANGE_PERCENT_CLICKS: Report.Metric
    AD_EXCHANGE_PERCENT_IMPRESSIONS: Report.Metric
    AD_EXCHANGE_PERCENT_REVENUE: Report.Metric
    AD_EXCHANGE_PERCENT_REVENUE_WITHOUT_CPD: Report.Metric
    AD_EXCHANGE_RESPONSES_SERVED: Report.Metric
    AD_EXCHANGE_REVENUE: Report.Metric
    AD_REQUESTS: Report.Metric
    AD_SERVER_ACTIVE_VIEW_AVERAGE_VIEWABLE_TIME: Report.Metric
    AD_SERVER_ACTIVE_VIEW_ELIGIBLE_IMPRESSIONS: Report.Metric
    AD_SERVER_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS: Report.Metric
    AD_SERVER_ACTIVE_VIEW_MEASURABLE_IMPRESSIONS_RATE: Report.Metric
    AD_SERVER_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS: Report.Metric
    AD_SERVER_ACTIVE_VIEW_VIEWABLE_IMPRESSIONS_RATE: Report.Metric
    AD_SERVER_AVERAGE_ECPM: Report.Metric
    AD_SERVER_AVERAGE_ECPM_WITHOUT_CPD: Report.Metric
    AD_SERVER_CLICKS: Report.Metric
    AD_SERVER_CPD_REVENUE: Report.Metric
    AD_SERVER_CTR: Report.Metric
    AD_SERVER_IMPRESSIONS: Report.Metric
    AD_SERVER_PERCENT_CLICKS: Report.Metric
    AD_SERVER_PERCENT_IMPRESSIONS: Report.Metric
    AD_SERVER_PERCENT_REVENUE: Report.Metric
    AD_SERVER_PERCENT_REVENUE_WITHOUT_CPD: Report.Metric
    AD_SERVER_RESPONSES_SERVED: Report.Metric
    AD_SERVER_REVENUE: Report.Metric
    AD_SERVER_REVENUE_WITHOUT_CPD: Report.Metric
    AUCTIONS_WON: Report.Metric
    AVERAGE_ECPM: Report.Metric
    AVERAGE_ECPM_WITHOUT_CPD: Report.Metric
    BIDS: Report.Metric
    BIDS_IN_AUCTION: Report.Metric
    CALLOUTS: Report.Metric
    CLICKS: Report.Metric
    CODE_SERVED_COUNT: Report.Metric
    CTR: Report.Metric
    GOOGLE_SOLD_AUCTION_COVIEWED_IMPRESSIONS: Report.Metric
    GOOGLE_SOLD_AUCTION_IMPRESSIONS: Report.Metric
    GOOGLE_SOLD_COVIEWED_IMPRESSIONS: Report.Metric
    GOOGLE_SOLD_IMPRESSIONS: Report.Metric
    GOOGLE_SOLD_RESERVATION_COVIEWED_IMPRESSIONS: Report.Metric
    GOOGLE_SOLD_RESERVATION_IMPRESSIONS: Report.Metric
    IMPRESSIONS: Report.Metric
    PARTNER_SALES_FILLED_POD_REQUESTS: Report.Metric
    PARTNER_SALES_FILL_RATE: Report.Metric
    PARTNER_SALES_PARTNER_MATCH_RATE: Report.Metric
    PARTNER_SALES_QUERIES: Report.Metric
    PARTNER_SALES_UNFILLED_IMPRESSIONS: Report.Metric
    PARTNER_SALES_UNMATCHED_QUERIES: Report.Metric
    PARTNER_SOLD_CODE_SERVED: Report.Metric
    PARTNER_SOLD_COVIEWED_IMPRESSIONS: Report.Metric
    PARTNER_SOLD_IMPRESSIONS: Report.Metric
    PROGRAMMATIC_ELIGIBLE_AD_REQUESTS: Report.Metric
    PROGRAMMATIC_MATCH_RATE: Report.Metric
    PROGRAMMATIC_RESPONSES_SERVED: Report.Metric
    RESPONSES_SERVED: Report.Metric
    REVENUE: Report.Metric
    REVENUE_WITHOUT_CPD: Report.Metric
    SUCCESSFUL_RESPONSES: Report.Metric
    UNFILLED_IMPRESSIONS: Report.Metric
    UNMATCHED_AD_REQUESTS: Report.Metric
    USER_MESSAGES_OFFERWALL_MESSAGES_SHOWN: Report.Metric
    USER_MESSAGES_OFFERWALL_SUCCESSFUL_ENGAGEMENTS: Report.Metric
    VIDEO_INTERACTION_AVERAGE_INTERACTION_RATE: Report.Metric
    VIDEO_INTERACTION_COLLAPSES: Report.Metric
    VIDEO_INTERACTION_EXPANDS: Report.Metric
    VIDEO_INTERACTION_FULL_SCREENS: Report.Metric
    VIDEO_INTERACTION_MUTES: Report.Metric
    VIDEO_INTERACTION_PAUSES: Report.Metric
    VIDEO_INTERACTION_RESUMES: Report.Metric
    VIDEO_INTERACTION_REWINDS: Report.Metric
    VIDEO_INTERACTION_UNMUTES: Report.Metric
    VIDEO_INTERACTION_VIDEO_SKIPS: Report.Metric
    VIDEO_REAL_TIME_CREATIVE_SERVES: Report.Metric
    VIDEO_REAL_TIME_ERROR_100_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_101_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_102_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_200_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_201_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_202_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_203_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_300_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_301_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_302_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_303_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_400_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_401_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_402_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_403_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_405_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_406_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_407_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_408_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_409_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_410_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_500_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_501_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_502_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_503_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_600_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_601_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_602_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_603_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_604_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_900_COUNT: Report.Metric
    VIDEO_REAL_TIME_ERROR_901_COUNT: Report.Metric
    VIDEO_REAL_TIME_IMPRESSIONS: Report.Metric
    VIDEO_REAL_TIME_MATCHED_QUERIES: Report.Metric
    VIDEO_REAL_TIME_TOTAL_ERROR_COUNT: Report.Metric
    VIDEO_REAL_TIME_TOTAL_QUERIES: Report.Metric
    VIDEO_REAL_TIME_UNMATCHED_QUERIES: Report.Metric
    VIDEO_VIEWERSHIP_AUTO_PLAYS: Report.Metric
    VIDEO_VIEWERSHIP_AVERAGE_VIEW_RATE: Report.Metric
    VIDEO_VIEWERSHIP_AVERAGE_VIEW_TIME: Report.Metric
    VIDEO_VIEWERSHIP_CLICK_TO_PLAYS: Report.Metric
    VIDEO_VIEWERSHIP_COMPLETES: Report.Metric
    VIDEO_VIEWERSHIP_COMPLETION_RATE: Report.Metric
    VIDEO_VIEWERSHIP_ENGAGED_VIEWS: Report.Metric
    VIDEO_VIEWERSHIP_FIRST_QUARTILES: Report.Metric
    VIDEO_VIEWERSHIP_MIDPOINTS: Report.Metric
    VIDEO_VIEWERSHIP_SKIP_BUTTONS_SHOWN: Report.Metric
    VIDEO_VIEWERSHIP_STARTS: Report.Metric
    VIDEO_VIEWERSHIP_THIRD_QUARTILES: Report.Metric
    VIDEO_VIEWERSHIP_TOTAL_ERROR_COUNT: Report.Metric
    VIDEO_VIEWERSHIP_TOTAL_ERROR_RATE: Report.Metric
    VIDEO_VIEWERSHIP_VIDEO_LENGTH: Report.Metric
    VIDEO_VIEWERSHIP_VIEW_THROUGH_RATE: Report.Metric
    YIELD_GROUP_ESTIMATED_CPM: Report.Metric
    YIELD_GROUP_ESTIMATED_REVENUE: Report.Metric
    YIELD_GROUP_IMPRESSIONS: Report.Metric
    YIELD_GROUP_MEDIATION_FILL_RATE: Report.Metric
    YIELD_GROUP_MEDIATION_MATCHED_QUERIES: Report.Metric
    YIELD_GROUP_MEDIATION_PASSBACKS: Report.Metric
    YIELD_GROUP_MEDIATION_THIRD_PARTY_ECPM: Report.Metric
    class MetricValueType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        PRIMARY: _ClassVar[Report.MetricValueType]
        PRIMARY_PERCENT_OF_TOTAL: _ClassVar[Report.MetricValueType]
        COMPARISON: _ClassVar[Report.MetricValueType]
        COMPARISON_PERCENT_OF_TOTAL: _ClassVar[Report.MetricValueType]
        ABSOLUTE_CHANGE: _ClassVar[Report.MetricValueType]
        RELATIVE_CHANGE: _ClassVar[Report.MetricValueType]
    PRIMARY: Report.MetricValueType
    PRIMARY_PERCENT_OF_TOTAL: Report.MetricValueType
    COMPARISON: Report.MetricValueType
    COMPARISON_PERCENT_OF_TOTAL: Report.MetricValueType
    ABSOLUTE_CHANGE: Report.MetricValueType
    RELATIVE_CHANGE: Report.MetricValueType
    class ReportType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        REPORT_TYPE_UNSPECIFIED: _ClassVar[Report.ReportType]
        HISTORICAL: _ClassVar[Report.ReportType]
    REPORT_TYPE_UNSPECIFIED: Report.ReportType
    HISTORICAL: Report.ReportType
    class Visibility(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        HIDDEN: _ClassVar[Report.Visibility]
        DRAFT: _ClassVar[Report.Visibility]
        SAVED: _ClassVar[Report.Visibility]
    HIDDEN: Report.Visibility
    DRAFT: Report.Visibility
    SAVED: Report.Visibility
    class Value(_message.Message):
        __slots__ = ("int_value", "double_value", "string_value", "bool_value", "int_list_value", "string_list_value", "bytes_value")
        class IntList(_message.Message):
            __slots__ = ("values",)
            VALUES_FIELD_NUMBER: _ClassVar[int]
            values: _containers.RepeatedScalarFieldContainer[int]
            def __init__(self, values: _Optional[_Iterable[int]] = ...) -> None: ...
        class StringList(_message.Message):
            __slots__ = ("values",)
            VALUES_FIELD_NUMBER: _ClassVar[int]
            values: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, values: _Optional[_Iterable[str]] = ...) -> None: ...
        INT_VALUE_FIELD_NUMBER: _ClassVar[int]
        DOUBLE_VALUE_FIELD_NUMBER: _ClassVar[int]
        STRING_VALUE_FIELD_NUMBER: _ClassVar[int]
        BOOL_VALUE_FIELD_NUMBER: _ClassVar[int]
        INT_LIST_VALUE_FIELD_NUMBER: _ClassVar[int]
        STRING_LIST_VALUE_FIELD_NUMBER: _ClassVar[int]
        BYTES_VALUE_FIELD_NUMBER: _ClassVar[int]
        int_value: int
        double_value: float
        string_value: str
        bool_value: bool
        int_list_value: Report.Value.IntList
        string_list_value: Report.Value.StringList
        bytes_value: bytes
        def __init__(self, int_value: _Optional[int] = ..., double_value: _Optional[float] = ..., string_value: _Optional[str] = ..., bool_value: bool = ..., int_list_value: _Optional[_Union[Report.Value.IntList, _Mapping]] = ..., string_list_value: _Optional[_Union[Report.Value.StringList, _Mapping]] = ..., bytes_value: _Optional[bytes] = ...) -> None: ...
    class Sort(_message.Message):
        __slots__ = ("field", "descending", "slice", "time_period_index", "metric_value_type")
        FIELD_FIELD_NUMBER: _ClassVar[int]
        DESCENDING_FIELD_NUMBER: _ClassVar[int]
        SLICE_FIELD_NUMBER: _ClassVar[int]
        TIME_PERIOD_INDEX_FIELD_NUMBER: _ClassVar[int]
        METRIC_VALUE_TYPE_FIELD_NUMBER: _ClassVar[int]
        field: Report.Field
        descending: bool
        slice: Report.Slice
        time_period_index: int
        metric_value_type: Report.MetricValueType
        def __init__(self, field: _Optional[_Union[Report.Field, _Mapping]] = ..., descending: bool = ..., slice: _Optional[_Union[Report.Slice, _Mapping]] = ..., time_period_index: _Optional[int] = ..., metric_value_type: _Optional[_Union[Report.MetricValueType, str]] = ...) -> None: ...
    class DataTable(_message.Message):
        __slots__ = ()
        class Row(_message.Message):
            __slots__ = ("dimension_values", "metric_value_groups")
            DIMENSION_VALUES_FIELD_NUMBER: _ClassVar[int]
            METRIC_VALUE_GROUPS_FIELD_NUMBER: _ClassVar[int]
            dimension_values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            metric_value_groups: _containers.RepeatedCompositeFieldContainer[Report.DataTable.MetricValueGroup]
            def __init__(self, dimension_values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., metric_value_groups: _Optional[_Iterable[_Union[Report.DataTable.MetricValueGroup, _Mapping]]] = ...) -> None: ...
        class MetricValueGroup(_message.Message):
            __slots__ = ("primary_values", "primary_percent_of_total_values", "comparison_values", "comparison_percent_of_total_values", "absolute_change_values", "relative_change_values", "flag_values")
            PRIMARY_VALUES_FIELD_NUMBER: _ClassVar[int]
            PRIMARY_PERCENT_OF_TOTAL_VALUES_FIELD_NUMBER: _ClassVar[int]
            COMPARISON_VALUES_FIELD_NUMBER: _ClassVar[int]
            COMPARISON_PERCENT_OF_TOTAL_VALUES_FIELD_NUMBER: _ClassVar[int]
            ABSOLUTE_CHANGE_VALUES_FIELD_NUMBER: _ClassVar[int]
            RELATIVE_CHANGE_VALUES_FIELD_NUMBER: _ClassVar[int]
            FLAG_VALUES_FIELD_NUMBER: _ClassVar[int]
            primary_values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            primary_percent_of_total_values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            comparison_values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            comparison_percent_of_total_values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            absolute_change_values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            relative_change_values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            flag_values: _containers.RepeatedScalarFieldContainer[bool]
            def __init__(self, primary_values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., primary_percent_of_total_values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., comparison_values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., comparison_percent_of_total_values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., absolute_change_values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., relative_change_values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., flag_values: _Optional[_Iterable[bool]] = ...) -> None: ...
        def __init__(self) -> None: ...
    class Field(_message.Message):
        __slots__ = ("dimension", "metric")
        DIMENSION_FIELD_NUMBER: _ClassVar[int]
        METRIC_FIELD_NUMBER: _ClassVar[int]
        dimension: Report.Dimension
        metric: Report.Metric
        def __init__(self, dimension: _Optional[_Union[Report.Dimension, str]] = ..., metric: _Optional[_Union[Report.Metric, str]] = ...) -> None: ...
    class Slice(_message.Message):
        __slots__ = ("dimension", "value")
        DIMENSION_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        dimension: Report.Dimension
        value: Report.Value
        def __init__(self, dimension: _Optional[_Union[Report.Dimension, str]] = ..., value: _Optional[_Union[Report.Value, _Mapping]] = ...) -> None: ...
    class Filter(_message.Message):
        __slots__ = ("field_filter", "not_filter", "and_filter", "or_filter")
        class Operation(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            IN: _ClassVar[Report.Filter.Operation]
            NOT_IN: _ClassVar[Report.Filter.Operation]
            CONTAINS: _ClassVar[Report.Filter.Operation]
            NOT_CONTAINS: _ClassVar[Report.Filter.Operation]
            LESS_THAN: _ClassVar[Report.Filter.Operation]
            LESS_THAN_EQUALS: _ClassVar[Report.Filter.Operation]
            GREATER_THAN: _ClassVar[Report.Filter.Operation]
            GREATER_THAN_EQUALS: _ClassVar[Report.Filter.Operation]
            BETWEEN: _ClassVar[Report.Filter.Operation]
            MATCHES: _ClassVar[Report.Filter.Operation]
            NOT_MATCHES: _ClassVar[Report.Filter.Operation]
        IN: Report.Filter.Operation
        NOT_IN: Report.Filter.Operation
        CONTAINS: Report.Filter.Operation
        NOT_CONTAINS: Report.Filter.Operation
        LESS_THAN: Report.Filter.Operation
        LESS_THAN_EQUALS: Report.Filter.Operation
        GREATER_THAN: Report.Filter.Operation
        GREATER_THAN_EQUALS: Report.Filter.Operation
        BETWEEN: Report.Filter.Operation
        MATCHES: Report.Filter.Operation
        NOT_MATCHES: Report.Filter.Operation
        class FieldFilter(_message.Message):
            __slots__ = ("field", "operation", "values", "slice", "time_period_index", "metric_value_type")
            FIELD_FIELD_NUMBER: _ClassVar[int]
            OPERATION_FIELD_NUMBER: _ClassVar[int]
            VALUES_FIELD_NUMBER: _ClassVar[int]
            SLICE_FIELD_NUMBER: _ClassVar[int]
            TIME_PERIOD_INDEX_FIELD_NUMBER: _ClassVar[int]
            METRIC_VALUE_TYPE_FIELD_NUMBER: _ClassVar[int]
            field: Report.Field
            operation: Report.Filter.Operation
            values: _containers.RepeatedCompositeFieldContainer[Report.Value]
            slice: Report.Slice
            time_period_index: int
            metric_value_type: Report.MetricValueType
            def __init__(self, field: _Optional[_Union[Report.Field, _Mapping]] = ..., operation: _Optional[_Union[Report.Filter.Operation, str]] = ..., values: _Optional[_Iterable[_Union[Report.Value, _Mapping]]] = ..., slice: _Optional[_Union[Report.Slice, _Mapping]] = ..., time_period_index: _Optional[int] = ..., metric_value_type: _Optional[_Union[Report.MetricValueType, str]] = ...) -> None: ...
        class FilterList(_message.Message):
            __slots__ = ("filters",)
            FILTERS_FIELD_NUMBER: _ClassVar[int]
            filters: _containers.RepeatedCompositeFieldContainer[Report.Filter]
            def __init__(self, filters: _Optional[_Iterable[_Union[Report.Filter, _Mapping]]] = ...) -> None: ...
        FIELD_FILTER_FIELD_NUMBER: _ClassVar[int]
        NOT_FILTER_FIELD_NUMBER: _ClassVar[int]
        AND_FILTER_FIELD_NUMBER: _ClassVar[int]
        OR_FILTER_FIELD_NUMBER: _ClassVar[int]
        field_filter: Report.Filter.FieldFilter
        not_filter: Report.Filter
        and_filter: Report.Filter.FilterList
        or_filter: Report.Filter.FilterList
        def __init__(self, field_filter: _Optional[_Union[Report.Filter.FieldFilter, _Mapping]] = ..., not_filter: _Optional[_Union[Report.Filter, _Mapping]] = ..., and_filter: _Optional[_Union[Report.Filter.FilterList, _Mapping]] = ..., or_filter: _Optional[_Union[Report.Filter.FilterList, _Mapping]] = ...) -> None: ...
    class Flag(_message.Message):
        __slots__ = ("filters", "name")
        FILTERS_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        filters: _containers.RepeatedCompositeFieldContainer[Report.Filter]
        name: str
        def __init__(self, filters: _Optional[_Iterable[_Union[Report.Filter, _Mapping]]] = ..., name: _Optional[str] = ...) -> None: ...
    class DateRange(_message.Message):
        __slots__ = ("fixed", "relative")
        class RelativeDateRange(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            RELATIVE_DATE_RANGE_UNSPECIFIED: _ClassVar[Report.DateRange.RelativeDateRange]
            TODAY: _ClassVar[Report.DateRange.RelativeDateRange]
            YESTERDAY: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_WEEK: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_WEEK_TO_DATE: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_MONTH: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_MONTH_TO_DATE: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_QUARTER: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_QUARTER_TO_DATE: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_YEAR: _ClassVar[Report.DateRange.RelativeDateRange]
            THIS_YEAR_TO_DATE: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_WEEK: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_MONTH: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_QUARTER: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_YEAR: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_7_DAYS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_30_DAYS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_60_DAYS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_90_DAYS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_180_DAYS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_360_DAYS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_365_DAYS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_3_MONTHS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_6_MONTHS: _ClassVar[Report.DateRange.RelativeDateRange]
            LAST_12_MONTHS: _ClassVar[Report.DateRange.RelativeDateRange]
            ALL_AVAILABLE: _ClassVar[Report.DateRange.RelativeDateRange]
            PREVIOUS_PERIOD: _ClassVar[Report.DateRange.RelativeDateRange]
            SAME_PERIOD_PREVIOUS_YEAR: _ClassVar[Report.DateRange.RelativeDateRange]
        RELATIVE_DATE_RANGE_UNSPECIFIED: Report.DateRange.RelativeDateRange
        TODAY: Report.DateRange.RelativeDateRange
        YESTERDAY: Report.DateRange.RelativeDateRange
        THIS_WEEK: Report.DateRange.RelativeDateRange
        THIS_WEEK_TO_DATE: Report.DateRange.RelativeDateRange
        THIS_MONTH: Report.DateRange.RelativeDateRange
        THIS_MONTH_TO_DATE: Report.DateRange.RelativeDateRange
        THIS_QUARTER: Report.DateRange.RelativeDateRange
        THIS_QUARTER_TO_DATE: Report.DateRange.RelativeDateRange
        THIS_YEAR: Report.DateRange.RelativeDateRange
        THIS_YEAR_TO_DATE: Report.DateRange.RelativeDateRange
        LAST_WEEK: Report.DateRange.RelativeDateRange
        LAST_MONTH: Report.DateRange.RelativeDateRange
        LAST_QUARTER: Report.DateRange.RelativeDateRange
        LAST_YEAR: Report.DateRange.RelativeDateRange
        LAST_7_DAYS: Report.DateRange.RelativeDateRange
        LAST_30_DAYS: Report.DateRange.RelativeDateRange
        LAST_60_DAYS: Report.DateRange.RelativeDateRange
        LAST_90_DAYS: Report.DateRange.RelativeDateRange
        LAST_180_DAYS: Report.DateRange.RelativeDateRange
        LAST_360_DAYS: Report.DateRange.RelativeDateRange
        LAST_365_DAYS: Report.DateRange.RelativeDateRange
        LAST_3_MONTHS: Report.DateRange.RelativeDateRange
        LAST_6_MONTHS: Report.DateRange.RelativeDateRange
        LAST_12_MONTHS: Report.DateRange.RelativeDateRange
        ALL_AVAILABLE: Report.DateRange.RelativeDateRange
        PREVIOUS_PERIOD: Report.DateRange.RelativeDateRange
        SAME_PERIOD_PREVIOUS_YEAR: Report.DateRange.RelativeDateRange
        class FixedDateRange(_message.Message):
            __slots__ = ("start_date", "end_date")
            START_DATE_FIELD_NUMBER: _ClassVar[int]
            END_DATE_FIELD_NUMBER: _ClassVar[int]
            start_date: _date_pb2.Date
            end_date: _date_pb2.Date
            def __init__(self, start_date: _Optional[_Union[_date_pb2.Date, _Mapping]] = ..., end_date: _Optional[_Union[_date_pb2.Date, _Mapping]] = ...) -> None: ...
        FIXED_FIELD_NUMBER: _ClassVar[int]
        RELATIVE_FIELD_NUMBER: _ClassVar[int]
        fixed: Report.DateRange.FixedDateRange
        relative: Report.DateRange.RelativeDateRange
        def __init__(self, fixed: _Optional[_Union[Report.DateRange.FixedDateRange, _Mapping]] = ..., relative: _Optional[_Union[Report.DateRange.RelativeDateRange, str]] = ...) -> None: ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    REPORT_ID_FIELD_NUMBER: _ClassVar[int]
    VISIBILITY_FIELD_NUMBER: _ClassVar[int]
    REPORT_DEFINITION_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    LOCALE_FIELD_NUMBER: _ClassVar[int]
    SCHEDULE_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    name: str
    report_id: int
    visibility: Report.Visibility
    report_definition: ReportDefinition
    display_name: str
    update_time: _timestamp_pb2.Timestamp
    create_time: _timestamp_pb2.Timestamp
    locale: str
    schedule_options: ScheduleOptions
    def __init__(self, name: _Optional[str] = ..., report_id: _Optional[int] = ..., visibility: _Optional[_Union[Report.Visibility, str]] = ..., report_definition: _Optional[_Union[ReportDefinition, _Mapping]] = ..., display_name: _Optional[str] = ..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., locale: _Optional[str] = ..., schedule_options: _Optional[_Union[ScheduleOptions, _Mapping]] = ...) -> None: ...

class RunReportRequest(_message.Message):
    __slots__ = ("name",)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class RunReportMetadata(_message.Message):
    __slots__ = ("percent_complete", "report")
    PERCENT_COMPLETE_FIELD_NUMBER: _ClassVar[int]
    REPORT_FIELD_NUMBER: _ClassVar[int]
    percent_complete: int
    report: str
    def __init__(self, percent_complete: _Optional[int] = ..., report: _Optional[str] = ...) -> None: ...

class RunReportResponse(_message.Message):
    __slots__ = ("report_result",)
    REPORT_RESULT_FIELD_NUMBER: _ClassVar[int]
    report_result: str
    def __init__(self, report_result: _Optional[str] = ...) -> None: ...

class GetReportRequest(_message.Message):
    __slots__ = ("name",)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class ListReportsRequest(_message.Message):
    __slots__ = ("parent", "page_size", "page_token", "filter", "order_by", "skip")
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    SKIP_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_size: int
    page_token: str
    filter: str
    order_by: str
    skip: int
    def __init__(self, parent: _Optional[str] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ..., filter: _Optional[str] = ..., order_by: _Optional[str] = ..., skip: _Optional[int] = ...) -> None: ...

class ListReportsResponse(_message.Message):
    __slots__ = ("reports", "next_page_token", "total_size")
    REPORTS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TOTAL_SIZE_FIELD_NUMBER: _ClassVar[int]
    reports: _containers.RepeatedCompositeFieldContainer[Report]
    next_page_token: str
    total_size: int
    def __init__(self, reports: _Optional[_Iterable[_Union[Report, _Mapping]]] = ..., next_page_token: _Optional[str] = ..., total_size: _Optional[int] = ...) -> None: ...

class CreateReportRequest(_message.Message):
    __slots__ = ("parent", "report")
    PARENT_FIELD_NUMBER: _ClassVar[int]
    REPORT_FIELD_NUMBER: _ClassVar[int]
    parent: str
    report: Report
    def __init__(self, parent: _Optional[str] = ..., report: _Optional[_Union[Report, _Mapping]] = ...) -> None: ...

class UpdateReportRequest(_message.Message):
    __slots__ = ("report", "update_mask")
    REPORT_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    report: Report
    update_mask: _field_mask_pb2.FieldMask
    def __init__(self, report: _Optional[_Union[Report, _Mapping]] = ..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class FetchReportResultRowsRequest(_message.Message):
    __slots__ = ("name", "page_size", "page_token")
    NAME_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    name: str
    page_size: int
    page_token: str
    def __init__(self, name: _Optional[str] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class FetchReportResultRowsResponse(_message.Message):
    __slots__ = ("rows", "run_time", "date_ranges", "comparison_date_ranges", "total_row_count", "next_page_token")
    ROWS_FIELD_NUMBER: _ClassVar[int]
    RUN_TIME_FIELD_NUMBER: _ClassVar[int]
    DATE_RANGES_FIELD_NUMBER: _ClassVar[int]
    COMPARISON_DATE_RANGES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_ROW_COUNT_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    rows: _containers.RepeatedCompositeFieldContainer[Report.DataTable.Row]
    run_time: _timestamp_pb2.Timestamp
    date_ranges: _containers.RepeatedCompositeFieldContainer[Report.DateRange.FixedDateRange]
    comparison_date_ranges: _containers.RepeatedCompositeFieldContainer[Report.DateRange.FixedDateRange]
    total_row_count: int
    next_page_token: str
    def __init__(self, rows: _Optional[_Iterable[_Union[Report.DataTable.Row, _Mapping]]] = ..., run_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., date_ranges: _Optional[_Iterable[_Union[Report.DateRange.FixedDateRange, _Mapping]]] = ..., comparison_date_ranges: _Optional[_Iterable[_Union[Report.DateRange.FixedDateRange, _Mapping]]] = ..., total_row_count: _Optional[int] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class ReportDefinition(_message.Message):
    __slots__ = ("dimensions", "metrics", "filters", "time_zone", "currency_code", "date_range", "comparison_date_range", "custom_dimension_key_ids", "line_item_custom_field_ids", "order_custom_field_ids", "creative_custom_field_ids", "report_type", "time_period_column", "flags", "sorts")
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    FILTERS_FIELD_NUMBER: _ClassVar[int]
    TIME_ZONE_FIELD_NUMBER: _ClassVar[int]
    CURRENCY_CODE_FIELD_NUMBER: _ClassVar[int]
    DATE_RANGE_FIELD_NUMBER: _ClassVar[int]
    COMPARISON_DATE_RANGE_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_DIMENSION_KEY_IDS_FIELD_NUMBER: _ClassVar[int]
    LINE_ITEM_CUSTOM_FIELD_IDS_FIELD_NUMBER: _ClassVar[int]
    ORDER_CUSTOM_FIELD_IDS_FIELD_NUMBER: _ClassVar[int]
    CREATIVE_CUSTOM_FIELD_IDS_FIELD_NUMBER: _ClassVar[int]
    REPORT_TYPE_FIELD_NUMBER: _ClassVar[int]
    TIME_PERIOD_COLUMN_FIELD_NUMBER: _ClassVar[int]
    FLAGS_FIELD_NUMBER: _ClassVar[int]
    SORTS_FIELD_NUMBER: _ClassVar[int]
    dimensions: _containers.RepeatedScalarFieldContainer[Report.Dimension]
    metrics: _containers.RepeatedScalarFieldContainer[Report.Metric]
    filters: _containers.RepeatedCompositeFieldContainer[Report.Filter]
    time_zone: str
    currency_code: str
    date_range: Report.DateRange
    comparison_date_range: Report.DateRange
    custom_dimension_key_ids: _containers.RepeatedScalarFieldContainer[int]
    line_item_custom_field_ids: _containers.RepeatedScalarFieldContainer[int]
    order_custom_field_ids: _containers.RepeatedScalarFieldContainer[int]
    creative_custom_field_ids: _containers.RepeatedScalarFieldContainer[int]
    report_type: Report.ReportType
    time_period_column: Report.TimePeriodColumn
    flags: _containers.RepeatedCompositeFieldContainer[Report.Flag]
    sorts: _containers.RepeatedCompositeFieldContainer[Report.Sort]
    def __init__(self, dimensions: _Optional[_Iterable[_Union[Report.Dimension, str]]] = ..., metrics: _Optional[_Iterable[_Union[Report.Metric, str]]] = ..., filters: _Optional[_Iterable[_Union[Report.Filter, _Mapping]]] = ..., time_zone: _Optional[str] = ..., currency_code: _Optional[str] = ..., date_range: _Optional[_Union[Report.DateRange, _Mapping]] = ..., comparison_date_range: _Optional[_Union[Report.DateRange, _Mapping]] = ..., custom_dimension_key_ids: _Optional[_Iterable[int]] = ..., line_item_custom_field_ids: _Optional[_Iterable[int]] = ..., order_custom_field_ids: _Optional[_Iterable[int]] = ..., creative_custom_field_ids: _Optional[_Iterable[int]] = ..., report_type: _Optional[_Union[Report.ReportType, str]] = ..., time_period_column: _Optional[_Union[Report.TimePeriodColumn, str]] = ..., flags: _Optional[_Iterable[_Union[Report.Flag, _Mapping]]] = ..., sorts: _Optional[_Iterable[_Union[Report.Sort, _Mapping]]] = ...) -> None: ...

class ScheduleOptions(_message.Message):
    __slots__ = ("schedule", "delivery_condition", "flags")
    class DeliveryCondition(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        NEVER: _ClassVar[ScheduleOptions.DeliveryCondition]
        ALWAYS: _ClassVar[ScheduleOptions.DeliveryCondition]
        WHEN_FLAG_CONDITIONS_MET: _ClassVar[ScheduleOptions.DeliveryCondition]
    NEVER: ScheduleOptions.DeliveryCondition
    ALWAYS: ScheduleOptions.DeliveryCondition
    WHEN_FLAG_CONDITIONS_MET: ScheduleOptions.DeliveryCondition
    SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    DELIVERY_CONDITION_FIELD_NUMBER: _ClassVar[int]
    FLAGS_FIELD_NUMBER: _ClassVar[int]
    schedule: Schedule
    delivery_condition: ScheduleOptions.DeliveryCondition
    flags: _containers.RepeatedCompositeFieldContainer[Report.Flag]
    def __init__(self, schedule: _Optional[_Union[Schedule, _Mapping]] = ..., delivery_condition: _Optional[_Union[ScheduleOptions.DeliveryCondition, str]] = ..., flags: _Optional[_Iterable[_Union[Report.Flag, _Mapping]]] = ...) -> None: ...

class Schedule(_message.Message):
    __slots__ = ("weekly_schedule", "monthly_schedule", "start_date", "end_date", "frequency", "start_time")
    class Frequency(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        FREQUENCY_UNSPECIFIED: _ClassVar[Schedule.Frequency]
        HOURLY: _ClassVar[Schedule.Frequency]
        TWO_TIMES_DAILY: _ClassVar[Schedule.Frequency]
        THREE_TIMES_DAILY: _ClassVar[Schedule.Frequency]
        FOUR_TIMES_DAILY: _ClassVar[Schedule.Frequency]
        DAILY: _ClassVar[Schedule.Frequency]
        WEEKLY: _ClassVar[Schedule.Frequency]
        MONTHLY: _ClassVar[Schedule.Frequency]
    FREQUENCY_UNSPECIFIED: Schedule.Frequency
    HOURLY: Schedule.Frequency
    TWO_TIMES_DAILY: Schedule.Frequency
    THREE_TIMES_DAILY: Schedule.Frequency
    FOUR_TIMES_DAILY: Schedule.Frequency
    DAILY: Schedule.Frequency
    WEEKLY: Schedule.Frequency
    MONTHLY: Schedule.Frequency
    class WeeklySchedule(_message.Message):
        __slots__ = ("weekly_scheduled_days",)
        WEEKLY_SCHEDULED_DAYS_FIELD_NUMBER: _ClassVar[int]
        weekly_scheduled_days: _containers.RepeatedScalarFieldContainer[_dayofweek_pb2.DayOfWeek]
        def __init__(self, weekly_scheduled_days: _Optional[_Iterable[_Union[_dayofweek_pb2.DayOfWeek, str]]] = ...) -> None: ...
    class MonthlySchedule(_message.Message):
        __slots__ = ("monthly_scheduled_days",)
        MONTHLY_SCHEDULED_DAYS_FIELD_NUMBER: _ClassVar[int]
        monthly_scheduled_days: _containers.RepeatedScalarFieldContainer[int]
        def __init__(self, monthly_scheduled_days: _Optional[_Iterable[int]] = ...) -> None: ...
    WEEKLY_SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    MONTHLY_SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    START_DATE_FIELD_NUMBER: _ClassVar[int]
    END_DATE_FIELD_NUMBER: _ClassVar[int]
    FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    weekly_schedule: Schedule.WeeklySchedule
    monthly_schedule: Schedule.MonthlySchedule
    start_date: _date_pb2.Date
    end_date: _date_pb2.Date
    frequency: Schedule.Frequency
    start_time: _timeofday_pb2.TimeOfDay
    def __init__(self, weekly_schedule: _Optional[_Union[Schedule.WeeklySchedule, _Mapping]] = ..., monthly_schedule: _Optional[_Union[Schedule.MonthlySchedule, _Mapping]] = ..., start_date: _Optional[_Union[_date_pb2.Date, _Mapping]] = ..., end_date: _Optional[_Union[_date_pb2.Date, _Mapping]] = ..., frequency: _Optional[_Union[Schedule.Frequency, str]] = ..., start_time: _Optional[_Union[_timeofday_pb2.TimeOfDay, _Mapping]] = ...) -> None: ...
