from google.api import annotations_pb2 as _annotations_pb2
from google.api import client_pb2 as _client_pb2
from google.api import field_behavior_pb2 as _field_behavior_pb2
from google.api import resource_pb2 as _resource_pb2
from google.cloud import extended_operations_pb2 as _extended_operations_pb2
from google.protobuf import any_pb2 as _any_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class AWSV4Signature(_message.Message):
    __slots__ = ("access_key", "access_key_id", "access_key_version", "origin_region")
    ACCESS_KEY_FIELD_NUMBER: _ClassVar[int]
    ACCESS_KEY_ID_FIELD_NUMBER: _ClassVar[int]
    ACCESS_KEY_VERSION_FIELD_NUMBER: _ClassVar[int]
    ORIGIN_REGION_FIELD_NUMBER: _ClassVar[int]
    access_key: str
    access_key_id: str
    access_key_version: str
    origin_region: str
    def __init__(self, access_key: _Optional[str] = ..., access_key_id: _Optional[str] = ..., access_key_version: _Optional[str] = ..., origin_region: _Optional[str] = ...) -> None: ...

class AbandonInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_abandon_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_ABANDON_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_abandon_instances_request_resource: InstanceGroupManagersAbandonInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_abandon_instances_request_resource: _Optional[_Union[InstanceGroupManagersAbandonInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AbandonInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_abandon_instances_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_ABANDON_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_abandon_instances_request_resource: RegionInstanceGroupManagersAbandonInstancesRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_abandon_instances_request_resource: _Optional[_Union[RegionInstanceGroupManagersAbandonInstancesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class AcceleratorConfig(_message.Message):
    __slots__ = ("accelerator_count", "accelerator_type")
    ACCELERATOR_COUNT_FIELD_NUMBER: _ClassVar[int]
    ACCELERATOR_TYPE_FIELD_NUMBER: _ClassVar[int]
    accelerator_count: int
    accelerator_type: str
    def __init__(self, accelerator_count: _Optional[int] = ..., accelerator_type: _Optional[str] = ...) -> None: ...

class AcceleratorType(_message.Message):
    __slots__ = ("creation_timestamp", "deprecated", "description", "id", "kind", "maximum_cards_per_instance", "name", "self_link", "zone")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MAXIMUM_CARDS_PER_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    deprecated: DeprecationStatus
    description: str
    id: int
    kind: str
    maximum_cards_per_instance: int
    name: str
    self_link: str
    zone: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., maximum_cards_per_instance: _Optional[int] = ..., name: _Optional[str] = ..., self_link: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AcceleratorTypeAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: AcceleratorTypesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[AcceleratorTypesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, AcceleratorTypesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, AcceleratorTypesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AcceleratorTypeList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[AcceleratorType]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[AcceleratorType, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AcceleratorTypesScopedList(_message.Message):
    __slots__ = ("accelerator_types", "warning")
    ACCELERATOR_TYPES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    accelerator_types: _containers.RepeatedCompositeFieldContainer[AcceleratorType]
    warning: Warning
    def __init__(self, accelerator_types: _Optional[_Iterable[_Union[AcceleratorType, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class Accelerators(_message.Message):
    __slots__ = ("guest_accelerator_count", "guest_accelerator_type")
    GUEST_ACCELERATOR_COUNT_FIELD_NUMBER: _ClassVar[int]
    GUEST_ACCELERATOR_TYPE_FIELD_NUMBER: _ClassVar[int]
    guest_accelerator_count: int
    guest_accelerator_type: str
    def __init__(self, guest_accelerator_count: _Optional[int] = ..., guest_accelerator_type: _Optional[str] = ...) -> None: ...

class AccessConfig(_message.Message):
    __slots__ = ("external_ipv6", "external_ipv6_prefix_length", "kind", "name", "nat_i_p", "network_tier", "public_ptr_domain_name", "security_policy", "set_public_ptr", "type")
    class NetworkTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NETWORK_TIER: _ClassVar[AccessConfig.NetworkTier]
        FIXED_STANDARD: _ClassVar[AccessConfig.NetworkTier]
        PREMIUM: _ClassVar[AccessConfig.NetworkTier]
        STANDARD: _ClassVar[AccessConfig.NetworkTier]
        STANDARD_OVERRIDES_FIXED_STANDARD: _ClassVar[AccessConfig.NetworkTier]
    UNDEFINED_NETWORK_TIER: AccessConfig.NetworkTier
    FIXED_STANDARD: AccessConfig.NetworkTier
    PREMIUM: AccessConfig.NetworkTier
    STANDARD: AccessConfig.NetworkTier
    STANDARD_OVERRIDES_FIXED_STANDARD: AccessConfig.NetworkTier
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[AccessConfig.Type]
        DIRECT_IPV6: _ClassVar[AccessConfig.Type]
        ONE_TO_ONE_NAT: _ClassVar[AccessConfig.Type]
    UNDEFINED_TYPE: AccessConfig.Type
    DIRECT_IPV6: AccessConfig.Type
    ONE_TO_ONE_NAT: AccessConfig.Type
    EXTERNAL_IPV6_FIELD_NUMBER: _ClassVar[int]
    EXTERNAL_IPV6_PREFIX_LENGTH_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NAT_I_P_FIELD_NUMBER: _ClassVar[int]
    NETWORK_TIER_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_PTR_DOMAIN_NAME_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SET_PUBLIC_PTR_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    external_ipv6: str
    external_ipv6_prefix_length: int
    kind: str
    name: str
    nat_i_p: str
    network_tier: str
    public_ptr_domain_name: str
    security_policy: str
    set_public_ptr: bool
    type: str
    def __init__(self, external_ipv6: _Optional[str] = ..., external_ipv6_prefix_length: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., nat_i_p: _Optional[str] = ..., network_tier: _Optional[str] = ..., public_ptr_domain_name: _Optional[str] = ..., security_policy: _Optional[str] = ..., set_public_ptr: bool = ..., type: _Optional[str] = ...) -> None: ...

class AddAccessConfigInstanceRequest(_message.Message):
    __slots__ = ("access_config_resource", "instance", "network_interface", "project", "request_id", "zone")
    ACCESS_CONFIG_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    access_config_resource: AccessConfig
    instance: str
    network_interface: str
    project: str
    request_id: str
    zone: str
    def __init__(self, access_config_resource: _Optional[_Union[AccessConfig, _Mapping]] = ..., instance: _Optional[str] = ..., network_interface: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AddAssociationFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_association_resource", "replace_existing_association", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_ASSOCIATION_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REPLACE_EXISTING_ASSOCIATION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_association_resource: FirewallPolicyAssociation
    replace_existing_association: bool
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_association_resource: _Optional[_Union[FirewallPolicyAssociation, _Mapping]] = ..., replace_existing_association: bool = ..., request_id: _Optional[str] = ...) -> None: ...

class AddAssociationNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_association_resource", "project", "replace_existing_association", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_ASSOCIATION_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REPLACE_EXISTING_ASSOCIATION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_association_resource: FirewallPolicyAssociation
    project: str
    replace_existing_association: bool
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_association_resource: _Optional[_Union[FirewallPolicyAssociation, _Mapping]] = ..., project: _Optional[str] = ..., replace_existing_association: bool = ..., request_id: _Optional[str] = ...) -> None: ...

class AddAssociationRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_association_resource", "project", "region", "replace_existing_association", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_ASSOCIATION_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REPLACE_EXISTING_ASSOCIATION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_association_resource: FirewallPolicyAssociation
    project: str
    region: str
    replace_existing_association: bool
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_association_resource: _Optional[_Union[FirewallPolicyAssociation, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., replace_existing_association: bool = ..., request_id: _Optional[str] = ...) -> None: ...

class AddHealthCheckTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_pool", "target_pools_add_health_check_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOLS_ADD_HEALTH_CHECK_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_pool: str
    target_pools_add_health_check_request_resource: TargetPoolsAddHealthCheckRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_pool: _Optional[str] = ..., target_pools_add_health_check_request_resource: _Optional[_Union[TargetPoolsAddHealthCheckRequest, _Mapping]] = ...) -> None: ...

class AddInstanceTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_pool", "target_pools_add_instance_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOLS_ADD_INSTANCE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_pool: str
    target_pools_add_instance_request_resource: TargetPoolsAddInstanceRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_pool: _Optional[str] = ..., target_pools_add_instance_request_resource: _Optional[_Union[TargetPoolsAddInstanceRequest, _Mapping]] = ...) -> None: ...

class AddInstancesInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group", "instance_groups_add_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUPS_ADD_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group: str
    instance_groups_add_instances_request_resource: InstanceGroupsAddInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group: _Optional[str] = ..., instance_groups_add_instances_request_resource: _Optional[_Union[InstanceGroupsAddInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AddNodesNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "node_groups_add_nodes_request_resource", "project", "request_id", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUPS_ADD_NODES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    node_groups_add_nodes_request_resource: NodeGroupsAddNodesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., node_groups_add_nodes_request_resource: _Optional[_Union[NodeGroupsAddNodesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AddPeeringNetworkRequest(_message.Message):
    __slots__ = ("network", "networks_add_peering_request_resource", "project", "request_id")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORKS_ADD_PEERING_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network: str
    networks_add_peering_request_resource: NetworksAddPeeringRequest
    project: str
    request_id: str
    def __init__(self, network: _Optional[str] = ..., networks_add_peering_request_resource: _Optional[_Union[NetworksAddPeeringRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class AddResourcePoliciesDiskRequest(_message.Message):
    __slots__ = ("disk", "disks_add_resource_policies_request_resource", "project", "request_id", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    DISKS_ADD_RESOURCE_POLICIES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    disks_add_resource_policies_request_resource: DisksAddResourcePoliciesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., disks_add_resource_policies_request_resource: _Optional[_Union[DisksAddResourcePoliciesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AddResourcePoliciesInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_add_resource_policies_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_ADD_RESOURCE_POLICIES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_add_resource_policies_request_resource: InstancesAddResourcePoliciesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_add_resource_policies_request_resource: _Optional[_Union[InstancesAddResourcePoliciesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AddResourcePoliciesRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region", "region_disks_add_resource_policies_request_resource", "request_id")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_DISKS_ADD_RESOURCE_POLICIES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    region_disks_add_resource_policies_request_resource: RegionDisksAddResourcePoliciesRequest
    request_id: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_disks_add_resource_policies_request_resource: _Optional[_Union[RegionDisksAddResourcePoliciesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class AddRuleFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_rule_resource", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_rule_resource: FirewallPolicyRule
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_rule_resource: _Optional[_Union[FirewallPolicyRule, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class AddRuleNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_rule_resource", "max_priority", "min_priority", "project", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    MAX_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    MIN_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_rule_resource: FirewallPolicyRule
    max_priority: int
    min_priority: int
    project: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_rule_resource: _Optional[_Union[FirewallPolicyRule, _Mapping]] = ..., max_priority: _Optional[int] = ..., min_priority: _Optional[int] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class AddRuleRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_rule_resource", "max_priority", "min_priority", "project", "region", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    MAX_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    MIN_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_rule_resource: FirewallPolicyRule
    max_priority: int
    min_priority: int
    project: str
    region: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_rule_resource: _Optional[_Union[FirewallPolicyRule, _Mapping]] = ..., max_priority: _Optional[int] = ..., min_priority: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class AddRuleRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "security_policy", "security_policy_rule_resource", "validate_only")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    security_policy: str
    security_policy_rule_resource: SecurityPolicyRule
    validate_only: bool
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ..., security_policy_rule_resource: _Optional[_Union[SecurityPolicyRule, _Mapping]] = ..., validate_only: bool = ...) -> None: ...

class AddRuleSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "security_policy", "security_policy_rule_resource", "validate_only")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    project: str
    security_policy: str
    security_policy_rule_resource: SecurityPolicyRule
    validate_only: bool
    def __init__(self, project: _Optional[str] = ..., security_policy: _Optional[str] = ..., security_policy_rule_resource: _Optional[_Union[SecurityPolicyRule, _Mapping]] = ..., validate_only: bool = ...) -> None: ...

class AddSignedUrlKeyBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket", "project", "request_id", "signed_url_key_resource")
    BACKEND_BUCKET_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SIGNED_URL_KEY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_bucket: str
    project: str
    request_id: str
    signed_url_key_resource: SignedUrlKey
    def __init__(self, backend_bucket: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., signed_url_key_resource: _Optional[_Union[SignedUrlKey, _Mapping]] = ...) -> None: ...

class AddSignedUrlKeyBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "request_id", "signed_url_key_resource")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SIGNED_URL_KEY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    request_id: str
    signed_url_key_resource: SignedUrlKey
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., signed_url_key_resource: _Optional[_Union[SignedUrlKey, _Mapping]] = ...) -> None: ...

class Address(_message.Message):
    __slots__ = ("address", "address_type", "creation_timestamp", "description", "id", "ip_version", "ipv6_endpoint_type", "kind", "label_fingerprint", "labels", "name", "network", "network_tier", "prefix_length", "purpose", "region", "self_link", "status", "subnetwork", "users")
    class AddressType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ADDRESS_TYPE: _ClassVar[Address.AddressType]
        EXTERNAL: _ClassVar[Address.AddressType]
        INTERNAL: _ClassVar[Address.AddressType]
        UNSPECIFIED_TYPE: _ClassVar[Address.AddressType]
    UNDEFINED_ADDRESS_TYPE: Address.AddressType
    EXTERNAL: Address.AddressType
    INTERNAL: Address.AddressType
    UNSPECIFIED_TYPE: Address.AddressType
    class IpVersion(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IP_VERSION: _ClassVar[Address.IpVersion]
        IPV4: _ClassVar[Address.IpVersion]
        IPV6: _ClassVar[Address.IpVersion]
        UNSPECIFIED_VERSION: _ClassVar[Address.IpVersion]
    UNDEFINED_IP_VERSION: Address.IpVersion
    IPV4: Address.IpVersion
    IPV6: Address.IpVersion
    UNSPECIFIED_VERSION: Address.IpVersion
    class Ipv6EndpointType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IPV6_ENDPOINT_TYPE: _ClassVar[Address.Ipv6EndpointType]
        NETLB: _ClassVar[Address.Ipv6EndpointType]
        VM: _ClassVar[Address.Ipv6EndpointType]
    UNDEFINED_IPV6_ENDPOINT_TYPE: Address.Ipv6EndpointType
    NETLB: Address.Ipv6EndpointType
    VM: Address.Ipv6EndpointType
    class NetworkTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NETWORK_TIER: _ClassVar[Address.NetworkTier]
        FIXED_STANDARD: _ClassVar[Address.NetworkTier]
        PREMIUM: _ClassVar[Address.NetworkTier]
        STANDARD: _ClassVar[Address.NetworkTier]
        STANDARD_OVERRIDES_FIXED_STANDARD: _ClassVar[Address.NetworkTier]
    UNDEFINED_NETWORK_TIER: Address.NetworkTier
    FIXED_STANDARD: Address.NetworkTier
    PREMIUM: Address.NetworkTier
    STANDARD: Address.NetworkTier
    STANDARD_OVERRIDES_FIXED_STANDARD: Address.NetworkTier
    class Purpose(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PURPOSE: _ClassVar[Address.Purpose]
        DNS_RESOLVER: _ClassVar[Address.Purpose]
        GCE_ENDPOINT: _ClassVar[Address.Purpose]
        IPSEC_INTERCONNECT: _ClassVar[Address.Purpose]
        NAT_AUTO: _ClassVar[Address.Purpose]
        PRIVATE_SERVICE_CONNECT: _ClassVar[Address.Purpose]
        SERVERLESS: _ClassVar[Address.Purpose]
        SHARED_LOADBALANCER_VIP: _ClassVar[Address.Purpose]
        VPC_PEERING: _ClassVar[Address.Purpose]
    UNDEFINED_PURPOSE: Address.Purpose
    DNS_RESOLVER: Address.Purpose
    GCE_ENDPOINT: Address.Purpose
    IPSEC_INTERCONNECT: Address.Purpose
    NAT_AUTO: Address.Purpose
    PRIVATE_SERVICE_CONNECT: Address.Purpose
    SERVERLESS: Address.Purpose
    SHARED_LOADBALANCER_VIP: Address.Purpose
    VPC_PEERING: Address.Purpose
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Address.Status]
        IN_USE: _ClassVar[Address.Status]
        RESERVED: _ClassVar[Address.Status]
        RESERVING: _ClassVar[Address.Status]
    UNDEFINED_STATUS: Address.Status
    IN_USE: Address.Status
    RESERVED: Address.Status
    RESERVING: Address.Status
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    ADDRESS_TYPE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IP_VERSION_FIELD_NUMBER: _ClassVar[int]
    IPV6_ENDPOINT_TYPE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORK_TIER_FIELD_NUMBER: _ClassVar[int]
    PREFIX_LENGTH_FIELD_NUMBER: _ClassVar[int]
    PURPOSE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    USERS_FIELD_NUMBER: _ClassVar[int]
    address: str
    address_type: str
    creation_timestamp: str
    description: str
    id: int
    ip_version: str
    ipv6_endpoint_type: str
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    name: str
    network: str
    network_tier: str
    prefix_length: int
    purpose: str
    region: str
    self_link: str
    status: str
    subnetwork: str
    users: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, address: _Optional[str] = ..., address_type: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., ip_version: _Optional[str] = ..., ipv6_endpoint_type: _Optional[str] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., network_tier: _Optional[str] = ..., prefix_length: _Optional[int] = ..., purpose: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ..., subnetwork: _Optional[str] = ..., users: _Optional[_Iterable[str]] = ...) -> None: ...

class AddressAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: AddressesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[AddressesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, AddressesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, AddressesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AddressList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Address]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Address, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AddressesScopedList(_message.Message):
    __slots__ = ("addresses", "warning")
    ADDRESSES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    addresses: _containers.RepeatedCompositeFieldContainer[Address]
    warning: Warning
    def __init__(self, addresses: _Optional[_Iterable[_Union[Address, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AdvancedMachineFeatures(_message.Message):
    __slots__ = ("enable_nested_virtualization", "enable_uefi_networking", "performance_monitoring_unit", "threads_per_core", "turbo_mode", "visible_core_count")
    class PerformanceMonitoringUnit(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PERFORMANCE_MONITORING_UNIT: _ClassVar[AdvancedMachineFeatures.PerformanceMonitoringUnit]
        ARCHITECTURAL: _ClassVar[AdvancedMachineFeatures.PerformanceMonitoringUnit]
        ENHANCED: _ClassVar[AdvancedMachineFeatures.PerformanceMonitoringUnit]
        PERFORMANCE_MONITORING_UNIT_UNSPECIFIED: _ClassVar[AdvancedMachineFeatures.PerformanceMonitoringUnit]
        STANDARD: _ClassVar[AdvancedMachineFeatures.PerformanceMonitoringUnit]
    UNDEFINED_PERFORMANCE_MONITORING_UNIT: AdvancedMachineFeatures.PerformanceMonitoringUnit
    ARCHITECTURAL: AdvancedMachineFeatures.PerformanceMonitoringUnit
    ENHANCED: AdvancedMachineFeatures.PerformanceMonitoringUnit
    PERFORMANCE_MONITORING_UNIT_UNSPECIFIED: AdvancedMachineFeatures.PerformanceMonitoringUnit
    STANDARD: AdvancedMachineFeatures.PerformanceMonitoringUnit
    ENABLE_NESTED_VIRTUALIZATION_FIELD_NUMBER: _ClassVar[int]
    ENABLE_UEFI_NETWORKING_FIELD_NUMBER: _ClassVar[int]
    PERFORMANCE_MONITORING_UNIT_FIELD_NUMBER: _ClassVar[int]
    THREADS_PER_CORE_FIELD_NUMBER: _ClassVar[int]
    TURBO_MODE_FIELD_NUMBER: _ClassVar[int]
    VISIBLE_CORE_COUNT_FIELD_NUMBER: _ClassVar[int]
    enable_nested_virtualization: bool
    enable_uefi_networking: bool
    performance_monitoring_unit: str
    threads_per_core: int
    turbo_mode: str
    visible_core_count: int
    def __init__(self, enable_nested_virtualization: bool = ..., enable_uefi_networking: bool = ..., performance_monitoring_unit: _Optional[str] = ..., threads_per_core: _Optional[int] = ..., turbo_mode: _Optional[str] = ..., visible_core_count: _Optional[int] = ...) -> None: ...

class AggregatedListAcceleratorTypesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListAddressesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListAutoscalersRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListBackendServicesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListDiskTypesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListDisksRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListForwardingRulesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListGlobalOperationsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListHealthChecksRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListInstanceGroupsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListInstanceTemplatesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListInstancesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListInstantSnapshotsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListInterconnectAttachmentsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListMachineTypesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListNetworkAttachmentsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListNetworkEdgeSecurityServicesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListNetworkEndpointGroupsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListNetworkFirewallPoliciesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListNodeGroupsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListNodeTemplatesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListNodeTypesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListPacketMirroringsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListPublicDelegatedPrefixesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListRegionCommitmentsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListReservationsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListResourcePoliciesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListRoutersRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListSecurityPoliciesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListServiceAttachmentsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListSslCertificatesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListSslPoliciesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListStoragePoolTypesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListStoragePoolsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListSubnetworksRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListTargetHttpProxiesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListTargetHttpsProxiesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListTargetInstancesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListTargetPoolsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListTargetTcpProxiesRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListTargetVpnGatewaysRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListUrlMapsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListVpnGatewaysRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AggregatedListVpnTunnelsRequest(_message.Message):
    __slots__ = ("filter", "include_all_scopes", "max_results", "order_by", "page_token", "project", "return_partial_success", "service_project_number")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ALL_SCOPES_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_PROJECT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    include_all_scopes: bool
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    service_project_number: int
    def __init__(self, filter: _Optional[str] = ..., include_all_scopes: bool = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., service_project_number: _Optional[int] = ...) -> None: ...

class AliasIpRange(_message.Message):
    __slots__ = ("ip_cidr_range", "subnetwork_range_name")
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_RANGE_NAME_FIELD_NUMBER: _ClassVar[int]
    ip_cidr_range: str
    subnetwork_range_name: str
    def __init__(self, ip_cidr_range: _Optional[str] = ..., subnetwork_range_name: _Optional[str] = ...) -> None: ...

class AllocationAggregateReservation(_message.Message):
    __slots__ = ("in_use_resources", "reserved_resources", "vm_family", "workload_type")
    class VmFamily(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_VM_FAMILY: _ClassVar[AllocationAggregateReservation.VmFamily]
        VM_FAMILY_CLOUD_TPU_DEVICE_CT3: _ClassVar[AllocationAggregateReservation.VmFamily]
        VM_FAMILY_CLOUD_TPU_LITE_DEVICE_CT5L: _ClassVar[AllocationAggregateReservation.VmFamily]
        VM_FAMILY_CLOUD_TPU_LITE_POD_SLICE_CT5LP: _ClassVar[AllocationAggregateReservation.VmFamily]
        VM_FAMILY_CLOUD_TPU_POD_SLICE_CT3P: _ClassVar[AllocationAggregateReservation.VmFamily]
        VM_FAMILY_CLOUD_TPU_POD_SLICE_CT4P: _ClassVar[AllocationAggregateReservation.VmFamily]
    UNDEFINED_VM_FAMILY: AllocationAggregateReservation.VmFamily
    VM_FAMILY_CLOUD_TPU_DEVICE_CT3: AllocationAggregateReservation.VmFamily
    VM_FAMILY_CLOUD_TPU_LITE_DEVICE_CT5L: AllocationAggregateReservation.VmFamily
    VM_FAMILY_CLOUD_TPU_LITE_POD_SLICE_CT5LP: AllocationAggregateReservation.VmFamily
    VM_FAMILY_CLOUD_TPU_POD_SLICE_CT3P: AllocationAggregateReservation.VmFamily
    VM_FAMILY_CLOUD_TPU_POD_SLICE_CT4P: AllocationAggregateReservation.VmFamily
    class WorkloadType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_WORKLOAD_TYPE: _ClassVar[AllocationAggregateReservation.WorkloadType]
        BATCH: _ClassVar[AllocationAggregateReservation.WorkloadType]
        SERVING: _ClassVar[AllocationAggregateReservation.WorkloadType]
        UNSPECIFIED: _ClassVar[AllocationAggregateReservation.WorkloadType]
    UNDEFINED_WORKLOAD_TYPE: AllocationAggregateReservation.WorkloadType
    BATCH: AllocationAggregateReservation.WorkloadType
    SERVING: AllocationAggregateReservation.WorkloadType
    UNSPECIFIED: AllocationAggregateReservation.WorkloadType
    IN_USE_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    RESERVED_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    VM_FAMILY_FIELD_NUMBER: _ClassVar[int]
    WORKLOAD_TYPE_FIELD_NUMBER: _ClassVar[int]
    in_use_resources: _containers.RepeatedCompositeFieldContainer[AllocationAggregateReservationReservedResourceInfo]
    reserved_resources: _containers.RepeatedCompositeFieldContainer[AllocationAggregateReservationReservedResourceInfo]
    vm_family: str
    workload_type: str
    def __init__(self, in_use_resources: _Optional[_Iterable[_Union[AllocationAggregateReservationReservedResourceInfo, _Mapping]]] = ..., reserved_resources: _Optional[_Iterable[_Union[AllocationAggregateReservationReservedResourceInfo, _Mapping]]] = ..., vm_family: _Optional[str] = ..., workload_type: _Optional[str] = ...) -> None: ...

class AllocationAggregateReservationReservedResourceInfo(_message.Message):
    __slots__ = ("accelerator",)
    ACCELERATOR_FIELD_NUMBER: _ClassVar[int]
    accelerator: AllocationAggregateReservationReservedResourceInfoAccelerator
    def __init__(self, accelerator: _Optional[_Union[AllocationAggregateReservationReservedResourceInfoAccelerator, _Mapping]] = ...) -> None: ...

class AllocationAggregateReservationReservedResourceInfoAccelerator(_message.Message):
    __slots__ = ("accelerator_count", "accelerator_type")
    ACCELERATOR_COUNT_FIELD_NUMBER: _ClassVar[int]
    ACCELERATOR_TYPE_FIELD_NUMBER: _ClassVar[int]
    accelerator_count: int
    accelerator_type: str
    def __init__(self, accelerator_count: _Optional[int] = ..., accelerator_type: _Optional[str] = ...) -> None: ...

class AllocationResourceStatus(_message.Message):
    __slots__ = ("specific_sku_allocation",)
    SPECIFIC_SKU_ALLOCATION_FIELD_NUMBER: _ClassVar[int]
    specific_sku_allocation: AllocationResourceStatusSpecificSKUAllocation
    def __init__(self, specific_sku_allocation: _Optional[_Union[AllocationResourceStatusSpecificSKUAllocation, _Mapping]] = ...) -> None: ...

class AllocationResourceStatusSpecificSKUAllocation(_message.Message):
    __slots__ = ("source_instance_template_id",)
    SOURCE_INSTANCE_TEMPLATE_ID_FIELD_NUMBER: _ClassVar[int]
    source_instance_template_id: str
    def __init__(self, source_instance_template_id: _Optional[str] = ...) -> None: ...

class AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk(_message.Message):
    __slots__ = ("disk_size_gb", "interface")
    class Interface(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INTERFACE: _ClassVar[AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface]
        NVME: _ClassVar[AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface]
        SCSI: _ClassVar[AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface]
    UNDEFINED_INTERFACE: AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface
    NVME: AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface
    SCSI: AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    INTERFACE_FIELD_NUMBER: _ClassVar[int]
    disk_size_gb: int
    interface: str
    def __init__(self, disk_size_gb: _Optional[int] = ..., interface: _Optional[str] = ...) -> None: ...

class AllocationSpecificSKUAllocationReservedInstanceProperties(_message.Message):
    __slots__ = ("guest_accelerators", "local_ssds", "location_hint", "machine_type", "min_cpu_platform")
    GUEST_ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    LOCAL_SSDS_FIELD_NUMBER: _ClassVar[int]
    LOCATION_HINT_FIELD_NUMBER: _ClassVar[int]
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    MIN_CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    guest_accelerators: _containers.RepeatedCompositeFieldContainer[AcceleratorConfig]
    local_ssds: _containers.RepeatedCompositeFieldContainer[AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk]
    location_hint: str
    machine_type: str
    min_cpu_platform: str
    def __init__(self, guest_accelerators: _Optional[_Iterable[_Union[AcceleratorConfig, _Mapping]]] = ..., local_ssds: _Optional[_Iterable[_Union[AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk, _Mapping]]] = ..., location_hint: _Optional[str] = ..., machine_type: _Optional[str] = ..., min_cpu_platform: _Optional[str] = ...) -> None: ...

class AllocationSpecificSKUReservation(_message.Message):
    __slots__ = ("assured_count", "count", "in_use_count", "instance_properties", "source_instance_template")
    ASSURED_COUNT_FIELD_NUMBER: _ClassVar[int]
    COUNT_FIELD_NUMBER: _ClassVar[int]
    IN_USE_COUNT_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    assured_count: int
    count: int
    in_use_count: int
    instance_properties: AllocationSpecificSKUAllocationReservedInstanceProperties
    source_instance_template: str
    def __init__(self, assured_count: _Optional[int] = ..., count: _Optional[int] = ..., in_use_count: _Optional[int] = ..., instance_properties: _Optional[_Union[AllocationSpecificSKUAllocationReservedInstanceProperties, _Mapping]] = ..., source_instance_template: _Optional[str] = ...) -> None: ...

class Allowed(_message.Message):
    __slots__ = ("I_p_protocol", "ports")
    I_P_PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    PORTS_FIELD_NUMBER: _ClassVar[int]
    I_p_protocol: str
    ports: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, I_p_protocol: _Optional[str] = ..., ports: _Optional[_Iterable[str]] = ...) -> None: ...

class AnnouncePublicAdvertisedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_advertised_prefix", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_ADVERTISED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_advertised_prefix: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_advertised_prefix: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class AnnouncePublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix", "region", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    region: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class ApplyUpdatesToInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_apply_updates_request_resource", "project", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_APPLY_UPDATES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_apply_updates_request_resource: InstanceGroupManagersApplyUpdatesRequest
    project: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_apply_updates_request_resource: _Optional[_Union[InstanceGroupManagersApplyUpdatesRequest, _Mapping]] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_apply_updates_request_resource")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_APPLY_UPDATES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_apply_updates_request_resource: RegionInstanceGroupManagersApplyUpdatesRequest
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_apply_updates_request_resource: _Optional[_Union[RegionInstanceGroupManagersApplyUpdatesRequest, _Mapping]] = ...) -> None: ...

class AttachDiskInstanceRequest(_message.Message):
    __slots__ = ("attached_disk_resource", "force_attach", "instance", "project", "request_id", "zone")
    ATTACHED_DISK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    FORCE_ATTACH_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    attached_disk_resource: AttachedDisk
    force_attach: bool
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, attached_disk_resource: _Optional[_Union[AttachedDisk, _Mapping]] = ..., force_attach: bool = ..., instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("global_network_endpoint_groups_attach_endpoints_request_resource", "network_endpoint_group", "project", "request_id")
    GLOBAL_NETWORK_ENDPOINT_GROUPS_ATTACH_ENDPOINTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    global_network_endpoint_groups_attach_endpoints_request_resource: GlobalNetworkEndpointGroupsAttachEndpointsRequest
    network_endpoint_group: str
    project: str
    request_id: str
    def __init__(self, global_network_endpoint_groups_attach_endpoints_request_resource: _Optional[_Union[GlobalNetworkEndpointGroupsAttachEndpointsRequest, _Mapping]] = ..., network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class AttachNetworkEndpointsNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "network_endpoint_groups_attach_endpoints_request_resource", "project", "request_id", "zone")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUPS_ATTACH_ENDPOINTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    network_endpoint_groups_attach_endpoints_request_resource: NetworkEndpointGroupsAttachEndpointsRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., network_endpoint_groups_attach_endpoints_request_resource: _Optional[_Union[NetworkEndpointGroupsAttachEndpointsRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AttachNetworkEndpointsRegionNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project", "region", "region_network_endpoint_groups_attach_endpoints_request_resource", "request_id")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_NETWORK_ENDPOINT_GROUPS_ATTACH_ENDPOINTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    region: str
    region_network_endpoint_groups_attach_endpoints_request_resource: RegionNetworkEndpointGroupsAttachEndpointsRequest
    request_id: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_network_endpoint_groups_attach_endpoints_request_resource: _Optional[_Union[RegionNetworkEndpointGroupsAttachEndpointsRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class AttachedDisk(_message.Message):
    __slots__ = ("architecture", "auto_delete", "boot", "device_name", "disk_encryption_key", "disk_size_gb", "force_attach", "guest_os_features", "index", "initialize_params", "interface", "kind", "licenses", "mode", "saved_state", "shielded_instance_initial_state", "source", "type")
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[AttachedDisk.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[AttachedDisk.Architecture]
        ARM64: _ClassVar[AttachedDisk.Architecture]
        X86_64: _ClassVar[AttachedDisk.Architecture]
    UNDEFINED_ARCHITECTURE: AttachedDisk.Architecture
    ARCHITECTURE_UNSPECIFIED: AttachedDisk.Architecture
    ARM64: AttachedDisk.Architecture
    X86_64: AttachedDisk.Architecture
    class Interface(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INTERFACE: _ClassVar[AttachedDisk.Interface]
        NVME: _ClassVar[AttachedDisk.Interface]
        SCSI: _ClassVar[AttachedDisk.Interface]
    UNDEFINED_INTERFACE: AttachedDisk.Interface
    NVME: AttachedDisk.Interface
    SCSI: AttachedDisk.Interface
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[AttachedDisk.Mode]
        READ_ONLY: _ClassVar[AttachedDisk.Mode]
        READ_WRITE: _ClassVar[AttachedDisk.Mode]
    UNDEFINED_MODE: AttachedDisk.Mode
    READ_ONLY: AttachedDisk.Mode
    READ_WRITE: AttachedDisk.Mode
    class SavedState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SAVED_STATE: _ClassVar[AttachedDisk.SavedState]
        DISK_SAVED_STATE_UNSPECIFIED: _ClassVar[AttachedDisk.SavedState]
        PRESERVED: _ClassVar[AttachedDisk.SavedState]
    UNDEFINED_SAVED_STATE: AttachedDisk.SavedState
    DISK_SAVED_STATE_UNSPECIFIED: AttachedDisk.SavedState
    PRESERVED: AttachedDisk.SavedState
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[AttachedDisk.Type]
        PERSISTENT: _ClassVar[AttachedDisk.Type]
        SCRATCH: _ClassVar[AttachedDisk.Type]
    UNDEFINED_TYPE: AttachedDisk.Type
    PERSISTENT: AttachedDisk.Type
    SCRATCH: AttachedDisk.Type
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    BOOT_FIELD_NUMBER: _ClassVar[int]
    DEVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    DISK_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    FORCE_ATTACH_FIELD_NUMBER: _ClassVar[int]
    GUEST_OS_FEATURES_FIELD_NUMBER: _ClassVar[int]
    INDEX_FIELD_NUMBER: _ClassVar[int]
    INITIALIZE_PARAMS_FIELD_NUMBER: _ClassVar[int]
    INTERFACE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LICENSES_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    SAVED_STATE_FIELD_NUMBER: _ClassVar[int]
    SHIELDED_INSTANCE_INITIAL_STATE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    architecture: str
    auto_delete: bool
    boot: bool
    device_name: str
    disk_encryption_key: CustomerEncryptionKey
    disk_size_gb: int
    force_attach: bool
    guest_os_features: _containers.RepeatedCompositeFieldContainer[GuestOsFeature]
    index: int
    initialize_params: AttachedDiskInitializeParams
    interface: str
    kind: str
    licenses: _containers.RepeatedScalarFieldContainer[str]
    mode: str
    saved_state: str
    shielded_instance_initial_state: InitialStateConfig
    source: str
    type: str
    def __init__(self, architecture: _Optional[str] = ..., auto_delete: bool = ..., boot: bool = ..., device_name: _Optional[str] = ..., disk_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., disk_size_gb: _Optional[int] = ..., force_attach: bool = ..., guest_os_features: _Optional[_Iterable[_Union[GuestOsFeature, _Mapping]]] = ..., index: _Optional[int] = ..., initialize_params: _Optional[_Union[AttachedDiskInitializeParams, _Mapping]] = ..., interface: _Optional[str] = ..., kind: _Optional[str] = ..., licenses: _Optional[_Iterable[str]] = ..., mode: _Optional[str] = ..., saved_state: _Optional[str] = ..., shielded_instance_initial_state: _Optional[_Union[InitialStateConfig, _Mapping]] = ..., source: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class AttachedDiskInitializeParams(_message.Message):
    __slots__ = ("architecture", "description", "disk_name", "disk_size_gb", "disk_type", "enable_confidential_compute", "labels", "licenses", "on_update_action", "provisioned_iops", "provisioned_throughput", "replica_zones", "resource_manager_tags", "resource_policies", "source_image", "source_image_encryption_key", "source_snapshot", "source_snapshot_encryption_key", "storage_pool")
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[AttachedDiskInitializeParams.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[AttachedDiskInitializeParams.Architecture]
        ARM64: _ClassVar[AttachedDiskInitializeParams.Architecture]
        X86_64: _ClassVar[AttachedDiskInitializeParams.Architecture]
    UNDEFINED_ARCHITECTURE: AttachedDiskInitializeParams.Architecture
    ARCHITECTURE_UNSPECIFIED: AttachedDiskInitializeParams.Architecture
    ARM64: AttachedDiskInitializeParams.Architecture
    X86_64: AttachedDiskInitializeParams.Architecture
    class OnUpdateAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ON_UPDATE_ACTION: _ClassVar[AttachedDiskInitializeParams.OnUpdateAction]
        RECREATE_DISK: _ClassVar[AttachedDiskInitializeParams.OnUpdateAction]
        RECREATE_DISK_IF_SOURCE_CHANGED: _ClassVar[AttachedDiskInitializeParams.OnUpdateAction]
        USE_EXISTING_DISK: _ClassVar[AttachedDiskInitializeParams.OnUpdateAction]
    UNDEFINED_ON_UPDATE_ACTION: AttachedDiskInitializeParams.OnUpdateAction
    RECREATE_DISK: AttachedDiskInitializeParams.OnUpdateAction
    RECREATE_DISK_IF_SOURCE_CHANGED: AttachedDiskInitializeParams.OnUpdateAction
    USE_EXISTING_DISK: AttachedDiskInitializeParams.OnUpdateAction
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class ResourceManagerTagsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISK_NAME_FIELD_NUMBER: _ClassVar[int]
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    DISK_TYPE_FIELD_NUMBER: _ClassVar[int]
    ENABLE_CONFIDENTIAL_COMPUTE_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LICENSES_FIELD_NUMBER: _ClassVar[int]
    ON_UPDATE_ACTION_FIELD_NUMBER: _ClassVar[int]
    PROVISIONED_IOPS_FIELD_NUMBER: _ClassVar[int]
    PROVISIONED_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    REPLICA_ZONES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_MANAGER_TAGS_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_FIELD_NUMBER: _ClassVar[int]
    architecture: str
    description: str
    disk_name: str
    disk_size_gb: int
    disk_type: str
    enable_confidential_compute: bool
    labels: _containers.ScalarMap[str, str]
    licenses: _containers.RepeatedScalarFieldContainer[str]
    on_update_action: str
    provisioned_iops: int
    provisioned_throughput: int
    replica_zones: _containers.RepeatedScalarFieldContainer[str]
    resource_manager_tags: _containers.ScalarMap[str, str]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    source_image: str
    source_image_encryption_key: CustomerEncryptionKey
    source_snapshot: str
    source_snapshot_encryption_key: CustomerEncryptionKey
    storage_pool: str
    def __init__(self, architecture: _Optional[str] = ..., description: _Optional[str] = ..., disk_name: _Optional[str] = ..., disk_size_gb: _Optional[int] = ..., disk_type: _Optional[str] = ..., enable_confidential_compute: bool = ..., labels: _Optional[_Mapping[str, str]] = ..., licenses: _Optional[_Iterable[str]] = ..., on_update_action: _Optional[str] = ..., provisioned_iops: _Optional[int] = ..., provisioned_throughput: _Optional[int] = ..., replica_zones: _Optional[_Iterable[str]] = ..., resource_manager_tags: _Optional[_Mapping[str, str]] = ..., resource_policies: _Optional[_Iterable[str]] = ..., source_image: _Optional[str] = ..., source_image_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_snapshot: _Optional[str] = ..., source_snapshot_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., storage_pool: _Optional[str] = ...) -> None: ...

class AuditConfig(_message.Message):
    __slots__ = ("audit_log_configs", "exempted_members", "service")
    AUDIT_LOG_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    EXEMPTED_MEMBERS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    audit_log_configs: _containers.RepeatedCompositeFieldContainer[AuditLogConfig]
    exempted_members: _containers.RepeatedScalarFieldContainer[str]
    service: str
    def __init__(self, audit_log_configs: _Optional[_Iterable[_Union[AuditLogConfig, _Mapping]]] = ..., exempted_members: _Optional[_Iterable[str]] = ..., service: _Optional[str] = ...) -> None: ...

class AuditLogConfig(_message.Message):
    __slots__ = ("exempted_members", "ignore_child_exemptions", "log_type")
    class LogType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOG_TYPE: _ClassVar[AuditLogConfig.LogType]
        ADMIN_READ: _ClassVar[AuditLogConfig.LogType]
        DATA_READ: _ClassVar[AuditLogConfig.LogType]
        DATA_WRITE: _ClassVar[AuditLogConfig.LogType]
        LOG_TYPE_UNSPECIFIED: _ClassVar[AuditLogConfig.LogType]
    UNDEFINED_LOG_TYPE: AuditLogConfig.LogType
    ADMIN_READ: AuditLogConfig.LogType
    DATA_READ: AuditLogConfig.LogType
    DATA_WRITE: AuditLogConfig.LogType
    LOG_TYPE_UNSPECIFIED: AuditLogConfig.LogType
    EXEMPTED_MEMBERS_FIELD_NUMBER: _ClassVar[int]
    IGNORE_CHILD_EXEMPTIONS_FIELD_NUMBER: _ClassVar[int]
    LOG_TYPE_FIELD_NUMBER: _ClassVar[int]
    exempted_members: _containers.RepeatedScalarFieldContainer[str]
    ignore_child_exemptions: bool
    log_type: str
    def __init__(self, exempted_members: _Optional[_Iterable[str]] = ..., ignore_child_exemptions: bool = ..., log_type: _Optional[str] = ...) -> None: ...

class Autoscaler(_message.Message):
    __slots__ = ("autoscaling_policy", "creation_timestamp", "description", "id", "kind", "name", "recommended_size", "region", "scaling_schedule_status", "self_link", "status", "status_details", "target", "zone")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Autoscaler.Status]
        ACTIVE: _ClassVar[Autoscaler.Status]
        DELETING: _ClassVar[Autoscaler.Status]
        ERROR: _ClassVar[Autoscaler.Status]
        PENDING: _ClassVar[Autoscaler.Status]
    UNDEFINED_STATUS: Autoscaler.Status
    ACTIVE: Autoscaler.Status
    DELETING: Autoscaler.Status
    ERROR: Autoscaler.Status
    PENDING: Autoscaler.Status
    class ScalingScheduleStatusEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ScalingScheduleStatus
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ScalingScheduleStatus, _Mapping]] = ...) -> None: ...
    AUTOSCALING_POLICY_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    RECOMMENDED_SIZE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SCALING_SCHEDULE_STATUS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STATUS_DETAILS_FIELD_NUMBER: _ClassVar[int]
    TARGET_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    autoscaling_policy: AutoscalingPolicy
    creation_timestamp: str
    description: str
    id: int
    kind: str
    name: str
    recommended_size: int
    region: str
    scaling_schedule_status: _containers.MessageMap[str, ScalingScheduleStatus]
    self_link: str
    status: str
    status_details: _containers.RepeatedCompositeFieldContainer[AutoscalerStatusDetails]
    target: str
    zone: str
    def __init__(self, autoscaling_policy: _Optional[_Union[AutoscalingPolicy, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., recommended_size: _Optional[int] = ..., region: _Optional[str] = ..., scaling_schedule_status: _Optional[_Mapping[str, ScalingScheduleStatus]] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ..., status_details: _Optional[_Iterable[_Union[AutoscalerStatusDetails, _Mapping]]] = ..., target: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class AutoscalerAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: AutoscalersScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[AutoscalersScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, AutoscalersScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, AutoscalersScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AutoscalerList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Autoscaler]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Autoscaler, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AutoscalerStatusDetails(_message.Message):
    __slots__ = ("message", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[AutoscalerStatusDetails.Type]
        ALL_INSTANCES_UNHEALTHY: _ClassVar[AutoscalerStatusDetails.Type]
        BACKEND_SERVICE_DOES_NOT_EXIST: _ClassVar[AutoscalerStatusDetails.Type]
        CAPPED_AT_MAX_NUM_REPLICAS: _ClassVar[AutoscalerStatusDetails.Type]
        CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE: _ClassVar[AutoscalerStatusDetails.Type]
        CUSTOM_METRIC_INVALID: _ClassVar[AutoscalerStatusDetails.Type]
        MIN_EQUALS_MAX: _ClassVar[AutoscalerStatusDetails.Type]
        MISSING_CUSTOM_METRIC_DATA_POINTS: _ClassVar[AutoscalerStatusDetails.Type]
        MISSING_LOAD_BALANCING_DATA_POINTS: _ClassVar[AutoscalerStatusDetails.Type]
        MODE_OFF: _ClassVar[AutoscalerStatusDetails.Type]
        MODE_ONLY_SCALE_OUT: _ClassVar[AutoscalerStatusDetails.Type]
        MODE_ONLY_UP: _ClassVar[AutoscalerStatusDetails.Type]
        MORE_THAN_ONE_BACKEND_SERVICE: _ClassVar[AutoscalerStatusDetails.Type]
        NOT_ENOUGH_QUOTA_AVAILABLE: _ClassVar[AutoscalerStatusDetails.Type]
        REGION_RESOURCE_STOCKOUT: _ClassVar[AutoscalerStatusDetails.Type]
        SCALING_TARGET_DOES_NOT_EXIST: _ClassVar[AutoscalerStatusDetails.Type]
        SCHEDULED_INSTANCES_GREATER_THAN_AUTOSCALER_MAX: _ClassVar[AutoscalerStatusDetails.Type]
        SCHEDULED_INSTANCES_LESS_THAN_AUTOSCALER_MIN: _ClassVar[AutoscalerStatusDetails.Type]
        UNKNOWN: _ClassVar[AutoscalerStatusDetails.Type]
        UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION: _ClassVar[AutoscalerStatusDetails.Type]
        ZONE_RESOURCE_STOCKOUT: _ClassVar[AutoscalerStatusDetails.Type]
    UNDEFINED_TYPE: AutoscalerStatusDetails.Type
    ALL_INSTANCES_UNHEALTHY: AutoscalerStatusDetails.Type
    BACKEND_SERVICE_DOES_NOT_EXIST: AutoscalerStatusDetails.Type
    CAPPED_AT_MAX_NUM_REPLICAS: AutoscalerStatusDetails.Type
    CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE: AutoscalerStatusDetails.Type
    CUSTOM_METRIC_INVALID: AutoscalerStatusDetails.Type
    MIN_EQUALS_MAX: AutoscalerStatusDetails.Type
    MISSING_CUSTOM_METRIC_DATA_POINTS: AutoscalerStatusDetails.Type
    MISSING_LOAD_BALANCING_DATA_POINTS: AutoscalerStatusDetails.Type
    MODE_OFF: AutoscalerStatusDetails.Type
    MODE_ONLY_SCALE_OUT: AutoscalerStatusDetails.Type
    MODE_ONLY_UP: AutoscalerStatusDetails.Type
    MORE_THAN_ONE_BACKEND_SERVICE: AutoscalerStatusDetails.Type
    NOT_ENOUGH_QUOTA_AVAILABLE: AutoscalerStatusDetails.Type
    REGION_RESOURCE_STOCKOUT: AutoscalerStatusDetails.Type
    SCALING_TARGET_DOES_NOT_EXIST: AutoscalerStatusDetails.Type
    SCHEDULED_INSTANCES_GREATER_THAN_AUTOSCALER_MAX: AutoscalerStatusDetails.Type
    SCHEDULED_INSTANCES_LESS_THAN_AUTOSCALER_MIN: AutoscalerStatusDetails.Type
    UNKNOWN: AutoscalerStatusDetails.Type
    UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION: AutoscalerStatusDetails.Type
    ZONE_RESOURCE_STOCKOUT: AutoscalerStatusDetails.Type
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    message: str
    type: str
    def __init__(self, message: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class AutoscalersScopedList(_message.Message):
    __slots__ = ("autoscalers", "warning")
    AUTOSCALERS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    autoscalers: _containers.RepeatedCompositeFieldContainer[Autoscaler]
    warning: Warning
    def __init__(self, autoscalers: _Optional[_Iterable[_Union[Autoscaler, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class AutoscalingPolicy(_message.Message):
    __slots__ = ("cool_down_period_sec", "cpu_utilization", "custom_metric_utilizations", "load_balancing_utilization", "max_num_replicas", "min_num_replicas", "mode", "scale_in_control", "scaling_schedules")
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[AutoscalingPolicy.Mode]
        OFF: _ClassVar[AutoscalingPolicy.Mode]
        ON: _ClassVar[AutoscalingPolicy.Mode]
        ONLY_SCALE_OUT: _ClassVar[AutoscalingPolicy.Mode]
        ONLY_UP: _ClassVar[AutoscalingPolicy.Mode]
    UNDEFINED_MODE: AutoscalingPolicy.Mode
    OFF: AutoscalingPolicy.Mode
    ON: AutoscalingPolicy.Mode
    ONLY_SCALE_OUT: AutoscalingPolicy.Mode
    ONLY_UP: AutoscalingPolicy.Mode
    class ScalingSchedulesEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: AutoscalingPolicyScalingSchedule
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[AutoscalingPolicyScalingSchedule, _Mapping]] = ...) -> None: ...
    COOL_DOWN_PERIOD_SEC_FIELD_NUMBER: _ClassVar[int]
    CPU_UTILIZATION_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_METRIC_UTILIZATIONS_FIELD_NUMBER: _ClassVar[int]
    LOAD_BALANCING_UTILIZATION_FIELD_NUMBER: _ClassVar[int]
    MAX_NUM_REPLICAS_FIELD_NUMBER: _ClassVar[int]
    MIN_NUM_REPLICAS_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    SCALE_IN_CONTROL_FIELD_NUMBER: _ClassVar[int]
    SCALING_SCHEDULES_FIELD_NUMBER: _ClassVar[int]
    cool_down_period_sec: int
    cpu_utilization: AutoscalingPolicyCpuUtilization
    custom_metric_utilizations: _containers.RepeatedCompositeFieldContainer[AutoscalingPolicyCustomMetricUtilization]
    load_balancing_utilization: AutoscalingPolicyLoadBalancingUtilization
    max_num_replicas: int
    min_num_replicas: int
    mode: str
    scale_in_control: AutoscalingPolicyScaleInControl
    scaling_schedules: _containers.MessageMap[str, AutoscalingPolicyScalingSchedule]
    def __init__(self, cool_down_period_sec: _Optional[int] = ..., cpu_utilization: _Optional[_Union[AutoscalingPolicyCpuUtilization, _Mapping]] = ..., custom_metric_utilizations: _Optional[_Iterable[_Union[AutoscalingPolicyCustomMetricUtilization, _Mapping]]] = ..., load_balancing_utilization: _Optional[_Union[AutoscalingPolicyLoadBalancingUtilization, _Mapping]] = ..., max_num_replicas: _Optional[int] = ..., min_num_replicas: _Optional[int] = ..., mode: _Optional[str] = ..., scale_in_control: _Optional[_Union[AutoscalingPolicyScaleInControl, _Mapping]] = ..., scaling_schedules: _Optional[_Mapping[str, AutoscalingPolicyScalingSchedule]] = ...) -> None: ...

class AutoscalingPolicyCpuUtilization(_message.Message):
    __slots__ = ("predictive_method", "utilization_target")
    class PredictiveMethod(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PREDICTIVE_METHOD: _ClassVar[AutoscalingPolicyCpuUtilization.PredictiveMethod]
        NONE: _ClassVar[AutoscalingPolicyCpuUtilization.PredictiveMethod]
        OPTIMIZE_AVAILABILITY: _ClassVar[AutoscalingPolicyCpuUtilization.PredictiveMethod]
    UNDEFINED_PREDICTIVE_METHOD: AutoscalingPolicyCpuUtilization.PredictiveMethod
    NONE: AutoscalingPolicyCpuUtilization.PredictiveMethod
    OPTIMIZE_AVAILABILITY: AutoscalingPolicyCpuUtilization.PredictiveMethod
    PREDICTIVE_METHOD_FIELD_NUMBER: _ClassVar[int]
    UTILIZATION_TARGET_FIELD_NUMBER: _ClassVar[int]
    predictive_method: str
    utilization_target: float
    def __init__(self, predictive_method: _Optional[str] = ..., utilization_target: _Optional[float] = ...) -> None: ...

class AutoscalingPolicyCustomMetricUtilization(_message.Message):
    __slots__ = ("filter", "metric", "single_instance_assignment", "utilization_target", "utilization_target_type")
    class UtilizationTargetType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_UTILIZATION_TARGET_TYPE: _ClassVar[AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType]
        DELTA_PER_MINUTE: _ClassVar[AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType]
        DELTA_PER_SECOND: _ClassVar[AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType]
        GAUGE: _ClassVar[AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType]
    UNDEFINED_UTILIZATION_TARGET_TYPE: AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType
    DELTA_PER_MINUTE: AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType
    DELTA_PER_SECOND: AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType
    GAUGE: AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType
    FILTER_FIELD_NUMBER: _ClassVar[int]
    METRIC_FIELD_NUMBER: _ClassVar[int]
    SINGLE_INSTANCE_ASSIGNMENT_FIELD_NUMBER: _ClassVar[int]
    UTILIZATION_TARGET_FIELD_NUMBER: _ClassVar[int]
    UTILIZATION_TARGET_TYPE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    metric: str
    single_instance_assignment: float
    utilization_target: float
    utilization_target_type: str
    def __init__(self, filter: _Optional[str] = ..., metric: _Optional[str] = ..., single_instance_assignment: _Optional[float] = ..., utilization_target: _Optional[float] = ..., utilization_target_type: _Optional[str] = ...) -> None: ...

class AutoscalingPolicyLoadBalancingUtilization(_message.Message):
    __slots__ = ("utilization_target",)
    UTILIZATION_TARGET_FIELD_NUMBER: _ClassVar[int]
    utilization_target: float
    def __init__(self, utilization_target: _Optional[float] = ...) -> None: ...

class AutoscalingPolicyScaleInControl(_message.Message):
    __slots__ = ("max_scaled_in_replicas", "time_window_sec")
    MAX_SCALED_IN_REPLICAS_FIELD_NUMBER: _ClassVar[int]
    TIME_WINDOW_SEC_FIELD_NUMBER: _ClassVar[int]
    max_scaled_in_replicas: FixedOrPercent
    time_window_sec: int
    def __init__(self, max_scaled_in_replicas: _Optional[_Union[FixedOrPercent, _Mapping]] = ..., time_window_sec: _Optional[int] = ...) -> None: ...

class AutoscalingPolicyScalingSchedule(_message.Message):
    __slots__ = ("description", "disabled", "duration_sec", "min_required_replicas", "schedule", "time_zone")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    DURATION_SEC_FIELD_NUMBER: _ClassVar[int]
    MIN_REQUIRED_REPLICAS_FIELD_NUMBER: _ClassVar[int]
    SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    TIME_ZONE_FIELD_NUMBER: _ClassVar[int]
    description: str
    disabled: bool
    duration_sec: int
    min_required_replicas: int
    schedule: str
    time_zone: str
    def __init__(self, description: _Optional[str] = ..., disabled: bool = ..., duration_sec: _Optional[int] = ..., min_required_replicas: _Optional[int] = ..., schedule: _Optional[str] = ..., time_zone: _Optional[str] = ...) -> None: ...

class Backend(_message.Message):
    __slots__ = ("balancing_mode", "capacity_scaler", "description", "failover", "group", "max_connections", "max_connections_per_endpoint", "max_connections_per_instance", "max_rate", "max_rate_per_endpoint", "max_rate_per_instance", "max_utilization", "preference")
    class BalancingMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BALANCING_MODE: _ClassVar[Backend.BalancingMode]
        CONNECTION: _ClassVar[Backend.BalancingMode]
        RATE: _ClassVar[Backend.BalancingMode]
        UTILIZATION: _ClassVar[Backend.BalancingMode]
    UNDEFINED_BALANCING_MODE: Backend.BalancingMode
    CONNECTION: Backend.BalancingMode
    RATE: Backend.BalancingMode
    UTILIZATION: Backend.BalancingMode
    class Preference(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PREFERENCE: _ClassVar[Backend.Preference]
        DEFAULT: _ClassVar[Backend.Preference]
        PREFERENCE_UNSPECIFIED: _ClassVar[Backend.Preference]
        PREFERRED: _ClassVar[Backend.Preference]
    UNDEFINED_PREFERENCE: Backend.Preference
    DEFAULT: Backend.Preference
    PREFERENCE_UNSPECIFIED: Backend.Preference
    PREFERRED: Backend.Preference
    BALANCING_MODE_FIELD_NUMBER: _ClassVar[int]
    CAPACITY_SCALER_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FAILOVER_FIELD_NUMBER: _ClassVar[int]
    GROUP_FIELD_NUMBER: _ClassVar[int]
    MAX_CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    MAX_CONNECTIONS_PER_ENDPOINT_FIELD_NUMBER: _ClassVar[int]
    MAX_CONNECTIONS_PER_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    MAX_RATE_FIELD_NUMBER: _ClassVar[int]
    MAX_RATE_PER_ENDPOINT_FIELD_NUMBER: _ClassVar[int]
    MAX_RATE_PER_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    MAX_UTILIZATION_FIELD_NUMBER: _ClassVar[int]
    PREFERENCE_FIELD_NUMBER: _ClassVar[int]
    balancing_mode: str
    capacity_scaler: float
    description: str
    failover: bool
    group: str
    max_connections: int
    max_connections_per_endpoint: int
    max_connections_per_instance: int
    max_rate: int
    max_rate_per_endpoint: float
    max_rate_per_instance: float
    max_utilization: float
    preference: str
    def __init__(self, balancing_mode: _Optional[str] = ..., capacity_scaler: _Optional[float] = ..., description: _Optional[str] = ..., failover: bool = ..., group: _Optional[str] = ..., max_connections: _Optional[int] = ..., max_connections_per_endpoint: _Optional[int] = ..., max_connections_per_instance: _Optional[int] = ..., max_rate: _Optional[int] = ..., max_rate_per_endpoint: _Optional[float] = ..., max_rate_per_instance: _Optional[float] = ..., max_utilization: _Optional[float] = ..., preference: _Optional[str] = ...) -> None: ...

class BackendBucket(_message.Message):
    __slots__ = ("bucket_name", "cdn_policy", "compression_mode", "creation_timestamp", "custom_response_headers", "description", "edge_security_policy", "enable_cdn", "id", "kind", "name", "self_link", "used_by")
    class CompressionMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_COMPRESSION_MODE: _ClassVar[BackendBucket.CompressionMode]
        AUTOMATIC: _ClassVar[BackendBucket.CompressionMode]
        DISABLED: _ClassVar[BackendBucket.CompressionMode]
    UNDEFINED_COMPRESSION_MODE: BackendBucket.CompressionMode
    AUTOMATIC: BackendBucket.CompressionMode
    DISABLED: BackendBucket.CompressionMode
    BUCKET_NAME_FIELD_NUMBER: _ClassVar[int]
    CDN_POLICY_FIELD_NUMBER: _ClassVar[int]
    COMPRESSION_MODE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_RESPONSE_HEADERS_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    EDGE_SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    ENABLE_CDN_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    USED_BY_FIELD_NUMBER: _ClassVar[int]
    bucket_name: str
    cdn_policy: BackendBucketCdnPolicy
    compression_mode: str
    creation_timestamp: str
    custom_response_headers: _containers.RepeatedScalarFieldContainer[str]
    description: str
    edge_security_policy: str
    enable_cdn: bool
    id: int
    kind: str
    name: str
    self_link: str
    used_by: _containers.RepeatedCompositeFieldContainer[BackendBucketUsedBy]
    def __init__(self, bucket_name: _Optional[str] = ..., cdn_policy: _Optional[_Union[BackendBucketCdnPolicy, _Mapping]] = ..., compression_mode: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., custom_response_headers: _Optional[_Iterable[str]] = ..., description: _Optional[str] = ..., edge_security_policy: _Optional[str] = ..., enable_cdn: bool = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., self_link: _Optional[str] = ..., used_by: _Optional[_Iterable[_Union[BackendBucketUsedBy, _Mapping]]] = ...) -> None: ...

class BackendBucketCdnPolicy(_message.Message):
    __slots__ = ("bypass_cache_on_request_headers", "cache_key_policy", "cache_mode", "client_ttl", "default_ttl", "max_ttl", "negative_caching", "negative_caching_policy", "request_coalescing", "serve_while_stale", "signed_url_cache_max_age_sec", "signed_url_key_names")
    class CacheMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CACHE_MODE: _ClassVar[BackendBucketCdnPolicy.CacheMode]
        CACHE_ALL_STATIC: _ClassVar[BackendBucketCdnPolicy.CacheMode]
        FORCE_CACHE_ALL: _ClassVar[BackendBucketCdnPolicy.CacheMode]
        INVALID_CACHE_MODE: _ClassVar[BackendBucketCdnPolicy.CacheMode]
        USE_ORIGIN_HEADERS: _ClassVar[BackendBucketCdnPolicy.CacheMode]
    UNDEFINED_CACHE_MODE: BackendBucketCdnPolicy.CacheMode
    CACHE_ALL_STATIC: BackendBucketCdnPolicy.CacheMode
    FORCE_CACHE_ALL: BackendBucketCdnPolicy.CacheMode
    INVALID_CACHE_MODE: BackendBucketCdnPolicy.CacheMode
    USE_ORIGIN_HEADERS: BackendBucketCdnPolicy.CacheMode
    BYPASS_CACHE_ON_REQUEST_HEADERS_FIELD_NUMBER: _ClassVar[int]
    CACHE_KEY_POLICY_FIELD_NUMBER: _ClassVar[int]
    CACHE_MODE_FIELD_NUMBER: _ClassVar[int]
    CLIENT_TTL_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_TTL_FIELD_NUMBER: _ClassVar[int]
    MAX_TTL_FIELD_NUMBER: _ClassVar[int]
    NEGATIVE_CACHING_FIELD_NUMBER: _ClassVar[int]
    NEGATIVE_CACHING_POLICY_FIELD_NUMBER: _ClassVar[int]
    REQUEST_COALESCING_FIELD_NUMBER: _ClassVar[int]
    SERVE_WHILE_STALE_FIELD_NUMBER: _ClassVar[int]
    SIGNED_URL_CACHE_MAX_AGE_SEC_FIELD_NUMBER: _ClassVar[int]
    SIGNED_URL_KEY_NAMES_FIELD_NUMBER: _ClassVar[int]
    bypass_cache_on_request_headers: _containers.RepeatedCompositeFieldContainer[BackendBucketCdnPolicyBypassCacheOnRequestHeader]
    cache_key_policy: BackendBucketCdnPolicyCacheKeyPolicy
    cache_mode: str
    client_ttl: int
    default_ttl: int
    max_ttl: int
    negative_caching: bool
    negative_caching_policy: _containers.RepeatedCompositeFieldContainer[BackendBucketCdnPolicyNegativeCachingPolicy]
    request_coalescing: bool
    serve_while_stale: int
    signed_url_cache_max_age_sec: int
    signed_url_key_names: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, bypass_cache_on_request_headers: _Optional[_Iterable[_Union[BackendBucketCdnPolicyBypassCacheOnRequestHeader, _Mapping]]] = ..., cache_key_policy: _Optional[_Union[BackendBucketCdnPolicyCacheKeyPolicy, _Mapping]] = ..., cache_mode: _Optional[str] = ..., client_ttl: _Optional[int] = ..., default_ttl: _Optional[int] = ..., max_ttl: _Optional[int] = ..., negative_caching: bool = ..., negative_caching_policy: _Optional[_Iterable[_Union[BackendBucketCdnPolicyNegativeCachingPolicy, _Mapping]]] = ..., request_coalescing: bool = ..., serve_while_stale: _Optional[int] = ..., signed_url_cache_max_age_sec: _Optional[int] = ..., signed_url_key_names: _Optional[_Iterable[str]] = ...) -> None: ...

class BackendBucketCdnPolicyBypassCacheOnRequestHeader(_message.Message):
    __slots__ = ("header_name",)
    HEADER_NAME_FIELD_NUMBER: _ClassVar[int]
    header_name: str
    def __init__(self, header_name: _Optional[str] = ...) -> None: ...

class BackendBucketCdnPolicyCacheKeyPolicy(_message.Message):
    __slots__ = ("include_http_headers", "query_string_whitelist")
    INCLUDE_HTTP_HEADERS_FIELD_NUMBER: _ClassVar[int]
    QUERY_STRING_WHITELIST_FIELD_NUMBER: _ClassVar[int]
    include_http_headers: _containers.RepeatedScalarFieldContainer[str]
    query_string_whitelist: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, include_http_headers: _Optional[_Iterable[str]] = ..., query_string_whitelist: _Optional[_Iterable[str]] = ...) -> None: ...

class BackendBucketCdnPolicyNegativeCachingPolicy(_message.Message):
    __slots__ = ("code", "ttl")
    CODE_FIELD_NUMBER: _ClassVar[int]
    TTL_FIELD_NUMBER: _ClassVar[int]
    code: int
    ttl: int
    def __init__(self, code: _Optional[int] = ..., ttl: _Optional[int] = ...) -> None: ...

class BackendBucketList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[BackendBucket]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[BackendBucket, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class BackendBucketUsedBy(_message.Message):
    __slots__ = ("reference",)
    REFERENCE_FIELD_NUMBER: _ClassVar[int]
    reference: str
    def __init__(self, reference: _Optional[str] = ...) -> None: ...

class BackendService(_message.Message):
    __slots__ = ("affinity_cookie_ttl_sec", "backends", "cdn_policy", "circuit_breakers", "compression_mode", "connection_draining", "connection_tracking_policy", "consistent_hash", "creation_timestamp", "custom_request_headers", "custom_response_headers", "description", "edge_security_policy", "enable_c_d_n", "failover_policy", "fingerprint", "health_checks", "iap", "id", "ip_address_selection_policy", "kind", "load_balancing_scheme", "locality_lb_policies", "locality_lb_policy", "log_config", "max_stream_duration", "metadatas", "name", "network", "outlier_detection", "port", "port_name", "protocol", "region", "security_policy", "security_settings", "self_link", "service_bindings", "service_lb_policy", "session_affinity", "strong_session_affinity_cookie", "subsetting", "timeout_sec", "used_by")
    class CompressionMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_COMPRESSION_MODE: _ClassVar[BackendService.CompressionMode]
        AUTOMATIC: _ClassVar[BackendService.CompressionMode]
        DISABLED: _ClassVar[BackendService.CompressionMode]
    UNDEFINED_COMPRESSION_MODE: BackendService.CompressionMode
    AUTOMATIC: BackendService.CompressionMode
    DISABLED: BackendService.CompressionMode
    class IpAddressSelectionPolicy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IP_ADDRESS_SELECTION_POLICY: _ClassVar[BackendService.IpAddressSelectionPolicy]
        IPV4_ONLY: _ClassVar[BackendService.IpAddressSelectionPolicy]
        IPV6_ONLY: _ClassVar[BackendService.IpAddressSelectionPolicy]
        IP_ADDRESS_SELECTION_POLICY_UNSPECIFIED: _ClassVar[BackendService.IpAddressSelectionPolicy]
        PREFER_IPV6: _ClassVar[BackendService.IpAddressSelectionPolicy]
    UNDEFINED_IP_ADDRESS_SELECTION_POLICY: BackendService.IpAddressSelectionPolicy
    IPV4_ONLY: BackendService.IpAddressSelectionPolicy
    IPV6_ONLY: BackendService.IpAddressSelectionPolicy
    IP_ADDRESS_SELECTION_POLICY_UNSPECIFIED: BackendService.IpAddressSelectionPolicy
    PREFER_IPV6: BackendService.IpAddressSelectionPolicy
    class LoadBalancingScheme(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOAD_BALANCING_SCHEME: _ClassVar[BackendService.LoadBalancingScheme]
        EXTERNAL: _ClassVar[BackendService.LoadBalancingScheme]
        EXTERNAL_MANAGED: _ClassVar[BackendService.LoadBalancingScheme]
        INTERNAL: _ClassVar[BackendService.LoadBalancingScheme]
        INTERNAL_MANAGED: _ClassVar[BackendService.LoadBalancingScheme]
        INTERNAL_SELF_MANAGED: _ClassVar[BackendService.LoadBalancingScheme]
        INVALID_LOAD_BALANCING_SCHEME: _ClassVar[BackendService.LoadBalancingScheme]
    UNDEFINED_LOAD_BALANCING_SCHEME: BackendService.LoadBalancingScheme
    EXTERNAL: BackendService.LoadBalancingScheme
    EXTERNAL_MANAGED: BackendService.LoadBalancingScheme
    INTERNAL: BackendService.LoadBalancingScheme
    INTERNAL_MANAGED: BackendService.LoadBalancingScheme
    INTERNAL_SELF_MANAGED: BackendService.LoadBalancingScheme
    INVALID_LOAD_BALANCING_SCHEME: BackendService.LoadBalancingScheme
    class LocalityLbPolicy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOCALITY_LB_POLICY: _ClassVar[BackendService.LocalityLbPolicy]
        INVALID_LB_POLICY: _ClassVar[BackendService.LocalityLbPolicy]
        LEAST_REQUEST: _ClassVar[BackendService.LocalityLbPolicy]
        MAGLEV: _ClassVar[BackendService.LocalityLbPolicy]
        ORIGINAL_DESTINATION: _ClassVar[BackendService.LocalityLbPolicy]
        RANDOM: _ClassVar[BackendService.LocalityLbPolicy]
        RING_HASH: _ClassVar[BackendService.LocalityLbPolicy]
        ROUND_ROBIN: _ClassVar[BackendService.LocalityLbPolicy]
        WEIGHTED_MAGLEV: _ClassVar[BackendService.LocalityLbPolicy]
    UNDEFINED_LOCALITY_LB_POLICY: BackendService.LocalityLbPolicy
    INVALID_LB_POLICY: BackendService.LocalityLbPolicy
    LEAST_REQUEST: BackendService.LocalityLbPolicy
    MAGLEV: BackendService.LocalityLbPolicy
    ORIGINAL_DESTINATION: BackendService.LocalityLbPolicy
    RANDOM: BackendService.LocalityLbPolicy
    RING_HASH: BackendService.LocalityLbPolicy
    ROUND_ROBIN: BackendService.LocalityLbPolicy
    WEIGHTED_MAGLEV: BackendService.LocalityLbPolicy
    class Protocol(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROTOCOL: _ClassVar[BackendService.Protocol]
        GRPC: _ClassVar[BackendService.Protocol]
        HTTP: _ClassVar[BackendService.Protocol]
        HTTP2: _ClassVar[BackendService.Protocol]
        HTTPS: _ClassVar[BackendService.Protocol]
        SSL: _ClassVar[BackendService.Protocol]
        TCP: _ClassVar[BackendService.Protocol]
        UDP: _ClassVar[BackendService.Protocol]
        UNSPECIFIED: _ClassVar[BackendService.Protocol]
    UNDEFINED_PROTOCOL: BackendService.Protocol
    GRPC: BackendService.Protocol
    HTTP: BackendService.Protocol
    HTTP2: BackendService.Protocol
    HTTPS: BackendService.Protocol
    SSL: BackendService.Protocol
    TCP: BackendService.Protocol
    UDP: BackendService.Protocol
    UNSPECIFIED: BackendService.Protocol
    class SessionAffinity(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SESSION_AFFINITY: _ClassVar[BackendService.SessionAffinity]
        CLIENT_IP: _ClassVar[BackendService.SessionAffinity]
        CLIENT_IP_NO_DESTINATION: _ClassVar[BackendService.SessionAffinity]
        CLIENT_IP_PORT_PROTO: _ClassVar[BackendService.SessionAffinity]
        CLIENT_IP_PROTO: _ClassVar[BackendService.SessionAffinity]
        GENERATED_COOKIE: _ClassVar[BackendService.SessionAffinity]
        HEADER_FIELD: _ClassVar[BackendService.SessionAffinity]
        HTTP_COOKIE: _ClassVar[BackendService.SessionAffinity]
        NONE: _ClassVar[BackendService.SessionAffinity]
        STRONG_COOKIE_AFFINITY: _ClassVar[BackendService.SessionAffinity]
    UNDEFINED_SESSION_AFFINITY: BackendService.SessionAffinity
    CLIENT_IP: BackendService.SessionAffinity
    CLIENT_IP_NO_DESTINATION: BackendService.SessionAffinity
    CLIENT_IP_PORT_PROTO: BackendService.SessionAffinity
    CLIENT_IP_PROTO: BackendService.SessionAffinity
    GENERATED_COOKIE: BackendService.SessionAffinity
    HEADER_FIELD: BackendService.SessionAffinity
    HTTP_COOKIE: BackendService.SessionAffinity
    NONE: BackendService.SessionAffinity
    STRONG_COOKIE_AFFINITY: BackendService.SessionAffinity
    class MetadatasEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    AFFINITY_COOKIE_TTL_SEC_FIELD_NUMBER: _ClassVar[int]
    BACKENDS_FIELD_NUMBER: _ClassVar[int]
    CDN_POLICY_FIELD_NUMBER: _ClassVar[int]
    CIRCUIT_BREAKERS_FIELD_NUMBER: _ClassVar[int]
    COMPRESSION_MODE_FIELD_NUMBER: _ClassVar[int]
    CONNECTION_DRAINING_FIELD_NUMBER: _ClassVar[int]
    CONNECTION_TRACKING_POLICY_FIELD_NUMBER: _ClassVar[int]
    CONSISTENT_HASH_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_REQUEST_HEADERS_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_RESPONSE_HEADERS_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    EDGE_SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    ENABLE_C_D_N_FIELD_NUMBER: _ClassVar[int]
    FAILOVER_POLICY_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECKS_FIELD_NUMBER: _ClassVar[int]
    IAP_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_SELECTION_POLICY_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOAD_BALANCING_SCHEME_FIELD_NUMBER: _ClassVar[int]
    LOCALITY_LB_POLICIES_FIELD_NUMBER: _ClassVar[int]
    LOCALITY_LB_POLICY_FIELD_NUMBER: _ClassVar[int]
    LOG_CONFIG_FIELD_NUMBER: _ClassVar[int]
    MAX_STREAM_DURATION_FIELD_NUMBER: _ClassVar[int]
    METADATAS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    OUTLIER_DETECTION_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SECURITY_SETTINGS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SERVICE_BINDINGS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_LB_POLICY_FIELD_NUMBER: _ClassVar[int]
    SESSION_AFFINITY_FIELD_NUMBER: _ClassVar[int]
    STRONG_SESSION_AFFINITY_COOKIE_FIELD_NUMBER: _ClassVar[int]
    SUBSETTING_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    USED_BY_FIELD_NUMBER: _ClassVar[int]
    affinity_cookie_ttl_sec: int
    backends: _containers.RepeatedCompositeFieldContainer[Backend]
    cdn_policy: BackendServiceCdnPolicy
    circuit_breakers: CircuitBreakers
    compression_mode: str
    connection_draining: ConnectionDraining
    connection_tracking_policy: BackendServiceConnectionTrackingPolicy
    consistent_hash: ConsistentHashLoadBalancerSettings
    creation_timestamp: str
    custom_request_headers: _containers.RepeatedScalarFieldContainer[str]
    custom_response_headers: _containers.RepeatedScalarFieldContainer[str]
    description: str
    edge_security_policy: str
    enable_c_d_n: bool
    failover_policy: BackendServiceFailoverPolicy
    fingerprint: str
    health_checks: _containers.RepeatedScalarFieldContainer[str]
    iap: BackendServiceIAP
    id: int
    ip_address_selection_policy: str
    kind: str
    load_balancing_scheme: str
    locality_lb_policies: _containers.RepeatedCompositeFieldContainer[BackendServiceLocalityLoadBalancingPolicyConfig]
    locality_lb_policy: str
    log_config: BackendServiceLogConfig
    max_stream_duration: Duration
    metadatas: _containers.ScalarMap[str, str]
    name: str
    network: str
    outlier_detection: OutlierDetection
    port: int
    port_name: str
    protocol: str
    region: str
    security_policy: str
    security_settings: SecuritySettings
    self_link: str
    service_bindings: _containers.RepeatedScalarFieldContainer[str]
    service_lb_policy: str
    session_affinity: str
    strong_session_affinity_cookie: BackendServiceHttpCookie
    subsetting: Subsetting
    timeout_sec: int
    used_by: _containers.RepeatedCompositeFieldContainer[BackendServiceUsedBy]
    def __init__(self, affinity_cookie_ttl_sec: _Optional[int] = ..., backends: _Optional[_Iterable[_Union[Backend, _Mapping]]] = ..., cdn_policy: _Optional[_Union[BackendServiceCdnPolicy, _Mapping]] = ..., circuit_breakers: _Optional[_Union[CircuitBreakers, _Mapping]] = ..., compression_mode: _Optional[str] = ..., connection_draining: _Optional[_Union[ConnectionDraining, _Mapping]] = ..., connection_tracking_policy: _Optional[_Union[BackendServiceConnectionTrackingPolicy, _Mapping]] = ..., consistent_hash: _Optional[_Union[ConsistentHashLoadBalancerSettings, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., custom_request_headers: _Optional[_Iterable[str]] = ..., custom_response_headers: _Optional[_Iterable[str]] = ..., description: _Optional[str] = ..., edge_security_policy: _Optional[str] = ..., enable_c_d_n: bool = ..., failover_policy: _Optional[_Union[BackendServiceFailoverPolicy, _Mapping]] = ..., fingerprint: _Optional[str] = ..., health_checks: _Optional[_Iterable[str]] = ..., iap: _Optional[_Union[BackendServiceIAP, _Mapping]] = ..., id: _Optional[int] = ..., ip_address_selection_policy: _Optional[str] = ..., kind: _Optional[str] = ..., load_balancing_scheme: _Optional[str] = ..., locality_lb_policies: _Optional[_Iterable[_Union[BackendServiceLocalityLoadBalancingPolicyConfig, _Mapping]]] = ..., locality_lb_policy: _Optional[str] = ..., log_config: _Optional[_Union[BackendServiceLogConfig, _Mapping]] = ..., max_stream_duration: _Optional[_Union[Duration, _Mapping]] = ..., metadatas: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., outlier_detection: _Optional[_Union[OutlierDetection, _Mapping]] = ..., port: _Optional[int] = ..., port_name: _Optional[str] = ..., protocol: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ..., security_settings: _Optional[_Union[SecuritySettings, _Mapping]] = ..., self_link: _Optional[str] = ..., service_bindings: _Optional[_Iterable[str]] = ..., service_lb_policy: _Optional[str] = ..., session_affinity: _Optional[str] = ..., strong_session_affinity_cookie: _Optional[_Union[BackendServiceHttpCookie, _Mapping]] = ..., subsetting: _Optional[_Union[Subsetting, _Mapping]] = ..., timeout_sec: _Optional[int] = ..., used_by: _Optional[_Iterable[_Union[BackendServiceUsedBy, _Mapping]]] = ...) -> None: ...

class BackendServiceAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: BackendServicesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[BackendServicesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, BackendServicesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, BackendServicesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class BackendServiceCdnPolicy(_message.Message):
    __slots__ = ("bypass_cache_on_request_headers", "cache_key_policy", "cache_mode", "client_ttl", "default_ttl", "max_ttl", "negative_caching", "negative_caching_policy", "request_coalescing", "serve_while_stale", "signed_url_cache_max_age_sec", "signed_url_key_names")
    class CacheMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CACHE_MODE: _ClassVar[BackendServiceCdnPolicy.CacheMode]
        CACHE_ALL_STATIC: _ClassVar[BackendServiceCdnPolicy.CacheMode]
        FORCE_CACHE_ALL: _ClassVar[BackendServiceCdnPolicy.CacheMode]
        INVALID_CACHE_MODE: _ClassVar[BackendServiceCdnPolicy.CacheMode]
        USE_ORIGIN_HEADERS: _ClassVar[BackendServiceCdnPolicy.CacheMode]
    UNDEFINED_CACHE_MODE: BackendServiceCdnPolicy.CacheMode
    CACHE_ALL_STATIC: BackendServiceCdnPolicy.CacheMode
    FORCE_CACHE_ALL: BackendServiceCdnPolicy.CacheMode
    INVALID_CACHE_MODE: BackendServiceCdnPolicy.CacheMode
    USE_ORIGIN_HEADERS: BackendServiceCdnPolicy.CacheMode
    BYPASS_CACHE_ON_REQUEST_HEADERS_FIELD_NUMBER: _ClassVar[int]
    CACHE_KEY_POLICY_FIELD_NUMBER: _ClassVar[int]
    CACHE_MODE_FIELD_NUMBER: _ClassVar[int]
    CLIENT_TTL_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_TTL_FIELD_NUMBER: _ClassVar[int]
    MAX_TTL_FIELD_NUMBER: _ClassVar[int]
    NEGATIVE_CACHING_FIELD_NUMBER: _ClassVar[int]
    NEGATIVE_CACHING_POLICY_FIELD_NUMBER: _ClassVar[int]
    REQUEST_COALESCING_FIELD_NUMBER: _ClassVar[int]
    SERVE_WHILE_STALE_FIELD_NUMBER: _ClassVar[int]
    SIGNED_URL_CACHE_MAX_AGE_SEC_FIELD_NUMBER: _ClassVar[int]
    SIGNED_URL_KEY_NAMES_FIELD_NUMBER: _ClassVar[int]
    bypass_cache_on_request_headers: _containers.RepeatedCompositeFieldContainer[BackendServiceCdnPolicyBypassCacheOnRequestHeader]
    cache_key_policy: CacheKeyPolicy
    cache_mode: str
    client_ttl: int
    default_ttl: int
    max_ttl: int
    negative_caching: bool
    negative_caching_policy: _containers.RepeatedCompositeFieldContainer[BackendServiceCdnPolicyNegativeCachingPolicy]
    request_coalescing: bool
    serve_while_stale: int
    signed_url_cache_max_age_sec: int
    signed_url_key_names: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, bypass_cache_on_request_headers: _Optional[_Iterable[_Union[BackendServiceCdnPolicyBypassCacheOnRequestHeader, _Mapping]]] = ..., cache_key_policy: _Optional[_Union[CacheKeyPolicy, _Mapping]] = ..., cache_mode: _Optional[str] = ..., client_ttl: _Optional[int] = ..., default_ttl: _Optional[int] = ..., max_ttl: _Optional[int] = ..., negative_caching: bool = ..., negative_caching_policy: _Optional[_Iterable[_Union[BackendServiceCdnPolicyNegativeCachingPolicy, _Mapping]]] = ..., request_coalescing: bool = ..., serve_while_stale: _Optional[int] = ..., signed_url_cache_max_age_sec: _Optional[int] = ..., signed_url_key_names: _Optional[_Iterable[str]] = ...) -> None: ...

class BackendServiceCdnPolicyBypassCacheOnRequestHeader(_message.Message):
    __slots__ = ("header_name",)
    HEADER_NAME_FIELD_NUMBER: _ClassVar[int]
    header_name: str
    def __init__(self, header_name: _Optional[str] = ...) -> None: ...

class BackendServiceCdnPolicyNegativeCachingPolicy(_message.Message):
    __slots__ = ("code", "ttl")
    CODE_FIELD_NUMBER: _ClassVar[int]
    TTL_FIELD_NUMBER: _ClassVar[int]
    code: int
    ttl: int
    def __init__(self, code: _Optional[int] = ..., ttl: _Optional[int] = ...) -> None: ...

class BackendServiceConnectionTrackingPolicy(_message.Message):
    __slots__ = ("connection_persistence_on_unhealthy_backends", "enable_strong_affinity", "idle_timeout_sec", "tracking_mode")
    class ConnectionPersistenceOnUnhealthyBackends(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONNECTION_PERSISTENCE_ON_UNHEALTHY_BACKENDS: _ClassVar[BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends]
        ALWAYS_PERSIST: _ClassVar[BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends]
        DEFAULT_FOR_PROTOCOL: _ClassVar[BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends]
        NEVER_PERSIST: _ClassVar[BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends]
    UNDEFINED_CONNECTION_PERSISTENCE_ON_UNHEALTHY_BACKENDS: BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends
    ALWAYS_PERSIST: BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends
    DEFAULT_FOR_PROTOCOL: BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends
    NEVER_PERSIST: BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends
    class TrackingMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TRACKING_MODE: _ClassVar[BackendServiceConnectionTrackingPolicy.TrackingMode]
        INVALID_TRACKING_MODE: _ClassVar[BackendServiceConnectionTrackingPolicy.TrackingMode]
        PER_CONNECTION: _ClassVar[BackendServiceConnectionTrackingPolicy.TrackingMode]
        PER_SESSION: _ClassVar[BackendServiceConnectionTrackingPolicy.TrackingMode]
    UNDEFINED_TRACKING_MODE: BackendServiceConnectionTrackingPolicy.TrackingMode
    INVALID_TRACKING_MODE: BackendServiceConnectionTrackingPolicy.TrackingMode
    PER_CONNECTION: BackendServiceConnectionTrackingPolicy.TrackingMode
    PER_SESSION: BackendServiceConnectionTrackingPolicy.TrackingMode
    CONNECTION_PERSISTENCE_ON_UNHEALTHY_BACKENDS_FIELD_NUMBER: _ClassVar[int]
    ENABLE_STRONG_AFFINITY_FIELD_NUMBER: _ClassVar[int]
    IDLE_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    TRACKING_MODE_FIELD_NUMBER: _ClassVar[int]
    connection_persistence_on_unhealthy_backends: str
    enable_strong_affinity: bool
    idle_timeout_sec: int
    tracking_mode: str
    def __init__(self, connection_persistence_on_unhealthy_backends: _Optional[str] = ..., enable_strong_affinity: bool = ..., idle_timeout_sec: _Optional[int] = ..., tracking_mode: _Optional[str] = ...) -> None: ...

class BackendServiceFailoverPolicy(_message.Message):
    __slots__ = ("disable_connection_drain_on_failover", "drop_traffic_if_unhealthy", "failover_ratio")
    DISABLE_CONNECTION_DRAIN_ON_FAILOVER_FIELD_NUMBER: _ClassVar[int]
    DROP_TRAFFIC_IF_UNHEALTHY_FIELD_NUMBER: _ClassVar[int]
    FAILOVER_RATIO_FIELD_NUMBER: _ClassVar[int]
    disable_connection_drain_on_failover: bool
    drop_traffic_if_unhealthy: bool
    failover_ratio: float
    def __init__(self, disable_connection_drain_on_failover: bool = ..., drop_traffic_if_unhealthy: bool = ..., failover_ratio: _Optional[float] = ...) -> None: ...

class BackendServiceGroupHealth(_message.Message):
    __slots__ = ("annotations", "health_status", "kind")
    class AnnotationsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ANNOTATIONS_FIELD_NUMBER: _ClassVar[int]
    HEALTH_STATUS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    annotations: _containers.ScalarMap[str, str]
    health_status: _containers.RepeatedCompositeFieldContainer[HealthStatus]
    kind: str
    def __init__(self, annotations: _Optional[_Mapping[str, str]] = ..., health_status: _Optional[_Iterable[_Union[HealthStatus, _Mapping]]] = ..., kind: _Optional[str] = ...) -> None: ...

class BackendServiceHttpCookie(_message.Message):
    __slots__ = ("name", "path", "ttl")
    NAME_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    TTL_FIELD_NUMBER: _ClassVar[int]
    name: str
    path: str
    ttl: Duration
    def __init__(self, name: _Optional[str] = ..., path: _Optional[str] = ..., ttl: _Optional[_Union[Duration, _Mapping]] = ...) -> None: ...

class BackendServiceIAP(_message.Message):
    __slots__ = ("enabled", "oauth2_client_id", "oauth2_client_secret", "oauth2_client_secret_sha256")
    ENABLED_FIELD_NUMBER: _ClassVar[int]
    OAUTH2_CLIENT_ID_FIELD_NUMBER: _ClassVar[int]
    OAUTH2_CLIENT_SECRET_FIELD_NUMBER: _ClassVar[int]
    OAUTH2_CLIENT_SECRET_SHA256_FIELD_NUMBER: _ClassVar[int]
    enabled: bool
    oauth2_client_id: str
    oauth2_client_secret: str
    oauth2_client_secret_sha256: str
    def __init__(self, enabled: bool = ..., oauth2_client_id: _Optional[str] = ..., oauth2_client_secret: _Optional[str] = ..., oauth2_client_secret_sha256: _Optional[str] = ...) -> None: ...

class BackendServiceList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[BackendService]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[BackendService, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class BackendServiceListUsable(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[BackendService]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[BackendService, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class BackendServiceLocalityLoadBalancingPolicyConfig(_message.Message):
    __slots__ = ("custom_policy", "policy")
    CUSTOM_POLICY_FIELD_NUMBER: _ClassVar[int]
    POLICY_FIELD_NUMBER: _ClassVar[int]
    custom_policy: BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
    policy: BackendServiceLocalityLoadBalancingPolicyConfigPolicy
    def __init__(self, custom_policy: _Optional[_Union[BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy, _Mapping]] = ..., policy: _Optional[_Union[BackendServiceLocalityLoadBalancingPolicyConfigPolicy, _Mapping]] = ...) -> None: ...

class BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy(_message.Message):
    __slots__ = ("data", "name")
    DATA_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    data: str
    name: str
    def __init__(self, data: _Optional[str] = ..., name: _Optional[str] = ...) -> None: ...

class BackendServiceLocalityLoadBalancingPolicyConfigPolicy(_message.Message):
    __slots__ = ("name",)
    class Name(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NAME: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        INVALID_LB_POLICY: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        LEAST_REQUEST: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        MAGLEV: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        ORIGINAL_DESTINATION: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        RANDOM: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        RING_HASH: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        ROUND_ROBIN: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
        WEIGHTED_MAGLEV: _ClassVar[BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name]
    UNDEFINED_NAME: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    INVALID_LB_POLICY: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    LEAST_REQUEST: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    MAGLEV: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    ORIGINAL_DESTINATION: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    RANDOM: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    RING_HASH: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    ROUND_ROBIN: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    WEIGHTED_MAGLEV: BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class BackendServiceLogConfig(_message.Message):
    __slots__ = ("enable", "optional_fields", "optional_mode", "sample_rate")
    class OptionalMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_OPTIONAL_MODE: _ClassVar[BackendServiceLogConfig.OptionalMode]
        CUSTOM: _ClassVar[BackendServiceLogConfig.OptionalMode]
        EXCLUDE_ALL_OPTIONAL: _ClassVar[BackendServiceLogConfig.OptionalMode]
        INCLUDE_ALL_OPTIONAL: _ClassVar[BackendServiceLogConfig.OptionalMode]
    UNDEFINED_OPTIONAL_MODE: BackendServiceLogConfig.OptionalMode
    CUSTOM: BackendServiceLogConfig.OptionalMode
    EXCLUDE_ALL_OPTIONAL: BackendServiceLogConfig.OptionalMode
    INCLUDE_ALL_OPTIONAL: BackendServiceLogConfig.OptionalMode
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    OPTIONAL_FIELDS_FIELD_NUMBER: _ClassVar[int]
    OPTIONAL_MODE_FIELD_NUMBER: _ClassVar[int]
    SAMPLE_RATE_FIELD_NUMBER: _ClassVar[int]
    enable: bool
    optional_fields: _containers.RepeatedScalarFieldContainer[str]
    optional_mode: str
    sample_rate: float
    def __init__(self, enable: bool = ..., optional_fields: _Optional[_Iterable[str]] = ..., optional_mode: _Optional[str] = ..., sample_rate: _Optional[float] = ...) -> None: ...

class BackendServiceReference(_message.Message):
    __slots__ = ("backend_service",)
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    def __init__(self, backend_service: _Optional[str] = ...) -> None: ...

class BackendServiceUsedBy(_message.Message):
    __slots__ = ("reference",)
    REFERENCE_FIELD_NUMBER: _ClassVar[int]
    reference: str
    def __init__(self, reference: _Optional[str] = ...) -> None: ...

class BackendServicesScopedList(_message.Message):
    __slots__ = ("backend_services", "warning")
    BACKEND_SERVICES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    backend_services: _containers.RepeatedCompositeFieldContainer[BackendService]
    warning: Warning
    def __init__(self, backend_services: _Optional[_Iterable[_Union[BackendService, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class BfdPacket(_message.Message):
    __slots__ = ("authentication_present", "control_plane_independent", "demand", "diagnostic", "final", "length", "min_echo_rx_interval_ms", "min_rx_interval_ms", "min_tx_interval_ms", "multiplier", "multipoint", "my_discriminator", "poll", "state", "version", "your_discriminator")
    class Diagnostic(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DIAGNOSTIC: _ClassVar[BfdPacket.Diagnostic]
        ADMINISTRATIVELY_DOWN: _ClassVar[BfdPacket.Diagnostic]
        CONCATENATED_PATH_DOWN: _ClassVar[BfdPacket.Diagnostic]
        CONTROL_DETECTION_TIME_EXPIRED: _ClassVar[BfdPacket.Diagnostic]
        DIAGNOSTIC_UNSPECIFIED: _ClassVar[BfdPacket.Diagnostic]
        ECHO_FUNCTION_FAILED: _ClassVar[BfdPacket.Diagnostic]
        FORWARDING_PLANE_RESET: _ClassVar[BfdPacket.Diagnostic]
        NEIGHBOR_SIGNALED_SESSION_DOWN: _ClassVar[BfdPacket.Diagnostic]
        NO_DIAGNOSTIC: _ClassVar[BfdPacket.Diagnostic]
        PATH_DOWN: _ClassVar[BfdPacket.Diagnostic]
        REVERSE_CONCATENATED_PATH_DOWN: _ClassVar[BfdPacket.Diagnostic]
    UNDEFINED_DIAGNOSTIC: BfdPacket.Diagnostic
    ADMINISTRATIVELY_DOWN: BfdPacket.Diagnostic
    CONCATENATED_PATH_DOWN: BfdPacket.Diagnostic
    CONTROL_DETECTION_TIME_EXPIRED: BfdPacket.Diagnostic
    DIAGNOSTIC_UNSPECIFIED: BfdPacket.Diagnostic
    ECHO_FUNCTION_FAILED: BfdPacket.Diagnostic
    FORWARDING_PLANE_RESET: BfdPacket.Diagnostic
    NEIGHBOR_SIGNALED_SESSION_DOWN: BfdPacket.Diagnostic
    NO_DIAGNOSTIC: BfdPacket.Diagnostic
    PATH_DOWN: BfdPacket.Diagnostic
    REVERSE_CONCATENATED_PATH_DOWN: BfdPacket.Diagnostic
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[BfdPacket.State]
        ADMIN_DOWN: _ClassVar[BfdPacket.State]
        DOWN: _ClassVar[BfdPacket.State]
        INIT: _ClassVar[BfdPacket.State]
        STATE_UNSPECIFIED: _ClassVar[BfdPacket.State]
        UP: _ClassVar[BfdPacket.State]
    UNDEFINED_STATE: BfdPacket.State
    ADMIN_DOWN: BfdPacket.State
    DOWN: BfdPacket.State
    INIT: BfdPacket.State
    STATE_UNSPECIFIED: BfdPacket.State
    UP: BfdPacket.State
    AUTHENTICATION_PRESENT_FIELD_NUMBER: _ClassVar[int]
    CONTROL_PLANE_INDEPENDENT_FIELD_NUMBER: _ClassVar[int]
    DEMAND_FIELD_NUMBER: _ClassVar[int]
    DIAGNOSTIC_FIELD_NUMBER: _ClassVar[int]
    FINAL_FIELD_NUMBER: _ClassVar[int]
    LENGTH_FIELD_NUMBER: _ClassVar[int]
    MIN_ECHO_RX_INTERVAL_MS_FIELD_NUMBER: _ClassVar[int]
    MIN_RX_INTERVAL_MS_FIELD_NUMBER: _ClassVar[int]
    MIN_TX_INTERVAL_MS_FIELD_NUMBER: _ClassVar[int]
    MULTIPLIER_FIELD_NUMBER: _ClassVar[int]
    MULTIPOINT_FIELD_NUMBER: _ClassVar[int]
    MY_DISCRIMINATOR_FIELD_NUMBER: _ClassVar[int]
    POLL_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    YOUR_DISCRIMINATOR_FIELD_NUMBER: _ClassVar[int]
    authentication_present: bool
    control_plane_independent: bool
    demand: bool
    diagnostic: str
    final: bool
    length: int
    min_echo_rx_interval_ms: int
    min_rx_interval_ms: int
    min_tx_interval_ms: int
    multiplier: int
    multipoint: bool
    my_discriminator: int
    poll: bool
    state: str
    version: int
    your_discriminator: int
    def __init__(self, authentication_present: bool = ..., control_plane_independent: bool = ..., demand: bool = ..., diagnostic: _Optional[str] = ..., final: bool = ..., length: _Optional[int] = ..., min_echo_rx_interval_ms: _Optional[int] = ..., min_rx_interval_ms: _Optional[int] = ..., min_tx_interval_ms: _Optional[int] = ..., multiplier: _Optional[int] = ..., multipoint: bool = ..., my_discriminator: _Optional[int] = ..., poll: bool = ..., state: _Optional[str] = ..., version: _Optional[int] = ..., your_discriminator: _Optional[int] = ...) -> None: ...

class BfdStatus(_message.Message):
    __slots__ = ("bfd_session_initialization_mode", "config_update_timestamp_micros", "control_packet_counts", "control_packet_intervals", "local_diagnostic", "local_state", "negotiated_local_control_tx_interval_ms", "rx_packet", "tx_packet", "uptime_ms")
    class BfdSessionInitializationMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BFD_SESSION_INITIALIZATION_MODE: _ClassVar[BfdStatus.BfdSessionInitializationMode]
        ACTIVE: _ClassVar[BfdStatus.BfdSessionInitializationMode]
        DISABLED: _ClassVar[BfdStatus.BfdSessionInitializationMode]
        PASSIVE: _ClassVar[BfdStatus.BfdSessionInitializationMode]
    UNDEFINED_BFD_SESSION_INITIALIZATION_MODE: BfdStatus.BfdSessionInitializationMode
    ACTIVE: BfdStatus.BfdSessionInitializationMode
    DISABLED: BfdStatus.BfdSessionInitializationMode
    PASSIVE: BfdStatus.BfdSessionInitializationMode
    class LocalDiagnostic(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOCAL_DIAGNOSTIC: _ClassVar[BfdStatus.LocalDiagnostic]
        ADMINISTRATIVELY_DOWN: _ClassVar[BfdStatus.LocalDiagnostic]
        CONCATENATED_PATH_DOWN: _ClassVar[BfdStatus.LocalDiagnostic]
        CONTROL_DETECTION_TIME_EXPIRED: _ClassVar[BfdStatus.LocalDiagnostic]
        DIAGNOSTIC_UNSPECIFIED: _ClassVar[BfdStatus.LocalDiagnostic]
        ECHO_FUNCTION_FAILED: _ClassVar[BfdStatus.LocalDiagnostic]
        FORWARDING_PLANE_RESET: _ClassVar[BfdStatus.LocalDiagnostic]
        NEIGHBOR_SIGNALED_SESSION_DOWN: _ClassVar[BfdStatus.LocalDiagnostic]
        NO_DIAGNOSTIC: _ClassVar[BfdStatus.LocalDiagnostic]
        PATH_DOWN: _ClassVar[BfdStatus.LocalDiagnostic]
        REVERSE_CONCATENATED_PATH_DOWN: _ClassVar[BfdStatus.LocalDiagnostic]
    UNDEFINED_LOCAL_DIAGNOSTIC: BfdStatus.LocalDiagnostic
    ADMINISTRATIVELY_DOWN: BfdStatus.LocalDiagnostic
    CONCATENATED_PATH_DOWN: BfdStatus.LocalDiagnostic
    CONTROL_DETECTION_TIME_EXPIRED: BfdStatus.LocalDiagnostic
    DIAGNOSTIC_UNSPECIFIED: BfdStatus.LocalDiagnostic
    ECHO_FUNCTION_FAILED: BfdStatus.LocalDiagnostic
    FORWARDING_PLANE_RESET: BfdStatus.LocalDiagnostic
    NEIGHBOR_SIGNALED_SESSION_DOWN: BfdStatus.LocalDiagnostic
    NO_DIAGNOSTIC: BfdStatus.LocalDiagnostic
    PATH_DOWN: BfdStatus.LocalDiagnostic
    REVERSE_CONCATENATED_PATH_DOWN: BfdStatus.LocalDiagnostic
    class LocalState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOCAL_STATE: _ClassVar[BfdStatus.LocalState]
        ADMIN_DOWN: _ClassVar[BfdStatus.LocalState]
        DOWN: _ClassVar[BfdStatus.LocalState]
        INIT: _ClassVar[BfdStatus.LocalState]
        STATE_UNSPECIFIED: _ClassVar[BfdStatus.LocalState]
        UP: _ClassVar[BfdStatus.LocalState]
    UNDEFINED_LOCAL_STATE: BfdStatus.LocalState
    ADMIN_DOWN: BfdStatus.LocalState
    DOWN: BfdStatus.LocalState
    INIT: BfdStatus.LocalState
    STATE_UNSPECIFIED: BfdStatus.LocalState
    UP: BfdStatus.LocalState
    BFD_SESSION_INITIALIZATION_MODE_FIELD_NUMBER: _ClassVar[int]
    CONFIG_UPDATE_TIMESTAMP_MICROS_FIELD_NUMBER: _ClassVar[int]
    CONTROL_PACKET_COUNTS_FIELD_NUMBER: _ClassVar[int]
    CONTROL_PACKET_INTERVALS_FIELD_NUMBER: _ClassVar[int]
    LOCAL_DIAGNOSTIC_FIELD_NUMBER: _ClassVar[int]
    LOCAL_STATE_FIELD_NUMBER: _ClassVar[int]
    NEGOTIATED_LOCAL_CONTROL_TX_INTERVAL_MS_FIELD_NUMBER: _ClassVar[int]
    RX_PACKET_FIELD_NUMBER: _ClassVar[int]
    TX_PACKET_FIELD_NUMBER: _ClassVar[int]
    UPTIME_MS_FIELD_NUMBER: _ClassVar[int]
    bfd_session_initialization_mode: str
    config_update_timestamp_micros: int
    control_packet_counts: BfdStatusPacketCounts
    control_packet_intervals: _containers.RepeatedCompositeFieldContainer[PacketIntervals]
    local_diagnostic: str
    local_state: str
    negotiated_local_control_tx_interval_ms: int
    rx_packet: BfdPacket
    tx_packet: BfdPacket
    uptime_ms: int
    def __init__(self, bfd_session_initialization_mode: _Optional[str] = ..., config_update_timestamp_micros: _Optional[int] = ..., control_packet_counts: _Optional[_Union[BfdStatusPacketCounts, _Mapping]] = ..., control_packet_intervals: _Optional[_Iterable[_Union[PacketIntervals, _Mapping]]] = ..., local_diagnostic: _Optional[str] = ..., local_state: _Optional[str] = ..., negotiated_local_control_tx_interval_ms: _Optional[int] = ..., rx_packet: _Optional[_Union[BfdPacket, _Mapping]] = ..., tx_packet: _Optional[_Union[BfdPacket, _Mapping]] = ..., uptime_ms: _Optional[int] = ...) -> None: ...

class BfdStatusPacketCounts(_message.Message):
    __slots__ = ("num_rx", "num_rx_rejected", "num_rx_successful", "num_tx")
    NUM_RX_FIELD_NUMBER: _ClassVar[int]
    NUM_RX_REJECTED_FIELD_NUMBER: _ClassVar[int]
    NUM_RX_SUCCESSFUL_FIELD_NUMBER: _ClassVar[int]
    NUM_TX_FIELD_NUMBER: _ClassVar[int]
    num_rx: int
    num_rx_rejected: int
    num_rx_successful: int
    num_tx: int
    def __init__(self, num_rx: _Optional[int] = ..., num_rx_rejected: _Optional[int] = ..., num_rx_successful: _Optional[int] = ..., num_tx: _Optional[int] = ...) -> None: ...

class Binding(_message.Message):
    __slots__ = ("binding_id", "condition", "members", "role")
    BINDING_ID_FIELD_NUMBER: _ClassVar[int]
    CONDITION_FIELD_NUMBER: _ClassVar[int]
    MEMBERS_FIELD_NUMBER: _ClassVar[int]
    ROLE_FIELD_NUMBER: _ClassVar[int]
    binding_id: str
    condition: Expr
    members: _containers.RepeatedScalarFieldContainer[str]
    role: str
    def __init__(self, binding_id: _Optional[str] = ..., condition: _Optional[_Union[Expr, _Mapping]] = ..., members: _Optional[_Iterable[str]] = ..., role: _Optional[str] = ...) -> None: ...

class BulkInsertDiskRequest(_message.Message):
    __slots__ = ("bulk_insert_disk_resource_resource", "project", "request_id", "zone")
    BULK_INSERT_DISK_RESOURCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    bulk_insert_disk_resource_resource: BulkInsertDiskResource
    project: str
    request_id: str
    zone: str
    def __init__(self, bulk_insert_disk_resource_resource: _Optional[_Union[BulkInsertDiskResource, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class BulkInsertDiskResource(_message.Message):
    __slots__ = ("source_consistency_group_policy",)
    SOURCE_CONSISTENCY_GROUP_POLICY_FIELD_NUMBER: _ClassVar[int]
    source_consistency_group_policy: str
    def __init__(self, source_consistency_group_policy: _Optional[str] = ...) -> None: ...

class BulkInsertInstanceRequest(_message.Message):
    __slots__ = ("bulk_insert_instance_resource_resource", "project", "request_id", "zone")
    BULK_INSERT_INSTANCE_RESOURCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    bulk_insert_instance_resource_resource: BulkInsertInstanceResource
    project: str
    request_id: str
    zone: str
    def __init__(self, bulk_insert_instance_resource_resource: _Optional[_Union[BulkInsertInstanceResource, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class BulkInsertInstanceResource(_message.Message):
    __slots__ = ("count", "instance_properties", "location_policy", "min_count", "name_pattern", "per_instance_properties", "source_instance_template")
    class PerInstancePropertiesEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: BulkInsertInstanceResourcePerInstanceProperties
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[BulkInsertInstanceResourcePerInstanceProperties, _Mapping]] = ...) -> None: ...
    COUNT_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    LOCATION_POLICY_FIELD_NUMBER: _ClassVar[int]
    MIN_COUNT_FIELD_NUMBER: _ClassVar[int]
    NAME_PATTERN_FIELD_NUMBER: _ClassVar[int]
    PER_INSTANCE_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    count: int
    instance_properties: InstanceProperties
    location_policy: LocationPolicy
    min_count: int
    name_pattern: str
    per_instance_properties: _containers.MessageMap[str, BulkInsertInstanceResourcePerInstanceProperties]
    source_instance_template: str
    def __init__(self, count: _Optional[int] = ..., instance_properties: _Optional[_Union[InstanceProperties, _Mapping]] = ..., location_policy: _Optional[_Union[LocationPolicy, _Mapping]] = ..., min_count: _Optional[int] = ..., name_pattern: _Optional[str] = ..., per_instance_properties: _Optional[_Mapping[str, BulkInsertInstanceResourcePerInstanceProperties]] = ..., source_instance_template: _Optional[str] = ...) -> None: ...

class BulkInsertInstanceResourcePerInstanceProperties(_message.Message):
    __slots__ = ("hostname", "name")
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    hostname: str
    name: str
    def __init__(self, hostname: _Optional[str] = ..., name: _Optional[str] = ...) -> None: ...

class BulkInsertOperationStatus(_message.Message):
    __slots__ = ("created_vm_count", "deleted_vm_count", "failed_to_create_vm_count", "status", "target_vm_count")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[BulkInsertOperationStatus.Status]
        CREATING: _ClassVar[BulkInsertOperationStatus.Status]
        DONE: _ClassVar[BulkInsertOperationStatus.Status]
        ROLLING_BACK: _ClassVar[BulkInsertOperationStatus.Status]
        STATUS_UNSPECIFIED: _ClassVar[BulkInsertOperationStatus.Status]
    UNDEFINED_STATUS: BulkInsertOperationStatus.Status
    CREATING: BulkInsertOperationStatus.Status
    DONE: BulkInsertOperationStatus.Status
    ROLLING_BACK: BulkInsertOperationStatus.Status
    STATUS_UNSPECIFIED: BulkInsertOperationStatus.Status
    CREATED_VM_COUNT_FIELD_NUMBER: _ClassVar[int]
    DELETED_VM_COUNT_FIELD_NUMBER: _ClassVar[int]
    FAILED_TO_CREATE_VM_COUNT_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TARGET_VM_COUNT_FIELD_NUMBER: _ClassVar[int]
    created_vm_count: int
    deleted_vm_count: int
    failed_to_create_vm_count: int
    status: str
    target_vm_count: int
    def __init__(self, created_vm_count: _Optional[int] = ..., deleted_vm_count: _Optional[int] = ..., failed_to_create_vm_count: _Optional[int] = ..., status: _Optional[str] = ..., target_vm_count: _Optional[int] = ...) -> None: ...

class BulkInsertRegionDiskRequest(_message.Message):
    __slots__ = ("bulk_insert_disk_resource_resource", "project", "region", "request_id")
    BULK_INSERT_DISK_RESOURCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    bulk_insert_disk_resource_resource: BulkInsertDiskResource
    project: str
    region: str
    request_id: str
    def __init__(self, bulk_insert_disk_resource_resource: _Optional[_Union[BulkInsertDiskResource, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class BulkInsertRegionInstanceRequest(_message.Message):
    __slots__ = ("bulk_insert_instance_resource_resource", "project", "region", "request_id")
    BULK_INSERT_INSTANCE_RESOURCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    bulk_insert_instance_resource_resource: BulkInsertInstanceResource
    project: str
    region: str
    request_id: str
    def __init__(self, bulk_insert_instance_resource_resource: _Optional[_Union[BulkInsertInstanceResource, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class CacheInvalidationRule(_message.Message):
    __slots__ = ("host", "path")
    HOST_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    host: str
    path: str
    def __init__(self, host: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class CacheKeyPolicy(_message.Message):
    __slots__ = ("include_host", "include_http_headers", "include_named_cookies", "include_protocol", "include_query_string", "query_string_blacklist", "query_string_whitelist")
    INCLUDE_HOST_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_HTTP_HEADERS_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_NAMED_COOKIES_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_QUERY_STRING_FIELD_NUMBER: _ClassVar[int]
    QUERY_STRING_BLACKLIST_FIELD_NUMBER: _ClassVar[int]
    QUERY_STRING_WHITELIST_FIELD_NUMBER: _ClassVar[int]
    include_host: bool
    include_http_headers: _containers.RepeatedScalarFieldContainer[str]
    include_named_cookies: _containers.RepeatedScalarFieldContainer[str]
    include_protocol: bool
    include_query_string: bool
    query_string_blacklist: _containers.RepeatedScalarFieldContainer[str]
    query_string_whitelist: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, include_host: bool = ..., include_http_headers: _Optional[_Iterable[str]] = ..., include_named_cookies: _Optional[_Iterable[str]] = ..., include_protocol: bool = ..., include_query_string: bool = ..., query_string_blacklist: _Optional[_Iterable[str]] = ..., query_string_whitelist: _Optional[_Iterable[str]] = ...) -> None: ...

class CancelInstanceGroupManagerResizeRequestRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "request_id", "resize_request", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESIZE_REQUEST_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    request_id: str
    resize_request: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., resize_request: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class CircuitBreakers(_message.Message):
    __slots__ = ("max_connections", "max_pending_requests", "max_requests", "max_requests_per_connection", "max_retries")
    MAX_CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    MAX_PENDING_REQUESTS_FIELD_NUMBER: _ClassVar[int]
    MAX_REQUESTS_FIELD_NUMBER: _ClassVar[int]
    MAX_REQUESTS_PER_CONNECTION_FIELD_NUMBER: _ClassVar[int]
    MAX_RETRIES_FIELD_NUMBER: _ClassVar[int]
    max_connections: int
    max_pending_requests: int
    max_requests: int
    max_requests_per_connection: int
    max_retries: int
    def __init__(self, max_connections: _Optional[int] = ..., max_pending_requests: _Optional[int] = ..., max_requests: _Optional[int] = ..., max_requests_per_connection: _Optional[int] = ..., max_retries: _Optional[int] = ...) -> None: ...

class CloneRulesFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "request_id", "source_firewall_policy")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    request_id: str
    source_firewall_policy: str
    def __init__(self, firewall_policy: _Optional[str] = ..., request_id: _Optional[str] = ..., source_firewall_policy: _Optional[str] = ...) -> None: ...

class CloneRulesNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "project", "request_id", "source_firewall_policy")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    project: str
    request_id: str
    source_firewall_policy: str
    def __init__(self, firewall_policy: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., source_firewall_policy: _Optional[str] = ...) -> None: ...

class CloneRulesRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "project", "region", "request_id", "source_firewall_policy")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    project: str
    region: str
    request_id: str
    source_firewall_policy: str
    def __init__(self, firewall_policy: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., source_firewall_policy: _Optional[str] = ...) -> None: ...

class Commitment(_message.Message):
    __slots__ = ("auto_renew", "category", "creation_timestamp", "custom_end_timestamp", "description", "end_timestamp", "existing_reservations", "id", "kind", "license_resource", "merge_source_commitments", "name", "plan", "region", "reservations", "resource_status", "resources", "self_link", "split_source_commitment", "start_timestamp", "status", "status_message", "type")
    class Category(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CATEGORY: _ClassVar[Commitment.Category]
        CATEGORY_UNSPECIFIED: _ClassVar[Commitment.Category]
        LICENSE: _ClassVar[Commitment.Category]
        MACHINE: _ClassVar[Commitment.Category]
    UNDEFINED_CATEGORY: Commitment.Category
    CATEGORY_UNSPECIFIED: Commitment.Category
    LICENSE: Commitment.Category
    MACHINE: Commitment.Category
    class Plan(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PLAN: _ClassVar[Commitment.Plan]
        INVALID: _ClassVar[Commitment.Plan]
        THIRTY_SIX_MONTH: _ClassVar[Commitment.Plan]
        TWELVE_MONTH: _ClassVar[Commitment.Plan]
    UNDEFINED_PLAN: Commitment.Plan
    INVALID: Commitment.Plan
    THIRTY_SIX_MONTH: Commitment.Plan
    TWELVE_MONTH: Commitment.Plan
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Commitment.Status]
        ACTIVE: _ClassVar[Commitment.Status]
        CANCELLED: _ClassVar[Commitment.Status]
        CREATING: _ClassVar[Commitment.Status]
        EXPIRED: _ClassVar[Commitment.Status]
        NOT_YET_ACTIVE: _ClassVar[Commitment.Status]
    UNDEFINED_STATUS: Commitment.Status
    ACTIVE: Commitment.Status
    CANCELLED: Commitment.Status
    CREATING: Commitment.Status
    EXPIRED: Commitment.Status
    NOT_YET_ACTIVE: Commitment.Status
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[Commitment.Type]
        ACCELERATOR_OPTIMIZED: _ClassVar[Commitment.Type]
        ACCELERATOR_OPTIMIZED_A3: _ClassVar[Commitment.Type]
        ACCELERATOR_OPTIMIZED_A3_MEGA: _ClassVar[Commitment.Type]
        ACCELERATOR_OPTIMIZED_A3_ULTRA: _ClassVar[Commitment.Type]
        COMPUTE_OPTIMIZED: _ClassVar[Commitment.Type]
        COMPUTE_OPTIMIZED_C2D: _ClassVar[Commitment.Type]
        COMPUTE_OPTIMIZED_C3: _ClassVar[Commitment.Type]
        COMPUTE_OPTIMIZED_C3D: _ClassVar[Commitment.Type]
        COMPUTE_OPTIMIZED_H3: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE_C4: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE_C4A: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE_E2: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE_N2: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE_N2D: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE_N4: _ClassVar[Commitment.Type]
        GENERAL_PURPOSE_T2D: _ClassVar[Commitment.Type]
        GRAPHICS_OPTIMIZED: _ClassVar[Commitment.Type]
        MEMORY_OPTIMIZED: _ClassVar[Commitment.Type]
        MEMORY_OPTIMIZED_M3: _ClassVar[Commitment.Type]
        MEMORY_OPTIMIZED_X4_16TB: _ClassVar[Commitment.Type]
        MEMORY_OPTIMIZED_X4_24TB: _ClassVar[Commitment.Type]
        MEMORY_OPTIMIZED_X4_32TB: _ClassVar[Commitment.Type]
        STORAGE_OPTIMIZED_Z3: _ClassVar[Commitment.Type]
        TYPE_UNSPECIFIED: _ClassVar[Commitment.Type]
    UNDEFINED_TYPE: Commitment.Type
    ACCELERATOR_OPTIMIZED: Commitment.Type
    ACCELERATOR_OPTIMIZED_A3: Commitment.Type
    ACCELERATOR_OPTIMIZED_A3_MEGA: Commitment.Type
    ACCELERATOR_OPTIMIZED_A3_ULTRA: Commitment.Type
    COMPUTE_OPTIMIZED: Commitment.Type
    COMPUTE_OPTIMIZED_C2D: Commitment.Type
    COMPUTE_OPTIMIZED_C3: Commitment.Type
    COMPUTE_OPTIMIZED_C3D: Commitment.Type
    COMPUTE_OPTIMIZED_H3: Commitment.Type
    GENERAL_PURPOSE: Commitment.Type
    GENERAL_PURPOSE_C4: Commitment.Type
    GENERAL_PURPOSE_C4A: Commitment.Type
    GENERAL_PURPOSE_E2: Commitment.Type
    GENERAL_PURPOSE_N2: Commitment.Type
    GENERAL_PURPOSE_N2D: Commitment.Type
    GENERAL_PURPOSE_N4: Commitment.Type
    GENERAL_PURPOSE_T2D: Commitment.Type
    GRAPHICS_OPTIMIZED: Commitment.Type
    MEMORY_OPTIMIZED: Commitment.Type
    MEMORY_OPTIMIZED_M3: Commitment.Type
    MEMORY_OPTIMIZED_X4_16TB: Commitment.Type
    MEMORY_OPTIMIZED_X4_24TB: Commitment.Type
    MEMORY_OPTIMIZED_X4_32TB: Commitment.Type
    STORAGE_OPTIMIZED_Z3: Commitment.Type
    TYPE_UNSPECIFIED: Commitment.Type
    AUTO_RENEW_FIELD_NUMBER: _ClassVar[int]
    CATEGORY_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_END_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    END_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    EXISTING_RESERVATIONS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LICENSE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    MERGE_SOURCE_COMMITMENTS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PLAN_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESERVATIONS_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    RESOURCES_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SPLIT_SOURCE_COMMITMENT_FIELD_NUMBER: _ClassVar[int]
    START_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STATUS_MESSAGE_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    auto_renew: bool
    category: str
    creation_timestamp: str
    custom_end_timestamp: str
    description: str
    end_timestamp: str
    existing_reservations: _containers.RepeatedScalarFieldContainer[str]
    id: int
    kind: str
    license_resource: LicenseResourceCommitment
    merge_source_commitments: _containers.RepeatedScalarFieldContainer[str]
    name: str
    plan: str
    region: str
    reservations: _containers.RepeatedCompositeFieldContainer[Reservation]
    resource_status: CommitmentResourceStatus
    resources: _containers.RepeatedCompositeFieldContainer[ResourceCommitment]
    self_link: str
    split_source_commitment: str
    start_timestamp: str
    status: str
    status_message: str
    type: str
    def __init__(self, auto_renew: bool = ..., category: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., custom_end_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., end_timestamp: _Optional[str] = ..., existing_reservations: _Optional[_Iterable[str]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., license_resource: _Optional[_Union[LicenseResourceCommitment, _Mapping]] = ..., merge_source_commitments: _Optional[_Iterable[str]] = ..., name: _Optional[str] = ..., plan: _Optional[str] = ..., region: _Optional[str] = ..., reservations: _Optional[_Iterable[_Union[Reservation, _Mapping]]] = ..., resource_status: _Optional[_Union[CommitmentResourceStatus, _Mapping]] = ..., resources: _Optional[_Iterable[_Union[ResourceCommitment, _Mapping]]] = ..., self_link: _Optional[str] = ..., split_source_commitment: _Optional[str] = ..., start_timestamp: _Optional[str] = ..., status: _Optional[str] = ..., status_message: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class CommitmentAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: CommitmentsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[CommitmentsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, CommitmentsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, CommitmentsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class CommitmentList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Commitment]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Commitment, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class CommitmentResourceStatus(_message.Message):
    __slots__ = ("custom_term_eligibility_end_timestamp",)
    CUSTOM_TERM_ELIGIBILITY_END_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    custom_term_eligibility_end_timestamp: str
    def __init__(self, custom_term_eligibility_end_timestamp: _Optional[str] = ...) -> None: ...

class CommitmentsScopedList(_message.Message):
    __slots__ = ("commitments", "warning")
    COMMITMENTS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    commitments: _containers.RepeatedCompositeFieldContainer[Commitment]
    warning: Warning
    def __init__(self, commitments: _Optional[_Iterable[_Union[Commitment, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ConfidentialInstanceConfig(_message.Message):
    __slots__ = ("confidential_instance_type", "enable_confidential_compute")
    class ConfidentialInstanceType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONFIDENTIAL_INSTANCE_TYPE: _ClassVar[ConfidentialInstanceConfig.ConfidentialInstanceType]
        CONFIDENTIAL_INSTANCE_TYPE_UNSPECIFIED: _ClassVar[ConfidentialInstanceConfig.ConfidentialInstanceType]
        SEV: _ClassVar[ConfidentialInstanceConfig.ConfidentialInstanceType]
        SEV_SNP: _ClassVar[ConfidentialInstanceConfig.ConfidentialInstanceType]
        TDX: _ClassVar[ConfidentialInstanceConfig.ConfidentialInstanceType]
    UNDEFINED_CONFIDENTIAL_INSTANCE_TYPE: ConfidentialInstanceConfig.ConfidentialInstanceType
    CONFIDENTIAL_INSTANCE_TYPE_UNSPECIFIED: ConfidentialInstanceConfig.ConfidentialInstanceType
    SEV: ConfidentialInstanceConfig.ConfidentialInstanceType
    SEV_SNP: ConfidentialInstanceConfig.ConfidentialInstanceType
    TDX: ConfidentialInstanceConfig.ConfidentialInstanceType
    CONFIDENTIAL_INSTANCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    ENABLE_CONFIDENTIAL_COMPUTE_FIELD_NUMBER: _ClassVar[int]
    confidential_instance_type: str
    enable_confidential_compute: bool
    def __init__(self, confidential_instance_type: _Optional[str] = ..., enable_confidential_compute: bool = ...) -> None: ...

class ConnectionDraining(_message.Message):
    __slots__ = ("draining_timeout_sec",)
    DRAINING_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    draining_timeout_sec: int
    def __init__(self, draining_timeout_sec: _Optional[int] = ...) -> None: ...

class ConsistentHashLoadBalancerSettings(_message.Message):
    __slots__ = ("http_cookie", "http_header_name", "minimum_ring_size")
    HTTP_COOKIE_FIELD_NUMBER: _ClassVar[int]
    HTTP_HEADER_NAME_FIELD_NUMBER: _ClassVar[int]
    MINIMUM_RING_SIZE_FIELD_NUMBER: _ClassVar[int]
    http_cookie: ConsistentHashLoadBalancerSettingsHttpCookie
    http_header_name: str
    minimum_ring_size: int
    def __init__(self, http_cookie: _Optional[_Union[ConsistentHashLoadBalancerSettingsHttpCookie, _Mapping]] = ..., http_header_name: _Optional[str] = ..., minimum_ring_size: _Optional[int] = ...) -> None: ...

class ConsistentHashLoadBalancerSettingsHttpCookie(_message.Message):
    __slots__ = ("name", "path", "ttl")
    NAME_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    TTL_FIELD_NUMBER: _ClassVar[int]
    name: str
    path: str
    ttl: Duration
    def __init__(self, name: _Optional[str] = ..., path: _Optional[str] = ..., ttl: _Optional[_Union[Duration, _Mapping]] = ...) -> None: ...

class CorsPolicy(_message.Message):
    __slots__ = ("allow_credentials", "allow_headers", "allow_methods", "allow_origin_regexes", "allow_origins", "disabled", "expose_headers", "max_age")
    ALLOW_CREDENTIALS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_HEADERS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_METHODS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_ORIGIN_REGEXES_FIELD_NUMBER: _ClassVar[int]
    ALLOW_ORIGINS_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    EXPOSE_HEADERS_FIELD_NUMBER: _ClassVar[int]
    MAX_AGE_FIELD_NUMBER: _ClassVar[int]
    allow_credentials: bool
    allow_headers: _containers.RepeatedScalarFieldContainer[str]
    allow_methods: _containers.RepeatedScalarFieldContainer[str]
    allow_origin_regexes: _containers.RepeatedScalarFieldContainer[str]
    allow_origins: _containers.RepeatedScalarFieldContainer[str]
    disabled: bool
    expose_headers: _containers.RepeatedScalarFieldContainer[str]
    max_age: int
    def __init__(self, allow_credentials: bool = ..., allow_headers: _Optional[_Iterable[str]] = ..., allow_methods: _Optional[_Iterable[str]] = ..., allow_origin_regexes: _Optional[_Iterable[str]] = ..., allow_origins: _Optional[_Iterable[str]] = ..., disabled: bool = ..., expose_headers: _Optional[_Iterable[str]] = ..., max_age: _Optional[int] = ...) -> None: ...

class CreateInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_create_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_CREATE_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_create_instances_request_resource: InstanceGroupManagersCreateInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_create_instances_request_resource: _Optional[_Union[InstanceGroupManagersCreateInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class CreateInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_create_instances_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_CREATE_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_create_instances_request_resource: RegionInstanceGroupManagersCreateInstancesRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_create_instances_request_resource: _Optional[_Union[RegionInstanceGroupManagersCreateInstancesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class CreateSnapshotDiskRequest(_message.Message):
    __slots__ = ("disk", "guest_flush", "project", "request_id", "snapshot_resource", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    GUEST_FLUSH_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    guest_flush: bool
    project: str
    request_id: str
    snapshot_resource: Snapshot
    zone: str
    def __init__(self, disk: _Optional[str] = ..., guest_flush: bool = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., snapshot_resource: _Optional[_Union[Snapshot, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class CreateSnapshotRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region", "request_id", "snapshot_resource")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    request_id: str
    snapshot_resource: Snapshot
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., snapshot_resource: _Optional[_Union[Snapshot, _Mapping]] = ...) -> None: ...

class CustomErrorResponsePolicy(_message.Message):
    __slots__ = ("error_response_rules", "error_service")
    ERROR_RESPONSE_RULES_FIELD_NUMBER: _ClassVar[int]
    ERROR_SERVICE_FIELD_NUMBER: _ClassVar[int]
    error_response_rules: _containers.RepeatedCompositeFieldContainer[CustomErrorResponsePolicyCustomErrorResponseRule]
    error_service: str
    def __init__(self, error_response_rules: _Optional[_Iterable[_Union[CustomErrorResponsePolicyCustomErrorResponseRule, _Mapping]]] = ..., error_service: _Optional[str] = ...) -> None: ...

class CustomErrorResponsePolicyCustomErrorResponseRule(_message.Message):
    __slots__ = ("match_response_codes", "override_response_code", "path")
    MATCH_RESPONSE_CODES_FIELD_NUMBER: _ClassVar[int]
    OVERRIDE_RESPONSE_CODE_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    match_response_codes: _containers.RepeatedScalarFieldContainer[str]
    override_response_code: int
    path: str
    def __init__(self, match_response_codes: _Optional[_Iterable[str]] = ..., override_response_code: _Optional[int] = ..., path: _Optional[str] = ...) -> None: ...

class CustomerEncryptionKey(_message.Message):
    __slots__ = ("kms_key_name", "kms_key_service_account", "raw_key", "rsa_encrypted_key", "sha256")
    KMS_KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    KMS_KEY_SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    RAW_KEY_FIELD_NUMBER: _ClassVar[int]
    RSA_ENCRYPTED_KEY_FIELD_NUMBER: _ClassVar[int]
    SHA256_FIELD_NUMBER: _ClassVar[int]
    kms_key_name: str
    kms_key_service_account: str
    raw_key: str
    rsa_encrypted_key: str
    sha256: str
    def __init__(self, kms_key_name: _Optional[str] = ..., kms_key_service_account: _Optional[str] = ..., raw_key: _Optional[str] = ..., rsa_encrypted_key: _Optional[str] = ..., sha256: _Optional[str] = ...) -> None: ...

class CustomerEncryptionKeyProtectedDisk(_message.Message):
    __slots__ = ("disk_encryption_key", "source")
    DISK_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    disk_encryption_key: CustomerEncryptionKey
    source: str
    def __init__(self, disk_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source: _Optional[str] = ...) -> None: ...

class Data(_message.Message):
    __slots__ = ("key", "value")
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    value: str
    def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class DeleteAccessConfigInstanceRequest(_message.Message):
    __slots__ = ("access_config", "instance", "network_interface", "project", "request_id", "zone")
    ACCESS_CONFIG_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    access_config: str
    instance: str
    network_interface: str
    project: str
    request_id: str
    zone: str
    def __init__(self, access_config: _Optional[str] = ..., instance: _Optional[str] = ..., network_interface: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteAddressRequest(_message.Message):
    __slots__ = ("address", "project", "region", "request_id")
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    address: str
    project: str
    region: str
    request_id: str
    def __init__(self, address: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "project", "request_id", "zone")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    project: str
    request_id: str
    zone: str
    def __init__(self, autoscaler: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket", "project", "request_id")
    BACKEND_BUCKET_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_bucket: str
    project: str
    request_id: str
    def __init__(self, backend_bucket: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "request_id")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    request_id: str
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "request_id", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    request_id: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteExternalVpnGatewayRequest(_message.Message):
    __slots__ = ("external_vpn_gateway", "project", "request_id")
    EXTERNAL_VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    external_vpn_gateway: str
    project: str
    request_id: str
    def __init__(self, external_vpn_gateway: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteFirewallRequest(_message.Message):
    __slots__ = ("firewall", "project", "request_id")
    FIREWALL_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall: str
    project: str
    request_id: str
    def __init__(self, firewall: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "project", "region", "request_id")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    project: str
    region: str
    request_id: str
    def __init__(self, forwarding_rule: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteGlobalAddressRequest(_message.Message):
    __slots__ = ("address", "project", "request_id")
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    address: str
    project: str
    request_id: str
    def __init__(self, address: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteGlobalForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "project", "request_id")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    project: str
    request_id: str
    def __init__(self, forwarding_rule: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteGlobalNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project", "request_id")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    request_id: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteGlobalOperationRequest(_message.Message):
    __slots__ = ("operation", "project")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class DeleteGlobalOperationResponse(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class DeleteGlobalOrganizationOperationRequest(_message.Message):
    __slots__ = ("operation", "parent_id")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PARENT_ID_FIELD_NUMBER: _ClassVar[int]
    operation: str
    parent_id: str
    def __init__(self, operation: _Optional[str] = ..., parent_id: _Optional[str] = ...) -> None: ...

class DeleteGlobalOrganizationOperationResponse(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class DeleteGlobalPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "project", "request_id")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    project: str
    request_id: str
    def __init__(self, health_check: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteImageRequest(_message.Message):
    __slots__ = ("image", "project", "request_id")
    IMAGE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    image: str
    project: str
    request_id: str
    def __init__(self, image: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteInstanceGroupManagerResizeRequestRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "request_id", "resize_request", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESIZE_REQUEST_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    request_id: str
    resize_request: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., resize_request: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group", "project", "request_id", "zone")
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteInstanceTemplateRequest(_message.Message):
    __slots__ = ("instance_template", "project", "request_id")
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    project: str
    request_id: str
    def __init__(self, instance_template: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_delete_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_DELETE_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_delete_instances_request_resource: InstanceGroupManagersDeleteInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_delete_instances_request_resource: _Optional[_Union[InstanceGroupManagersDeleteInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_delete_instances_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_DELETE_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_delete_instances_request_resource: RegionInstanceGroupManagersDeleteInstancesRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_delete_instances_request_resource: _Optional[_Union[RegionInstanceGroupManagersDeleteInstancesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteInstantSnapshotRequest(_message.Message):
    __slots__ = ("instant_snapshot", "project", "request_id", "zone")
    INSTANT_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instant_snapshot: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instant_snapshot: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteInterconnectAttachmentRequest(_message.Message):
    __slots__ = ("interconnect_attachment", "project", "region", "request_id")
    INTERCONNECT_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    interconnect_attachment: str
    project: str
    region: str
    request_id: str
    def __init__(self, interconnect_attachment: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteInterconnectRequest(_message.Message):
    __slots__ = ("interconnect", "project", "request_id")
    INTERCONNECT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    interconnect: str
    project: str
    request_id: str
    def __init__(self, interconnect: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteLicenseRequest(_message.Message):
    __slots__ = ("license", "project", "request_id")
    LICENSE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    license: str
    project: str
    request_id: str
    def __init__(self, license: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteMachineImageRequest(_message.Message):
    __slots__ = ("machine_image", "project", "request_id")
    MACHINE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    machine_image: str
    project: str
    request_id: str
    def __init__(self, machine_image: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteNetworkAttachmentRequest(_message.Message):
    __slots__ = ("network_attachment", "project", "region", "request_id")
    NETWORK_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_attachment: str
    project: str
    region: str
    request_id: str
    def __init__(self, network_attachment: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteNetworkEdgeSecurityServiceRequest(_message.Message):
    __slots__ = ("network_edge_security_service", "project", "region", "request_id")
    NETWORK_EDGE_SECURITY_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_edge_security_service: str
    project: str
    region: str
    request_id: str
    def __init__(self, network_edge_security_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project", "request_id", "zone")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    request_id: str
    zone: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "project", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    project: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteNetworkRequest(_message.Message):
    __slots__ = ("network", "project", "request_id")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network: str
    project: str
    request_id: str
    def __init__(self, network: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "project", "request_id", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    project: str
    request_id: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteNodeTemplateRequest(_message.Message):
    __slots__ = ("node_template", "project", "region", "request_id")
    NODE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    node_template: str
    project: str
    region: str
    request_id: str
    def __init__(self, node_template: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteNodesNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "node_groups_delete_nodes_request_resource", "project", "request_id", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUPS_DELETE_NODES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    node_groups_delete_nodes_request_resource: NodeGroupsDeleteNodesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., node_groups_delete_nodes_request_resource: _Optional[_Union[NodeGroupsDeleteNodesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeletePacketMirroringRequest(_message.Message):
    __slots__ = ("packet_mirroring", "project", "region", "request_id")
    PACKET_MIRRORING_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    packet_mirroring: str
    project: str
    region: str
    request_id: str
    def __init__(self, packet_mirroring: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeletePerInstanceConfigsInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_delete_per_instance_configs_req_resource", "project", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_DELETE_PER_INSTANCE_CONFIGS_REQ_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_delete_per_instance_configs_req_resource: InstanceGroupManagersDeletePerInstanceConfigsReq
    project: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_delete_per_instance_configs_req_resource: _Optional[_Union[InstanceGroupManagersDeletePerInstanceConfigsReq, _Mapping]] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeletePerInstanceConfigsRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_manager_delete_instance_config_req_resource")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGER_DELETE_INSTANCE_CONFIG_REQ_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_manager_delete_instance_config_req_resource: RegionInstanceGroupManagerDeleteInstanceConfigReq
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_manager_delete_instance_config_req_resource: _Optional[_Union[RegionInstanceGroupManagerDeleteInstanceConfigReq, _Mapping]] = ...) -> None: ...

class DeletePublicAdvertisedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_advertised_prefix", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_ADVERTISED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_advertised_prefix: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_advertised_prefix: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeletePublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix", "region", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    region: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "project", "region", "request_id")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    project: str
    region: str
    request_id: str
    def __init__(self, autoscaler: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "region", "request_id")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    region: str
    request_id: str
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region", "request_id")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    request_id: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "project", "region", "request_id")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    project: str
    region: str
    request_id: str
    def __init__(self, health_check: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionHealthCheckServiceRequest(_message.Message):
    __slots__ = ("health_check_service", "project", "region", "request_id")
    HEALTH_CHECK_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check_service: str
    project: str
    region: str
    request_id: str
    def __init__(self, health_check_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionInstanceTemplateRequest(_message.Message):
    __slots__ = ("instance_template", "project", "region", "request_id")
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    project: str
    region: str
    request_id: str
    def __init__(self, instance_template: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionInstantSnapshotRequest(_message.Message):
    __slots__ = ("instant_snapshot", "project", "region", "request_id")
    INSTANT_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instant_snapshot: str
    project: str
    region: str
    request_id: str
    def __init__(self, instant_snapshot: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project", "region", "request_id")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    region: str
    request_id: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "project", "region", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    project: str
    region: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionNotificationEndpointRequest(_message.Message):
    __slots__ = ("notification_endpoint", "project", "region", "request_id")
    NOTIFICATION_ENDPOINT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    notification_endpoint: str
    project: str
    region: str
    request_id: str
    def __init__(self, notification_endpoint: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteRegionOperationRequest(_message.Message):
    __slots__ = ("operation", "project", "region")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    region: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class DeleteRegionOperationResponse(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class DeleteRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "security_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    security_policy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class DeleteRegionSslCertificateRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "ssl_certificate")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    ssl_certificate: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_certificate: _Optional[str] = ...) -> None: ...

class DeleteRegionSslPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "ssl_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    ssl_policy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy: _Optional[str] = ...) -> None: ...

class DeleteRegionTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_http_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_http_proxy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_http_proxy: _Optional[str] = ...) -> None: ...

class DeleteRegionTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class DeleteRegionTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_tcp_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_tcp_proxy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_tcp_proxy: _Optional[str] = ...) -> None: ...

class DeleteRegionUrlMapRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "url_map")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    url_map: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map: _Optional[str] = ...) -> None: ...

class DeleteReservationRequest(_message.Message):
    __slots__ = ("project", "request_id", "reservation", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    reservation: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., reservation: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteResourcePolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "resource_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    resource_policy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., resource_policy: _Optional[str] = ...) -> None: ...

class DeleteRouteRequest(_message.Message):
    __slots__ = ("project", "request_id", "route")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ROUTE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    route: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., route: _Optional[str] = ...) -> None: ...

class DeleteRouterRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "router")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    router: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., router: _Optional[str] = ...) -> None: ...

class DeleteSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "request_id", "security_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    security_policy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class DeleteServiceAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "service_attachment")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    service_attachment: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., service_attachment: _Optional[str] = ...) -> None: ...

class DeleteSignedUrlKeyBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket", "key_name", "project", "request_id")
    BACKEND_BUCKET_FIELD_NUMBER: _ClassVar[int]
    KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_bucket: str
    key_name: str
    project: str
    request_id: str
    def __init__(self, backend_bucket: _Optional[str] = ..., key_name: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteSignedUrlKeyBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "key_name", "project", "request_id")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    key_name: str
    project: str
    request_id: str
    def __init__(self, backend_service: _Optional[str] = ..., key_name: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeleteSnapshotRequest(_message.Message):
    __slots__ = ("project", "request_id", "snapshot")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    snapshot: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., snapshot: _Optional[str] = ...) -> None: ...

class DeleteSslCertificateRequest(_message.Message):
    __slots__ = ("project", "request_id", "ssl_certificate")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    ssl_certificate: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_certificate: _Optional[str] = ...) -> None: ...

class DeleteSslPolicyRequest(_message.Message):
    __slots__ = ("project", "request_id", "ssl_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    ssl_policy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy: _Optional[str] = ...) -> None: ...

class DeleteStoragePoolRequest(_message.Message):
    __slots__ = ("project", "request_id", "storage_pool", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    storage_pool: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., storage_pool: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteSubnetworkRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "subnetwork")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    subnetwork: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., subnetwork: _Optional[str] = ...) -> None: ...

class DeleteTargetGrpcProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_grpc_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_GRPC_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_grpc_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_grpc_proxy: _Optional[str] = ...) -> None: ...

class DeleteTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_http_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_http_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_http_proxy: _Optional[str] = ...) -> None: ...

class DeleteTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class DeleteTargetInstanceRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_instance", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_instance: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_instance: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_pool")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_pool: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_pool: _Optional[str] = ...) -> None: ...

class DeleteTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_ssl_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_ssl_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_ssl_proxy: _Optional[str] = ...) -> None: ...

class DeleteTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_tcp_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_tcp_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_tcp_proxy: _Optional[str] = ...) -> None: ...

class DeleteTargetVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_vpn_gateway")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_vpn_gateway: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_vpn_gateway: _Optional[str] = ...) -> None: ...

class DeleteUrlMapRequest(_message.Message):
    __slots__ = ("project", "request_id", "url_map")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    url_map: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map: _Optional[str] = ...) -> None: ...

class DeleteVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "vpn_gateway")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    vpn_gateway: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., vpn_gateway: _Optional[str] = ...) -> None: ...

class DeleteVpnTunnelRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "vpn_tunnel")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    VPN_TUNNEL_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    vpn_tunnel: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., vpn_tunnel: _Optional[str] = ...) -> None: ...

class DeleteZoneOperationRequest(_message.Message):
    __slots__ = ("operation", "project", "zone")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    zone: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DeleteZoneOperationResponse(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class Denied(_message.Message):
    __slots__ = ("I_p_protocol", "ports")
    I_P_PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    PORTS_FIELD_NUMBER: _ClassVar[int]
    I_p_protocol: str
    ports: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, I_p_protocol: _Optional[str] = ..., ports: _Optional[_Iterable[str]] = ...) -> None: ...

class DeprecateImageRequest(_message.Message):
    __slots__ = ("deprecation_status_resource", "image", "project", "request_id")
    DEPRECATION_STATUS_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    IMAGE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    deprecation_status_resource: DeprecationStatus
    image: str
    project: str
    request_id: str
    def __init__(self, deprecation_status_resource: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., image: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DeprecationStatus(_message.Message):
    __slots__ = ("deleted", "deprecated", "obsolete", "replacement", "state")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[DeprecationStatus.State]
        ACTIVE: _ClassVar[DeprecationStatus.State]
        DELETED: _ClassVar[DeprecationStatus.State]
        DEPRECATED: _ClassVar[DeprecationStatus.State]
        OBSOLETE: _ClassVar[DeprecationStatus.State]
    UNDEFINED_STATE: DeprecationStatus.State
    ACTIVE: DeprecationStatus.State
    DELETED: DeprecationStatus.State
    DEPRECATED: DeprecationStatus.State
    OBSOLETE: DeprecationStatus.State
    DELETED_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    OBSOLETE_FIELD_NUMBER: _ClassVar[int]
    REPLACEMENT_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    deleted: str
    deprecated: str
    obsolete: str
    replacement: str
    state: str
    def __init__(self, deleted: _Optional[str] = ..., deprecated: _Optional[str] = ..., obsolete: _Optional[str] = ..., replacement: _Optional[str] = ..., state: _Optional[str] = ...) -> None: ...

class DetachDiskInstanceRequest(_message.Message):
    __slots__ = ("device_name", "instance", "project", "request_id", "zone")
    DEVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    device_name: str
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, device_name: _Optional[str] = ..., instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("global_network_endpoint_groups_detach_endpoints_request_resource", "network_endpoint_group", "project", "request_id")
    GLOBAL_NETWORK_ENDPOINT_GROUPS_DETACH_ENDPOINTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    global_network_endpoint_groups_detach_endpoints_request_resource: GlobalNetworkEndpointGroupsDetachEndpointsRequest
    network_endpoint_group: str
    project: str
    request_id: str
    def __init__(self, global_network_endpoint_groups_detach_endpoints_request_resource: _Optional[_Union[GlobalNetworkEndpointGroupsDetachEndpointsRequest, _Mapping]] = ..., network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DetachNetworkEndpointsNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "network_endpoint_groups_detach_endpoints_request_resource", "project", "request_id", "zone")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUPS_DETACH_ENDPOINTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    network_endpoint_groups_detach_endpoints_request_resource: NetworkEndpointGroupsDetachEndpointsRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., network_endpoint_groups_detach_endpoints_request_resource: _Optional[_Union[NetworkEndpointGroupsDetachEndpointsRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DetachNetworkEndpointsRegionNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project", "region", "region_network_endpoint_groups_detach_endpoints_request_resource", "request_id")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_NETWORK_ENDPOINT_GROUPS_DETACH_ENDPOINTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    region: str
    region_network_endpoint_groups_detach_endpoints_request_resource: RegionNetworkEndpointGroupsDetachEndpointsRequest
    request_id: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_network_endpoint_groups_detach_endpoints_request_resource: _Optional[_Union[RegionNetworkEndpointGroupsDetachEndpointsRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class DisableXpnHostProjectRequest(_message.Message):
    __slots__ = ("project", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class DisableXpnResourceProjectRequest(_message.Message):
    __slots__ = ("project", "projects_disable_xpn_resource_request_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PROJECTS_DISABLE_XPN_RESOURCE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    projects_disable_xpn_resource_request_resource: ProjectsDisableXpnResourceRequest
    request_id: str
    def __init__(self, project: _Optional[str] = ..., projects_disable_xpn_resource_request_resource: _Optional[_Union[ProjectsDisableXpnResourceRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class Disk(_message.Message):
    __slots__ = ("access_mode", "architecture", "async_primary_disk", "async_secondary_disks", "creation_timestamp", "description", "disk_encryption_key", "enable_confidential_compute", "guest_os_features", "id", "kind", "label_fingerprint", "labels", "last_attach_timestamp", "last_detach_timestamp", "license_codes", "licenses", "location_hint", "name", "options", "params", "physical_block_size_bytes", "provisioned_iops", "provisioned_throughput", "region", "replica_zones", "resource_policies", "resource_status", "satisfies_pzi", "satisfies_pzs", "self_link", "size_gb", "source_consistency_group_policy", "source_consistency_group_policy_id", "source_disk", "source_disk_id", "source_image", "source_image_encryption_key", "source_image_id", "source_instant_snapshot", "source_instant_snapshot_id", "source_snapshot", "source_snapshot_encryption_key", "source_snapshot_id", "source_storage_object", "status", "storage_pool", "type", "users", "zone")
    class AccessMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ACCESS_MODE: _ClassVar[Disk.AccessMode]
        READ_ONLY_MANY: _ClassVar[Disk.AccessMode]
        READ_WRITE_MANY: _ClassVar[Disk.AccessMode]
        READ_WRITE_SINGLE: _ClassVar[Disk.AccessMode]
    UNDEFINED_ACCESS_MODE: Disk.AccessMode
    READ_ONLY_MANY: Disk.AccessMode
    READ_WRITE_MANY: Disk.AccessMode
    READ_WRITE_SINGLE: Disk.AccessMode
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[Disk.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[Disk.Architecture]
        ARM64: _ClassVar[Disk.Architecture]
        X86_64: _ClassVar[Disk.Architecture]
    UNDEFINED_ARCHITECTURE: Disk.Architecture
    ARCHITECTURE_UNSPECIFIED: Disk.Architecture
    ARM64: Disk.Architecture
    X86_64: Disk.Architecture
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Disk.Status]
        CREATING: _ClassVar[Disk.Status]
        DELETING: _ClassVar[Disk.Status]
        FAILED: _ClassVar[Disk.Status]
        READY: _ClassVar[Disk.Status]
        RESTORING: _ClassVar[Disk.Status]
        UNAVAILABLE: _ClassVar[Disk.Status]
    UNDEFINED_STATUS: Disk.Status
    CREATING: Disk.Status
    DELETING: Disk.Status
    FAILED: Disk.Status
    READY: Disk.Status
    RESTORING: Disk.Status
    UNAVAILABLE: Disk.Status
    class AsyncSecondaryDisksEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: DiskAsyncReplicationList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[DiskAsyncReplicationList, _Mapping]] = ...) -> None: ...
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ACCESS_MODE_FIELD_NUMBER: _ClassVar[int]
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    ASYNC_PRIMARY_DISK_FIELD_NUMBER: _ClassVar[int]
    ASYNC_SECONDARY_DISKS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISK_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    ENABLE_CONFIDENTIAL_COMPUTE_FIELD_NUMBER: _ClassVar[int]
    GUEST_OS_FEATURES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LAST_ATTACH_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    LAST_DETACH_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    LICENSE_CODES_FIELD_NUMBER: _ClassVar[int]
    LICENSES_FIELD_NUMBER: _ClassVar[int]
    LOCATION_HINT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    OPTIONS_FIELD_NUMBER: _ClassVar[int]
    PARAMS_FIELD_NUMBER: _ClassVar[int]
    PHYSICAL_BLOCK_SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    PROVISIONED_IOPS_FIELD_NUMBER: _ClassVar[int]
    PROVISIONED_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REPLICA_ZONES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZI_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    SOURCE_CONSISTENCY_GROUP_POLICY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_CONSISTENCY_GROUP_POLICY_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANT_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANT_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_STORAGE_OBJECT_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    USERS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    access_mode: str
    architecture: str
    async_primary_disk: DiskAsyncReplication
    async_secondary_disks: _containers.MessageMap[str, DiskAsyncReplicationList]
    creation_timestamp: str
    description: str
    disk_encryption_key: CustomerEncryptionKey
    enable_confidential_compute: bool
    guest_os_features: _containers.RepeatedCompositeFieldContainer[GuestOsFeature]
    id: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    last_attach_timestamp: str
    last_detach_timestamp: str
    license_codes: _containers.RepeatedScalarFieldContainer[int]
    licenses: _containers.RepeatedScalarFieldContainer[str]
    location_hint: str
    name: str
    options: str
    params: DiskParams
    physical_block_size_bytes: int
    provisioned_iops: int
    provisioned_throughput: int
    region: str
    replica_zones: _containers.RepeatedScalarFieldContainer[str]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    resource_status: DiskResourceStatus
    satisfies_pzi: bool
    satisfies_pzs: bool
    self_link: str
    size_gb: int
    source_consistency_group_policy: str
    source_consistency_group_policy_id: str
    source_disk: str
    source_disk_id: str
    source_image: str
    source_image_encryption_key: CustomerEncryptionKey
    source_image_id: str
    source_instant_snapshot: str
    source_instant_snapshot_id: str
    source_snapshot: str
    source_snapshot_encryption_key: CustomerEncryptionKey
    source_snapshot_id: str
    source_storage_object: str
    status: str
    storage_pool: str
    type: str
    users: _containers.RepeatedScalarFieldContainer[str]
    zone: str
    def __init__(self, access_mode: _Optional[str] = ..., architecture: _Optional[str] = ..., async_primary_disk: _Optional[_Union[DiskAsyncReplication, _Mapping]] = ..., async_secondary_disks: _Optional[_Mapping[str, DiskAsyncReplicationList]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., disk_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., enable_confidential_compute: bool = ..., guest_os_features: _Optional[_Iterable[_Union[GuestOsFeature, _Mapping]]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., last_attach_timestamp: _Optional[str] = ..., last_detach_timestamp: _Optional[str] = ..., license_codes: _Optional[_Iterable[int]] = ..., licenses: _Optional[_Iterable[str]] = ..., location_hint: _Optional[str] = ..., name: _Optional[str] = ..., options: _Optional[str] = ..., params: _Optional[_Union[DiskParams, _Mapping]] = ..., physical_block_size_bytes: _Optional[int] = ..., provisioned_iops: _Optional[int] = ..., provisioned_throughput: _Optional[int] = ..., region: _Optional[str] = ..., replica_zones: _Optional[_Iterable[str]] = ..., resource_policies: _Optional[_Iterable[str]] = ..., resource_status: _Optional[_Union[DiskResourceStatus, _Mapping]] = ..., satisfies_pzi: bool = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., size_gb: _Optional[int] = ..., source_consistency_group_policy: _Optional[str] = ..., source_consistency_group_policy_id: _Optional[str] = ..., source_disk: _Optional[str] = ..., source_disk_id: _Optional[str] = ..., source_image: _Optional[str] = ..., source_image_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_image_id: _Optional[str] = ..., source_instant_snapshot: _Optional[str] = ..., source_instant_snapshot_id: _Optional[str] = ..., source_snapshot: _Optional[str] = ..., source_snapshot_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_snapshot_id: _Optional[str] = ..., source_storage_object: _Optional[str] = ..., status: _Optional[str] = ..., storage_pool: _Optional[str] = ..., type: _Optional[str] = ..., users: _Optional[_Iterable[str]] = ..., zone: _Optional[str] = ...) -> None: ...

class DiskAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: DisksScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[DisksScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, DisksScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, DisksScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class DiskAsyncReplication(_message.Message):
    __slots__ = ("consistency_group_policy", "consistency_group_policy_id", "disk", "disk_id")
    CONSISTENCY_GROUP_POLICY_FIELD_NUMBER: _ClassVar[int]
    CONSISTENCY_GROUP_POLICY_ID_FIELD_NUMBER: _ClassVar[int]
    DISK_FIELD_NUMBER: _ClassVar[int]
    DISK_ID_FIELD_NUMBER: _ClassVar[int]
    consistency_group_policy: str
    consistency_group_policy_id: str
    disk: str
    disk_id: str
    def __init__(self, consistency_group_policy: _Optional[str] = ..., consistency_group_policy_id: _Optional[str] = ..., disk: _Optional[str] = ..., disk_id: _Optional[str] = ...) -> None: ...

class DiskAsyncReplicationList(_message.Message):
    __slots__ = ("async_replication_disk",)
    ASYNC_REPLICATION_DISK_FIELD_NUMBER: _ClassVar[int]
    async_replication_disk: DiskAsyncReplication
    def __init__(self, async_replication_disk: _Optional[_Union[DiskAsyncReplication, _Mapping]] = ...) -> None: ...

class DiskInstantiationConfig(_message.Message):
    __slots__ = ("auto_delete", "custom_image", "device_name", "instantiate_from")
    class InstantiateFrom(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INSTANTIATE_FROM: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
        ATTACH_READ_ONLY: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
        BLANK: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
        CUSTOM_IMAGE: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
        DEFAULT: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
        DO_NOT_INCLUDE: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
        SOURCE_IMAGE: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
        SOURCE_IMAGE_FAMILY: _ClassVar[DiskInstantiationConfig.InstantiateFrom]
    UNDEFINED_INSTANTIATE_FROM: DiskInstantiationConfig.InstantiateFrom
    ATTACH_READ_ONLY: DiskInstantiationConfig.InstantiateFrom
    BLANK: DiskInstantiationConfig.InstantiateFrom
    CUSTOM_IMAGE: DiskInstantiationConfig.InstantiateFrom
    DEFAULT: DiskInstantiationConfig.InstantiateFrom
    DO_NOT_INCLUDE: DiskInstantiationConfig.InstantiateFrom
    SOURCE_IMAGE: DiskInstantiationConfig.InstantiateFrom
    SOURCE_IMAGE_FAMILY: DiskInstantiationConfig.InstantiateFrom
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_IMAGE_FIELD_NUMBER: _ClassVar[int]
    DEVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    INSTANTIATE_FROM_FIELD_NUMBER: _ClassVar[int]
    auto_delete: bool
    custom_image: str
    device_name: str
    instantiate_from: str
    def __init__(self, auto_delete: bool = ..., custom_image: _Optional[str] = ..., device_name: _Optional[str] = ..., instantiate_from: _Optional[str] = ...) -> None: ...

class DiskList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Disk]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Disk, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class DiskMoveRequest(_message.Message):
    __slots__ = ("destination_zone", "target_disk")
    DESTINATION_ZONE_FIELD_NUMBER: _ClassVar[int]
    TARGET_DISK_FIELD_NUMBER: _ClassVar[int]
    destination_zone: str
    target_disk: str
    def __init__(self, destination_zone: _Optional[str] = ..., target_disk: _Optional[str] = ...) -> None: ...

class DiskParams(_message.Message):
    __slots__ = ("resource_manager_tags",)
    class ResourceManagerTagsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    RESOURCE_MANAGER_TAGS_FIELD_NUMBER: _ClassVar[int]
    resource_manager_tags: _containers.ScalarMap[str, str]
    def __init__(self, resource_manager_tags: _Optional[_Mapping[str, str]] = ...) -> None: ...

class DiskResourceStatus(_message.Message):
    __slots__ = ("async_primary_disk", "async_secondary_disks")
    class AsyncSecondaryDisksEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: DiskResourceStatusAsyncReplicationStatus
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[DiskResourceStatusAsyncReplicationStatus, _Mapping]] = ...) -> None: ...
    ASYNC_PRIMARY_DISK_FIELD_NUMBER: _ClassVar[int]
    ASYNC_SECONDARY_DISKS_FIELD_NUMBER: _ClassVar[int]
    async_primary_disk: DiskResourceStatusAsyncReplicationStatus
    async_secondary_disks: _containers.MessageMap[str, DiskResourceStatusAsyncReplicationStatus]
    def __init__(self, async_primary_disk: _Optional[_Union[DiskResourceStatusAsyncReplicationStatus, _Mapping]] = ..., async_secondary_disks: _Optional[_Mapping[str, DiskResourceStatusAsyncReplicationStatus]] = ...) -> None: ...

class DiskResourceStatusAsyncReplicationStatus(_message.Message):
    __slots__ = ("state",)
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[DiskResourceStatusAsyncReplicationStatus.State]
        ACTIVE: _ClassVar[DiskResourceStatusAsyncReplicationStatus.State]
        CREATED: _ClassVar[DiskResourceStatusAsyncReplicationStatus.State]
        STARTING: _ClassVar[DiskResourceStatusAsyncReplicationStatus.State]
        STATE_UNSPECIFIED: _ClassVar[DiskResourceStatusAsyncReplicationStatus.State]
        STOPPED: _ClassVar[DiskResourceStatusAsyncReplicationStatus.State]
        STOPPING: _ClassVar[DiskResourceStatusAsyncReplicationStatus.State]
    UNDEFINED_STATE: DiskResourceStatusAsyncReplicationStatus.State
    ACTIVE: DiskResourceStatusAsyncReplicationStatus.State
    CREATED: DiskResourceStatusAsyncReplicationStatus.State
    STARTING: DiskResourceStatusAsyncReplicationStatus.State
    STATE_UNSPECIFIED: DiskResourceStatusAsyncReplicationStatus.State
    STOPPED: DiskResourceStatusAsyncReplicationStatus.State
    STOPPING: DiskResourceStatusAsyncReplicationStatus.State
    STATE_FIELD_NUMBER: _ClassVar[int]
    state: str
    def __init__(self, state: _Optional[str] = ...) -> None: ...

class DiskType(_message.Message):
    __slots__ = ("creation_timestamp", "default_disk_size_gb", "deprecated", "description", "id", "kind", "name", "region", "self_link", "valid_disk_size", "zone")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    VALID_DISK_SIZE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    default_disk_size_gb: int
    deprecated: DeprecationStatus
    description: str
    id: int
    kind: str
    name: str
    region: str
    self_link: str
    valid_disk_size: str
    zone: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., default_disk_size_gb: _Optional[int] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., valid_disk_size: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class DiskTypeAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: DiskTypesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[DiskTypesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, DiskTypesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, DiskTypesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class DiskTypeList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[DiskType]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[DiskType, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class DiskTypesScopedList(_message.Message):
    __slots__ = ("disk_types", "warning")
    DISK_TYPES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    disk_types: _containers.RepeatedCompositeFieldContainer[DiskType]
    warning: Warning
    def __init__(self, disk_types: _Optional[_Iterable[_Union[DiskType, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class DisksAddResourcePoliciesRequest(_message.Message):
    __slots__ = ("resource_policies",)
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, resource_policies: _Optional[_Iterable[str]] = ...) -> None: ...

class DisksRemoveResourcePoliciesRequest(_message.Message):
    __slots__ = ("resource_policies",)
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, resource_policies: _Optional[_Iterable[str]] = ...) -> None: ...

class DisksResizeRequest(_message.Message):
    __slots__ = ("size_gb",)
    SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    size_gb: int
    def __init__(self, size_gb: _Optional[int] = ...) -> None: ...

class DisksScopedList(_message.Message):
    __slots__ = ("disks", "warning")
    DISKS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    disks: _containers.RepeatedCompositeFieldContainer[Disk]
    warning: Warning
    def __init__(self, disks: _Optional[_Iterable[_Union[Disk, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class DisksStartAsyncReplicationRequest(_message.Message):
    __slots__ = ("async_secondary_disk",)
    ASYNC_SECONDARY_DISK_FIELD_NUMBER: _ClassVar[int]
    async_secondary_disk: str
    def __init__(self, async_secondary_disk: _Optional[str] = ...) -> None: ...

class DisksStopGroupAsyncReplicationResource(_message.Message):
    __slots__ = ("resource_policy",)
    RESOURCE_POLICY_FIELD_NUMBER: _ClassVar[int]
    resource_policy: str
    def __init__(self, resource_policy: _Optional[str] = ...) -> None: ...

class DisplayDevice(_message.Message):
    __slots__ = ("enable_display",)
    ENABLE_DISPLAY_FIELD_NUMBER: _ClassVar[int]
    enable_display: bool
    def __init__(self, enable_display: bool = ...) -> None: ...

class DistributionPolicy(_message.Message):
    __slots__ = ("target_shape", "zones")
    class TargetShape(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TARGET_SHAPE: _ClassVar[DistributionPolicy.TargetShape]
        ANY: _ClassVar[DistributionPolicy.TargetShape]
        ANY_SINGLE_ZONE: _ClassVar[DistributionPolicy.TargetShape]
        BALANCED: _ClassVar[DistributionPolicy.TargetShape]
        EVEN: _ClassVar[DistributionPolicy.TargetShape]
    UNDEFINED_TARGET_SHAPE: DistributionPolicy.TargetShape
    ANY: DistributionPolicy.TargetShape
    ANY_SINGLE_ZONE: DistributionPolicy.TargetShape
    BALANCED: DistributionPolicy.TargetShape
    EVEN: DistributionPolicy.TargetShape
    TARGET_SHAPE_FIELD_NUMBER: _ClassVar[int]
    ZONES_FIELD_NUMBER: _ClassVar[int]
    target_shape: str
    zones: _containers.RepeatedCompositeFieldContainer[DistributionPolicyZoneConfiguration]
    def __init__(self, target_shape: _Optional[str] = ..., zones: _Optional[_Iterable[_Union[DistributionPolicyZoneConfiguration, _Mapping]]] = ...) -> None: ...

class DistributionPolicyZoneConfiguration(_message.Message):
    __slots__ = ("zone",)
    ZONE_FIELD_NUMBER: _ClassVar[int]
    zone: str
    def __init__(self, zone: _Optional[str] = ...) -> None: ...

class Duration(_message.Message):
    __slots__ = ("nanos", "seconds")
    NANOS_FIELD_NUMBER: _ClassVar[int]
    SECONDS_FIELD_NUMBER: _ClassVar[int]
    nanos: int
    seconds: int
    def __init__(self, nanos: _Optional[int] = ..., seconds: _Optional[int] = ...) -> None: ...

class EnableXpnHostProjectRequest(_message.Message):
    __slots__ = ("project", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class EnableXpnResourceProjectRequest(_message.Message):
    __slots__ = ("project", "projects_enable_xpn_resource_request_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PROJECTS_ENABLE_XPN_RESOURCE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    projects_enable_xpn_resource_request_resource: ProjectsEnableXpnResourceRequest
    request_id: str
    def __init__(self, project: _Optional[str] = ..., projects_enable_xpn_resource_request_resource: _Optional[_Union[ProjectsEnableXpnResourceRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class Error(_message.Message):
    __slots__ = ("errors",)
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    errors: _containers.RepeatedCompositeFieldContainer[Errors]
    def __init__(self, errors: _Optional[_Iterable[_Union[Errors, _Mapping]]] = ...) -> None: ...

class ErrorDetails(_message.Message):
    __slots__ = ("error_info", "help", "localized_message", "quota_info")
    ERROR_INFO_FIELD_NUMBER: _ClassVar[int]
    HELP_FIELD_NUMBER: _ClassVar[int]
    LOCALIZED_MESSAGE_FIELD_NUMBER: _ClassVar[int]
    QUOTA_INFO_FIELD_NUMBER: _ClassVar[int]
    error_info: ErrorInfo
    help: Help
    localized_message: LocalizedMessage
    quota_info: QuotaExceededInfo
    def __init__(self, error_info: _Optional[_Union[ErrorInfo, _Mapping]] = ..., help: _Optional[_Union[Help, _Mapping]] = ..., localized_message: _Optional[_Union[LocalizedMessage, _Mapping]] = ..., quota_info: _Optional[_Union[QuotaExceededInfo, _Mapping]] = ...) -> None: ...

class ErrorInfo(_message.Message):
    __slots__ = ("domain", "metadatas", "reason")
    class MetadatasEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DOMAIN_FIELD_NUMBER: _ClassVar[int]
    METADATAS_FIELD_NUMBER: _ClassVar[int]
    REASON_FIELD_NUMBER: _ClassVar[int]
    domain: str
    metadatas: _containers.ScalarMap[str, str]
    reason: str
    def __init__(self, domain: _Optional[str] = ..., metadatas: _Optional[_Mapping[str, str]] = ..., reason: _Optional[str] = ...) -> None: ...

class Errors(_message.Message):
    __slots__ = ("code", "error_details", "location", "message")
    CODE_FIELD_NUMBER: _ClassVar[int]
    ERROR_DETAILS_FIELD_NUMBER: _ClassVar[int]
    LOCATION_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    code: str
    error_details: _containers.RepeatedCompositeFieldContainer[ErrorDetails]
    location: str
    message: str
    def __init__(self, code: _Optional[str] = ..., error_details: _Optional[_Iterable[_Union[ErrorDetails, _Mapping]]] = ..., location: _Optional[str] = ..., message: _Optional[str] = ...) -> None: ...

class ExchangedPeeringRoute(_message.Message):
    __slots__ = ("dest_range", "imported", "next_hop_region", "priority", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[ExchangedPeeringRoute.Type]
        DYNAMIC_PEERING_ROUTE: _ClassVar[ExchangedPeeringRoute.Type]
        STATIC_PEERING_ROUTE: _ClassVar[ExchangedPeeringRoute.Type]
        SUBNET_PEERING_ROUTE: _ClassVar[ExchangedPeeringRoute.Type]
    UNDEFINED_TYPE: ExchangedPeeringRoute.Type
    DYNAMIC_PEERING_ROUTE: ExchangedPeeringRoute.Type
    STATIC_PEERING_ROUTE: ExchangedPeeringRoute.Type
    SUBNET_PEERING_ROUTE: ExchangedPeeringRoute.Type
    DEST_RANGE_FIELD_NUMBER: _ClassVar[int]
    IMPORTED_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_REGION_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    dest_range: str
    imported: bool
    next_hop_region: str
    priority: int
    type: str
    def __init__(self, dest_range: _Optional[str] = ..., imported: bool = ..., next_hop_region: _Optional[str] = ..., priority: _Optional[int] = ..., type: _Optional[str] = ...) -> None: ...

class ExchangedPeeringRoutesList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[ExchangedPeeringRoute]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[ExchangedPeeringRoute, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ExpandIpCidrRangeSubnetworkRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "subnetwork", "subnetworks_expand_ip_cidr_range_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORKS_EXPAND_IP_CIDR_RANGE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    subnetwork: str
    subnetworks_expand_ip_cidr_range_request_resource: SubnetworksExpandIpCidrRangeRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., subnetwork: _Optional[str] = ..., subnetworks_expand_ip_cidr_range_request_resource: _Optional[_Union[SubnetworksExpandIpCidrRangeRequest, _Mapping]] = ...) -> None: ...

class Expr(_message.Message):
    __slots__ = ("description", "expression", "location", "title")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    EXPRESSION_FIELD_NUMBER: _ClassVar[int]
    LOCATION_FIELD_NUMBER: _ClassVar[int]
    TITLE_FIELD_NUMBER: _ClassVar[int]
    description: str
    expression: str
    location: str
    title: str
    def __init__(self, description: _Optional[str] = ..., expression: _Optional[str] = ..., location: _Optional[str] = ..., title: _Optional[str] = ...) -> None: ...

class ExternalVpnGateway(_message.Message):
    __slots__ = ("creation_timestamp", "description", "id", "interfaces", "kind", "label_fingerprint", "labels", "name", "redundancy_type", "self_link")
    class RedundancyType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_REDUNDANCY_TYPE: _ClassVar[ExternalVpnGateway.RedundancyType]
        FOUR_IPS_REDUNDANCY: _ClassVar[ExternalVpnGateway.RedundancyType]
        SINGLE_IP_INTERNALLY_REDUNDANT: _ClassVar[ExternalVpnGateway.RedundancyType]
        TWO_IPS_REDUNDANCY: _ClassVar[ExternalVpnGateway.RedundancyType]
    UNDEFINED_REDUNDANCY_TYPE: ExternalVpnGateway.RedundancyType
    FOUR_IPS_REDUNDANCY: ExternalVpnGateway.RedundancyType
    SINGLE_IP_INTERNALLY_REDUNDANT: ExternalVpnGateway.RedundancyType
    TWO_IPS_REDUNDANCY: ExternalVpnGateway.RedundancyType
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INTERFACES_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REDUNDANCY_TYPE_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    id: int
    interfaces: _containers.RepeatedCompositeFieldContainer[ExternalVpnGatewayInterface]
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    name: str
    redundancy_type: str
    self_link: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., interfaces: _Optional[_Iterable[_Union[ExternalVpnGatewayInterface, _Mapping]]] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., redundancy_type: _Optional[str] = ..., self_link: _Optional[str] = ...) -> None: ...

class ExternalVpnGatewayInterface(_message.Message):
    __slots__ = ("id", "ip_address", "ipv6_address")
    ID_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    id: int
    ip_address: str
    ipv6_address: str
    def __init__(self, id: _Optional[int] = ..., ip_address: _Optional[str] = ..., ipv6_address: _Optional[str] = ...) -> None: ...

class ExternalVpnGatewayList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "warning")
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.RepeatedCompositeFieldContainer[ExternalVpnGateway]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[ExternalVpnGateway, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class FileContentBuffer(_message.Message):
    __slots__ = ("content", "file_type")
    class FileType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_FILE_TYPE: _ClassVar[FileContentBuffer.FileType]
        BIN: _ClassVar[FileContentBuffer.FileType]
        UNDEFINED: _ClassVar[FileContentBuffer.FileType]
        X509: _ClassVar[FileContentBuffer.FileType]
    UNDEFINED_FILE_TYPE: FileContentBuffer.FileType
    BIN: FileContentBuffer.FileType
    UNDEFINED: FileContentBuffer.FileType
    X509: FileContentBuffer.FileType
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    FILE_TYPE_FIELD_NUMBER: _ClassVar[int]
    content: str
    file_type: str
    def __init__(self, content: _Optional[str] = ..., file_type: _Optional[str] = ...) -> None: ...

class Firewall(_message.Message):
    __slots__ = ("allowed", "creation_timestamp", "denied", "description", "destination_ranges", "direction", "disabled", "id", "kind", "log_config", "name", "network", "priority", "self_link", "source_ranges", "source_service_accounts", "source_tags", "target_service_accounts", "target_tags")
    class Direction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DIRECTION: _ClassVar[Firewall.Direction]
        EGRESS: _ClassVar[Firewall.Direction]
        INGRESS: _ClassVar[Firewall.Direction]
    UNDEFINED_DIRECTION: Firewall.Direction
    EGRESS: Firewall.Direction
    INGRESS: Firewall.Direction
    ALLOWED_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DENIED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DESTINATION_RANGES_FIELD_NUMBER: _ClassVar[int]
    DIRECTION_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOG_CONFIG_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_RANGES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SERVICE_ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
    SOURCE_TAGS_FIELD_NUMBER: _ClassVar[int]
    TARGET_SERVICE_ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
    TARGET_TAGS_FIELD_NUMBER: _ClassVar[int]
    allowed: _containers.RepeatedCompositeFieldContainer[Allowed]
    creation_timestamp: str
    denied: _containers.RepeatedCompositeFieldContainer[Denied]
    description: str
    destination_ranges: _containers.RepeatedScalarFieldContainer[str]
    direction: str
    disabled: bool
    id: int
    kind: str
    log_config: FirewallLogConfig
    name: str
    network: str
    priority: int
    self_link: str
    source_ranges: _containers.RepeatedScalarFieldContainer[str]
    source_service_accounts: _containers.RepeatedScalarFieldContainer[str]
    source_tags: _containers.RepeatedScalarFieldContainer[str]
    target_service_accounts: _containers.RepeatedScalarFieldContainer[str]
    target_tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, allowed: _Optional[_Iterable[_Union[Allowed, _Mapping]]] = ..., creation_timestamp: _Optional[str] = ..., denied: _Optional[_Iterable[_Union[Denied, _Mapping]]] = ..., description: _Optional[str] = ..., destination_ranges: _Optional[_Iterable[str]] = ..., direction: _Optional[str] = ..., disabled: bool = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., log_config: _Optional[_Union[FirewallLogConfig, _Mapping]] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., priority: _Optional[int] = ..., self_link: _Optional[str] = ..., source_ranges: _Optional[_Iterable[str]] = ..., source_service_accounts: _Optional[_Iterable[str]] = ..., source_tags: _Optional[_Iterable[str]] = ..., target_service_accounts: _Optional[_Iterable[str]] = ..., target_tags: _Optional[_Iterable[str]] = ...) -> None: ...

class FirewallList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Firewall]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Firewall, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class FirewallLogConfig(_message.Message):
    __slots__ = ("enable", "metadata")
    class Metadata(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_METADATA: _ClassVar[FirewallLogConfig.Metadata]
        EXCLUDE_ALL_METADATA: _ClassVar[FirewallLogConfig.Metadata]
        INCLUDE_ALL_METADATA: _ClassVar[FirewallLogConfig.Metadata]
    UNDEFINED_METADATA: FirewallLogConfig.Metadata
    EXCLUDE_ALL_METADATA: FirewallLogConfig.Metadata
    INCLUDE_ALL_METADATA: FirewallLogConfig.Metadata
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    enable: bool
    metadata: str
    def __init__(self, enable: bool = ..., metadata: _Optional[str] = ...) -> None: ...

class FirewallPoliciesListAssociationsResponse(_message.Message):
    __slots__ = ("associations", "kind")
    ASSOCIATIONS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    associations: _containers.RepeatedCompositeFieldContainer[FirewallPolicyAssociation]
    kind: str
    def __init__(self, associations: _Optional[_Iterable[_Union[FirewallPolicyAssociation, _Mapping]]] = ..., kind: _Optional[str] = ...) -> None: ...

class FirewallPoliciesScopedList(_message.Message):
    __slots__ = ("firewall_policies", "warning")
    FIREWALL_POLICIES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    firewall_policies: _containers.RepeatedCompositeFieldContainer[FirewallPolicy]
    warning: Warning
    def __init__(self, firewall_policies: _Optional[_Iterable[_Union[FirewallPolicy, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class FirewallPolicy(_message.Message):
    __slots__ = ("associations", "creation_timestamp", "description", "display_name", "fingerprint", "id", "kind", "name", "parent", "region", "rule_tuple_count", "rules", "self_link", "self_link_with_id", "short_name")
    ASSOCIATIONS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RULE_TUPLE_COUNT_FIELD_NUMBER: _ClassVar[int]
    RULES_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    SHORT_NAME_FIELD_NUMBER: _ClassVar[int]
    associations: _containers.RepeatedCompositeFieldContainer[FirewallPolicyAssociation]
    creation_timestamp: str
    description: str
    display_name: str
    fingerprint: str
    id: int
    kind: str
    name: str
    parent: str
    region: str
    rule_tuple_count: int
    rules: _containers.RepeatedCompositeFieldContainer[FirewallPolicyRule]
    self_link: str
    self_link_with_id: str
    short_name: str
    def __init__(self, associations: _Optional[_Iterable[_Union[FirewallPolicyAssociation, _Mapping]]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., display_name: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., parent: _Optional[str] = ..., region: _Optional[str] = ..., rule_tuple_count: _Optional[int] = ..., rules: _Optional[_Iterable[_Union[FirewallPolicyRule, _Mapping]]] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., short_name: _Optional[str] = ...) -> None: ...

class FirewallPolicyAssociation(_message.Message):
    __slots__ = ("attachment_target", "display_name", "firewall_policy_id", "name", "short_name")
    ATTACHMENT_TARGET_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_ID_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SHORT_NAME_FIELD_NUMBER: _ClassVar[int]
    attachment_target: str
    display_name: str
    firewall_policy_id: str
    name: str
    short_name: str
    def __init__(self, attachment_target: _Optional[str] = ..., display_name: _Optional[str] = ..., firewall_policy_id: _Optional[str] = ..., name: _Optional[str] = ..., short_name: _Optional[str] = ...) -> None: ...

class FirewallPolicyList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[FirewallPolicy]
    kind: str
    next_page_token: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[FirewallPolicy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class FirewallPolicyRule(_message.Message):
    __slots__ = ("action", "description", "direction", "disabled", "enable_logging", "kind", "match", "priority", "rule_name", "rule_tuple_count", "security_profile_group", "target_resources", "target_secure_tags", "target_service_accounts", "tls_inspect")
    class Direction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DIRECTION: _ClassVar[FirewallPolicyRule.Direction]
        EGRESS: _ClassVar[FirewallPolicyRule.Direction]
        INGRESS: _ClassVar[FirewallPolicyRule.Direction]
    UNDEFINED_DIRECTION: FirewallPolicyRule.Direction
    EGRESS: FirewallPolicyRule.Direction
    INGRESS: FirewallPolicyRule.Direction
    ACTION_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DIRECTION_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    ENABLE_LOGGING_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MATCH_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    RULE_NAME_FIELD_NUMBER: _ClassVar[int]
    RULE_TUPLE_COUNT_FIELD_NUMBER: _ClassVar[int]
    SECURITY_PROFILE_GROUP_FIELD_NUMBER: _ClassVar[int]
    TARGET_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    TARGET_SECURE_TAGS_FIELD_NUMBER: _ClassVar[int]
    TARGET_SERVICE_ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
    TLS_INSPECT_FIELD_NUMBER: _ClassVar[int]
    action: str
    description: str
    direction: str
    disabled: bool
    enable_logging: bool
    kind: str
    match: FirewallPolicyRuleMatcher
    priority: int
    rule_name: str
    rule_tuple_count: int
    security_profile_group: str
    target_resources: _containers.RepeatedScalarFieldContainer[str]
    target_secure_tags: _containers.RepeatedCompositeFieldContainer[FirewallPolicyRuleSecureTag]
    target_service_accounts: _containers.RepeatedScalarFieldContainer[str]
    tls_inspect: bool
    def __init__(self, action: _Optional[str] = ..., description: _Optional[str] = ..., direction: _Optional[str] = ..., disabled: bool = ..., enable_logging: bool = ..., kind: _Optional[str] = ..., match: _Optional[_Union[FirewallPolicyRuleMatcher, _Mapping]] = ..., priority: _Optional[int] = ..., rule_name: _Optional[str] = ..., rule_tuple_count: _Optional[int] = ..., security_profile_group: _Optional[str] = ..., target_resources: _Optional[_Iterable[str]] = ..., target_secure_tags: _Optional[_Iterable[_Union[FirewallPolicyRuleSecureTag, _Mapping]]] = ..., target_service_accounts: _Optional[_Iterable[str]] = ..., tls_inspect: bool = ...) -> None: ...

class FirewallPolicyRuleMatcher(_message.Message):
    __slots__ = ("dest_address_groups", "dest_fqdns", "dest_ip_ranges", "dest_region_codes", "dest_threat_intelligences", "layer4_configs", "src_address_groups", "src_fqdns", "src_ip_ranges", "src_region_codes", "src_secure_tags", "src_threat_intelligences")
    DEST_ADDRESS_GROUPS_FIELD_NUMBER: _ClassVar[int]
    DEST_FQDNS_FIELD_NUMBER: _ClassVar[int]
    DEST_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    DEST_REGION_CODES_FIELD_NUMBER: _ClassVar[int]
    DEST_THREAT_INTELLIGENCES_FIELD_NUMBER: _ClassVar[int]
    LAYER4_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    SRC_ADDRESS_GROUPS_FIELD_NUMBER: _ClassVar[int]
    SRC_FQDNS_FIELD_NUMBER: _ClassVar[int]
    SRC_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    SRC_REGION_CODES_FIELD_NUMBER: _ClassVar[int]
    SRC_SECURE_TAGS_FIELD_NUMBER: _ClassVar[int]
    SRC_THREAT_INTELLIGENCES_FIELD_NUMBER: _ClassVar[int]
    dest_address_groups: _containers.RepeatedScalarFieldContainer[str]
    dest_fqdns: _containers.RepeatedScalarFieldContainer[str]
    dest_ip_ranges: _containers.RepeatedScalarFieldContainer[str]
    dest_region_codes: _containers.RepeatedScalarFieldContainer[str]
    dest_threat_intelligences: _containers.RepeatedScalarFieldContainer[str]
    layer4_configs: _containers.RepeatedCompositeFieldContainer[FirewallPolicyRuleMatcherLayer4Config]
    src_address_groups: _containers.RepeatedScalarFieldContainer[str]
    src_fqdns: _containers.RepeatedScalarFieldContainer[str]
    src_ip_ranges: _containers.RepeatedScalarFieldContainer[str]
    src_region_codes: _containers.RepeatedScalarFieldContainer[str]
    src_secure_tags: _containers.RepeatedCompositeFieldContainer[FirewallPolicyRuleSecureTag]
    src_threat_intelligences: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, dest_address_groups: _Optional[_Iterable[str]] = ..., dest_fqdns: _Optional[_Iterable[str]] = ..., dest_ip_ranges: _Optional[_Iterable[str]] = ..., dest_region_codes: _Optional[_Iterable[str]] = ..., dest_threat_intelligences: _Optional[_Iterable[str]] = ..., layer4_configs: _Optional[_Iterable[_Union[FirewallPolicyRuleMatcherLayer4Config, _Mapping]]] = ..., src_address_groups: _Optional[_Iterable[str]] = ..., src_fqdns: _Optional[_Iterable[str]] = ..., src_ip_ranges: _Optional[_Iterable[str]] = ..., src_region_codes: _Optional[_Iterable[str]] = ..., src_secure_tags: _Optional[_Iterable[_Union[FirewallPolicyRuleSecureTag, _Mapping]]] = ..., src_threat_intelligences: _Optional[_Iterable[str]] = ...) -> None: ...

class FirewallPolicyRuleMatcherLayer4Config(_message.Message):
    __slots__ = ("ip_protocol", "ports")
    IP_PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    PORTS_FIELD_NUMBER: _ClassVar[int]
    ip_protocol: str
    ports: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, ip_protocol: _Optional[str] = ..., ports: _Optional[_Iterable[str]] = ...) -> None: ...

class FirewallPolicyRuleSecureTag(_message.Message):
    __slots__ = ("name", "state")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[FirewallPolicyRuleSecureTag.State]
        EFFECTIVE: _ClassVar[FirewallPolicyRuleSecureTag.State]
        INEFFECTIVE: _ClassVar[FirewallPolicyRuleSecureTag.State]
    UNDEFINED_STATE: FirewallPolicyRuleSecureTag.State
    EFFECTIVE: FirewallPolicyRuleSecureTag.State
    INEFFECTIVE: FirewallPolicyRuleSecureTag.State
    NAME_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    name: str
    state: str
    def __init__(self, name: _Optional[str] = ..., state: _Optional[str] = ...) -> None: ...

class FixedOrPercent(_message.Message):
    __slots__ = ("calculated", "fixed", "percent")
    CALCULATED_FIELD_NUMBER: _ClassVar[int]
    FIXED_FIELD_NUMBER: _ClassVar[int]
    PERCENT_FIELD_NUMBER: _ClassVar[int]
    calculated: int
    fixed: int
    percent: int
    def __init__(self, calculated: _Optional[int] = ..., fixed: _Optional[int] = ..., percent: _Optional[int] = ...) -> None: ...

class ForwardingRule(_message.Message):
    __slots__ = ("I_p_address", "I_p_protocol", "all_ports", "allow_global_access", "allow_psc_global_access", "backend_service", "base_forwarding_rule", "creation_timestamp", "description", "fingerprint", "id", "ip_collection", "ip_version", "is_mirroring_collector", "kind", "label_fingerprint", "labels", "load_balancing_scheme", "metadata_filters", "name", "network", "network_tier", "no_automate_dns_zone", "port_range", "ports", "psc_connection_id", "psc_connection_status", "region", "self_link", "service_directory_registrations", "service_label", "service_name", "source_ip_ranges", "subnetwork", "target")
    class IPProtocolEnum(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_I_P_PROTOCOL_ENUM: _ClassVar[ForwardingRule.IPProtocolEnum]
        AH: _ClassVar[ForwardingRule.IPProtocolEnum]
        ESP: _ClassVar[ForwardingRule.IPProtocolEnum]
        ICMP: _ClassVar[ForwardingRule.IPProtocolEnum]
        L3_DEFAULT: _ClassVar[ForwardingRule.IPProtocolEnum]
        SCTP: _ClassVar[ForwardingRule.IPProtocolEnum]
        TCP: _ClassVar[ForwardingRule.IPProtocolEnum]
        UDP: _ClassVar[ForwardingRule.IPProtocolEnum]
    UNDEFINED_I_P_PROTOCOL_ENUM: ForwardingRule.IPProtocolEnum
    AH: ForwardingRule.IPProtocolEnum
    ESP: ForwardingRule.IPProtocolEnum
    ICMP: ForwardingRule.IPProtocolEnum
    L3_DEFAULT: ForwardingRule.IPProtocolEnum
    SCTP: ForwardingRule.IPProtocolEnum
    TCP: ForwardingRule.IPProtocolEnum
    UDP: ForwardingRule.IPProtocolEnum
    class IpVersion(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IP_VERSION: _ClassVar[ForwardingRule.IpVersion]
        IPV4: _ClassVar[ForwardingRule.IpVersion]
        IPV6: _ClassVar[ForwardingRule.IpVersion]
        UNSPECIFIED_VERSION: _ClassVar[ForwardingRule.IpVersion]
    UNDEFINED_IP_VERSION: ForwardingRule.IpVersion
    IPV4: ForwardingRule.IpVersion
    IPV6: ForwardingRule.IpVersion
    UNSPECIFIED_VERSION: ForwardingRule.IpVersion
    class LoadBalancingScheme(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOAD_BALANCING_SCHEME: _ClassVar[ForwardingRule.LoadBalancingScheme]
        EXTERNAL: _ClassVar[ForwardingRule.LoadBalancingScheme]
        EXTERNAL_MANAGED: _ClassVar[ForwardingRule.LoadBalancingScheme]
        INTERNAL: _ClassVar[ForwardingRule.LoadBalancingScheme]
        INTERNAL_MANAGED: _ClassVar[ForwardingRule.LoadBalancingScheme]
        INTERNAL_SELF_MANAGED: _ClassVar[ForwardingRule.LoadBalancingScheme]
        INVALID: _ClassVar[ForwardingRule.LoadBalancingScheme]
    UNDEFINED_LOAD_BALANCING_SCHEME: ForwardingRule.LoadBalancingScheme
    EXTERNAL: ForwardingRule.LoadBalancingScheme
    EXTERNAL_MANAGED: ForwardingRule.LoadBalancingScheme
    INTERNAL: ForwardingRule.LoadBalancingScheme
    INTERNAL_MANAGED: ForwardingRule.LoadBalancingScheme
    INTERNAL_SELF_MANAGED: ForwardingRule.LoadBalancingScheme
    INVALID: ForwardingRule.LoadBalancingScheme
    class NetworkTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NETWORK_TIER: _ClassVar[ForwardingRule.NetworkTier]
        FIXED_STANDARD: _ClassVar[ForwardingRule.NetworkTier]
        PREMIUM: _ClassVar[ForwardingRule.NetworkTier]
        STANDARD: _ClassVar[ForwardingRule.NetworkTier]
        STANDARD_OVERRIDES_FIXED_STANDARD: _ClassVar[ForwardingRule.NetworkTier]
    UNDEFINED_NETWORK_TIER: ForwardingRule.NetworkTier
    FIXED_STANDARD: ForwardingRule.NetworkTier
    PREMIUM: ForwardingRule.NetworkTier
    STANDARD: ForwardingRule.NetworkTier
    STANDARD_OVERRIDES_FIXED_STANDARD: ForwardingRule.NetworkTier
    class PscConnectionStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PSC_CONNECTION_STATUS: _ClassVar[ForwardingRule.PscConnectionStatus]
        ACCEPTED: _ClassVar[ForwardingRule.PscConnectionStatus]
        CLOSED: _ClassVar[ForwardingRule.PscConnectionStatus]
        NEEDS_ATTENTION: _ClassVar[ForwardingRule.PscConnectionStatus]
        PENDING: _ClassVar[ForwardingRule.PscConnectionStatus]
        REJECTED: _ClassVar[ForwardingRule.PscConnectionStatus]
        STATUS_UNSPECIFIED: _ClassVar[ForwardingRule.PscConnectionStatus]
    UNDEFINED_PSC_CONNECTION_STATUS: ForwardingRule.PscConnectionStatus
    ACCEPTED: ForwardingRule.PscConnectionStatus
    CLOSED: ForwardingRule.PscConnectionStatus
    NEEDS_ATTENTION: ForwardingRule.PscConnectionStatus
    PENDING: ForwardingRule.PscConnectionStatus
    REJECTED: ForwardingRule.PscConnectionStatus
    STATUS_UNSPECIFIED: ForwardingRule.PscConnectionStatus
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    I_P_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    I_P_PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    ALL_PORTS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_GLOBAL_ACCESS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_PSC_GLOBAL_ACCESS_FIELD_NUMBER: _ClassVar[int]
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    BASE_FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IP_COLLECTION_FIELD_NUMBER: _ClassVar[int]
    IP_VERSION_FIELD_NUMBER: _ClassVar[int]
    IS_MIRRORING_COLLECTOR_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LOAD_BALANCING_SCHEME_FIELD_NUMBER: _ClassVar[int]
    METADATA_FILTERS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORK_TIER_FIELD_NUMBER: _ClassVar[int]
    NO_AUTOMATE_DNS_ZONE_FIELD_NUMBER: _ClassVar[int]
    PORT_RANGE_FIELD_NUMBER: _ClassVar[int]
    PORTS_FIELD_NUMBER: _ClassVar[int]
    PSC_CONNECTION_ID_FIELD_NUMBER: _ClassVar[int]
    PSC_CONNECTION_STATUS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SERVICE_DIRECTORY_REGISTRATIONS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_LABEL_FIELD_NUMBER: _ClassVar[int]
    SERVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    TARGET_FIELD_NUMBER: _ClassVar[int]
    I_p_address: str
    I_p_protocol: str
    all_ports: bool
    allow_global_access: bool
    allow_psc_global_access: bool
    backend_service: str
    base_forwarding_rule: str
    creation_timestamp: str
    description: str
    fingerprint: str
    id: int
    ip_collection: str
    ip_version: str
    is_mirroring_collector: bool
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    load_balancing_scheme: str
    metadata_filters: _containers.RepeatedCompositeFieldContainer[MetadataFilter]
    name: str
    network: str
    network_tier: str
    no_automate_dns_zone: bool
    port_range: str
    ports: _containers.RepeatedScalarFieldContainer[str]
    psc_connection_id: int
    psc_connection_status: str
    region: str
    self_link: str
    service_directory_registrations: _containers.RepeatedCompositeFieldContainer[ForwardingRuleServiceDirectoryRegistration]
    service_label: str
    service_name: str
    source_ip_ranges: _containers.RepeatedScalarFieldContainer[str]
    subnetwork: str
    target: str
    def __init__(self, I_p_address: _Optional[str] = ..., I_p_protocol: _Optional[str] = ..., all_ports: bool = ..., allow_global_access: bool = ..., allow_psc_global_access: bool = ..., backend_service: _Optional[str] = ..., base_forwarding_rule: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., ip_collection: _Optional[str] = ..., ip_version: _Optional[str] = ..., is_mirroring_collector: bool = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., load_balancing_scheme: _Optional[str] = ..., metadata_filters: _Optional[_Iterable[_Union[MetadataFilter, _Mapping]]] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., network_tier: _Optional[str] = ..., no_automate_dns_zone: bool = ..., port_range: _Optional[str] = ..., ports: _Optional[_Iterable[str]] = ..., psc_connection_id: _Optional[int] = ..., psc_connection_status: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., service_directory_registrations: _Optional[_Iterable[_Union[ForwardingRuleServiceDirectoryRegistration, _Mapping]]] = ..., service_label: _Optional[str] = ..., service_name: _Optional[str] = ..., source_ip_ranges: _Optional[_Iterable[str]] = ..., subnetwork: _Optional[str] = ..., target: _Optional[str] = ...) -> None: ...

class ForwardingRuleAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ForwardingRulesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ForwardingRulesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, ForwardingRulesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, ForwardingRulesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ForwardingRuleList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[ForwardingRule]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[ForwardingRule, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ForwardingRuleReference(_message.Message):
    __slots__ = ("forwarding_rule",)
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    def __init__(self, forwarding_rule: _Optional[str] = ...) -> None: ...

class ForwardingRuleServiceDirectoryRegistration(_message.Message):
    __slots__ = ("namespace", "service", "service_directory_region")
    NAMESPACE_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    SERVICE_DIRECTORY_REGION_FIELD_NUMBER: _ClassVar[int]
    namespace: str
    service: str
    service_directory_region: str
    def __init__(self, namespace: _Optional[str] = ..., service: _Optional[str] = ..., service_directory_region: _Optional[str] = ...) -> None: ...

class ForwardingRulesScopedList(_message.Message):
    __slots__ = ("forwarding_rules", "warning")
    FORWARDING_RULES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    forwarding_rules: _containers.RepeatedCompositeFieldContainer[ForwardingRule]
    warning: Warning
    def __init__(self, forwarding_rules: _Optional[_Iterable[_Union[ForwardingRule, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class GRPCHealthCheck(_message.Message):
    __slots__ = ("grpc_service_name", "port", "port_name", "port_specification")
    class PortSpecification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_SPECIFICATION: _ClassVar[GRPCHealthCheck.PortSpecification]
        USE_FIXED_PORT: _ClassVar[GRPCHealthCheck.PortSpecification]
        USE_NAMED_PORT: _ClassVar[GRPCHealthCheck.PortSpecification]
        USE_SERVING_PORT: _ClassVar[GRPCHealthCheck.PortSpecification]
    UNDEFINED_PORT_SPECIFICATION: GRPCHealthCheck.PortSpecification
    USE_FIXED_PORT: GRPCHealthCheck.PortSpecification
    USE_NAMED_PORT: GRPCHealthCheck.PortSpecification
    USE_SERVING_PORT: GRPCHealthCheck.PortSpecification
    GRPC_SERVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_SPECIFICATION_FIELD_NUMBER: _ClassVar[int]
    grpc_service_name: str
    port: int
    port_name: str
    port_specification: str
    def __init__(self, grpc_service_name: _Optional[str] = ..., port: _Optional[int] = ..., port_name: _Optional[str] = ..., port_specification: _Optional[str] = ...) -> None: ...

class GetAcceleratorTypeRequest(_message.Message):
    __slots__ = ("accelerator_type", "project", "zone")
    ACCELERATOR_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    accelerator_type: str
    project: str
    zone: str
    def __init__(self, accelerator_type: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetAddressRequest(_message.Message):
    __slots__ = ("address", "project", "region")
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    address: str
    project: str
    region: str
    def __init__(self, address: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetAssociationFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "name")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    name: str
    def __init__(self, firewall_policy: _Optional[str] = ..., name: _Optional[str] = ...) -> None: ...

class GetAssociationNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "name", "project")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    name: str
    project: str
    def __init__(self, firewall_policy: _Optional[str] = ..., name: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetAssociationRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "name", "project", "region")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    name: str
    project: str
    region: str
    def __init__(self, firewall_policy: _Optional[str] = ..., name: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "project", "zone")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    project: str
    zone: str
    def __init__(self, autoscaler: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket", "project")
    BACKEND_BUCKET_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    backend_bucket: str
    project: str
    def __init__(self, backend_bucket: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetDiagnosticsInterconnectRequest(_message.Message):
    __slots__ = ("interconnect", "project")
    INTERCONNECT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    interconnect: str
    project: str
    def __init__(self, interconnect: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetDiskTypeRequest(_message.Message):
    __slots__ = ("disk_type", "project", "zone")
    DISK_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk_type: str
    project: str
    zone: str
    def __init__(self, disk_type: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetEffectiveFirewallsInstanceRequest(_message.Message):
    __slots__ = ("instance", "network_interface", "project", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    network_interface: str
    project: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., network_interface: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetEffectiveFirewallsNetworkRequest(_message.Message):
    __slots__ = ("network", "project")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    network: str
    project: str
    def __init__(self, network: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("network", "project", "region")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    network: str
    project: str
    region: str
    def __init__(self, network: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetExternalVpnGatewayRequest(_message.Message):
    __slots__ = ("external_vpn_gateway", "project")
    EXTERNAL_VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    external_vpn_gateway: str
    project: str
    def __init__(self, external_vpn_gateway: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy",)
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    def __init__(self, firewall_policy: _Optional[str] = ...) -> None: ...

class GetFirewallRequest(_message.Message):
    __slots__ = ("firewall", "project")
    FIREWALL_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    firewall: str
    project: str
    def __init__(self, firewall: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "project", "region")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    project: str
    region: str
    def __init__(self, forwarding_rule: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetFromFamilyImageRequest(_message.Message):
    __slots__ = ("family", "project")
    FAMILY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    family: str
    project: str
    def __init__(self, family: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetGlobalAddressRequest(_message.Message):
    __slots__ = ("address", "project")
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    address: str
    project: str
    def __init__(self, address: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetGlobalForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "project")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    project: str
    def __init__(self, forwarding_rule: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetGlobalNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetGlobalOperationRequest(_message.Message):
    __slots__ = ("operation", "project")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetGlobalOrganizationOperationRequest(_message.Message):
    __slots__ = ("operation", "parent_id")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PARENT_ID_FIELD_NUMBER: _ClassVar[int]
    operation: str
    parent_id: str
    def __init__(self, operation: _Optional[str] = ..., parent_id: _Optional[str] = ...) -> None: ...

class GetGlobalPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ...) -> None: ...

class GetGuestAttributesInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "query_path", "variable_key", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    QUERY_PATH_FIELD_NUMBER: _ClassVar[int]
    VARIABLE_KEY_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    query_path: str
    variable_key: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., query_path: _Optional[str] = ..., variable_key: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetHealthBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "resource_group_reference_resource")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_GROUP_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    resource_group_reference_resource: ResourceGroupReference
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., resource_group_reference_resource: _Optional[_Union[ResourceGroupReference, _Mapping]] = ...) -> None: ...

class GetHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "project")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    project: str
    def __init__(self, health_check: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetHealthRegionBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "region", "resource_group_reference_resource")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_GROUP_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    region: str
    resource_group_reference_resource: ResourceGroupReference
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource_group_reference_resource: _Optional[_Union[ResourceGroupReference, _Mapping]] = ...) -> None: ...

class GetHealthTargetPoolRequest(_message.Message):
    __slots__ = ("instance_reference_resource", "project", "region", "target_pool")
    INSTANCE_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    instance_reference_resource: InstanceReference
    project: str
    region: str
    target_pool: str
    def __init__(self, instance_reference_resource: _Optional[_Union[InstanceReference, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., target_pool: _Optional[str] = ...) -> None: ...

class GetIamPolicyBackendBucketRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyBackendServiceRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyDiskRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource", "zone")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    zone: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetIamPolicyFirewallPolicyRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyImageRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyInstanceRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource", "zone")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    zone: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetIamPolicyInstanceTemplateRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyInstantSnapshotRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource", "zone")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    zone: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetIamPolicyLicenseRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyMachineImageRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyNetworkAttachmentRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyNodeGroupRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource", "zone")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    zone: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetIamPolicyNodeTemplateRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyRegionBackendServiceRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyRegionDiskRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyRegionInstantSnapshotRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyReservationRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource", "zone")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    zone: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetIamPolicyResourcePolicyRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyServiceAttachmentRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicySnapshotRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetIamPolicyStoragePoolRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "resource", "zone")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    resource: str
    zone: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetIamPolicySubnetworkRequest(_message.Message):
    __slots__ = ("options_requested_policy_version", "project", "region", "resource")
    OPTIONS_REQUESTED_POLICY_VERSION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    options_requested_policy_version: int
    project: str
    region: str
    resource: str
    def __init__(self, options_requested_policy_version: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class GetImageFamilyViewRequest(_message.Message):
    __slots__ = ("family", "project", "zone")
    FAMILY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    family: str
    project: str
    zone: str
    def __init__(self, family: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetImageRequest(_message.Message):
    __slots__ = ("image", "project")
    IMAGE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    image: str
    project: str
    def __init__(self, image: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetInstanceGroupManagerResizeRequestRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "resize_request", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESIZE_REQUEST_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    resize_request: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., resize_request: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group", "project", "zone")
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group: str
    project: str
    zone: str
    def __init__(self, instance_group: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetInstanceSettingRequest(_message.Message):
    __slots__ = ("project", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetInstanceTemplateRequest(_message.Message):
    __slots__ = ("instance_template", "project")
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    project: str
    def __init__(self, instance_template: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetInstantSnapshotRequest(_message.Message):
    __slots__ = ("instant_snapshot", "project", "zone")
    INSTANT_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instant_snapshot: str
    project: str
    zone: str
    def __init__(self, instant_snapshot: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetInterconnectAttachmentRequest(_message.Message):
    __slots__ = ("interconnect_attachment", "project", "region")
    INTERCONNECT_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    interconnect_attachment: str
    project: str
    region: str
    def __init__(self, interconnect_attachment: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetInterconnectLocationRequest(_message.Message):
    __slots__ = ("interconnect_location", "project")
    INTERCONNECT_LOCATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    interconnect_location: str
    project: str
    def __init__(self, interconnect_location: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetInterconnectRemoteLocationRequest(_message.Message):
    __slots__ = ("interconnect_remote_location", "project")
    INTERCONNECT_REMOTE_LOCATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    interconnect_remote_location: str
    project: str
    def __init__(self, interconnect_remote_location: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetInterconnectRequest(_message.Message):
    __slots__ = ("interconnect", "project")
    INTERCONNECT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    interconnect: str
    project: str
    def __init__(self, interconnect: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetLicenseCodeRequest(_message.Message):
    __slots__ = ("license_code", "project")
    LICENSE_CODE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    license_code: str
    project: str
    def __init__(self, license_code: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetLicenseRequest(_message.Message):
    __slots__ = ("license", "project")
    LICENSE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    license: str
    project: str
    def __init__(self, license: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetMachineImageRequest(_message.Message):
    __slots__ = ("machine_image", "project")
    MACHINE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    machine_image: str
    project: str
    def __init__(self, machine_image: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetMachineTypeRequest(_message.Message):
    __slots__ = ("machine_type", "project", "zone")
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    machine_type: str
    project: str
    zone: str
    def __init__(self, machine_type: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetMacsecConfigInterconnectRequest(_message.Message):
    __slots__ = ("interconnect", "project")
    INTERCONNECT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    interconnect: str
    project: str
    def __init__(self, interconnect: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetNatIpInfoRouterRequest(_message.Message):
    __slots__ = ("nat_name", "project", "region", "router")
    NAT_NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    nat_name: str
    project: str
    region: str
    router: str
    def __init__(self, nat_name: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., router: _Optional[str] = ...) -> None: ...

class GetNatMappingInfoRoutersRequest(_message.Message):
    __slots__ = ("filter", "max_results", "nat_name", "order_by", "page_token", "project", "region", "return_partial_success", "router")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    NAT_NAME_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    nat_name: str
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    router: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., nat_name: _Optional[str] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ..., router: _Optional[str] = ...) -> None: ...

class GetNetworkAttachmentRequest(_message.Message):
    __slots__ = ("network_attachment", "project", "region")
    NETWORK_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    network_attachment: str
    project: str
    region: str
    def __init__(self, network_attachment: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetNetworkEdgeSecurityServiceRequest(_message.Message):
    __slots__ = ("network_edge_security_service", "project", "region")
    NETWORK_EDGE_SECURITY_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    network_edge_security_service: str
    project: str
    region: str
    def __init__(self, network_edge_security_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project", "zone")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    zone: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "project")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    project: str
    def __init__(self, firewall_policy: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetNetworkProfileRequest(_message.Message):
    __slots__ = ("network_profile", "project")
    NETWORK_PROFILE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    network_profile: str
    project: str
    def __init__(self, network_profile: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetNetworkRequest(_message.Message):
    __slots__ = ("network", "project")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    network: str
    project: str
    def __init__(self, network: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class GetNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "project", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    project: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetNodeTemplateRequest(_message.Message):
    __slots__ = ("node_template", "project", "region")
    NODE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    node_template: str
    project: str
    region: str
    def __init__(self, node_template: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetNodeTypeRequest(_message.Message):
    __slots__ = ("node_type", "project", "zone")
    NODE_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_type: str
    project: str
    zone: str
    def __init__(self, node_type: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetPacketMirroringRequest(_message.Message):
    __slots__ = ("packet_mirroring", "project", "region")
    PACKET_MIRRORING_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    packet_mirroring: str
    project: str
    region: str
    def __init__(self, packet_mirroring: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetProjectRequest(_message.Message):
    __slots__ = ("project",)
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    project: str
    def __init__(self, project: _Optional[str] = ...) -> None: ...

class GetPublicAdvertisedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_advertised_prefix")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_ADVERTISED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_advertised_prefix: str
    def __init__(self, project: _Optional[str] = ..., public_advertised_prefix: _Optional[str] = ...) -> None: ...

class GetPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix", "region")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    region: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "project", "region")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    project: str
    region: str
    def __init__(self, autoscaler: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "region")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    region: str
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionCommitmentRequest(_message.Message):
    __slots__ = ("commitment", "project", "region")
    COMMITMENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    commitment: str
    project: str
    region: str
    def __init__(self, commitment: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionDiskTypeRequest(_message.Message):
    __slots__ = ("disk_type", "project", "region")
    DISK_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    disk_type: str
    project: str
    region: str
    def __init__(self, disk_type: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "project", "region")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    project: str
    region: str
    def __init__(self, health_check: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionHealthCheckServiceRequest(_message.Message):
    __slots__ = ("health_check_service", "project", "region")
    HEALTH_CHECK_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    health_check_service: str
    project: str
    region: str
    def __init__(self, health_check_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group", "project", "region")
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    instance_group: str
    project: str
    region: str
    def __init__(self, instance_group: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionInstanceTemplateRequest(_message.Message):
    __slots__ = ("instance_template", "project", "region")
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    project: str
    region: str
    def __init__(self, instance_template: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionInstantSnapshotRequest(_message.Message):
    __slots__ = ("instant_snapshot", "project", "region")
    INSTANT_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    instant_snapshot: str
    project: str
    region: str
    def __init__(self, instant_snapshot: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group", "project", "region")
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group: str
    project: str
    region: str
    def __init__(self, network_endpoint_group: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "project", "region")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    project: str
    region: str
    def __init__(self, firewall_policy: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionNotificationEndpointRequest(_message.Message):
    __slots__ = ("notification_endpoint", "project", "region")
    NOTIFICATION_ENDPOINT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    notification_endpoint: str
    project: str
    region: str
    def __init__(self, notification_endpoint: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionOperationRequest(_message.Message):
    __slots__ = ("operation", "project", "region")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    region: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionRequest(_message.Message):
    __slots__ = ("project", "region")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "security_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    security_policy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class GetRegionSslCertificateRequest(_message.Message):
    __slots__ = ("project", "region", "ssl_certificate")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    ssl_certificate: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., ssl_certificate: _Optional[str] = ...) -> None: ...

class GetRegionSslPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "ssl_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    ssl_policy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., ssl_policy: _Optional[str] = ...) -> None: ...

class GetRegionTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "region", "target_http_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    target_http_proxy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., target_http_proxy: _Optional[str] = ...) -> None: ...

class GetRegionTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "region", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class GetRegionTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "region", "target_tcp_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    target_tcp_proxy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., target_tcp_proxy: _Optional[str] = ...) -> None: ...

class GetRegionUrlMapRequest(_message.Message):
    __slots__ = ("project", "region", "url_map")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    url_map: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., url_map: _Optional[str] = ...) -> None: ...

class GetReservationRequest(_message.Message):
    __slots__ = ("project", "reservation", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    reservation: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., reservation: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetResourcePolicyRequest(_message.Message):
    __slots__ = ("project", "region", "resource_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource_policy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource_policy: _Optional[str] = ...) -> None: ...

class GetRouteRequest(_message.Message):
    __slots__ = ("project", "route")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ROUTE_FIELD_NUMBER: _ClassVar[int]
    project: str
    route: str
    def __init__(self, project: _Optional[str] = ..., route: _Optional[str] = ...) -> None: ...

class GetRouterRequest(_message.Message):
    __slots__ = ("project", "region", "router")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    router: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., router: _Optional[str] = ...) -> None: ...

class GetRouterStatusRouterRequest(_message.Message):
    __slots__ = ("project", "region", "router")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    router: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., router: _Optional[str] = ...) -> None: ...

class GetRuleFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "priority")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    priority: int
    def __init__(self, firewall_policy: _Optional[str] = ..., priority: _Optional[int] = ...) -> None: ...

class GetRuleNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "priority", "project")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    priority: int
    project: str
    def __init__(self, firewall_policy: _Optional[str] = ..., priority: _Optional[int] = ..., project: _Optional[str] = ...) -> None: ...

class GetRuleRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "priority", "project", "region")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    priority: int
    project: str
    region: str
    def __init__(self, firewall_policy: _Optional[str] = ..., priority: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class GetRuleRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("priority", "project", "region", "security_policy")
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    priority: int
    project: str
    region: str
    security_policy: str
    def __init__(self, priority: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class GetRuleSecurityPolicyRequest(_message.Message):
    __slots__ = ("priority", "project", "security_policy")
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    priority: int
    project: str
    security_policy: str
    def __init__(self, priority: _Optional[int] = ..., project: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class GetScreenshotInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "security_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    security_policy: str
    def __init__(self, project: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class GetSerialPortOutputInstanceRequest(_message.Message):
    __slots__ = ("instance", "port", "project", "start", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    port: int
    project: str
    start: int
    zone: str
    def __init__(self, instance: _Optional[str] = ..., port: _Optional[int] = ..., project: _Optional[str] = ..., start: _Optional[int] = ..., zone: _Optional[str] = ...) -> None: ...

class GetServiceAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "service_attachment")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    service_attachment: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., service_attachment: _Optional[str] = ...) -> None: ...

class GetShieldedInstanceIdentityInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetSnapshotRequest(_message.Message):
    __slots__ = ("project", "snapshot")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    project: str
    snapshot: str
    def __init__(self, project: _Optional[str] = ..., snapshot: _Optional[str] = ...) -> None: ...

class GetSnapshotSettingRequest(_message.Message):
    __slots__ = ("project",)
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    project: str
    def __init__(self, project: _Optional[str] = ...) -> None: ...

class GetSslCertificateRequest(_message.Message):
    __slots__ = ("project", "ssl_certificate")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATE_FIELD_NUMBER: _ClassVar[int]
    project: str
    ssl_certificate: str
    def __init__(self, project: _Optional[str] = ..., ssl_certificate: _Optional[str] = ...) -> None: ...

class GetSslPolicyRequest(_message.Message):
    __slots__ = ("project", "ssl_policy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    project: str
    ssl_policy: str
    def __init__(self, project: _Optional[str] = ..., ssl_policy: _Optional[str] = ...) -> None: ...

class GetStatusVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "vpn_gateway")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    vpn_gateway: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., vpn_gateway: _Optional[str] = ...) -> None: ...

class GetStoragePoolRequest(_message.Message):
    __slots__ = ("project", "storage_pool", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    storage_pool: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., storage_pool: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetStoragePoolTypeRequest(_message.Message):
    __slots__ = ("project", "storage_pool_type", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_TYPE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    storage_pool_type: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., storage_pool_type: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetSubnetworkRequest(_message.Message):
    __slots__ = ("project", "region", "subnetwork")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    subnetwork: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., subnetwork: _Optional[str] = ...) -> None: ...

class GetTargetGrpcProxyRequest(_message.Message):
    __slots__ = ("project", "target_grpc_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TARGET_GRPC_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    target_grpc_proxy: str
    def __init__(self, project: _Optional[str] = ..., target_grpc_proxy: _Optional[str] = ...) -> None: ...

class GetTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "target_http_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    target_http_proxy: str
    def __init__(self, project: _Optional[str] = ..., target_http_proxy: _Optional[str] = ...) -> None: ...

class GetTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class GetTargetInstanceRequest(_message.Message):
    __slots__ = ("project", "target_instance", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TARGET_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    target_instance: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., target_instance: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "target_pool")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    target_pool: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., target_pool: _Optional[str] = ...) -> None: ...

class GetTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "target_ssl_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    target_ssl_proxy: str
    def __init__(self, project: _Optional[str] = ..., target_ssl_proxy: _Optional[str] = ...) -> None: ...

class GetTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "target_tcp_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    target_tcp_proxy: str
    def __init__(self, project: _Optional[str] = ..., target_tcp_proxy: _Optional[str] = ...) -> None: ...

class GetTargetVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "target_vpn_gateway")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    TARGET_VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    target_vpn_gateway: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., target_vpn_gateway: _Optional[str] = ...) -> None: ...

class GetUrlMapRequest(_message.Message):
    __slots__ = ("project", "url_map")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    project: str
    url_map: str
    def __init__(self, project: _Optional[str] = ..., url_map: _Optional[str] = ...) -> None: ...

class GetVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "vpn_gateway")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    vpn_gateway: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., vpn_gateway: _Optional[str] = ...) -> None: ...

class GetVpnTunnelRequest(_message.Message):
    __slots__ = ("project", "region", "vpn_tunnel")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    VPN_TUNNEL_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    vpn_tunnel: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., vpn_tunnel: _Optional[str] = ...) -> None: ...

class GetXpnHostProjectRequest(_message.Message):
    __slots__ = ("project",)
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    project: str
    def __init__(self, project: _Optional[str] = ...) -> None: ...

class GetXpnResourcesProjectsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class GetZoneOperationRequest(_message.Message):
    __slots__ = ("operation", "project", "zone")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    zone: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GetZoneRequest(_message.Message):
    __slots__ = ("project", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class GlobalAddressesMoveRequest(_message.Message):
    __slots__ = ("description", "destination_address")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DESTINATION_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    description: str
    destination_address: str
    def __init__(self, description: _Optional[str] = ..., destination_address: _Optional[str] = ...) -> None: ...

class GlobalNetworkEndpointGroupsAttachEndpointsRequest(_message.Message):
    __slots__ = ("network_endpoints",)
    NETWORK_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    network_endpoints: _containers.RepeatedCompositeFieldContainer[NetworkEndpoint]
    def __init__(self, network_endpoints: _Optional[_Iterable[_Union[NetworkEndpoint, _Mapping]]] = ...) -> None: ...

class GlobalNetworkEndpointGroupsDetachEndpointsRequest(_message.Message):
    __slots__ = ("network_endpoints",)
    NETWORK_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    network_endpoints: _containers.RepeatedCompositeFieldContainer[NetworkEndpoint]
    def __init__(self, network_endpoints: _Optional[_Iterable[_Union[NetworkEndpoint, _Mapping]]] = ...) -> None: ...

class GlobalOrganizationSetPolicyRequest(_message.Message):
    __slots__ = ("bindings", "etag", "policy")
    BINDINGS_FIELD_NUMBER: _ClassVar[int]
    ETAG_FIELD_NUMBER: _ClassVar[int]
    POLICY_FIELD_NUMBER: _ClassVar[int]
    bindings: _containers.RepeatedCompositeFieldContainer[Binding]
    etag: str
    policy: Policy
    def __init__(self, bindings: _Optional[_Iterable[_Union[Binding, _Mapping]]] = ..., etag: _Optional[str] = ..., policy: _Optional[_Union[Policy, _Mapping]] = ...) -> None: ...

class GlobalSetLabelsRequest(_message.Message):
    __slots__ = ("label_fingerprint", "labels")
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    def __init__(self, label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ...) -> None: ...

class GlobalSetPolicyRequest(_message.Message):
    __slots__ = ("bindings", "etag", "policy")
    BINDINGS_FIELD_NUMBER: _ClassVar[int]
    ETAG_FIELD_NUMBER: _ClassVar[int]
    POLICY_FIELD_NUMBER: _ClassVar[int]
    bindings: _containers.RepeatedCompositeFieldContainer[Binding]
    etag: str
    policy: Policy
    def __init__(self, bindings: _Optional[_Iterable[_Union[Binding, _Mapping]]] = ..., etag: _Optional[str] = ..., policy: _Optional[_Union[Policy, _Mapping]] = ...) -> None: ...

class GuestAttributes(_message.Message):
    __slots__ = ("kind", "query_path", "query_value", "self_link", "variable_key", "variable_value")
    KIND_FIELD_NUMBER: _ClassVar[int]
    QUERY_PATH_FIELD_NUMBER: _ClassVar[int]
    QUERY_VALUE_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    VARIABLE_KEY_FIELD_NUMBER: _ClassVar[int]
    VARIABLE_VALUE_FIELD_NUMBER: _ClassVar[int]
    kind: str
    query_path: str
    query_value: GuestAttributesValue
    self_link: str
    variable_key: str
    variable_value: str
    def __init__(self, kind: _Optional[str] = ..., query_path: _Optional[str] = ..., query_value: _Optional[_Union[GuestAttributesValue, _Mapping]] = ..., self_link: _Optional[str] = ..., variable_key: _Optional[str] = ..., variable_value: _Optional[str] = ...) -> None: ...

class GuestAttributesEntry(_message.Message):
    __slots__ = ("key", "namespace", "value")
    KEY_FIELD_NUMBER: _ClassVar[int]
    NAMESPACE_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    namespace: str
    value: str
    def __init__(self, key: _Optional[str] = ..., namespace: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class GuestAttributesValue(_message.Message):
    __slots__ = ("items",)
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    items: _containers.RepeatedCompositeFieldContainer[GuestAttributesEntry]
    def __init__(self, items: _Optional[_Iterable[_Union[GuestAttributesEntry, _Mapping]]] = ...) -> None: ...

class GuestOsFeature(_message.Message):
    __slots__ = ("type",)
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[GuestOsFeature.Type]
        FEATURE_TYPE_UNSPECIFIED: _ClassVar[GuestOsFeature.Type]
        GVNIC: _ClassVar[GuestOsFeature.Type]
        IDPF: _ClassVar[GuestOsFeature.Type]
        MULTI_IP_SUBNET: _ClassVar[GuestOsFeature.Type]
        SECURE_BOOT: _ClassVar[GuestOsFeature.Type]
        SEV_CAPABLE: _ClassVar[GuestOsFeature.Type]
        SEV_LIVE_MIGRATABLE: _ClassVar[GuestOsFeature.Type]
        SEV_LIVE_MIGRATABLE_V2: _ClassVar[GuestOsFeature.Type]
        SEV_SNP_CAPABLE: _ClassVar[GuestOsFeature.Type]
        TDX_CAPABLE: _ClassVar[GuestOsFeature.Type]
        UEFI_COMPATIBLE: _ClassVar[GuestOsFeature.Type]
        VIRTIO_SCSI_MULTIQUEUE: _ClassVar[GuestOsFeature.Type]
        WINDOWS: _ClassVar[GuestOsFeature.Type]
    UNDEFINED_TYPE: GuestOsFeature.Type
    FEATURE_TYPE_UNSPECIFIED: GuestOsFeature.Type
    GVNIC: GuestOsFeature.Type
    IDPF: GuestOsFeature.Type
    MULTI_IP_SUBNET: GuestOsFeature.Type
    SECURE_BOOT: GuestOsFeature.Type
    SEV_CAPABLE: GuestOsFeature.Type
    SEV_LIVE_MIGRATABLE: GuestOsFeature.Type
    SEV_LIVE_MIGRATABLE_V2: GuestOsFeature.Type
    SEV_SNP_CAPABLE: GuestOsFeature.Type
    TDX_CAPABLE: GuestOsFeature.Type
    UEFI_COMPATIBLE: GuestOsFeature.Type
    VIRTIO_SCSI_MULTIQUEUE: GuestOsFeature.Type
    WINDOWS: GuestOsFeature.Type
    TYPE_FIELD_NUMBER: _ClassVar[int]
    type: str
    def __init__(self, type: _Optional[str] = ...) -> None: ...

class HTTP2HealthCheck(_message.Message):
    __slots__ = ("host", "port", "port_name", "port_specification", "proxy_header", "request_path", "response")
    class PortSpecification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_SPECIFICATION: _ClassVar[HTTP2HealthCheck.PortSpecification]
        USE_FIXED_PORT: _ClassVar[HTTP2HealthCheck.PortSpecification]
        USE_NAMED_PORT: _ClassVar[HTTP2HealthCheck.PortSpecification]
        USE_SERVING_PORT: _ClassVar[HTTP2HealthCheck.PortSpecification]
    UNDEFINED_PORT_SPECIFICATION: HTTP2HealthCheck.PortSpecification
    USE_FIXED_PORT: HTTP2HealthCheck.PortSpecification
    USE_NAMED_PORT: HTTP2HealthCheck.PortSpecification
    USE_SERVING_PORT: HTTP2HealthCheck.PortSpecification
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[HTTP2HealthCheck.ProxyHeader]
        NONE: _ClassVar[HTTP2HealthCheck.ProxyHeader]
        PROXY_V1: _ClassVar[HTTP2HealthCheck.ProxyHeader]
    UNDEFINED_PROXY_HEADER: HTTP2HealthCheck.ProxyHeader
    NONE: HTTP2HealthCheck.ProxyHeader
    PROXY_V1: HTTP2HealthCheck.ProxyHeader
    HOST_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_SPECIFICATION_FIELD_NUMBER: _ClassVar[int]
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    REQUEST_PATH_FIELD_NUMBER: _ClassVar[int]
    RESPONSE_FIELD_NUMBER: _ClassVar[int]
    host: str
    port: int
    port_name: str
    port_specification: str
    proxy_header: str
    request_path: str
    response: str
    def __init__(self, host: _Optional[str] = ..., port: _Optional[int] = ..., port_name: _Optional[str] = ..., port_specification: _Optional[str] = ..., proxy_header: _Optional[str] = ..., request_path: _Optional[str] = ..., response: _Optional[str] = ...) -> None: ...

class HTTPHealthCheck(_message.Message):
    __slots__ = ("host", "port", "port_name", "port_specification", "proxy_header", "request_path", "response")
    class PortSpecification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_SPECIFICATION: _ClassVar[HTTPHealthCheck.PortSpecification]
        USE_FIXED_PORT: _ClassVar[HTTPHealthCheck.PortSpecification]
        USE_NAMED_PORT: _ClassVar[HTTPHealthCheck.PortSpecification]
        USE_SERVING_PORT: _ClassVar[HTTPHealthCheck.PortSpecification]
    UNDEFINED_PORT_SPECIFICATION: HTTPHealthCheck.PortSpecification
    USE_FIXED_PORT: HTTPHealthCheck.PortSpecification
    USE_NAMED_PORT: HTTPHealthCheck.PortSpecification
    USE_SERVING_PORT: HTTPHealthCheck.PortSpecification
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[HTTPHealthCheck.ProxyHeader]
        NONE: _ClassVar[HTTPHealthCheck.ProxyHeader]
        PROXY_V1: _ClassVar[HTTPHealthCheck.ProxyHeader]
    UNDEFINED_PROXY_HEADER: HTTPHealthCheck.ProxyHeader
    NONE: HTTPHealthCheck.ProxyHeader
    PROXY_V1: HTTPHealthCheck.ProxyHeader
    HOST_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_SPECIFICATION_FIELD_NUMBER: _ClassVar[int]
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    REQUEST_PATH_FIELD_NUMBER: _ClassVar[int]
    RESPONSE_FIELD_NUMBER: _ClassVar[int]
    host: str
    port: int
    port_name: str
    port_specification: str
    proxy_header: str
    request_path: str
    response: str
    def __init__(self, host: _Optional[str] = ..., port: _Optional[int] = ..., port_name: _Optional[str] = ..., port_specification: _Optional[str] = ..., proxy_header: _Optional[str] = ..., request_path: _Optional[str] = ..., response: _Optional[str] = ...) -> None: ...

class HTTPSHealthCheck(_message.Message):
    __slots__ = ("host", "port", "port_name", "port_specification", "proxy_header", "request_path", "response")
    class PortSpecification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_SPECIFICATION: _ClassVar[HTTPSHealthCheck.PortSpecification]
        USE_FIXED_PORT: _ClassVar[HTTPSHealthCheck.PortSpecification]
        USE_NAMED_PORT: _ClassVar[HTTPSHealthCheck.PortSpecification]
        USE_SERVING_PORT: _ClassVar[HTTPSHealthCheck.PortSpecification]
    UNDEFINED_PORT_SPECIFICATION: HTTPSHealthCheck.PortSpecification
    USE_FIXED_PORT: HTTPSHealthCheck.PortSpecification
    USE_NAMED_PORT: HTTPSHealthCheck.PortSpecification
    USE_SERVING_PORT: HTTPSHealthCheck.PortSpecification
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[HTTPSHealthCheck.ProxyHeader]
        NONE: _ClassVar[HTTPSHealthCheck.ProxyHeader]
        PROXY_V1: _ClassVar[HTTPSHealthCheck.ProxyHeader]
    UNDEFINED_PROXY_HEADER: HTTPSHealthCheck.ProxyHeader
    NONE: HTTPSHealthCheck.ProxyHeader
    PROXY_V1: HTTPSHealthCheck.ProxyHeader
    HOST_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_SPECIFICATION_FIELD_NUMBER: _ClassVar[int]
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    REQUEST_PATH_FIELD_NUMBER: _ClassVar[int]
    RESPONSE_FIELD_NUMBER: _ClassVar[int]
    host: str
    port: int
    port_name: str
    port_specification: str
    proxy_header: str
    request_path: str
    response: str
    def __init__(self, host: _Optional[str] = ..., port: _Optional[int] = ..., port_name: _Optional[str] = ..., port_specification: _Optional[str] = ..., proxy_header: _Optional[str] = ..., request_path: _Optional[str] = ..., response: _Optional[str] = ...) -> None: ...

class HealthCheck(_message.Message):
    __slots__ = ("check_interval_sec", "creation_timestamp", "description", "grpc_health_check", "healthy_threshold", "http2_health_check", "http_health_check", "https_health_check", "id", "kind", "log_config", "name", "region", "self_link", "source_regions", "ssl_health_check", "tcp_health_check", "timeout_sec", "type", "unhealthy_threshold")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[HealthCheck.Type]
        GRPC: _ClassVar[HealthCheck.Type]
        HTTP: _ClassVar[HealthCheck.Type]
        HTTP2: _ClassVar[HealthCheck.Type]
        HTTPS: _ClassVar[HealthCheck.Type]
        INVALID: _ClassVar[HealthCheck.Type]
        SSL: _ClassVar[HealthCheck.Type]
        TCP: _ClassVar[HealthCheck.Type]
    UNDEFINED_TYPE: HealthCheck.Type
    GRPC: HealthCheck.Type
    HTTP: HealthCheck.Type
    HTTP2: HealthCheck.Type
    HTTPS: HealthCheck.Type
    INVALID: HealthCheck.Type
    SSL: HealthCheck.Type
    TCP: HealthCheck.Type
    CHECK_INTERVAL_SEC_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    GRPC_HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HEALTHY_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    HTTP2_HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HTTP_HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HTTPS_HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOG_CONFIG_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_REGIONS_FIELD_NUMBER: _ClassVar[int]
    SSL_HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    TCP_HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    UNHEALTHY_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    check_interval_sec: int
    creation_timestamp: str
    description: str
    grpc_health_check: GRPCHealthCheck
    healthy_threshold: int
    http2_health_check: HTTP2HealthCheck
    http_health_check: HTTPHealthCheck
    https_health_check: HTTPSHealthCheck
    id: int
    kind: str
    log_config: HealthCheckLogConfig
    name: str
    region: str
    self_link: str
    source_regions: _containers.RepeatedScalarFieldContainer[str]
    ssl_health_check: SSLHealthCheck
    tcp_health_check: TCPHealthCheck
    timeout_sec: int
    type: str
    unhealthy_threshold: int
    def __init__(self, check_interval_sec: _Optional[int] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., grpc_health_check: _Optional[_Union[GRPCHealthCheck, _Mapping]] = ..., healthy_threshold: _Optional[int] = ..., http2_health_check: _Optional[_Union[HTTP2HealthCheck, _Mapping]] = ..., http_health_check: _Optional[_Union[HTTPHealthCheck, _Mapping]] = ..., https_health_check: _Optional[_Union[HTTPSHealthCheck, _Mapping]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., log_config: _Optional[_Union[HealthCheckLogConfig, _Mapping]] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., source_regions: _Optional[_Iterable[str]] = ..., ssl_health_check: _Optional[_Union[SSLHealthCheck, _Mapping]] = ..., tcp_health_check: _Optional[_Union[TCPHealthCheck, _Mapping]] = ..., timeout_sec: _Optional[int] = ..., type: _Optional[str] = ..., unhealthy_threshold: _Optional[int] = ...) -> None: ...

class HealthCheckList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[HealthCheck]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[HealthCheck, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class HealthCheckLogConfig(_message.Message):
    __slots__ = ("enable",)
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    enable: bool
    def __init__(self, enable: bool = ...) -> None: ...

class HealthCheckReference(_message.Message):
    __slots__ = ("health_check",)
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    def __init__(self, health_check: _Optional[str] = ...) -> None: ...

class HealthCheckService(_message.Message):
    __slots__ = ("creation_timestamp", "description", "fingerprint", "health_checks", "health_status_aggregation_policy", "id", "kind", "name", "network_endpoint_groups", "notification_endpoints", "region", "self_link")
    class HealthStatusAggregationPolicy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_HEALTH_STATUS_AGGREGATION_POLICY: _ClassVar[HealthCheckService.HealthStatusAggregationPolicy]
        AND: _ClassVar[HealthCheckService.HealthStatusAggregationPolicy]
        NO_AGGREGATION: _ClassVar[HealthCheckService.HealthStatusAggregationPolicy]
    UNDEFINED_HEALTH_STATUS_AGGREGATION_POLICY: HealthCheckService.HealthStatusAggregationPolicy
    AND: HealthCheckService.HealthStatusAggregationPolicy
    NO_AGGREGATION: HealthCheckService.HealthStatusAggregationPolicy
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECKS_FIELD_NUMBER: _ClassVar[int]
    HEALTH_STATUS_AGGREGATION_POLICY_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUPS_FIELD_NUMBER: _ClassVar[int]
    NOTIFICATION_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    fingerprint: str
    health_checks: _containers.RepeatedScalarFieldContainer[str]
    health_status_aggregation_policy: str
    id: int
    kind: str
    name: str
    network_endpoint_groups: _containers.RepeatedScalarFieldContainer[str]
    notification_endpoints: _containers.RepeatedScalarFieldContainer[str]
    region: str
    self_link: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., health_checks: _Optional[_Iterable[str]] = ..., health_status_aggregation_policy: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., network_endpoint_groups: _Optional[_Iterable[str]] = ..., notification_endpoints: _Optional[_Iterable[str]] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ...) -> None: ...

class HealthCheckServiceReference(_message.Message):
    __slots__ = ("health_check_service",)
    HEALTH_CHECK_SERVICE_FIELD_NUMBER: _ClassVar[int]
    health_check_service: str
    def __init__(self, health_check_service: _Optional[str] = ...) -> None: ...

class HealthCheckServicesList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[HealthCheckService]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[HealthCheckService, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class HealthChecksAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: HealthChecksScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[HealthChecksScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, HealthChecksScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, HealthChecksScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class HealthChecksScopedList(_message.Message):
    __slots__ = ("health_checks", "warning")
    HEALTH_CHECKS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    health_checks: _containers.RepeatedCompositeFieldContainer[HealthCheck]
    warning: Warning
    def __init__(self, health_checks: _Optional[_Iterable[_Union[HealthCheck, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class HealthStatus(_message.Message):
    __slots__ = ("annotations", "forwarding_rule", "forwarding_rule_ip", "health_state", "instance", "ip_address", "ipv6_address", "ipv6_health_state", "port", "weight", "weight_error")
    class HealthState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_HEALTH_STATE: _ClassVar[HealthStatus.HealthState]
        HEALTHY: _ClassVar[HealthStatus.HealthState]
        UNHEALTHY: _ClassVar[HealthStatus.HealthState]
    UNDEFINED_HEALTH_STATE: HealthStatus.HealthState
    HEALTHY: HealthStatus.HealthState
    UNHEALTHY: HealthStatus.HealthState
    class Ipv6HealthState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IPV6_HEALTH_STATE: _ClassVar[HealthStatus.Ipv6HealthState]
    UNDEFINED_IPV6_HEALTH_STATE: HealthStatus.Ipv6HealthState
    class WeightError(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_WEIGHT_ERROR: _ClassVar[HealthStatus.WeightError]
        INVALID_WEIGHT: _ClassVar[HealthStatus.WeightError]
        MISSING_WEIGHT: _ClassVar[HealthStatus.WeightError]
        UNAVAILABLE_WEIGHT: _ClassVar[HealthStatus.WeightError]
        WEIGHT_NONE: _ClassVar[HealthStatus.WeightError]
    UNDEFINED_WEIGHT_ERROR: HealthStatus.WeightError
    INVALID_WEIGHT: HealthStatus.WeightError
    MISSING_WEIGHT: HealthStatus.WeightError
    UNAVAILABLE_WEIGHT: HealthStatus.WeightError
    WEIGHT_NONE: HealthStatus.WeightError
    class AnnotationsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ANNOTATIONS_FIELD_NUMBER: _ClassVar[int]
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    FORWARDING_RULE_IP_FIELD_NUMBER: _ClassVar[int]
    HEALTH_STATE_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_HEALTH_STATE_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    WEIGHT_FIELD_NUMBER: _ClassVar[int]
    WEIGHT_ERROR_FIELD_NUMBER: _ClassVar[int]
    annotations: _containers.ScalarMap[str, str]
    forwarding_rule: str
    forwarding_rule_ip: str
    health_state: str
    instance: str
    ip_address: str
    ipv6_address: str
    ipv6_health_state: str
    port: int
    weight: str
    weight_error: str
    def __init__(self, annotations: _Optional[_Mapping[str, str]] = ..., forwarding_rule: _Optional[str] = ..., forwarding_rule_ip: _Optional[str] = ..., health_state: _Optional[str] = ..., instance: _Optional[str] = ..., ip_address: _Optional[str] = ..., ipv6_address: _Optional[str] = ..., ipv6_health_state: _Optional[str] = ..., port: _Optional[int] = ..., weight: _Optional[str] = ..., weight_error: _Optional[str] = ...) -> None: ...

class HealthStatusForNetworkEndpoint(_message.Message):
    __slots__ = ("backend_service", "forwarding_rule", "health_check", "health_check_service", "health_state", "ipv6_health_state")
    class HealthState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_HEALTH_STATE: _ClassVar[HealthStatusForNetworkEndpoint.HealthState]
        DRAINING: _ClassVar[HealthStatusForNetworkEndpoint.HealthState]
        HEALTHY: _ClassVar[HealthStatusForNetworkEndpoint.HealthState]
        UNHEALTHY: _ClassVar[HealthStatusForNetworkEndpoint.HealthState]
        UNKNOWN: _ClassVar[HealthStatusForNetworkEndpoint.HealthState]
    UNDEFINED_HEALTH_STATE: HealthStatusForNetworkEndpoint.HealthState
    DRAINING: HealthStatusForNetworkEndpoint.HealthState
    HEALTHY: HealthStatusForNetworkEndpoint.HealthState
    UNHEALTHY: HealthStatusForNetworkEndpoint.HealthState
    UNKNOWN: HealthStatusForNetworkEndpoint.HealthState
    class Ipv6HealthState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IPV6_HEALTH_STATE: _ClassVar[HealthStatusForNetworkEndpoint.Ipv6HealthState]
    UNDEFINED_IPV6_HEALTH_STATE: HealthStatusForNetworkEndpoint.Ipv6HealthState
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_SERVICE_FIELD_NUMBER: _ClassVar[int]
    HEALTH_STATE_FIELD_NUMBER: _ClassVar[int]
    IPV6_HEALTH_STATE_FIELD_NUMBER: _ClassVar[int]
    backend_service: BackendServiceReference
    forwarding_rule: ForwardingRuleReference
    health_check: HealthCheckReference
    health_check_service: HealthCheckServiceReference
    health_state: str
    ipv6_health_state: str
    def __init__(self, backend_service: _Optional[_Union[BackendServiceReference, _Mapping]] = ..., forwarding_rule: _Optional[_Union[ForwardingRuleReference, _Mapping]] = ..., health_check: _Optional[_Union[HealthCheckReference, _Mapping]] = ..., health_check_service: _Optional[_Union[HealthCheckServiceReference, _Mapping]] = ..., health_state: _Optional[str] = ..., ipv6_health_state: _Optional[str] = ...) -> None: ...

class Help(_message.Message):
    __slots__ = ("links",)
    LINKS_FIELD_NUMBER: _ClassVar[int]
    links: _containers.RepeatedCompositeFieldContainer[HelpLink]
    def __init__(self, links: _Optional[_Iterable[_Union[HelpLink, _Mapping]]] = ...) -> None: ...

class HelpLink(_message.Message):
    __slots__ = ("description", "url")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    description: str
    url: str
    def __init__(self, description: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class HostRule(_message.Message):
    __slots__ = ("description", "hosts", "path_matcher")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    HOSTS_FIELD_NUMBER: _ClassVar[int]
    PATH_MATCHER_FIELD_NUMBER: _ClassVar[int]
    description: str
    hosts: _containers.RepeatedScalarFieldContainer[str]
    path_matcher: str
    def __init__(self, description: _Optional[str] = ..., hosts: _Optional[_Iterable[str]] = ..., path_matcher: _Optional[str] = ...) -> None: ...

class HttpFaultAbort(_message.Message):
    __slots__ = ("http_status", "percentage")
    HTTP_STATUS_FIELD_NUMBER: _ClassVar[int]
    PERCENTAGE_FIELD_NUMBER: _ClassVar[int]
    http_status: int
    percentage: float
    def __init__(self, http_status: _Optional[int] = ..., percentage: _Optional[float] = ...) -> None: ...

class HttpFaultDelay(_message.Message):
    __slots__ = ("fixed_delay", "percentage")
    FIXED_DELAY_FIELD_NUMBER: _ClassVar[int]
    PERCENTAGE_FIELD_NUMBER: _ClassVar[int]
    fixed_delay: Duration
    percentage: float
    def __init__(self, fixed_delay: _Optional[_Union[Duration, _Mapping]] = ..., percentage: _Optional[float] = ...) -> None: ...

class HttpFaultInjection(_message.Message):
    __slots__ = ("abort", "delay")
    ABORT_FIELD_NUMBER: _ClassVar[int]
    DELAY_FIELD_NUMBER: _ClassVar[int]
    abort: HttpFaultAbort
    delay: HttpFaultDelay
    def __init__(self, abort: _Optional[_Union[HttpFaultAbort, _Mapping]] = ..., delay: _Optional[_Union[HttpFaultDelay, _Mapping]] = ...) -> None: ...

class HttpHeaderAction(_message.Message):
    __slots__ = ("request_headers_to_add", "request_headers_to_remove", "response_headers_to_add", "response_headers_to_remove")
    REQUEST_HEADERS_TO_ADD_FIELD_NUMBER: _ClassVar[int]
    REQUEST_HEADERS_TO_REMOVE_FIELD_NUMBER: _ClassVar[int]
    RESPONSE_HEADERS_TO_ADD_FIELD_NUMBER: _ClassVar[int]
    RESPONSE_HEADERS_TO_REMOVE_FIELD_NUMBER: _ClassVar[int]
    request_headers_to_add: _containers.RepeatedCompositeFieldContainer[HttpHeaderOption]
    request_headers_to_remove: _containers.RepeatedScalarFieldContainer[str]
    response_headers_to_add: _containers.RepeatedCompositeFieldContainer[HttpHeaderOption]
    response_headers_to_remove: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, request_headers_to_add: _Optional[_Iterable[_Union[HttpHeaderOption, _Mapping]]] = ..., request_headers_to_remove: _Optional[_Iterable[str]] = ..., response_headers_to_add: _Optional[_Iterable[_Union[HttpHeaderOption, _Mapping]]] = ..., response_headers_to_remove: _Optional[_Iterable[str]] = ...) -> None: ...

class HttpHeaderMatch(_message.Message):
    __slots__ = ("exact_match", "header_name", "invert_match", "prefix_match", "present_match", "range_match", "regex_match", "suffix_match")
    EXACT_MATCH_FIELD_NUMBER: _ClassVar[int]
    HEADER_NAME_FIELD_NUMBER: _ClassVar[int]
    INVERT_MATCH_FIELD_NUMBER: _ClassVar[int]
    PREFIX_MATCH_FIELD_NUMBER: _ClassVar[int]
    PRESENT_MATCH_FIELD_NUMBER: _ClassVar[int]
    RANGE_MATCH_FIELD_NUMBER: _ClassVar[int]
    REGEX_MATCH_FIELD_NUMBER: _ClassVar[int]
    SUFFIX_MATCH_FIELD_NUMBER: _ClassVar[int]
    exact_match: str
    header_name: str
    invert_match: bool
    prefix_match: str
    present_match: bool
    range_match: Int64RangeMatch
    regex_match: str
    suffix_match: str
    def __init__(self, exact_match: _Optional[str] = ..., header_name: _Optional[str] = ..., invert_match: bool = ..., prefix_match: _Optional[str] = ..., present_match: bool = ..., range_match: _Optional[_Union[Int64RangeMatch, _Mapping]] = ..., regex_match: _Optional[str] = ..., suffix_match: _Optional[str] = ...) -> None: ...

class HttpHeaderOption(_message.Message):
    __slots__ = ("header_name", "header_value", "replace")
    HEADER_NAME_FIELD_NUMBER: _ClassVar[int]
    HEADER_VALUE_FIELD_NUMBER: _ClassVar[int]
    REPLACE_FIELD_NUMBER: _ClassVar[int]
    header_name: str
    header_value: str
    replace: bool
    def __init__(self, header_name: _Optional[str] = ..., header_value: _Optional[str] = ..., replace: bool = ...) -> None: ...

class HttpQueryParameterMatch(_message.Message):
    __slots__ = ("exact_match", "name", "present_match", "regex_match")
    EXACT_MATCH_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRESENT_MATCH_FIELD_NUMBER: _ClassVar[int]
    REGEX_MATCH_FIELD_NUMBER: _ClassVar[int]
    exact_match: str
    name: str
    present_match: bool
    regex_match: str
    def __init__(self, exact_match: _Optional[str] = ..., name: _Optional[str] = ..., present_match: bool = ..., regex_match: _Optional[str] = ...) -> None: ...

class HttpRedirectAction(_message.Message):
    __slots__ = ("host_redirect", "https_redirect", "path_redirect", "prefix_redirect", "redirect_response_code", "strip_query")
    class RedirectResponseCode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_REDIRECT_RESPONSE_CODE: _ClassVar[HttpRedirectAction.RedirectResponseCode]
        FOUND: _ClassVar[HttpRedirectAction.RedirectResponseCode]
        MOVED_PERMANENTLY_DEFAULT: _ClassVar[HttpRedirectAction.RedirectResponseCode]
        PERMANENT_REDIRECT: _ClassVar[HttpRedirectAction.RedirectResponseCode]
        SEE_OTHER: _ClassVar[HttpRedirectAction.RedirectResponseCode]
        TEMPORARY_REDIRECT: _ClassVar[HttpRedirectAction.RedirectResponseCode]
    UNDEFINED_REDIRECT_RESPONSE_CODE: HttpRedirectAction.RedirectResponseCode
    FOUND: HttpRedirectAction.RedirectResponseCode
    MOVED_PERMANENTLY_DEFAULT: HttpRedirectAction.RedirectResponseCode
    PERMANENT_REDIRECT: HttpRedirectAction.RedirectResponseCode
    SEE_OTHER: HttpRedirectAction.RedirectResponseCode
    TEMPORARY_REDIRECT: HttpRedirectAction.RedirectResponseCode
    HOST_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    HTTPS_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    PATH_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    PREFIX_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    REDIRECT_RESPONSE_CODE_FIELD_NUMBER: _ClassVar[int]
    STRIP_QUERY_FIELD_NUMBER: _ClassVar[int]
    host_redirect: str
    https_redirect: bool
    path_redirect: str
    prefix_redirect: str
    redirect_response_code: str
    strip_query: bool
    def __init__(self, host_redirect: _Optional[str] = ..., https_redirect: bool = ..., path_redirect: _Optional[str] = ..., prefix_redirect: _Optional[str] = ..., redirect_response_code: _Optional[str] = ..., strip_query: bool = ...) -> None: ...

class HttpRetryPolicy(_message.Message):
    __slots__ = ("num_retries", "per_try_timeout", "retry_conditions")
    NUM_RETRIES_FIELD_NUMBER: _ClassVar[int]
    PER_TRY_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    RETRY_CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    num_retries: int
    per_try_timeout: Duration
    retry_conditions: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, num_retries: _Optional[int] = ..., per_try_timeout: _Optional[_Union[Duration, _Mapping]] = ..., retry_conditions: _Optional[_Iterable[str]] = ...) -> None: ...

class HttpRouteAction(_message.Message):
    __slots__ = ("cors_policy", "fault_injection_policy", "max_stream_duration", "request_mirror_policy", "retry_policy", "timeout", "url_rewrite", "weighted_backend_services")
    CORS_POLICY_FIELD_NUMBER: _ClassVar[int]
    FAULT_INJECTION_POLICY_FIELD_NUMBER: _ClassVar[int]
    MAX_STREAM_DURATION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_MIRROR_POLICY_FIELD_NUMBER: _ClassVar[int]
    RETRY_POLICY_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    URL_REWRITE_FIELD_NUMBER: _ClassVar[int]
    WEIGHTED_BACKEND_SERVICES_FIELD_NUMBER: _ClassVar[int]
    cors_policy: CorsPolicy
    fault_injection_policy: HttpFaultInjection
    max_stream_duration: Duration
    request_mirror_policy: RequestMirrorPolicy
    retry_policy: HttpRetryPolicy
    timeout: Duration
    url_rewrite: UrlRewrite
    weighted_backend_services: _containers.RepeatedCompositeFieldContainer[WeightedBackendService]
    def __init__(self, cors_policy: _Optional[_Union[CorsPolicy, _Mapping]] = ..., fault_injection_policy: _Optional[_Union[HttpFaultInjection, _Mapping]] = ..., max_stream_duration: _Optional[_Union[Duration, _Mapping]] = ..., request_mirror_policy: _Optional[_Union[RequestMirrorPolicy, _Mapping]] = ..., retry_policy: _Optional[_Union[HttpRetryPolicy, _Mapping]] = ..., timeout: _Optional[_Union[Duration, _Mapping]] = ..., url_rewrite: _Optional[_Union[UrlRewrite, _Mapping]] = ..., weighted_backend_services: _Optional[_Iterable[_Union[WeightedBackendService, _Mapping]]] = ...) -> None: ...

class HttpRouteRule(_message.Message):
    __slots__ = ("custom_error_response_policy", "description", "header_action", "match_rules", "priority", "route_action", "service", "url_redirect")
    CUSTOM_ERROR_RESPONSE_POLICY_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    HEADER_ACTION_FIELD_NUMBER: _ClassVar[int]
    MATCH_RULES_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    ROUTE_ACTION_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    URL_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    custom_error_response_policy: CustomErrorResponsePolicy
    description: str
    header_action: HttpHeaderAction
    match_rules: _containers.RepeatedCompositeFieldContainer[HttpRouteRuleMatch]
    priority: int
    route_action: HttpRouteAction
    service: str
    url_redirect: HttpRedirectAction
    def __init__(self, custom_error_response_policy: _Optional[_Union[CustomErrorResponsePolicy, _Mapping]] = ..., description: _Optional[str] = ..., header_action: _Optional[_Union[HttpHeaderAction, _Mapping]] = ..., match_rules: _Optional[_Iterable[_Union[HttpRouteRuleMatch, _Mapping]]] = ..., priority: _Optional[int] = ..., route_action: _Optional[_Union[HttpRouteAction, _Mapping]] = ..., service: _Optional[str] = ..., url_redirect: _Optional[_Union[HttpRedirectAction, _Mapping]] = ...) -> None: ...

class HttpRouteRuleMatch(_message.Message):
    __slots__ = ("full_path_match", "header_matches", "ignore_case", "metadata_filters", "path_template_match", "prefix_match", "query_parameter_matches", "regex_match")
    FULL_PATH_MATCH_FIELD_NUMBER: _ClassVar[int]
    HEADER_MATCHES_FIELD_NUMBER: _ClassVar[int]
    IGNORE_CASE_FIELD_NUMBER: _ClassVar[int]
    METADATA_FILTERS_FIELD_NUMBER: _ClassVar[int]
    PATH_TEMPLATE_MATCH_FIELD_NUMBER: _ClassVar[int]
    PREFIX_MATCH_FIELD_NUMBER: _ClassVar[int]
    QUERY_PARAMETER_MATCHES_FIELD_NUMBER: _ClassVar[int]
    REGEX_MATCH_FIELD_NUMBER: _ClassVar[int]
    full_path_match: str
    header_matches: _containers.RepeatedCompositeFieldContainer[HttpHeaderMatch]
    ignore_case: bool
    metadata_filters: _containers.RepeatedCompositeFieldContainer[MetadataFilter]
    path_template_match: str
    prefix_match: str
    query_parameter_matches: _containers.RepeatedCompositeFieldContainer[HttpQueryParameterMatch]
    regex_match: str
    def __init__(self, full_path_match: _Optional[str] = ..., header_matches: _Optional[_Iterable[_Union[HttpHeaderMatch, _Mapping]]] = ..., ignore_case: bool = ..., metadata_filters: _Optional[_Iterable[_Union[MetadataFilter, _Mapping]]] = ..., path_template_match: _Optional[str] = ..., prefix_match: _Optional[str] = ..., query_parameter_matches: _Optional[_Iterable[_Union[HttpQueryParameterMatch, _Mapping]]] = ..., regex_match: _Optional[str] = ...) -> None: ...

class Image(_message.Message):
    __slots__ = ("architecture", "archive_size_bytes", "creation_timestamp", "deprecated", "description", "disk_size_gb", "enable_confidential_compute", "family", "guest_os_features", "id", "image_encryption_key", "kind", "label_fingerprint", "labels", "license_codes", "licenses", "name", "raw_disk", "satisfies_pzi", "satisfies_pzs", "self_link", "shielded_instance_initial_state", "source_disk", "source_disk_encryption_key", "source_disk_id", "source_image", "source_image_encryption_key", "source_image_id", "source_snapshot", "source_snapshot_encryption_key", "source_snapshot_id", "source_type", "status", "storage_locations")
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[Image.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[Image.Architecture]
        ARM64: _ClassVar[Image.Architecture]
        X86_64: _ClassVar[Image.Architecture]
    UNDEFINED_ARCHITECTURE: Image.Architecture
    ARCHITECTURE_UNSPECIFIED: Image.Architecture
    ARM64: Image.Architecture
    X86_64: Image.Architecture
    class SourceType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SOURCE_TYPE: _ClassVar[Image.SourceType]
        RAW: _ClassVar[Image.SourceType]
    UNDEFINED_SOURCE_TYPE: Image.SourceType
    RAW: Image.SourceType
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Image.Status]
        DELETING: _ClassVar[Image.Status]
        FAILED: _ClassVar[Image.Status]
        PENDING: _ClassVar[Image.Status]
        READY: _ClassVar[Image.Status]
    UNDEFINED_STATUS: Image.Status
    DELETING: Image.Status
    FAILED: Image.Status
    PENDING: Image.Status
    READY: Image.Status
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    ARCHIVE_SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    ENABLE_CONFIDENTIAL_COMPUTE_FIELD_NUMBER: _ClassVar[int]
    FAMILY_FIELD_NUMBER: _ClassVar[int]
    GUEST_OS_FEATURES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IMAGE_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LICENSE_CODES_FIELD_NUMBER: _ClassVar[int]
    LICENSES_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    RAW_DISK_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZI_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SHIELDED_INSTANCE_INITIAL_STATE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    architecture: str
    archive_size_bytes: int
    creation_timestamp: str
    deprecated: DeprecationStatus
    description: str
    disk_size_gb: int
    enable_confidential_compute: bool
    family: str
    guest_os_features: _containers.RepeatedCompositeFieldContainer[GuestOsFeature]
    id: int
    image_encryption_key: CustomerEncryptionKey
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    license_codes: _containers.RepeatedScalarFieldContainer[int]
    licenses: _containers.RepeatedScalarFieldContainer[str]
    name: str
    raw_disk: RawDisk
    satisfies_pzi: bool
    satisfies_pzs: bool
    self_link: str
    shielded_instance_initial_state: InitialStateConfig
    source_disk: str
    source_disk_encryption_key: CustomerEncryptionKey
    source_disk_id: str
    source_image: str
    source_image_encryption_key: CustomerEncryptionKey
    source_image_id: str
    source_snapshot: str
    source_snapshot_encryption_key: CustomerEncryptionKey
    source_snapshot_id: str
    source_type: str
    status: str
    storage_locations: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, architecture: _Optional[str] = ..., archive_size_bytes: _Optional[int] = ..., creation_timestamp: _Optional[str] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., disk_size_gb: _Optional[int] = ..., enable_confidential_compute: bool = ..., family: _Optional[str] = ..., guest_os_features: _Optional[_Iterable[_Union[GuestOsFeature, _Mapping]]] = ..., id: _Optional[int] = ..., image_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., license_codes: _Optional[_Iterable[int]] = ..., licenses: _Optional[_Iterable[str]] = ..., name: _Optional[str] = ..., raw_disk: _Optional[_Union[RawDisk, _Mapping]] = ..., satisfies_pzi: bool = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., shielded_instance_initial_state: _Optional[_Union[InitialStateConfig, _Mapping]] = ..., source_disk: _Optional[str] = ..., source_disk_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_disk_id: _Optional[str] = ..., source_image: _Optional[str] = ..., source_image_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_image_id: _Optional[str] = ..., source_snapshot: _Optional[str] = ..., source_snapshot_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_snapshot_id: _Optional[str] = ..., source_type: _Optional[str] = ..., status: _Optional[str] = ..., storage_locations: _Optional[_Iterable[str]] = ...) -> None: ...

class ImageFamilyView(_message.Message):
    __slots__ = ("image",)
    IMAGE_FIELD_NUMBER: _ClassVar[int]
    image: Image
    def __init__(self, image: _Optional[_Union[Image, _Mapping]] = ...) -> None: ...

class ImageList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Image]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Image, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InitialStateConfig(_message.Message):
    __slots__ = ("dbs", "dbxs", "keks", "pk")
    DBS_FIELD_NUMBER: _ClassVar[int]
    DBXS_FIELD_NUMBER: _ClassVar[int]
    KEKS_FIELD_NUMBER: _ClassVar[int]
    PK_FIELD_NUMBER: _ClassVar[int]
    dbs: _containers.RepeatedCompositeFieldContainer[FileContentBuffer]
    dbxs: _containers.RepeatedCompositeFieldContainer[FileContentBuffer]
    keks: _containers.RepeatedCompositeFieldContainer[FileContentBuffer]
    pk: FileContentBuffer
    def __init__(self, dbs: _Optional[_Iterable[_Union[FileContentBuffer, _Mapping]]] = ..., dbxs: _Optional[_Iterable[_Union[FileContentBuffer, _Mapping]]] = ..., keks: _Optional[_Iterable[_Union[FileContentBuffer, _Mapping]]] = ..., pk: _Optional[_Union[FileContentBuffer, _Mapping]] = ...) -> None: ...

class InsertAddressRequest(_message.Message):
    __slots__ = ("address_resource", "project", "region", "request_id")
    ADDRESS_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    address_resource: Address
    project: str
    region: str
    request_id: str
    def __init__(self, address_resource: _Optional[_Union[Address, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler_resource", "project", "request_id", "zone")
    AUTOSCALER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    autoscaler_resource: Autoscaler
    project: str
    request_id: str
    zone: str
    def __init__(self, autoscaler_resource: _Optional[_Union[Autoscaler, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket_resource", "project", "request_id")
    BACKEND_BUCKET_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_bucket_resource: BackendBucket
    project: str
    request_id: str
    def __init__(self, backend_bucket_resource: _Optional[_Union[BackendBucket, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service_resource", "project", "request_id")
    BACKEND_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service_resource: BackendService
    project: str
    request_id: str
    def __init__(self, backend_service_resource: _Optional[_Union[BackendService, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertDiskRequest(_message.Message):
    __slots__ = ("disk_resource", "project", "request_id", "source_image", "zone")
    DISK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk_resource: Disk
    project: str
    request_id: str
    source_image: str
    zone: str
    def __init__(self, disk_resource: _Optional[_Union[Disk, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., source_image: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertExternalVpnGatewayRequest(_message.Message):
    __slots__ = ("external_vpn_gateway_resource", "project", "request_id")
    EXTERNAL_VPN_GATEWAY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    external_vpn_gateway_resource: ExternalVpnGateway
    project: str
    request_id: str
    def __init__(self, external_vpn_gateway_resource: _Optional[_Union[ExternalVpnGateway, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy_resource", "parent_id", "request_id")
    FIREWALL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PARENT_ID_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy_resource: FirewallPolicy
    parent_id: str
    request_id: str
    def __init__(self, firewall_policy_resource: _Optional[_Union[FirewallPolicy, _Mapping]] = ..., parent_id: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertFirewallRequest(_message.Message):
    __slots__ = ("firewall_resource", "project", "request_id")
    FIREWALL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_resource: Firewall
    project: str
    request_id: str
    def __init__(self, firewall_resource: _Optional[_Union[Firewall, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule_resource", "project", "region", "request_id")
    FORWARDING_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule_resource: ForwardingRule
    project: str
    region: str
    request_id: str
    def __init__(self, forwarding_rule_resource: _Optional[_Union[ForwardingRule, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertGlobalAddressRequest(_message.Message):
    __slots__ = ("address_resource", "project", "request_id")
    ADDRESS_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    address_resource: Address
    project: str
    request_id: str
    def __init__(self, address_resource: _Optional[_Union[Address, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertGlobalForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule_resource", "project", "request_id")
    FORWARDING_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule_resource: ForwardingRule
    project: str
    request_id: str
    def __init__(self, forwarding_rule_resource: _Optional[_Union[ForwardingRule, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertGlobalNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group_resource", "project", "request_id")
    NETWORK_ENDPOINT_GROUP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group_resource: NetworkEndpointGroup
    project: str
    request_id: str
    def __init__(self, network_endpoint_group_resource: _Optional[_Union[NetworkEndpointGroup, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertGlobalPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix_resource: PublicDelegatedPrefix
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix_resource: _Optional[_Union[PublicDelegatedPrefix, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertHealthCheckRequest(_message.Message):
    __slots__ = ("health_check_resource", "project", "request_id")
    HEALTH_CHECK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check_resource: HealthCheck
    project: str
    request_id: str
    def __init__(self, health_check_resource: _Optional[_Union[HealthCheck, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertImageRequest(_message.Message):
    __slots__ = ("force_create", "image_resource", "project", "request_id")
    FORCE_CREATE_FIELD_NUMBER: _ClassVar[int]
    IMAGE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    force_create: bool
    image_resource: Image
    project: str
    request_id: str
    def __init__(self, force_create: bool = ..., image_resource: _Optional[_Union[Image, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager_resource: InstanceGroupManager
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager_resource: _Optional[_Union[InstanceGroupManager, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertInstanceGroupManagerResizeRequestRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_manager_resize_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_RESIZE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_manager_resize_request_resource: InstanceGroupManagerResizeRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_manager_resize_request_resource: _Optional[_Union[InstanceGroupManagerResizeRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_resource: InstanceGroup
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_resource: _Optional[_Union[InstanceGroup, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertInstanceRequest(_message.Message):
    __slots__ = ("instance_resource", "project", "request_id", "source_instance_template", "source_machine_image", "zone")
    INSTANCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_MACHINE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_resource: Instance
    project: str
    request_id: str
    source_instance_template: str
    source_machine_image: str
    zone: str
    def __init__(self, instance_resource: _Optional[_Union[Instance, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., source_instance_template: _Optional[str] = ..., source_machine_image: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertInstanceTemplateRequest(_message.Message):
    __slots__ = ("instance_template_resource", "project", "request_id")
    INSTANCE_TEMPLATE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_template_resource: InstanceTemplate
    project: str
    request_id: str
    def __init__(self, instance_template_resource: _Optional[_Union[InstanceTemplate, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertInstantSnapshotRequest(_message.Message):
    __slots__ = ("instant_snapshot_resource", "project", "request_id", "zone")
    INSTANT_SNAPSHOT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instant_snapshot_resource: InstantSnapshot
    project: str
    request_id: str
    zone: str
    def __init__(self, instant_snapshot_resource: _Optional[_Union[InstantSnapshot, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertInterconnectAttachmentRequest(_message.Message):
    __slots__ = ("interconnect_attachment_resource", "project", "region", "request_id", "validate_only")
    INTERCONNECT_ATTACHMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    interconnect_attachment_resource: InterconnectAttachment
    project: str
    region: str
    request_id: str
    validate_only: bool
    def __init__(self, interconnect_attachment_resource: _Optional[_Union[InterconnectAttachment, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., validate_only: bool = ...) -> None: ...

class InsertInterconnectRequest(_message.Message):
    __slots__ = ("interconnect_resource", "project", "request_id")
    INTERCONNECT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    interconnect_resource: Interconnect
    project: str
    request_id: str
    def __init__(self, interconnect_resource: _Optional[_Union[Interconnect, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertLicenseRequest(_message.Message):
    __slots__ = ("license_resource", "project", "request_id")
    LICENSE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    license_resource: License
    project: str
    request_id: str
    def __init__(self, license_resource: _Optional[_Union[License, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertMachineImageRequest(_message.Message):
    __slots__ = ("machine_image_resource", "project", "request_id", "source_instance")
    MACHINE_IMAGE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    machine_image_resource: MachineImage
    project: str
    request_id: str
    source_instance: str
    def __init__(self, machine_image_resource: _Optional[_Union[MachineImage, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., source_instance: _Optional[str] = ...) -> None: ...

class InsertNetworkAttachmentRequest(_message.Message):
    __slots__ = ("network_attachment_resource", "project", "region", "request_id")
    NETWORK_ATTACHMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_attachment_resource: NetworkAttachment
    project: str
    region: str
    request_id: str
    def __init__(self, network_attachment_resource: _Optional[_Union[NetworkAttachment, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertNetworkEdgeSecurityServiceRequest(_message.Message):
    __slots__ = ("network_edge_security_service_resource", "project", "region", "request_id", "validate_only")
    NETWORK_EDGE_SECURITY_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    network_edge_security_service_resource: NetworkEdgeSecurityService
    project: str
    region: str
    request_id: str
    validate_only: bool
    def __init__(self, network_edge_security_service_resource: _Optional[_Union[NetworkEdgeSecurityService, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., validate_only: bool = ...) -> None: ...

class InsertNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group_resource", "project", "request_id", "zone")
    NETWORK_ENDPOINT_GROUP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group_resource: NetworkEndpointGroup
    project: str
    request_id: str
    zone: str
    def __init__(self, network_endpoint_group_resource: _Optional[_Union[NetworkEndpointGroup, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy_resource", "project", "request_id")
    FIREWALL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy_resource: FirewallPolicy
    project: str
    request_id: str
    def __init__(self, firewall_policy_resource: _Optional[_Union[FirewallPolicy, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertNetworkRequest(_message.Message):
    __slots__ = ("network_resource", "project", "request_id")
    NETWORK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_resource: Network
    project: str
    request_id: str
    def __init__(self, network_resource: _Optional[_Union[Network, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertNodeGroupRequest(_message.Message):
    __slots__ = ("initial_node_count", "node_group_resource", "project", "request_id", "zone")
    INITIAL_NODE_COUNT_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    initial_node_count: int
    node_group_resource: NodeGroup
    project: str
    request_id: str
    zone: str
    def __init__(self, initial_node_count: _Optional[int] = ..., node_group_resource: _Optional[_Union[NodeGroup, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertNodeTemplateRequest(_message.Message):
    __slots__ = ("node_template_resource", "project", "region", "request_id")
    NODE_TEMPLATE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    node_template_resource: NodeTemplate
    project: str
    region: str
    request_id: str
    def __init__(self, node_template_resource: _Optional[_Union[NodeTemplate, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertPacketMirroringRequest(_message.Message):
    __slots__ = ("packet_mirroring_resource", "project", "region", "request_id")
    PACKET_MIRRORING_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    packet_mirroring_resource: PacketMirroring
    project: str
    region: str
    request_id: str
    def __init__(self, packet_mirroring_resource: _Optional[_Union[PacketMirroring, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertPublicAdvertisedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_advertised_prefix_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_ADVERTISED_PREFIX_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_advertised_prefix_resource: PublicAdvertisedPrefix
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_advertised_prefix_resource: _Optional[_Union[PublicAdvertisedPrefix, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix_resource", "region", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix_resource: PublicDelegatedPrefix
    region: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix_resource: _Optional[_Union[PublicDelegatedPrefix, _Mapping]] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler_resource", "project", "region", "request_id")
    AUTOSCALER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    autoscaler_resource: Autoscaler
    project: str
    region: str
    request_id: str
    def __init__(self, autoscaler_resource: _Optional[_Union[Autoscaler, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service_resource", "project", "region", "request_id")
    BACKEND_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service_resource: BackendService
    project: str
    region: str
    request_id: str
    def __init__(self, backend_service_resource: _Optional[_Union[BackendService, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionCommitmentRequest(_message.Message):
    __slots__ = ("commitment_resource", "project", "region", "request_id")
    COMMITMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    commitment_resource: Commitment
    project: str
    region: str
    request_id: str
    def __init__(self, commitment_resource: _Optional[_Union[Commitment, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionDiskRequest(_message.Message):
    __slots__ = ("disk_resource", "project", "region", "request_id", "source_image")
    DISK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    disk_resource: Disk
    project: str
    region: str
    request_id: str
    source_image: str
    def __init__(self, disk_resource: _Optional[_Union[Disk, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., source_image: _Optional[str] = ...) -> None: ...

class InsertRegionHealthCheckRequest(_message.Message):
    __slots__ = ("health_check_resource", "project", "region", "request_id")
    HEALTH_CHECK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check_resource: HealthCheck
    project: str
    region: str
    request_id: str
    def __init__(self, health_check_resource: _Optional[_Union[HealthCheck, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionHealthCheckServiceRequest(_message.Message):
    __slots__ = ("health_check_service_resource", "project", "region", "request_id")
    HEALTH_CHECK_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check_service_resource: HealthCheckService
    project: str
    region: str
    request_id: str
    def __init__(self, health_check_service_resource: _Optional[_Union[HealthCheckService, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager_resource", "project", "region", "request_id")
    INSTANCE_GROUP_MANAGER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager_resource: InstanceGroupManager
    project: str
    region: str
    request_id: str
    def __init__(self, instance_group_manager_resource: _Optional[_Union[InstanceGroupManager, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionInstanceTemplateRequest(_message.Message):
    __slots__ = ("instance_template_resource", "project", "region", "request_id")
    INSTANCE_TEMPLATE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_template_resource: InstanceTemplate
    project: str
    region: str
    request_id: str
    def __init__(self, instance_template_resource: _Optional[_Union[InstanceTemplate, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionInstantSnapshotRequest(_message.Message):
    __slots__ = ("instant_snapshot_resource", "project", "region", "request_id")
    INSTANT_SNAPSHOT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instant_snapshot_resource: InstantSnapshot
    project: str
    region: str
    request_id: str
    def __init__(self, instant_snapshot_resource: _Optional[_Union[InstantSnapshot, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("network_endpoint_group_resource", "project", "region", "request_id")
    NETWORK_ENDPOINT_GROUP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_group_resource: NetworkEndpointGroup
    project: str
    region: str
    request_id: str
    def __init__(self, network_endpoint_group_resource: _Optional[_Union[NetworkEndpointGroup, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy_resource", "project", "region", "request_id")
    FIREWALL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy_resource: FirewallPolicy
    project: str
    region: str
    request_id: str
    def __init__(self, firewall_policy_resource: _Optional[_Union[FirewallPolicy, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionNotificationEndpointRequest(_message.Message):
    __slots__ = ("notification_endpoint_resource", "project", "region", "request_id")
    NOTIFICATION_ENDPOINT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    notification_endpoint_resource: NotificationEndpoint
    project: str
    region: str
    request_id: str
    def __init__(self, notification_endpoint_resource: _Optional[_Union[NotificationEndpoint, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class InsertRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "security_policy_resource", "validate_only")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    security_policy_resource: SecurityPolicy
    validate_only: bool
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_resource: _Optional[_Union[SecurityPolicy, _Mapping]] = ..., validate_only: bool = ...) -> None: ...

class InsertRegionSslCertificateRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "ssl_certificate_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    ssl_certificate_resource: SslCertificate
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_certificate_resource: _Optional[_Union[SslCertificate, _Mapping]] = ...) -> None: ...

class InsertRegionSslPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "ssl_policy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    ssl_policy_resource: SslPolicy
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy_resource: _Optional[_Union[SslPolicy, _Mapping]] = ...) -> None: ...

class InsertRegionTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_http_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_http_proxy_resource: TargetHttpProxy
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_http_proxy_resource: _Optional[_Union[TargetHttpProxy, _Mapping]] = ...) -> None: ...

class InsertRegionTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_https_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_https_proxy_resource: TargetHttpsProxy
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy_resource: _Optional[_Union[TargetHttpsProxy, _Mapping]] = ...) -> None: ...

class InsertRegionTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_tcp_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_tcp_proxy_resource: TargetTcpProxy
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_tcp_proxy_resource: _Optional[_Union[TargetTcpProxy, _Mapping]] = ...) -> None: ...

class InsertRegionUrlMapRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "url_map_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    url_map_resource: UrlMap
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map_resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class InsertReservationRequest(_message.Message):
    __slots__ = ("project", "request_id", "reservation_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    reservation_resource: Reservation
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., reservation_resource: _Optional[_Union[Reservation, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertResourcePolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "resource_policy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    resource_policy_resource: ResourcePolicy
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., resource_policy_resource: _Optional[_Union[ResourcePolicy, _Mapping]] = ...) -> None: ...

class InsertRouteRequest(_message.Message):
    __slots__ = ("project", "request_id", "route_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ROUTE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    route_resource: Route
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., route_resource: _Optional[_Union[Route, _Mapping]] = ...) -> None: ...

class InsertRouterRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "router_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ROUTER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    router_resource: Router
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., router_resource: _Optional[_Union[Router, _Mapping]] = ...) -> None: ...

class InsertSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "request_id", "security_policy_resource", "validate_only")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    security_policy_resource: SecurityPolicy
    validate_only: bool
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_resource: _Optional[_Union[SecurityPolicy, _Mapping]] = ..., validate_only: bool = ...) -> None: ...

class InsertServiceAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "service_attachment_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ATTACHMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    service_attachment_resource: ServiceAttachment
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., service_attachment_resource: _Optional[_Union[ServiceAttachment, _Mapping]] = ...) -> None: ...

class InsertSnapshotRequest(_message.Message):
    __slots__ = ("project", "request_id", "snapshot_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    snapshot_resource: Snapshot
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., snapshot_resource: _Optional[_Union[Snapshot, _Mapping]] = ...) -> None: ...

class InsertSslCertificateRequest(_message.Message):
    __slots__ = ("project", "request_id", "ssl_certificate_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    ssl_certificate_resource: SslCertificate
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_certificate_resource: _Optional[_Union[SslCertificate, _Mapping]] = ...) -> None: ...

class InsertSslPolicyRequest(_message.Message):
    __slots__ = ("project", "request_id", "ssl_policy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    ssl_policy_resource: SslPolicy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy_resource: _Optional[_Union[SslPolicy, _Mapping]] = ...) -> None: ...

class InsertStoragePoolRequest(_message.Message):
    __slots__ = ("project", "request_id", "storage_pool_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    storage_pool_resource: StoragePool
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., storage_pool_resource: _Optional[_Union[StoragePool, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertSubnetworkRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "subnetwork_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    subnetwork_resource: Subnetwork
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., subnetwork_resource: _Optional[_Union[Subnetwork, _Mapping]] = ...) -> None: ...

class InsertTargetGrpcProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_grpc_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_GRPC_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_grpc_proxy_resource: TargetGrpcProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_grpc_proxy_resource: _Optional[_Union[TargetGrpcProxy, _Mapping]] = ...) -> None: ...

class InsertTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_http_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_http_proxy_resource: TargetHttpProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_http_proxy_resource: _Optional[_Union[TargetHttpProxy, _Mapping]] = ...) -> None: ...

class InsertTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_https_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_https_proxy_resource: TargetHttpsProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy_resource: _Optional[_Union[TargetHttpsProxy, _Mapping]] = ...) -> None: ...

class InsertTargetInstanceRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_instance_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_INSTANCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_instance_resource: TargetInstance
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_instance_resource: _Optional[_Union[TargetInstance, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class InsertTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_pool_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_pool_resource: TargetPool
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_pool_resource: _Optional[_Union[TargetPool, _Mapping]] = ...) -> None: ...

class InsertTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_ssl_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_ssl_proxy_resource: TargetSslProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_ssl_proxy_resource: _Optional[_Union[TargetSslProxy, _Mapping]] = ...) -> None: ...

class InsertTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_tcp_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_tcp_proxy_resource: TargetTcpProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_tcp_proxy_resource: _Optional[_Union[TargetTcpProxy, _Mapping]] = ...) -> None: ...

class InsertTargetVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_vpn_gateway_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_VPN_GATEWAY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_vpn_gateway_resource: TargetVpnGateway
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_vpn_gateway_resource: _Optional[_Union[TargetVpnGateway, _Mapping]] = ...) -> None: ...

class InsertUrlMapRequest(_message.Message):
    __slots__ = ("project", "request_id", "url_map_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    url_map_resource: UrlMap
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map_resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class InsertVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "vpn_gateway_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    VPN_GATEWAY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    vpn_gateway_resource: VpnGateway
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., vpn_gateway_resource: _Optional[_Union[VpnGateway, _Mapping]] = ...) -> None: ...

class InsertVpnTunnelRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "vpn_tunnel_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    VPN_TUNNEL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    vpn_tunnel_resource: VpnTunnel
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., vpn_tunnel_resource: _Optional[_Union[VpnTunnel, _Mapping]] = ...) -> None: ...

class Instance(_message.Message):
    __slots__ = ("advanced_machine_features", "can_ip_forward", "confidential_instance_config", "cpu_platform", "creation_timestamp", "deletion_protection", "description", "disks", "display_device", "fingerprint", "guest_accelerators", "hostname", "id", "instance_encryption_key", "key_revocation_action_type", "kind", "label_fingerprint", "labels", "last_start_timestamp", "last_stop_timestamp", "last_suspended_timestamp", "machine_type", "metadata", "min_cpu_platform", "name", "network_interfaces", "network_performance_config", "params", "private_ipv6_google_access", "reservation_affinity", "resource_policies", "resource_status", "satisfies_pzi", "satisfies_pzs", "scheduling", "self_link", "service_accounts", "shielded_instance_config", "shielded_instance_integrity_policy", "source_machine_image", "source_machine_image_encryption_key", "start_restricted", "status", "status_message", "tags", "zone")
    class KeyRevocationActionType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_KEY_REVOCATION_ACTION_TYPE: _ClassVar[Instance.KeyRevocationActionType]
        KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED: _ClassVar[Instance.KeyRevocationActionType]
        NONE: _ClassVar[Instance.KeyRevocationActionType]
        STOP: _ClassVar[Instance.KeyRevocationActionType]
    UNDEFINED_KEY_REVOCATION_ACTION_TYPE: Instance.KeyRevocationActionType
    KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED: Instance.KeyRevocationActionType
    NONE: Instance.KeyRevocationActionType
    STOP: Instance.KeyRevocationActionType
    class PrivateIpv6GoogleAccess(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS: _ClassVar[Instance.PrivateIpv6GoogleAccess]
        ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE: _ClassVar[Instance.PrivateIpv6GoogleAccess]
        ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE: _ClassVar[Instance.PrivateIpv6GoogleAccess]
        INHERIT_FROM_SUBNETWORK: _ClassVar[Instance.PrivateIpv6GoogleAccess]
    UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS: Instance.PrivateIpv6GoogleAccess
    ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE: Instance.PrivateIpv6GoogleAccess
    ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE: Instance.PrivateIpv6GoogleAccess
    INHERIT_FROM_SUBNETWORK: Instance.PrivateIpv6GoogleAccess
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Instance.Status]
        DEPROVISIONING: _ClassVar[Instance.Status]
        PROVISIONING: _ClassVar[Instance.Status]
        REPAIRING: _ClassVar[Instance.Status]
        RUNNING: _ClassVar[Instance.Status]
        STAGING: _ClassVar[Instance.Status]
        STOPPED: _ClassVar[Instance.Status]
        STOPPING: _ClassVar[Instance.Status]
        SUSPENDED: _ClassVar[Instance.Status]
        SUSPENDING: _ClassVar[Instance.Status]
        TERMINATED: _ClassVar[Instance.Status]
    UNDEFINED_STATUS: Instance.Status
    DEPROVISIONING: Instance.Status
    PROVISIONING: Instance.Status
    REPAIRING: Instance.Status
    RUNNING: Instance.Status
    STAGING: Instance.Status
    STOPPED: Instance.Status
    STOPPING: Instance.Status
    SUSPENDED: Instance.Status
    SUSPENDING: Instance.Status
    TERMINATED: Instance.Status
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ADVANCED_MACHINE_FEATURES_FIELD_NUMBER: _ClassVar[int]
    CAN_IP_FORWARD_FIELD_NUMBER: _ClassVar[int]
    CONFIDENTIAL_INSTANCE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DELETION_PROTECTION_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISKS_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_DEVICE_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    GUEST_ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    KEY_REVOCATION_ACTION_TYPE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LAST_START_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    LAST_STOP_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    LAST_SUSPENDED_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    MIN_CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACES_FIELD_NUMBER: _ClassVar[int]
    NETWORK_PERFORMANCE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    PARAMS_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_IPV6_GOOGLE_ACCESS_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_AFFINITY_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZI_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
    SHIELDED_INSTANCE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    SHIELDED_INSTANCE_INTEGRITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_MACHINE_IMAGE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_MACHINE_IMAGE_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    START_RESTRICTED_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STATUS_MESSAGE_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    advanced_machine_features: AdvancedMachineFeatures
    can_ip_forward: bool
    confidential_instance_config: ConfidentialInstanceConfig
    cpu_platform: str
    creation_timestamp: str
    deletion_protection: bool
    description: str
    disks: _containers.RepeatedCompositeFieldContainer[AttachedDisk]
    display_device: DisplayDevice
    fingerprint: str
    guest_accelerators: _containers.RepeatedCompositeFieldContainer[AcceleratorConfig]
    hostname: str
    id: int
    instance_encryption_key: CustomerEncryptionKey
    key_revocation_action_type: str
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    last_start_timestamp: str
    last_stop_timestamp: str
    last_suspended_timestamp: str
    machine_type: str
    metadata: Metadata
    min_cpu_platform: str
    name: str
    network_interfaces: _containers.RepeatedCompositeFieldContainer[NetworkInterface]
    network_performance_config: NetworkPerformanceConfig
    params: InstanceParams
    private_ipv6_google_access: str
    reservation_affinity: ReservationAffinity
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    resource_status: ResourceStatus
    satisfies_pzi: bool
    satisfies_pzs: bool
    scheduling: Scheduling
    self_link: str
    service_accounts: _containers.RepeatedCompositeFieldContainer[ServiceAccount]
    shielded_instance_config: ShieldedInstanceConfig
    shielded_instance_integrity_policy: ShieldedInstanceIntegrityPolicy
    source_machine_image: str
    source_machine_image_encryption_key: CustomerEncryptionKey
    start_restricted: bool
    status: str
    status_message: str
    tags: Tags
    zone: str
    def __init__(self, advanced_machine_features: _Optional[_Union[AdvancedMachineFeatures, _Mapping]] = ..., can_ip_forward: bool = ..., confidential_instance_config: _Optional[_Union[ConfidentialInstanceConfig, _Mapping]] = ..., cpu_platform: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., deletion_protection: bool = ..., description: _Optional[str] = ..., disks: _Optional[_Iterable[_Union[AttachedDisk, _Mapping]]] = ..., display_device: _Optional[_Union[DisplayDevice, _Mapping]] = ..., fingerprint: _Optional[str] = ..., guest_accelerators: _Optional[_Iterable[_Union[AcceleratorConfig, _Mapping]]] = ..., hostname: _Optional[str] = ..., id: _Optional[int] = ..., instance_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., key_revocation_action_type: _Optional[str] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., last_start_timestamp: _Optional[str] = ..., last_stop_timestamp: _Optional[str] = ..., last_suspended_timestamp: _Optional[str] = ..., machine_type: _Optional[str] = ..., metadata: _Optional[_Union[Metadata, _Mapping]] = ..., min_cpu_platform: _Optional[str] = ..., name: _Optional[str] = ..., network_interfaces: _Optional[_Iterable[_Union[NetworkInterface, _Mapping]]] = ..., network_performance_config: _Optional[_Union[NetworkPerformanceConfig, _Mapping]] = ..., params: _Optional[_Union[InstanceParams, _Mapping]] = ..., private_ipv6_google_access: _Optional[str] = ..., reservation_affinity: _Optional[_Union[ReservationAffinity, _Mapping]] = ..., resource_policies: _Optional[_Iterable[str]] = ..., resource_status: _Optional[_Union[ResourceStatus, _Mapping]] = ..., satisfies_pzi: bool = ..., satisfies_pzs: bool = ..., scheduling: _Optional[_Union[Scheduling, _Mapping]] = ..., self_link: _Optional[str] = ..., service_accounts: _Optional[_Iterable[_Union[ServiceAccount, _Mapping]]] = ..., shielded_instance_config: _Optional[_Union[ShieldedInstanceConfig, _Mapping]] = ..., shielded_instance_integrity_policy: _Optional[_Union[ShieldedInstanceIntegrityPolicy, _Mapping]] = ..., source_machine_image: _Optional[str] = ..., source_machine_image_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., start_restricted: bool = ..., status: _Optional[str] = ..., status_message: _Optional[str] = ..., tags: _Optional[_Union[Tags, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class InstanceAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: InstancesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InstancesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, InstancesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, InstancesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceConsumptionData(_message.Message):
    __slots__ = ("consumption_info", "instance")
    CONSUMPTION_INFO_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    consumption_info: InstanceConsumptionInfo
    instance: str
    def __init__(self, consumption_info: _Optional[_Union[InstanceConsumptionInfo, _Mapping]] = ..., instance: _Optional[str] = ...) -> None: ...

class InstanceConsumptionInfo(_message.Message):
    __slots__ = ("guest_cpus", "local_ssd_gb", "memory_mb", "min_node_cpus")
    GUEST_CPUS_FIELD_NUMBER: _ClassVar[int]
    LOCAL_SSD_GB_FIELD_NUMBER: _ClassVar[int]
    MEMORY_MB_FIELD_NUMBER: _ClassVar[int]
    MIN_NODE_CPUS_FIELD_NUMBER: _ClassVar[int]
    guest_cpus: int
    local_ssd_gb: int
    memory_mb: int
    min_node_cpus: int
    def __init__(self, guest_cpus: _Optional[int] = ..., local_ssd_gb: _Optional[int] = ..., memory_mb: _Optional[int] = ..., min_node_cpus: _Optional[int] = ...) -> None: ...

class InstanceGroup(_message.Message):
    __slots__ = ("creation_timestamp", "description", "fingerprint", "id", "kind", "name", "named_ports", "network", "region", "self_link", "size", "subnetwork", "zone")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NAMED_PORTS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    fingerprint: str
    id: int
    kind: str
    name: str
    named_ports: _containers.RepeatedCompositeFieldContainer[NamedPort]
    network: str
    region: str
    self_link: str
    size: int
    subnetwork: str
    zone: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., named_ports: _Optional[_Iterable[_Union[NamedPort, _Mapping]]] = ..., network: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., size: _Optional[int] = ..., subnetwork: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InstanceGroupAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: InstanceGroupsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InstanceGroupsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, InstanceGroupsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, InstanceGroupsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceGroup]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceGroup, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupManager(_message.Message):
    __slots__ = ("all_instances_config", "auto_healing_policies", "base_instance_name", "creation_timestamp", "current_actions", "description", "distribution_policy", "fingerprint", "id", "instance_flexibility_policy", "instance_group", "instance_lifecycle_policy", "instance_template", "kind", "list_managed_instances_results", "name", "named_ports", "region", "satisfies_pzi", "satisfies_pzs", "self_link", "standby_policy", "stateful_policy", "status", "target_pools", "target_size", "target_stopped_size", "target_suspended_size", "update_policy", "versions", "zone")
    class ListManagedInstancesResults(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LIST_MANAGED_INSTANCES_RESULTS: _ClassVar[InstanceGroupManager.ListManagedInstancesResults]
        PAGELESS: _ClassVar[InstanceGroupManager.ListManagedInstancesResults]
        PAGINATED: _ClassVar[InstanceGroupManager.ListManagedInstancesResults]
    UNDEFINED_LIST_MANAGED_INSTANCES_RESULTS: InstanceGroupManager.ListManagedInstancesResults
    PAGELESS: InstanceGroupManager.ListManagedInstancesResults
    PAGINATED: InstanceGroupManager.ListManagedInstancesResults
    ALL_INSTANCES_CONFIG_FIELD_NUMBER: _ClassVar[int]
    AUTO_HEALING_POLICIES_FIELD_NUMBER: _ClassVar[int]
    BASE_INSTANCE_NAME_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CURRENT_ACTIONS_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISTRIBUTION_POLICY_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FLEXIBILITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_LIFECYCLE_POLICY_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LIST_MANAGED_INSTANCES_RESULTS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NAMED_PORTS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZI_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STANDBY_POLICY_FIELD_NUMBER: _ClassVar[int]
    STATEFUL_POLICY_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOLS_FIELD_NUMBER: _ClassVar[int]
    TARGET_SIZE_FIELD_NUMBER: _ClassVar[int]
    TARGET_STOPPED_SIZE_FIELD_NUMBER: _ClassVar[int]
    TARGET_SUSPENDED_SIZE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_POLICY_FIELD_NUMBER: _ClassVar[int]
    VERSIONS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    all_instances_config: InstanceGroupManagerAllInstancesConfig
    auto_healing_policies: _containers.RepeatedCompositeFieldContainer[InstanceGroupManagerAutoHealingPolicy]
    base_instance_name: str
    creation_timestamp: str
    current_actions: InstanceGroupManagerActionsSummary
    description: str
    distribution_policy: DistributionPolicy
    fingerprint: str
    id: int
    instance_flexibility_policy: InstanceGroupManagerInstanceFlexibilityPolicy
    instance_group: str
    instance_lifecycle_policy: InstanceGroupManagerInstanceLifecyclePolicy
    instance_template: str
    kind: str
    list_managed_instances_results: str
    name: str
    named_ports: _containers.RepeatedCompositeFieldContainer[NamedPort]
    region: str
    satisfies_pzi: bool
    satisfies_pzs: bool
    self_link: str
    standby_policy: InstanceGroupManagerStandbyPolicy
    stateful_policy: StatefulPolicy
    status: InstanceGroupManagerStatus
    target_pools: _containers.RepeatedScalarFieldContainer[str]
    target_size: int
    target_stopped_size: int
    target_suspended_size: int
    update_policy: InstanceGroupManagerUpdatePolicy
    versions: _containers.RepeatedCompositeFieldContainer[InstanceGroupManagerVersion]
    zone: str
    def __init__(self, all_instances_config: _Optional[_Union[InstanceGroupManagerAllInstancesConfig, _Mapping]] = ..., auto_healing_policies: _Optional[_Iterable[_Union[InstanceGroupManagerAutoHealingPolicy, _Mapping]]] = ..., base_instance_name: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., current_actions: _Optional[_Union[InstanceGroupManagerActionsSummary, _Mapping]] = ..., description: _Optional[str] = ..., distribution_policy: _Optional[_Union[DistributionPolicy, _Mapping]] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., instance_flexibility_policy: _Optional[_Union[InstanceGroupManagerInstanceFlexibilityPolicy, _Mapping]] = ..., instance_group: _Optional[str] = ..., instance_lifecycle_policy: _Optional[_Union[InstanceGroupManagerInstanceLifecyclePolicy, _Mapping]] = ..., instance_template: _Optional[str] = ..., kind: _Optional[str] = ..., list_managed_instances_results: _Optional[str] = ..., name: _Optional[str] = ..., named_ports: _Optional[_Iterable[_Union[NamedPort, _Mapping]]] = ..., region: _Optional[str] = ..., satisfies_pzi: bool = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., standby_policy: _Optional[_Union[InstanceGroupManagerStandbyPolicy, _Mapping]] = ..., stateful_policy: _Optional[_Union[StatefulPolicy, _Mapping]] = ..., status: _Optional[_Union[InstanceGroupManagerStatus, _Mapping]] = ..., target_pools: _Optional[_Iterable[str]] = ..., target_size: _Optional[int] = ..., target_stopped_size: _Optional[int] = ..., target_suspended_size: _Optional[int] = ..., update_policy: _Optional[_Union[InstanceGroupManagerUpdatePolicy, _Mapping]] = ..., versions: _Optional[_Iterable[_Union[InstanceGroupManagerVersion, _Mapping]]] = ..., zone: _Optional[str] = ...) -> None: ...

class InstanceGroupManagerActionsSummary(_message.Message):
    __slots__ = ("abandoning", "creating", "creating_without_retries", "deleting", "none", "recreating", "refreshing", "restarting", "resuming", "starting", "stopping", "suspending", "verifying")
    ABANDONING_FIELD_NUMBER: _ClassVar[int]
    CREATING_FIELD_NUMBER: _ClassVar[int]
    CREATING_WITHOUT_RETRIES_FIELD_NUMBER: _ClassVar[int]
    DELETING_FIELD_NUMBER: _ClassVar[int]
    NONE_FIELD_NUMBER: _ClassVar[int]
    RECREATING_FIELD_NUMBER: _ClassVar[int]
    REFRESHING_FIELD_NUMBER: _ClassVar[int]
    RESTARTING_FIELD_NUMBER: _ClassVar[int]
    RESUMING_FIELD_NUMBER: _ClassVar[int]
    STARTING_FIELD_NUMBER: _ClassVar[int]
    STOPPING_FIELD_NUMBER: _ClassVar[int]
    SUSPENDING_FIELD_NUMBER: _ClassVar[int]
    VERIFYING_FIELD_NUMBER: _ClassVar[int]
    abandoning: int
    creating: int
    creating_without_retries: int
    deleting: int
    none: int
    recreating: int
    refreshing: int
    restarting: int
    resuming: int
    starting: int
    stopping: int
    suspending: int
    verifying: int
    def __init__(self, abandoning: _Optional[int] = ..., creating: _Optional[int] = ..., creating_without_retries: _Optional[int] = ..., deleting: _Optional[int] = ..., none: _Optional[int] = ..., recreating: _Optional[int] = ..., refreshing: _Optional[int] = ..., restarting: _Optional[int] = ..., resuming: _Optional[int] = ..., starting: _Optional[int] = ..., stopping: _Optional[int] = ..., suspending: _Optional[int] = ..., verifying: _Optional[int] = ...) -> None: ...

class InstanceGroupManagerAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: InstanceGroupManagersScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InstanceGroupManagersScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, InstanceGroupManagersScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, InstanceGroupManagersScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerAllInstancesConfig(_message.Message):
    __slots__ = ("properties",)
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    properties: InstancePropertiesPatch
    def __init__(self, properties: _Optional[_Union[InstancePropertiesPatch, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerAutoHealingPolicy(_message.Message):
    __slots__ = ("health_check", "initial_delay_sec")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    INITIAL_DELAY_SEC_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    initial_delay_sec: int
    def __init__(self, health_check: _Optional[str] = ..., initial_delay_sec: _Optional[int] = ...) -> None: ...

class InstanceGroupManagerInstanceFlexibilityPolicy(_message.Message):
    __slots__ = ("instance_selections",)
    class InstanceSelectionsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: InstanceGroupManagerInstanceFlexibilityPolicyInstanceSelection
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InstanceGroupManagerInstanceFlexibilityPolicyInstanceSelection, _Mapping]] = ...) -> None: ...
    INSTANCE_SELECTIONS_FIELD_NUMBER: _ClassVar[int]
    instance_selections: _containers.MessageMap[str, InstanceGroupManagerInstanceFlexibilityPolicyInstanceSelection]
    def __init__(self, instance_selections: _Optional[_Mapping[str, InstanceGroupManagerInstanceFlexibilityPolicyInstanceSelection]] = ...) -> None: ...

class InstanceGroupManagerInstanceFlexibilityPolicyInstanceSelection(_message.Message):
    __slots__ = ("machine_types", "rank")
    MACHINE_TYPES_FIELD_NUMBER: _ClassVar[int]
    RANK_FIELD_NUMBER: _ClassVar[int]
    machine_types: _containers.RepeatedScalarFieldContainer[str]
    rank: int
    def __init__(self, machine_types: _Optional[_Iterable[str]] = ..., rank: _Optional[int] = ...) -> None: ...

class InstanceGroupManagerInstanceLifecyclePolicy(_message.Message):
    __slots__ = ("default_action_on_failure", "force_update_on_repair")
    class DefaultActionOnFailure(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DEFAULT_ACTION_ON_FAILURE: _ClassVar[InstanceGroupManagerInstanceLifecyclePolicy.DefaultActionOnFailure]
        DO_NOTHING: _ClassVar[InstanceGroupManagerInstanceLifecyclePolicy.DefaultActionOnFailure]
        REPAIR: _ClassVar[InstanceGroupManagerInstanceLifecyclePolicy.DefaultActionOnFailure]
    UNDEFINED_DEFAULT_ACTION_ON_FAILURE: InstanceGroupManagerInstanceLifecyclePolicy.DefaultActionOnFailure
    DO_NOTHING: InstanceGroupManagerInstanceLifecyclePolicy.DefaultActionOnFailure
    REPAIR: InstanceGroupManagerInstanceLifecyclePolicy.DefaultActionOnFailure
    class ForceUpdateOnRepair(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_FORCE_UPDATE_ON_REPAIR: _ClassVar[InstanceGroupManagerInstanceLifecyclePolicy.ForceUpdateOnRepair]
        NO: _ClassVar[InstanceGroupManagerInstanceLifecyclePolicy.ForceUpdateOnRepair]
        YES: _ClassVar[InstanceGroupManagerInstanceLifecyclePolicy.ForceUpdateOnRepair]
    UNDEFINED_FORCE_UPDATE_ON_REPAIR: InstanceGroupManagerInstanceLifecyclePolicy.ForceUpdateOnRepair
    NO: InstanceGroupManagerInstanceLifecyclePolicy.ForceUpdateOnRepair
    YES: InstanceGroupManagerInstanceLifecyclePolicy.ForceUpdateOnRepair
    DEFAULT_ACTION_ON_FAILURE_FIELD_NUMBER: _ClassVar[int]
    FORCE_UPDATE_ON_REPAIR_FIELD_NUMBER: _ClassVar[int]
    default_action_on_failure: str
    force_update_on_repair: str
    def __init__(self, default_action_on_failure: _Optional[str] = ..., force_update_on_repair: _Optional[str] = ...) -> None: ...

class InstanceGroupManagerList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceGroupManager]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceGroupManager, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerResizeRequest(_message.Message):
    __slots__ = ("creation_timestamp", "description", "id", "kind", "name", "requested_run_duration", "resize_by", "self_link", "self_link_with_id", "state", "status", "zone")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[InstanceGroupManagerResizeRequest.State]
        ACCEPTED: _ClassVar[InstanceGroupManagerResizeRequest.State]
        CANCELLED: _ClassVar[InstanceGroupManagerResizeRequest.State]
        CREATING: _ClassVar[InstanceGroupManagerResizeRequest.State]
        FAILED: _ClassVar[InstanceGroupManagerResizeRequest.State]
        STATE_UNSPECIFIED: _ClassVar[InstanceGroupManagerResizeRequest.State]
        SUCCEEDED: _ClassVar[InstanceGroupManagerResizeRequest.State]
    UNDEFINED_STATE: InstanceGroupManagerResizeRequest.State
    ACCEPTED: InstanceGroupManagerResizeRequest.State
    CANCELLED: InstanceGroupManagerResizeRequest.State
    CREATING: InstanceGroupManagerResizeRequest.State
    FAILED: InstanceGroupManagerResizeRequest.State
    STATE_UNSPECIFIED: InstanceGroupManagerResizeRequest.State
    SUCCEEDED: InstanceGroupManagerResizeRequest.State
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REQUESTED_RUN_DURATION_FIELD_NUMBER: _ClassVar[int]
    RESIZE_BY_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    id: int
    kind: str
    name: str
    requested_run_duration: Duration
    resize_by: int
    self_link: str
    self_link_with_id: str
    state: str
    status: InstanceGroupManagerResizeRequestStatus
    zone: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., requested_run_duration: _Optional[_Union[Duration, _Mapping]] = ..., resize_by: _Optional[int] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., state: _Optional[str] = ..., status: _Optional[_Union[InstanceGroupManagerResizeRequestStatus, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class InstanceGroupManagerResizeRequestStatus(_message.Message):
    __slots__ = ("error", "last_attempt")
    ERROR_FIELD_NUMBER: _ClassVar[int]
    LAST_ATTEMPT_FIELD_NUMBER: _ClassVar[int]
    error: Error
    last_attempt: InstanceGroupManagerResizeRequestStatusLastAttempt
    def __init__(self, error: _Optional[_Union[Error, _Mapping]] = ..., last_attempt: _Optional[_Union[InstanceGroupManagerResizeRequestStatusLastAttempt, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerResizeRequestStatusLastAttempt(_message.Message):
    __slots__ = ("error",)
    ERROR_FIELD_NUMBER: _ClassVar[int]
    error: Error
    def __init__(self, error: _Optional[_Union[Error, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerResizeRequestsListResponse(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceGroupManagerResizeRequest]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceGroupManagerResizeRequest, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerStandbyPolicy(_message.Message):
    __slots__ = ("initial_delay_sec", "mode")
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[InstanceGroupManagerStandbyPolicy.Mode]
        MANUAL: _ClassVar[InstanceGroupManagerStandbyPolicy.Mode]
        SCALE_OUT_POOL: _ClassVar[InstanceGroupManagerStandbyPolicy.Mode]
    UNDEFINED_MODE: InstanceGroupManagerStandbyPolicy.Mode
    MANUAL: InstanceGroupManagerStandbyPolicy.Mode
    SCALE_OUT_POOL: InstanceGroupManagerStandbyPolicy.Mode
    INITIAL_DELAY_SEC_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    initial_delay_sec: int
    mode: str
    def __init__(self, initial_delay_sec: _Optional[int] = ..., mode: _Optional[str] = ...) -> None: ...

class InstanceGroupManagerStatus(_message.Message):
    __slots__ = ("all_instances_config", "autoscaler", "is_stable", "stateful", "version_target")
    ALL_INSTANCES_CONFIG_FIELD_NUMBER: _ClassVar[int]
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    IS_STABLE_FIELD_NUMBER: _ClassVar[int]
    STATEFUL_FIELD_NUMBER: _ClassVar[int]
    VERSION_TARGET_FIELD_NUMBER: _ClassVar[int]
    all_instances_config: InstanceGroupManagerStatusAllInstancesConfig
    autoscaler: str
    is_stable: bool
    stateful: InstanceGroupManagerStatusStateful
    version_target: InstanceGroupManagerStatusVersionTarget
    def __init__(self, all_instances_config: _Optional[_Union[InstanceGroupManagerStatusAllInstancesConfig, _Mapping]] = ..., autoscaler: _Optional[str] = ..., is_stable: bool = ..., stateful: _Optional[_Union[InstanceGroupManagerStatusStateful, _Mapping]] = ..., version_target: _Optional[_Union[InstanceGroupManagerStatusVersionTarget, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerStatusAllInstancesConfig(_message.Message):
    __slots__ = ("current_revision", "effective")
    CURRENT_REVISION_FIELD_NUMBER: _ClassVar[int]
    EFFECTIVE_FIELD_NUMBER: _ClassVar[int]
    current_revision: str
    effective: bool
    def __init__(self, current_revision: _Optional[str] = ..., effective: bool = ...) -> None: ...

class InstanceGroupManagerStatusStateful(_message.Message):
    __slots__ = ("has_stateful_config", "per_instance_configs")
    HAS_STATEFUL_CONFIG_FIELD_NUMBER: _ClassVar[int]
    PER_INSTANCE_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    has_stateful_config: bool
    per_instance_configs: InstanceGroupManagerStatusStatefulPerInstanceConfigs
    def __init__(self, has_stateful_config: bool = ..., per_instance_configs: _Optional[_Union[InstanceGroupManagerStatusStatefulPerInstanceConfigs, _Mapping]] = ...) -> None: ...

class InstanceGroupManagerStatusStatefulPerInstanceConfigs(_message.Message):
    __slots__ = ("all_effective",)
    ALL_EFFECTIVE_FIELD_NUMBER: _ClassVar[int]
    all_effective: bool
    def __init__(self, all_effective: bool = ...) -> None: ...

class InstanceGroupManagerStatusVersionTarget(_message.Message):
    __slots__ = ("is_reached",)
    IS_REACHED_FIELD_NUMBER: _ClassVar[int]
    is_reached: bool
    def __init__(self, is_reached: bool = ...) -> None: ...

class InstanceGroupManagerUpdatePolicy(_message.Message):
    __slots__ = ("instance_redistribution_type", "max_surge", "max_unavailable", "minimal_action", "most_disruptive_allowed_action", "replacement_method", "type")
    class InstanceRedistributionType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INSTANCE_REDISTRIBUTION_TYPE: _ClassVar[InstanceGroupManagerUpdatePolicy.InstanceRedistributionType]
    UNDEFINED_INSTANCE_REDISTRIBUTION_TYPE: InstanceGroupManagerUpdatePolicy.InstanceRedistributionType
    class MinimalAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MINIMAL_ACTION: _ClassVar[InstanceGroupManagerUpdatePolicy.MinimalAction]
    UNDEFINED_MINIMAL_ACTION: InstanceGroupManagerUpdatePolicy.MinimalAction
    class MostDisruptiveAllowedAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: _ClassVar[InstanceGroupManagerUpdatePolicy.MostDisruptiveAllowedAction]
    UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: InstanceGroupManagerUpdatePolicy.MostDisruptiveAllowedAction
    class ReplacementMethod(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_REPLACEMENT_METHOD: _ClassVar[InstanceGroupManagerUpdatePolicy.ReplacementMethod]
        RECREATE: _ClassVar[InstanceGroupManagerUpdatePolicy.ReplacementMethod]
        SUBSTITUTE: _ClassVar[InstanceGroupManagerUpdatePolicy.ReplacementMethod]
    UNDEFINED_REPLACEMENT_METHOD: InstanceGroupManagerUpdatePolicy.ReplacementMethod
    RECREATE: InstanceGroupManagerUpdatePolicy.ReplacementMethod
    SUBSTITUTE: InstanceGroupManagerUpdatePolicy.ReplacementMethod
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[InstanceGroupManagerUpdatePolicy.Type]
        OPPORTUNISTIC: _ClassVar[InstanceGroupManagerUpdatePolicy.Type]
    UNDEFINED_TYPE: InstanceGroupManagerUpdatePolicy.Type
    OPPORTUNISTIC: InstanceGroupManagerUpdatePolicy.Type
    INSTANCE_REDISTRIBUTION_TYPE_FIELD_NUMBER: _ClassVar[int]
    MAX_SURGE_FIELD_NUMBER: _ClassVar[int]
    MAX_UNAVAILABLE_FIELD_NUMBER: _ClassVar[int]
    MINIMAL_ACTION_FIELD_NUMBER: _ClassVar[int]
    MOST_DISRUPTIVE_ALLOWED_ACTION_FIELD_NUMBER: _ClassVar[int]
    REPLACEMENT_METHOD_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    instance_redistribution_type: str
    max_surge: FixedOrPercent
    max_unavailable: FixedOrPercent
    minimal_action: str
    most_disruptive_allowed_action: str
    replacement_method: str
    type: str
    def __init__(self, instance_redistribution_type: _Optional[str] = ..., max_surge: _Optional[_Union[FixedOrPercent, _Mapping]] = ..., max_unavailable: _Optional[_Union[FixedOrPercent, _Mapping]] = ..., minimal_action: _Optional[str] = ..., most_disruptive_allowed_action: _Optional[str] = ..., replacement_method: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class InstanceGroupManagerVersion(_message.Message):
    __slots__ = ("instance_template", "name", "target_size")
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    TARGET_SIZE_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    name: str
    target_size: FixedOrPercent
    def __init__(self, instance_template: _Optional[str] = ..., name: _Optional[str] = ..., target_size: _Optional[_Union[FixedOrPercent, _Mapping]] = ...) -> None: ...

class InstanceGroupManagersAbandonInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersApplyUpdatesRequest(_message.Message):
    __slots__ = ("all_instances", "instances", "minimal_action", "most_disruptive_allowed_action")
    class MinimalAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MINIMAL_ACTION: _ClassVar[InstanceGroupManagersApplyUpdatesRequest.MinimalAction]
    UNDEFINED_MINIMAL_ACTION: InstanceGroupManagersApplyUpdatesRequest.MinimalAction
    class MostDisruptiveAllowedAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: _ClassVar[InstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction]
    UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: InstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction
    ALL_INSTANCES_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    MINIMAL_ACTION_FIELD_NUMBER: _ClassVar[int]
    MOST_DISRUPTIVE_ALLOWED_ACTION_FIELD_NUMBER: _ClassVar[int]
    all_instances: bool
    instances: _containers.RepeatedScalarFieldContainer[str]
    minimal_action: str
    most_disruptive_allowed_action: str
    def __init__(self, all_instances: bool = ..., instances: _Optional[_Iterable[str]] = ..., minimal_action: _Optional[str] = ..., most_disruptive_allowed_action: _Optional[str] = ...) -> None: ...

class InstanceGroupManagersCreateInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    def __init__(self, instances: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ...) -> None: ...

class InstanceGroupManagersDeleteInstancesRequest(_message.Message):
    __slots__ = ("instances", "skip_instances_on_validation_error")
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    SKIP_INSTANCES_ON_VALIDATION_ERROR_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    skip_instances_on_validation_error: bool
    def __init__(self, instances: _Optional[_Iterable[str]] = ..., skip_instances_on_validation_error: bool = ...) -> None: ...

class InstanceGroupManagersDeletePerInstanceConfigsReq(_message.Message):
    __slots__ = ("names",)
    NAMES_FIELD_NUMBER: _ClassVar[int]
    names: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, names: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersListErrorsResponse(_message.Message):
    __slots__ = ("items", "next_page_token")
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    items: _containers.RepeatedCompositeFieldContainer[InstanceManagedByIgmError]
    next_page_token: str
    def __init__(self, items: _Optional[_Iterable[_Union[InstanceManagedByIgmError, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class InstanceGroupManagersListManagedInstancesResponse(_message.Message):
    __slots__ = ("managed_instances", "next_page_token")
    MANAGED_INSTANCES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    managed_instances: _containers.RepeatedCompositeFieldContainer[ManagedInstance]
    next_page_token: str
    def __init__(self, managed_instances: _Optional[_Iterable[_Union[ManagedInstance, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class InstanceGroupManagersListPerInstanceConfigsResp(_message.Message):
    __slots__ = ("items", "next_page_token", "warning")
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    items: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    next_page_token: str
    warning: Warning
    def __init__(self, items: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ..., next_page_token: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupManagersPatchPerInstanceConfigsReq(_message.Message):
    __slots__ = ("per_instance_configs",)
    PER_INSTANCE_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    per_instance_configs: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    def __init__(self, per_instance_configs: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ...) -> None: ...

class InstanceGroupManagersRecreateInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersResumeInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersScopedList(_message.Message):
    __slots__ = ("instance_group_managers", "warning")
    INSTANCE_GROUP_MANAGERS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    instance_group_managers: _containers.RepeatedCompositeFieldContainer[InstanceGroupManager]
    warning: Warning
    def __init__(self, instance_group_managers: _Optional[_Iterable[_Union[InstanceGroupManager, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupManagersSetInstanceTemplateRequest(_message.Message):
    __slots__ = ("instance_template",)
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    def __init__(self, instance_template: _Optional[str] = ...) -> None: ...

class InstanceGroupManagersSetTargetPoolsRequest(_message.Message):
    __slots__ = ("fingerprint", "target_pools")
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOLS_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    target_pools: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, fingerprint: _Optional[str] = ..., target_pools: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersStartInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersStopInstancesRequest(_message.Message):
    __slots__ = ("force_stop", "instances")
    FORCE_STOP_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    force_stop: bool
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, force_stop: bool = ..., instances: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersSuspendInstancesRequest(_message.Message):
    __slots__ = ("force_suspend", "instances")
    FORCE_SUSPEND_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    force_suspend: bool
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, force_suspend: bool = ..., instances: _Optional[_Iterable[str]] = ...) -> None: ...

class InstanceGroupManagersUpdatePerInstanceConfigsReq(_message.Message):
    __slots__ = ("per_instance_configs",)
    PER_INSTANCE_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    per_instance_configs: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    def __init__(self, per_instance_configs: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ...) -> None: ...

class InstanceGroupsAddInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[InstanceReference]
    def __init__(self, instances: _Optional[_Iterable[_Union[InstanceReference, _Mapping]]] = ...) -> None: ...

class InstanceGroupsListInstances(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceWithNamedPorts]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceWithNamedPorts, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupsListInstancesRequest(_message.Message):
    __slots__ = ("instance_state",)
    class InstanceState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INSTANCE_STATE: _ClassVar[InstanceGroupsListInstancesRequest.InstanceState]
        ALL: _ClassVar[InstanceGroupsListInstancesRequest.InstanceState]
        RUNNING: _ClassVar[InstanceGroupsListInstancesRequest.InstanceState]
    UNDEFINED_INSTANCE_STATE: InstanceGroupsListInstancesRequest.InstanceState
    ALL: InstanceGroupsListInstancesRequest.InstanceState
    RUNNING: InstanceGroupsListInstancesRequest.InstanceState
    INSTANCE_STATE_FIELD_NUMBER: _ClassVar[int]
    instance_state: str
    def __init__(self, instance_state: _Optional[str] = ...) -> None: ...

class InstanceGroupsRemoveInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[InstanceReference]
    def __init__(self, instances: _Optional[_Iterable[_Union[InstanceReference, _Mapping]]] = ...) -> None: ...

class InstanceGroupsScopedList(_message.Message):
    __slots__ = ("instance_groups", "warning")
    INSTANCE_GROUPS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    instance_groups: _containers.RepeatedCompositeFieldContainer[InstanceGroup]
    warning: Warning
    def __init__(self, instance_groups: _Optional[_Iterable[_Union[InstanceGroup, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceGroupsSetNamedPortsRequest(_message.Message):
    __slots__ = ("fingerprint", "named_ports")
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    NAMED_PORTS_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    named_ports: _containers.RepeatedCompositeFieldContainer[NamedPort]
    def __init__(self, fingerprint: _Optional[str] = ..., named_ports: _Optional[_Iterable[_Union[NamedPort, _Mapping]]] = ...) -> None: ...

class InstanceList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Instance]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Instance, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceListReferrers(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Reference]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Reference, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceManagedByIgmError(_message.Message):
    __slots__ = ("error", "instance_action_details", "timestamp")
    ERROR_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_ACTION_DETAILS_FIELD_NUMBER: _ClassVar[int]
    TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    error: InstanceManagedByIgmErrorManagedInstanceError
    instance_action_details: InstanceManagedByIgmErrorInstanceActionDetails
    timestamp: str
    def __init__(self, error: _Optional[_Union[InstanceManagedByIgmErrorManagedInstanceError, _Mapping]] = ..., instance_action_details: _Optional[_Union[InstanceManagedByIgmErrorInstanceActionDetails, _Mapping]] = ..., timestamp: _Optional[str] = ...) -> None: ...

class InstanceManagedByIgmErrorInstanceActionDetails(_message.Message):
    __slots__ = ("action", "instance", "version")
    class Action(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ACTION: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        ABANDONING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        CREATING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        CREATING_WITHOUT_RETRIES: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        DELETING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        NONE: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        RECREATING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        REFRESHING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        RESTARTING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        RESUMING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        STARTING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        STOPPING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        SUSPENDING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
        VERIFYING: _ClassVar[InstanceManagedByIgmErrorInstanceActionDetails.Action]
    UNDEFINED_ACTION: InstanceManagedByIgmErrorInstanceActionDetails.Action
    ABANDONING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    CREATING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    CREATING_WITHOUT_RETRIES: InstanceManagedByIgmErrorInstanceActionDetails.Action
    DELETING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    NONE: InstanceManagedByIgmErrorInstanceActionDetails.Action
    RECREATING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    REFRESHING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    RESTARTING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    RESUMING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    STARTING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    STOPPING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    SUSPENDING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    VERIFYING: InstanceManagedByIgmErrorInstanceActionDetails.Action
    ACTION_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    action: str
    instance: str
    version: ManagedInstanceVersion
    def __init__(self, action: _Optional[str] = ..., instance: _Optional[str] = ..., version: _Optional[_Union[ManagedInstanceVersion, _Mapping]] = ...) -> None: ...

class InstanceManagedByIgmErrorManagedInstanceError(_message.Message):
    __slots__ = ("code", "message")
    CODE_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    code: str
    message: str
    def __init__(self, code: _Optional[str] = ..., message: _Optional[str] = ...) -> None: ...

class InstanceMoveRequest(_message.Message):
    __slots__ = ("destination_zone", "target_instance")
    DESTINATION_ZONE_FIELD_NUMBER: _ClassVar[int]
    TARGET_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    destination_zone: str
    target_instance: str
    def __init__(self, destination_zone: _Optional[str] = ..., target_instance: _Optional[str] = ...) -> None: ...

class InstanceParams(_message.Message):
    __slots__ = ("resource_manager_tags",)
    class ResourceManagerTagsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    RESOURCE_MANAGER_TAGS_FIELD_NUMBER: _ClassVar[int]
    resource_manager_tags: _containers.ScalarMap[str, str]
    def __init__(self, resource_manager_tags: _Optional[_Mapping[str, str]] = ...) -> None: ...

class InstanceProperties(_message.Message):
    __slots__ = ("advanced_machine_features", "can_ip_forward", "confidential_instance_config", "description", "disks", "guest_accelerators", "key_revocation_action_type", "labels", "machine_type", "metadata", "min_cpu_platform", "network_interfaces", "network_performance_config", "private_ipv6_google_access", "reservation_affinity", "resource_manager_tags", "resource_policies", "scheduling", "service_accounts", "shielded_instance_config", "tags")
    class KeyRevocationActionType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_KEY_REVOCATION_ACTION_TYPE: _ClassVar[InstanceProperties.KeyRevocationActionType]
        KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED: _ClassVar[InstanceProperties.KeyRevocationActionType]
        NONE: _ClassVar[InstanceProperties.KeyRevocationActionType]
        STOP: _ClassVar[InstanceProperties.KeyRevocationActionType]
    UNDEFINED_KEY_REVOCATION_ACTION_TYPE: InstanceProperties.KeyRevocationActionType
    KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED: InstanceProperties.KeyRevocationActionType
    NONE: InstanceProperties.KeyRevocationActionType
    STOP: InstanceProperties.KeyRevocationActionType
    class PrivateIpv6GoogleAccess(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS: _ClassVar[InstanceProperties.PrivateIpv6GoogleAccess]
        ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE: _ClassVar[InstanceProperties.PrivateIpv6GoogleAccess]
        ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE: _ClassVar[InstanceProperties.PrivateIpv6GoogleAccess]
        INHERIT_FROM_SUBNETWORK: _ClassVar[InstanceProperties.PrivateIpv6GoogleAccess]
    UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS: InstanceProperties.PrivateIpv6GoogleAccess
    ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE: InstanceProperties.PrivateIpv6GoogleAccess
    ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE: InstanceProperties.PrivateIpv6GoogleAccess
    INHERIT_FROM_SUBNETWORK: InstanceProperties.PrivateIpv6GoogleAccess
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class ResourceManagerTagsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ADVANCED_MACHINE_FEATURES_FIELD_NUMBER: _ClassVar[int]
    CAN_IP_FORWARD_FIELD_NUMBER: _ClassVar[int]
    CONFIDENTIAL_INSTANCE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISKS_FIELD_NUMBER: _ClassVar[int]
    GUEST_ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    KEY_REVOCATION_ACTION_TYPE_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    MIN_CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACES_FIELD_NUMBER: _ClassVar[int]
    NETWORK_PERFORMANCE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_IPV6_GOOGLE_ACCESS_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_AFFINITY_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_MANAGER_TAGS_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
    SHIELDED_INSTANCE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    advanced_machine_features: AdvancedMachineFeatures
    can_ip_forward: bool
    confidential_instance_config: ConfidentialInstanceConfig
    description: str
    disks: _containers.RepeatedCompositeFieldContainer[AttachedDisk]
    guest_accelerators: _containers.RepeatedCompositeFieldContainer[AcceleratorConfig]
    key_revocation_action_type: str
    labels: _containers.ScalarMap[str, str]
    machine_type: str
    metadata: Metadata
    min_cpu_platform: str
    network_interfaces: _containers.RepeatedCompositeFieldContainer[NetworkInterface]
    network_performance_config: NetworkPerformanceConfig
    private_ipv6_google_access: str
    reservation_affinity: ReservationAffinity
    resource_manager_tags: _containers.ScalarMap[str, str]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    scheduling: Scheduling
    service_accounts: _containers.RepeatedCompositeFieldContainer[ServiceAccount]
    shielded_instance_config: ShieldedInstanceConfig
    tags: Tags
    def __init__(self, advanced_machine_features: _Optional[_Union[AdvancedMachineFeatures, _Mapping]] = ..., can_ip_forward: bool = ..., confidential_instance_config: _Optional[_Union[ConfidentialInstanceConfig, _Mapping]] = ..., description: _Optional[str] = ..., disks: _Optional[_Iterable[_Union[AttachedDisk, _Mapping]]] = ..., guest_accelerators: _Optional[_Iterable[_Union[AcceleratorConfig, _Mapping]]] = ..., key_revocation_action_type: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., machine_type: _Optional[str] = ..., metadata: _Optional[_Union[Metadata, _Mapping]] = ..., min_cpu_platform: _Optional[str] = ..., network_interfaces: _Optional[_Iterable[_Union[NetworkInterface, _Mapping]]] = ..., network_performance_config: _Optional[_Union[NetworkPerformanceConfig, _Mapping]] = ..., private_ipv6_google_access: _Optional[str] = ..., reservation_affinity: _Optional[_Union[ReservationAffinity, _Mapping]] = ..., resource_manager_tags: _Optional[_Mapping[str, str]] = ..., resource_policies: _Optional[_Iterable[str]] = ..., scheduling: _Optional[_Union[Scheduling, _Mapping]] = ..., service_accounts: _Optional[_Iterable[_Union[ServiceAccount, _Mapping]]] = ..., shielded_instance_config: _Optional[_Union[ShieldedInstanceConfig, _Mapping]] = ..., tags: _Optional[_Union[Tags, _Mapping]] = ...) -> None: ...

class InstancePropertiesPatch(_message.Message):
    __slots__ = ("labels", "metadata")
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class MetadataEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    LABELS_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    labels: _containers.ScalarMap[str, str]
    metadata: _containers.ScalarMap[str, str]
    def __init__(self, labels: _Optional[_Mapping[str, str]] = ..., metadata: _Optional[_Mapping[str, str]] = ...) -> None: ...

class InstanceReference(_message.Message):
    __slots__ = ("instance",)
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    def __init__(self, instance: _Optional[str] = ...) -> None: ...

class InstanceSettings(_message.Message):
    __slots__ = ("fingerprint", "kind", "metadata", "zone")
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    kind: str
    metadata: InstanceSettingsMetadata
    zone: str
    def __init__(self, fingerprint: _Optional[str] = ..., kind: _Optional[str] = ..., metadata: _Optional[_Union[InstanceSettingsMetadata, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class InstanceSettingsMetadata(_message.Message):
    __slots__ = ("items", "kind")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    items: _containers.ScalarMap[str, str]
    kind: str
    def __init__(self, items: _Optional[_Mapping[str, str]] = ..., kind: _Optional[str] = ...) -> None: ...

class InstanceTemplate(_message.Message):
    __slots__ = ("creation_timestamp", "description", "id", "kind", "name", "properties", "region", "self_link", "source_instance", "source_instance_params")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_PARAMS_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    id: int
    kind: str
    name: str
    properties: InstanceProperties
    region: str
    self_link: str
    source_instance: str
    source_instance_params: SourceInstanceParams
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., properties: _Optional[_Union[InstanceProperties, _Mapping]] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., source_instance: _Optional[str] = ..., source_instance_params: _Optional[_Union[SourceInstanceParams, _Mapping]] = ...) -> None: ...

class InstanceTemplateAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: InstanceTemplatesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InstanceTemplatesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, InstanceTemplatesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, InstanceTemplatesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceTemplateList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceTemplate]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceTemplate, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceTemplatesScopedList(_message.Message):
    __slots__ = ("instance_templates", "warning")
    INSTANCE_TEMPLATES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    instance_templates: _containers.RepeatedCompositeFieldContainer[InstanceTemplate]
    warning: Warning
    def __init__(self, instance_templates: _Optional[_Iterable[_Union[InstanceTemplate, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstanceWithNamedPorts(_message.Message):
    __slots__ = ("instance", "named_ports", "status")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[InstanceWithNamedPorts.Status]
        DEPROVISIONING: _ClassVar[InstanceWithNamedPorts.Status]
        PROVISIONING: _ClassVar[InstanceWithNamedPorts.Status]
        REPAIRING: _ClassVar[InstanceWithNamedPorts.Status]
        RUNNING: _ClassVar[InstanceWithNamedPorts.Status]
        STAGING: _ClassVar[InstanceWithNamedPorts.Status]
        STOPPED: _ClassVar[InstanceWithNamedPorts.Status]
        STOPPING: _ClassVar[InstanceWithNamedPorts.Status]
        SUSPENDED: _ClassVar[InstanceWithNamedPorts.Status]
        SUSPENDING: _ClassVar[InstanceWithNamedPorts.Status]
        TERMINATED: _ClassVar[InstanceWithNamedPorts.Status]
    UNDEFINED_STATUS: InstanceWithNamedPorts.Status
    DEPROVISIONING: InstanceWithNamedPorts.Status
    PROVISIONING: InstanceWithNamedPorts.Status
    REPAIRING: InstanceWithNamedPorts.Status
    RUNNING: InstanceWithNamedPorts.Status
    STAGING: InstanceWithNamedPorts.Status
    STOPPED: InstanceWithNamedPorts.Status
    STOPPING: InstanceWithNamedPorts.Status
    SUSPENDED: InstanceWithNamedPorts.Status
    SUSPENDING: InstanceWithNamedPorts.Status
    TERMINATED: InstanceWithNamedPorts.Status
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NAMED_PORTS_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    instance: str
    named_ports: _containers.RepeatedCompositeFieldContainer[NamedPort]
    status: str
    def __init__(self, instance: _Optional[str] = ..., named_ports: _Optional[_Iterable[_Union[NamedPort, _Mapping]]] = ..., status: _Optional[str] = ...) -> None: ...

class InstancesAddResourcePoliciesRequest(_message.Message):
    __slots__ = ("resource_policies",)
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, resource_policies: _Optional[_Iterable[str]] = ...) -> None: ...

class InstancesBulkInsertOperationMetadata(_message.Message):
    __slots__ = ("per_location_status",)
    class PerLocationStatusEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: BulkInsertOperationStatus
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[BulkInsertOperationStatus, _Mapping]] = ...) -> None: ...
    PER_LOCATION_STATUS_FIELD_NUMBER: _ClassVar[int]
    per_location_status: _containers.MessageMap[str, BulkInsertOperationStatus]
    def __init__(self, per_location_status: _Optional[_Mapping[str, BulkInsertOperationStatus]] = ...) -> None: ...

class InstancesGetEffectiveFirewallsResponse(_message.Message):
    __slots__ = ("firewall_policys", "firewalls")
    FIREWALL_POLICYS_FIELD_NUMBER: _ClassVar[int]
    FIREWALLS_FIELD_NUMBER: _ClassVar[int]
    firewall_policys: _containers.RepeatedCompositeFieldContainer[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy]
    firewalls: _containers.RepeatedCompositeFieldContainer[Firewall]
    def __init__(self, firewall_policys: _Optional[_Iterable[_Union[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy, _Mapping]]] = ..., firewalls: _Optional[_Iterable[_Union[Firewall, _Mapping]]] = ...) -> None: ...

class InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy(_message.Message):
    __slots__ = ("display_name", "name", "priority", "rules", "short_name", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        HIERARCHY: _ClassVar[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        NETWORK: _ClassVar[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        NETWORK_REGIONAL: _ClassVar[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        SYSTEM_GLOBAL: _ClassVar[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        SYSTEM_REGIONAL: _ClassVar[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        UNSPECIFIED: _ClassVar[InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
    UNDEFINED_TYPE: InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    HIERARCHY: InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    NETWORK: InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    NETWORK_REGIONAL: InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    SYSTEM_GLOBAL: InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    SYSTEM_REGIONAL: InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    UNSPECIFIED: InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    RULES_FIELD_NUMBER: _ClassVar[int]
    SHORT_NAME_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    display_name: str
    name: str
    priority: int
    rules: _containers.RepeatedCompositeFieldContainer[FirewallPolicyRule]
    short_name: str
    type: str
    def __init__(self, display_name: _Optional[str] = ..., name: _Optional[str] = ..., priority: _Optional[int] = ..., rules: _Optional[_Iterable[_Union[FirewallPolicyRule, _Mapping]]] = ..., short_name: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class InstancesRemoveResourcePoliciesRequest(_message.Message):
    __slots__ = ("resource_policies",)
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, resource_policies: _Optional[_Iterable[str]] = ...) -> None: ...

class InstancesScopedList(_message.Message):
    __slots__ = ("instances", "warning")
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[Instance]
    warning: Warning
    def __init__(self, instances: _Optional[_Iterable[_Union[Instance, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstancesSetLabelsRequest(_message.Message):
    __slots__ = ("label_fingerprint", "labels")
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    def __init__(self, label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ...) -> None: ...

class InstancesSetMachineResourcesRequest(_message.Message):
    __slots__ = ("guest_accelerators",)
    GUEST_ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    guest_accelerators: _containers.RepeatedCompositeFieldContainer[AcceleratorConfig]
    def __init__(self, guest_accelerators: _Optional[_Iterable[_Union[AcceleratorConfig, _Mapping]]] = ...) -> None: ...

class InstancesSetMachineTypeRequest(_message.Message):
    __slots__ = ("machine_type",)
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    machine_type: str
    def __init__(self, machine_type: _Optional[str] = ...) -> None: ...

class InstancesSetMinCpuPlatformRequest(_message.Message):
    __slots__ = ("min_cpu_platform",)
    MIN_CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    min_cpu_platform: str
    def __init__(self, min_cpu_platform: _Optional[str] = ...) -> None: ...

class InstancesSetNameRequest(_message.Message):
    __slots__ = ("current_name", "name")
    CURRENT_NAME_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    current_name: str
    name: str
    def __init__(self, current_name: _Optional[str] = ..., name: _Optional[str] = ...) -> None: ...

class InstancesSetSecurityPolicyRequest(_message.Message):
    __slots__ = ("network_interfaces", "security_policy")
    NETWORK_INTERFACES_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    network_interfaces: _containers.RepeatedScalarFieldContainer[str]
    security_policy: str
    def __init__(self, network_interfaces: _Optional[_Iterable[str]] = ..., security_policy: _Optional[str] = ...) -> None: ...

class InstancesSetServiceAccountRequest(_message.Message):
    __slots__ = ("email", "scopes")
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    SCOPES_FIELD_NUMBER: _ClassVar[int]
    email: str
    scopes: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, email: _Optional[str] = ..., scopes: _Optional[_Iterable[str]] = ...) -> None: ...

class InstancesStartWithEncryptionKeyRequest(_message.Message):
    __slots__ = ("disks",)
    DISKS_FIELD_NUMBER: _ClassVar[int]
    disks: _containers.RepeatedCompositeFieldContainer[CustomerEncryptionKeyProtectedDisk]
    def __init__(self, disks: _Optional[_Iterable[_Union[CustomerEncryptionKeyProtectedDisk, _Mapping]]] = ...) -> None: ...

class InstantSnapshot(_message.Message):
    __slots__ = ("architecture", "creation_timestamp", "description", "disk_size_gb", "id", "kind", "label_fingerprint", "labels", "name", "region", "resource_status", "satisfies_pzi", "satisfies_pzs", "self_link", "self_link_with_id", "source_disk", "source_disk_id", "status", "zone")
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[InstantSnapshot.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[InstantSnapshot.Architecture]
        ARM64: _ClassVar[InstantSnapshot.Architecture]
        X86_64: _ClassVar[InstantSnapshot.Architecture]
    UNDEFINED_ARCHITECTURE: InstantSnapshot.Architecture
    ARCHITECTURE_UNSPECIFIED: InstantSnapshot.Architecture
    ARM64: InstantSnapshot.Architecture
    X86_64: InstantSnapshot.Architecture
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[InstantSnapshot.Status]
        CREATING: _ClassVar[InstantSnapshot.Status]
        DELETING: _ClassVar[InstantSnapshot.Status]
        FAILED: _ClassVar[InstantSnapshot.Status]
        READY: _ClassVar[InstantSnapshot.Status]
        UNAVAILABLE: _ClassVar[InstantSnapshot.Status]
    UNDEFINED_STATUS: InstantSnapshot.Status
    CREATING: InstantSnapshot.Status
    DELETING: InstantSnapshot.Status
    FAILED: InstantSnapshot.Status
    READY: InstantSnapshot.Status
    UNAVAILABLE: InstantSnapshot.Status
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZI_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_ID_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    architecture: str
    creation_timestamp: str
    description: str
    disk_size_gb: int
    id: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    name: str
    region: str
    resource_status: InstantSnapshotResourceStatus
    satisfies_pzi: bool
    satisfies_pzs: bool
    self_link: str
    self_link_with_id: str
    source_disk: str
    source_disk_id: str
    status: str
    zone: str
    def __init__(self, architecture: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., disk_size_gb: _Optional[int] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., resource_status: _Optional[_Union[InstantSnapshotResourceStatus, _Mapping]] = ..., satisfies_pzi: bool = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., source_disk: _Optional[str] = ..., source_disk_id: _Optional[str] = ..., status: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class InstantSnapshotAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: InstantSnapshotsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InstantSnapshotsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, InstantSnapshotsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, InstantSnapshotsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstantSnapshotList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstantSnapshot]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstantSnapshot, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InstantSnapshotResourceStatus(_message.Message):
    __slots__ = ("storage_size_bytes",)
    STORAGE_SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    storage_size_bytes: int
    def __init__(self, storage_size_bytes: _Optional[int] = ...) -> None: ...

class InstantSnapshotsScopedList(_message.Message):
    __slots__ = ("instant_snapshots", "warning")
    INSTANT_SNAPSHOTS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    instant_snapshots: _containers.RepeatedCompositeFieldContainer[InstantSnapshot]
    warning: Warning
    def __init__(self, instant_snapshots: _Optional[_Iterable[_Union[InstantSnapshot, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class Int64RangeMatch(_message.Message):
    __slots__ = ("range_end", "range_start")
    RANGE_END_FIELD_NUMBER: _ClassVar[int]
    RANGE_START_FIELD_NUMBER: _ClassVar[int]
    range_end: int
    range_start: int
    def __init__(self, range_end: _Optional[int] = ..., range_start: _Optional[int] = ...) -> None: ...

class Interconnect(_message.Message):
    __slots__ = ("admin_enabled", "available_features", "circuit_infos", "creation_timestamp", "customer_name", "description", "expected_outages", "google_ip_address", "google_reference_id", "id", "interconnect_attachments", "interconnect_type", "kind", "label_fingerprint", "labels", "link_type", "location", "macsec", "macsec_enabled", "name", "noc_contact_email", "operational_status", "peer_ip_address", "provisioned_link_count", "remote_location", "requested_features", "requested_link_count", "satisfies_pzs", "self_link", "state")
    class AvailableFeatures(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AVAILABLE_FEATURES: _ClassVar[Interconnect.AvailableFeatures]
    UNDEFINED_AVAILABLE_FEATURES: Interconnect.AvailableFeatures
    class InterconnectType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INTERCONNECT_TYPE: _ClassVar[Interconnect.InterconnectType]
        DEDICATED: _ClassVar[Interconnect.InterconnectType]
        IT_PRIVATE: _ClassVar[Interconnect.InterconnectType]
        PARTNER: _ClassVar[Interconnect.InterconnectType]
    UNDEFINED_INTERCONNECT_TYPE: Interconnect.InterconnectType
    DEDICATED: Interconnect.InterconnectType
    IT_PRIVATE: Interconnect.InterconnectType
    PARTNER: Interconnect.InterconnectType
    class LinkType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LINK_TYPE: _ClassVar[Interconnect.LinkType]
        LINK_TYPE_ETHERNET_100G_LR: _ClassVar[Interconnect.LinkType]
        LINK_TYPE_ETHERNET_10G_LR: _ClassVar[Interconnect.LinkType]
    UNDEFINED_LINK_TYPE: Interconnect.LinkType
    LINK_TYPE_ETHERNET_100G_LR: Interconnect.LinkType
    LINK_TYPE_ETHERNET_10G_LR: Interconnect.LinkType
    class OperationalStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_OPERATIONAL_STATUS: _ClassVar[Interconnect.OperationalStatus]
        OS_ACTIVE: _ClassVar[Interconnect.OperationalStatus]
        OS_UNPROVISIONED: _ClassVar[Interconnect.OperationalStatus]
    UNDEFINED_OPERATIONAL_STATUS: Interconnect.OperationalStatus
    OS_ACTIVE: Interconnect.OperationalStatus
    OS_UNPROVISIONED: Interconnect.OperationalStatus
    class RequestedFeatures(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_REQUESTED_FEATURES: _ClassVar[Interconnect.RequestedFeatures]
    UNDEFINED_REQUESTED_FEATURES: Interconnect.RequestedFeatures
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[Interconnect.State]
        ACTIVE: _ClassVar[Interconnect.State]
        UNPROVISIONED: _ClassVar[Interconnect.State]
    UNDEFINED_STATE: Interconnect.State
    ACTIVE: Interconnect.State
    UNPROVISIONED: Interconnect.State
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ADMIN_ENABLED_FIELD_NUMBER: _ClassVar[int]
    AVAILABLE_FEATURES_FIELD_NUMBER: _ClassVar[int]
    CIRCUIT_INFOS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CUSTOMER_NAME_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_OUTAGES_FIELD_NUMBER: _ClassVar[int]
    GOOGLE_IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    GOOGLE_REFERENCE_ID_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INTERCONNECT_ATTACHMENTS_FIELD_NUMBER: _ClassVar[int]
    INTERCONNECT_TYPE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LINK_TYPE_FIELD_NUMBER: _ClassVar[int]
    LOCATION_FIELD_NUMBER: _ClassVar[int]
    MACSEC_FIELD_NUMBER: _ClassVar[int]
    MACSEC_ENABLED_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NOC_CONTACT_EMAIL_FIELD_NUMBER: _ClassVar[int]
    OPERATIONAL_STATUS_FIELD_NUMBER: _ClassVar[int]
    PEER_IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PROVISIONED_LINK_COUNT_FIELD_NUMBER: _ClassVar[int]
    REMOTE_LOCATION_FIELD_NUMBER: _ClassVar[int]
    REQUESTED_FEATURES_FIELD_NUMBER: _ClassVar[int]
    REQUESTED_LINK_COUNT_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    admin_enabled: bool
    available_features: _containers.RepeatedScalarFieldContainer[str]
    circuit_infos: _containers.RepeatedCompositeFieldContainer[InterconnectCircuitInfo]
    creation_timestamp: str
    customer_name: str
    description: str
    expected_outages: _containers.RepeatedCompositeFieldContainer[InterconnectOutageNotification]
    google_ip_address: str
    google_reference_id: str
    id: int
    interconnect_attachments: _containers.RepeatedScalarFieldContainer[str]
    interconnect_type: str
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    link_type: str
    location: str
    macsec: InterconnectMacsec
    macsec_enabled: bool
    name: str
    noc_contact_email: str
    operational_status: str
    peer_ip_address: str
    provisioned_link_count: int
    remote_location: str
    requested_features: _containers.RepeatedScalarFieldContainer[str]
    requested_link_count: int
    satisfies_pzs: bool
    self_link: str
    state: str
    def __init__(self, admin_enabled: bool = ..., available_features: _Optional[_Iterable[str]] = ..., circuit_infos: _Optional[_Iterable[_Union[InterconnectCircuitInfo, _Mapping]]] = ..., creation_timestamp: _Optional[str] = ..., customer_name: _Optional[str] = ..., description: _Optional[str] = ..., expected_outages: _Optional[_Iterable[_Union[InterconnectOutageNotification, _Mapping]]] = ..., google_ip_address: _Optional[str] = ..., google_reference_id: _Optional[str] = ..., id: _Optional[int] = ..., interconnect_attachments: _Optional[_Iterable[str]] = ..., interconnect_type: _Optional[str] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., link_type: _Optional[str] = ..., location: _Optional[str] = ..., macsec: _Optional[_Union[InterconnectMacsec, _Mapping]] = ..., macsec_enabled: bool = ..., name: _Optional[str] = ..., noc_contact_email: _Optional[str] = ..., operational_status: _Optional[str] = ..., peer_ip_address: _Optional[str] = ..., provisioned_link_count: _Optional[int] = ..., remote_location: _Optional[str] = ..., requested_features: _Optional[_Iterable[str]] = ..., requested_link_count: _Optional[int] = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., state: _Optional[str] = ...) -> None: ...

class InterconnectAttachment(_message.Message):
    __slots__ = ("admin_enabled", "bandwidth", "candidate_ipv6_subnets", "candidate_subnets", "cloud_router_ip_address", "cloud_router_ipv6_address", "cloud_router_ipv6_interface_id", "configuration_constraints", "creation_timestamp", "customer_router_ip_address", "customer_router_ipv6_address", "customer_router_ipv6_interface_id", "dataplane_version", "description", "edge_availability_domain", "encryption", "google_reference_id", "id", "interconnect", "ipsec_internal_addresses", "kind", "label_fingerprint", "labels", "mtu", "name", "operational_status", "pairing_key", "partner_asn", "partner_metadata", "private_interconnect_info", "region", "remote_service", "router", "satisfies_pzs", "self_link", "stack_type", "state", "subnet_length", "type", "vlan_tag8021q")
    class Bandwidth(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BANDWIDTH: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_100G: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_100M: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_10G: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_1G: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_200M: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_20G: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_2G: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_300M: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_400M: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_500M: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_50G: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_50M: _ClassVar[InterconnectAttachment.Bandwidth]
        BPS_5G: _ClassVar[InterconnectAttachment.Bandwidth]
    UNDEFINED_BANDWIDTH: InterconnectAttachment.Bandwidth
    BPS_100G: InterconnectAttachment.Bandwidth
    BPS_100M: InterconnectAttachment.Bandwidth
    BPS_10G: InterconnectAttachment.Bandwidth
    BPS_1G: InterconnectAttachment.Bandwidth
    BPS_200M: InterconnectAttachment.Bandwidth
    BPS_20G: InterconnectAttachment.Bandwidth
    BPS_2G: InterconnectAttachment.Bandwidth
    BPS_300M: InterconnectAttachment.Bandwidth
    BPS_400M: InterconnectAttachment.Bandwidth
    BPS_500M: InterconnectAttachment.Bandwidth
    BPS_50G: InterconnectAttachment.Bandwidth
    BPS_50M: InterconnectAttachment.Bandwidth
    BPS_5G: InterconnectAttachment.Bandwidth
    class EdgeAvailabilityDomain(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_EDGE_AVAILABILITY_DOMAIN: _ClassVar[InterconnectAttachment.EdgeAvailabilityDomain]
        AVAILABILITY_DOMAIN_1: _ClassVar[InterconnectAttachment.EdgeAvailabilityDomain]
        AVAILABILITY_DOMAIN_2: _ClassVar[InterconnectAttachment.EdgeAvailabilityDomain]
        AVAILABILITY_DOMAIN_ANY: _ClassVar[InterconnectAttachment.EdgeAvailabilityDomain]
    UNDEFINED_EDGE_AVAILABILITY_DOMAIN: InterconnectAttachment.EdgeAvailabilityDomain
    AVAILABILITY_DOMAIN_1: InterconnectAttachment.EdgeAvailabilityDomain
    AVAILABILITY_DOMAIN_2: InterconnectAttachment.EdgeAvailabilityDomain
    AVAILABILITY_DOMAIN_ANY: InterconnectAttachment.EdgeAvailabilityDomain
    class Encryption(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ENCRYPTION: _ClassVar[InterconnectAttachment.Encryption]
        IPSEC: _ClassVar[InterconnectAttachment.Encryption]
        NONE: _ClassVar[InterconnectAttachment.Encryption]
    UNDEFINED_ENCRYPTION: InterconnectAttachment.Encryption
    IPSEC: InterconnectAttachment.Encryption
    NONE: InterconnectAttachment.Encryption
    class OperationalStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_OPERATIONAL_STATUS: _ClassVar[InterconnectAttachment.OperationalStatus]
        OS_ACTIVE: _ClassVar[InterconnectAttachment.OperationalStatus]
        OS_UNPROVISIONED: _ClassVar[InterconnectAttachment.OperationalStatus]
    UNDEFINED_OPERATIONAL_STATUS: InterconnectAttachment.OperationalStatus
    OS_ACTIVE: InterconnectAttachment.OperationalStatus
    OS_UNPROVISIONED: InterconnectAttachment.OperationalStatus
    class StackType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STACK_TYPE: _ClassVar[InterconnectAttachment.StackType]
        IPV4_IPV6: _ClassVar[InterconnectAttachment.StackType]
        IPV4_ONLY: _ClassVar[InterconnectAttachment.StackType]
    UNDEFINED_STACK_TYPE: InterconnectAttachment.StackType
    IPV4_IPV6: InterconnectAttachment.StackType
    IPV4_ONLY: InterconnectAttachment.StackType
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[InterconnectAttachment.State]
        ACTIVE: _ClassVar[InterconnectAttachment.State]
        DEFUNCT: _ClassVar[InterconnectAttachment.State]
        PARTNER_REQUEST_RECEIVED: _ClassVar[InterconnectAttachment.State]
        PENDING_CUSTOMER: _ClassVar[InterconnectAttachment.State]
        PENDING_PARTNER: _ClassVar[InterconnectAttachment.State]
        STATE_UNSPECIFIED: _ClassVar[InterconnectAttachment.State]
        UNPROVISIONED: _ClassVar[InterconnectAttachment.State]
    UNDEFINED_STATE: InterconnectAttachment.State
    ACTIVE: InterconnectAttachment.State
    DEFUNCT: InterconnectAttachment.State
    PARTNER_REQUEST_RECEIVED: InterconnectAttachment.State
    PENDING_CUSTOMER: InterconnectAttachment.State
    PENDING_PARTNER: InterconnectAttachment.State
    STATE_UNSPECIFIED: InterconnectAttachment.State
    UNPROVISIONED: InterconnectAttachment.State
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[InterconnectAttachment.Type]
        DEDICATED: _ClassVar[InterconnectAttachment.Type]
        PARTNER: _ClassVar[InterconnectAttachment.Type]
        PARTNER_PROVIDER: _ClassVar[InterconnectAttachment.Type]
    UNDEFINED_TYPE: InterconnectAttachment.Type
    DEDICATED: InterconnectAttachment.Type
    PARTNER: InterconnectAttachment.Type
    PARTNER_PROVIDER: InterconnectAttachment.Type
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ADMIN_ENABLED_FIELD_NUMBER: _ClassVar[int]
    BANDWIDTH_FIELD_NUMBER: _ClassVar[int]
    CANDIDATE_IPV6_SUBNETS_FIELD_NUMBER: _ClassVar[int]
    CANDIDATE_SUBNETS_FIELD_NUMBER: _ClassVar[int]
    CLOUD_ROUTER_IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    CLOUD_ROUTER_IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    CLOUD_ROUTER_IPV6_INTERFACE_ID_FIELD_NUMBER: _ClassVar[int]
    CONFIGURATION_CONSTRAINTS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CUSTOMER_ROUTER_IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    CUSTOMER_ROUTER_IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    CUSTOMER_ROUTER_IPV6_INTERFACE_ID_FIELD_NUMBER: _ClassVar[int]
    DATAPLANE_VERSION_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    EDGE_AVAILABILITY_DOMAIN_FIELD_NUMBER: _ClassVar[int]
    ENCRYPTION_FIELD_NUMBER: _ClassVar[int]
    GOOGLE_REFERENCE_ID_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INTERCONNECT_FIELD_NUMBER: _ClassVar[int]
    IPSEC_INTERNAL_ADDRESSES_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    MTU_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    OPERATIONAL_STATUS_FIELD_NUMBER: _ClassVar[int]
    PAIRING_KEY_FIELD_NUMBER: _ClassVar[int]
    PARTNER_ASN_FIELD_NUMBER: _ClassVar[int]
    PARTNER_METADATA_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_INTERCONNECT_INFO_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REMOTE_SERVICE_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STACK_TYPE_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    SUBNET_LENGTH_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    VLAN_TAG8021Q_FIELD_NUMBER: _ClassVar[int]
    admin_enabled: bool
    bandwidth: str
    candidate_ipv6_subnets: _containers.RepeatedScalarFieldContainer[str]
    candidate_subnets: _containers.RepeatedScalarFieldContainer[str]
    cloud_router_ip_address: str
    cloud_router_ipv6_address: str
    cloud_router_ipv6_interface_id: str
    configuration_constraints: InterconnectAttachmentConfigurationConstraints
    creation_timestamp: str
    customer_router_ip_address: str
    customer_router_ipv6_address: str
    customer_router_ipv6_interface_id: str
    dataplane_version: int
    description: str
    edge_availability_domain: str
    encryption: str
    google_reference_id: str
    id: int
    interconnect: str
    ipsec_internal_addresses: _containers.RepeatedScalarFieldContainer[str]
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    mtu: int
    name: str
    operational_status: str
    pairing_key: str
    partner_asn: int
    partner_metadata: InterconnectAttachmentPartnerMetadata
    private_interconnect_info: InterconnectAttachmentPrivateInfo
    region: str
    remote_service: str
    router: str
    satisfies_pzs: bool
    self_link: str
    stack_type: str
    state: str
    subnet_length: int
    type: str
    vlan_tag8021q: int
    def __init__(self, admin_enabled: bool = ..., bandwidth: _Optional[str] = ..., candidate_ipv6_subnets: _Optional[_Iterable[str]] = ..., candidate_subnets: _Optional[_Iterable[str]] = ..., cloud_router_ip_address: _Optional[str] = ..., cloud_router_ipv6_address: _Optional[str] = ..., cloud_router_ipv6_interface_id: _Optional[str] = ..., configuration_constraints: _Optional[_Union[InterconnectAttachmentConfigurationConstraints, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., customer_router_ip_address: _Optional[str] = ..., customer_router_ipv6_address: _Optional[str] = ..., customer_router_ipv6_interface_id: _Optional[str] = ..., dataplane_version: _Optional[int] = ..., description: _Optional[str] = ..., edge_availability_domain: _Optional[str] = ..., encryption: _Optional[str] = ..., google_reference_id: _Optional[str] = ..., id: _Optional[int] = ..., interconnect: _Optional[str] = ..., ipsec_internal_addresses: _Optional[_Iterable[str]] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., mtu: _Optional[int] = ..., name: _Optional[str] = ..., operational_status: _Optional[str] = ..., pairing_key: _Optional[str] = ..., partner_asn: _Optional[int] = ..., partner_metadata: _Optional[_Union[InterconnectAttachmentPartnerMetadata, _Mapping]] = ..., private_interconnect_info: _Optional[_Union[InterconnectAttachmentPrivateInfo, _Mapping]] = ..., region: _Optional[str] = ..., remote_service: _Optional[str] = ..., router: _Optional[str] = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., stack_type: _Optional[str] = ..., state: _Optional[str] = ..., subnet_length: _Optional[int] = ..., type: _Optional[str] = ..., vlan_tag8021q: _Optional[int] = ...) -> None: ...

class InterconnectAttachmentAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: InterconnectAttachmentsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InterconnectAttachmentsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, InterconnectAttachmentsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, InterconnectAttachmentsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InterconnectAttachmentConfigurationConstraints(_message.Message):
    __slots__ = ("bgp_md5", "bgp_peer_asn_ranges")
    class BgpMd5(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BGP_MD5: _ClassVar[InterconnectAttachmentConfigurationConstraints.BgpMd5]
        MD5_OPTIONAL: _ClassVar[InterconnectAttachmentConfigurationConstraints.BgpMd5]
        MD5_REQUIRED: _ClassVar[InterconnectAttachmentConfigurationConstraints.BgpMd5]
        MD5_UNSUPPORTED: _ClassVar[InterconnectAttachmentConfigurationConstraints.BgpMd5]
    UNDEFINED_BGP_MD5: InterconnectAttachmentConfigurationConstraints.BgpMd5
    MD5_OPTIONAL: InterconnectAttachmentConfigurationConstraints.BgpMd5
    MD5_REQUIRED: InterconnectAttachmentConfigurationConstraints.BgpMd5
    MD5_UNSUPPORTED: InterconnectAttachmentConfigurationConstraints.BgpMd5
    BGP_MD5_FIELD_NUMBER: _ClassVar[int]
    BGP_PEER_ASN_RANGES_FIELD_NUMBER: _ClassVar[int]
    bgp_md5: str
    bgp_peer_asn_ranges: _containers.RepeatedCompositeFieldContainer[InterconnectAttachmentConfigurationConstraintsBgpPeerASNRange]
    def __init__(self, bgp_md5: _Optional[str] = ..., bgp_peer_asn_ranges: _Optional[_Iterable[_Union[InterconnectAttachmentConfigurationConstraintsBgpPeerASNRange, _Mapping]]] = ...) -> None: ...

class InterconnectAttachmentConfigurationConstraintsBgpPeerASNRange(_message.Message):
    __slots__ = ("max", "min")
    MAX_FIELD_NUMBER: _ClassVar[int]
    MIN_FIELD_NUMBER: _ClassVar[int]
    max: int
    min: int
    def __init__(self, max: _Optional[int] = ..., min: _Optional[int] = ...) -> None: ...

class InterconnectAttachmentList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InterconnectAttachment]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InterconnectAttachment, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InterconnectAttachmentPartnerMetadata(_message.Message):
    __slots__ = ("interconnect_name", "partner_name", "portal_url")
    INTERCONNECT_NAME_FIELD_NUMBER: _ClassVar[int]
    PARTNER_NAME_FIELD_NUMBER: _ClassVar[int]
    PORTAL_URL_FIELD_NUMBER: _ClassVar[int]
    interconnect_name: str
    partner_name: str
    portal_url: str
    def __init__(self, interconnect_name: _Optional[str] = ..., partner_name: _Optional[str] = ..., portal_url: _Optional[str] = ...) -> None: ...

class InterconnectAttachmentPrivateInfo(_message.Message):
    __slots__ = ("tag8021q",)
    TAG8021Q_FIELD_NUMBER: _ClassVar[int]
    tag8021q: int
    def __init__(self, tag8021q: _Optional[int] = ...) -> None: ...

class InterconnectAttachmentsScopedList(_message.Message):
    __slots__ = ("interconnect_attachments", "warning")
    INTERCONNECT_ATTACHMENTS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    interconnect_attachments: _containers.RepeatedCompositeFieldContainer[InterconnectAttachment]
    warning: Warning
    def __init__(self, interconnect_attachments: _Optional[_Iterable[_Union[InterconnectAttachment, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InterconnectCircuitInfo(_message.Message):
    __slots__ = ("customer_demarc_id", "google_circuit_id", "google_demarc_id")
    CUSTOMER_DEMARC_ID_FIELD_NUMBER: _ClassVar[int]
    GOOGLE_CIRCUIT_ID_FIELD_NUMBER: _ClassVar[int]
    GOOGLE_DEMARC_ID_FIELD_NUMBER: _ClassVar[int]
    customer_demarc_id: str
    google_circuit_id: str
    google_demarc_id: str
    def __init__(self, customer_demarc_id: _Optional[str] = ..., google_circuit_id: _Optional[str] = ..., google_demarc_id: _Optional[str] = ...) -> None: ...

class InterconnectDiagnostics(_message.Message):
    __slots__ = ("arp_caches", "bundle_aggregation_type", "bundle_operational_status", "links", "mac_address")
    class BundleAggregationType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BUNDLE_AGGREGATION_TYPE: _ClassVar[InterconnectDiagnostics.BundleAggregationType]
        BUNDLE_AGGREGATION_TYPE_LACP: _ClassVar[InterconnectDiagnostics.BundleAggregationType]
        BUNDLE_AGGREGATION_TYPE_STATIC: _ClassVar[InterconnectDiagnostics.BundleAggregationType]
    UNDEFINED_BUNDLE_AGGREGATION_TYPE: InterconnectDiagnostics.BundleAggregationType
    BUNDLE_AGGREGATION_TYPE_LACP: InterconnectDiagnostics.BundleAggregationType
    BUNDLE_AGGREGATION_TYPE_STATIC: InterconnectDiagnostics.BundleAggregationType
    class BundleOperationalStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BUNDLE_OPERATIONAL_STATUS: _ClassVar[InterconnectDiagnostics.BundleOperationalStatus]
        BUNDLE_OPERATIONAL_STATUS_DOWN: _ClassVar[InterconnectDiagnostics.BundleOperationalStatus]
        BUNDLE_OPERATIONAL_STATUS_UP: _ClassVar[InterconnectDiagnostics.BundleOperationalStatus]
    UNDEFINED_BUNDLE_OPERATIONAL_STATUS: InterconnectDiagnostics.BundleOperationalStatus
    BUNDLE_OPERATIONAL_STATUS_DOWN: InterconnectDiagnostics.BundleOperationalStatus
    BUNDLE_OPERATIONAL_STATUS_UP: InterconnectDiagnostics.BundleOperationalStatus
    ARP_CACHES_FIELD_NUMBER: _ClassVar[int]
    BUNDLE_AGGREGATION_TYPE_FIELD_NUMBER: _ClassVar[int]
    BUNDLE_OPERATIONAL_STATUS_FIELD_NUMBER: _ClassVar[int]
    LINKS_FIELD_NUMBER: _ClassVar[int]
    MAC_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    arp_caches: _containers.RepeatedCompositeFieldContainer[InterconnectDiagnosticsARPEntry]
    bundle_aggregation_type: str
    bundle_operational_status: str
    links: _containers.RepeatedCompositeFieldContainer[InterconnectDiagnosticsLinkStatus]
    mac_address: str
    def __init__(self, arp_caches: _Optional[_Iterable[_Union[InterconnectDiagnosticsARPEntry, _Mapping]]] = ..., bundle_aggregation_type: _Optional[str] = ..., bundle_operational_status: _Optional[str] = ..., links: _Optional[_Iterable[_Union[InterconnectDiagnosticsLinkStatus, _Mapping]]] = ..., mac_address: _Optional[str] = ...) -> None: ...

class InterconnectDiagnosticsARPEntry(_message.Message):
    __slots__ = ("ip_address", "mac_address")
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    MAC_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    ip_address: str
    mac_address: str
    def __init__(self, ip_address: _Optional[str] = ..., mac_address: _Optional[str] = ...) -> None: ...

class InterconnectDiagnosticsLinkLACPStatus(_message.Message):
    __slots__ = ("google_system_id", "neighbor_system_id", "state")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[InterconnectDiagnosticsLinkLACPStatus.State]
        ACTIVE: _ClassVar[InterconnectDiagnosticsLinkLACPStatus.State]
        DETACHED: _ClassVar[InterconnectDiagnosticsLinkLACPStatus.State]
    UNDEFINED_STATE: InterconnectDiagnosticsLinkLACPStatus.State
    ACTIVE: InterconnectDiagnosticsLinkLACPStatus.State
    DETACHED: InterconnectDiagnosticsLinkLACPStatus.State
    GOOGLE_SYSTEM_ID_FIELD_NUMBER: _ClassVar[int]
    NEIGHBOR_SYSTEM_ID_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    google_system_id: str
    neighbor_system_id: str
    state: str
    def __init__(self, google_system_id: _Optional[str] = ..., neighbor_system_id: _Optional[str] = ..., state: _Optional[str] = ...) -> None: ...

class InterconnectDiagnosticsLinkOpticalPower(_message.Message):
    __slots__ = ("state", "value")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[InterconnectDiagnosticsLinkOpticalPower.State]
        HIGH_ALARM: _ClassVar[InterconnectDiagnosticsLinkOpticalPower.State]
        HIGH_WARNING: _ClassVar[InterconnectDiagnosticsLinkOpticalPower.State]
        LOW_ALARM: _ClassVar[InterconnectDiagnosticsLinkOpticalPower.State]
        LOW_WARNING: _ClassVar[InterconnectDiagnosticsLinkOpticalPower.State]
        OK: _ClassVar[InterconnectDiagnosticsLinkOpticalPower.State]
    UNDEFINED_STATE: InterconnectDiagnosticsLinkOpticalPower.State
    HIGH_ALARM: InterconnectDiagnosticsLinkOpticalPower.State
    HIGH_WARNING: InterconnectDiagnosticsLinkOpticalPower.State
    LOW_ALARM: InterconnectDiagnosticsLinkOpticalPower.State
    LOW_WARNING: InterconnectDiagnosticsLinkOpticalPower.State
    OK: InterconnectDiagnosticsLinkOpticalPower.State
    STATE_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    state: str
    value: float
    def __init__(self, state: _Optional[str] = ..., value: _Optional[float] = ...) -> None: ...

class InterconnectDiagnosticsLinkStatus(_message.Message):
    __slots__ = ("arp_caches", "circuit_id", "google_demarc", "lacp_status", "macsec", "operational_status", "receiving_optical_power", "transmitting_optical_power")
    class OperationalStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_OPERATIONAL_STATUS: _ClassVar[InterconnectDiagnosticsLinkStatus.OperationalStatus]
        LINK_OPERATIONAL_STATUS_DOWN: _ClassVar[InterconnectDiagnosticsLinkStatus.OperationalStatus]
        LINK_OPERATIONAL_STATUS_UP: _ClassVar[InterconnectDiagnosticsLinkStatus.OperationalStatus]
    UNDEFINED_OPERATIONAL_STATUS: InterconnectDiagnosticsLinkStatus.OperationalStatus
    LINK_OPERATIONAL_STATUS_DOWN: InterconnectDiagnosticsLinkStatus.OperationalStatus
    LINK_OPERATIONAL_STATUS_UP: InterconnectDiagnosticsLinkStatus.OperationalStatus
    ARP_CACHES_FIELD_NUMBER: _ClassVar[int]
    CIRCUIT_ID_FIELD_NUMBER: _ClassVar[int]
    GOOGLE_DEMARC_FIELD_NUMBER: _ClassVar[int]
    LACP_STATUS_FIELD_NUMBER: _ClassVar[int]
    MACSEC_FIELD_NUMBER: _ClassVar[int]
    OPERATIONAL_STATUS_FIELD_NUMBER: _ClassVar[int]
    RECEIVING_OPTICAL_POWER_FIELD_NUMBER: _ClassVar[int]
    TRANSMITTING_OPTICAL_POWER_FIELD_NUMBER: _ClassVar[int]
    arp_caches: _containers.RepeatedCompositeFieldContainer[InterconnectDiagnosticsARPEntry]
    circuit_id: str
    google_demarc: str
    lacp_status: InterconnectDiagnosticsLinkLACPStatus
    macsec: InterconnectDiagnosticsMacsecStatus
    operational_status: str
    receiving_optical_power: InterconnectDiagnosticsLinkOpticalPower
    transmitting_optical_power: InterconnectDiagnosticsLinkOpticalPower
    def __init__(self, arp_caches: _Optional[_Iterable[_Union[InterconnectDiagnosticsARPEntry, _Mapping]]] = ..., circuit_id: _Optional[str] = ..., google_demarc: _Optional[str] = ..., lacp_status: _Optional[_Union[InterconnectDiagnosticsLinkLACPStatus, _Mapping]] = ..., macsec: _Optional[_Union[InterconnectDiagnosticsMacsecStatus, _Mapping]] = ..., operational_status: _Optional[str] = ..., receiving_optical_power: _Optional[_Union[InterconnectDiagnosticsLinkOpticalPower, _Mapping]] = ..., transmitting_optical_power: _Optional[_Union[InterconnectDiagnosticsLinkOpticalPower, _Mapping]] = ...) -> None: ...

class InterconnectDiagnosticsMacsecStatus(_message.Message):
    __slots__ = ("ckn", "operational")
    CKN_FIELD_NUMBER: _ClassVar[int]
    OPERATIONAL_FIELD_NUMBER: _ClassVar[int]
    ckn: str
    operational: bool
    def __init__(self, ckn: _Optional[str] = ..., operational: bool = ...) -> None: ...

class InterconnectList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Interconnect]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Interconnect, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InterconnectLocation(_message.Message):
    __slots__ = ("address", "availability_zone", "available_features", "available_link_types", "city", "continent", "creation_timestamp", "description", "facility_provider", "facility_provider_facility_id", "id", "kind", "name", "peeringdb_facility_id", "region_infos", "self_link", "status", "supports_pzs")
    class AvailableFeatures(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AVAILABLE_FEATURES: _ClassVar[InterconnectLocation.AvailableFeatures]
        IF_MACSEC: _ClassVar[InterconnectLocation.AvailableFeatures]
    UNDEFINED_AVAILABLE_FEATURES: InterconnectLocation.AvailableFeatures
    IF_MACSEC: InterconnectLocation.AvailableFeatures
    class AvailableLinkTypes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AVAILABLE_LINK_TYPES: _ClassVar[InterconnectLocation.AvailableLinkTypes]
        LINK_TYPE_ETHERNET_100G_LR: _ClassVar[InterconnectLocation.AvailableLinkTypes]
        LINK_TYPE_ETHERNET_10G_LR: _ClassVar[InterconnectLocation.AvailableLinkTypes]
    UNDEFINED_AVAILABLE_LINK_TYPES: InterconnectLocation.AvailableLinkTypes
    LINK_TYPE_ETHERNET_100G_LR: InterconnectLocation.AvailableLinkTypes
    LINK_TYPE_ETHERNET_10G_LR: InterconnectLocation.AvailableLinkTypes
    class Continent(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONTINENT: _ClassVar[InterconnectLocation.Continent]
        AFRICA: _ClassVar[InterconnectLocation.Continent]
        ASIA_PAC: _ClassVar[InterconnectLocation.Continent]
        C_AFRICA: _ClassVar[InterconnectLocation.Continent]
        C_ASIA_PAC: _ClassVar[InterconnectLocation.Continent]
        C_EUROPE: _ClassVar[InterconnectLocation.Continent]
        C_NORTH_AMERICA: _ClassVar[InterconnectLocation.Continent]
        C_SOUTH_AMERICA: _ClassVar[InterconnectLocation.Continent]
        EUROPE: _ClassVar[InterconnectLocation.Continent]
        NORTH_AMERICA: _ClassVar[InterconnectLocation.Continent]
        SOUTH_AMERICA: _ClassVar[InterconnectLocation.Continent]
    UNDEFINED_CONTINENT: InterconnectLocation.Continent
    AFRICA: InterconnectLocation.Continent
    ASIA_PAC: InterconnectLocation.Continent
    C_AFRICA: InterconnectLocation.Continent
    C_ASIA_PAC: InterconnectLocation.Continent
    C_EUROPE: InterconnectLocation.Continent
    C_NORTH_AMERICA: InterconnectLocation.Continent
    C_SOUTH_AMERICA: InterconnectLocation.Continent
    EUROPE: InterconnectLocation.Continent
    NORTH_AMERICA: InterconnectLocation.Continent
    SOUTH_AMERICA: InterconnectLocation.Continent
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[InterconnectLocation.Status]
        AVAILABLE: _ClassVar[InterconnectLocation.Status]
        CLOSED: _ClassVar[InterconnectLocation.Status]
    UNDEFINED_STATUS: InterconnectLocation.Status
    AVAILABLE: InterconnectLocation.Status
    CLOSED: InterconnectLocation.Status
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    AVAILABILITY_ZONE_FIELD_NUMBER: _ClassVar[int]
    AVAILABLE_FEATURES_FIELD_NUMBER: _ClassVar[int]
    AVAILABLE_LINK_TYPES_FIELD_NUMBER: _ClassVar[int]
    CITY_FIELD_NUMBER: _ClassVar[int]
    CONTINENT_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FACILITY_PROVIDER_FIELD_NUMBER: _ClassVar[int]
    FACILITY_PROVIDER_FACILITY_ID_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PEERINGDB_FACILITY_ID_FIELD_NUMBER: _ClassVar[int]
    REGION_INFOS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUPPORTS_PZS_FIELD_NUMBER: _ClassVar[int]
    address: str
    availability_zone: str
    available_features: _containers.RepeatedScalarFieldContainer[str]
    available_link_types: _containers.RepeatedScalarFieldContainer[str]
    city: str
    continent: str
    creation_timestamp: str
    description: str
    facility_provider: str
    facility_provider_facility_id: str
    id: int
    kind: str
    name: str
    peeringdb_facility_id: str
    region_infos: _containers.RepeatedCompositeFieldContainer[InterconnectLocationRegionInfo]
    self_link: str
    status: str
    supports_pzs: bool
    def __init__(self, address: _Optional[str] = ..., availability_zone: _Optional[str] = ..., available_features: _Optional[_Iterable[str]] = ..., available_link_types: _Optional[_Iterable[str]] = ..., city: _Optional[str] = ..., continent: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., facility_provider: _Optional[str] = ..., facility_provider_facility_id: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., peeringdb_facility_id: _Optional[str] = ..., region_infos: _Optional[_Iterable[_Union[InterconnectLocationRegionInfo, _Mapping]]] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ..., supports_pzs: bool = ...) -> None: ...

class InterconnectLocationList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InterconnectLocation]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InterconnectLocation, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InterconnectLocationRegionInfo(_message.Message):
    __slots__ = ("expected_rtt_ms", "location_presence", "region")
    class LocationPresence(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOCATION_PRESENCE: _ClassVar[InterconnectLocationRegionInfo.LocationPresence]
        GLOBAL: _ClassVar[InterconnectLocationRegionInfo.LocationPresence]
        LOCAL_REGION: _ClassVar[InterconnectLocationRegionInfo.LocationPresence]
        LP_GLOBAL: _ClassVar[InterconnectLocationRegionInfo.LocationPresence]
        LP_LOCAL_REGION: _ClassVar[InterconnectLocationRegionInfo.LocationPresence]
    UNDEFINED_LOCATION_PRESENCE: InterconnectLocationRegionInfo.LocationPresence
    GLOBAL: InterconnectLocationRegionInfo.LocationPresence
    LOCAL_REGION: InterconnectLocationRegionInfo.LocationPresence
    LP_GLOBAL: InterconnectLocationRegionInfo.LocationPresence
    LP_LOCAL_REGION: InterconnectLocationRegionInfo.LocationPresence
    EXPECTED_RTT_MS_FIELD_NUMBER: _ClassVar[int]
    LOCATION_PRESENCE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    expected_rtt_ms: int
    location_presence: str
    region: str
    def __init__(self, expected_rtt_ms: _Optional[int] = ..., location_presence: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class InterconnectMacsec(_message.Message):
    __slots__ = ("fail_open", "pre_shared_keys")
    FAIL_OPEN_FIELD_NUMBER: _ClassVar[int]
    PRE_SHARED_KEYS_FIELD_NUMBER: _ClassVar[int]
    fail_open: bool
    pre_shared_keys: _containers.RepeatedCompositeFieldContainer[InterconnectMacsecPreSharedKey]
    def __init__(self, fail_open: bool = ..., pre_shared_keys: _Optional[_Iterable[_Union[InterconnectMacsecPreSharedKey, _Mapping]]] = ...) -> None: ...

class InterconnectMacsecConfig(_message.Message):
    __slots__ = ("pre_shared_keys",)
    PRE_SHARED_KEYS_FIELD_NUMBER: _ClassVar[int]
    pre_shared_keys: _containers.RepeatedCompositeFieldContainer[InterconnectMacsecConfigPreSharedKey]
    def __init__(self, pre_shared_keys: _Optional[_Iterable[_Union[InterconnectMacsecConfigPreSharedKey, _Mapping]]] = ...) -> None: ...

class InterconnectMacsecConfigPreSharedKey(_message.Message):
    __slots__ = ("cak", "ckn", "name", "start_time")
    CAK_FIELD_NUMBER: _ClassVar[int]
    CKN_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    cak: str
    ckn: str
    name: str
    start_time: str
    def __init__(self, cak: _Optional[str] = ..., ckn: _Optional[str] = ..., name: _Optional[str] = ..., start_time: _Optional[str] = ...) -> None: ...

class InterconnectMacsecPreSharedKey(_message.Message):
    __slots__ = ("name", "start_time")
    NAME_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    name: str
    start_time: str
    def __init__(self, name: _Optional[str] = ..., start_time: _Optional[str] = ...) -> None: ...

class InterconnectOutageNotification(_message.Message):
    __slots__ = ("affected_circuits", "description", "end_time", "issue_type", "name", "source", "start_time", "state")
    class IssueType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ISSUE_TYPE: _ClassVar[InterconnectOutageNotification.IssueType]
        IT_OUTAGE: _ClassVar[InterconnectOutageNotification.IssueType]
        IT_PARTIAL_OUTAGE: _ClassVar[InterconnectOutageNotification.IssueType]
        OUTAGE: _ClassVar[InterconnectOutageNotification.IssueType]
        PARTIAL_OUTAGE: _ClassVar[InterconnectOutageNotification.IssueType]
    UNDEFINED_ISSUE_TYPE: InterconnectOutageNotification.IssueType
    IT_OUTAGE: InterconnectOutageNotification.IssueType
    IT_PARTIAL_OUTAGE: InterconnectOutageNotification.IssueType
    OUTAGE: InterconnectOutageNotification.IssueType
    PARTIAL_OUTAGE: InterconnectOutageNotification.IssueType
    class Source(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SOURCE: _ClassVar[InterconnectOutageNotification.Source]
        GOOGLE: _ClassVar[InterconnectOutageNotification.Source]
        NSRC_GOOGLE: _ClassVar[InterconnectOutageNotification.Source]
    UNDEFINED_SOURCE: InterconnectOutageNotification.Source
    GOOGLE: InterconnectOutageNotification.Source
    NSRC_GOOGLE: InterconnectOutageNotification.Source
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[InterconnectOutageNotification.State]
        ACTIVE: _ClassVar[InterconnectOutageNotification.State]
        CANCELLED: _ClassVar[InterconnectOutageNotification.State]
        COMPLETED: _ClassVar[InterconnectOutageNotification.State]
        NS_ACTIVE: _ClassVar[InterconnectOutageNotification.State]
        NS_CANCELED: _ClassVar[InterconnectOutageNotification.State]
    UNDEFINED_STATE: InterconnectOutageNotification.State
    ACTIVE: InterconnectOutageNotification.State
    CANCELLED: InterconnectOutageNotification.State
    COMPLETED: InterconnectOutageNotification.State
    NS_ACTIVE: InterconnectOutageNotification.State
    NS_CANCELED: InterconnectOutageNotification.State
    AFFECTED_CIRCUITS_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    END_TIME_FIELD_NUMBER: _ClassVar[int]
    ISSUE_TYPE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    affected_circuits: _containers.RepeatedScalarFieldContainer[str]
    description: str
    end_time: int
    issue_type: str
    name: str
    source: str
    start_time: int
    state: str
    def __init__(self, affected_circuits: _Optional[_Iterable[str]] = ..., description: _Optional[str] = ..., end_time: _Optional[int] = ..., issue_type: _Optional[str] = ..., name: _Optional[str] = ..., source: _Optional[str] = ..., start_time: _Optional[int] = ..., state: _Optional[str] = ...) -> None: ...

class InterconnectRemoteLocation(_message.Message):
    __slots__ = ("address", "attachment_configuration_constraints", "city", "constraints", "continent", "creation_timestamp", "description", "facility_provider", "facility_provider_facility_id", "id", "kind", "lacp", "max_lag_size100_gbps", "max_lag_size10_gbps", "name", "peeringdb_facility_id", "permitted_connections", "remote_service", "self_link", "status")
    class Continent(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONTINENT: _ClassVar[InterconnectRemoteLocation.Continent]
        AFRICA: _ClassVar[InterconnectRemoteLocation.Continent]
        ASIA_PAC: _ClassVar[InterconnectRemoteLocation.Continent]
        EUROPE: _ClassVar[InterconnectRemoteLocation.Continent]
        NORTH_AMERICA: _ClassVar[InterconnectRemoteLocation.Continent]
        SOUTH_AMERICA: _ClassVar[InterconnectRemoteLocation.Continent]
    UNDEFINED_CONTINENT: InterconnectRemoteLocation.Continent
    AFRICA: InterconnectRemoteLocation.Continent
    ASIA_PAC: InterconnectRemoteLocation.Continent
    EUROPE: InterconnectRemoteLocation.Continent
    NORTH_AMERICA: InterconnectRemoteLocation.Continent
    SOUTH_AMERICA: InterconnectRemoteLocation.Continent
    class Lacp(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LACP: _ClassVar[InterconnectRemoteLocation.Lacp]
        LACP_SUPPORTED: _ClassVar[InterconnectRemoteLocation.Lacp]
        LACP_UNSUPPORTED: _ClassVar[InterconnectRemoteLocation.Lacp]
    UNDEFINED_LACP: InterconnectRemoteLocation.Lacp
    LACP_SUPPORTED: InterconnectRemoteLocation.Lacp
    LACP_UNSUPPORTED: InterconnectRemoteLocation.Lacp
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[InterconnectRemoteLocation.Status]
        AVAILABLE: _ClassVar[InterconnectRemoteLocation.Status]
        CLOSED: _ClassVar[InterconnectRemoteLocation.Status]
    UNDEFINED_STATUS: InterconnectRemoteLocation.Status
    AVAILABLE: InterconnectRemoteLocation.Status
    CLOSED: InterconnectRemoteLocation.Status
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    ATTACHMENT_CONFIGURATION_CONSTRAINTS_FIELD_NUMBER: _ClassVar[int]
    CITY_FIELD_NUMBER: _ClassVar[int]
    CONSTRAINTS_FIELD_NUMBER: _ClassVar[int]
    CONTINENT_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FACILITY_PROVIDER_FIELD_NUMBER: _ClassVar[int]
    FACILITY_PROVIDER_FACILITY_ID_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LACP_FIELD_NUMBER: _ClassVar[int]
    MAX_LAG_SIZE100_GBPS_FIELD_NUMBER: _ClassVar[int]
    MAX_LAG_SIZE10_GBPS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PEERINGDB_FACILITY_ID_FIELD_NUMBER: _ClassVar[int]
    PERMITTED_CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    REMOTE_SERVICE_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    address: str
    attachment_configuration_constraints: InterconnectAttachmentConfigurationConstraints
    city: str
    constraints: InterconnectRemoteLocationConstraints
    continent: str
    creation_timestamp: str
    description: str
    facility_provider: str
    facility_provider_facility_id: str
    id: int
    kind: str
    lacp: str
    max_lag_size100_gbps: int
    max_lag_size10_gbps: int
    name: str
    peeringdb_facility_id: str
    permitted_connections: _containers.RepeatedCompositeFieldContainer[InterconnectRemoteLocationPermittedConnections]
    remote_service: str
    self_link: str
    status: str
    def __init__(self, address: _Optional[str] = ..., attachment_configuration_constraints: _Optional[_Union[InterconnectAttachmentConfigurationConstraints, _Mapping]] = ..., city: _Optional[str] = ..., constraints: _Optional[_Union[InterconnectRemoteLocationConstraints, _Mapping]] = ..., continent: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., facility_provider: _Optional[str] = ..., facility_provider_facility_id: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., lacp: _Optional[str] = ..., max_lag_size100_gbps: _Optional[int] = ..., max_lag_size10_gbps: _Optional[int] = ..., name: _Optional[str] = ..., peeringdb_facility_id: _Optional[str] = ..., permitted_connections: _Optional[_Iterable[_Union[InterconnectRemoteLocationPermittedConnections, _Mapping]]] = ..., remote_service: _Optional[str] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ...) -> None: ...

class InterconnectRemoteLocationConstraints(_message.Message):
    __slots__ = ("port_pair_remote_location", "port_pair_vlan", "subnet_length_range")
    class PortPairRemoteLocation(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_PAIR_REMOTE_LOCATION: _ClassVar[InterconnectRemoteLocationConstraints.PortPairRemoteLocation]
        PORT_PAIR_MATCHING_REMOTE_LOCATION: _ClassVar[InterconnectRemoteLocationConstraints.PortPairRemoteLocation]
        PORT_PAIR_UNCONSTRAINED_REMOTE_LOCATION: _ClassVar[InterconnectRemoteLocationConstraints.PortPairRemoteLocation]
    UNDEFINED_PORT_PAIR_REMOTE_LOCATION: InterconnectRemoteLocationConstraints.PortPairRemoteLocation
    PORT_PAIR_MATCHING_REMOTE_LOCATION: InterconnectRemoteLocationConstraints.PortPairRemoteLocation
    PORT_PAIR_UNCONSTRAINED_REMOTE_LOCATION: InterconnectRemoteLocationConstraints.PortPairRemoteLocation
    class PortPairVlan(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_PAIR_VLAN: _ClassVar[InterconnectRemoteLocationConstraints.PortPairVlan]
        PORT_PAIR_MATCHING_VLAN: _ClassVar[InterconnectRemoteLocationConstraints.PortPairVlan]
        PORT_PAIR_UNCONSTRAINED_VLAN: _ClassVar[InterconnectRemoteLocationConstraints.PortPairVlan]
    UNDEFINED_PORT_PAIR_VLAN: InterconnectRemoteLocationConstraints.PortPairVlan
    PORT_PAIR_MATCHING_VLAN: InterconnectRemoteLocationConstraints.PortPairVlan
    PORT_PAIR_UNCONSTRAINED_VLAN: InterconnectRemoteLocationConstraints.PortPairVlan
    PORT_PAIR_REMOTE_LOCATION_FIELD_NUMBER: _ClassVar[int]
    PORT_PAIR_VLAN_FIELD_NUMBER: _ClassVar[int]
    SUBNET_LENGTH_RANGE_FIELD_NUMBER: _ClassVar[int]
    port_pair_remote_location: str
    port_pair_vlan: str
    subnet_length_range: InterconnectRemoteLocationConstraintsSubnetLengthRange
    def __init__(self, port_pair_remote_location: _Optional[str] = ..., port_pair_vlan: _Optional[str] = ..., subnet_length_range: _Optional[_Union[InterconnectRemoteLocationConstraintsSubnetLengthRange, _Mapping]] = ...) -> None: ...

class InterconnectRemoteLocationConstraintsSubnetLengthRange(_message.Message):
    __slots__ = ("max", "min")
    MAX_FIELD_NUMBER: _ClassVar[int]
    MIN_FIELD_NUMBER: _ClassVar[int]
    max: int
    min: int
    def __init__(self, max: _Optional[int] = ..., min: _Optional[int] = ...) -> None: ...

class InterconnectRemoteLocationList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InterconnectRemoteLocation]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InterconnectRemoteLocation, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class InterconnectRemoteLocationPermittedConnections(_message.Message):
    __slots__ = ("interconnect_location",)
    INTERCONNECT_LOCATION_FIELD_NUMBER: _ClassVar[int]
    interconnect_location: str
    def __init__(self, interconnect_location: _Optional[str] = ...) -> None: ...

class InterconnectsGetDiagnosticsResponse(_message.Message):
    __slots__ = ("result",)
    RESULT_FIELD_NUMBER: _ClassVar[int]
    result: InterconnectDiagnostics
    def __init__(self, result: _Optional[_Union[InterconnectDiagnostics, _Mapping]] = ...) -> None: ...

class InterconnectsGetMacsecConfigResponse(_message.Message):
    __slots__ = ("etag", "result")
    ETAG_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    etag: str
    result: InterconnectMacsecConfig
    def __init__(self, etag: _Optional[str] = ..., result: _Optional[_Union[InterconnectMacsecConfig, _Mapping]] = ...) -> None: ...

class InvalidateCacheUrlMapRequest(_message.Message):
    __slots__ = ("cache_invalidation_rule_resource", "project", "request_id", "url_map")
    CACHE_INVALIDATION_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    cache_invalidation_rule_resource: CacheInvalidationRule
    project: str
    request_id: str
    url_map: str
    def __init__(self, cache_invalidation_rule_resource: _Optional[_Union[CacheInvalidationRule, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map: _Optional[str] = ...) -> None: ...

class Items(_message.Message):
    __slots__ = ("key", "value")
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    value: str
    def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class License(_message.Message):
    __slots__ = ("charges_use_fee", "creation_timestamp", "description", "id", "kind", "license_code", "name", "resource_requirements", "self_link", "transferable")
    CHARGES_USE_FEE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LICENSE_CODE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_REQUIREMENTS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    TRANSFERABLE_FIELD_NUMBER: _ClassVar[int]
    charges_use_fee: bool
    creation_timestamp: str
    description: str
    id: int
    kind: str
    license_code: int
    name: str
    resource_requirements: LicenseResourceRequirements
    self_link: str
    transferable: bool
    def __init__(self, charges_use_fee: bool = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., license_code: _Optional[int] = ..., name: _Optional[str] = ..., resource_requirements: _Optional[_Union[LicenseResourceRequirements, _Mapping]] = ..., self_link: _Optional[str] = ..., transferable: bool = ...) -> None: ...

class LicenseCode(_message.Message):
    __slots__ = ("creation_timestamp", "description", "id", "kind", "license_alias", "name", "self_link", "state", "transferable")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[LicenseCode.State]
        DISABLED: _ClassVar[LicenseCode.State]
        ENABLED: _ClassVar[LicenseCode.State]
        RESTRICTED: _ClassVar[LicenseCode.State]
        STATE_UNSPECIFIED: _ClassVar[LicenseCode.State]
        TERMINATED: _ClassVar[LicenseCode.State]
    UNDEFINED_STATE: LicenseCode.State
    DISABLED: LicenseCode.State
    ENABLED: LicenseCode.State
    RESTRICTED: LicenseCode.State
    STATE_UNSPECIFIED: LicenseCode.State
    TERMINATED: LicenseCode.State
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LICENSE_ALIAS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TRANSFERABLE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    id: int
    kind: str
    license_alias: _containers.RepeatedCompositeFieldContainer[LicenseCodeLicenseAlias]
    name: str
    self_link: str
    state: str
    transferable: bool
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., license_alias: _Optional[_Iterable[_Union[LicenseCodeLicenseAlias, _Mapping]]] = ..., name: _Optional[str] = ..., self_link: _Optional[str] = ..., state: _Optional[str] = ..., transferable: bool = ...) -> None: ...

class LicenseCodeLicenseAlias(_message.Message):
    __slots__ = ("description", "self_link")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    description: str
    self_link: str
    def __init__(self, description: _Optional[str] = ..., self_link: _Optional[str] = ...) -> None: ...

class LicenseResourceCommitment(_message.Message):
    __slots__ = ("amount", "cores_per_license", "license")
    AMOUNT_FIELD_NUMBER: _ClassVar[int]
    CORES_PER_LICENSE_FIELD_NUMBER: _ClassVar[int]
    LICENSE_FIELD_NUMBER: _ClassVar[int]
    amount: int
    cores_per_license: str
    license: str
    def __init__(self, amount: _Optional[int] = ..., cores_per_license: _Optional[str] = ..., license: _Optional[str] = ...) -> None: ...

class LicenseResourceRequirements(_message.Message):
    __slots__ = ("min_guest_cpu_count", "min_memory_mb")
    MIN_GUEST_CPU_COUNT_FIELD_NUMBER: _ClassVar[int]
    MIN_MEMORY_MB_FIELD_NUMBER: _ClassVar[int]
    min_guest_cpu_count: int
    min_memory_mb: int
    def __init__(self, min_guest_cpu_count: _Optional[int] = ..., min_memory_mb: _Optional[int] = ...) -> None: ...

class LicensesListResponse(_message.Message):
    __slots__ = ("id", "items", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[License]
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[License, _Mapping]]] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ListAcceleratorTypesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListAddressesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListAssociationsFirewallPolicyRequest(_message.Message):
    __slots__ = ("target_resource",)
    TARGET_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    target_resource: str
    def __init__(self, target_resource: _Optional[str] = ...) -> None: ...

class ListAutoscalersRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListAvailableFeaturesRegionSslPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListAvailableFeaturesSslPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListBackendBucketsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListBackendServicesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListDiskTypesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListDisksRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListDisksStoragePoolsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "storage_pool", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    storage_pool: str
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., storage_pool: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class ListErrorsInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "instance_group_manager", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group_manager: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., instance_group_manager: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListErrorsRegionInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "instance_group_manager", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group_manager: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., instance_group_manager: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListExternalVpnGatewaysRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListFirewallPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "parent_id", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PARENT_ID_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    parent_id: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., parent_id: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListFirewallsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListForwardingRulesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListGlobalAddressesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListGlobalForwardingRulesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListGlobalNetworkEndpointGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListGlobalOperationsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListGlobalOrganizationOperationsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "parent_id", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PARENT_ID_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    parent_id: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., parent_id: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListGlobalPublicDelegatedPrefixesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListHealthChecksRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListImagesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListInstanceGroupManagerResizeRequestsRequest(_message.Message):
    __slots__ = ("filter", "instance_group_manager", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group_manager: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., instance_group_manager: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListInstanceGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListInstanceTemplatesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListInstancesInstanceGroupsRequest(_message.Message):
    __slots__ = ("filter", "instance_group", "instance_groups_list_instances_request_resource", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUPS_LIST_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group: str
    instance_groups_list_instances_request_resource: InstanceGroupsListInstancesRequest
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., instance_group: _Optional[str] = ..., instance_groups_list_instances_request_resource: _Optional[_Union[InstanceGroupsListInstancesRequest, _Mapping]] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListInstancesRegionInstanceGroupsRequest(_message.Message):
    __slots__ = ("filter", "instance_group", "max_results", "order_by", "page_token", "project", "region", "region_instance_groups_list_instances_request_resource", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUPS_LIST_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    region_instance_groups_list_instances_request_resource: RegionInstanceGroupsListInstancesRequest
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., instance_group: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_groups_list_instances_request_resource: _Optional[_Union[RegionInstanceGroupsListInstancesRequest, _Mapping]] = ..., return_partial_success: bool = ...) -> None: ...

class ListInstancesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListInstantSnapshotsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListInterconnectAttachmentsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListInterconnectLocationsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListInterconnectRemoteLocationsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListInterconnectsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListLicensesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListMachineImagesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListMachineTypesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListManagedInstancesInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "instance_group_manager", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group_manager: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., instance_group_manager: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListManagedInstancesRegionInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "instance_group_manager", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group_manager: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., instance_group_manager: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNetworkAttachmentsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNetworkEndpointGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "network_endpoint_group", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    network_endpoint_group: str
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., network_endpoint_group: _Optional[str] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNetworkEndpointsNetworkEndpointGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "network_endpoint_group", "network_endpoint_groups_list_endpoints_request_resource", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUPS_LIST_ENDPOINTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    network_endpoint_group: str
    network_endpoint_groups_list_endpoints_request_resource: NetworkEndpointGroupsListEndpointsRequest
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., network_endpoint_group: _Optional[str] = ..., network_endpoint_groups_list_endpoints_request_resource: _Optional[_Union[NetworkEndpointGroupsListEndpointsRequest, _Mapping]] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListNetworkEndpointsRegionNetworkEndpointGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "network_endpoint_group", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_GROUP_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    network_endpoint_group: str
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., network_endpoint_group: _Optional[str] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNetworkFirewallPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNetworkProfilesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNetworksRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNodeGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListNodeTemplatesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListNodeTypesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListNodesNodeGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "node_group", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    node_group: str
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., node_group: _Optional[str] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListPacketMirroringsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListPeeringRoutesNetworksRequest(_message.Message):
    __slots__ = ("direction", "filter", "max_results", "network", "order_by", "page_token", "peering_name", "project", "region", "return_partial_success")
    class Direction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DIRECTION: _ClassVar[ListPeeringRoutesNetworksRequest.Direction]
        INCOMING: _ClassVar[ListPeeringRoutesNetworksRequest.Direction]
        OUTGOING: _ClassVar[ListPeeringRoutesNetworksRequest.Direction]
    UNDEFINED_DIRECTION: ListPeeringRoutesNetworksRequest.Direction
    INCOMING: ListPeeringRoutesNetworksRequest.Direction
    OUTGOING: ListPeeringRoutesNetworksRequest.Direction
    DIRECTION_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PEERING_NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    direction: str
    filter: str
    max_results: int
    network: str
    order_by: str
    page_token: str
    peering_name: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, direction: _Optional[str] = ..., filter: _Optional[str] = ..., max_results: _Optional[int] = ..., network: _Optional[str] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., peering_name: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListPerInstanceConfigsInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "instance_group_manager", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group_manager: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., instance_group_manager: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListPerInstanceConfigsRegionInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "instance_group_manager", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance_group_manager: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., instance_group_manager: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListPreconfiguredExpressionSetsSecurityPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListPublicAdvertisedPrefixesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListPublicDelegatedPrefixesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListReferrersInstancesRequest(_message.Message):
    __slots__ = ("filter", "instance", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    instance: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., instance: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListRegionAutoscalersRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionBackendServicesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionCommitmentsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionDiskTypesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionDisksRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionHealthCheckServicesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionHealthChecksRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionInstanceGroupManagersRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionInstanceGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionInstanceTemplatesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionInstantSnapshotsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionNetworkEndpointGroupsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionNetworkFirewallPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionNotificationEndpointsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionOperationsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionSecurityPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionSslCertificatesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionSslPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionTargetHttpProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionTargetHttpsProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionTargetTcpProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionUrlMapsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionZonesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRegionsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListReservationsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListResourcePoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRoutersRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListRoutesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListSecurityPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListServiceAttachmentsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListSnapshotsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListSslCertificatesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListSslPoliciesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListStoragePoolTypesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListStoragePoolsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListSubnetworksRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListTargetGrpcProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListTargetHttpProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListTargetHttpsProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListTargetInstancesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListTargetPoolsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListTargetSslProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListTargetTcpProxiesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListTargetVpnGatewaysRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListUrlMapsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListUsableBackendServicesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListUsableRegionBackendServicesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListUsableSubnetworksRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListVpnGatewaysRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListVpnTunnelsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "region", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    region: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class ListXpnHostsProjectsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "projects_list_xpn_hosts_request_resource", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PROJECTS_LIST_XPN_HOSTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    projects_list_xpn_hosts_request_resource: ProjectsListXpnHostsRequest
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., projects_list_xpn_hosts_request_resource: _Optional[_Union[ProjectsListXpnHostsRequest, _Mapping]] = ..., return_partial_success: bool = ...) -> None: ...

class ListZoneOperationsRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success", "zone")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    zone: str
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ..., zone: _Optional[str] = ...) -> None: ...

class ListZonesRequest(_message.Message):
    __slots__ = ("filter", "max_results", "order_by", "page_token", "project", "return_partial_success")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    MAX_RESULTS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RETURN_PARTIAL_SUCCESS_FIELD_NUMBER: _ClassVar[int]
    filter: str
    max_results: int
    order_by: str
    page_token: str
    project: str
    return_partial_success: bool
    def __init__(self, filter: _Optional[str] = ..., max_results: _Optional[int] = ..., order_by: _Optional[str] = ..., page_token: _Optional[str] = ..., project: _Optional[str] = ..., return_partial_success: bool = ...) -> None: ...

class LocalDisk(_message.Message):
    __slots__ = ("disk_count", "disk_size_gb", "disk_type")
    DISK_COUNT_FIELD_NUMBER: _ClassVar[int]
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    DISK_TYPE_FIELD_NUMBER: _ClassVar[int]
    disk_count: int
    disk_size_gb: int
    disk_type: str
    def __init__(self, disk_count: _Optional[int] = ..., disk_size_gb: _Optional[int] = ..., disk_type: _Optional[str] = ...) -> None: ...

class LocalizedMessage(_message.Message):
    __slots__ = ("locale", "message")
    LOCALE_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    locale: str
    message: str
    def __init__(self, locale: _Optional[str] = ..., message: _Optional[str] = ...) -> None: ...

class LocationPolicy(_message.Message):
    __slots__ = ("locations", "target_shape")
    class TargetShape(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TARGET_SHAPE: _ClassVar[LocationPolicy.TargetShape]
        ANY: _ClassVar[LocationPolicy.TargetShape]
        ANY_SINGLE_ZONE: _ClassVar[LocationPolicy.TargetShape]
        BALANCED: _ClassVar[LocationPolicy.TargetShape]
    UNDEFINED_TARGET_SHAPE: LocationPolicy.TargetShape
    ANY: LocationPolicy.TargetShape
    ANY_SINGLE_ZONE: LocationPolicy.TargetShape
    BALANCED: LocationPolicy.TargetShape
    class LocationsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: LocationPolicyLocation
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[LocationPolicyLocation, _Mapping]] = ...) -> None: ...
    LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    TARGET_SHAPE_FIELD_NUMBER: _ClassVar[int]
    locations: _containers.MessageMap[str, LocationPolicyLocation]
    target_shape: str
    def __init__(self, locations: _Optional[_Mapping[str, LocationPolicyLocation]] = ..., target_shape: _Optional[str] = ...) -> None: ...

class LocationPolicyLocation(_message.Message):
    __slots__ = ("constraints", "preference")
    class Preference(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PREFERENCE: _ClassVar[LocationPolicyLocation.Preference]
        ALLOW: _ClassVar[LocationPolicyLocation.Preference]
        DENY: _ClassVar[LocationPolicyLocation.Preference]
        PREFERENCE_UNSPECIFIED: _ClassVar[LocationPolicyLocation.Preference]
    UNDEFINED_PREFERENCE: LocationPolicyLocation.Preference
    ALLOW: LocationPolicyLocation.Preference
    DENY: LocationPolicyLocation.Preference
    PREFERENCE_UNSPECIFIED: LocationPolicyLocation.Preference
    CONSTRAINTS_FIELD_NUMBER: _ClassVar[int]
    PREFERENCE_FIELD_NUMBER: _ClassVar[int]
    constraints: LocationPolicyLocationConstraints
    preference: str
    def __init__(self, constraints: _Optional[_Union[LocationPolicyLocationConstraints, _Mapping]] = ..., preference: _Optional[str] = ...) -> None: ...

class LocationPolicyLocationConstraints(_message.Message):
    __slots__ = ("max_count",)
    MAX_COUNT_FIELD_NUMBER: _ClassVar[int]
    max_count: int
    def __init__(self, max_count: _Optional[int] = ...) -> None: ...

class MachineImage(_message.Message):
    __slots__ = ("creation_timestamp", "description", "guest_flush", "id", "instance_properties", "kind", "machine_image_encryption_key", "name", "satisfies_pzi", "satisfies_pzs", "saved_disks", "self_link", "source_disk_encryption_keys", "source_instance", "source_instance_properties", "status", "storage_locations", "total_storage_bytes")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[MachineImage.Status]
        CREATING: _ClassVar[MachineImage.Status]
        DELETING: _ClassVar[MachineImage.Status]
        INVALID: _ClassVar[MachineImage.Status]
        READY: _ClassVar[MachineImage.Status]
        UPLOADING: _ClassVar[MachineImage.Status]
    UNDEFINED_STATUS: MachineImage.Status
    CREATING: MachineImage.Status
    DELETING: MachineImage.Status
    INVALID: MachineImage.Status
    READY: MachineImage.Status
    UPLOADING: MachineImage.Status
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    GUEST_FLUSH_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MACHINE_IMAGE_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZI_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SAVED_DISKS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_ENCRYPTION_KEYS_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANCE_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    TOTAL_STORAGE_BYTES_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    guest_flush: bool
    id: int
    instance_properties: InstanceProperties
    kind: str
    machine_image_encryption_key: CustomerEncryptionKey
    name: str
    satisfies_pzi: bool
    satisfies_pzs: bool
    saved_disks: _containers.RepeatedCompositeFieldContainer[SavedDisk]
    self_link: str
    source_disk_encryption_keys: _containers.RepeatedCompositeFieldContainer[SourceDiskEncryptionKey]
    source_instance: str
    source_instance_properties: SourceInstanceProperties
    status: str
    storage_locations: _containers.RepeatedScalarFieldContainer[str]
    total_storage_bytes: int
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., guest_flush: bool = ..., id: _Optional[int] = ..., instance_properties: _Optional[_Union[InstanceProperties, _Mapping]] = ..., kind: _Optional[str] = ..., machine_image_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., name: _Optional[str] = ..., satisfies_pzi: bool = ..., satisfies_pzs: bool = ..., saved_disks: _Optional[_Iterable[_Union[SavedDisk, _Mapping]]] = ..., self_link: _Optional[str] = ..., source_disk_encryption_keys: _Optional[_Iterable[_Union[SourceDiskEncryptionKey, _Mapping]]] = ..., source_instance: _Optional[str] = ..., source_instance_properties: _Optional[_Union[SourceInstanceProperties, _Mapping]] = ..., status: _Optional[str] = ..., storage_locations: _Optional[_Iterable[str]] = ..., total_storage_bytes: _Optional[int] = ...) -> None: ...

class MachineImageList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[MachineImage]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[MachineImage, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class MachineType(_message.Message):
    __slots__ = ("accelerators", "architecture", "creation_timestamp", "deprecated", "description", "guest_cpus", "id", "image_space_gb", "is_shared_cpu", "kind", "maximum_persistent_disks", "maximum_persistent_disks_size_gb", "memory_mb", "name", "scratch_disks", "self_link", "zone")
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[MachineType.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[MachineType.Architecture]
        ARM64: _ClassVar[MachineType.Architecture]
        X86_64: _ClassVar[MachineType.Architecture]
    UNDEFINED_ARCHITECTURE: MachineType.Architecture
    ARCHITECTURE_UNSPECIFIED: MachineType.Architecture
    ARM64: MachineType.Architecture
    X86_64: MachineType.Architecture
    ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    GUEST_CPUS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IMAGE_SPACE_GB_FIELD_NUMBER: _ClassVar[int]
    IS_SHARED_CPU_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MAXIMUM_PERSISTENT_DISKS_FIELD_NUMBER: _ClassVar[int]
    MAXIMUM_PERSISTENT_DISKS_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    MEMORY_MB_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SCRATCH_DISKS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    accelerators: _containers.RepeatedCompositeFieldContainer[Accelerators]
    architecture: str
    creation_timestamp: str
    deprecated: DeprecationStatus
    description: str
    guest_cpus: int
    id: int
    image_space_gb: int
    is_shared_cpu: bool
    kind: str
    maximum_persistent_disks: int
    maximum_persistent_disks_size_gb: int
    memory_mb: int
    name: str
    scratch_disks: _containers.RepeatedCompositeFieldContainer[ScratchDisks]
    self_link: str
    zone: str
    def __init__(self, accelerators: _Optional[_Iterable[_Union[Accelerators, _Mapping]]] = ..., architecture: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., guest_cpus: _Optional[int] = ..., id: _Optional[int] = ..., image_space_gb: _Optional[int] = ..., is_shared_cpu: bool = ..., kind: _Optional[str] = ..., maximum_persistent_disks: _Optional[int] = ..., maximum_persistent_disks_size_gb: _Optional[int] = ..., memory_mb: _Optional[int] = ..., name: _Optional[str] = ..., scratch_disks: _Optional[_Iterable[_Union[ScratchDisks, _Mapping]]] = ..., self_link: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class MachineTypeAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: MachineTypesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[MachineTypesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, MachineTypesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, MachineTypesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class MachineTypeList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[MachineType]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[MachineType, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class MachineTypesScopedList(_message.Message):
    __slots__ = ("machine_types", "warning")
    MACHINE_TYPES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    machine_types: _containers.RepeatedCompositeFieldContainer[MachineType]
    warning: Warning
    def __init__(self, machine_types: _Optional[_Iterable[_Union[MachineType, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ManagedInstance(_message.Message):
    __slots__ = ("current_action", "id", "instance", "instance_health", "instance_status", "last_attempt", "name", "preserved_state_from_config", "preserved_state_from_policy", "properties_from_flexibility_policy", "version")
    class CurrentAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CURRENT_ACTION: _ClassVar[ManagedInstance.CurrentAction]
        ABANDONING: _ClassVar[ManagedInstance.CurrentAction]
        CREATING: _ClassVar[ManagedInstance.CurrentAction]
        CREATING_WITHOUT_RETRIES: _ClassVar[ManagedInstance.CurrentAction]
        DELETING: _ClassVar[ManagedInstance.CurrentAction]
        NONE: _ClassVar[ManagedInstance.CurrentAction]
        RECREATING: _ClassVar[ManagedInstance.CurrentAction]
        REFRESHING: _ClassVar[ManagedInstance.CurrentAction]
        RESTARTING: _ClassVar[ManagedInstance.CurrentAction]
        RESUMING: _ClassVar[ManagedInstance.CurrentAction]
        STARTING: _ClassVar[ManagedInstance.CurrentAction]
        VERIFYING: _ClassVar[ManagedInstance.CurrentAction]
    UNDEFINED_CURRENT_ACTION: ManagedInstance.CurrentAction
    ABANDONING: ManagedInstance.CurrentAction
    CREATING: ManagedInstance.CurrentAction
    CREATING_WITHOUT_RETRIES: ManagedInstance.CurrentAction
    DELETING: ManagedInstance.CurrentAction
    NONE: ManagedInstance.CurrentAction
    RECREATING: ManagedInstance.CurrentAction
    REFRESHING: ManagedInstance.CurrentAction
    RESTARTING: ManagedInstance.CurrentAction
    RESUMING: ManagedInstance.CurrentAction
    STARTING: ManagedInstance.CurrentAction
    VERIFYING: ManagedInstance.CurrentAction
    class InstanceStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INSTANCE_STATUS: _ClassVar[ManagedInstance.InstanceStatus]
        DEPROVISIONING: _ClassVar[ManagedInstance.InstanceStatus]
        PROVISIONING: _ClassVar[ManagedInstance.InstanceStatus]
        REPAIRING: _ClassVar[ManagedInstance.InstanceStatus]
        RUNNING: _ClassVar[ManagedInstance.InstanceStatus]
        STAGING: _ClassVar[ManagedInstance.InstanceStatus]
        STOPPED: _ClassVar[ManagedInstance.InstanceStatus]
        STOPPING: _ClassVar[ManagedInstance.InstanceStatus]
        SUSPENDED: _ClassVar[ManagedInstance.InstanceStatus]
        SUSPENDING: _ClassVar[ManagedInstance.InstanceStatus]
        TERMINATED: _ClassVar[ManagedInstance.InstanceStatus]
    UNDEFINED_INSTANCE_STATUS: ManagedInstance.InstanceStatus
    DEPROVISIONING: ManagedInstance.InstanceStatus
    PROVISIONING: ManagedInstance.InstanceStatus
    REPAIRING: ManagedInstance.InstanceStatus
    RUNNING: ManagedInstance.InstanceStatus
    STAGING: ManagedInstance.InstanceStatus
    STOPPED: ManagedInstance.InstanceStatus
    STOPPING: ManagedInstance.InstanceStatus
    SUSPENDED: ManagedInstance.InstanceStatus
    SUSPENDING: ManagedInstance.InstanceStatus
    TERMINATED: ManagedInstance.InstanceStatus
    CURRENT_ACTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_HEALTH_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    LAST_ATTEMPT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRESERVED_STATE_FROM_CONFIG_FIELD_NUMBER: _ClassVar[int]
    PRESERVED_STATE_FROM_POLICY_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FROM_FLEXIBILITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    current_action: str
    id: int
    instance: str
    instance_health: _containers.RepeatedCompositeFieldContainer[ManagedInstanceInstanceHealth]
    instance_status: str
    last_attempt: ManagedInstanceLastAttempt
    name: str
    preserved_state_from_config: PreservedState
    preserved_state_from_policy: PreservedState
    properties_from_flexibility_policy: ManagedInstancePropertiesFromFlexibilityPolicy
    version: ManagedInstanceVersion
    def __init__(self, current_action: _Optional[str] = ..., id: _Optional[int] = ..., instance: _Optional[str] = ..., instance_health: _Optional[_Iterable[_Union[ManagedInstanceInstanceHealth, _Mapping]]] = ..., instance_status: _Optional[str] = ..., last_attempt: _Optional[_Union[ManagedInstanceLastAttempt, _Mapping]] = ..., name: _Optional[str] = ..., preserved_state_from_config: _Optional[_Union[PreservedState, _Mapping]] = ..., preserved_state_from_policy: _Optional[_Union[PreservedState, _Mapping]] = ..., properties_from_flexibility_policy: _Optional[_Union[ManagedInstancePropertiesFromFlexibilityPolicy, _Mapping]] = ..., version: _Optional[_Union[ManagedInstanceVersion, _Mapping]] = ...) -> None: ...

class ManagedInstanceInstanceHealth(_message.Message):
    __slots__ = ("detailed_health_state", "health_check")
    class DetailedHealthState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DETAILED_HEALTH_STATE: _ClassVar[ManagedInstanceInstanceHealth.DetailedHealthState]
        DRAINING: _ClassVar[ManagedInstanceInstanceHealth.DetailedHealthState]
        HEALTHY: _ClassVar[ManagedInstanceInstanceHealth.DetailedHealthState]
        TIMEOUT: _ClassVar[ManagedInstanceInstanceHealth.DetailedHealthState]
        UNHEALTHY: _ClassVar[ManagedInstanceInstanceHealth.DetailedHealthState]
        UNKNOWN: _ClassVar[ManagedInstanceInstanceHealth.DetailedHealthState]
    UNDEFINED_DETAILED_HEALTH_STATE: ManagedInstanceInstanceHealth.DetailedHealthState
    DRAINING: ManagedInstanceInstanceHealth.DetailedHealthState
    HEALTHY: ManagedInstanceInstanceHealth.DetailedHealthState
    TIMEOUT: ManagedInstanceInstanceHealth.DetailedHealthState
    UNHEALTHY: ManagedInstanceInstanceHealth.DetailedHealthState
    UNKNOWN: ManagedInstanceInstanceHealth.DetailedHealthState
    DETAILED_HEALTH_STATE_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    detailed_health_state: str
    health_check: str
    def __init__(self, detailed_health_state: _Optional[str] = ..., health_check: _Optional[str] = ...) -> None: ...

class ManagedInstanceLastAttempt(_message.Message):
    __slots__ = ("errors",)
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    errors: Errors
    def __init__(self, errors: _Optional[_Union[Errors, _Mapping]] = ...) -> None: ...

class ManagedInstancePropertiesFromFlexibilityPolicy(_message.Message):
    __slots__ = ("machine_type",)
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    machine_type: str
    def __init__(self, machine_type: _Optional[str] = ...) -> None: ...

class ManagedInstanceVersion(_message.Message):
    __slots__ = ("instance_template", "name")
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    name: str
    def __init__(self, instance_template: _Optional[str] = ..., name: _Optional[str] = ...) -> None: ...

class Metadata(_message.Message):
    __slots__ = ("fingerprint", "items", "kind")
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    items: _containers.RepeatedCompositeFieldContainer[Items]
    kind: str
    def __init__(self, fingerprint: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Items, _Mapping]]] = ..., kind: _Optional[str] = ...) -> None: ...

class MetadataFilter(_message.Message):
    __slots__ = ("filter_labels", "filter_match_criteria")
    class FilterMatchCriteria(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_FILTER_MATCH_CRITERIA: _ClassVar[MetadataFilter.FilterMatchCriteria]
        MATCH_ALL: _ClassVar[MetadataFilter.FilterMatchCriteria]
        MATCH_ANY: _ClassVar[MetadataFilter.FilterMatchCriteria]
        NOT_SET: _ClassVar[MetadataFilter.FilterMatchCriteria]
    UNDEFINED_FILTER_MATCH_CRITERIA: MetadataFilter.FilterMatchCriteria
    MATCH_ALL: MetadataFilter.FilterMatchCriteria
    MATCH_ANY: MetadataFilter.FilterMatchCriteria
    NOT_SET: MetadataFilter.FilterMatchCriteria
    FILTER_LABELS_FIELD_NUMBER: _ClassVar[int]
    FILTER_MATCH_CRITERIA_FIELD_NUMBER: _ClassVar[int]
    filter_labels: _containers.RepeatedCompositeFieldContainer[MetadataFilterLabelMatch]
    filter_match_criteria: str
    def __init__(self, filter_labels: _Optional[_Iterable[_Union[MetadataFilterLabelMatch, _Mapping]]] = ..., filter_match_criteria: _Optional[str] = ...) -> None: ...

class MetadataFilterLabelMatch(_message.Message):
    __slots__ = ("name", "value")
    NAME_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    name: str
    value: str
    def __init__(self, name: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class MoveAddressRequest(_message.Message):
    __slots__ = ("address", "project", "region", "region_addresses_move_request_resource", "request_id")
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_ADDRESSES_MOVE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    address: str
    project: str
    region: str
    region_addresses_move_request_resource: RegionAddressesMoveRequest
    request_id: str
    def __init__(self, address: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_addresses_move_request_resource: _Optional[_Union[RegionAddressesMoveRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class MoveDiskProjectRequest(_message.Message):
    __slots__ = ("disk_move_request_resource", "project", "request_id")
    DISK_MOVE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disk_move_request_resource: DiskMoveRequest
    project: str
    request_id: str
    def __init__(self, disk_move_request_resource: _Optional[_Union[DiskMoveRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class MoveFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "parent_id", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PARENT_ID_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    parent_id: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., parent_id: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class MoveGlobalAddressRequest(_message.Message):
    __slots__ = ("address", "global_addresses_move_request_resource", "project", "request_id")
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    GLOBAL_ADDRESSES_MOVE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    address: str
    global_addresses_move_request_resource: GlobalAddressesMoveRequest
    project: str
    request_id: str
    def __init__(self, address: _Optional[str] = ..., global_addresses_move_request_resource: _Optional[_Union[GlobalAddressesMoveRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class MoveInstanceProjectRequest(_message.Message):
    __slots__ = ("instance_move_request_resource", "project", "request_id")
    INSTANCE_MOVE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_move_request_resource: InstanceMoveRequest
    project: str
    request_id: str
    def __init__(self, instance_move_request_resource: _Optional[_Union[InstanceMoveRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class NamedPort(_message.Message):
    __slots__ = ("name", "port")
    NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    name: str
    port: int
    def __init__(self, name: _Optional[str] = ..., port: _Optional[int] = ...) -> None: ...

class NatIpInfo(_message.Message):
    __slots__ = ("nat_ip_info_mappings", "nat_name")
    NAT_IP_INFO_MAPPINGS_FIELD_NUMBER: _ClassVar[int]
    NAT_NAME_FIELD_NUMBER: _ClassVar[int]
    nat_ip_info_mappings: _containers.RepeatedCompositeFieldContainer[NatIpInfoNatIpInfoMapping]
    nat_name: str
    def __init__(self, nat_ip_info_mappings: _Optional[_Iterable[_Union[NatIpInfoNatIpInfoMapping, _Mapping]]] = ..., nat_name: _Optional[str] = ...) -> None: ...

class NatIpInfoNatIpInfoMapping(_message.Message):
    __slots__ = ("mode", "nat_ip", "usage")
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[NatIpInfoNatIpInfoMapping.Mode]
        AUTO: _ClassVar[NatIpInfoNatIpInfoMapping.Mode]
        MANUAL: _ClassVar[NatIpInfoNatIpInfoMapping.Mode]
    UNDEFINED_MODE: NatIpInfoNatIpInfoMapping.Mode
    AUTO: NatIpInfoNatIpInfoMapping.Mode
    MANUAL: NatIpInfoNatIpInfoMapping.Mode
    class Usage(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_USAGE: _ClassVar[NatIpInfoNatIpInfoMapping.Usage]
        IN_USE: _ClassVar[NatIpInfoNatIpInfoMapping.Usage]
        UNUSED: _ClassVar[NatIpInfoNatIpInfoMapping.Usage]
    UNDEFINED_USAGE: NatIpInfoNatIpInfoMapping.Usage
    IN_USE: NatIpInfoNatIpInfoMapping.Usage
    UNUSED: NatIpInfoNatIpInfoMapping.Usage
    MODE_FIELD_NUMBER: _ClassVar[int]
    NAT_IP_FIELD_NUMBER: _ClassVar[int]
    USAGE_FIELD_NUMBER: _ClassVar[int]
    mode: str
    nat_ip: str
    usage: str
    def __init__(self, mode: _Optional[str] = ..., nat_ip: _Optional[str] = ..., usage: _Optional[str] = ...) -> None: ...

class NatIpInfoResponse(_message.Message):
    __slots__ = ("result",)
    RESULT_FIELD_NUMBER: _ClassVar[int]
    result: _containers.RepeatedCompositeFieldContainer[NatIpInfo]
    def __init__(self, result: _Optional[_Iterable[_Union[NatIpInfo, _Mapping]]] = ...) -> None: ...

class Network(_message.Message):
    __slots__ = ("I_pv4_range", "auto_create_subnetworks", "creation_timestamp", "description", "enable_ula_internal_ipv6", "firewall_policy", "gateway_i_pv4", "id", "internal_ipv6_range", "kind", "mtu", "name", "network_firewall_policy_enforcement_order", "network_profile", "peerings", "routing_config", "self_link", "self_link_with_id", "subnetworks")
    class NetworkFirewallPolicyEnforcementOrder(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NETWORK_FIREWALL_POLICY_ENFORCEMENT_ORDER: _ClassVar[Network.NetworkFirewallPolicyEnforcementOrder]
        AFTER_CLASSIC_FIREWALL: _ClassVar[Network.NetworkFirewallPolicyEnforcementOrder]
        BEFORE_CLASSIC_FIREWALL: _ClassVar[Network.NetworkFirewallPolicyEnforcementOrder]
    UNDEFINED_NETWORK_FIREWALL_POLICY_ENFORCEMENT_ORDER: Network.NetworkFirewallPolicyEnforcementOrder
    AFTER_CLASSIC_FIREWALL: Network.NetworkFirewallPolicyEnforcementOrder
    BEFORE_CLASSIC_FIREWALL: Network.NetworkFirewallPolicyEnforcementOrder
    I_PV4_RANGE_FIELD_NUMBER: _ClassVar[int]
    AUTO_CREATE_SUBNETWORKS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ENABLE_ULA_INTERNAL_IPV6_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    GATEWAY_I_PV4_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INTERNAL_IPV6_RANGE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MTU_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIREWALL_POLICY_ENFORCEMENT_ORDER_FIELD_NUMBER: _ClassVar[int]
    NETWORK_PROFILE_FIELD_NUMBER: _ClassVar[int]
    PEERINGS_FIELD_NUMBER: _ClassVar[int]
    ROUTING_CONFIG_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORKS_FIELD_NUMBER: _ClassVar[int]
    I_pv4_range: str
    auto_create_subnetworks: bool
    creation_timestamp: str
    description: str
    enable_ula_internal_ipv6: bool
    firewall_policy: str
    gateway_i_pv4: str
    id: int
    internal_ipv6_range: str
    kind: str
    mtu: int
    name: str
    network_firewall_policy_enforcement_order: str
    network_profile: str
    peerings: _containers.RepeatedCompositeFieldContainer[NetworkPeering]
    routing_config: NetworkRoutingConfig
    self_link: str
    self_link_with_id: str
    subnetworks: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, I_pv4_range: _Optional[str] = ..., auto_create_subnetworks: bool = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., enable_ula_internal_ipv6: bool = ..., firewall_policy: _Optional[str] = ..., gateway_i_pv4: _Optional[str] = ..., id: _Optional[int] = ..., internal_ipv6_range: _Optional[str] = ..., kind: _Optional[str] = ..., mtu: _Optional[int] = ..., name: _Optional[str] = ..., network_firewall_policy_enforcement_order: _Optional[str] = ..., network_profile: _Optional[str] = ..., peerings: _Optional[_Iterable[_Union[NetworkPeering, _Mapping]]] = ..., routing_config: _Optional[_Union[NetworkRoutingConfig, _Mapping]] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., subnetworks: _Optional[_Iterable[str]] = ...) -> None: ...

class NetworkAttachment(_message.Message):
    __slots__ = ("connection_endpoints", "connection_preference", "creation_timestamp", "description", "fingerprint", "id", "kind", "name", "network", "producer_accept_lists", "producer_reject_lists", "region", "self_link", "self_link_with_id", "subnetworks")
    class ConnectionPreference(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONNECTION_PREFERENCE: _ClassVar[NetworkAttachment.ConnectionPreference]
        ACCEPT_AUTOMATIC: _ClassVar[NetworkAttachment.ConnectionPreference]
        ACCEPT_MANUAL: _ClassVar[NetworkAttachment.ConnectionPreference]
        INVALID: _ClassVar[NetworkAttachment.ConnectionPreference]
    UNDEFINED_CONNECTION_PREFERENCE: NetworkAttachment.ConnectionPreference
    ACCEPT_AUTOMATIC: NetworkAttachment.ConnectionPreference
    ACCEPT_MANUAL: NetworkAttachment.ConnectionPreference
    INVALID: NetworkAttachment.ConnectionPreference
    CONNECTION_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    CONNECTION_PREFERENCE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PRODUCER_ACCEPT_LISTS_FIELD_NUMBER: _ClassVar[int]
    PRODUCER_REJECT_LISTS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORKS_FIELD_NUMBER: _ClassVar[int]
    connection_endpoints: _containers.RepeatedCompositeFieldContainer[NetworkAttachmentConnectedEndpoint]
    connection_preference: str
    creation_timestamp: str
    description: str
    fingerprint: str
    id: int
    kind: str
    name: str
    network: str
    producer_accept_lists: _containers.RepeatedScalarFieldContainer[str]
    producer_reject_lists: _containers.RepeatedScalarFieldContainer[str]
    region: str
    self_link: str
    self_link_with_id: str
    subnetworks: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, connection_endpoints: _Optional[_Iterable[_Union[NetworkAttachmentConnectedEndpoint, _Mapping]]] = ..., connection_preference: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., producer_accept_lists: _Optional[_Iterable[str]] = ..., producer_reject_lists: _Optional[_Iterable[str]] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., subnetworks: _Optional[_Iterable[str]] = ...) -> None: ...

class NetworkAttachmentAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: NetworkAttachmentsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[NetworkAttachmentsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, NetworkAttachmentsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, NetworkAttachmentsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkAttachmentConnectedEndpoint(_message.Message):
    __slots__ = ("ip_address", "ipv6_address", "project_id_or_num", "secondary_ip_cidr_ranges", "status", "subnetwork", "subnetwork_cidr_range")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[NetworkAttachmentConnectedEndpoint.Status]
        ACCEPTED: _ClassVar[NetworkAttachmentConnectedEndpoint.Status]
        CLOSED: _ClassVar[NetworkAttachmentConnectedEndpoint.Status]
        NEEDS_ATTENTION: _ClassVar[NetworkAttachmentConnectedEndpoint.Status]
        PENDING: _ClassVar[NetworkAttachmentConnectedEndpoint.Status]
        REJECTED: _ClassVar[NetworkAttachmentConnectedEndpoint.Status]
        STATUS_UNSPECIFIED: _ClassVar[NetworkAttachmentConnectedEndpoint.Status]
    UNDEFINED_STATUS: NetworkAttachmentConnectedEndpoint.Status
    ACCEPTED: NetworkAttachmentConnectedEndpoint.Status
    CLOSED: NetworkAttachmentConnectedEndpoint.Status
    NEEDS_ATTENTION: NetworkAttachmentConnectedEndpoint.Status
    PENDING: NetworkAttachmentConnectedEndpoint.Status
    REJECTED: NetworkAttachmentConnectedEndpoint.Status
    STATUS_UNSPECIFIED: NetworkAttachmentConnectedEndpoint.Status
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_OR_NUM_FIELD_NUMBER: _ClassVar[int]
    SECONDARY_IP_CIDR_RANGES_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    ip_address: str
    ipv6_address: str
    project_id_or_num: str
    secondary_ip_cidr_ranges: _containers.RepeatedScalarFieldContainer[str]
    status: str
    subnetwork: str
    subnetwork_cidr_range: str
    def __init__(self, ip_address: _Optional[str] = ..., ipv6_address: _Optional[str] = ..., project_id_or_num: _Optional[str] = ..., secondary_ip_cidr_ranges: _Optional[_Iterable[str]] = ..., status: _Optional[str] = ..., subnetwork: _Optional[str] = ..., subnetwork_cidr_range: _Optional[str] = ...) -> None: ...

class NetworkAttachmentList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NetworkAttachment]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NetworkAttachment, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkAttachmentsScopedList(_message.Message):
    __slots__ = ("network_attachments", "warning")
    NETWORK_ATTACHMENTS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    network_attachments: _containers.RepeatedCompositeFieldContainer[NetworkAttachment]
    warning: Warning
    def __init__(self, network_attachments: _Optional[_Iterable[_Union[NetworkAttachment, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkEdgeSecurityService(_message.Message):
    __slots__ = ("creation_timestamp", "description", "fingerprint", "id", "kind", "name", "region", "security_policy", "self_link", "self_link_with_id")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    fingerprint: str
    id: int
    kind: str
    name: str
    region: str
    security_policy: str
    self_link: str
    self_link_with_id: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ...) -> None: ...

class NetworkEdgeSecurityServiceAggregatedList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: NetworkEdgeSecurityServicesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[NetworkEdgeSecurityServicesScopedList, _Mapping]] = ...) -> None: ...
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.MessageMap[str, NetworkEdgeSecurityServicesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Mapping[str, NetworkEdgeSecurityServicesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkEdgeSecurityServicesScopedList(_message.Message):
    __slots__ = ("network_edge_security_services", "warning")
    NETWORK_EDGE_SECURITY_SERVICES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    network_edge_security_services: _containers.RepeatedCompositeFieldContainer[NetworkEdgeSecurityService]
    warning: Warning
    def __init__(self, network_edge_security_services: _Optional[_Iterable[_Union[NetworkEdgeSecurityService, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkEndpoint(_message.Message):
    __slots__ = ("annotations", "client_destination_port", "fqdn", "instance", "ip_address", "ipv6_address", "port")
    class AnnotationsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ANNOTATIONS_FIELD_NUMBER: _ClassVar[int]
    CLIENT_DESTINATION_PORT_FIELD_NUMBER: _ClassVar[int]
    FQDN_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PORT_FIELD_NUMBER: _ClassVar[int]
    annotations: _containers.ScalarMap[str, str]
    client_destination_port: int
    fqdn: str
    instance: str
    ip_address: str
    ipv6_address: str
    port: int
    def __init__(self, annotations: _Optional[_Mapping[str, str]] = ..., client_destination_port: _Optional[int] = ..., fqdn: _Optional[str] = ..., instance: _Optional[str] = ..., ip_address: _Optional[str] = ..., ipv6_address: _Optional[str] = ..., port: _Optional[int] = ...) -> None: ...

class NetworkEndpointGroup(_message.Message):
    __slots__ = ("annotations", "app_engine", "cloud_function", "cloud_run", "creation_timestamp", "default_port", "description", "id", "kind", "name", "network", "network_endpoint_type", "psc_data", "psc_target_service", "region", "self_link", "size", "subnetwork", "zone")
    class NetworkEndpointType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NETWORK_ENDPOINT_TYPE: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        GCE_VM_IP: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        GCE_VM_IP_PORT: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        GCE_VM_IP_PORTMAP: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        INTERNET_FQDN_PORT: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        INTERNET_IP_PORT: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        NON_GCP_PRIVATE_IP_PORT: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        PRIVATE_SERVICE_CONNECT: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
        SERVERLESS: _ClassVar[NetworkEndpointGroup.NetworkEndpointType]
    UNDEFINED_NETWORK_ENDPOINT_TYPE: NetworkEndpointGroup.NetworkEndpointType
    GCE_VM_IP: NetworkEndpointGroup.NetworkEndpointType
    GCE_VM_IP_PORT: NetworkEndpointGroup.NetworkEndpointType
    GCE_VM_IP_PORTMAP: NetworkEndpointGroup.NetworkEndpointType
    INTERNET_FQDN_PORT: NetworkEndpointGroup.NetworkEndpointType
    INTERNET_IP_PORT: NetworkEndpointGroup.NetworkEndpointType
    NON_GCP_PRIVATE_IP_PORT: NetworkEndpointGroup.NetworkEndpointType
    PRIVATE_SERVICE_CONNECT: NetworkEndpointGroup.NetworkEndpointType
    SERVERLESS: NetworkEndpointGroup.NetworkEndpointType
    class AnnotationsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ANNOTATIONS_FIELD_NUMBER: _ClassVar[int]
    APP_ENGINE_FIELD_NUMBER: _ClassVar[int]
    CLOUD_FUNCTION_FIELD_NUMBER: _ClassVar[int]
    CLOUD_RUN_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_PORT_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_TYPE_FIELD_NUMBER: _ClassVar[int]
    PSC_DATA_FIELD_NUMBER: _ClassVar[int]
    PSC_TARGET_SERVICE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    annotations: _containers.ScalarMap[str, str]
    app_engine: NetworkEndpointGroupAppEngine
    cloud_function: NetworkEndpointGroupCloudFunction
    cloud_run: NetworkEndpointGroupCloudRun
    creation_timestamp: str
    default_port: int
    description: str
    id: int
    kind: str
    name: str
    network: str
    network_endpoint_type: str
    psc_data: NetworkEndpointGroupPscData
    psc_target_service: str
    region: str
    self_link: str
    size: int
    subnetwork: str
    zone: str
    def __init__(self, annotations: _Optional[_Mapping[str, str]] = ..., app_engine: _Optional[_Union[NetworkEndpointGroupAppEngine, _Mapping]] = ..., cloud_function: _Optional[_Union[NetworkEndpointGroupCloudFunction, _Mapping]] = ..., cloud_run: _Optional[_Union[NetworkEndpointGroupCloudRun, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., default_port: _Optional[int] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., network_endpoint_type: _Optional[str] = ..., psc_data: _Optional[_Union[NetworkEndpointGroupPscData, _Mapping]] = ..., psc_target_service: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., size: _Optional[int] = ..., subnetwork: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class NetworkEndpointGroupAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: NetworkEndpointGroupsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[NetworkEndpointGroupsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, NetworkEndpointGroupsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, NetworkEndpointGroupsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkEndpointGroupAppEngine(_message.Message):
    __slots__ = ("service", "url_mask", "version")
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    URL_MASK_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    service: str
    url_mask: str
    version: str
    def __init__(self, service: _Optional[str] = ..., url_mask: _Optional[str] = ..., version: _Optional[str] = ...) -> None: ...

class NetworkEndpointGroupCloudFunction(_message.Message):
    __slots__ = ("function", "url_mask")
    FUNCTION_FIELD_NUMBER: _ClassVar[int]
    URL_MASK_FIELD_NUMBER: _ClassVar[int]
    function: str
    url_mask: str
    def __init__(self, function: _Optional[str] = ..., url_mask: _Optional[str] = ...) -> None: ...

class NetworkEndpointGroupCloudRun(_message.Message):
    __slots__ = ("service", "tag", "url_mask")
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    TAG_FIELD_NUMBER: _ClassVar[int]
    URL_MASK_FIELD_NUMBER: _ClassVar[int]
    service: str
    tag: str
    url_mask: str
    def __init__(self, service: _Optional[str] = ..., tag: _Optional[str] = ..., url_mask: _Optional[str] = ...) -> None: ...

class NetworkEndpointGroupList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NetworkEndpointGroup]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NetworkEndpointGroup, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkEndpointGroupPscData(_message.Message):
    __slots__ = ("consumer_psc_address", "producer_port", "psc_connection_id", "psc_connection_status")
    class PscConnectionStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PSC_CONNECTION_STATUS: _ClassVar[NetworkEndpointGroupPscData.PscConnectionStatus]
        ACCEPTED: _ClassVar[NetworkEndpointGroupPscData.PscConnectionStatus]
        CLOSED: _ClassVar[NetworkEndpointGroupPscData.PscConnectionStatus]
        NEEDS_ATTENTION: _ClassVar[NetworkEndpointGroupPscData.PscConnectionStatus]
        PENDING: _ClassVar[NetworkEndpointGroupPscData.PscConnectionStatus]
        REJECTED: _ClassVar[NetworkEndpointGroupPscData.PscConnectionStatus]
        STATUS_UNSPECIFIED: _ClassVar[NetworkEndpointGroupPscData.PscConnectionStatus]
    UNDEFINED_PSC_CONNECTION_STATUS: NetworkEndpointGroupPscData.PscConnectionStatus
    ACCEPTED: NetworkEndpointGroupPscData.PscConnectionStatus
    CLOSED: NetworkEndpointGroupPscData.PscConnectionStatus
    NEEDS_ATTENTION: NetworkEndpointGroupPscData.PscConnectionStatus
    PENDING: NetworkEndpointGroupPscData.PscConnectionStatus
    REJECTED: NetworkEndpointGroupPscData.PscConnectionStatus
    STATUS_UNSPECIFIED: NetworkEndpointGroupPscData.PscConnectionStatus
    CONSUMER_PSC_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PRODUCER_PORT_FIELD_NUMBER: _ClassVar[int]
    PSC_CONNECTION_ID_FIELD_NUMBER: _ClassVar[int]
    PSC_CONNECTION_STATUS_FIELD_NUMBER: _ClassVar[int]
    consumer_psc_address: str
    producer_port: int
    psc_connection_id: int
    psc_connection_status: str
    def __init__(self, consumer_psc_address: _Optional[str] = ..., producer_port: _Optional[int] = ..., psc_connection_id: _Optional[int] = ..., psc_connection_status: _Optional[str] = ...) -> None: ...

class NetworkEndpointGroupsAttachEndpointsRequest(_message.Message):
    __slots__ = ("network_endpoints",)
    NETWORK_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    network_endpoints: _containers.RepeatedCompositeFieldContainer[NetworkEndpoint]
    def __init__(self, network_endpoints: _Optional[_Iterable[_Union[NetworkEndpoint, _Mapping]]] = ...) -> None: ...

class NetworkEndpointGroupsDetachEndpointsRequest(_message.Message):
    __slots__ = ("network_endpoints",)
    NETWORK_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    network_endpoints: _containers.RepeatedCompositeFieldContainer[NetworkEndpoint]
    def __init__(self, network_endpoints: _Optional[_Iterable[_Union[NetworkEndpoint, _Mapping]]] = ...) -> None: ...

class NetworkEndpointGroupsListEndpointsRequest(_message.Message):
    __slots__ = ("health_status",)
    class HealthStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_HEALTH_STATUS: _ClassVar[NetworkEndpointGroupsListEndpointsRequest.HealthStatus]
        SHOW: _ClassVar[NetworkEndpointGroupsListEndpointsRequest.HealthStatus]
        SKIP: _ClassVar[NetworkEndpointGroupsListEndpointsRequest.HealthStatus]
    UNDEFINED_HEALTH_STATUS: NetworkEndpointGroupsListEndpointsRequest.HealthStatus
    SHOW: NetworkEndpointGroupsListEndpointsRequest.HealthStatus
    SKIP: NetworkEndpointGroupsListEndpointsRequest.HealthStatus
    HEALTH_STATUS_FIELD_NUMBER: _ClassVar[int]
    health_status: str
    def __init__(self, health_status: _Optional[str] = ...) -> None: ...

class NetworkEndpointGroupsListNetworkEndpoints(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NetworkEndpointWithHealthStatus]
    kind: str
    next_page_token: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NetworkEndpointWithHealthStatus, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkEndpointGroupsScopedList(_message.Message):
    __slots__ = ("network_endpoint_groups", "warning")
    NETWORK_ENDPOINT_GROUPS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    network_endpoint_groups: _containers.RepeatedCompositeFieldContainer[NetworkEndpointGroup]
    warning: Warning
    def __init__(self, network_endpoint_groups: _Optional[_Iterable[_Union[NetworkEndpointGroup, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkEndpointWithHealthStatus(_message.Message):
    __slots__ = ("healths", "network_endpoint")
    HEALTHS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ENDPOINT_FIELD_NUMBER: _ClassVar[int]
    healths: _containers.RepeatedCompositeFieldContainer[HealthStatusForNetworkEndpoint]
    network_endpoint: NetworkEndpoint
    def __init__(self, healths: _Optional[_Iterable[_Union[HealthStatusForNetworkEndpoint, _Mapping]]] = ..., network_endpoint: _Optional[_Union[NetworkEndpoint, _Mapping]] = ...) -> None: ...

class NetworkFirewallPolicyAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: FirewallPoliciesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[FirewallPoliciesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, FirewallPoliciesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, FirewallPoliciesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkInterface(_message.Message):
    __slots__ = ("access_configs", "alias_ip_ranges", "fingerprint", "internal_ipv6_prefix_length", "ipv6_access_configs", "ipv6_access_type", "ipv6_address", "kind", "name", "network", "network_attachment", "network_i_p", "nic_type", "queue_count", "stack_type", "subnetwork")
    class Ipv6AccessType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IPV6_ACCESS_TYPE: _ClassVar[NetworkInterface.Ipv6AccessType]
        EXTERNAL: _ClassVar[NetworkInterface.Ipv6AccessType]
        INTERNAL: _ClassVar[NetworkInterface.Ipv6AccessType]
        UNSPECIFIED_IPV6_ACCESS_TYPE: _ClassVar[NetworkInterface.Ipv6AccessType]
    UNDEFINED_IPV6_ACCESS_TYPE: NetworkInterface.Ipv6AccessType
    EXTERNAL: NetworkInterface.Ipv6AccessType
    INTERNAL: NetworkInterface.Ipv6AccessType
    UNSPECIFIED_IPV6_ACCESS_TYPE: NetworkInterface.Ipv6AccessType
    class NicType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NIC_TYPE: _ClassVar[NetworkInterface.NicType]
        GVNIC: _ClassVar[NetworkInterface.NicType]
        IDPF: _ClassVar[NetworkInterface.NicType]
        IRDMA: _ClassVar[NetworkInterface.NicType]
        MRDMA: _ClassVar[NetworkInterface.NicType]
        UNSPECIFIED_NIC_TYPE: _ClassVar[NetworkInterface.NicType]
        VIRTIO_NET: _ClassVar[NetworkInterface.NicType]
    UNDEFINED_NIC_TYPE: NetworkInterface.NicType
    GVNIC: NetworkInterface.NicType
    IDPF: NetworkInterface.NicType
    IRDMA: NetworkInterface.NicType
    MRDMA: NetworkInterface.NicType
    UNSPECIFIED_NIC_TYPE: NetworkInterface.NicType
    VIRTIO_NET: NetworkInterface.NicType
    class StackType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STACK_TYPE: _ClassVar[NetworkInterface.StackType]
        IPV4_IPV6: _ClassVar[NetworkInterface.StackType]
        IPV4_ONLY: _ClassVar[NetworkInterface.StackType]
        IPV6_ONLY: _ClassVar[NetworkInterface.StackType]
        UNSPECIFIED_STACK_TYPE: _ClassVar[NetworkInterface.StackType]
    UNDEFINED_STACK_TYPE: NetworkInterface.StackType
    IPV4_IPV6: NetworkInterface.StackType
    IPV4_ONLY: NetworkInterface.StackType
    IPV6_ONLY: NetworkInterface.StackType
    UNSPECIFIED_STACK_TYPE: NetworkInterface.StackType
    ACCESS_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    ALIAS_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    INTERNAL_IPV6_PREFIX_LENGTH_FIELD_NUMBER: _ClassVar[int]
    IPV6_ACCESS_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    IPV6_ACCESS_TYPE_FIELD_NUMBER: _ClassVar[int]
    IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    NETWORK_I_P_FIELD_NUMBER: _ClassVar[int]
    NIC_TYPE_FIELD_NUMBER: _ClassVar[int]
    QUEUE_COUNT_FIELD_NUMBER: _ClassVar[int]
    STACK_TYPE_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    access_configs: _containers.RepeatedCompositeFieldContainer[AccessConfig]
    alias_ip_ranges: _containers.RepeatedCompositeFieldContainer[AliasIpRange]
    fingerprint: str
    internal_ipv6_prefix_length: int
    ipv6_access_configs: _containers.RepeatedCompositeFieldContainer[AccessConfig]
    ipv6_access_type: str
    ipv6_address: str
    kind: str
    name: str
    network: str
    network_attachment: str
    network_i_p: str
    nic_type: str
    queue_count: int
    stack_type: str
    subnetwork: str
    def __init__(self, access_configs: _Optional[_Iterable[_Union[AccessConfig, _Mapping]]] = ..., alias_ip_ranges: _Optional[_Iterable[_Union[AliasIpRange, _Mapping]]] = ..., fingerprint: _Optional[str] = ..., internal_ipv6_prefix_length: _Optional[int] = ..., ipv6_access_configs: _Optional[_Iterable[_Union[AccessConfig, _Mapping]]] = ..., ipv6_access_type: _Optional[str] = ..., ipv6_address: _Optional[str] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., network_attachment: _Optional[str] = ..., network_i_p: _Optional[str] = ..., nic_type: _Optional[str] = ..., queue_count: _Optional[int] = ..., stack_type: _Optional[str] = ..., subnetwork: _Optional[str] = ...) -> None: ...

class NetworkList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Network]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Network, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkPeering(_message.Message):
    __slots__ = ("auto_create_routes", "exchange_subnet_routes", "export_custom_routes", "export_subnet_routes_with_public_ip", "import_custom_routes", "import_subnet_routes_with_public_ip", "name", "network", "peer_mtu", "stack_type", "state", "state_details")
    class StackType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STACK_TYPE: _ClassVar[NetworkPeering.StackType]
        IPV4_IPV6: _ClassVar[NetworkPeering.StackType]
        IPV4_ONLY: _ClassVar[NetworkPeering.StackType]
    UNDEFINED_STACK_TYPE: NetworkPeering.StackType
    IPV4_IPV6: NetworkPeering.StackType
    IPV4_ONLY: NetworkPeering.StackType
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[NetworkPeering.State]
        ACTIVE: _ClassVar[NetworkPeering.State]
        INACTIVE: _ClassVar[NetworkPeering.State]
    UNDEFINED_STATE: NetworkPeering.State
    ACTIVE: NetworkPeering.State
    INACTIVE: NetworkPeering.State
    AUTO_CREATE_ROUTES_FIELD_NUMBER: _ClassVar[int]
    EXCHANGE_SUBNET_ROUTES_FIELD_NUMBER: _ClassVar[int]
    EXPORT_CUSTOM_ROUTES_FIELD_NUMBER: _ClassVar[int]
    EXPORT_SUBNET_ROUTES_WITH_PUBLIC_IP_FIELD_NUMBER: _ClassVar[int]
    IMPORT_CUSTOM_ROUTES_FIELD_NUMBER: _ClassVar[int]
    IMPORT_SUBNET_ROUTES_WITH_PUBLIC_IP_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PEER_MTU_FIELD_NUMBER: _ClassVar[int]
    STACK_TYPE_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    STATE_DETAILS_FIELD_NUMBER: _ClassVar[int]
    auto_create_routes: bool
    exchange_subnet_routes: bool
    export_custom_routes: bool
    export_subnet_routes_with_public_ip: bool
    import_custom_routes: bool
    import_subnet_routes_with_public_ip: bool
    name: str
    network: str
    peer_mtu: int
    stack_type: str
    state: str
    state_details: str
    def __init__(self, auto_create_routes: bool = ..., exchange_subnet_routes: bool = ..., export_custom_routes: bool = ..., export_subnet_routes_with_public_ip: bool = ..., import_custom_routes: bool = ..., import_subnet_routes_with_public_ip: bool = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., peer_mtu: _Optional[int] = ..., stack_type: _Optional[str] = ..., state: _Optional[str] = ..., state_details: _Optional[str] = ...) -> None: ...

class NetworkPerformanceConfig(_message.Message):
    __slots__ = ("total_egress_bandwidth_tier",)
    class TotalEgressBandwidthTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TOTAL_EGRESS_BANDWIDTH_TIER: _ClassVar[NetworkPerformanceConfig.TotalEgressBandwidthTier]
        DEFAULT: _ClassVar[NetworkPerformanceConfig.TotalEgressBandwidthTier]
        TIER_1: _ClassVar[NetworkPerformanceConfig.TotalEgressBandwidthTier]
    UNDEFINED_TOTAL_EGRESS_BANDWIDTH_TIER: NetworkPerformanceConfig.TotalEgressBandwidthTier
    DEFAULT: NetworkPerformanceConfig.TotalEgressBandwidthTier
    TIER_1: NetworkPerformanceConfig.TotalEgressBandwidthTier
    TOTAL_EGRESS_BANDWIDTH_TIER_FIELD_NUMBER: _ClassVar[int]
    total_egress_bandwidth_tier: str
    def __init__(self, total_egress_bandwidth_tier: _Optional[str] = ...) -> None: ...

class NetworkProfile(_message.Message):
    __slots__ = ("creation_timestamp", "description", "features", "id", "kind", "location", "name", "self_link", "self_link_with_id", "zone")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FEATURES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOCATION_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    features: NetworkProfileNetworkFeatures
    id: int
    kind: str
    location: NetworkProfileLocation
    name: str
    self_link: str
    self_link_with_id: str
    zone: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., features: _Optional[_Union[NetworkProfileNetworkFeatures, _Mapping]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., location: _Optional[_Union[NetworkProfileLocation, _Mapping]] = ..., name: _Optional[str] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class NetworkProfileLocation(_message.Message):
    __slots__ = ("name", "scope")
    class Scope(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SCOPE: _ClassVar[NetworkProfileLocation.Scope]
        REGION: _ClassVar[NetworkProfileLocation.Scope]
        ZONE: _ClassVar[NetworkProfileLocation.Scope]
    UNDEFINED_SCOPE: NetworkProfileLocation.Scope
    REGION: NetworkProfileLocation.Scope
    ZONE: NetworkProfileLocation.Scope
    NAME_FIELD_NUMBER: _ClassVar[int]
    SCOPE_FIELD_NUMBER: _ClassVar[int]
    name: str
    scope: str
    def __init__(self, name: _Optional[str] = ..., scope: _Optional[str] = ...) -> None: ...

class NetworkProfileNetworkFeatures(_message.Message):
    __slots__ = ("address_purposes", "allow_alias_ip_ranges", "allow_auto_mode_subnet", "allow_class_d_firewalls", "allow_cloud_nat", "allow_cloud_router", "allow_external_ip_access", "allow_interconnect", "allow_load_balancing", "allow_multi_nic_in_same_network", "allow_packet_mirroring", "allow_private_google_access", "allow_psc", "allow_same_network_unicast", "allow_static_routes", "allow_sub_interfaces", "allow_vpc_peering", "allow_vpn", "interface_types", "subnet_purposes", "subnet_stack_types", "unicast")
    class AddressPurposes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ADDRESS_PURPOSES: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        DNS_RESOLVER: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        GCE_ENDPOINT: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        IPSEC_INTERCONNECT: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        NAT_AUTO: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        PRIVATE_SERVICE_CONNECT: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        SERVERLESS: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        SHARED_LOADBALANCER_VIP: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
        VPC_PEERING: _ClassVar[NetworkProfileNetworkFeatures.AddressPurposes]
    UNDEFINED_ADDRESS_PURPOSES: NetworkProfileNetworkFeatures.AddressPurposes
    DNS_RESOLVER: NetworkProfileNetworkFeatures.AddressPurposes
    GCE_ENDPOINT: NetworkProfileNetworkFeatures.AddressPurposes
    IPSEC_INTERCONNECT: NetworkProfileNetworkFeatures.AddressPurposes
    NAT_AUTO: NetworkProfileNetworkFeatures.AddressPurposes
    PRIVATE_SERVICE_CONNECT: NetworkProfileNetworkFeatures.AddressPurposes
    SERVERLESS: NetworkProfileNetworkFeatures.AddressPurposes
    SHARED_LOADBALANCER_VIP: NetworkProfileNetworkFeatures.AddressPurposes
    VPC_PEERING: NetworkProfileNetworkFeatures.AddressPurposes
    class AllowAliasIpRanges(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_ALIAS_IP_RANGES: _ClassVar[NetworkProfileNetworkFeatures.AllowAliasIpRanges]
        ALIAS_IP_RANGES_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowAliasIpRanges]
        ALIAS_IP_RANGES_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowAliasIpRanges]
    UNDEFINED_ALLOW_ALIAS_IP_RANGES: NetworkProfileNetworkFeatures.AllowAliasIpRanges
    ALIAS_IP_RANGES_ALLOWED: NetworkProfileNetworkFeatures.AllowAliasIpRanges
    ALIAS_IP_RANGES_BLOCKED: NetworkProfileNetworkFeatures.AllowAliasIpRanges
    class AllowAutoModeSubnet(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_AUTO_MODE_SUBNET: _ClassVar[NetworkProfileNetworkFeatures.AllowAutoModeSubnet]
        AUTO_MODE_SUBNET_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowAutoModeSubnet]
        AUTO_MODE_SUBNET_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowAutoModeSubnet]
    UNDEFINED_ALLOW_AUTO_MODE_SUBNET: NetworkProfileNetworkFeatures.AllowAutoModeSubnet
    AUTO_MODE_SUBNET_ALLOWED: NetworkProfileNetworkFeatures.AllowAutoModeSubnet
    AUTO_MODE_SUBNET_BLOCKED: NetworkProfileNetworkFeatures.AllowAutoModeSubnet
    class AllowClassDFirewalls(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_CLASS_D_FIREWALLS: _ClassVar[NetworkProfileNetworkFeatures.AllowClassDFirewalls]
        CLASS_D_FIREWALLS_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowClassDFirewalls]
        CLASS_D_FIREWALLS_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowClassDFirewalls]
    UNDEFINED_ALLOW_CLASS_D_FIREWALLS: NetworkProfileNetworkFeatures.AllowClassDFirewalls
    CLASS_D_FIREWALLS_ALLOWED: NetworkProfileNetworkFeatures.AllowClassDFirewalls
    CLASS_D_FIREWALLS_BLOCKED: NetworkProfileNetworkFeatures.AllowClassDFirewalls
    class AllowCloudNat(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_CLOUD_NAT: _ClassVar[NetworkProfileNetworkFeatures.AllowCloudNat]
        CLOUD_NAT_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowCloudNat]
        CLOUD_NAT_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowCloudNat]
    UNDEFINED_ALLOW_CLOUD_NAT: NetworkProfileNetworkFeatures.AllowCloudNat
    CLOUD_NAT_ALLOWED: NetworkProfileNetworkFeatures.AllowCloudNat
    CLOUD_NAT_BLOCKED: NetworkProfileNetworkFeatures.AllowCloudNat
    class AllowCloudRouter(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_CLOUD_ROUTER: _ClassVar[NetworkProfileNetworkFeatures.AllowCloudRouter]
        CLOUD_ROUTER_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowCloudRouter]
        CLOUD_ROUTER_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowCloudRouter]
    UNDEFINED_ALLOW_CLOUD_ROUTER: NetworkProfileNetworkFeatures.AllowCloudRouter
    CLOUD_ROUTER_ALLOWED: NetworkProfileNetworkFeatures.AllowCloudRouter
    CLOUD_ROUTER_BLOCKED: NetworkProfileNetworkFeatures.AllowCloudRouter
    class AllowExternalIpAccess(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_EXTERNAL_IP_ACCESS: _ClassVar[NetworkProfileNetworkFeatures.AllowExternalIpAccess]
        EXTERNAL_IP_ACCESS_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowExternalIpAccess]
        EXTERNAL_IP_ACCESS_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowExternalIpAccess]
    UNDEFINED_ALLOW_EXTERNAL_IP_ACCESS: NetworkProfileNetworkFeatures.AllowExternalIpAccess
    EXTERNAL_IP_ACCESS_ALLOWED: NetworkProfileNetworkFeatures.AllowExternalIpAccess
    EXTERNAL_IP_ACCESS_BLOCKED: NetworkProfileNetworkFeatures.AllowExternalIpAccess
    class AllowInterconnect(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_INTERCONNECT: _ClassVar[NetworkProfileNetworkFeatures.AllowInterconnect]
        INTERCONNECT_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowInterconnect]
        INTERCONNECT_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowInterconnect]
    UNDEFINED_ALLOW_INTERCONNECT: NetworkProfileNetworkFeatures.AllowInterconnect
    INTERCONNECT_ALLOWED: NetworkProfileNetworkFeatures.AllowInterconnect
    INTERCONNECT_BLOCKED: NetworkProfileNetworkFeatures.AllowInterconnect
    class AllowLoadBalancing(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_LOAD_BALANCING: _ClassVar[NetworkProfileNetworkFeatures.AllowLoadBalancing]
        LOAD_BALANCING_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowLoadBalancing]
        LOAD_BALANCING_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowLoadBalancing]
    UNDEFINED_ALLOW_LOAD_BALANCING: NetworkProfileNetworkFeatures.AllowLoadBalancing
    LOAD_BALANCING_ALLOWED: NetworkProfileNetworkFeatures.AllowLoadBalancing
    LOAD_BALANCING_BLOCKED: NetworkProfileNetworkFeatures.AllowLoadBalancing
    class AllowMultiNicInSameNetwork(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_MULTI_NIC_IN_SAME_NETWORK: _ClassVar[NetworkProfileNetworkFeatures.AllowMultiNicInSameNetwork]
        MULTI_NIC_IN_SAME_NETWORK_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowMultiNicInSameNetwork]
        MULTI_NIC_IN_SAME_NETWORK_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowMultiNicInSameNetwork]
    UNDEFINED_ALLOW_MULTI_NIC_IN_SAME_NETWORK: NetworkProfileNetworkFeatures.AllowMultiNicInSameNetwork
    MULTI_NIC_IN_SAME_NETWORK_ALLOWED: NetworkProfileNetworkFeatures.AllowMultiNicInSameNetwork
    MULTI_NIC_IN_SAME_NETWORK_BLOCKED: NetworkProfileNetworkFeatures.AllowMultiNicInSameNetwork
    class AllowPacketMirroring(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_PACKET_MIRRORING: _ClassVar[NetworkProfileNetworkFeatures.AllowPacketMirroring]
        PACKET_MIRRORING_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowPacketMirroring]
        PACKET_MIRRORING_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowPacketMirroring]
    UNDEFINED_ALLOW_PACKET_MIRRORING: NetworkProfileNetworkFeatures.AllowPacketMirroring
    PACKET_MIRRORING_ALLOWED: NetworkProfileNetworkFeatures.AllowPacketMirroring
    PACKET_MIRRORING_BLOCKED: NetworkProfileNetworkFeatures.AllowPacketMirroring
    class AllowPrivateGoogleAccess(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_PRIVATE_GOOGLE_ACCESS: _ClassVar[NetworkProfileNetworkFeatures.AllowPrivateGoogleAccess]
        PRIVATE_GOOGLE_ACCESS_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowPrivateGoogleAccess]
        PRIVATE_GOOGLE_ACCESS_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowPrivateGoogleAccess]
    UNDEFINED_ALLOW_PRIVATE_GOOGLE_ACCESS: NetworkProfileNetworkFeatures.AllowPrivateGoogleAccess
    PRIVATE_GOOGLE_ACCESS_ALLOWED: NetworkProfileNetworkFeatures.AllowPrivateGoogleAccess
    PRIVATE_GOOGLE_ACCESS_BLOCKED: NetworkProfileNetworkFeatures.AllowPrivateGoogleAccess
    class AllowPsc(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_PSC: _ClassVar[NetworkProfileNetworkFeatures.AllowPsc]
        PSC_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowPsc]
        PSC_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowPsc]
    UNDEFINED_ALLOW_PSC: NetworkProfileNetworkFeatures.AllowPsc
    PSC_ALLOWED: NetworkProfileNetworkFeatures.AllowPsc
    PSC_BLOCKED: NetworkProfileNetworkFeatures.AllowPsc
    class AllowSameNetworkUnicast(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_SAME_NETWORK_UNICAST: _ClassVar[NetworkProfileNetworkFeatures.AllowSameNetworkUnicast]
        SAME_NETWORK_UNICAST_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowSameNetworkUnicast]
        SAME_NETWORK_UNICAST_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowSameNetworkUnicast]
    UNDEFINED_ALLOW_SAME_NETWORK_UNICAST: NetworkProfileNetworkFeatures.AllowSameNetworkUnicast
    SAME_NETWORK_UNICAST_ALLOWED: NetworkProfileNetworkFeatures.AllowSameNetworkUnicast
    SAME_NETWORK_UNICAST_BLOCKED: NetworkProfileNetworkFeatures.AllowSameNetworkUnicast
    class AllowStaticRoutes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_STATIC_ROUTES: _ClassVar[NetworkProfileNetworkFeatures.AllowStaticRoutes]
        STATIC_ROUTES_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowStaticRoutes]
        STATIC_ROUTES_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowStaticRoutes]
    UNDEFINED_ALLOW_STATIC_ROUTES: NetworkProfileNetworkFeatures.AllowStaticRoutes
    STATIC_ROUTES_ALLOWED: NetworkProfileNetworkFeatures.AllowStaticRoutes
    STATIC_ROUTES_BLOCKED: NetworkProfileNetworkFeatures.AllowStaticRoutes
    class AllowSubInterfaces(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_SUB_INTERFACES: _ClassVar[NetworkProfileNetworkFeatures.AllowSubInterfaces]
        SUBINTERFACES_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowSubInterfaces]
        SUBINTERFACES_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowSubInterfaces]
    UNDEFINED_ALLOW_SUB_INTERFACES: NetworkProfileNetworkFeatures.AllowSubInterfaces
    SUBINTERFACES_ALLOWED: NetworkProfileNetworkFeatures.AllowSubInterfaces
    SUBINTERFACES_BLOCKED: NetworkProfileNetworkFeatures.AllowSubInterfaces
    class AllowVpcPeering(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_VPC_PEERING: _ClassVar[NetworkProfileNetworkFeatures.AllowVpcPeering]
        VPC_PEERING_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowVpcPeering]
        VPC_PEERING_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowVpcPeering]
    UNDEFINED_ALLOW_VPC_PEERING: NetworkProfileNetworkFeatures.AllowVpcPeering
    VPC_PEERING_ALLOWED: NetworkProfileNetworkFeatures.AllowVpcPeering
    VPC_PEERING_BLOCKED: NetworkProfileNetworkFeatures.AllowVpcPeering
    class AllowVpn(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ALLOW_VPN: _ClassVar[NetworkProfileNetworkFeatures.AllowVpn]
        VPN_ALLOWED: _ClassVar[NetworkProfileNetworkFeatures.AllowVpn]
        VPN_BLOCKED: _ClassVar[NetworkProfileNetworkFeatures.AllowVpn]
    UNDEFINED_ALLOW_VPN: NetworkProfileNetworkFeatures.AllowVpn
    VPN_ALLOWED: NetworkProfileNetworkFeatures.AllowVpn
    VPN_BLOCKED: NetworkProfileNetworkFeatures.AllowVpn
    class InterfaceTypes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INTERFACE_TYPES: _ClassVar[NetworkProfileNetworkFeatures.InterfaceTypes]
        GVNIC: _ClassVar[NetworkProfileNetworkFeatures.InterfaceTypes]
        IDPF: _ClassVar[NetworkProfileNetworkFeatures.InterfaceTypes]
        IRDMA: _ClassVar[NetworkProfileNetworkFeatures.InterfaceTypes]
        MRDMA: _ClassVar[NetworkProfileNetworkFeatures.InterfaceTypes]
        UNSPECIFIED_NIC_TYPE: _ClassVar[NetworkProfileNetworkFeatures.InterfaceTypes]
        VIRTIO_NET: _ClassVar[NetworkProfileNetworkFeatures.InterfaceTypes]
    UNDEFINED_INTERFACE_TYPES: NetworkProfileNetworkFeatures.InterfaceTypes
    GVNIC: NetworkProfileNetworkFeatures.InterfaceTypes
    IDPF: NetworkProfileNetworkFeatures.InterfaceTypes
    IRDMA: NetworkProfileNetworkFeatures.InterfaceTypes
    MRDMA: NetworkProfileNetworkFeatures.InterfaceTypes
    UNSPECIFIED_NIC_TYPE: NetworkProfileNetworkFeatures.InterfaceTypes
    VIRTIO_NET: NetworkProfileNetworkFeatures.InterfaceTypes
    class SubnetPurposes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SUBNET_PURPOSES: _ClassVar[NetworkProfileNetworkFeatures.SubnetPurposes]
        SUBNET_PURPOSE_CUSTOM_HARDWARE: _ClassVar[NetworkProfileNetworkFeatures.SubnetPurposes]
        SUBNET_PURPOSE_PRIVATE: _ClassVar[NetworkProfileNetworkFeatures.SubnetPurposes]
    UNDEFINED_SUBNET_PURPOSES: NetworkProfileNetworkFeatures.SubnetPurposes
    SUBNET_PURPOSE_CUSTOM_HARDWARE: NetworkProfileNetworkFeatures.SubnetPurposes
    SUBNET_PURPOSE_PRIVATE: NetworkProfileNetworkFeatures.SubnetPurposes
    class SubnetStackTypes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SUBNET_STACK_TYPES: _ClassVar[NetworkProfileNetworkFeatures.SubnetStackTypes]
        SUBNET_STACK_TYPE_IPV4_IPV6: _ClassVar[NetworkProfileNetworkFeatures.SubnetStackTypes]
        SUBNET_STACK_TYPE_IPV4_ONLY: _ClassVar[NetworkProfileNetworkFeatures.SubnetStackTypes]
        SUBNET_STACK_TYPE_IPV6_ONLY: _ClassVar[NetworkProfileNetworkFeatures.SubnetStackTypes]
    UNDEFINED_SUBNET_STACK_TYPES: NetworkProfileNetworkFeatures.SubnetStackTypes
    SUBNET_STACK_TYPE_IPV4_IPV6: NetworkProfileNetworkFeatures.SubnetStackTypes
    SUBNET_STACK_TYPE_IPV4_ONLY: NetworkProfileNetworkFeatures.SubnetStackTypes
    SUBNET_STACK_TYPE_IPV6_ONLY: NetworkProfileNetworkFeatures.SubnetStackTypes
    class Unicast(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_UNICAST: _ClassVar[NetworkProfileNetworkFeatures.Unicast]
        UNICAST_SDN: _ClassVar[NetworkProfileNetworkFeatures.Unicast]
        UNICAST_ULL: _ClassVar[NetworkProfileNetworkFeatures.Unicast]
    UNDEFINED_UNICAST: NetworkProfileNetworkFeatures.Unicast
    UNICAST_SDN: NetworkProfileNetworkFeatures.Unicast
    UNICAST_ULL: NetworkProfileNetworkFeatures.Unicast
    ADDRESS_PURPOSES_FIELD_NUMBER: _ClassVar[int]
    ALLOW_ALIAS_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    ALLOW_AUTO_MODE_SUBNET_FIELD_NUMBER: _ClassVar[int]
    ALLOW_CLASS_D_FIREWALLS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_CLOUD_NAT_FIELD_NUMBER: _ClassVar[int]
    ALLOW_CLOUD_ROUTER_FIELD_NUMBER: _ClassVar[int]
    ALLOW_EXTERNAL_IP_ACCESS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_INTERCONNECT_FIELD_NUMBER: _ClassVar[int]
    ALLOW_LOAD_BALANCING_FIELD_NUMBER: _ClassVar[int]
    ALLOW_MULTI_NIC_IN_SAME_NETWORK_FIELD_NUMBER: _ClassVar[int]
    ALLOW_PACKET_MIRRORING_FIELD_NUMBER: _ClassVar[int]
    ALLOW_PRIVATE_GOOGLE_ACCESS_FIELD_NUMBER: _ClassVar[int]
    ALLOW_PSC_FIELD_NUMBER: _ClassVar[int]
    ALLOW_SAME_NETWORK_UNICAST_FIELD_NUMBER: _ClassVar[int]
    ALLOW_STATIC_ROUTES_FIELD_NUMBER: _ClassVar[int]
    ALLOW_SUB_INTERFACES_FIELD_NUMBER: _ClassVar[int]
    ALLOW_VPC_PEERING_FIELD_NUMBER: _ClassVar[int]
    ALLOW_VPN_FIELD_NUMBER: _ClassVar[int]
    INTERFACE_TYPES_FIELD_NUMBER: _ClassVar[int]
    SUBNET_PURPOSES_FIELD_NUMBER: _ClassVar[int]
    SUBNET_STACK_TYPES_FIELD_NUMBER: _ClassVar[int]
    UNICAST_FIELD_NUMBER: _ClassVar[int]
    address_purposes: _containers.RepeatedScalarFieldContainer[str]
    allow_alias_ip_ranges: str
    allow_auto_mode_subnet: str
    allow_class_d_firewalls: str
    allow_cloud_nat: str
    allow_cloud_router: str
    allow_external_ip_access: str
    allow_interconnect: str
    allow_load_balancing: str
    allow_multi_nic_in_same_network: str
    allow_packet_mirroring: str
    allow_private_google_access: str
    allow_psc: str
    allow_same_network_unicast: str
    allow_static_routes: str
    allow_sub_interfaces: str
    allow_vpc_peering: str
    allow_vpn: str
    interface_types: _containers.RepeatedScalarFieldContainer[str]
    subnet_purposes: _containers.RepeatedScalarFieldContainer[str]
    subnet_stack_types: _containers.RepeatedScalarFieldContainer[str]
    unicast: str
    def __init__(self, address_purposes: _Optional[_Iterable[str]] = ..., allow_alias_ip_ranges: _Optional[str] = ..., allow_auto_mode_subnet: _Optional[str] = ..., allow_class_d_firewalls: _Optional[str] = ..., allow_cloud_nat: _Optional[str] = ..., allow_cloud_router: _Optional[str] = ..., allow_external_ip_access: _Optional[str] = ..., allow_interconnect: _Optional[str] = ..., allow_load_balancing: _Optional[str] = ..., allow_multi_nic_in_same_network: _Optional[str] = ..., allow_packet_mirroring: _Optional[str] = ..., allow_private_google_access: _Optional[str] = ..., allow_psc: _Optional[str] = ..., allow_same_network_unicast: _Optional[str] = ..., allow_static_routes: _Optional[str] = ..., allow_sub_interfaces: _Optional[str] = ..., allow_vpc_peering: _Optional[str] = ..., allow_vpn: _Optional[str] = ..., interface_types: _Optional[_Iterable[str]] = ..., subnet_purposes: _Optional[_Iterable[str]] = ..., subnet_stack_types: _Optional[_Iterable[str]] = ..., unicast: _Optional[str] = ...) -> None: ...

class NetworkProfilesListResponse(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NetworkProfile]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NetworkProfile, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NetworkRoutingConfig(_message.Message):
    __slots__ = ("bgp_always_compare_med", "bgp_best_path_selection_mode", "bgp_inter_region_cost", "effective_bgp_always_compare_med", "effective_bgp_inter_region_cost", "routing_mode")
    class BgpBestPathSelectionMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BGP_BEST_PATH_SELECTION_MODE: _ClassVar[NetworkRoutingConfig.BgpBestPathSelectionMode]
        LEGACY: _ClassVar[NetworkRoutingConfig.BgpBestPathSelectionMode]
        STANDARD: _ClassVar[NetworkRoutingConfig.BgpBestPathSelectionMode]
    UNDEFINED_BGP_BEST_PATH_SELECTION_MODE: NetworkRoutingConfig.BgpBestPathSelectionMode
    LEGACY: NetworkRoutingConfig.BgpBestPathSelectionMode
    STANDARD: NetworkRoutingConfig.BgpBestPathSelectionMode
    class BgpInterRegionCost(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BGP_INTER_REGION_COST: _ClassVar[NetworkRoutingConfig.BgpInterRegionCost]
        ADD_COST_TO_MED: _ClassVar[NetworkRoutingConfig.BgpInterRegionCost]
        DEFAULT: _ClassVar[NetworkRoutingConfig.BgpInterRegionCost]
    UNDEFINED_BGP_INTER_REGION_COST: NetworkRoutingConfig.BgpInterRegionCost
    ADD_COST_TO_MED: NetworkRoutingConfig.BgpInterRegionCost
    DEFAULT: NetworkRoutingConfig.BgpInterRegionCost
    class EffectiveBgpInterRegionCost(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_EFFECTIVE_BGP_INTER_REGION_COST: _ClassVar[NetworkRoutingConfig.EffectiveBgpInterRegionCost]
    UNDEFINED_EFFECTIVE_BGP_INTER_REGION_COST: NetworkRoutingConfig.EffectiveBgpInterRegionCost
    class RoutingMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ROUTING_MODE: _ClassVar[NetworkRoutingConfig.RoutingMode]
        GLOBAL: _ClassVar[NetworkRoutingConfig.RoutingMode]
        REGIONAL: _ClassVar[NetworkRoutingConfig.RoutingMode]
    UNDEFINED_ROUTING_MODE: NetworkRoutingConfig.RoutingMode
    GLOBAL: NetworkRoutingConfig.RoutingMode
    REGIONAL: NetworkRoutingConfig.RoutingMode
    BGP_ALWAYS_COMPARE_MED_FIELD_NUMBER: _ClassVar[int]
    BGP_BEST_PATH_SELECTION_MODE_FIELD_NUMBER: _ClassVar[int]
    BGP_INTER_REGION_COST_FIELD_NUMBER: _ClassVar[int]
    EFFECTIVE_BGP_ALWAYS_COMPARE_MED_FIELD_NUMBER: _ClassVar[int]
    EFFECTIVE_BGP_INTER_REGION_COST_FIELD_NUMBER: _ClassVar[int]
    ROUTING_MODE_FIELD_NUMBER: _ClassVar[int]
    bgp_always_compare_med: bool
    bgp_best_path_selection_mode: str
    bgp_inter_region_cost: str
    effective_bgp_always_compare_med: bool
    effective_bgp_inter_region_cost: str
    routing_mode: str
    def __init__(self, bgp_always_compare_med: bool = ..., bgp_best_path_selection_mode: _Optional[str] = ..., bgp_inter_region_cost: _Optional[str] = ..., effective_bgp_always_compare_med: bool = ..., effective_bgp_inter_region_cost: _Optional[str] = ..., routing_mode: _Optional[str] = ...) -> None: ...

class NetworksAddPeeringRequest(_message.Message):
    __slots__ = ("auto_create_routes", "name", "network_peering", "peer_network")
    AUTO_CREATE_ROUTES_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_PEERING_FIELD_NUMBER: _ClassVar[int]
    PEER_NETWORK_FIELD_NUMBER: _ClassVar[int]
    auto_create_routes: bool
    name: str
    network_peering: NetworkPeering
    peer_network: str
    def __init__(self, auto_create_routes: bool = ..., name: _Optional[str] = ..., network_peering: _Optional[_Union[NetworkPeering, _Mapping]] = ..., peer_network: _Optional[str] = ...) -> None: ...

class NetworksGetEffectiveFirewallsResponse(_message.Message):
    __slots__ = ("firewall_policys", "firewalls")
    FIREWALL_POLICYS_FIELD_NUMBER: _ClassVar[int]
    FIREWALLS_FIELD_NUMBER: _ClassVar[int]
    firewall_policys: _containers.RepeatedCompositeFieldContainer[NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy]
    firewalls: _containers.RepeatedCompositeFieldContainer[Firewall]
    def __init__(self, firewall_policys: _Optional[_Iterable[_Union[NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy, _Mapping]]] = ..., firewalls: _Optional[_Iterable[_Union[Firewall, _Mapping]]] = ...) -> None: ...

class NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy(_message.Message):
    __slots__ = ("display_name", "name", "priority", "rules", "short_name", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        HIERARCHY: _ClassVar[NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        NETWORK: _ClassVar[NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        SYSTEM: _ClassVar[NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        UNSPECIFIED: _ClassVar[NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
    UNDEFINED_TYPE: NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    HIERARCHY: NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    NETWORK: NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    SYSTEM: NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    UNSPECIFIED: NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    RULES_FIELD_NUMBER: _ClassVar[int]
    SHORT_NAME_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    display_name: str
    name: str
    priority: int
    rules: _containers.RepeatedCompositeFieldContainer[FirewallPolicyRule]
    short_name: str
    type: str
    def __init__(self, display_name: _Optional[str] = ..., name: _Optional[str] = ..., priority: _Optional[int] = ..., rules: _Optional[_Iterable[_Union[FirewallPolicyRule, _Mapping]]] = ..., short_name: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class NetworksRemovePeeringRequest(_message.Message):
    __slots__ = ("name",)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class NetworksUpdatePeeringRequest(_message.Message):
    __slots__ = ("network_peering",)
    NETWORK_PEERING_FIELD_NUMBER: _ClassVar[int]
    network_peering: NetworkPeering
    def __init__(self, network_peering: _Optional[_Union[NetworkPeering, _Mapping]] = ...) -> None: ...

class NodeGroup(_message.Message):
    __slots__ = ("autoscaling_policy", "creation_timestamp", "description", "fingerprint", "id", "kind", "location_hint", "maintenance_interval", "maintenance_policy", "maintenance_window", "name", "node_template", "self_link", "share_settings", "size", "status", "zone")
    class MaintenanceInterval(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MAINTENANCE_INTERVAL: _ClassVar[NodeGroup.MaintenanceInterval]
        AS_NEEDED: _ClassVar[NodeGroup.MaintenanceInterval]
        RECURRENT: _ClassVar[NodeGroup.MaintenanceInterval]
    UNDEFINED_MAINTENANCE_INTERVAL: NodeGroup.MaintenanceInterval
    AS_NEEDED: NodeGroup.MaintenanceInterval
    RECURRENT: NodeGroup.MaintenanceInterval
    class MaintenancePolicy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MAINTENANCE_POLICY: _ClassVar[NodeGroup.MaintenancePolicy]
        DEFAULT: _ClassVar[NodeGroup.MaintenancePolicy]
        MAINTENANCE_POLICY_UNSPECIFIED: _ClassVar[NodeGroup.MaintenancePolicy]
        MIGRATE_WITHIN_NODE_GROUP: _ClassVar[NodeGroup.MaintenancePolicy]
        RESTART_IN_PLACE: _ClassVar[NodeGroup.MaintenancePolicy]
    UNDEFINED_MAINTENANCE_POLICY: NodeGroup.MaintenancePolicy
    DEFAULT: NodeGroup.MaintenancePolicy
    MAINTENANCE_POLICY_UNSPECIFIED: NodeGroup.MaintenancePolicy
    MIGRATE_WITHIN_NODE_GROUP: NodeGroup.MaintenancePolicy
    RESTART_IN_PLACE: NodeGroup.MaintenancePolicy
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[NodeGroup.Status]
        CREATING: _ClassVar[NodeGroup.Status]
        DELETING: _ClassVar[NodeGroup.Status]
        INVALID: _ClassVar[NodeGroup.Status]
        READY: _ClassVar[NodeGroup.Status]
    UNDEFINED_STATUS: NodeGroup.Status
    CREATING: NodeGroup.Status
    DELETING: NodeGroup.Status
    INVALID: NodeGroup.Status
    READY: NodeGroup.Status
    AUTOSCALING_POLICY_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOCATION_HINT_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_INTERVAL_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_POLICY_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_WINDOW_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NODE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SHARE_SETTINGS_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    autoscaling_policy: NodeGroupAutoscalingPolicy
    creation_timestamp: str
    description: str
    fingerprint: str
    id: int
    kind: str
    location_hint: str
    maintenance_interval: str
    maintenance_policy: str
    maintenance_window: NodeGroupMaintenanceWindow
    name: str
    node_template: str
    self_link: str
    share_settings: ShareSettings
    size: int
    status: str
    zone: str
    def __init__(self, autoscaling_policy: _Optional[_Union[NodeGroupAutoscalingPolicy, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., location_hint: _Optional[str] = ..., maintenance_interval: _Optional[str] = ..., maintenance_policy: _Optional[str] = ..., maintenance_window: _Optional[_Union[NodeGroupMaintenanceWindow, _Mapping]] = ..., name: _Optional[str] = ..., node_template: _Optional[str] = ..., self_link: _Optional[str] = ..., share_settings: _Optional[_Union[ShareSettings, _Mapping]] = ..., size: _Optional[int] = ..., status: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class NodeGroupAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: NodeGroupsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[NodeGroupsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, NodeGroupsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, NodeGroupsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeGroupAutoscalingPolicy(_message.Message):
    __slots__ = ("max_nodes", "min_nodes", "mode")
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[NodeGroupAutoscalingPolicy.Mode]
        MODE_UNSPECIFIED: _ClassVar[NodeGroupAutoscalingPolicy.Mode]
        OFF: _ClassVar[NodeGroupAutoscalingPolicy.Mode]
        ON: _ClassVar[NodeGroupAutoscalingPolicy.Mode]
        ONLY_SCALE_OUT: _ClassVar[NodeGroupAutoscalingPolicy.Mode]
    UNDEFINED_MODE: NodeGroupAutoscalingPolicy.Mode
    MODE_UNSPECIFIED: NodeGroupAutoscalingPolicy.Mode
    OFF: NodeGroupAutoscalingPolicy.Mode
    ON: NodeGroupAutoscalingPolicy.Mode
    ONLY_SCALE_OUT: NodeGroupAutoscalingPolicy.Mode
    MAX_NODES_FIELD_NUMBER: _ClassVar[int]
    MIN_NODES_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    max_nodes: int
    min_nodes: int
    mode: str
    def __init__(self, max_nodes: _Optional[int] = ..., min_nodes: _Optional[int] = ..., mode: _Optional[str] = ...) -> None: ...

class NodeGroupList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NodeGroup]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NodeGroup, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeGroupMaintenanceWindow(_message.Message):
    __slots__ = ("maintenance_duration", "start_time")
    MAINTENANCE_DURATION_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    maintenance_duration: Duration
    start_time: str
    def __init__(self, maintenance_duration: _Optional[_Union[Duration, _Mapping]] = ..., start_time: _Optional[str] = ...) -> None: ...

class NodeGroupNode(_message.Message):
    __slots__ = ("accelerators", "consumed_resources", "cpu_overcommit_type", "disks", "instance_consumption_data", "instances", "name", "node_type", "satisfies_pzs", "server_binding", "server_id", "status", "total_resources", "upcoming_maintenance")
    class CpuOvercommitType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CPU_OVERCOMMIT_TYPE: _ClassVar[NodeGroupNode.CpuOvercommitType]
        CPU_OVERCOMMIT_TYPE_UNSPECIFIED: _ClassVar[NodeGroupNode.CpuOvercommitType]
        ENABLED: _ClassVar[NodeGroupNode.CpuOvercommitType]
        NONE: _ClassVar[NodeGroupNode.CpuOvercommitType]
    UNDEFINED_CPU_OVERCOMMIT_TYPE: NodeGroupNode.CpuOvercommitType
    CPU_OVERCOMMIT_TYPE_UNSPECIFIED: NodeGroupNode.CpuOvercommitType
    ENABLED: NodeGroupNode.CpuOvercommitType
    NONE: NodeGroupNode.CpuOvercommitType
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[NodeGroupNode.Status]
        CREATING: _ClassVar[NodeGroupNode.Status]
        DELETING: _ClassVar[NodeGroupNode.Status]
        INVALID: _ClassVar[NodeGroupNode.Status]
        READY: _ClassVar[NodeGroupNode.Status]
        REPAIRING: _ClassVar[NodeGroupNode.Status]
    UNDEFINED_STATUS: NodeGroupNode.Status
    CREATING: NodeGroupNode.Status
    DELETING: NodeGroupNode.Status
    INVALID: NodeGroupNode.Status
    READY: NodeGroupNode.Status
    REPAIRING: NodeGroupNode.Status
    ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    CONSUMED_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    CPU_OVERCOMMIT_TYPE_FIELD_NUMBER: _ClassVar[int]
    DISKS_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_CONSUMPTION_DATA_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NODE_TYPE_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SERVER_BINDING_FIELD_NUMBER: _ClassVar[int]
    SERVER_ID_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TOTAL_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    UPCOMING_MAINTENANCE_FIELD_NUMBER: _ClassVar[int]
    accelerators: _containers.RepeatedCompositeFieldContainer[AcceleratorConfig]
    consumed_resources: InstanceConsumptionInfo
    cpu_overcommit_type: str
    disks: _containers.RepeatedCompositeFieldContainer[LocalDisk]
    instance_consumption_data: _containers.RepeatedCompositeFieldContainer[InstanceConsumptionData]
    instances: _containers.RepeatedScalarFieldContainer[str]
    name: str
    node_type: str
    satisfies_pzs: bool
    server_binding: ServerBinding
    server_id: str
    status: str
    total_resources: InstanceConsumptionInfo
    upcoming_maintenance: UpcomingMaintenance
    def __init__(self, accelerators: _Optional[_Iterable[_Union[AcceleratorConfig, _Mapping]]] = ..., consumed_resources: _Optional[_Union[InstanceConsumptionInfo, _Mapping]] = ..., cpu_overcommit_type: _Optional[str] = ..., disks: _Optional[_Iterable[_Union[LocalDisk, _Mapping]]] = ..., instance_consumption_data: _Optional[_Iterable[_Union[InstanceConsumptionData, _Mapping]]] = ..., instances: _Optional[_Iterable[str]] = ..., name: _Optional[str] = ..., node_type: _Optional[str] = ..., satisfies_pzs: bool = ..., server_binding: _Optional[_Union[ServerBinding, _Mapping]] = ..., server_id: _Optional[str] = ..., status: _Optional[str] = ..., total_resources: _Optional[_Union[InstanceConsumptionInfo, _Mapping]] = ..., upcoming_maintenance: _Optional[_Union[UpcomingMaintenance, _Mapping]] = ...) -> None: ...

class NodeGroupsAddNodesRequest(_message.Message):
    __slots__ = ("additional_node_count",)
    ADDITIONAL_NODE_COUNT_FIELD_NUMBER: _ClassVar[int]
    additional_node_count: int
    def __init__(self, additional_node_count: _Optional[int] = ...) -> None: ...

class NodeGroupsDeleteNodesRequest(_message.Message):
    __slots__ = ("nodes",)
    NODES_FIELD_NUMBER: _ClassVar[int]
    nodes: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, nodes: _Optional[_Iterable[str]] = ...) -> None: ...

class NodeGroupsListNodes(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NodeGroupNode]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NodeGroupNode, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeGroupsPerformMaintenanceRequest(_message.Message):
    __slots__ = ("nodes", "start_time")
    NODES_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    nodes: _containers.RepeatedScalarFieldContainer[str]
    start_time: str
    def __init__(self, nodes: _Optional[_Iterable[str]] = ..., start_time: _Optional[str] = ...) -> None: ...

class NodeGroupsScopedList(_message.Message):
    __slots__ = ("node_groups", "warning")
    NODE_GROUPS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    node_groups: _containers.RepeatedCompositeFieldContainer[NodeGroup]
    warning: Warning
    def __init__(self, node_groups: _Optional[_Iterable[_Union[NodeGroup, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeGroupsSetNodeTemplateRequest(_message.Message):
    __slots__ = ("node_template",)
    NODE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    node_template: str
    def __init__(self, node_template: _Optional[str] = ...) -> None: ...

class NodeGroupsSimulateMaintenanceEventRequest(_message.Message):
    __slots__ = ("nodes",)
    NODES_FIELD_NUMBER: _ClassVar[int]
    nodes: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, nodes: _Optional[_Iterable[str]] = ...) -> None: ...

class NodeTemplate(_message.Message):
    __slots__ = ("accelerators", "cpu_overcommit_type", "creation_timestamp", "description", "disks", "id", "kind", "name", "node_affinity_labels", "node_type", "node_type_flexibility", "region", "self_link", "server_binding", "status", "status_message")
    class CpuOvercommitType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CPU_OVERCOMMIT_TYPE: _ClassVar[NodeTemplate.CpuOvercommitType]
        CPU_OVERCOMMIT_TYPE_UNSPECIFIED: _ClassVar[NodeTemplate.CpuOvercommitType]
        ENABLED: _ClassVar[NodeTemplate.CpuOvercommitType]
        NONE: _ClassVar[NodeTemplate.CpuOvercommitType]
    UNDEFINED_CPU_OVERCOMMIT_TYPE: NodeTemplate.CpuOvercommitType
    CPU_OVERCOMMIT_TYPE_UNSPECIFIED: NodeTemplate.CpuOvercommitType
    ENABLED: NodeTemplate.CpuOvercommitType
    NONE: NodeTemplate.CpuOvercommitType
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[NodeTemplate.Status]
        CREATING: _ClassVar[NodeTemplate.Status]
        DELETING: _ClassVar[NodeTemplate.Status]
        INVALID: _ClassVar[NodeTemplate.Status]
        READY: _ClassVar[NodeTemplate.Status]
    UNDEFINED_STATUS: NodeTemplate.Status
    CREATING: NodeTemplate.Status
    DELETING: NodeTemplate.Status
    INVALID: NodeTemplate.Status
    READY: NodeTemplate.Status
    class NodeAffinityLabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    CPU_OVERCOMMIT_TYPE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISKS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NODE_AFFINITY_LABELS_FIELD_NUMBER: _ClassVar[int]
    NODE_TYPE_FIELD_NUMBER: _ClassVar[int]
    NODE_TYPE_FLEXIBILITY_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SERVER_BINDING_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STATUS_MESSAGE_FIELD_NUMBER: _ClassVar[int]
    accelerators: _containers.RepeatedCompositeFieldContainer[AcceleratorConfig]
    cpu_overcommit_type: str
    creation_timestamp: str
    description: str
    disks: _containers.RepeatedCompositeFieldContainer[LocalDisk]
    id: int
    kind: str
    name: str
    node_affinity_labels: _containers.ScalarMap[str, str]
    node_type: str
    node_type_flexibility: NodeTemplateNodeTypeFlexibility
    region: str
    self_link: str
    server_binding: ServerBinding
    status: str
    status_message: str
    def __init__(self, accelerators: _Optional[_Iterable[_Union[AcceleratorConfig, _Mapping]]] = ..., cpu_overcommit_type: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., disks: _Optional[_Iterable[_Union[LocalDisk, _Mapping]]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., node_affinity_labels: _Optional[_Mapping[str, str]] = ..., node_type: _Optional[str] = ..., node_type_flexibility: _Optional[_Union[NodeTemplateNodeTypeFlexibility, _Mapping]] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., server_binding: _Optional[_Union[ServerBinding, _Mapping]] = ..., status: _Optional[str] = ..., status_message: _Optional[str] = ...) -> None: ...

class NodeTemplateAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: NodeTemplatesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[NodeTemplatesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, NodeTemplatesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, NodeTemplatesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeTemplateList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NodeTemplate]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NodeTemplate, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeTemplateNodeTypeFlexibility(_message.Message):
    __slots__ = ("cpus", "local_ssd", "memory")
    CPUS_FIELD_NUMBER: _ClassVar[int]
    LOCAL_SSD_FIELD_NUMBER: _ClassVar[int]
    MEMORY_FIELD_NUMBER: _ClassVar[int]
    cpus: str
    local_ssd: str
    memory: str
    def __init__(self, cpus: _Optional[str] = ..., local_ssd: _Optional[str] = ..., memory: _Optional[str] = ...) -> None: ...

class NodeTemplatesScopedList(_message.Message):
    __slots__ = ("node_templates", "warning")
    NODE_TEMPLATES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    node_templates: _containers.RepeatedCompositeFieldContainer[NodeTemplate]
    warning: Warning
    def __init__(self, node_templates: _Optional[_Iterable[_Union[NodeTemplate, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeType(_message.Message):
    __slots__ = ("cpu_platform", "creation_timestamp", "deprecated", "description", "guest_cpus", "id", "kind", "local_ssd_gb", "memory_mb", "name", "self_link", "zone")
    CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    GUEST_CPUS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOCAL_SSD_GB_FIELD_NUMBER: _ClassVar[int]
    MEMORY_MB_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    cpu_platform: str
    creation_timestamp: str
    deprecated: DeprecationStatus
    description: str
    guest_cpus: int
    id: int
    kind: str
    local_ssd_gb: int
    memory_mb: int
    name: str
    self_link: str
    zone: str
    def __init__(self, cpu_platform: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., guest_cpus: _Optional[int] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., local_ssd_gb: _Optional[int] = ..., memory_mb: _Optional[int] = ..., name: _Optional[str] = ..., self_link: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class NodeTypeAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: NodeTypesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[NodeTypesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, NodeTypesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, NodeTypesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeTypeList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NodeType]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NodeType, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NodeTypesScopedList(_message.Message):
    __slots__ = ("node_types", "warning")
    NODE_TYPES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    node_types: _containers.RepeatedCompositeFieldContainer[NodeType]
    warning: Warning
    def __init__(self, node_types: _Optional[_Iterable[_Union[NodeType, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class NotificationEndpoint(_message.Message):
    __slots__ = ("creation_timestamp", "description", "grpc_settings", "id", "kind", "name", "region", "self_link")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    GRPC_SETTINGS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    grpc_settings: NotificationEndpointGrpcSettings
    id: int
    kind: str
    name: str
    region: str
    self_link: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., grpc_settings: _Optional[_Union[NotificationEndpointGrpcSettings, _Mapping]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ...) -> None: ...

class NotificationEndpointGrpcSettings(_message.Message):
    __slots__ = ("authority", "endpoint", "payload_name", "resend_interval", "retry_duration_sec")
    AUTHORITY_FIELD_NUMBER: _ClassVar[int]
    ENDPOINT_FIELD_NUMBER: _ClassVar[int]
    PAYLOAD_NAME_FIELD_NUMBER: _ClassVar[int]
    RESEND_INTERVAL_FIELD_NUMBER: _ClassVar[int]
    RETRY_DURATION_SEC_FIELD_NUMBER: _ClassVar[int]
    authority: str
    endpoint: str
    payload_name: str
    resend_interval: Duration
    retry_duration_sec: int
    def __init__(self, authority: _Optional[str] = ..., endpoint: _Optional[str] = ..., payload_name: _Optional[str] = ..., resend_interval: _Optional[_Union[Duration, _Mapping]] = ..., retry_duration_sec: _Optional[int] = ...) -> None: ...

class NotificationEndpointList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[NotificationEndpoint]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[NotificationEndpoint, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class Operation(_message.Message):
    __slots__ = ("client_operation_id", "creation_timestamp", "description", "end_time", "error", "http_error_message", "http_error_status_code", "id", "insert_time", "instances_bulk_insert_operation_metadata", "kind", "name", "operation_group_id", "operation_type", "progress", "region", "self_link", "set_common_instance_metadata_operation_metadata", "start_time", "status", "status_message", "target_id", "target_link", "user", "warnings", "zone")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Operation.Status]
        DONE: _ClassVar[Operation.Status]
        PENDING: _ClassVar[Operation.Status]
        RUNNING: _ClassVar[Operation.Status]
    UNDEFINED_STATUS: Operation.Status
    DONE: Operation.Status
    PENDING: Operation.Status
    RUNNING: Operation.Status
    CLIENT_OPERATION_ID_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    END_TIME_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    HTTP_ERROR_MESSAGE_FIELD_NUMBER: _ClassVar[int]
    HTTP_ERROR_STATUS_CODE_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSERT_TIME_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_BULK_INSERT_OPERATION_METADATA_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    OPERATION_GROUP_ID_FIELD_NUMBER: _ClassVar[int]
    OPERATION_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROGRESS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SET_COMMON_INSTANCE_METADATA_OPERATION_METADATA_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STATUS_MESSAGE_FIELD_NUMBER: _ClassVar[int]
    TARGET_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_LINK_FIELD_NUMBER: _ClassVar[int]
    USER_FIELD_NUMBER: _ClassVar[int]
    WARNINGS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    client_operation_id: str
    creation_timestamp: str
    description: str
    end_time: str
    error: Error
    http_error_message: str
    http_error_status_code: int
    id: int
    insert_time: str
    instances_bulk_insert_operation_metadata: InstancesBulkInsertOperationMetadata
    kind: str
    name: str
    operation_group_id: str
    operation_type: str
    progress: int
    region: str
    self_link: str
    set_common_instance_metadata_operation_metadata: SetCommonInstanceMetadataOperationMetadata
    start_time: str
    status: Operation.Status
    status_message: str
    target_id: int
    target_link: str
    user: str
    warnings: _containers.RepeatedCompositeFieldContainer[Warnings]
    zone: str
    def __init__(self, client_operation_id: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., end_time: _Optional[str] = ..., error: _Optional[_Union[Error, _Mapping]] = ..., http_error_message: _Optional[str] = ..., http_error_status_code: _Optional[int] = ..., id: _Optional[int] = ..., insert_time: _Optional[str] = ..., instances_bulk_insert_operation_metadata: _Optional[_Union[InstancesBulkInsertOperationMetadata, _Mapping]] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., operation_group_id: _Optional[str] = ..., operation_type: _Optional[str] = ..., progress: _Optional[int] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., set_common_instance_metadata_operation_metadata: _Optional[_Union[SetCommonInstanceMetadataOperationMetadata, _Mapping]] = ..., start_time: _Optional[str] = ..., status: _Optional[_Union[Operation.Status, str]] = ..., status_message: _Optional[str] = ..., target_id: _Optional[int] = ..., target_link: _Optional[str] = ..., user: _Optional[str] = ..., warnings: _Optional[_Iterable[_Union[Warnings, _Mapping]]] = ..., zone: _Optional[str] = ...) -> None: ...

class OperationAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: OperationsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[OperationsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, OperationsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, OperationsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class OperationList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Operation]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Operation, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class OperationsScopedList(_message.Message):
    __slots__ = ("operations", "warning")
    OPERATIONS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    operations: _containers.RepeatedCompositeFieldContainer[Operation]
    warning: Warning
    def __init__(self, operations: _Optional[_Iterable[_Union[Operation, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class OutlierDetection(_message.Message):
    __slots__ = ("base_ejection_time", "consecutive_errors", "consecutive_gateway_failure", "enforcing_consecutive_errors", "enforcing_consecutive_gateway_failure", "enforcing_success_rate", "interval", "max_ejection_percent", "success_rate_minimum_hosts", "success_rate_request_volume", "success_rate_stdev_factor")
    BASE_EJECTION_TIME_FIELD_NUMBER: _ClassVar[int]
    CONSECUTIVE_ERRORS_FIELD_NUMBER: _ClassVar[int]
    CONSECUTIVE_GATEWAY_FAILURE_FIELD_NUMBER: _ClassVar[int]
    ENFORCING_CONSECUTIVE_ERRORS_FIELD_NUMBER: _ClassVar[int]
    ENFORCING_CONSECUTIVE_GATEWAY_FAILURE_FIELD_NUMBER: _ClassVar[int]
    ENFORCING_SUCCESS_RATE_FIELD_NUMBER: _ClassVar[int]
    INTERVAL_FIELD_NUMBER: _ClassVar[int]
    MAX_EJECTION_PERCENT_FIELD_NUMBER: _ClassVar[int]
    SUCCESS_RATE_MINIMUM_HOSTS_FIELD_NUMBER: _ClassVar[int]
    SUCCESS_RATE_REQUEST_VOLUME_FIELD_NUMBER: _ClassVar[int]
    SUCCESS_RATE_STDEV_FACTOR_FIELD_NUMBER: _ClassVar[int]
    base_ejection_time: Duration
    consecutive_errors: int
    consecutive_gateway_failure: int
    enforcing_consecutive_errors: int
    enforcing_consecutive_gateway_failure: int
    enforcing_success_rate: int
    interval: Duration
    max_ejection_percent: int
    success_rate_minimum_hosts: int
    success_rate_request_volume: int
    success_rate_stdev_factor: int
    def __init__(self, base_ejection_time: _Optional[_Union[Duration, _Mapping]] = ..., consecutive_errors: _Optional[int] = ..., consecutive_gateway_failure: _Optional[int] = ..., enforcing_consecutive_errors: _Optional[int] = ..., enforcing_consecutive_gateway_failure: _Optional[int] = ..., enforcing_success_rate: _Optional[int] = ..., interval: _Optional[_Union[Duration, _Mapping]] = ..., max_ejection_percent: _Optional[int] = ..., success_rate_minimum_hosts: _Optional[int] = ..., success_rate_request_volume: _Optional[int] = ..., success_rate_stdev_factor: _Optional[int] = ...) -> None: ...

class PacketIntervals(_message.Message):
    __slots__ = ("avg_ms", "duration", "max_ms", "min_ms", "num_intervals", "type")
    class Duration(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DURATION: _ClassVar[PacketIntervals.Duration]
        DURATION_UNSPECIFIED: _ClassVar[PacketIntervals.Duration]
        HOUR: _ClassVar[PacketIntervals.Duration]
        MAX: _ClassVar[PacketIntervals.Duration]
        MINUTE: _ClassVar[PacketIntervals.Duration]
    UNDEFINED_DURATION: PacketIntervals.Duration
    DURATION_UNSPECIFIED: PacketIntervals.Duration
    HOUR: PacketIntervals.Duration
    MAX: PacketIntervals.Duration
    MINUTE: PacketIntervals.Duration
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[PacketIntervals.Type]
        LOOPBACK: _ClassVar[PacketIntervals.Type]
        RECEIVE: _ClassVar[PacketIntervals.Type]
        TRANSMIT: _ClassVar[PacketIntervals.Type]
        TYPE_UNSPECIFIED: _ClassVar[PacketIntervals.Type]
    UNDEFINED_TYPE: PacketIntervals.Type
    LOOPBACK: PacketIntervals.Type
    RECEIVE: PacketIntervals.Type
    TRANSMIT: PacketIntervals.Type
    TYPE_UNSPECIFIED: PacketIntervals.Type
    AVG_MS_FIELD_NUMBER: _ClassVar[int]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    MAX_MS_FIELD_NUMBER: _ClassVar[int]
    MIN_MS_FIELD_NUMBER: _ClassVar[int]
    NUM_INTERVALS_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    avg_ms: int
    duration: str
    max_ms: int
    min_ms: int
    num_intervals: int
    type: str
    def __init__(self, avg_ms: _Optional[int] = ..., duration: _Optional[str] = ..., max_ms: _Optional[int] = ..., min_ms: _Optional[int] = ..., num_intervals: _Optional[int] = ..., type: _Optional[str] = ...) -> None: ...

class PacketMirroring(_message.Message):
    __slots__ = ("collector_ilb", "creation_timestamp", "description", "enable", "filter", "id", "kind", "mirrored_resources", "name", "network", "priority", "region", "self_link")
    class Enable(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ENABLE: _ClassVar[PacketMirroring.Enable]
        FALSE: _ClassVar[PacketMirroring.Enable]
        TRUE: _ClassVar[PacketMirroring.Enable]
    UNDEFINED_ENABLE: PacketMirroring.Enable
    FALSE: PacketMirroring.Enable
    TRUE: PacketMirroring.Enable
    COLLECTOR_ILB_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MIRRORED_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    collector_ilb: PacketMirroringForwardingRuleInfo
    creation_timestamp: str
    description: str
    enable: str
    filter: PacketMirroringFilter
    id: int
    kind: str
    mirrored_resources: PacketMirroringMirroredResourceInfo
    name: str
    network: PacketMirroringNetworkInfo
    priority: int
    region: str
    self_link: str
    def __init__(self, collector_ilb: _Optional[_Union[PacketMirroringForwardingRuleInfo, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., enable: _Optional[str] = ..., filter: _Optional[_Union[PacketMirroringFilter, _Mapping]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., mirrored_resources: _Optional[_Union[PacketMirroringMirroredResourceInfo, _Mapping]] = ..., name: _Optional[str] = ..., network: _Optional[_Union[PacketMirroringNetworkInfo, _Mapping]] = ..., priority: _Optional[int] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ...) -> None: ...

class PacketMirroringAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: PacketMirroringsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[PacketMirroringsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, PacketMirroringsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, PacketMirroringsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class PacketMirroringFilter(_message.Message):
    __slots__ = ("I_p_protocols", "cidr_ranges", "direction")
    class Direction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DIRECTION: _ClassVar[PacketMirroringFilter.Direction]
        BOTH: _ClassVar[PacketMirroringFilter.Direction]
        EGRESS: _ClassVar[PacketMirroringFilter.Direction]
        INGRESS: _ClassVar[PacketMirroringFilter.Direction]
    UNDEFINED_DIRECTION: PacketMirroringFilter.Direction
    BOTH: PacketMirroringFilter.Direction
    EGRESS: PacketMirroringFilter.Direction
    INGRESS: PacketMirroringFilter.Direction
    I_P_PROTOCOLS_FIELD_NUMBER: _ClassVar[int]
    CIDR_RANGES_FIELD_NUMBER: _ClassVar[int]
    DIRECTION_FIELD_NUMBER: _ClassVar[int]
    I_p_protocols: _containers.RepeatedScalarFieldContainer[str]
    cidr_ranges: _containers.RepeatedScalarFieldContainer[str]
    direction: str
    def __init__(self, I_p_protocols: _Optional[_Iterable[str]] = ..., cidr_ranges: _Optional[_Iterable[str]] = ..., direction: _Optional[str] = ...) -> None: ...

class PacketMirroringForwardingRuleInfo(_message.Message):
    __slots__ = ("canonical_url", "url")
    CANONICAL_URL_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    canonical_url: str
    url: str
    def __init__(self, canonical_url: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class PacketMirroringList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[PacketMirroring]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[PacketMirroring, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class PacketMirroringMirroredResourceInfo(_message.Message):
    __slots__ = ("instances", "subnetworks", "tags")
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORKS_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[PacketMirroringMirroredResourceInfoInstanceInfo]
    subnetworks: _containers.RepeatedCompositeFieldContainer[PacketMirroringMirroredResourceInfoSubnetInfo]
    tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[_Union[PacketMirroringMirroredResourceInfoInstanceInfo, _Mapping]]] = ..., subnetworks: _Optional[_Iterable[_Union[PacketMirroringMirroredResourceInfoSubnetInfo, _Mapping]]] = ..., tags: _Optional[_Iterable[str]] = ...) -> None: ...

class PacketMirroringMirroredResourceInfoInstanceInfo(_message.Message):
    __slots__ = ("canonical_url", "url")
    CANONICAL_URL_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    canonical_url: str
    url: str
    def __init__(self, canonical_url: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class PacketMirroringMirroredResourceInfoSubnetInfo(_message.Message):
    __slots__ = ("canonical_url", "url")
    CANONICAL_URL_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    canonical_url: str
    url: str
    def __init__(self, canonical_url: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class PacketMirroringNetworkInfo(_message.Message):
    __slots__ = ("canonical_url", "url")
    CANONICAL_URL_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    canonical_url: str
    url: str
    def __init__(self, canonical_url: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class PacketMirroringsScopedList(_message.Message):
    __slots__ = ("packet_mirrorings", "warning")
    PACKET_MIRRORINGS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    packet_mirrorings: _containers.RepeatedCompositeFieldContainer[PacketMirroring]
    warning: Warning
    def __init__(self, packet_mirrorings: _Optional[_Iterable[_Union[PacketMirroring, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class PatchAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "autoscaler_resource", "project", "request_id", "zone")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    AUTOSCALER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    autoscaler_resource: Autoscaler
    project: str
    request_id: str
    zone: str
    def __init__(self, autoscaler: _Optional[str] = ..., autoscaler_resource: _Optional[_Union[Autoscaler, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class PatchBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket", "backend_bucket_resource", "project", "request_id")
    BACKEND_BUCKET_FIELD_NUMBER: _ClassVar[int]
    BACKEND_BUCKET_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_bucket: str
    backend_bucket_resource: BackendBucket
    project: str
    request_id: str
    def __init__(self, backend_bucket: _Optional[str] = ..., backend_bucket_resource: _Optional[_Union[BackendBucket, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "backend_service_resource", "project", "request_id")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    BACKEND_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    backend_service_resource: BackendService
    project: str
    request_id: str
    def __init__(self, backend_service: _Optional[str] = ..., backend_service_resource: _Optional[_Union[BackendService, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_resource", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_resource: FirewallPolicy
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_resource: _Optional[_Union[FirewallPolicy, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchFirewallRequest(_message.Message):
    __slots__ = ("firewall", "firewall_resource", "project", "request_id")
    FIREWALL_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall: str
    firewall_resource: Firewall
    project: str
    request_id: str
    def __init__(self, firewall: _Optional[str] = ..., firewall_resource: _Optional[_Union[Firewall, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "forwarding_rule_resource", "project", "region", "request_id")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    FORWARDING_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    forwarding_rule_resource: ForwardingRule
    project: str
    region: str
    request_id: str
    def __init__(self, forwarding_rule: _Optional[str] = ..., forwarding_rule_resource: _Optional[_Union[ForwardingRule, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchGlobalForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "forwarding_rule_resource", "project", "request_id")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    FORWARDING_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    forwarding_rule_resource: ForwardingRule
    project: str
    request_id: str
    def __init__(self, forwarding_rule: _Optional[str] = ..., forwarding_rule_resource: _Optional[_Union[ForwardingRule, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchGlobalPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix", "public_delegated_prefix_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    public_delegated_prefix_resource: PublicDelegatedPrefix
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ..., public_delegated_prefix_resource: _Optional[_Union[PublicDelegatedPrefix, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "health_check_resource", "project", "request_id")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    health_check_resource: HealthCheck
    project: str
    request_id: str
    def __init__(self, health_check: _Optional[str] = ..., health_check_resource: _Optional[_Union[HealthCheck, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchImageRequest(_message.Message):
    __slots__ = ("image", "image_resource", "project", "request_id")
    IMAGE_FIELD_NUMBER: _ClassVar[int]
    IMAGE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    image: str
    image_resource: Image
    project: str
    request_id: str
    def __init__(self, image: _Optional[str] = ..., image_resource: _Optional[_Union[Image, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_manager_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_manager_resource: InstanceGroupManager
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_manager_resource: _Optional[_Union[InstanceGroupManager, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class PatchInstanceSettingRequest(_message.Message):
    __slots__ = ("instance_settings_resource", "project", "request_id", "update_mask", "zone")
    INSTANCE_SETTINGS_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_settings_resource: InstanceSettings
    project: str
    request_id: str
    update_mask: str
    zone: str
    def __init__(self, instance_settings_resource: _Optional[_Union[InstanceSettings, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., update_mask: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class PatchInterconnectAttachmentRequest(_message.Message):
    __slots__ = ("interconnect_attachment", "interconnect_attachment_resource", "project", "region", "request_id")
    INTERCONNECT_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    INTERCONNECT_ATTACHMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    interconnect_attachment: str
    interconnect_attachment_resource: InterconnectAttachment
    project: str
    region: str
    request_id: str
    def __init__(self, interconnect_attachment: _Optional[str] = ..., interconnect_attachment_resource: _Optional[_Union[InterconnectAttachment, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchInterconnectRequest(_message.Message):
    __slots__ = ("interconnect", "interconnect_resource", "project", "request_id")
    INTERCONNECT_FIELD_NUMBER: _ClassVar[int]
    INTERCONNECT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    interconnect: str
    interconnect_resource: Interconnect
    project: str
    request_id: str
    def __init__(self, interconnect: _Optional[str] = ..., interconnect_resource: _Optional[_Union[Interconnect, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchNetworkAttachmentRequest(_message.Message):
    __slots__ = ("network_attachment", "network_attachment_resource", "project", "region", "request_id")
    NETWORK_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    NETWORK_ATTACHMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network_attachment: str
    network_attachment_resource: NetworkAttachment
    project: str
    region: str
    request_id: str
    def __init__(self, network_attachment: _Optional[str] = ..., network_attachment_resource: _Optional[_Union[NetworkAttachment, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchNetworkEdgeSecurityServiceRequest(_message.Message):
    __slots__ = ("network_edge_security_service", "network_edge_security_service_resource", "paths", "project", "region", "request_id", "update_mask")
    NETWORK_EDGE_SECURITY_SERVICE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_EDGE_SECURITY_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PATHS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    network_edge_security_service: str
    network_edge_security_service_resource: NetworkEdgeSecurityService
    paths: str
    project: str
    region: str
    request_id: str
    update_mask: str
    def __init__(self, network_edge_security_service: _Optional[str] = ..., network_edge_security_service_resource: _Optional[_Union[NetworkEdgeSecurityService, _Mapping]] = ..., paths: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., update_mask: _Optional[str] = ...) -> None: ...

class PatchNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_resource", "project", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_resource: FirewallPolicy
    project: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_resource: _Optional[_Union[FirewallPolicy, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchNetworkRequest(_message.Message):
    __slots__ = ("network", "network_resource", "project", "request_id")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network: str
    network_resource: Network
    project: str
    request_id: str
    def __init__(self, network: _Optional[str] = ..., network_resource: _Optional[_Union[Network, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "node_group_resource", "project", "request_id", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    node_group_resource: NodeGroup
    project: str
    request_id: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., node_group_resource: _Optional[_Union[NodeGroup, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class PatchPacketMirroringRequest(_message.Message):
    __slots__ = ("packet_mirroring", "packet_mirroring_resource", "project", "region", "request_id")
    PACKET_MIRRORING_FIELD_NUMBER: _ClassVar[int]
    PACKET_MIRRORING_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    packet_mirroring: str
    packet_mirroring_resource: PacketMirroring
    project: str
    region: str
    request_id: str
    def __init__(self, packet_mirroring: _Optional[str] = ..., packet_mirroring_resource: _Optional[_Union[PacketMirroring, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchPerInstanceConfigsInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_patch_per_instance_configs_req_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_PATCH_PER_INSTANCE_CONFIGS_REQ_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_patch_per_instance_configs_req_resource: InstanceGroupManagersPatchPerInstanceConfigsReq
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_patch_per_instance_configs_req_resource: _Optional[_Union[InstanceGroupManagersPatchPerInstanceConfigsReq, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class PatchPerInstanceConfigsRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_manager_patch_instance_config_req_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGER_PATCH_INSTANCE_CONFIG_REQ_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_manager_patch_instance_config_req_resource: RegionInstanceGroupManagerPatchInstanceConfigReq
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_manager_patch_instance_config_req_resource: _Optional[_Union[RegionInstanceGroupManagerPatchInstanceConfigReq, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchPublicAdvertisedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_advertised_prefix", "public_advertised_prefix_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_ADVERTISED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_ADVERTISED_PREFIX_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_advertised_prefix: str
    public_advertised_prefix_resource: PublicAdvertisedPrefix
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_advertised_prefix: _Optional[str] = ..., public_advertised_prefix_resource: _Optional[_Union[PublicAdvertisedPrefix, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix", "public_delegated_prefix_resource", "region", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    public_delegated_prefix_resource: PublicDelegatedPrefix
    region: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ..., public_delegated_prefix_resource: _Optional[_Union[PublicDelegatedPrefix, _Mapping]] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRegionAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "autoscaler_resource", "project", "region", "request_id")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    AUTOSCALER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    autoscaler_resource: Autoscaler
    project: str
    region: str
    request_id: str
    def __init__(self, autoscaler: _Optional[str] = ..., autoscaler_resource: _Optional[_Union[Autoscaler, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRegionBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "backend_service_resource", "project", "region", "request_id")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    BACKEND_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    backend_service_resource: BackendService
    project: str
    region: str
    request_id: str
    def __init__(self, backend_service: _Optional[str] = ..., backend_service_resource: _Optional[_Union[BackendService, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRegionHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "health_check_resource", "project", "region", "request_id")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    health_check_resource: HealthCheck
    project: str
    region: str
    request_id: str
    def __init__(self, health_check: _Optional[str] = ..., health_check_resource: _Optional[_Union[HealthCheck, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRegionHealthCheckServiceRequest(_message.Message):
    __slots__ = ("health_check_service", "health_check_service_resource", "project", "region", "request_id")
    HEALTH_CHECK_SERVICE_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check_service: str
    health_check_service_resource: HealthCheckService
    project: str
    region: str
    request_id: str
    def __init__(self, health_check_service: _Optional[str] = ..., health_check_service_resource: _Optional[_Union[HealthCheckService, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_manager_resource", "project", "region", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_manager_resource: InstanceGroupManager
    project: str
    region: str
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_manager_resource: _Optional[_Union[InstanceGroupManager, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_resource", "project", "region", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_resource: FirewallPolicy
    project: str
    region: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_resource: _Optional[_Union[FirewallPolicy, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "security_policy", "security_policy_resource", "update_mask")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    security_policy: str
    security_policy_resource: SecurityPolicy
    update_mask: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy: _Optional[str] = ..., security_policy_resource: _Optional[_Union[SecurityPolicy, _Mapping]] = ..., update_mask: _Optional[str] = ...) -> None: ...

class PatchRegionSslPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "ssl_policy", "ssl_policy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    ssl_policy: str
    ssl_policy_resource: SslPolicy
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy: _Optional[str] = ..., ssl_policy_resource: _Optional[_Union[SslPolicy, _Mapping]] = ...) -> None: ...

class PatchRegionTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_https_proxy", "target_https_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_https_proxy: str
    target_https_proxy_resource: TargetHttpsProxy
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy: _Optional[str] = ..., target_https_proxy_resource: _Optional[_Union[TargetHttpsProxy, _Mapping]] = ...) -> None: ...

class PatchRegionUrlMapRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "url_map", "url_map_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    url_map: str
    url_map_resource: UrlMap
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map: _Optional[str] = ..., url_map_resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class PatchResourcePolicyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "resource_policy", "resource_policy_resource", "update_mask")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICY_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    resource_policy: str
    resource_policy_resource: ResourcePolicy
    update_mask: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., resource_policy: _Optional[str] = ..., resource_policy_resource: _Optional[_Union[ResourcePolicy, _Mapping]] = ..., update_mask: _Optional[str] = ...) -> None: ...

class PatchRouterRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "router", "router_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    ROUTER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    router: str
    router_resource: Router
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., router: _Optional[str] = ..., router_resource: _Optional[_Union[Router, _Mapping]] = ...) -> None: ...

class PatchRuleFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_rule_resource", "priority", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_rule_resource: FirewallPolicyRule
    priority: int
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_rule_resource: _Optional[_Union[FirewallPolicyRule, _Mapping]] = ..., priority: _Optional[int] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRuleNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_rule_resource", "priority", "project", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_rule_resource: FirewallPolicyRule
    priority: int
    project: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_rule_resource: _Optional[_Union[FirewallPolicyRule, _Mapping]] = ..., priority: _Optional[int] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRuleRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "firewall_policy_rule_resource", "priority", "project", "region", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    firewall_policy_rule_resource: FirewallPolicyRule
    priority: int
    project: str
    region: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., firewall_policy_rule_resource: _Optional[_Union[FirewallPolicyRule, _Mapping]] = ..., priority: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class PatchRuleRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("priority", "project", "region", "security_policy", "security_policy_rule_resource", "update_mask", "validate_only")
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    priority: int
    project: str
    region: str
    security_policy: str
    security_policy_rule_resource: SecurityPolicyRule
    update_mask: str
    validate_only: bool
    def __init__(self, priority: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ..., security_policy_rule_resource: _Optional[_Union[SecurityPolicyRule, _Mapping]] = ..., update_mask: _Optional[str] = ..., validate_only: bool = ...) -> None: ...

class PatchRuleSecurityPolicyRequest(_message.Message):
    __slots__ = ("priority", "project", "security_policy", "security_policy_rule_resource", "update_mask", "validate_only")
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RULE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    priority: int
    project: str
    security_policy: str
    security_policy_rule_resource: SecurityPolicyRule
    update_mask: str
    validate_only: bool
    def __init__(self, priority: _Optional[int] = ..., project: _Optional[str] = ..., security_policy: _Optional[str] = ..., security_policy_rule_resource: _Optional[_Union[SecurityPolicyRule, _Mapping]] = ..., update_mask: _Optional[str] = ..., validate_only: bool = ...) -> None: ...

class PatchSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "request_id", "security_policy", "security_policy_resource", "update_mask")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    security_policy: str
    security_policy_resource: SecurityPolicy
    update_mask: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy: _Optional[str] = ..., security_policy_resource: _Optional[_Union[SecurityPolicy, _Mapping]] = ..., update_mask: _Optional[str] = ...) -> None: ...

class PatchServiceAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "service_attachment", "service_attachment_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ATTACHMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    service_attachment: str
    service_attachment_resource: ServiceAttachment
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., service_attachment: _Optional[str] = ..., service_attachment_resource: _Optional[_Union[ServiceAttachment, _Mapping]] = ...) -> None: ...

class PatchSnapshotSettingRequest(_message.Message):
    __slots__ = ("project", "request_id", "snapshot_settings_resource", "update_mask")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_SETTINGS_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    snapshot_settings_resource: SnapshotSettings
    update_mask: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., snapshot_settings_resource: _Optional[_Union[SnapshotSettings, _Mapping]] = ..., update_mask: _Optional[str] = ...) -> None: ...

class PatchSslPolicyRequest(_message.Message):
    __slots__ = ("project", "request_id", "ssl_policy", "ssl_policy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    ssl_policy: str
    ssl_policy_resource: SslPolicy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy: _Optional[str] = ..., ssl_policy_resource: _Optional[_Union[SslPolicy, _Mapping]] = ...) -> None: ...

class PatchSubnetworkRequest(_message.Message):
    __slots__ = ("drain_timeout_seconds", "project", "region", "request_id", "subnetwork", "subnetwork_resource")
    DRAIN_TIMEOUT_SECONDS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    drain_timeout_seconds: int
    project: str
    region: str
    request_id: str
    subnetwork: str
    subnetwork_resource: Subnetwork
    def __init__(self, drain_timeout_seconds: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., subnetwork: _Optional[str] = ..., subnetwork_resource: _Optional[_Union[Subnetwork, _Mapping]] = ...) -> None: ...

class PatchTargetGrpcProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_grpc_proxy", "target_grpc_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_GRPC_PROXY_FIELD_NUMBER: _ClassVar[int]
    TARGET_GRPC_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_grpc_proxy: str
    target_grpc_proxy_resource: TargetGrpcProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_grpc_proxy: _Optional[str] = ..., target_grpc_proxy_resource: _Optional[_Union[TargetGrpcProxy, _Mapping]] = ...) -> None: ...

class PatchTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_http_proxy", "target_http_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_http_proxy: str
    target_http_proxy_resource: TargetHttpProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_http_proxy: _Optional[str] = ..., target_http_proxy_resource: _Optional[_Union[TargetHttpProxy, _Mapping]] = ...) -> None: ...

class PatchTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_https_proxy", "target_https_proxy_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_https_proxy: str
    target_https_proxy_resource: TargetHttpsProxy
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy: _Optional[str] = ..., target_https_proxy_resource: _Optional[_Union[TargetHttpsProxy, _Mapping]] = ...) -> None: ...

class PatchUrlMapRequest(_message.Message):
    __slots__ = ("project", "request_id", "url_map", "url_map_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    url_map: str
    url_map_resource: UrlMap
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map: _Optional[str] = ..., url_map_resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class PathMatcher(_message.Message):
    __slots__ = ("default_custom_error_response_policy", "default_route_action", "default_service", "default_url_redirect", "description", "header_action", "name", "path_rules", "route_rules")
    DEFAULT_CUSTOM_ERROR_RESPONSE_POLICY_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_ROUTE_ACTION_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_SERVICE_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_URL_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    HEADER_ACTION_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PATH_RULES_FIELD_NUMBER: _ClassVar[int]
    ROUTE_RULES_FIELD_NUMBER: _ClassVar[int]
    default_custom_error_response_policy: CustomErrorResponsePolicy
    default_route_action: HttpRouteAction
    default_service: str
    default_url_redirect: HttpRedirectAction
    description: str
    header_action: HttpHeaderAction
    name: str
    path_rules: _containers.RepeatedCompositeFieldContainer[PathRule]
    route_rules: _containers.RepeatedCompositeFieldContainer[HttpRouteRule]
    def __init__(self, default_custom_error_response_policy: _Optional[_Union[CustomErrorResponsePolicy, _Mapping]] = ..., default_route_action: _Optional[_Union[HttpRouteAction, _Mapping]] = ..., default_service: _Optional[str] = ..., default_url_redirect: _Optional[_Union[HttpRedirectAction, _Mapping]] = ..., description: _Optional[str] = ..., header_action: _Optional[_Union[HttpHeaderAction, _Mapping]] = ..., name: _Optional[str] = ..., path_rules: _Optional[_Iterable[_Union[PathRule, _Mapping]]] = ..., route_rules: _Optional[_Iterable[_Union[HttpRouteRule, _Mapping]]] = ...) -> None: ...

class PathRule(_message.Message):
    __slots__ = ("custom_error_response_policy", "paths", "route_action", "service", "url_redirect")
    CUSTOM_ERROR_RESPONSE_POLICY_FIELD_NUMBER: _ClassVar[int]
    PATHS_FIELD_NUMBER: _ClassVar[int]
    ROUTE_ACTION_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    URL_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    custom_error_response_policy: CustomErrorResponsePolicy
    paths: _containers.RepeatedScalarFieldContainer[str]
    route_action: HttpRouteAction
    service: str
    url_redirect: HttpRedirectAction
    def __init__(self, custom_error_response_policy: _Optional[_Union[CustomErrorResponsePolicy, _Mapping]] = ..., paths: _Optional[_Iterable[str]] = ..., route_action: _Optional[_Union[HttpRouteAction, _Mapping]] = ..., service: _Optional[str] = ..., url_redirect: _Optional[_Union[HttpRedirectAction, _Mapping]] = ...) -> None: ...

class PerInstanceConfig(_message.Message):
    __slots__ = ("fingerprint", "name", "preserved_state", "status")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[PerInstanceConfig.Status]
        APPLYING: _ClassVar[PerInstanceConfig.Status]
        DELETING: _ClassVar[PerInstanceConfig.Status]
        EFFECTIVE: _ClassVar[PerInstanceConfig.Status]
        NONE: _ClassVar[PerInstanceConfig.Status]
        UNAPPLIED: _ClassVar[PerInstanceConfig.Status]
        UNAPPLIED_DELETION: _ClassVar[PerInstanceConfig.Status]
    UNDEFINED_STATUS: PerInstanceConfig.Status
    APPLYING: PerInstanceConfig.Status
    DELETING: PerInstanceConfig.Status
    EFFECTIVE: PerInstanceConfig.Status
    NONE: PerInstanceConfig.Status
    UNAPPLIED: PerInstanceConfig.Status
    UNAPPLIED_DELETION: PerInstanceConfig.Status
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRESERVED_STATE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    name: str
    preserved_state: PreservedState
    status: str
    def __init__(self, fingerprint: _Optional[str] = ..., name: _Optional[str] = ..., preserved_state: _Optional[_Union[PreservedState, _Mapping]] = ..., status: _Optional[str] = ...) -> None: ...

class PerformMaintenanceInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class PerformMaintenanceNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "node_groups_perform_maintenance_request_resource", "project", "request_id", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUPS_PERFORM_MAINTENANCE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    node_groups_perform_maintenance_request_resource: NodeGroupsPerformMaintenanceRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., node_groups_perform_maintenance_request_resource: _Optional[_Union[NodeGroupsPerformMaintenanceRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class Policy(_message.Message):
    __slots__ = ("audit_configs", "bindings", "etag", "iam_owned", "version")
    AUDIT_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    BINDINGS_FIELD_NUMBER: _ClassVar[int]
    ETAG_FIELD_NUMBER: _ClassVar[int]
    IAM_OWNED_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    audit_configs: _containers.RepeatedCompositeFieldContainer[AuditConfig]
    bindings: _containers.RepeatedCompositeFieldContainer[Binding]
    etag: str
    iam_owned: bool
    version: int
    def __init__(self, audit_configs: _Optional[_Iterable[_Union[AuditConfig, _Mapping]]] = ..., bindings: _Optional[_Iterable[_Union[Binding, _Mapping]]] = ..., etag: _Optional[str] = ..., iam_owned: bool = ..., version: _Optional[int] = ...) -> None: ...

class PreconfiguredWafSet(_message.Message):
    __slots__ = ("expression_sets",)
    EXPRESSION_SETS_FIELD_NUMBER: _ClassVar[int]
    expression_sets: _containers.RepeatedCompositeFieldContainer[WafExpressionSet]
    def __init__(self, expression_sets: _Optional[_Iterable[_Union[WafExpressionSet, _Mapping]]] = ...) -> None: ...

class PreservedState(_message.Message):
    __slots__ = ("disks", "external_i_ps", "internal_i_ps", "metadata")
    class DisksEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: PreservedStatePreservedDisk
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[PreservedStatePreservedDisk, _Mapping]] = ...) -> None: ...
    class ExternalIPsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: PreservedStatePreservedNetworkIp
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[PreservedStatePreservedNetworkIp, _Mapping]] = ...) -> None: ...
    class InternalIPsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: PreservedStatePreservedNetworkIp
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[PreservedStatePreservedNetworkIp, _Mapping]] = ...) -> None: ...
    class MetadataEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DISKS_FIELD_NUMBER: _ClassVar[int]
    EXTERNAL_I_PS_FIELD_NUMBER: _ClassVar[int]
    INTERNAL_I_PS_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    disks: _containers.MessageMap[str, PreservedStatePreservedDisk]
    external_i_ps: _containers.MessageMap[str, PreservedStatePreservedNetworkIp]
    internal_i_ps: _containers.MessageMap[str, PreservedStatePreservedNetworkIp]
    metadata: _containers.ScalarMap[str, str]
    def __init__(self, disks: _Optional[_Mapping[str, PreservedStatePreservedDisk]] = ..., external_i_ps: _Optional[_Mapping[str, PreservedStatePreservedNetworkIp]] = ..., internal_i_ps: _Optional[_Mapping[str, PreservedStatePreservedNetworkIp]] = ..., metadata: _Optional[_Mapping[str, str]] = ...) -> None: ...

class PreservedStatePreservedDisk(_message.Message):
    __slots__ = ("auto_delete", "mode", "source")
    class AutoDelete(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AUTO_DELETE: _ClassVar[PreservedStatePreservedDisk.AutoDelete]
        NEVER: _ClassVar[PreservedStatePreservedDisk.AutoDelete]
        ON_PERMANENT_INSTANCE_DELETION: _ClassVar[PreservedStatePreservedDisk.AutoDelete]
    UNDEFINED_AUTO_DELETE: PreservedStatePreservedDisk.AutoDelete
    NEVER: PreservedStatePreservedDisk.AutoDelete
    ON_PERMANENT_INSTANCE_DELETION: PreservedStatePreservedDisk.AutoDelete
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[PreservedStatePreservedDisk.Mode]
        READ_ONLY: _ClassVar[PreservedStatePreservedDisk.Mode]
        READ_WRITE: _ClassVar[PreservedStatePreservedDisk.Mode]
    UNDEFINED_MODE: PreservedStatePreservedDisk.Mode
    READ_ONLY: PreservedStatePreservedDisk.Mode
    READ_WRITE: PreservedStatePreservedDisk.Mode
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    auto_delete: str
    mode: str
    source: str
    def __init__(self, auto_delete: _Optional[str] = ..., mode: _Optional[str] = ..., source: _Optional[str] = ...) -> None: ...

class PreservedStatePreservedNetworkIp(_message.Message):
    __slots__ = ("auto_delete", "ip_address")
    class AutoDelete(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AUTO_DELETE: _ClassVar[PreservedStatePreservedNetworkIp.AutoDelete]
        NEVER: _ClassVar[PreservedStatePreservedNetworkIp.AutoDelete]
        ON_PERMANENT_INSTANCE_DELETION: _ClassVar[PreservedStatePreservedNetworkIp.AutoDelete]
    UNDEFINED_AUTO_DELETE: PreservedStatePreservedNetworkIp.AutoDelete
    NEVER: PreservedStatePreservedNetworkIp.AutoDelete
    ON_PERMANENT_INSTANCE_DELETION: PreservedStatePreservedNetworkIp.AutoDelete
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    auto_delete: str
    ip_address: PreservedStatePreservedNetworkIpIpAddress
    def __init__(self, auto_delete: _Optional[str] = ..., ip_address: _Optional[_Union[PreservedStatePreservedNetworkIpIpAddress, _Mapping]] = ...) -> None: ...

class PreservedStatePreservedNetworkIpIpAddress(_message.Message):
    __slots__ = ("address", "literal")
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    LITERAL_FIELD_NUMBER: _ClassVar[int]
    address: str
    literal: str
    def __init__(self, address: _Optional[str] = ..., literal: _Optional[str] = ...) -> None: ...

class PreviewRouterRequest(_message.Message):
    __slots__ = ("project", "region", "router", "router_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    ROUTER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    router: str
    router_resource: Router
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., router: _Optional[str] = ..., router_resource: _Optional[_Union[Router, _Mapping]] = ...) -> None: ...

class Project(_message.Message):
    __slots__ = ("cloud_armor_tier", "common_instance_metadata", "creation_timestamp", "default_network_tier", "default_service_account", "description", "enabled_features", "id", "kind", "name", "quotas", "self_link", "usage_export_location", "vm_dns_setting", "xpn_project_status")
    class CloudArmorTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CLOUD_ARMOR_TIER: _ClassVar[Project.CloudArmorTier]
        CA_ENTERPRISE_ANNUAL: _ClassVar[Project.CloudArmorTier]
        CA_ENTERPRISE_PAYGO: _ClassVar[Project.CloudArmorTier]
        CA_STANDARD: _ClassVar[Project.CloudArmorTier]
    UNDEFINED_CLOUD_ARMOR_TIER: Project.CloudArmorTier
    CA_ENTERPRISE_ANNUAL: Project.CloudArmorTier
    CA_ENTERPRISE_PAYGO: Project.CloudArmorTier
    CA_STANDARD: Project.CloudArmorTier
    class DefaultNetworkTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DEFAULT_NETWORK_TIER: _ClassVar[Project.DefaultNetworkTier]
        FIXED_STANDARD: _ClassVar[Project.DefaultNetworkTier]
        PREMIUM: _ClassVar[Project.DefaultNetworkTier]
        STANDARD: _ClassVar[Project.DefaultNetworkTier]
        STANDARD_OVERRIDES_FIXED_STANDARD: _ClassVar[Project.DefaultNetworkTier]
    UNDEFINED_DEFAULT_NETWORK_TIER: Project.DefaultNetworkTier
    FIXED_STANDARD: Project.DefaultNetworkTier
    PREMIUM: Project.DefaultNetworkTier
    STANDARD: Project.DefaultNetworkTier
    STANDARD_OVERRIDES_FIXED_STANDARD: Project.DefaultNetworkTier
    class VmDnsSetting(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_VM_DNS_SETTING: _ClassVar[Project.VmDnsSetting]
        GLOBAL_DEFAULT: _ClassVar[Project.VmDnsSetting]
        UNSPECIFIED_VM_DNS_SETTING: _ClassVar[Project.VmDnsSetting]
        ZONAL_DEFAULT: _ClassVar[Project.VmDnsSetting]
        ZONAL_ONLY: _ClassVar[Project.VmDnsSetting]
    UNDEFINED_VM_DNS_SETTING: Project.VmDnsSetting
    GLOBAL_DEFAULT: Project.VmDnsSetting
    UNSPECIFIED_VM_DNS_SETTING: Project.VmDnsSetting
    ZONAL_DEFAULT: Project.VmDnsSetting
    ZONAL_ONLY: Project.VmDnsSetting
    class XpnProjectStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_XPN_PROJECT_STATUS: _ClassVar[Project.XpnProjectStatus]
        HOST: _ClassVar[Project.XpnProjectStatus]
        UNSPECIFIED_XPN_PROJECT_STATUS: _ClassVar[Project.XpnProjectStatus]
    UNDEFINED_XPN_PROJECT_STATUS: Project.XpnProjectStatus
    HOST: Project.XpnProjectStatus
    UNSPECIFIED_XPN_PROJECT_STATUS: Project.XpnProjectStatus
    CLOUD_ARMOR_TIER_FIELD_NUMBER: _ClassVar[int]
    COMMON_INSTANCE_METADATA_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_NETWORK_TIER_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ENABLED_FEATURES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    QUOTAS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    USAGE_EXPORT_LOCATION_FIELD_NUMBER: _ClassVar[int]
    VM_DNS_SETTING_FIELD_NUMBER: _ClassVar[int]
    XPN_PROJECT_STATUS_FIELD_NUMBER: _ClassVar[int]
    cloud_armor_tier: str
    common_instance_metadata: Metadata
    creation_timestamp: str
    default_network_tier: str
    default_service_account: str
    description: str
    enabled_features: _containers.RepeatedScalarFieldContainer[str]
    id: int
    kind: str
    name: str
    quotas: _containers.RepeatedCompositeFieldContainer[Quota]
    self_link: str
    usage_export_location: UsageExportLocation
    vm_dns_setting: str
    xpn_project_status: str
    def __init__(self, cloud_armor_tier: _Optional[str] = ..., common_instance_metadata: _Optional[_Union[Metadata, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., default_network_tier: _Optional[str] = ..., default_service_account: _Optional[str] = ..., description: _Optional[str] = ..., enabled_features: _Optional[_Iterable[str]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., quotas: _Optional[_Iterable[_Union[Quota, _Mapping]]] = ..., self_link: _Optional[str] = ..., usage_export_location: _Optional[_Union[UsageExportLocation, _Mapping]] = ..., vm_dns_setting: _Optional[str] = ..., xpn_project_status: _Optional[str] = ...) -> None: ...

class ProjectsDisableXpnResourceRequest(_message.Message):
    __slots__ = ("xpn_resource",)
    XPN_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    xpn_resource: XpnResourceId
    def __init__(self, xpn_resource: _Optional[_Union[XpnResourceId, _Mapping]] = ...) -> None: ...

class ProjectsEnableXpnResourceRequest(_message.Message):
    __slots__ = ("xpn_resource",)
    XPN_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    xpn_resource: XpnResourceId
    def __init__(self, xpn_resource: _Optional[_Union[XpnResourceId, _Mapping]] = ...) -> None: ...

class ProjectsGetXpnResources(_message.Message):
    __slots__ = ("kind", "next_page_token", "resources")
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    RESOURCES_FIELD_NUMBER: _ClassVar[int]
    kind: str
    next_page_token: str
    resources: _containers.RepeatedCompositeFieldContainer[XpnResourceId]
    def __init__(self, kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., resources: _Optional[_Iterable[_Union[XpnResourceId, _Mapping]]] = ...) -> None: ...

class ProjectsListXpnHostsRequest(_message.Message):
    __slots__ = ("organization",)
    ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
    organization: str
    def __init__(self, organization: _Optional[str] = ...) -> None: ...

class ProjectsSetCloudArmorTierRequest(_message.Message):
    __slots__ = ("cloud_armor_tier",)
    class CloudArmorTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CLOUD_ARMOR_TIER: _ClassVar[ProjectsSetCloudArmorTierRequest.CloudArmorTier]
        CA_ENTERPRISE_ANNUAL: _ClassVar[ProjectsSetCloudArmorTierRequest.CloudArmorTier]
        CA_ENTERPRISE_PAYGO: _ClassVar[ProjectsSetCloudArmorTierRequest.CloudArmorTier]
        CA_STANDARD: _ClassVar[ProjectsSetCloudArmorTierRequest.CloudArmorTier]
    UNDEFINED_CLOUD_ARMOR_TIER: ProjectsSetCloudArmorTierRequest.CloudArmorTier
    CA_ENTERPRISE_ANNUAL: ProjectsSetCloudArmorTierRequest.CloudArmorTier
    CA_ENTERPRISE_PAYGO: ProjectsSetCloudArmorTierRequest.CloudArmorTier
    CA_STANDARD: ProjectsSetCloudArmorTierRequest.CloudArmorTier
    CLOUD_ARMOR_TIER_FIELD_NUMBER: _ClassVar[int]
    cloud_armor_tier: str
    def __init__(self, cloud_armor_tier: _Optional[str] = ...) -> None: ...

class ProjectsSetDefaultNetworkTierRequest(_message.Message):
    __slots__ = ("network_tier",)
    class NetworkTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NETWORK_TIER: _ClassVar[ProjectsSetDefaultNetworkTierRequest.NetworkTier]
        FIXED_STANDARD: _ClassVar[ProjectsSetDefaultNetworkTierRequest.NetworkTier]
        PREMIUM: _ClassVar[ProjectsSetDefaultNetworkTierRequest.NetworkTier]
        STANDARD: _ClassVar[ProjectsSetDefaultNetworkTierRequest.NetworkTier]
        STANDARD_OVERRIDES_FIXED_STANDARD: _ClassVar[ProjectsSetDefaultNetworkTierRequest.NetworkTier]
    UNDEFINED_NETWORK_TIER: ProjectsSetDefaultNetworkTierRequest.NetworkTier
    FIXED_STANDARD: ProjectsSetDefaultNetworkTierRequest.NetworkTier
    PREMIUM: ProjectsSetDefaultNetworkTierRequest.NetworkTier
    STANDARD: ProjectsSetDefaultNetworkTierRequest.NetworkTier
    STANDARD_OVERRIDES_FIXED_STANDARD: ProjectsSetDefaultNetworkTierRequest.NetworkTier
    NETWORK_TIER_FIELD_NUMBER: _ClassVar[int]
    network_tier: str
    def __init__(self, network_tier: _Optional[str] = ...) -> None: ...

class PublicAdvertisedPrefix(_message.Message):
    __slots__ = ("byoip_api_version", "creation_timestamp", "description", "dns_verification_ip", "fingerprint", "id", "ip_cidr_range", "kind", "name", "pdp_scope", "public_delegated_prefixs", "self_link", "shared_secret", "status")
    class ByoipApiVersion(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BYOIP_API_VERSION: _ClassVar[PublicAdvertisedPrefix.ByoipApiVersion]
        V1: _ClassVar[PublicAdvertisedPrefix.ByoipApiVersion]
        V2: _ClassVar[PublicAdvertisedPrefix.ByoipApiVersion]
    UNDEFINED_BYOIP_API_VERSION: PublicAdvertisedPrefix.ByoipApiVersion
    V1: PublicAdvertisedPrefix.ByoipApiVersion
    V2: PublicAdvertisedPrefix.ByoipApiVersion
    class PdpScope(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PDP_SCOPE: _ClassVar[PublicAdvertisedPrefix.PdpScope]
        GLOBAL: _ClassVar[PublicAdvertisedPrefix.PdpScope]
        GLOBAL_AND_REGIONAL: _ClassVar[PublicAdvertisedPrefix.PdpScope]
        REGIONAL: _ClassVar[PublicAdvertisedPrefix.PdpScope]
    UNDEFINED_PDP_SCOPE: PublicAdvertisedPrefix.PdpScope
    GLOBAL: PublicAdvertisedPrefix.PdpScope
    GLOBAL_AND_REGIONAL: PublicAdvertisedPrefix.PdpScope
    REGIONAL: PublicAdvertisedPrefix.PdpScope
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[PublicAdvertisedPrefix.Status]
        ANNOUNCED_TO_INTERNET: _ClassVar[PublicAdvertisedPrefix.Status]
        INITIAL: _ClassVar[PublicAdvertisedPrefix.Status]
        PREFIX_CONFIGURATION_COMPLETE: _ClassVar[PublicAdvertisedPrefix.Status]
        PREFIX_CONFIGURATION_IN_PROGRESS: _ClassVar[PublicAdvertisedPrefix.Status]
        PREFIX_REMOVAL_IN_PROGRESS: _ClassVar[PublicAdvertisedPrefix.Status]
        PTR_CONFIGURED: _ClassVar[PublicAdvertisedPrefix.Status]
        READY_TO_ANNOUNCE: _ClassVar[PublicAdvertisedPrefix.Status]
        REVERSE_DNS_LOOKUP_FAILED: _ClassVar[PublicAdvertisedPrefix.Status]
        VALIDATED: _ClassVar[PublicAdvertisedPrefix.Status]
    UNDEFINED_STATUS: PublicAdvertisedPrefix.Status
    ANNOUNCED_TO_INTERNET: PublicAdvertisedPrefix.Status
    INITIAL: PublicAdvertisedPrefix.Status
    PREFIX_CONFIGURATION_COMPLETE: PublicAdvertisedPrefix.Status
    PREFIX_CONFIGURATION_IN_PROGRESS: PublicAdvertisedPrefix.Status
    PREFIX_REMOVAL_IN_PROGRESS: PublicAdvertisedPrefix.Status
    PTR_CONFIGURED: PublicAdvertisedPrefix.Status
    READY_TO_ANNOUNCE: PublicAdvertisedPrefix.Status
    REVERSE_DNS_LOOKUP_FAILED: PublicAdvertisedPrefix.Status
    VALIDATED: PublicAdvertisedPrefix.Status
    BYOIP_API_VERSION_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DNS_VERIFICATION_IP_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PDP_SCOPE_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIXS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SHARED_SECRET_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    byoip_api_version: str
    creation_timestamp: str
    description: str
    dns_verification_ip: str
    fingerprint: str
    id: int
    ip_cidr_range: str
    kind: str
    name: str
    pdp_scope: str
    public_delegated_prefixs: _containers.RepeatedCompositeFieldContainer[PublicAdvertisedPrefixPublicDelegatedPrefix]
    self_link: str
    shared_secret: str
    status: str
    def __init__(self, byoip_api_version: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., dns_verification_ip: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., ip_cidr_range: _Optional[str] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., pdp_scope: _Optional[str] = ..., public_delegated_prefixs: _Optional[_Iterable[_Union[PublicAdvertisedPrefixPublicDelegatedPrefix, _Mapping]]] = ..., self_link: _Optional[str] = ..., shared_secret: _Optional[str] = ..., status: _Optional[str] = ...) -> None: ...

class PublicAdvertisedPrefixList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[PublicAdvertisedPrefix]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[PublicAdvertisedPrefix, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class PublicAdvertisedPrefixPublicDelegatedPrefix(_message.Message):
    __slots__ = ("ip_range", "name", "project", "region", "status")
    IP_RANGE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    ip_range: str
    name: str
    project: str
    region: str
    status: str
    def __init__(self, ip_range: _Optional[str] = ..., name: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., status: _Optional[str] = ...) -> None: ...

class PublicDelegatedPrefix(_message.Message):
    __slots__ = ("allocatable_prefix_length", "byoip_api_version", "creation_timestamp", "description", "fingerprint", "id", "ip_cidr_range", "is_live_migration", "kind", "mode", "name", "parent_prefix", "public_delegated_sub_prefixs", "region", "self_link", "status")
    class ByoipApiVersion(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BYOIP_API_VERSION: _ClassVar[PublicDelegatedPrefix.ByoipApiVersion]
        V1: _ClassVar[PublicDelegatedPrefix.ByoipApiVersion]
        V2: _ClassVar[PublicDelegatedPrefix.ByoipApiVersion]
    UNDEFINED_BYOIP_API_VERSION: PublicDelegatedPrefix.ByoipApiVersion
    V1: PublicDelegatedPrefix.ByoipApiVersion
    V2: PublicDelegatedPrefix.ByoipApiVersion
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[PublicDelegatedPrefix.Mode]
        DELEGATION: _ClassVar[PublicDelegatedPrefix.Mode]
        EXTERNAL_IPV6_FORWARDING_RULE_CREATION: _ClassVar[PublicDelegatedPrefix.Mode]
    UNDEFINED_MODE: PublicDelegatedPrefix.Mode
    DELEGATION: PublicDelegatedPrefix.Mode
    EXTERNAL_IPV6_FORWARDING_RULE_CREATION: PublicDelegatedPrefix.Mode
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[PublicDelegatedPrefix.Status]
        ANNOUNCED: _ClassVar[PublicDelegatedPrefix.Status]
        ANNOUNCED_TO_GOOGLE: _ClassVar[PublicDelegatedPrefix.Status]
        ANNOUNCED_TO_INTERNET: _ClassVar[PublicDelegatedPrefix.Status]
        DELETING: _ClassVar[PublicDelegatedPrefix.Status]
        INITIALIZING: _ClassVar[PublicDelegatedPrefix.Status]
        READY_TO_ANNOUNCE: _ClassVar[PublicDelegatedPrefix.Status]
    UNDEFINED_STATUS: PublicDelegatedPrefix.Status
    ANNOUNCED: PublicDelegatedPrefix.Status
    ANNOUNCED_TO_GOOGLE: PublicDelegatedPrefix.Status
    ANNOUNCED_TO_INTERNET: PublicDelegatedPrefix.Status
    DELETING: PublicDelegatedPrefix.Status
    INITIALIZING: PublicDelegatedPrefix.Status
    READY_TO_ANNOUNCE: PublicDelegatedPrefix.Status
    ALLOCATABLE_PREFIX_LENGTH_FIELD_NUMBER: _ClassVar[int]
    BYOIP_API_VERSION_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    IS_LIVE_MIGRATION_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PARENT_PREFIX_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_SUB_PREFIXS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    allocatable_prefix_length: int
    byoip_api_version: str
    creation_timestamp: str
    description: str
    fingerprint: str
    id: int
    ip_cidr_range: str
    is_live_migration: bool
    kind: str
    mode: str
    name: str
    parent_prefix: str
    public_delegated_sub_prefixs: _containers.RepeatedCompositeFieldContainer[PublicDelegatedPrefixPublicDelegatedSubPrefix]
    region: str
    self_link: str
    status: str
    def __init__(self, allocatable_prefix_length: _Optional[int] = ..., byoip_api_version: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., ip_cidr_range: _Optional[str] = ..., is_live_migration: bool = ..., kind: _Optional[str] = ..., mode: _Optional[str] = ..., name: _Optional[str] = ..., parent_prefix: _Optional[str] = ..., public_delegated_sub_prefixs: _Optional[_Iterable[_Union[PublicDelegatedPrefixPublicDelegatedSubPrefix, _Mapping]]] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ...) -> None: ...

class PublicDelegatedPrefixAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: PublicDelegatedPrefixesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[PublicDelegatedPrefixesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, PublicDelegatedPrefixesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, PublicDelegatedPrefixesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class PublicDelegatedPrefixList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[PublicDelegatedPrefix]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[PublicDelegatedPrefix, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class PublicDelegatedPrefixPublicDelegatedSubPrefix(_message.Message):
    __slots__ = ("allocatable_prefix_length", "delegatee_project", "description", "ip_cidr_range", "is_address", "mode", "name", "region", "status")
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[PublicDelegatedPrefixPublicDelegatedSubPrefix.Mode]
        DELEGATION: _ClassVar[PublicDelegatedPrefixPublicDelegatedSubPrefix.Mode]
        EXTERNAL_IPV6_FORWARDING_RULE_CREATION: _ClassVar[PublicDelegatedPrefixPublicDelegatedSubPrefix.Mode]
    UNDEFINED_MODE: PublicDelegatedPrefixPublicDelegatedSubPrefix.Mode
    DELEGATION: PublicDelegatedPrefixPublicDelegatedSubPrefix.Mode
    EXTERNAL_IPV6_FORWARDING_RULE_CREATION: PublicDelegatedPrefixPublicDelegatedSubPrefix.Mode
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[PublicDelegatedPrefixPublicDelegatedSubPrefix.Status]
        ACTIVE: _ClassVar[PublicDelegatedPrefixPublicDelegatedSubPrefix.Status]
        INACTIVE: _ClassVar[PublicDelegatedPrefixPublicDelegatedSubPrefix.Status]
    UNDEFINED_STATUS: PublicDelegatedPrefixPublicDelegatedSubPrefix.Status
    ACTIVE: PublicDelegatedPrefixPublicDelegatedSubPrefix.Status
    INACTIVE: PublicDelegatedPrefixPublicDelegatedSubPrefix.Status
    ALLOCATABLE_PREFIX_LENGTH_FIELD_NUMBER: _ClassVar[int]
    DELEGATEE_PROJECT_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    IS_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    allocatable_prefix_length: int
    delegatee_project: str
    description: str
    ip_cidr_range: str
    is_address: bool
    mode: str
    name: str
    region: str
    status: str
    def __init__(self, allocatable_prefix_length: _Optional[int] = ..., delegatee_project: _Optional[str] = ..., description: _Optional[str] = ..., ip_cidr_range: _Optional[str] = ..., is_address: bool = ..., mode: _Optional[str] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., status: _Optional[str] = ...) -> None: ...

class PublicDelegatedPrefixesScopedList(_message.Message):
    __slots__ = ("public_delegated_prefixes", "warning")
    PUBLIC_DELEGATED_PREFIXES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    public_delegated_prefixes: _containers.RepeatedCompositeFieldContainer[PublicDelegatedPrefix]
    warning: Warning
    def __init__(self, public_delegated_prefixes: _Optional[_Iterable[_Union[PublicDelegatedPrefix, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class Quota(_message.Message):
    __slots__ = ("limit", "metric", "owner", "usage")
    class Metric(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_METRIC: _ClassVar[Quota.Metric]
        A2_CPUS: _ClassVar[Quota.Metric]
        AFFINITY_GROUPS: _ClassVar[Quota.Metric]
        AUTOSCALERS: _ClassVar[Quota.Metric]
        BACKEND_BUCKETS: _ClassVar[Quota.Metric]
        BACKEND_SERVICES: _ClassVar[Quota.Metric]
        C2D_CPUS: _ClassVar[Quota.Metric]
        C2_CPUS: _ClassVar[Quota.Metric]
        C3_CPUS: _ClassVar[Quota.Metric]
        COMMITMENTS: _ClassVar[Quota.Metric]
        COMMITTED_A2_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_C2D_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_C2_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_C3_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_E2_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_LICENSES: _ClassVar[Quota.Metric]
        COMMITTED_LOCAL_SSD_TOTAL_GB: _ClassVar[Quota.Metric]
        COMMITTED_M3_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_MEMORY_OPTIMIZED_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_N2A_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_N2D_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_N2_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_A100_80GB_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_A100_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_H100_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_K80_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_L4_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_P100_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_P4_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_T4_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_NVIDIA_V100_GPUS: _ClassVar[Quota.Metric]
        COMMITTED_T2A_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_T2D_CPUS: _ClassVar[Quota.Metric]
        COMMITTED_Z3_CPUS: _ClassVar[Quota.Metric]
        CPUS: _ClassVar[Quota.Metric]
        CPUS_ALL_REGIONS: _ClassVar[Quota.Metric]
        DISKS_TOTAL_GB: _ClassVar[Quota.Metric]
        E2_CPUS: _ClassVar[Quota.Metric]
        EXTERNAL_MANAGED_FORWARDING_RULES: _ClassVar[Quota.Metric]
        EXTERNAL_NETWORK_LB_FORWARDING_RULES: _ClassVar[Quota.Metric]
        EXTERNAL_PROTOCOL_FORWARDING_RULES: _ClassVar[Quota.Metric]
        EXTERNAL_VPN_GATEWAYS: _ClassVar[Quota.Metric]
        FIREWALLS: _ClassVar[Quota.Metric]
        FORWARDING_RULES: _ClassVar[Quota.Metric]
        GLOBAL_EXTERNAL_MANAGED_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        GLOBAL_EXTERNAL_MANAGED_FORWARDING_RULES: _ClassVar[Quota.Metric]
        GLOBAL_EXTERNAL_PROXY_LB_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        GLOBAL_INTERNAL_ADDRESSES: _ClassVar[Quota.Metric]
        GLOBAL_INTERNAL_MANAGED_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        GLOBAL_INTERNAL_TRAFFIC_DIRECTOR_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        GPUS_ALL_REGIONS: _ClassVar[Quota.Metric]
        HDB_TOTAL_GB: _ClassVar[Quota.Metric]
        HDB_TOTAL_IOPS: _ClassVar[Quota.Metric]
        HDB_TOTAL_THROUGHPUT: _ClassVar[Quota.Metric]
        HEALTH_CHECKS: _ClassVar[Quota.Metric]
        IMAGES: _ClassVar[Quota.Metric]
        INSTANCES: _ClassVar[Quota.Metric]
        INSTANCE_GROUPS: _ClassVar[Quota.Metric]
        INSTANCE_GROUP_MANAGERS: _ClassVar[Quota.Metric]
        INSTANCE_TEMPLATES: _ClassVar[Quota.Metric]
        INTERCONNECTS: _ClassVar[Quota.Metric]
        INTERCONNECT_ATTACHMENTS_PER_REGION: _ClassVar[Quota.Metric]
        INTERCONNECT_ATTACHMENTS_TOTAL_MBPS: _ClassVar[Quota.Metric]
        INTERCONNECT_TOTAL_GBPS: _ClassVar[Quota.Metric]
        INTERNAL_ADDRESSES: _ClassVar[Quota.Metric]
        INTERNAL_TRAFFIC_DIRECTOR_FORWARDING_RULES: _ClassVar[Quota.Metric]
        IN_PLACE_SNAPSHOTS: _ClassVar[Quota.Metric]
        IN_USE_ADDRESSES: _ClassVar[Quota.Metric]
        IN_USE_BACKUP_SCHEDULES: _ClassVar[Quota.Metric]
        IN_USE_SNAPSHOT_SCHEDULES: _ClassVar[Quota.Metric]
        LOCAL_SSD_TOTAL_GB: _ClassVar[Quota.Metric]
        M1_CPUS: _ClassVar[Quota.Metric]
        M2_CPUS: _ClassVar[Quota.Metric]
        M3_CPUS: _ClassVar[Quota.Metric]
        MACHINE_IMAGES: _ClassVar[Quota.Metric]
        N2A_CPUS: _ClassVar[Quota.Metric]
        N2D_CPUS: _ClassVar[Quota.Metric]
        N2_CPUS: _ClassVar[Quota.Metric]
        NETWORKS: _ClassVar[Quota.Metric]
        NETWORK_ATTACHMENTS: _ClassVar[Quota.Metric]
        NETWORK_ENDPOINT_GROUPS: _ClassVar[Quota.Metric]
        NETWORK_FIREWALL_POLICIES: _ClassVar[Quota.Metric]
        NET_LB_SECURITY_POLICIES_PER_REGION: _ClassVar[Quota.Metric]
        NET_LB_SECURITY_POLICY_RULES_PER_REGION: _ClassVar[Quota.Metric]
        NET_LB_SECURITY_POLICY_RULE_ATTRIBUTES_PER_REGION: _ClassVar[Quota.Metric]
        NODE_GROUPS: _ClassVar[Quota.Metric]
        NODE_TEMPLATES: _ClassVar[Quota.Metric]
        NVIDIA_A100_80GB_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_A100_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_K80_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_L4_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_P100_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_P100_VWS_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_P4_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_P4_VWS_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_T4_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_T4_VWS_GPUS: _ClassVar[Quota.Metric]
        NVIDIA_V100_GPUS: _ClassVar[Quota.Metric]
        PACKET_MIRRORINGS: _ClassVar[Quota.Metric]
        PD_EXTREME_TOTAL_PROVISIONED_IOPS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_CPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_LOCAL_SSD_GB: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_A100_80GB_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_A100_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_H100_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_K80_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_L4_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_P100_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_P100_VWS_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_P4_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_P4_VWS_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_T4_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_T4_VWS_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_NVIDIA_V100_GPUS: _ClassVar[Quota.Metric]
        PREEMPTIBLE_TPU_LITE_DEVICE_V5: _ClassVar[Quota.Metric]
        PREEMPTIBLE_TPU_LITE_PODSLICE_V5: _ClassVar[Quota.Metric]
        PREEMPTIBLE_TPU_PODSLICE_V4: _ClassVar[Quota.Metric]
        PSC_ILB_CONSUMER_FORWARDING_RULES_PER_PRODUCER_NETWORK: _ClassVar[Quota.Metric]
        PSC_INTERNAL_LB_FORWARDING_RULES: _ClassVar[Quota.Metric]
        PUBLIC_ADVERTISED_PREFIXES: _ClassVar[Quota.Metric]
        PUBLIC_DELEGATED_PREFIXES: _ClassVar[Quota.Metric]
        REGIONAL_AUTOSCALERS: _ClassVar[Quota.Metric]
        REGIONAL_EXTERNAL_MANAGED_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        REGIONAL_EXTERNAL_NETWORK_LB_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        REGIONAL_INSTANCE_GROUP_MANAGERS: _ClassVar[Quota.Metric]
        REGIONAL_INTERNAL_LB_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        REGIONAL_INTERNAL_MANAGED_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        REGIONAL_INTERNAL_TRAFFIC_DIRECTOR_BACKEND_SERVICES: _ClassVar[Quota.Metric]
        RESERVATIONS: _ClassVar[Quota.Metric]
        RESOURCE_POLICIES: _ClassVar[Quota.Metric]
        ROUTERS: _ClassVar[Quota.Metric]
        ROUTES: _ClassVar[Quota.Metric]
        SECURITY_POLICIES: _ClassVar[Quota.Metric]
        SECURITY_POLICIES_PER_REGION: _ClassVar[Quota.Metric]
        SECURITY_POLICY_ADVANCED_RULES_PER_REGION: _ClassVar[Quota.Metric]
        SECURITY_POLICY_CEVAL_RULES: _ClassVar[Quota.Metric]
        SECURITY_POLICY_RULES: _ClassVar[Quota.Metric]
        SECURITY_POLICY_RULES_PER_REGION: _ClassVar[Quota.Metric]
        SERVICE_ATTACHMENTS: _ClassVar[Quota.Metric]
        SNAPSHOTS: _ClassVar[Quota.Metric]
        SSD_TOTAL_GB: _ClassVar[Quota.Metric]
        SSL_CERTIFICATES: _ClassVar[Quota.Metric]
        SSL_POLICIES: _ClassVar[Quota.Metric]
        STATIC_ADDRESSES: _ClassVar[Quota.Metric]
        STATIC_BYOIP_ADDRESSES: _ClassVar[Quota.Metric]
        STATIC_EXTERNAL_IPV6_ADDRESS_RANGES: _ClassVar[Quota.Metric]
        SUBNETWORKS: _ClassVar[Quota.Metric]
        T2A_CPUS: _ClassVar[Quota.Metric]
        T2D_CPUS: _ClassVar[Quota.Metric]
        TARGET_HTTPS_PROXIES: _ClassVar[Quota.Metric]
        TARGET_HTTP_PROXIES: _ClassVar[Quota.Metric]
        TARGET_INSTANCES: _ClassVar[Quota.Metric]
        TARGET_POOLS: _ClassVar[Quota.Metric]
        TARGET_SSL_PROXIES: _ClassVar[Quota.Metric]
        TARGET_TCP_PROXIES: _ClassVar[Quota.Metric]
        TARGET_VPN_GATEWAYS: _ClassVar[Quota.Metric]
        TPU_LITE_DEVICE_V5: _ClassVar[Quota.Metric]
        TPU_LITE_PODSLICE_V5: _ClassVar[Quota.Metric]
        TPU_PODSLICE_V4: _ClassVar[Quota.Metric]
        URL_MAPS: _ClassVar[Quota.Metric]
        VARIABLE_IPV6_PUBLIC_DELEGATED_PREFIXES: _ClassVar[Quota.Metric]
        VPN_GATEWAYS: _ClassVar[Quota.Metric]
        VPN_TUNNELS: _ClassVar[Quota.Metric]
        XPN_SERVICE_PROJECTS: _ClassVar[Quota.Metric]
    UNDEFINED_METRIC: Quota.Metric
    A2_CPUS: Quota.Metric
    AFFINITY_GROUPS: Quota.Metric
    AUTOSCALERS: Quota.Metric
    BACKEND_BUCKETS: Quota.Metric
    BACKEND_SERVICES: Quota.Metric
    C2D_CPUS: Quota.Metric
    C2_CPUS: Quota.Metric
    C3_CPUS: Quota.Metric
    COMMITMENTS: Quota.Metric
    COMMITTED_A2_CPUS: Quota.Metric
    COMMITTED_C2D_CPUS: Quota.Metric
    COMMITTED_C2_CPUS: Quota.Metric
    COMMITTED_C3_CPUS: Quota.Metric
    COMMITTED_CPUS: Quota.Metric
    COMMITTED_E2_CPUS: Quota.Metric
    COMMITTED_LICENSES: Quota.Metric
    COMMITTED_LOCAL_SSD_TOTAL_GB: Quota.Metric
    COMMITTED_M3_CPUS: Quota.Metric
    COMMITTED_MEMORY_OPTIMIZED_CPUS: Quota.Metric
    COMMITTED_N2A_CPUS: Quota.Metric
    COMMITTED_N2D_CPUS: Quota.Metric
    COMMITTED_N2_CPUS: Quota.Metric
    COMMITTED_NVIDIA_A100_80GB_GPUS: Quota.Metric
    COMMITTED_NVIDIA_A100_GPUS: Quota.Metric
    COMMITTED_NVIDIA_H100_GPUS: Quota.Metric
    COMMITTED_NVIDIA_K80_GPUS: Quota.Metric
    COMMITTED_NVIDIA_L4_GPUS: Quota.Metric
    COMMITTED_NVIDIA_P100_GPUS: Quota.Metric
    COMMITTED_NVIDIA_P4_GPUS: Quota.Metric
    COMMITTED_NVIDIA_T4_GPUS: Quota.Metric
    COMMITTED_NVIDIA_V100_GPUS: Quota.Metric
    COMMITTED_T2A_CPUS: Quota.Metric
    COMMITTED_T2D_CPUS: Quota.Metric
    COMMITTED_Z3_CPUS: Quota.Metric
    CPUS: Quota.Metric
    CPUS_ALL_REGIONS: Quota.Metric
    DISKS_TOTAL_GB: Quota.Metric
    E2_CPUS: Quota.Metric
    EXTERNAL_MANAGED_FORWARDING_RULES: Quota.Metric
    EXTERNAL_NETWORK_LB_FORWARDING_RULES: Quota.Metric
    EXTERNAL_PROTOCOL_FORWARDING_RULES: Quota.Metric
    EXTERNAL_VPN_GATEWAYS: Quota.Metric
    FIREWALLS: Quota.Metric
    FORWARDING_RULES: Quota.Metric
    GLOBAL_EXTERNAL_MANAGED_BACKEND_SERVICES: Quota.Metric
    GLOBAL_EXTERNAL_MANAGED_FORWARDING_RULES: Quota.Metric
    GLOBAL_EXTERNAL_PROXY_LB_BACKEND_SERVICES: Quota.Metric
    GLOBAL_INTERNAL_ADDRESSES: Quota.Metric
    GLOBAL_INTERNAL_MANAGED_BACKEND_SERVICES: Quota.Metric
    GLOBAL_INTERNAL_TRAFFIC_DIRECTOR_BACKEND_SERVICES: Quota.Metric
    GPUS_ALL_REGIONS: Quota.Metric
    HDB_TOTAL_GB: Quota.Metric
    HDB_TOTAL_IOPS: Quota.Metric
    HDB_TOTAL_THROUGHPUT: Quota.Metric
    HEALTH_CHECKS: Quota.Metric
    IMAGES: Quota.Metric
    INSTANCES: Quota.Metric
    INSTANCE_GROUPS: Quota.Metric
    INSTANCE_GROUP_MANAGERS: Quota.Metric
    INSTANCE_TEMPLATES: Quota.Metric
    INTERCONNECTS: Quota.Metric
    INTERCONNECT_ATTACHMENTS_PER_REGION: Quota.Metric
    INTERCONNECT_ATTACHMENTS_TOTAL_MBPS: Quota.Metric
    INTERCONNECT_TOTAL_GBPS: Quota.Metric
    INTERNAL_ADDRESSES: Quota.Metric
    INTERNAL_TRAFFIC_DIRECTOR_FORWARDING_RULES: Quota.Metric
    IN_PLACE_SNAPSHOTS: Quota.Metric
    IN_USE_ADDRESSES: Quota.Metric
    IN_USE_BACKUP_SCHEDULES: Quota.Metric
    IN_USE_SNAPSHOT_SCHEDULES: Quota.Metric
    LOCAL_SSD_TOTAL_GB: Quota.Metric
    M1_CPUS: Quota.Metric
    M2_CPUS: Quota.Metric
    M3_CPUS: Quota.Metric
    MACHINE_IMAGES: Quota.Metric
    N2A_CPUS: Quota.Metric
    N2D_CPUS: Quota.Metric
    N2_CPUS: Quota.Metric
    NETWORKS: Quota.Metric
    NETWORK_ATTACHMENTS: Quota.Metric
    NETWORK_ENDPOINT_GROUPS: Quota.Metric
    NETWORK_FIREWALL_POLICIES: Quota.Metric
    NET_LB_SECURITY_POLICIES_PER_REGION: Quota.Metric
    NET_LB_SECURITY_POLICY_RULES_PER_REGION: Quota.Metric
    NET_LB_SECURITY_POLICY_RULE_ATTRIBUTES_PER_REGION: Quota.Metric
    NODE_GROUPS: Quota.Metric
    NODE_TEMPLATES: Quota.Metric
    NVIDIA_A100_80GB_GPUS: Quota.Metric
    NVIDIA_A100_GPUS: Quota.Metric
    NVIDIA_K80_GPUS: Quota.Metric
    NVIDIA_L4_GPUS: Quota.Metric
    NVIDIA_P100_GPUS: Quota.Metric
    NVIDIA_P100_VWS_GPUS: Quota.Metric
    NVIDIA_P4_GPUS: Quota.Metric
    NVIDIA_P4_VWS_GPUS: Quota.Metric
    NVIDIA_T4_GPUS: Quota.Metric
    NVIDIA_T4_VWS_GPUS: Quota.Metric
    NVIDIA_V100_GPUS: Quota.Metric
    PACKET_MIRRORINGS: Quota.Metric
    PD_EXTREME_TOTAL_PROVISIONED_IOPS: Quota.Metric
    PREEMPTIBLE_CPUS: Quota.Metric
    PREEMPTIBLE_LOCAL_SSD_GB: Quota.Metric
    PREEMPTIBLE_NVIDIA_A100_80GB_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_A100_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_H100_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_K80_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_L4_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_P100_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_P100_VWS_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_P4_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_P4_VWS_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_T4_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_T4_VWS_GPUS: Quota.Metric
    PREEMPTIBLE_NVIDIA_V100_GPUS: Quota.Metric
    PREEMPTIBLE_TPU_LITE_DEVICE_V5: Quota.Metric
    PREEMPTIBLE_TPU_LITE_PODSLICE_V5: Quota.Metric
    PREEMPTIBLE_TPU_PODSLICE_V4: Quota.Metric
    PSC_ILB_CONSUMER_FORWARDING_RULES_PER_PRODUCER_NETWORK: Quota.Metric
    PSC_INTERNAL_LB_FORWARDING_RULES: Quota.Metric
    PUBLIC_ADVERTISED_PREFIXES: Quota.Metric
    PUBLIC_DELEGATED_PREFIXES: Quota.Metric
    REGIONAL_AUTOSCALERS: Quota.Metric
    REGIONAL_EXTERNAL_MANAGED_BACKEND_SERVICES: Quota.Metric
    REGIONAL_EXTERNAL_NETWORK_LB_BACKEND_SERVICES: Quota.Metric
    REGIONAL_INSTANCE_GROUP_MANAGERS: Quota.Metric
    REGIONAL_INTERNAL_LB_BACKEND_SERVICES: Quota.Metric
    REGIONAL_INTERNAL_MANAGED_BACKEND_SERVICES: Quota.Metric
    REGIONAL_INTERNAL_TRAFFIC_DIRECTOR_BACKEND_SERVICES: Quota.Metric
    RESERVATIONS: Quota.Metric
    RESOURCE_POLICIES: Quota.Metric
    ROUTERS: Quota.Metric
    ROUTES: Quota.Metric
    SECURITY_POLICIES: Quota.Metric
    SECURITY_POLICIES_PER_REGION: Quota.Metric
    SECURITY_POLICY_ADVANCED_RULES_PER_REGION: Quota.Metric
    SECURITY_POLICY_CEVAL_RULES: Quota.Metric
    SECURITY_POLICY_RULES: Quota.Metric
    SECURITY_POLICY_RULES_PER_REGION: Quota.Metric
    SERVICE_ATTACHMENTS: Quota.Metric
    SNAPSHOTS: Quota.Metric
    SSD_TOTAL_GB: Quota.Metric
    SSL_CERTIFICATES: Quota.Metric
    SSL_POLICIES: Quota.Metric
    STATIC_ADDRESSES: Quota.Metric
    STATIC_BYOIP_ADDRESSES: Quota.Metric
    STATIC_EXTERNAL_IPV6_ADDRESS_RANGES: Quota.Metric
    SUBNETWORKS: Quota.Metric
    T2A_CPUS: Quota.Metric
    T2D_CPUS: Quota.Metric
    TARGET_HTTPS_PROXIES: Quota.Metric
    TARGET_HTTP_PROXIES: Quota.Metric
    TARGET_INSTANCES: Quota.Metric
    TARGET_POOLS: Quota.Metric
    TARGET_SSL_PROXIES: Quota.Metric
    TARGET_TCP_PROXIES: Quota.Metric
    TARGET_VPN_GATEWAYS: Quota.Metric
    TPU_LITE_DEVICE_V5: Quota.Metric
    TPU_LITE_PODSLICE_V5: Quota.Metric
    TPU_PODSLICE_V4: Quota.Metric
    URL_MAPS: Quota.Metric
    VARIABLE_IPV6_PUBLIC_DELEGATED_PREFIXES: Quota.Metric
    VPN_GATEWAYS: Quota.Metric
    VPN_TUNNELS: Quota.Metric
    XPN_SERVICE_PROJECTS: Quota.Metric
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    METRIC_FIELD_NUMBER: _ClassVar[int]
    OWNER_FIELD_NUMBER: _ClassVar[int]
    USAGE_FIELD_NUMBER: _ClassVar[int]
    limit: float
    metric: str
    owner: str
    usage: float
    def __init__(self, limit: _Optional[float] = ..., metric: _Optional[str] = ..., owner: _Optional[str] = ..., usage: _Optional[float] = ...) -> None: ...

class QuotaExceededInfo(_message.Message):
    __slots__ = ("dimensions", "future_limit", "limit", "limit_name", "metric_name", "rollout_status")
    class RolloutStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ROLLOUT_STATUS: _ClassVar[QuotaExceededInfo.RolloutStatus]
        IN_PROGRESS: _ClassVar[QuotaExceededInfo.RolloutStatus]
        ROLLOUT_STATUS_UNSPECIFIED: _ClassVar[QuotaExceededInfo.RolloutStatus]
    UNDEFINED_ROLLOUT_STATUS: QuotaExceededInfo.RolloutStatus
    IN_PROGRESS: QuotaExceededInfo.RolloutStatus
    ROLLOUT_STATUS_UNSPECIFIED: QuotaExceededInfo.RolloutStatus
    class DimensionsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    FUTURE_LIMIT_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    LIMIT_NAME_FIELD_NUMBER: _ClassVar[int]
    METRIC_NAME_FIELD_NUMBER: _ClassVar[int]
    ROLLOUT_STATUS_FIELD_NUMBER: _ClassVar[int]
    dimensions: _containers.ScalarMap[str, str]
    future_limit: float
    limit: float
    limit_name: str
    metric_name: str
    rollout_status: str
    def __init__(self, dimensions: _Optional[_Mapping[str, str]] = ..., future_limit: _Optional[float] = ..., limit: _Optional[float] = ..., limit_name: _Optional[str] = ..., metric_name: _Optional[str] = ..., rollout_status: _Optional[str] = ...) -> None: ...

class QuotaStatusWarning(_message.Message):
    __slots__ = ("code", "data", "message")
    class Code(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CODE: _ClassVar[QuotaStatusWarning.Code]
        CLEANUP_FAILED: _ClassVar[QuotaStatusWarning.Code]
        DEPRECATED_RESOURCE_USED: _ClassVar[QuotaStatusWarning.Code]
        DEPRECATED_TYPE_USED: _ClassVar[QuotaStatusWarning.Code]
        DISK_SIZE_LARGER_THAN_IMAGE_SIZE: _ClassVar[QuotaStatusWarning.Code]
        EXPERIMENTAL_TYPE_USED: _ClassVar[QuotaStatusWarning.Code]
        EXTERNAL_API_WARNING: _ClassVar[QuotaStatusWarning.Code]
        FIELD_VALUE_OVERRIDEN: _ClassVar[QuotaStatusWarning.Code]
        INJECTED_KERNELS_DEPRECATED: _ClassVar[QuotaStatusWarning.Code]
        INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB: _ClassVar[QuotaStatusWarning.Code]
        LARGE_DEPLOYMENT_WARNING: _ClassVar[QuotaStatusWarning.Code]
        LIST_OVERHEAD_QUOTA_EXCEED: _ClassVar[QuotaStatusWarning.Code]
        MISSING_TYPE_DEPENDENCY: _ClassVar[QuotaStatusWarning.Code]
        NEXT_HOP_ADDRESS_NOT_ASSIGNED: _ClassVar[QuotaStatusWarning.Code]
        NEXT_HOP_CANNOT_IP_FORWARD: _ClassVar[QuotaStatusWarning.Code]
        NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE: _ClassVar[QuotaStatusWarning.Code]
        NEXT_HOP_INSTANCE_NOT_FOUND: _ClassVar[QuotaStatusWarning.Code]
        NEXT_HOP_INSTANCE_NOT_ON_NETWORK: _ClassVar[QuotaStatusWarning.Code]
        NEXT_HOP_NOT_RUNNING: _ClassVar[QuotaStatusWarning.Code]
        NOT_CRITICAL_ERROR: _ClassVar[QuotaStatusWarning.Code]
        NO_RESULTS_ON_PAGE: _ClassVar[QuotaStatusWarning.Code]
        PARTIAL_SUCCESS: _ClassVar[QuotaStatusWarning.Code]
        QUOTA_INFO_UNAVAILABLE: _ClassVar[QuotaStatusWarning.Code]
        REQUIRED_TOS_AGREEMENT: _ClassVar[QuotaStatusWarning.Code]
        RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING: _ClassVar[QuotaStatusWarning.Code]
        RESOURCE_NOT_DELETED: _ClassVar[QuotaStatusWarning.Code]
        SCHEMA_VALIDATION_IGNORED: _ClassVar[QuotaStatusWarning.Code]
        SINGLE_INSTANCE_PROPERTY_TEMPLATE: _ClassVar[QuotaStatusWarning.Code]
        UNDECLARED_PROPERTIES: _ClassVar[QuotaStatusWarning.Code]
        UNREACHABLE: _ClassVar[QuotaStatusWarning.Code]
    UNDEFINED_CODE: QuotaStatusWarning.Code
    CLEANUP_FAILED: QuotaStatusWarning.Code
    DEPRECATED_RESOURCE_USED: QuotaStatusWarning.Code
    DEPRECATED_TYPE_USED: QuotaStatusWarning.Code
    DISK_SIZE_LARGER_THAN_IMAGE_SIZE: QuotaStatusWarning.Code
    EXPERIMENTAL_TYPE_USED: QuotaStatusWarning.Code
    EXTERNAL_API_WARNING: QuotaStatusWarning.Code
    FIELD_VALUE_OVERRIDEN: QuotaStatusWarning.Code
    INJECTED_KERNELS_DEPRECATED: QuotaStatusWarning.Code
    INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB: QuotaStatusWarning.Code
    LARGE_DEPLOYMENT_WARNING: QuotaStatusWarning.Code
    LIST_OVERHEAD_QUOTA_EXCEED: QuotaStatusWarning.Code
    MISSING_TYPE_DEPENDENCY: QuotaStatusWarning.Code
    NEXT_HOP_ADDRESS_NOT_ASSIGNED: QuotaStatusWarning.Code
    NEXT_HOP_CANNOT_IP_FORWARD: QuotaStatusWarning.Code
    NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE: QuotaStatusWarning.Code
    NEXT_HOP_INSTANCE_NOT_FOUND: QuotaStatusWarning.Code
    NEXT_HOP_INSTANCE_NOT_ON_NETWORK: QuotaStatusWarning.Code
    NEXT_HOP_NOT_RUNNING: QuotaStatusWarning.Code
    NOT_CRITICAL_ERROR: QuotaStatusWarning.Code
    NO_RESULTS_ON_PAGE: QuotaStatusWarning.Code
    PARTIAL_SUCCESS: QuotaStatusWarning.Code
    QUOTA_INFO_UNAVAILABLE: QuotaStatusWarning.Code
    REQUIRED_TOS_AGREEMENT: QuotaStatusWarning.Code
    RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING: QuotaStatusWarning.Code
    RESOURCE_NOT_DELETED: QuotaStatusWarning.Code
    SCHEMA_VALIDATION_IGNORED: QuotaStatusWarning.Code
    SINGLE_INSTANCE_PROPERTY_TEMPLATE: QuotaStatusWarning.Code
    UNDECLARED_PROPERTIES: QuotaStatusWarning.Code
    UNREACHABLE: QuotaStatusWarning.Code
    CODE_FIELD_NUMBER: _ClassVar[int]
    DATA_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    code: str
    data: _containers.RepeatedCompositeFieldContainer[Data]
    message: str
    def __init__(self, code: _Optional[str] = ..., data: _Optional[_Iterable[_Union[Data, _Mapping]]] = ..., message: _Optional[str] = ...) -> None: ...

class RawDisk(_message.Message):
    __slots__ = ("container_type", "sha1_checksum", "source")
    class ContainerType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONTAINER_TYPE: _ClassVar[RawDisk.ContainerType]
        TAR: _ClassVar[RawDisk.ContainerType]
    UNDEFINED_CONTAINER_TYPE: RawDisk.ContainerType
    TAR: RawDisk.ContainerType
    CONTAINER_TYPE_FIELD_NUMBER: _ClassVar[int]
    SHA1_CHECKSUM_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    container_type: str
    sha1_checksum: str
    source: str
    def __init__(self, container_type: _Optional[str] = ..., sha1_checksum: _Optional[str] = ..., source: _Optional[str] = ...) -> None: ...

class RecreateInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_recreate_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_RECREATE_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_recreate_instances_request_resource: InstanceGroupManagersRecreateInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_recreate_instances_request_resource: _Optional[_Union[InstanceGroupManagersRecreateInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class RecreateInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_recreate_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_RECREATE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_recreate_request_resource: RegionInstanceGroupManagersRecreateRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_recreate_request_resource: _Optional[_Union[RegionInstanceGroupManagersRecreateRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class Reference(_message.Message):
    __slots__ = ("kind", "reference_type", "referrer", "target")
    KIND_FIELD_NUMBER: _ClassVar[int]
    REFERENCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    REFERRER_FIELD_NUMBER: _ClassVar[int]
    TARGET_FIELD_NUMBER: _ClassVar[int]
    kind: str
    reference_type: str
    referrer: str
    target: str
    def __init__(self, kind: _Optional[str] = ..., reference_type: _Optional[str] = ..., referrer: _Optional[str] = ..., target: _Optional[str] = ...) -> None: ...

class Region(_message.Message):
    __slots__ = ("creation_timestamp", "deprecated", "description", "id", "kind", "name", "quota_status_warning", "quotas", "self_link", "status", "supports_pzs", "zones")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Region.Status]
        DOWN: _ClassVar[Region.Status]
        UP: _ClassVar[Region.Status]
    UNDEFINED_STATUS: Region.Status
    DOWN: Region.Status
    UP: Region.Status
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    QUOTA_STATUS_WARNING_FIELD_NUMBER: _ClassVar[int]
    QUOTAS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUPPORTS_PZS_FIELD_NUMBER: _ClassVar[int]
    ZONES_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    deprecated: DeprecationStatus
    description: str
    id: int
    kind: str
    name: str
    quota_status_warning: QuotaStatusWarning
    quotas: _containers.RepeatedCompositeFieldContainer[Quota]
    self_link: str
    status: str
    supports_pzs: bool
    zones: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, creation_timestamp: _Optional[str] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., quota_status_warning: _Optional[_Union[QuotaStatusWarning, _Mapping]] = ..., quotas: _Optional[_Iterable[_Union[Quota, _Mapping]]] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ..., supports_pzs: bool = ..., zones: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionAddressesMoveRequest(_message.Message):
    __slots__ = ("description", "destination_address")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DESTINATION_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    description: str
    destination_address: str
    def __init__(self, description: _Optional[str] = ..., destination_address: _Optional[str] = ...) -> None: ...

class RegionAutoscalerList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Autoscaler]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Autoscaler, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RegionDiskTypeList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[DiskType]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[DiskType, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RegionDisksAddResourcePoliciesRequest(_message.Message):
    __slots__ = ("resource_policies",)
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, resource_policies: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionDisksRemoveResourcePoliciesRequest(_message.Message):
    __slots__ = ("resource_policies",)
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, resource_policies: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionDisksResizeRequest(_message.Message):
    __slots__ = ("size_gb",)
    SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    size_gb: int
    def __init__(self, size_gb: _Optional[int] = ...) -> None: ...

class RegionDisksStartAsyncReplicationRequest(_message.Message):
    __slots__ = ("async_secondary_disk",)
    ASYNC_SECONDARY_DISK_FIELD_NUMBER: _ClassVar[int]
    async_secondary_disk: str
    def __init__(self, async_secondary_disk: _Optional[str] = ...) -> None: ...

class RegionInstanceGroupList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceGroup]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceGroup, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RegionInstanceGroupManagerDeleteInstanceConfigReq(_message.Message):
    __slots__ = ("names",)
    NAMES_FIELD_NUMBER: _ClassVar[int]
    names: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, names: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupManagerList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceGroupManager]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceGroupManager, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RegionInstanceGroupManagerPatchInstanceConfigReq(_message.Message):
    __slots__ = ("per_instance_configs",)
    PER_INSTANCE_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    per_instance_configs: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    def __init__(self, per_instance_configs: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ...) -> None: ...

class RegionInstanceGroupManagerUpdateInstanceConfigReq(_message.Message):
    __slots__ = ("per_instance_configs",)
    PER_INSTANCE_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    per_instance_configs: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    def __init__(self, per_instance_configs: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ...) -> None: ...

class RegionInstanceGroupManagersAbandonInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupManagersApplyUpdatesRequest(_message.Message):
    __slots__ = ("all_instances", "instances", "minimal_action", "most_disruptive_allowed_action")
    class MinimalAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MINIMAL_ACTION: _ClassVar[RegionInstanceGroupManagersApplyUpdatesRequest.MinimalAction]
    UNDEFINED_MINIMAL_ACTION: RegionInstanceGroupManagersApplyUpdatesRequest.MinimalAction
    class MostDisruptiveAllowedAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: _ClassVar[RegionInstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction]
    UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: RegionInstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction
    ALL_INSTANCES_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    MINIMAL_ACTION_FIELD_NUMBER: _ClassVar[int]
    MOST_DISRUPTIVE_ALLOWED_ACTION_FIELD_NUMBER: _ClassVar[int]
    all_instances: bool
    instances: _containers.RepeatedScalarFieldContainer[str]
    minimal_action: str
    most_disruptive_allowed_action: str
    def __init__(self, all_instances: bool = ..., instances: _Optional[_Iterable[str]] = ..., minimal_action: _Optional[str] = ..., most_disruptive_allowed_action: _Optional[str] = ...) -> None: ...

class RegionInstanceGroupManagersCreateInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    def __init__(self, instances: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ...) -> None: ...

class RegionInstanceGroupManagersDeleteInstancesRequest(_message.Message):
    __slots__ = ("instances", "skip_instances_on_validation_error")
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    SKIP_INSTANCES_ON_VALIDATION_ERROR_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    skip_instances_on_validation_error: bool
    def __init__(self, instances: _Optional[_Iterable[str]] = ..., skip_instances_on_validation_error: bool = ...) -> None: ...

class RegionInstanceGroupManagersListErrorsResponse(_message.Message):
    __slots__ = ("items", "next_page_token")
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    items: _containers.RepeatedCompositeFieldContainer[InstanceManagedByIgmError]
    next_page_token: str
    def __init__(self, items: _Optional[_Iterable[_Union[InstanceManagedByIgmError, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class RegionInstanceGroupManagersListInstanceConfigsResp(_message.Message):
    __slots__ = ("items", "next_page_token", "warning")
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    items: _containers.RepeatedCompositeFieldContainer[PerInstanceConfig]
    next_page_token: str
    warning: Warning
    def __init__(self, items: _Optional[_Iterable[_Union[PerInstanceConfig, _Mapping]]] = ..., next_page_token: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RegionInstanceGroupManagersListInstancesResponse(_message.Message):
    __slots__ = ("managed_instances", "next_page_token")
    MANAGED_INSTANCES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    managed_instances: _containers.RepeatedCompositeFieldContainer[ManagedInstance]
    next_page_token: str
    def __init__(self, managed_instances: _Optional[_Iterable[_Union[ManagedInstance, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class RegionInstanceGroupManagersRecreateRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupManagersResumeInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupManagersSetTargetPoolsRequest(_message.Message):
    __slots__ = ("fingerprint", "target_pools")
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOLS_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    target_pools: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, fingerprint: _Optional[str] = ..., target_pools: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupManagersSetTemplateRequest(_message.Message):
    __slots__ = ("instance_template",)
    INSTANCE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    instance_template: str
    def __init__(self, instance_template: _Optional[str] = ...) -> None: ...

class RegionInstanceGroupManagersStartInstancesRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, instances: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupManagersStopInstancesRequest(_message.Message):
    __slots__ = ("force_stop", "instances")
    FORCE_STOP_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    force_stop: bool
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, force_stop: bool = ..., instances: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupManagersSuspendInstancesRequest(_message.Message):
    __slots__ = ("force_suspend", "instances")
    FORCE_SUSPEND_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    force_suspend: bool
    instances: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, force_suspend: bool = ..., instances: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionInstanceGroupsListInstances(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[InstanceWithNamedPorts]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[InstanceWithNamedPorts, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RegionInstanceGroupsListInstancesRequest(_message.Message):
    __slots__ = ("instance_state", "port_name")
    class InstanceState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INSTANCE_STATE: _ClassVar[RegionInstanceGroupsListInstancesRequest.InstanceState]
        ALL: _ClassVar[RegionInstanceGroupsListInstancesRequest.InstanceState]
        RUNNING: _ClassVar[RegionInstanceGroupsListInstancesRequest.InstanceState]
    UNDEFINED_INSTANCE_STATE: RegionInstanceGroupsListInstancesRequest.InstanceState
    ALL: RegionInstanceGroupsListInstancesRequest.InstanceState
    RUNNING: RegionInstanceGroupsListInstancesRequest.InstanceState
    INSTANCE_STATE_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    instance_state: str
    port_name: str
    def __init__(self, instance_state: _Optional[str] = ..., port_name: _Optional[str] = ...) -> None: ...

class RegionInstanceGroupsSetNamedPortsRequest(_message.Message):
    __slots__ = ("fingerprint", "named_ports")
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    NAMED_PORTS_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    named_ports: _containers.RepeatedCompositeFieldContainer[NamedPort]
    def __init__(self, fingerprint: _Optional[str] = ..., named_ports: _Optional[_Iterable[_Union[NamedPort, _Mapping]]] = ...) -> None: ...

class RegionList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Region]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Region, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RegionNetworkEndpointGroupsAttachEndpointsRequest(_message.Message):
    __slots__ = ("network_endpoints",)
    NETWORK_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    network_endpoints: _containers.RepeatedCompositeFieldContainer[NetworkEndpoint]
    def __init__(self, network_endpoints: _Optional[_Iterable[_Union[NetworkEndpoint, _Mapping]]] = ...) -> None: ...

class RegionNetworkEndpointGroupsDetachEndpointsRequest(_message.Message):
    __slots__ = ("network_endpoints",)
    NETWORK_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    network_endpoints: _containers.RepeatedCompositeFieldContainer[NetworkEndpoint]
    def __init__(self, network_endpoints: _Optional[_Iterable[_Union[NetworkEndpoint, _Mapping]]] = ...) -> None: ...

class RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse(_message.Message):
    __slots__ = ("firewall_policys", "firewalls")
    FIREWALL_POLICYS_FIELD_NUMBER: _ClassVar[int]
    FIREWALLS_FIELD_NUMBER: _ClassVar[int]
    firewall_policys: _containers.RepeatedCompositeFieldContainer[RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy]
    firewalls: _containers.RepeatedCompositeFieldContainer[Firewall]
    def __init__(self, firewall_policys: _Optional[_Iterable[_Union[RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy, _Mapping]]] = ..., firewalls: _Optional[_Iterable[_Union[Firewall, _Mapping]]] = ...) -> None: ...

class RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy(_message.Message):
    __slots__ = ("display_name", "name", "rules", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        HIERARCHY: _ClassVar[RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        NETWORK: _ClassVar[RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        NETWORK_REGIONAL: _ClassVar[RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
        UNSPECIFIED: _ClassVar[RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type]
    UNDEFINED_TYPE: RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    HIERARCHY: RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    NETWORK: RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    NETWORK_REGIONAL: RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    UNSPECIFIED: RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    RULES_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    display_name: str
    name: str
    rules: _containers.RepeatedCompositeFieldContainer[FirewallPolicyRule]
    type: str
    def __init__(self, display_name: _Optional[str] = ..., name: _Optional[str] = ..., rules: _Optional[_Iterable[_Union[FirewallPolicyRule, _Mapping]]] = ..., type: _Optional[str] = ...) -> None: ...

class RegionSetLabelsRequest(_message.Message):
    __slots__ = ("label_fingerprint", "labels")
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    def __init__(self, label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ...) -> None: ...

class RegionSetPolicyRequest(_message.Message):
    __slots__ = ("bindings", "etag", "policy")
    BINDINGS_FIELD_NUMBER: _ClassVar[int]
    ETAG_FIELD_NUMBER: _ClassVar[int]
    POLICY_FIELD_NUMBER: _ClassVar[int]
    bindings: _containers.RepeatedCompositeFieldContainer[Binding]
    etag: str
    policy: Policy
    def __init__(self, bindings: _Optional[_Iterable[_Union[Binding, _Mapping]]] = ..., etag: _Optional[str] = ..., policy: _Optional[_Union[Policy, _Mapping]] = ...) -> None: ...

class RegionTargetHttpsProxiesSetSslCertificatesRequest(_message.Message):
    __slots__ = ("ssl_certificates",)
    SSL_CERTIFICATES_FIELD_NUMBER: _ClassVar[int]
    ssl_certificates: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, ssl_certificates: _Optional[_Iterable[str]] = ...) -> None: ...

class RegionUrlMapsValidateRequest(_message.Message):
    __slots__ = ("resource",)
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    resource: UrlMap
    def __init__(self, resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class RemoveAssociationFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "name", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    name: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., name: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveAssociationNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "name", "project", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    name: str
    project: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., name: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveAssociationRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "name", "project", "region", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    name: str
    project: str
    region: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., name: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveHealthCheckTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_pool", "target_pools_remove_health_check_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOLS_REMOVE_HEALTH_CHECK_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_pool: str
    target_pools_remove_health_check_request_resource: TargetPoolsRemoveHealthCheckRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_pool: _Optional[str] = ..., target_pools_remove_health_check_request_resource: _Optional[_Union[TargetPoolsRemoveHealthCheckRequest, _Mapping]] = ...) -> None: ...

class RemoveInstanceTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_pool", "target_pools_remove_instance_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOLS_REMOVE_INSTANCE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_pool: str
    target_pools_remove_instance_request_resource: TargetPoolsRemoveInstanceRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_pool: _Optional[str] = ..., target_pools_remove_instance_request_resource: _Optional[_Union[TargetPoolsRemoveInstanceRequest, _Mapping]] = ...) -> None: ...

class RemoveInstancesInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group", "instance_groups_remove_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUPS_REMOVE_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group: str
    instance_groups_remove_instances_request_resource: InstanceGroupsRemoveInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group: _Optional[str] = ..., instance_groups_remove_instances_request_resource: _Optional[_Union[InstanceGroupsRemoveInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class RemovePeeringNetworkRequest(_message.Message):
    __slots__ = ("network", "networks_remove_peering_request_resource", "project", "request_id")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORKS_REMOVE_PEERING_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network: str
    networks_remove_peering_request_resource: NetworksRemovePeeringRequest
    project: str
    request_id: str
    def __init__(self, network: _Optional[str] = ..., networks_remove_peering_request_resource: _Optional[_Union[NetworksRemovePeeringRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveResourcePoliciesDiskRequest(_message.Message):
    __slots__ = ("disk", "disks_remove_resource_policies_request_resource", "project", "request_id", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    DISKS_REMOVE_RESOURCE_POLICIES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    disks_remove_resource_policies_request_resource: DisksRemoveResourcePoliciesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., disks_remove_resource_policies_request_resource: _Optional[_Union[DisksRemoveResourcePoliciesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class RemoveResourcePoliciesInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_remove_resource_policies_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_REMOVE_RESOURCE_POLICIES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_remove_resource_policies_request_resource: InstancesRemoveResourcePoliciesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_remove_resource_policies_request_resource: _Optional[_Union[InstancesRemoveResourcePoliciesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class RemoveResourcePoliciesRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region", "region_disks_remove_resource_policies_request_resource", "request_id")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_DISKS_REMOVE_RESOURCE_POLICIES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    region_disks_remove_resource_policies_request_resource: RegionDisksRemoveResourcePoliciesRequest
    request_id: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_disks_remove_resource_policies_request_resource: _Optional[_Union[RegionDisksRemoveResourcePoliciesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveRuleFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "priority", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    priority: int
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., priority: _Optional[int] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveRuleNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "priority", "project", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    priority: int
    project: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., priority: _Optional[int] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveRuleRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("firewall_policy", "priority", "project", "region", "request_id")
    FIREWALL_POLICY_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall_policy: str
    priority: int
    project: str
    region: str
    request_id: str
    def __init__(self, firewall_policy: _Optional[str] = ..., priority: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class RemoveRuleRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("priority", "project", "region", "security_policy")
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    priority: int
    project: str
    region: str
    security_policy: str
    def __init__(self, priority: _Optional[int] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class RemoveRuleSecurityPolicyRequest(_message.Message):
    __slots__ = ("priority", "project", "security_policy")
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    priority: int
    project: str
    security_policy: str
    def __init__(self, priority: _Optional[int] = ..., project: _Optional[str] = ..., security_policy: _Optional[str] = ...) -> None: ...

class RequestMirrorPolicy(_message.Message):
    __slots__ = ("backend_service",)
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    def __init__(self, backend_service: _Optional[str] = ...) -> None: ...

class Reservation(_message.Message):
    __slots__ = ("aggregate_reservation", "commitment", "creation_timestamp", "description", "id", "kind", "name", "resource_policies", "resource_status", "satisfies_pzs", "self_link", "share_settings", "specific_reservation", "specific_reservation_required", "status", "zone")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Reservation.Status]
        CREATING: _ClassVar[Reservation.Status]
        DELETING: _ClassVar[Reservation.Status]
        INVALID: _ClassVar[Reservation.Status]
        READY: _ClassVar[Reservation.Status]
        UPDATING: _ClassVar[Reservation.Status]
    UNDEFINED_STATUS: Reservation.Status
    CREATING: Reservation.Status
    DELETING: Reservation.Status
    INVALID: Reservation.Status
    READY: Reservation.Status
    UPDATING: Reservation.Status
    class ResourcePoliciesEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    AGGREGATE_RESERVATION_FIELD_NUMBER: _ClassVar[int]
    COMMITMENT_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SHARE_SETTINGS_FIELD_NUMBER: _ClassVar[int]
    SPECIFIC_RESERVATION_FIELD_NUMBER: _ClassVar[int]
    SPECIFIC_RESERVATION_REQUIRED_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    aggregate_reservation: AllocationAggregateReservation
    commitment: str
    creation_timestamp: str
    description: str
    id: int
    kind: str
    name: str
    resource_policies: _containers.ScalarMap[str, str]
    resource_status: AllocationResourceStatus
    satisfies_pzs: bool
    self_link: str
    share_settings: ShareSettings
    specific_reservation: AllocationSpecificSKUReservation
    specific_reservation_required: bool
    status: str
    zone: str
    def __init__(self, aggregate_reservation: _Optional[_Union[AllocationAggregateReservation, _Mapping]] = ..., commitment: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., resource_policies: _Optional[_Mapping[str, str]] = ..., resource_status: _Optional[_Union[AllocationResourceStatus, _Mapping]] = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., share_settings: _Optional[_Union[ShareSettings, _Mapping]] = ..., specific_reservation: _Optional[_Union[AllocationSpecificSKUReservation, _Mapping]] = ..., specific_reservation_required: bool = ..., status: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class ReservationAffinity(_message.Message):
    __slots__ = ("consume_reservation_type", "key", "values")
    class ConsumeReservationType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONSUME_RESERVATION_TYPE: _ClassVar[ReservationAffinity.ConsumeReservationType]
        ANY_RESERVATION: _ClassVar[ReservationAffinity.ConsumeReservationType]
        NO_RESERVATION: _ClassVar[ReservationAffinity.ConsumeReservationType]
        SPECIFIC_RESERVATION: _ClassVar[ReservationAffinity.ConsumeReservationType]
        UNSPECIFIED: _ClassVar[ReservationAffinity.ConsumeReservationType]
    UNDEFINED_CONSUME_RESERVATION_TYPE: ReservationAffinity.ConsumeReservationType
    ANY_RESERVATION: ReservationAffinity.ConsumeReservationType
    NO_RESERVATION: ReservationAffinity.ConsumeReservationType
    SPECIFIC_RESERVATION: ReservationAffinity.ConsumeReservationType
    UNSPECIFIED: ReservationAffinity.ConsumeReservationType
    CONSUME_RESERVATION_TYPE_FIELD_NUMBER: _ClassVar[int]
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUES_FIELD_NUMBER: _ClassVar[int]
    consume_reservation_type: str
    key: str
    values: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, consume_reservation_type: _Optional[str] = ..., key: _Optional[str] = ..., values: _Optional[_Iterable[str]] = ...) -> None: ...

class ReservationAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ReservationsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ReservationsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, ReservationsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, ReservationsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ReservationList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Reservation]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Reservation, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ReservationsResizeRequest(_message.Message):
    __slots__ = ("specific_sku_count",)
    SPECIFIC_SKU_COUNT_FIELD_NUMBER: _ClassVar[int]
    specific_sku_count: int
    def __init__(self, specific_sku_count: _Optional[int] = ...) -> None: ...

class ReservationsScopedList(_message.Message):
    __slots__ = ("reservations", "warning")
    RESERVATIONS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    reservations: _containers.RepeatedCompositeFieldContainer[Reservation]
    warning: Warning
    def __init__(self, reservations: _Optional[_Iterable[_Union[Reservation, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ResetInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class ResizeDiskRequest(_message.Message):
    __slots__ = ("disk", "disks_resize_request_resource", "project", "request_id", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    DISKS_RESIZE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    disks_resize_request_resource: DisksResizeRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., disks_resize_request_resource: _Optional[_Union[DisksResizeRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class ResizeInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "request_id", "size", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    request_id: str
    size: int
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., size: _Optional[int] = ..., zone: _Optional[str] = ...) -> None: ...

class ResizeRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region", "region_disks_resize_request_resource", "request_id")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_DISKS_RESIZE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    region_disks_resize_request_resource: RegionDisksResizeRequest
    request_id: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_disks_resize_request_resource: _Optional[_Union[RegionDisksResizeRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class ResizeRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "request_id", "size")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    request_id: str
    size: int
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., size: _Optional[int] = ...) -> None: ...

class ResizeReservationRequest(_message.Message):
    __slots__ = ("project", "request_id", "reservation", "reservations_resize_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_FIELD_NUMBER: _ClassVar[int]
    RESERVATIONS_RESIZE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    reservation: str
    reservations_resize_request_resource: ReservationsResizeRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., reservation: _Optional[str] = ..., reservations_resize_request_resource: _Optional[_Union[ReservationsResizeRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class ResourceCommitment(_message.Message):
    __slots__ = ("accelerator_type", "amount", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[ResourceCommitment.Type]
        ACCELERATOR: _ClassVar[ResourceCommitment.Type]
        LOCAL_SSD: _ClassVar[ResourceCommitment.Type]
        MEMORY: _ClassVar[ResourceCommitment.Type]
        UNSPECIFIED: _ClassVar[ResourceCommitment.Type]
        VCPU: _ClassVar[ResourceCommitment.Type]
    UNDEFINED_TYPE: ResourceCommitment.Type
    ACCELERATOR: ResourceCommitment.Type
    LOCAL_SSD: ResourceCommitment.Type
    MEMORY: ResourceCommitment.Type
    UNSPECIFIED: ResourceCommitment.Type
    VCPU: ResourceCommitment.Type
    ACCELERATOR_TYPE_FIELD_NUMBER: _ClassVar[int]
    AMOUNT_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    accelerator_type: str
    amount: int
    type: str
    def __init__(self, accelerator_type: _Optional[str] = ..., amount: _Optional[int] = ..., type: _Optional[str] = ...) -> None: ...

class ResourceGroupReference(_message.Message):
    __slots__ = ("group",)
    GROUP_FIELD_NUMBER: _ClassVar[int]
    group: str
    def __init__(self, group: _Optional[str] = ...) -> None: ...

class ResourcePoliciesScopedList(_message.Message):
    __slots__ = ("resource_policies", "warning")
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    resource_policies: _containers.RepeatedCompositeFieldContainer[ResourcePolicy]
    warning: Warning
    def __init__(self, resource_policies: _Optional[_Iterable[_Union[ResourcePolicy, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ResourcePolicy(_message.Message):
    __slots__ = ("creation_timestamp", "description", "disk_consistency_group_policy", "group_placement_policy", "id", "instance_schedule_policy", "kind", "name", "region", "resource_status", "self_link", "snapshot_schedule_policy", "status")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[ResourcePolicy.Status]
        CREATING: _ClassVar[ResourcePolicy.Status]
        DELETING: _ClassVar[ResourcePolicy.Status]
        EXPIRED: _ClassVar[ResourcePolicy.Status]
        INVALID: _ClassVar[ResourcePolicy.Status]
        READY: _ClassVar[ResourcePolicy.Status]
    UNDEFINED_STATUS: ResourcePolicy.Status
    CREATING: ResourcePolicy.Status
    DELETING: ResourcePolicy.Status
    EXPIRED: ResourcePolicy.Status
    INVALID: ResourcePolicy.Status
    READY: ResourcePolicy.Status
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISK_CONSISTENCY_GROUP_POLICY_FIELD_NUMBER: _ClassVar[int]
    GROUP_PLACEMENT_POLICY_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_SCHEDULE_POLICY_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_SCHEDULE_POLICY_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    disk_consistency_group_policy: ResourcePolicyDiskConsistencyGroupPolicy
    group_placement_policy: ResourcePolicyGroupPlacementPolicy
    id: int
    instance_schedule_policy: ResourcePolicyInstanceSchedulePolicy
    kind: str
    name: str
    region: str
    resource_status: ResourcePolicyResourceStatus
    self_link: str
    snapshot_schedule_policy: ResourcePolicySnapshotSchedulePolicy
    status: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., disk_consistency_group_policy: _Optional[_Union[ResourcePolicyDiskConsistencyGroupPolicy, _Mapping]] = ..., group_placement_policy: _Optional[_Union[ResourcePolicyGroupPlacementPolicy, _Mapping]] = ..., id: _Optional[int] = ..., instance_schedule_policy: _Optional[_Union[ResourcePolicyInstanceSchedulePolicy, _Mapping]] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., resource_status: _Optional[_Union[ResourcePolicyResourceStatus, _Mapping]] = ..., self_link: _Optional[str] = ..., snapshot_schedule_policy: _Optional[_Union[ResourcePolicySnapshotSchedulePolicy, _Mapping]] = ..., status: _Optional[str] = ...) -> None: ...

class ResourcePolicyAggregatedList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ResourcePoliciesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ResourcePoliciesScopedList, _Mapping]] = ...) -> None: ...
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.MessageMap[str, ResourcePoliciesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Mapping[str, ResourcePoliciesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ResourcePolicyDailyCycle(_message.Message):
    __slots__ = ("days_in_cycle", "duration", "start_time")
    DAYS_IN_CYCLE_FIELD_NUMBER: _ClassVar[int]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    days_in_cycle: int
    duration: str
    start_time: str
    def __init__(self, days_in_cycle: _Optional[int] = ..., duration: _Optional[str] = ..., start_time: _Optional[str] = ...) -> None: ...

class ResourcePolicyDiskConsistencyGroupPolicy(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class ResourcePolicyGroupPlacementPolicy(_message.Message):
    __slots__ = ("availability_domain_count", "collocation", "vm_count")
    class Collocation(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_COLLOCATION: _ClassVar[ResourcePolicyGroupPlacementPolicy.Collocation]
        COLLOCATED: _ClassVar[ResourcePolicyGroupPlacementPolicy.Collocation]
        UNSPECIFIED_COLLOCATION: _ClassVar[ResourcePolicyGroupPlacementPolicy.Collocation]
    UNDEFINED_COLLOCATION: ResourcePolicyGroupPlacementPolicy.Collocation
    COLLOCATED: ResourcePolicyGroupPlacementPolicy.Collocation
    UNSPECIFIED_COLLOCATION: ResourcePolicyGroupPlacementPolicy.Collocation
    AVAILABILITY_DOMAIN_COUNT_FIELD_NUMBER: _ClassVar[int]
    COLLOCATION_FIELD_NUMBER: _ClassVar[int]
    VM_COUNT_FIELD_NUMBER: _ClassVar[int]
    availability_domain_count: int
    collocation: str
    vm_count: int
    def __init__(self, availability_domain_count: _Optional[int] = ..., collocation: _Optional[str] = ..., vm_count: _Optional[int] = ...) -> None: ...

class ResourcePolicyHourlyCycle(_message.Message):
    __slots__ = ("duration", "hours_in_cycle", "start_time")
    DURATION_FIELD_NUMBER: _ClassVar[int]
    HOURS_IN_CYCLE_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    duration: str
    hours_in_cycle: int
    start_time: str
    def __init__(self, duration: _Optional[str] = ..., hours_in_cycle: _Optional[int] = ..., start_time: _Optional[str] = ...) -> None: ...

class ResourcePolicyInstanceSchedulePolicy(_message.Message):
    __slots__ = ("expiration_time", "start_time", "time_zone", "vm_start_schedule", "vm_stop_schedule")
    EXPIRATION_TIME_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    TIME_ZONE_FIELD_NUMBER: _ClassVar[int]
    VM_START_SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    VM_STOP_SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    expiration_time: str
    start_time: str
    time_zone: str
    vm_start_schedule: ResourcePolicyInstanceSchedulePolicySchedule
    vm_stop_schedule: ResourcePolicyInstanceSchedulePolicySchedule
    def __init__(self, expiration_time: _Optional[str] = ..., start_time: _Optional[str] = ..., time_zone: _Optional[str] = ..., vm_start_schedule: _Optional[_Union[ResourcePolicyInstanceSchedulePolicySchedule, _Mapping]] = ..., vm_stop_schedule: _Optional[_Union[ResourcePolicyInstanceSchedulePolicySchedule, _Mapping]] = ...) -> None: ...

class ResourcePolicyInstanceSchedulePolicySchedule(_message.Message):
    __slots__ = ("schedule",)
    SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    schedule: str
    def __init__(self, schedule: _Optional[str] = ...) -> None: ...

class ResourcePolicyList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "warning")
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.RepeatedCompositeFieldContainer[ResourcePolicy]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[ResourcePolicy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ResourcePolicyResourceStatus(_message.Message):
    __slots__ = ("instance_schedule_policy",)
    INSTANCE_SCHEDULE_POLICY_FIELD_NUMBER: _ClassVar[int]
    instance_schedule_policy: ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
    def __init__(self, instance_schedule_policy: _Optional[_Union[ResourcePolicyResourceStatusInstanceSchedulePolicyStatus, _Mapping]] = ...) -> None: ...

class ResourcePolicyResourceStatusInstanceSchedulePolicyStatus(_message.Message):
    __slots__ = ("last_run_start_time", "next_run_start_time")
    LAST_RUN_START_TIME_FIELD_NUMBER: _ClassVar[int]
    NEXT_RUN_START_TIME_FIELD_NUMBER: _ClassVar[int]
    last_run_start_time: str
    next_run_start_time: str
    def __init__(self, last_run_start_time: _Optional[str] = ..., next_run_start_time: _Optional[str] = ...) -> None: ...

class ResourcePolicySnapshotSchedulePolicy(_message.Message):
    __slots__ = ("retention_policy", "schedule", "snapshot_properties")
    RETENTION_POLICY_FIELD_NUMBER: _ClassVar[int]
    SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    retention_policy: ResourcePolicySnapshotSchedulePolicyRetentionPolicy
    schedule: ResourcePolicySnapshotSchedulePolicySchedule
    snapshot_properties: ResourcePolicySnapshotSchedulePolicySnapshotProperties
    def __init__(self, retention_policy: _Optional[_Union[ResourcePolicySnapshotSchedulePolicyRetentionPolicy, _Mapping]] = ..., schedule: _Optional[_Union[ResourcePolicySnapshotSchedulePolicySchedule, _Mapping]] = ..., snapshot_properties: _Optional[_Union[ResourcePolicySnapshotSchedulePolicySnapshotProperties, _Mapping]] = ...) -> None: ...

class ResourcePolicySnapshotSchedulePolicyRetentionPolicy(_message.Message):
    __slots__ = ("max_retention_days", "on_source_disk_delete")
    class OnSourceDiskDelete(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ON_SOURCE_DISK_DELETE: _ClassVar[ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete]
        APPLY_RETENTION_POLICY: _ClassVar[ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete]
        KEEP_AUTO_SNAPSHOTS: _ClassVar[ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete]
        UNSPECIFIED_ON_SOURCE_DISK_DELETE: _ClassVar[ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete]
    UNDEFINED_ON_SOURCE_DISK_DELETE: ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete
    APPLY_RETENTION_POLICY: ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete
    KEEP_AUTO_SNAPSHOTS: ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete
    UNSPECIFIED_ON_SOURCE_DISK_DELETE: ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete
    MAX_RETENTION_DAYS_FIELD_NUMBER: _ClassVar[int]
    ON_SOURCE_DISK_DELETE_FIELD_NUMBER: _ClassVar[int]
    max_retention_days: int
    on_source_disk_delete: str
    def __init__(self, max_retention_days: _Optional[int] = ..., on_source_disk_delete: _Optional[str] = ...) -> None: ...

class ResourcePolicySnapshotSchedulePolicySchedule(_message.Message):
    __slots__ = ("daily_schedule", "hourly_schedule", "weekly_schedule")
    DAILY_SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    HOURLY_SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    WEEKLY_SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    daily_schedule: ResourcePolicyDailyCycle
    hourly_schedule: ResourcePolicyHourlyCycle
    weekly_schedule: ResourcePolicyWeeklyCycle
    def __init__(self, daily_schedule: _Optional[_Union[ResourcePolicyDailyCycle, _Mapping]] = ..., hourly_schedule: _Optional[_Union[ResourcePolicyHourlyCycle, _Mapping]] = ..., weekly_schedule: _Optional[_Union[ResourcePolicyWeeklyCycle, _Mapping]] = ...) -> None: ...

class ResourcePolicySnapshotSchedulePolicySnapshotProperties(_message.Message):
    __slots__ = ("chain_name", "guest_flush", "labels", "storage_locations")
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CHAIN_NAME_FIELD_NUMBER: _ClassVar[int]
    GUEST_FLUSH_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    chain_name: str
    guest_flush: bool
    labels: _containers.ScalarMap[str, str]
    storage_locations: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, chain_name: _Optional[str] = ..., guest_flush: bool = ..., labels: _Optional[_Mapping[str, str]] = ..., storage_locations: _Optional[_Iterable[str]] = ...) -> None: ...

class ResourcePolicyWeeklyCycle(_message.Message):
    __slots__ = ("day_of_weeks",)
    DAY_OF_WEEKS_FIELD_NUMBER: _ClassVar[int]
    day_of_weeks: _containers.RepeatedCompositeFieldContainer[ResourcePolicyWeeklyCycleDayOfWeek]
    def __init__(self, day_of_weeks: _Optional[_Iterable[_Union[ResourcePolicyWeeklyCycleDayOfWeek, _Mapping]]] = ...) -> None: ...

class ResourcePolicyWeeklyCycleDayOfWeek(_message.Message):
    __slots__ = ("day", "duration", "start_time")
    class Day(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        FRIDAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        INVALID: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        MONDAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        SATURDAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        SUNDAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        THURSDAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        TUESDAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
        WEDNESDAY: _ClassVar[ResourcePolicyWeeklyCycleDayOfWeek.Day]
    UNDEFINED_DAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    FRIDAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    INVALID: ResourcePolicyWeeklyCycleDayOfWeek.Day
    MONDAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    SATURDAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    SUNDAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    THURSDAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    TUESDAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    WEDNESDAY: ResourcePolicyWeeklyCycleDayOfWeek.Day
    DAY_FIELD_NUMBER: _ClassVar[int]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    day: str
    duration: str
    start_time: str
    def __init__(self, day: _Optional[str] = ..., duration: _Optional[str] = ..., start_time: _Optional[str] = ...) -> None: ...

class ResourceStatus(_message.Message):
    __slots__ = ("physical_host", "scheduling", "upcoming_maintenance")
    PHYSICAL_HOST_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_FIELD_NUMBER: _ClassVar[int]
    UPCOMING_MAINTENANCE_FIELD_NUMBER: _ClassVar[int]
    physical_host: str
    scheduling: ResourceStatusScheduling
    upcoming_maintenance: UpcomingMaintenance
    def __init__(self, physical_host: _Optional[str] = ..., scheduling: _Optional[_Union[ResourceStatusScheduling, _Mapping]] = ..., upcoming_maintenance: _Optional[_Union[UpcomingMaintenance, _Mapping]] = ...) -> None: ...

class ResourceStatusScheduling(_message.Message):
    __slots__ = ("availability_domain",)
    AVAILABILITY_DOMAIN_FIELD_NUMBER: _ClassVar[int]
    availability_domain: int
    def __init__(self, availability_domain: _Optional[int] = ...) -> None: ...

class ResumeInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class ResumeInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_resume_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_RESUME_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_resume_instances_request_resource: InstanceGroupManagersResumeInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_resume_instances_request_resource: _Optional[_Union[InstanceGroupManagersResumeInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class ResumeInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_resume_instances_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_RESUME_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_resume_instances_request_resource: RegionInstanceGroupManagersResumeInstancesRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_resume_instances_request_resource: _Optional[_Union[RegionInstanceGroupManagersResumeInstancesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class Route(_message.Message):
    __slots__ = ("as_paths", "creation_timestamp", "description", "dest_range", "id", "kind", "name", "network", "next_hop_gateway", "next_hop_hub", "next_hop_ilb", "next_hop_instance", "next_hop_inter_region_cost", "next_hop_ip", "next_hop_med", "next_hop_network", "next_hop_origin", "next_hop_peering", "next_hop_vpn_tunnel", "priority", "route_status", "route_type", "self_link", "tags", "warnings")
    class NextHopOrigin(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NEXT_HOP_ORIGIN: _ClassVar[Route.NextHopOrigin]
        EGP: _ClassVar[Route.NextHopOrigin]
        IGP: _ClassVar[Route.NextHopOrigin]
        INCOMPLETE: _ClassVar[Route.NextHopOrigin]
    UNDEFINED_NEXT_HOP_ORIGIN: Route.NextHopOrigin
    EGP: Route.NextHopOrigin
    IGP: Route.NextHopOrigin
    INCOMPLETE: Route.NextHopOrigin
    class RouteStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ROUTE_STATUS: _ClassVar[Route.RouteStatus]
        ACTIVE: _ClassVar[Route.RouteStatus]
        DROPPED: _ClassVar[Route.RouteStatus]
        INACTIVE: _ClassVar[Route.RouteStatus]
        PENDING: _ClassVar[Route.RouteStatus]
    UNDEFINED_ROUTE_STATUS: Route.RouteStatus
    ACTIVE: Route.RouteStatus
    DROPPED: Route.RouteStatus
    INACTIVE: Route.RouteStatus
    PENDING: Route.RouteStatus
    class RouteType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ROUTE_TYPE: _ClassVar[Route.RouteType]
        BGP: _ClassVar[Route.RouteType]
        STATIC: _ClassVar[Route.RouteType]
        SUBNET: _ClassVar[Route.RouteType]
        TRANSIT: _ClassVar[Route.RouteType]
    UNDEFINED_ROUTE_TYPE: Route.RouteType
    BGP: Route.RouteType
    STATIC: Route.RouteType
    SUBNET: Route.RouteType
    TRANSIT: Route.RouteType
    AS_PATHS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DEST_RANGE_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_HUB_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_ILB_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_INTER_REGION_COST_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_IP_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_MED_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_NETWORK_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_ORIGIN_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_PEERING_FIELD_NUMBER: _ClassVar[int]
    NEXT_HOP_VPN_TUNNEL_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    ROUTE_STATUS_FIELD_NUMBER: _ClassVar[int]
    ROUTE_TYPE_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    WARNINGS_FIELD_NUMBER: _ClassVar[int]
    as_paths: _containers.RepeatedCompositeFieldContainer[RouteAsPath]
    creation_timestamp: str
    description: str
    dest_range: str
    id: int
    kind: str
    name: str
    network: str
    next_hop_gateway: str
    next_hop_hub: str
    next_hop_ilb: str
    next_hop_instance: str
    next_hop_inter_region_cost: int
    next_hop_ip: str
    next_hop_med: int
    next_hop_network: str
    next_hop_origin: str
    next_hop_peering: str
    next_hop_vpn_tunnel: str
    priority: int
    route_status: str
    route_type: str
    self_link: str
    tags: _containers.RepeatedScalarFieldContainer[str]
    warnings: _containers.RepeatedCompositeFieldContainer[Warnings]
    def __init__(self, as_paths: _Optional[_Iterable[_Union[RouteAsPath, _Mapping]]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., dest_range: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., next_hop_gateway: _Optional[str] = ..., next_hop_hub: _Optional[str] = ..., next_hop_ilb: _Optional[str] = ..., next_hop_instance: _Optional[str] = ..., next_hop_inter_region_cost: _Optional[int] = ..., next_hop_ip: _Optional[str] = ..., next_hop_med: _Optional[int] = ..., next_hop_network: _Optional[str] = ..., next_hop_origin: _Optional[str] = ..., next_hop_peering: _Optional[str] = ..., next_hop_vpn_tunnel: _Optional[str] = ..., priority: _Optional[int] = ..., route_status: _Optional[str] = ..., route_type: _Optional[str] = ..., self_link: _Optional[str] = ..., tags: _Optional[_Iterable[str]] = ..., warnings: _Optional[_Iterable[_Union[Warnings, _Mapping]]] = ...) -> None: ...

class RouteAsPath(_message.Message):
    __slots__ = ("as_lists", "path_segment_type")
    class PathSegmentType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PATH_SEGMENT_TYPE: _ClassVar[RouteAsPath.PathSegmentType]
        AS_CONFED_SEQUENCE: _ClassVar[RouteAsPath.PathSegmentType]
        AS_CONFED_SET: _ClassVar[RouteAsPath.PathSegmentType]
        AS_SEQUENCE: _ClassVar[RouteAsPath.PathSegmentType]
        AS_SET: _ClassVar[RouteAsPath.PathSegmentType]
    UNDEFINED_PATH_SEGMENT_TYPE: RouteAsPath.PathSegmentType
    AS_CONFED_SEQUENCE: RouteAsPath.PathSegmentType
    AS_CONFED_SET: RouteAsPath.PathSegmentType
    AS_SEQUENCE: RouteAsPath.PathSegmentType
    AS_SET: RouteAsPath.PathSegmentType
    AS_LISTS_FIELD_NUMBER: _ClassVar[int]
    PATH_SEGMENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    as_lists: _containers.RepeatedScalarFieldContainer[int]
    path_segment_type: str
    def __init__(self, as_lists: _Optional[_Iterable[int]] = ..., path_segment_type: _Optional[str] = ...) -> None: ...

class RouteList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Route]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Route, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class Router(_message.Message):
    __slots__ = ("bgp", "bgp_peers", "creation_timestamp", "description", "encrypted_interconnect_router", "id", "interfaces", "kind", "md5_authentication_keys", "name", "nats", "network", "region", "self_link")
    BGP_FIELD_NUMBER: _ClassVar[int]
    BGP_PEERS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ENCRYPTED_INTERCONNECT_ROUTER_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INTERFACES_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MD5_AUTHENTICATION_KEYS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NATS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    bgp: RouterBgp
    bgp_peers: _containers.RepeatedCompositeFieldContainer[RouterBgpPeer]
    creation_timestamp: str
    description: str
    encrypted_interconnect_router: bool
    id: int
    interfaces: _containers.RepeatedCompositeFieldContainer[RouterInterface]
    kind: str
    md5_authentication_keys: _containers.RepeatedCompositeFieldContainer[RouterMd5AuthenticationKey]
    name: str
    nats: _containers.RepeatedCompositeFieldContainer[RouterNat]
    network: str
    region: str
    self_link: str
    def __init__(self, bgp: _Optional[_Union[RouterBgp, _Mapping]] = ..., bgp_peers: _Optional[_Iterable[_Union[RouterBgpPeer, _Mapping]]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., encrypted_interconnect_router: bool = ..., id: _Optional[int] = ..., interfaces: _Optional[_Iterable[_Union[RouterInterface, _Mapping]]] = ..., kind: _Optional[str] = ..., md5_authentication_keys: _Optional[_Iterable[_Union[RouterMd5AuthenticationKey, _Mapping]]] = ..., name: _Optional[str] = ..., nats: _Optional[_Iterable[_Union[RouterNat, _Mapping]]] = ..., network: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ...) -> None: ...

class RouterAdvertisedIpRange(_message.Message):
    __slots__ = ("description", "range")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    RANGE_FIELD_NUMBER: _ClassVar[int]
    description: str
    range: str
    def __init__(self, description: _Optional[str] = ..., range: _Optional[str] = ...) -> None: ...

class RouterAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: RoutersScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[RoutersScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, RoutersScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, RoutersScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RouterBgp(_message.Message):
    __slots__ = ("advertise_mode", "advertised_groups", "advertised_ip_ranges", "asn", "identifier_range", "keepalive_interval")
    class AdvertiseMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ADVERTISE_MODE: _ClassVar[RouterBgp.AdvertiseMode]
        CUSTOM: _ClassVar[RouterBgp.AdvertiseMode]
        DEFAULT: _ClassVar[RouterBgp.AdvertiseMode]
    UNDEFINED_ADVERTISE_MODE: RouterBgp.AdvertiseMode
    CUSTOM: RouterBgp.AdvertiseMode
    DEFAULT: RouterBgp.AdvertiseMode
    class AdvertisedGroups(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ADVERTISED_GROUPS: _ClassVar[RouterBgp.AdvertisedGroups]
        ALL_SUBNETS: _ClassVar[RouterBgp.AdvertisedGroups]
    UNDEFINED_ADVERTISED_GROUPS: RouterBgp.AdvertisedGroups
    ALL_SUBNETS: RouterBgp.AdvertisedGroups
    ADVERTISE_MODE_FIELD_NUMBER: _ClassVar[int]
    ADVERTISED_GROUPS_FIELD_NUMBER: _ClassVar[int]
    ADVERTISED_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    ASN_FIELD_NUMBER: _ClassVar[int]
    IDENTIFIER_RANGE_FIELD_NUMBER: _ClassVar[int]
    KEEPALIVE_INTERVAL_FIELD_NUMBER: _ClassVar[int]
    advertise_mode: str
    advertised_groups: _containers.RepeatedScalarFieldContainer[str]
    advertised_ip_ranges: _containers.RepeatedCompositeFieldContainer[RouterAdvertisedIpRange]
    asn: int
    identifier_range: str
    keepalive_interval: int
    def __init__(self, advertise_mode: _Optional[str] = ..., advertised_groups: _Optional[_Iterable[str]] = ..., advertised_ip_ranges: _Optional[_Iterable[_Union[RouterAdvertisedIpRange, _Mapping]]] = ..., asn: _Optional[int] = ..., identifier_range: _Optional[str] = ..., keepalive_interval: _Optional[int] = ...) -> None: ...

class RouterBgpPeer(_message.Message):
    __slots__ = ("advertise_mode", "advertised_groups", "advertised_ip_ranges", "advertised_route_priority", "bfd", "custom_learned_ip_ranges", "custom_learned_route_priority", "enable", "enable_ipv4", "enable_ipv6", "export_policies", "import_policies", "interface_name", "ip_address", "ipv4_nexthop_address", "ipv6_nexthop_address", "management_type", "md5_authentication_key_name", "name", "peer_asn", "peer_ip_address", "peer_ipv4_nexthop_address", "peer_ipv6_nexthop_address", "router_appliance_instance")
    class AdvertiseMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ADVERTISE_MODE: _ClassVar[RouterBgpPeer.AdvertiseMode]
        CUSTOM: _ClassVar[RouterBgpPeer.AdvertiseMode]
        DEFAULT: _ClassVar[RouterBgpPeer.AdvertiseMode]
    UNDEFINED_ADVERTISE_MODE: RouterBgpPeer.AdvertiseMode
    CUSTOM: RouterBgpPeer.AdvertiseMode
    DEFAULT: RouterBgpPeer.AdvertiseMode
    class AdvertisedGroups(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ADVERTISED_GROUPS: _ClassVar[RouterBgpPeer.AdvertisedGroups]
        ALL_SUBNETS: _ClassVar[RouterBgpPeer.AdvertisedGroups]
    UNDEFINED_ADVERTISED_GROUPS: RouterBgpPeer.AdvertisedGroups
    ALL_SUBNETS: RouterBgpPeer.AdvertisedGroups
    class Enable(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ENABLE: _ClassVar[RouterBgpPeer.Enable]
        FALSE: _ClassVar[RouterBgpPeer.Enable]
        TRUE: _ClassVar[RouterBgpPeer.Enable]
    UNDEFINED_ENABLE: RouterBgpPeer.Enable
    FALSE: RouterBgpPeer.Enable
    TRUE: RouterBgpPeer.Enable
    class ManagementType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MANAGEMENT_TYPE: _ClassVar[RouterBgpPeer.ManagementType]
        MANAGED_BY_ATTACHMENT: _ClassVar[RouterBgpPeer.ManagementType]
        MANAGED_BY_USER: _ClassVar[RouterBgpPeer.ManagementType]
    UNDEFINED_MANAGEMENT_TYPE: RouterBgpPeer.ManagementType
    MANAGED_BY_ATTACHMENT: RouterBgpPeer.ManagementType
    MANAGED_BY_USER: RouterBgpPeer.ManagementType
    ADVERTISE_MODE_FIELD_NUMBER: _ClassVar[int]
    ADVERTISED_GROUPS_FIELD_NUMBER: _ClassVar[int]
    ADVERTISED_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    ADVERTISED_ROUTE_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    BFD_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_LEARNED_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_LEARNED_ROUTE_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    ENABLE_IPV4_FIELD_NUMBER: _ClassVar[int]
    ENABLE_IPV6_FIELD_NUMBER: _ClassVar[int]
    EXPORT_POLICIES_FIELD_NUMBER: _ClassVar[int]
    IMPORT_POLICIES_FIELD_NUMBER: _ClassVar[int]
    INTERFACE_NAME_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV4_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    MANAGEMENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    MD5_AUTHENTICATION_KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PEER_ASN_FIELD_NUMBER: _ClassVar[int]
    PEER_IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PEER_IPV4_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PEER_IPV6_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    ROUTER_APPLIANCE_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    advertise_mode: str
    advertised_groups: _containers.RepeatedScalarFieldContainer[str]
    advertised_ip_ranges: _containers.RepeatedCompositeFieldContainer[RouterAdvertisedIpRange]
    advertised_route_priority: int
    bfd: RouterBgpPeerBfd
    custom_learned_ip_ranges: _containers.RepeatedCompositeFieldContainer[RouterBgpPeerCustomLearnedIpRange]
    custom_learned_route_priority: int
    enable: str
    enable_ipv4: bool
    enable_ipv6: bool
    export_policies: _containers.RepeatedScalarFieldContainer[str]
    import_policies: _containers.RepeatedScalarFieldContainer[str]
    interface_name: str
    ip_address: str
    ipv4_nexthop_address: str
    ipv6_nexthop_address: str
    management_type: str
    md5_authentication_key_name: str
    name: str
    peer_asn: int
    peer_ip_address: str
    peer_ipv4_nexthop_address: str
    peer_ipv6_nexthop_address: str
    router_appliance_instance: str
    def __init__(self, advertise_mode: _Optional[str] = ..., advertised_groups: _Optional[_Iterable[str]] = ..., advertised_ip_ranges: _Optional[_Iterable[_Union[RouterAdvertisedIpRange, _Mapping]]] = ..., advertised_route_priority: _Optional[int] = ..., bfd: _Optional[_Union[RouterBgpPeerBfd, _Mapping]] = ..., custom_learned_ip_ranges: _Optional[_Iterable[_Union[RouterBgpPeerCustomLearnedIpRange, _Mapping]]] = ..., custom_learned_route_priority: _Optional[int] = ..., enable: _Optional[str] = ..., enable_ipv4: bool = ..., enable_ipv6: bool = ..., export_policies: _Optional[_Iterable[str]] = ..., import_policies: _Optional[_Iterable[str]] = ..., interface_name: _Optional[str] = ..., ip_address: _Optional[str] = ..., ipv4_nexthop_address: _Optional[str] = ..., ipv6_nexthop_address: _Optional[str] = ..., management_type: _Optional[str] = ..., md5_authentication_key_name: _Optional[str] = ..., name: _Optional[str] = ..., peer_asn: _Optional[int] = ..., peer_ip_address: _Optional[str] = ..., peer_ipv4_nexthop_address: _Optional[str] = ..., peer_ipv6_nexthop_address: _Optional[str] = ..., router_appliance_instance: _Optional[str] = ...) -> None: ...

class RouterBgpPeerBfd(_message.Message):
    __slots__ = ("min_receive_interval", "min_transmit_interval", "multiplier", "session_initialization_mode")
    class SessionInitializationMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SESSION_INITIALIZATION_MODE: _ClassVar[RouterBgpPeerBfd.SessionInitializationMode]
        ACTIVE: _ClassVar[RouterBgpPeerBfd.SessionInitializationMode]
        DISABLED: _ClassVar[RouterBgpPeerBfd.SessionInitializationMode]
        PASSIVE: _ClassVar[RouterBgpPeerBfd.SessionInitializationMode]
    UNDEFINED_SESSION_INITIALIZATION_MODE: RouterBgpPeerBfd.SessionInitializationMode
    ACTIVE: RouterBgpPeerBfd.SessionInitializationMode
    DISABLED: RouterBgpPeerBfd.SessionInitializationMode
    PASSIVE: RouterBgpPeerBfd.SessionInitializationMode
    MIN_RECEIVE_INTERVAL_FIELD_NUMBER: _ClassVar[int]
    MIN_TRANSMIT_INTERVAL_FIELD_NUMBER: _ClassVar[int]
    MULTIPLIER_FIELD_NUMBER: _ClassVar[int]
    SESSION_INITIALIZATION_MODE_FIELD_NUMBER: _ClassVar[int]
    min_receive_interval: int
    min_transmit_interval: int
    multiplier: int
    session_initialization_mode: str
    def __init__(self, min_receive_interval: _Optional[int] = ..., min_transmit_interval: _Optional[int] = ..., multiplier: _Optional[int] = ..., session_initialization_mode: _Optional[str] = ...) -> None: ...

class RouterBgpPeerCustomLearnedIpRange(_message.Message):
    __slots__ = ("range",)
    RANGE_FIELD_NUMBER: _ClassVar[int]
    range: str
    def __init__(self, range: _Optional[str] = ...) -> None: ...

class RouterInterface(_message.Message):
    __slots__ = ("ip_range", "ip_version", "linked_interconnect_attachment", "linked_vpn_tunnel", "management_type", "name", "private_ip_address", "redundant_interface", "subnetwork")
    class IpVersion(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IP_VERSION: _ClassVar[RouterInterface.IpVersion]
        IPV4: _ClassVar[RouterInterface.IpVersion]
        IPV6: _ClassVar[RouterInterface.IpVersion]
    UNDEFINED_IP_VERSION: RouterInterface.IpVersion
    IPV4: RouterInterface.IpVersion
    IPV6: RouterInterface.IpVersion
    class ManagementType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MANAGEMENT_TYPE: _ClassVar[RouterInterface.ManagementType]
        MANAGED_BY_ATTACHMENT: _ClassVar[RouterInterface.ManagementType]
        MANAGED_BY_USER: _ClassVar[RouterInterface.ManagementType]
    UNDEFINED_MANAGEMENT_TYPE: RouterInterface.ManagementType
    MANAGED_BY_ATTACHMENT: RouterInterface.ManagementType
    MANAGED_BY_USER: RouterInterface.ManagementType
    IP_RANGE_FIELD_NUMBER: _ClassVar[int]
    IP_VERSION_FIELD_NUMBER: _ClassVar[int]
    LINKED_INTERCONNECT_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    LINKED_VPN_TUNNEL_FIELD_NUMBER: _ClassVar[int]
    MANAGEMENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    REDUNDANT_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    ip_range: str
    ip_version: str
    linked_interconnect_attachment: str
    linked_vpn_tunnel: str
    management_type: str
    name: str
    private_ip_address: str
    redundant_interface: str
    subnetwork: str
    def __init__(self, ip_range: _Optional[str] = ..., ip_version: _Optional[str] = ..., linked_interconnect_attachment: _Optional[str] = ..., linked_vpn_tunnel: _Optional[str] = ..., management_type: _Optional[str] = ..., name: _Optional[str] = ..., private_ip_address: _Optional[str] = ..., redundant_interface: _Optional[str] = ..., subnetwork: _Optional[str] = ...) -> None: ...

class RouterList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Router]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Router, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class RouterMd5AuthenticationKey(_message.Message):
    __slots__ = ("key", "name")
    KEY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    key: str
    name: str
    def __init__(self, key: _Optional[str] = ..., name: _Optional[str] = ...) -> None: ...

class RouterNat(_message.Message):
    __slots__ = ("auto_network_tier", "drain_nat_ips", "enable_dynamic_port_allocation", "enable_endpoint_independent_mapping", "endpoint_types", "icmp_idle_timeout_sec", "log_config", "max_ports_per_vm", "min_ports_per_vm", "name", "nat_ip_allocate_option", "nat_ips", "rules", "source_subnetwork_ip_ranges_to_nat", "subnetworks", "tcp_established_idle_timeout_sec", "tcp_time_wait_timeout_sec", "tcp_transitory_idle_timeout_sec", "type", "udp_idle_timeout_sec")
    class AutoNetworkTier(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AUTO_NETWORK_TIER: _ClassVar[RouterNat.AutoNetworkTier]
        FIXED_STANDARD: _ClassVar[RouterNat.AutoNetworkTier]
        PREMIUM: _ClassVar[RouterNat.AutoNetworkTier]
        STANDARD: _ClassVar[RouterNat.AutoNetworkTier]
        STANDARD_OVERRIDES_FIXED_STANDARD: _ClassVar[RouterNat.AutoNetworkTier]
    UNDEFINED_AUTO_NETWORK_TIER: RouterNat.AutoNetworkTier
    FIXED_STANDARD: RouterNat.AutoNetworkTier
    PREMIUM: RouterNat.AutoNetworkTier
    STANDARD: RouterNat.AutoNetworkTier
    STANDARD_OVERRIDES_FIXED_STANDARD: RouterNat.AutoNetworkTier
    class EndpointTypes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ENDPOINT_TYPES: _ClassVar[RouterNat.EndpointTypes]
        ENDPOINT_TYPE_MANAGED_PROXY_LB: _ClassVar[RouterNat.EndpointTypes]
        ENDPOINT_TYPE_SWG: _ClassVar[RouterNat.EndpointTypes]
        ENDPOINT_TYPE_VM: _ClassVar[RouterNat.EndpointTypes]
    UNDEFINED_ENDPOINT_TYPES: RouterNat.EndpointTypes
    ENDPOINT_TYPE_MANAGED_PROXY_LB: RouterNat.EndpointTypes
    ENDPOINT_TYPE_SWG: RouterNat.EndpointTypes
    ENDPOINT_TYPE_VM: RouterNat.EndpointTypes
    class NatIpAllocateOption(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NAT_IP_ALLOCATE_OPTION: _ClassVar[RouterNat.NatIpAllocateOption]
        AUTO_ONLY: _ClassVar[RouterNat.NatIpAllocateOption]
        MANUAL_ONLY: _ClassVar[RouterNat.NatIpAllocateOption]
    UNDEFINED_NAT_IP_ALLOCATE_OPTION: RouterNat.NatIpAllocateOption
    AUTO_ONLY: RouterNat.NatIpAllocateOption
    MANUAL_ONLY: RouterNat.NatIpAllocateOption
    class SourceSubnetworkIpRangesToNat(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SOURCE_SUBNETWORK_IP_RANGES_TO_NAT: _ClassVar[RouterNat.SourceSubnetworkIpRangesToNat]
        ALL_SUBNETWORKS_ALL_IP_RANGES: _ClassVar[RouterNat.SourceSubnetworkIpRangesToNat]
        ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES: _ClassVar[RouterNat.SourceSubnetworkIpRangesToNat]
        LIST_OF_SUBNETWORKS: _ClassVar[RouterNat.SourceSubnetworkIpRangesToNat]
    UNDEFINED_SOURCE_SUBNETWORK_IP_RANGES_TO_NAT: RouterNat.SourceSubnetworkIpRangesToNat
    ALL_SUBNETWORKS_ALL_IP_RANGES: RouterNat.SourceSubnetworkIpRangesToNat
    ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES: RouterNat.SourceSubnetworkIpRangesToNat
    LIST_OF_SUBNETWORKS: RouterNat.SourceSubnetworkIpRangesToNat
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[RouterNat.Type]
        PRIVATE: _ClassVar[RouterNat.Type]
        PUBLIC: _ClassVar[RouterNat.Type]
    UNDEFINED_TYPE: RouterNat.Type
    PRIVATE: RouterNat.Type
    PUBLIC: RouterNat.Type
    AUTO_NETWORK_TIER_FIELD_NUMBER: _ClassVar[int]
    DRAIN_NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    ENABLE_DYNAMIC_PORT_ALLOCATION_FIELD_NUMBER: _ClassVar[int]
    ENABLE_ENDPOINT_INDEPENDENT_MAPPING_FIELD_NUMBER: _ClassVar[int]
    ENDPOINT_TYPES_FIELD_NUMBER: _ClassVar[int]
    ICMP_IDLE_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    LOG_CONFIG_FIELD_NUMBER: _ClassVar[int]
    MAX_PORTS_PER_VM_FIELD_NUMBER: _ClassVar[int]
    MIN_PORTS_PER_VM_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NAT_IP_ALLOCATE_OPTION_FIELD_NUMBER: _ClassVar[int]
    NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    RULES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SUBNETWORK_IP_RANGES_TO_NAT_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORKS_FIELD_NUMBER: _ClassVar[int]
    TCP_ESTABLISHED_IDLE_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    TCP_TIME_WAIT_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    TCP_TRANSITORY_IDLE_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    UDP_IDLE_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    auto_network_tier: str
    drain_nat_ips: _containers.RepeatedScalarFieldContainer[str]
    enable_dynamic_port_allocation: bool
    enable_endpoint_independent_mapping: bool
    endpoint_types: _containers.RepeatedScalarFieldContainer[str]
    icmp_idle_timeout_sec: int
    log_config: RouterNatLogConfig
    max_ports_per_vm: int
    min_ports_per_vm: int
    name: str
    nat_ip_allocate_option: str
    nat_ips: _containers.RepeatedScalarFieldContainer[str]
    rules: _containers.RepeatedCompositeFieldContainer[RouterNatRule]
    source_subnetwork_ip_ranges_to_nat: str
    subnetworks: _containers.RepeatedCompositeFieldContainer[RouterNatSubnetworkToNat]
    tcp_established_idle_timeout_sec: int
    tcp_time_wait_timeout_sec: int
    tcp_transitory_idle_timeout_sec: int
    type: str
    udp_idle_timeout_sec: int
    def __init__(self, auto_network_tier: _Optional[str] = ..., drain_nat_ips: _Optional[_Iterable[str]] = ..., enable_dynamic_port_allocation: bool = ..., enable_endpoint_independent_mapping: bool = ..., endpoint_types: _Optional[_Iterable[str]] = ..., icmp_idle_timeout_sec: _Optional[int] = ..., log_config: _Optional[_Union[RouterNatLogConfig, _Mapping]] = ..., max_ports_per_vm: _Optional[int] = ..., min_ports_per_vm: _Optional[int] = ..., name: _Optional[str] = ..., nat_ip_allocate_option: _Optional[str] = ..., nat_ips: _Optional[_Iterable[str]] = ..., rules: _Optional[_Iterable[_Union[RouterNatRule, _Mapping]]] = ..., source_subnetwork_ip_ranges_to_nat: _Optional[str] = ..., subnetworks: _Optional[_Iterable[_Union[RouterNatSubnetworkToNat, _Mapping]]] = ..., tcp_established_idle_timeout_sec: _Optional[int] = ..., tcp_time_wait_timeout_sec: _Optional[int] = ..., tcp_transitory_idle_timeout_sec: _Optional[int] = ..., type: _Optional[str] = ..., udp_idle_timeout_sec: _Optional[int] = ...) -> None: ...

class RouterNatLogConfig(_message.Message):
    __slots__ = ("enable", "filter")
    class Filter(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_FILTER: _ClassVar[RouterNatLogConfig.Filter]
        ALL: _ClassVar[RouterNatLogConfig.Filter]
        ERRORS_ONLY: _ClassVar[RouterNatLogConfig.Filter]
        TRANSLATIONS_ONLY: _ClassVar[RouterNatLogConfig.Filter]
    UNDEFINED_FILTER: RouterNatLogConfig.Filter
    ALL: RouterNatLogConfig.Filter
    ERRORS_ONLY: RouterNatLogConfig.Filter
    TRANSLATIONS_ONLY: RouterNatLogConfig.Filter
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    enable: bool
    filter: str
    def __init__(self, enable: bool = ..., filter: _Optional[str] = ...) -> None: ...

class RouterNatRule(_message.Message):
    __slots__ = ("action", "description", "match", "rule_number")
    ACTION_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    MATCH_FIELD_NUMBER: _ClassVar[int]
    RULE_NUMBER_FIELD_NUMBER: _ClassVar[int]
    action: RouterNatRuleAction
    description: str
    match: str
    rule_number: int
    def __init__(self, action: _Optional[_Union[RouterNatRuleAction, _Mapping]] = ..., description: _Optional[str] = ..., match: _Optional[str] = ..., rule_number: _Optional[int] = ...) -> None: ...

class RouterNatRuleAction(_message.Message):
    __slots__ = ("source_nat_active_ips", "source_nat_active_ranges", "source_nat_drain_ips", "source_nat_drain_ranges")
    SOURCE_NAT_ACTIVE_IPS_FIELD_NUMBER: _ClassVar[int]
    SOURCE_NAT_ACTIVE_RANGES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_NAT_DRAIN_IPS_FIELD_NUMBER: _ClassVar[int]
    SOURCE_NAT_DRAIN_RANGES_FIELD_NUMBER: _ClassVar[int]
    source_nat_active_ips: _containers.RepeatedScalarFieldContainer[str]
    source_nat_active_ranges: _containers.RepeatedScalarFieldContainer[str]
    source_nat_drain_ips: _containers.RepeatedScalarFieldContainer[str]
    source_nat_drain_ranges: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, source_nat_active_ips: _Optional[_Iterable[str]] = ..., source_nat_active_ranges: _Optional[_Iterable[str]] = ..., source_nat_drain_ips: _Optional[_Iterable[str]] = ..., source_nat_drain_ranges: _Optional[_Iterable[str]] = ...) -> None: ...

class RouterNatSubnetworkToNat(_message.Message):
    __slots__ = ("name", "secondary_ip_range_names", "source_ip_ranges_to_nat")
    class SourceIpRangesToNat(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SOURCE_IP_RANGES_TO_NAT: _ClassVar[RouterNatSubnetworkToNat.SourceIpRangesToNat]
        ALL_IP_RANGES: _ClassVar[RouterNatSubnetworkToNat.SourceIpRangesToNat]
        LIST_OF_SECONDARY_IP_RANGES: _ClassVar[RouterNatSubnetworkToNat.SourceIpRangesToNat]
        PRIMARY_IP_RANGE: _ClassVar[RouterNatSubnetworkToNat.SourceIpRangesToNat]
    UNDEFINED_SOURCE_IP_RANGES_TO_NAT: RouterNatSubnetworkToNat.SourceIpRangesToNat
    ALL_IP_RANGES: RouterNatSubnetworkToNat.SourceIpRangesToNat
    LIST_OF_SECONDARY_IP_RANGES: RouterNatSubnetworkToNat.SourceIpRangesToNat
    PRIMARY_IP_RANGE: RouterNatSubnetworkToNat.SourceIpRangesToNat
    NAME_FIELD_NUMBER: _ClassVar[int]
    SECONDARY_IP_RANGE_NAMES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IP_RANGES_TO_NAT_FIELD_NUMBER: _ClassVar[int]
    name: str
    secondary_ip_range_names: _containers.RepeatedScalarFieldContainer[str]
    source_ip_ranges_to_nat: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, name: _Optional[str] = ..., secondary_ip_range_names: _Optional[_Iterable[str]] = ..., source_ip_ranges_to_nat: _Optional[_Iterable[str]] = ...) -> None: ...

class RouterStatus(_message.Message):
    __slots__ = ("best_routes", "best_routes_for_router", "bgp_peer_status", "nat_status", "network")
    BEST_ROUTES_FIELD_NUMBER: _ClassVar[int]
    BEST_ROUTES_FOR_ROUTER_FIELD_NUMBER: _ClassVar[int]
    BGP_PEER_STATUS_FIELD_NUMBER: _ClassVar[int]
    NAT_STATUS_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    best_routes: _containers.RepeatedCompositeFieldContainer[Route]
    best_routes_for_router: _containers.RepeatedCompositeFieldContainer[Route]
    bgp_peer_status: _containers.RepeatedCompositeFieldContainer[RouterStatusBgpPeerStatus]
    nat_status: _containers.RepeatedCompositeFieldContainer[RouterStatusNatStatus]
    network: str
    def __init__(self, best_routes: _Optional[_Iterable[_Union[Route, _Mapping]]] = ..., best_routes_for_router: _Optional[_Iterable[_Union[Route, _Mapping]]] = ..., bgp_peer_status: _Optional[_Iterable[_Union[RouterStatusBgpPeerStatus, _Mapping]]] = ..., nat_status: _Optional[_Iterable[_Union[RouterStatusNatStatus, _Mapping]]] = ..., network: _Optional[str] = ...) -> None: ...

class RouterStatusBgpPeerStatus(_message.Message):
    __slots__ = ("advertised_routes", "bfd_status", "enable_ipv4", "enable_ipv6", "ip_address", "ipv4_nexthop_address", "ipv6_nexthop_address", "linked_vpn_tunnel", "md5_auth_enabled", "name", "num_learned_routes", "peer_ip_address", "peer_ipv4_nexthop_address", "peer_ipv6_nexthop_address", "router_appliance_instance", "state", "status", "status_reason", "uptime", "uptime_seconds")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[RouterStatusBgpPeerStatus.Status]
        DOWN: _ClassVar[RouterStatusBgpPeerStatus.Status]
        UNKNOWN: _ClassVar[RouterStatusBgpPeerStatus.Status]
        UP: _ClassVar[RouterStatusBgpPeerStatus.Status]
    UNDEFINED_STATUS: RouterStatusBgpPeerStatus.Status
    DOWN: RouterStatusBgpPeerStatus.Status
    UNKNOWN: RouterStatusBgpPeerStatus.Status
    UP: RouterStatusBgpPeerStatus.Status
    class StatusReason(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS_REASON: _ClassVar[RouterStatusBgpPeerStatus.StatusReason]
        IPV4_PEER_ON_IPV6_ONLY_CONNECTION: _ClassVar[RouterStatusBgpPeerStatus.StatusReason]
        IPV6_PEER_ON_IPV4_ONLY_CONNECTION: _ClassVar[RouterStatusBgpPeerStatus.StatusReason]
        MD5_AUTH_INTERNAL_PROBLEM: _ClassVar[RouterStatusBgpPeerStatus.StatusReason]
        STATUS_REASON_UNSPECIFIED: _ClassVar[RouterStatusBgpPeerStatus.StatusReason]
    UNDEFINED_STATUS_REASON: RouterStatusBgpPeerStatus.StatusReason
    IPV4_PEER_ON_IPV6_ONLY_CONNECTION: RouterStatusBgpPeerStatus.StatusReason
    IPV6_PEER_ON_IPV4_ONLY_CONNECTION: RouterStatusBgpPeerStatus.StatusReason
    MD5_AUTH_INTERNAL_PROBLEM: RouterStatusBgpPeerStatus.StatusReason
    STATUS_REASON_UNSPECIFIED: RouterStatusBgpPeerStatus.StatusReason
    ADVERTISED_ROUTES_FIELD_NUMBER: _ClassVar[int]
    BFD_STATUS_FIELD_NUMBER: _ClassVar[int]
    ENABLE_IPV4_FIELD_NUMBER: _ClassVar[int]
    ENABLE_IPV6_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV4_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    LINKED_VPN_TUNNEL_FIELD_NUMBER: _ClassVar[int]
    MD5_AUTH_ENABLED_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NUM_LEARNED_ROUTES_FIELD_NUMBER: _ClassVar[int]
    PEER_IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PEER_IPV4_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    PEER_IPV6_NEXTHOP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    ROUTER_APPLIANCE_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STATUS_REASON_FIELD_NUMBER: _ClassVar[int]
    UPTIME_FIELD_NUMBER: _ClassVar[int]
    UPTIME_SECONDS_FIELD_NUMBER: _ClassVar[int]
    advertised_routes: _containers.RepeatedCompositeFieldContainer[Route]
    bfd_status: BfdStatus
    enable_ipv4: bool
    enable_ipv6: bool
    ip_address: str
    ipv4_nexthop_address: str
    ipv6_nexthop_address: str
    linked_vpn_tunnel: str
    md5_auth_enabled: bool
    name: str
    num_learned_routes: int
    peer_ip_address: str
    peer_ipv4_nexthop_address: str
    peer_ipv6_nexthop_address: str
    router_appliance_instance: str
    state: str
    status: str
    status_reason: str
    uptime: str
    uptime_seconds: str
    def __init__(self, advertised_routes: _Optional[_Iterable[_Union[Route, _Mapping]]] = ..., bfd_status: _Optional[_Union[BfdStatus, _Mapping]] = ..., enable_ipv4: bool = ..., enable_ipv6: bool = ..., ip_address: _Optional[str] = ..., ipv4_nexthop_address: _Optional[str] = ..., ipv6_nexthop_address: _Optional[str] = ..., linked_vpn_tunnel: _Optional[str] = ..., md5_auth_enabled: bool = ..., name: _Optional[str] = ..., num_learned_routes: _Optional[int] = ..., peer_ip_address: _Optional[str] = ..., peer_ipv4_nexthop_address: _Optional[str] = ..., peer_ipv6_nexthop_address: _Optional[str] = ..., router_appliance_instance: _Optional[str] = ..., state: _Optional[str] = ..., status: _Optional[str] = ..., status_reason: _Optional[str] = ..., uptime: _Optional[str] = ..., uptime_seconds: _Optional[str] = ...) -> None: ...

class RouterStatusNatStatus(_message.Message):
    __slots__ = ("auto_allocated_nat_ips", "drain_auto_allocated_nat_ips", "drain_user_allocated_nat_ips", "min_extra_nat_ips_needed", "name", "num_vm_endpoints_with_nat_mappings", "rule_status", "user_allocated_nat_ip_resources", "user_allocated_nat_ips")
    AUTO_ALLOCATED_NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    DRAIN_AUTO_ALLOCATED_NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    DRAIN_USER_ALLOCATED_NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    MIN_EXTRA_NAT_IPS_NEEDED_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NUM_VM_ENDPOINTS_WITH_NAT_MAPPINGS_FIELD_NUMBER: _ClassVar[int]
    RULE_STATUS_FIELD_NUMBER: _ClassVar[int]
    USER_ALLOCATED_NAT_IP_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    USER_ALLOCATED_NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    auto_allocated_nat_ips: _containers.RepeatedScalarFieldContainer[str]
    drain_auto_allocated_nat_ips: _containers.RepeatedScalarFieldContainer[str]
    drain_user_allocated_nat_ips: _containers.RepeatedScalarFieldContainer[str]
    min_extra_nat_ips_needed: int
    name: str
    num_vm_endpoints_with_nat_mappings: int
    rule_status: _containers.RepeatedCompositeFieldContainer[RouterStatusNatStatusNatRuleStatus]
    user_allocated_nat_ip_resources: _containers.RepeatedScalarFieldContainer[str]
    user_allocated_nat_ips: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, auto_allocated_nat_ips: _Optional[_Iterable[str]] = ..., drain_auto_allocated_nat_ips: _Optional[_Iterable[str]] = ..., drain_user_allocated_nat_ips: _Optional[_Iterable[str]] = ..., min_extra_nat_ips_needed: _Optional[int] = ..., name: _Optional[str] = ..., num_vm_endpoints_with_nat_mappings: _Optional[int] = ..., rule_status: _Optional[_Iterable[_Union[RouterStatusNatStatusNatRuleStatus, _Mapping]]] = ..., user_allocated_nat_ip_resources: _Optional[_Iterable[str]] = ..., user_allocated_nat_ips: _Optional[_Iterable[str]] = ...) -> None: ...

class RouterStatusNatStatusNatRuleStatus(_message.Message):
    __slots__ = ("active_nat_ips", "drain_nat_ips", "min_extra_ips_needed", "num_vm_endpoints_with_nat_mappings", "rule_number")
    ACTIVE_NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    DRAIN_NAT_IPS_FIELD_NUMBER: _ClassVar[int]
    MIN_EXTRA_IPS_NEEDED_FIELD_NUMBER: _ClassVar[int]
    NUM_VM_ENDPOINTS_WITH_NAT_MAPPINGS_FIELD_NUMBER: _ClassVar[int]
    RULE_NUMBER_FIELD_NUMBER: _ClassVar[int]
    active_nat_ips: _containers.RepeatedScalarFieldContainer[str]
    drain_nat_ips: _containers.RepeatedScalarFieldContainer[str]
    min_extra_ips_needed: int
    num_vm_endpoints_with_nat_mappings: int
    rule_number: int
    def __init__(self, active_nat_ips: _Optional[_Iterable[str]] = ..., drain_nat_ips: _Optional[_Iterable[str]] = ..., min_extra_ips_needed: _Optional[int] = ..., num_vm_endpoints_with_nat_mappings: _Optional[int] = ..., rule_number: _Optional[int] = ...) -> None: ...

class RouterStatusResponse(_message.Message):
    __slots__ = ("kind", "result")
    KIND_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    kind: str
    result: RouterStatus
    def __init__(self, kind: _Optional[str] = ..., result: _Optional[_Union[RouterStatus, _Mapping]] = ...) -> None: ...

class RoutersPreviewResponse(_message.Message):
    __slots__ = ("resource",)
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    resource: Router
    def __init__(self, resource: _Optional[_Union[Router, _Mapping]] = ...) -> None: ...

class RoutersScopedList(_message.Message):
    __slots__ = ("routers", "warning")
    ROUTERS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    routers: _containers.RepeatedCompositeFieldContainer[Router]
    warning: Warning
    def __init__(self, routers: _Optional[_Iterable[_Union[Router, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SSLHealthCheck(_message.Message):
    __slots__ = ("port", "port_name", "port_specification", "proxy_header", "request", "response")
    class PortSpecification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_SPECIFICATION: _ClassVar[SSLHealthCheck.PortSpecification]
        USE_FIXED_PORT: _ClassVar[SSLHealthCheck.PortSpecification]
        USE_NAMED_PORT: _ClassVar[SSLHealthCheck.PortSpecification]
        USE_SERVING_PORT: _ClassVar[SSLHealthCheck.PortSpecification]
    UNDEFINED_PORT_SPECIFICATION: SSLHealthCheck.PortSpecification
    USE_FIXED_PORT: SSLHealthCheck.PortSpecification
    USE_NAMED_PORT: SSLHealthCheck.PortSpecification
    USE_SERVING_PORT: SSLHealthCheck.PortSpecification
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[SSLHealthCheck.ProxyHeader]
        NONE: _ClassVar[SSLHealthCheck.ProxyHeader]
        PROXY_V1: _ClassVar[SSLHealthCheck.ProxyHeader]
    UNDEFINED_PROXY_HEADER: SSLHealthCheck.ProxyHeader
    NONE: SSLHealthCheck.ProxyHeader
    PROXY_V1: SSLHealthCheck.ProxyHeader
    PORT_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_SPECIFICATION_FIELD_NUMBER: _ClassVar[int]
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    REQUEST_FIELD_NUMBER: _ClassVar[int]
    RESPONSE_FIELD_NUMBER: _ClassVar[int]
    port: int
    port_name: str
    port_specification: str
    proxy_header: str
    request: str
    response: str
    def __init__(self, port: _Optional[int] = ..., port_name: _Optional[str] = ..., port_specification: _Optional[str] = ..., proxy_header: _Optional[str] = ..., request: _Optional[str] = ..., response: _Optional[str] = ...) -> None: ...

class SavedAttachedDisk(_message.Message):
    __slots__ = ("auto_delete", "boot", "device_name", "disk_encryption_key", "disk_size_gb", "disk_type", "guest_os_features", "index", "interface", "kind", "licenses", "mode", "source", "storage_bytes", "storage_bytes_status", "type")
    class Interface(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INTERFACE: _ClassVar[SavedAttachedDisk.Interface]
        NVME: _ClassVar[SavedAttachedDisk.Interface]
        SCSI: _ClassVar[SavedAttachedDisk.Interface]
    UNDEFINED_INTERFACE: SavedAttachedDisk.Interface
    NVME: SavedAttachedDisk.Interface
    SCSI: SavedAttachedDisk.Interface
    class Mode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MODE: _ClassVar[SavedAttachedDisk.Mode]
        READ_ONLY: _ClassVar[SavedAttachedDisk.Mode]
        READ_WRITE: _ClassVar[SavedAttachedDisk.Mode]
    UNDEFINED_MODE: SavedAttachedDisk.Mode
    READ_ONLY: SavedAttachedDisk.Mode
    READ_WRITE: SavedAttachedDisk.Mode
    class StorageBytesStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STORAGE_BYTES_STATUS: _ClassVar[SavedAttachedDisk.StorageBytesStatus]
        UPDATING: _ClassVar[SavedAttachedDisk.StorageBytesStatus]
        UP_TO_DATE: _ClassVar[SavedAttachedDisk.StorageBytesStatus]
    UNDEFINED_STORAGE_BYTES_STATUS: SavedAttachedDisk.StorageBytesStatus
    UPDATING: SavedAttachedDisk.StorageBytesStatus
    UP_TO_DATE: SavedAttachedDisk.StorageBytesStatus
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[SavedAttachedDisk.Type]
        PERSISTENT: _ClassVar[SavedAttachedDisk.Type]
        SCRATCH: _ClassVar[SavedAttachedDisk.Type]
    UNDEFINED_TYPE: SavedAttachedDisk.Type
    PERSISTENT: SavedAttachedDisk.Type
    SCRATCH: SavedAttachedDisk.Type
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    BOOT_FIELD_NUMBER: _ClassVar[int]
    DEVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    DISK_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    DISK_TYPE_FIELD_NUMBER: _ClassVar[int]
    GUEST_OS_FEATURES_FIELD_NUMBER: _ClassVar[int]
    INDEX_FIELD_NUMBER: _ClassVar[int]
    INTERFACE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LICENSES_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    STORAGE_BYTES_FIELD_NUMBER: _ClassVar[int]
    STORAGE_BYTES_STATUS_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    auto_delete: bool
    boot: bool
    device_name: str
    disk_encryption_key: CustomerEncryptionKey
    disk_size_gb: int
    disk_type: str
    guest_os_features: _containers.RepeatedCompositeFieldContainer[GuestOsFeature]
    index: int
    interface: str
    kind: str
    licenses: _containers.RepeatedScalarFieldContainer[str]
    mode: str
    source: str
    storage_bytes: int
    storage_bytes_status: str
    type: str
    def __init__(self, auto_delete: bool = ..., boot: bool = ..., device_name: _Optional[str] = ..., disk_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., disk_size_gb: _Optional[int] = ..., disk_type: _Optional[str] = ..., guest_os_features: _Optional[_Iterable[_Union[GuestOsFeature, _Mapping]]] = ..., index: _Optional[int] = ..., interface: _Optional[str] = ..., kind: _Optional[str] = ..., licenses: _Optional[_Iterable[str]] = ..., mode: _Optional[str] = ..., source: _Optional[str] = ..., storage_bytes: _Optional[int] = ..., storage_bytes_status: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class SavedDisk(_message.Message):
    __slots__ = ("architecture", "kind", "source_disk", "storage_bytes", "storage_bytes_status")
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[SavedDisk.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[SavedDisk.Architecture]
        ARM64: _ClassVar[SavedDisk.Architecture]
        X86_64: _ClassVar[SavedDisk.Architecture]
    UNDEFINED_ARCHITECTURE: SavedDisk.Architecture
    ARCHITECTURE_UNSPECIFIED: SavedDisk.Architecture
    ARM64: SavedDisk.Architecture
    X86_64: SavedDisk.Architecture
    class StorageBytesStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STORAGE_BYTES_STATUS: _ClassVar[SavedDisk.StorageBytesStatus]
        UPDATING: _ClassVar[SavedDisk.StorageBytesStatus]
        UP_TO_DATE: _ClassVar[SavedDisk.StorageBytesStatus]
    UNDEFINED_STORAGE_BYTES_STATUS: SavedDisk.StorageBytesStatus
    UPDATING: SavedDisk.StorageBytesStatus
    UP_TO_DATE: SavedDisk.StorageBytesStatus
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_FIELD_NUMBER: _ClassVar[int]
    STORAGE_BYTES_FIELD_NUMBER: _ClassVar[int]
    STORAGE_BYTES_STATUS_FIELD_NUMBER: _ClassVar[int]
    architecture: str
    kind: str
    source_disk: str
    storage_bytes: int
    storage_bytes_status: str
    def __init__(self, architecture: _Optional[str] = ..., kind: _Optional[str] = ..., source_disk: _Optional[str] = ..., storage_bytes: _Optional[int] = ..., storage_bytes_status: _Optional[str] = ...) -> None: ...

class ScalingScheduleStatus(_message.Message):
    __slots__ = ("last_start_time", "next_start_time", "state")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[ScalingScheduleStatus.State]
        ACTIVE: _ClassVar[ScalingScheduleStatus.State]
        DISABLED: _ClassVar[ScalingScheduleStatus.State]
        OBSOLETE: _ClassVar[ScalingScheduleStatus.State]
        READY: _ClassVar[ScalingScheduleStatus.State]
    UNDEFINED_STATE: ScalingScheduleStatus.State
    ACTIVE: ScalingScheduleStatus.State
    DISABLED: ScalingScheduleStatus.State
    OBSOLETE: ScalingScheduleStatus.State
    READY: ScalingScheduleStatus.State
    LAST_START_TIME_FIELD_NUMBER: _ClassVar[int]
    NEXT_START_TIME_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    last_start_time: str
    next_start_time: str
    state: str
    def __init__(self, last_start_time: _Optional[str] = ..., next_start_time: _Optional[str] = ..., state: _Optional[str] = ...) -> None: ...

class Scheduling(_message.Message):
    __slots__ = ("automatic_restart", "availability_domain", "host_error_timeout_seconds", "instance_termination_action", "local_ssd_recovery_timeout", "location_hint", "max_run_duration", "min_node_cpus", "node_affinities", "on_host_maintenance", "on_instance_stop_action", "preemptible", "provisioning_model", "termination_time")
    class InstanceTerminationAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_INSTANCE_TERMINATION_ACTION: _ClassVar[Scheduling.InstanceTerminationAction]
        DELETE: _ClassVar[Scheduling.InstanceTerminationAction]
        INSTANCE_TERMINATION_ACTION_UNSPECIFIED: _ClassVar[Scheduling.InstanceTerminationAction]
        STOP: _ClassVar[Scheduling.InstanceTerminationAction]
    UNDEFINED_INSTANCE_TERMINATION_ACTION: Scheduling.InstanceTerminationAction
    DELETE: Scheduling.InstanceTerminationAction
    INSTANCE_TERMINATION_ACTION_UNSPECIFIED: Scheduling.InstanceTerminationAction
    STOP: Scheduling.InstanceTerminationAction
    class OnHostMaintenance(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ON_HOST_MAINTENANCE: _ClassVar[Scheduling.OnHostMaintenance]
        MIGRATE: _ClassVar[Scheduling.OnHostMaintenance]
        TERMINATE: _ClassVar[Scheduling.OnHostMaintenance]
    UNDEFINED_ON_HOST_MAINTENANCE: Scheduling.OnHostMaintenance
    MIGRATE: Scheduling.OnHostMaintenance
    TERMINATE: Scheduling.OnHostMaintenance
    class ProvisioningModel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROVISIONING_MODEL: _ClassVar[Scheduling.ProvisioningModel]
        SPOT: _ClassVar[Scheduling.ProvisioningModel]
        STANDARD: _ClassVar[Scheduling.ProvisioningModel]
    UNDEFINED_PROVISIONING_MODEL: Scheduling.ProvisioningModel
    SPOT: Scheduling.ProvisioningModel
    STANDARD: Scheduling.ProvisioningModel
    AUTOMATIC_RESTART_FIELD_NUMBER: _ClassVar[int]
    AVAILABILITY_DOMAIN_FIELD_NUMBER: _ClassVar[int]
    HOST_ERROR_TIMEOUT_SECONDS_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_TERMINATION_ACTION_FIELD_NUMBER: _ClassVar[int]
    LOCAL_SSD_RECOVERY_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    LOCATION_HINT_FIELD_NUMBER: _ClassVar[int]
    MAX_RUN_DURATION_FIELD_NUMBER: _ClassVar[int]
    MIN_NODE_CPUS_FIELD_NUMBER: _ClassVar[int]
    NODE_AFFINITIES_FIELD_NUMBER: _ClassVar[int]
    ON_HOST_MAINTENANCE_FIELD_NUMBER: _ClassVar[int]
    ON_INSTANCE_STOP_ACTION_FIELD_NUMBER: _ClassVar[int]
    PREEMPTIBLE_FIELD_NUMBER: _ClassVar[int]
    PROVISIONING_MODEL_FIELD_NUMBER: _ClassVar[int]
    TERMINATION_TIME_FIELD_NUMBER: _ClassVar[int]
    automatic_restart: bool
    availability_domain: int
    host_error_timeout_seconds: int
    instance_termination_action: str
    local_ssd_recovery_timeout: Duration
    location_hint: str
    max_run_duration: Duration
    min_node_cpus: int
    node_affinities: _containers.RepeatedCompositeFieldContainer[SchedulingNodeAffinity]
    on_host_maintenance: str
    on_instance_stop_action: SchedulingOnInstanceStopAction
    preemptible: bool
    provisioning_model: str
    termination_time: str
    def __init__(self, automatic_restart: bool = ..., availability_domain: _Optional[int] = ..., host_error_timeout_seconds: _Optional[int] = ..., instance_termination_action: _Optional[str] = ..., local_ssd_recovery_timeout: _Optional[_Union[Duration, _Mapping]] = ..., location_hint: _Optional[str] = ..., max_run_duration: _Optional[_Union[Duration, _Mapping]] = ..., min_node_cpus: _Optional[int] = ..., node_affinities: _Optional[_Iterable[_Union[SchedulingNodeAffinity, _Mapping]]] = ..., on_host_maintenance: _Optional[str] = ..., on_instance_stop_action: _Optional[_Union[SchedulingOnInstanceStopAction, _Mapping]] = ..., preemptible: bool = ..., provisioning_model: _Optional[str] = ..., termination_time: _Optional[str] = ...) -> None: ...

class SchedulingNodeAffinity(_message.Message):
    __slots__ = ("key", "operator", "values")
    class Operator(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_OPERATOR: _ClassVar[SchedulingNodeAffinity.Operator]
        IN: _ClassVar[SchedulingNodeAffinity.Operator]
        NOT_IN: _ClassVar[SchedulingNodeAffinity.Operator]
        OPERATOR_UNSPECIFIED: _ClassVar[SchedulingNodeAffinity.Operator]
    UNDEFINED_OPERATOR: SchedulingNodeAffinity.Operator
    IN: SchedulingNodeAffinity.Operator
    NOT_IN: SchedulingNodeAffinity.Operator
    OPERATOR_UNSPECIFIED: SchedulingNodeAffinity.Operator
    KEY_FIELD_NUMBER: _ClassVar[int]
    OPERATOR_FIELD_NUMBER: _ClassVar[int]
    VALUES_FIELD_NUMBER: _ClassVar[int]
    key: str
    operator: str
    values: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, key: _Optional[str] = ..., operator: _Optional[str] = ..., values: _Optional[_Iterable[str]] = ...) -> None: ...

class SchedulingOnInstanceStopAction(_message.Message):
    __slots__ = ("discard_local_ssd",)
    DISCARD_LOCAL_SSD_FIELD_NUMBER: _ClassVar[int]
    discard_local_ssd: bool
    def __init__(self, discard_local_ssd: bool = ...) -> None: ...

class ScratchDisks(_message.Message):
    __slots__ = ("disk_gb",)
    DISK_GB_FIELD_NUMBER: _ClassVar[int]
    disk_gb: int
    def __init__(self, disk_gb: _Optional[int] = ...) -> None: ...

class Screenshot(_message.Message):
    __slots__ = ("contents", "kind")
    CONTENTS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    contents: str
    kind: str
    def __init__(self, contents: _Optional[str] = ..., kind: _Optional[str] = ...) -> None: ...

class SecurityPoliciesAggregatedList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: SecurityPoliciesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[SecurityPoliciesScopedList, _Mapping]] = ...) -> None: ...
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.MessageMap[str, SecurityPoliciesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Mapping[str, SecurityPoliciesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SecurityPoliciesListPreconfiguredExpressionSetsResponse(_message.Message):
    __slots__ = ("preconfigured_expression_sets",)
    PRECONFIGURED_EXPRESSION_SETS_FIELD_NUMBER: _ClassVar[int]
    preconfigured_expression_sets: SecurityPoliciesWafConfig
    def __init__(self, preconfigured_expression_sets: _Optional[_Union[SecurityPoliciesWafConfig, _Mapping]] = ...) -> None: ...

class SecurityPoliciesScopedList(_message.Message):
    __slots__ = ("security_policies", "warning")
    SECURITY_POLICIES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    security_policies: _containers.RepeatedCompositeFieldContainer[SecurityPolicy]
    warning: Warning
    def __init__(self, security_policies: _Optional[_Iterable[_Union[SecurityPolicy, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SecurityPoliciesWafConfig(_message.Message):
    __slots__ = ("waf_rules",)
    WAF_RULES_FIELD_NUMBER: _ClassVar[int]
    waf_rules: PreconfiguredWafSet
    def __init__(self, waf_rules: _Optional[_Union[PreconfiguredWafSet, _Mapping]] = ...) -> None: ...

class SecurityPolicy(_message.Message):
    __slots__ = ("adaptive_protection_config", "advanced_options_config", "creation_timestamp", "ddos_protection_config", "description", "fingerprint", "id", "kind", "label_fingerprint", "labels", "name", "recaptcha_options_config", "region", "rules", "self_link", "type", "user_defined_fields")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[SecurityPolicy.Type]
        CLOUD_ARMOR: _ClassVar[SecurityPolicy.Type]
        CLOUD_ARMOR_EDGE: _ClassVar[SecurityPolicy.Type]
        CLOUD_ARMOR_NETWORK: _ClassVar[SecurityPolicy.Type]
    UNDEFINED_TYPE: SecurityPolicy.Type
    CLOUD_ARMOR: SecurityPolicy.Type
    CLOUD_ARMOR_EDGE: SecurityPolicy.Type
    CLOUD_ARMOR_NETWORK: SecurityPolicy.Type
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ADAPTIVE_PROTECTION_CONFIG_FIELD_NUMBER: _ClassVar[int]
    ADVANCED_OPTIONS_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DDOS_PROTECTION_CONFIG_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    RECAPTCHA_OPTIONS_CONFIG_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RULES_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    USER_DEFINED_FIELDS_FIELD_NUMBER: _ClassVar[int]
    adaptive_protection_config: SecurityPolicyAdaptiveProtectionConfig
    advanced_options_config: SecurityPolicyAdvancedOptionsConfig
    creation_timestamp: str
    ddos_protection_config: SecurityPolicyDdosProtectionConfig
    description: str
    fingerprint: str
    id: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    name: str
    recaptcha_options_config: SecurityPolicyRecaptchaOptionsConfig
    region: str
    rules: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRule]
    self_link: str
    type: str
    user_defined_fields: _containers.RepeatedCompositeFieldContainer[SecurityPolicyUserDefinedField]
    def __init__(self, adaptive_protection_config: _Optional[_Union[SecurityPolicyAdaptiveProtectionConfig, _Mapping]] = ..., advanced_options_config: _Optional[_Union[SecurityPolicyAdvancedOptionsConfig, _Mapping]] = ..., creation_timestamp: _Optional[str] = ..., ddos_protection_config: _Optional[_Union[SecurityPolicyDdosProtectionConfig, _Mapping]] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., recaptcha_options_config: _Optional[_Union[SecurityPolicyRecaptchaOptionsConfig, _Mapping]] = ..., region: _Optional[str] = ..., rules: _Optional[_Iterable[_Union[SecurityPolicyRule, _Mapping]]] = ..., self_link: _Optional[str] = ..., type: _Optional[str] = ..., user_defined_fields: _Optional[_Iterable[_Union[SecurityPolicyUserDefinedField, _Mapping]]] = ...) -> None: ...

class SecurityPolicyAdaptiveProtectionConfig(_message.Message):
    __slots__ = ("layer7_ddos_defense_config",)
    LAYER7_DDOS_DEFENSE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    layer7_ddos_defense_config: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
    def __init__(self, layer7_ddos_defense_config: _Optional[_Union[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig, _Mapping]] = ...) -> None: ...

class SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig(_message.Message):
    __slots__ = ("enable", "rule_visibility", "threshold_configs")
    class RuleVisibility(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_RULE_VISIBILITY: _ClassVar[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility]
        PREMIUM: _ClassVar[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility]
        STANDARD: _ClassVar[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility]
    UNDEFINED_RULE_VISIBILITY: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility
    PREMIUM: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility
    STANDARD: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    RULE_VISIBILITY_FIELD_NUMBER: _ClassVar[int]
    THRESHOLD_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    enable: bool
    rule_visibility: str
    threshold_configs: _containers.RepeatedCompositeFieldContainer[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfig]
    def __init__(self, enable: bool = ..., rule_visibility: _Optional[str] = ..., threshold_configs: _Optional[_Iterable[_Union[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfig, _Mapping]]] = ...) -> None: ...

class SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfig(_message.Message):
    __slots__ = ("auto_deploy_confidence_threshold", "auto_deploy_expiration_sec", "auto_deploy_impacted_baseline_threshold", "auto_deploy_load_threshold", "detection_absolute_qps", "detection_load_threshold", "detection_relative_to_baseline_qps", "name", "traffic_granularity_configs")
    AUTO_DEPLOY_CONFIDENCE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    AUTO_DEPLOY_EXPIRATION_SEC_FIELD_NUMBER: _ClassVar[int]
    AUTO_DEPLOY_IMPACTED_BASELINE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    AUTO_DEPLOY_LOAD_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    DETECTION_ABSOLUTE_QPS_FIELD_NUMBER: _ClassVar[int]
    DETECTION_LOAD_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    DETECTION_RELATIVE_TO_BASELINE_QPS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    TRAFFIC_GRANULARITY_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    auto_deploy_confidence_threshold: float
    auto_deploy_expiration_sec: int
    auto_deploy_impacted_baseline_threshold: float
    auto_deploy_load_threshold: float
    detection_absolute_qps: float
    detection_load_threshold: float
    detection_relative_to_baseline_qps: float
    name: str
    traffic_granularity_configs: _containers.RepeatedCompositeFieldContainer[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig]
    def __init__(self, auto_deploy_confidence_threshold: _Optional[float] = ..., auto_deploy_expiration_sec: _Optional[int] = ..., auto_deploy_impacted_baseline_threshold: _Optional[float] = ..., auto_deploy_load_threshold: _Optional[float] = ..., detection_absolute_qps: _Optional[float] = ..., detection_load_threshold: _Optional[float] = ..., detection_relative_to_baseline_qps: _Optional[float] = ..., name: _Optional[str] = ..., traffic_granularity_configs: _Optional[_Iterable[_Union[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig, _Mapping]]] = ...) -> None: ...

class SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig(_message.Message):
    __slots__ = ("enable_each_unique_value", "type", "value")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type]
        HTTP_HEADER_HOST: _ClassVar[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type]
        HTTP_PATH: _ClassVar[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type]
        UNSPECIFIED_TYPE: _ClassVar[SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type]
    UNDEFINED_TYPE: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type
    HTTP_HEADER_HOST: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type
    HTTP_PATH: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type
    UNSPECIFIED_TYPE: SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfigThresholdConfigTrafficGranularityConfig.Type
    ENABLE_EACH_UNIQUE_VALUE_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    enable_each_unique_value: bool
    type: str
    value: str
    def __init__(self, enable_each_unique_value: bool = ..., type: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class SecurityPolicyAdvancedOptionsConfig(_message.Message):
    __slots__ = ("json_custom_config", "json_parsing", "log_level", "user_ip_request_headers")
    class JsonParsing(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_JSON_PARSING: _ClassVar[SecurityPolicyAdvancedOptionsConfig.JsonParsing]
        DISABLED: _ClassVar[SecurityPolicyAdvancedOptionsConfig.JsonParsing]
        STANDARD: _ClassVar[SecurityPolicyAdvancedOptionsConfig.JsonParsing]
        STANDARD_WITH_GRAPHQL: _ClassVar[SecurityPolicyAdvancedOptionsConfig.JsonParsing]
    UNDEFINED_JSON_PARSING: SecurityPolicyAdvancedOptionsConfig.JsonParsing
    DISABLED: SecurityPolicyAdvancedOptionsConfig.JsonParsing
    STANDARD: SecurityPolicyAdvancedOptionsConfig.JsonParsing
    STANDARD_WITH_GRAPHQL: SecurityPolicyAdvancedOptionsConfig.JsonParsing
    class LogLevel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOG_LEVEL: _ClassVar[SecurityPolicyAdvancedOptionsConfig.LogLevel]
        NORMAL: _ClassVar[SecurityPolicyAdvancedOptionsConfig.LogLevel]
        VERBOSE: _ClassVar[SecurityPolicyAdvancedOptionsConfig.LogLevel]
    UNDEFINED_LOG_LEVEL: SecurityPolicyAdvancedOptionsConfig.LogLevel
    NORMAL: SecurityPolicyAdvancedOptionsConfig.LogLevel
    VERBOSE: SecurityPolicyAdvancedOptionsConfig.LogLevel
    JSON_CUSTOM_CONFIG_FIELD_NUMBER: _ClassVar[int]
    JSON_PARSING_FIELD_NUMBER: _ClassVar[int]
    LOG_LEVEL_FIELD_NUMBER: _ClassVar[int]
    USER_IP_REQUEST_HEADERS_FIELD_NUMBER: _ClassVar[int]
    json_custom_config: SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
    json_parsing: str
    log_level: str
    user_ip_request_headers: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, json_custom_config: _Optional[_Union[SecurityPolicyAdvancedOptionsConfigJsonCustomConfig, _Mapping]] = ..., json_parsing: _Optional[str] = ..., log_level: _Optional[str] = ..., user_ip_request_headers: _Optional[_Iterable[str]] = ...) -> None: ...

class SecurityPolicyAdvancedOptionsConfigJsonCustomConfig(_message.Message):
    __slots__ = ("content_types",)
    CONTENT_TYPES_FIELD_NUMBER: _ClassVar[int]
    content_types: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, content_types: _Optional[_Iterable[str]] = ...) -> None: ...

class SecurityPolicyDdosProtectionConfig(_message.Message):
    __slots__ = ("ddos_protection",)
    class DdosProtection(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_DDOS_PROTECTION: _ClassVar[SecurityPolicyDdosProtectionConfig.DdosProtection]
        ADVANCED: _ClassVar[SecurityPolicyDdosProtectionConfig.DdosProtection]
        STANDARD: _ClassVar[SecurityPolicyDdosProtectionConfig.DdosProtection]
    UNDEFINED_DDOS_PROTECTION: SecurityPolicyDdosProtectionConfig.DdosProtection
    ADVANCED: SecurityPolicyDdosProtectionConfig.DdosProtection
    STANDARD: SecurityPolicyDdosProtectionConfig.DdosProtection
    DDOS_PROTECTION_FIELD_NUMBER: _ClassVar[int]
    ddos_protection: str
    def __init__(self, ddos_protection: _Optional[str] = ...) -> None: ...

class SecurityPolicyList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[SecurityPolicy]
    kind: str
    next_page_token: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[SecurityPolicy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SecurityPolicyRecaptchaOptionsConfig(_message.Message):
    __slots__ = ("redirect_site_key",)
    REDIRECT_SITE_KEY_FIELD_NUMBER: _ClassVar[int]
    redirect_site_key: str
    def __init__(self, redirect_site_key: _Optional[str] = ...) -> None: ...

class SecurityPolicyReference(_message.Message):
    __slots__ = ("security_policy",)
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    security_policy: str
    def __init__(self, security_policy: _Optional[str] = ...) -> None: ...

class SecurityPolicyRule(_message.Message):
    __slots__ = ("action", "description", "header_action", "kind", "match", "network_match", "preconfigured_waf_config", "preview", "priority", "rate_limit_options", "redirect_options")
    ACTION_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    HEADER_ACTION_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MATCH_FIELD_NUMBER: _ClassVar[int]
    NETWORK_MATCH_FIELD_NUMBER: _ClassVar[int]
    PRECONFIGURED_WAF_CONFIG_FIELD_NUMBER: _ClassVar[int]
    PREVIEW_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    RATE_LIMIT_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    REDIRECT_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    action: str
    description: str
    header_action: SecurityPolicyRuleHttpHeaderAction
    kind: str
    match: SecurityPolicyRuleMatcher
    network_match: SecurityPolicyRuleNetworkMatcher
    preconfigured_waf_config: SecurityPolicyRulePreconfiguredWafConfig
    preview: bool
    priority: int
    rate_limit_options: SecurityPolicyRuleRateLimitOptions
    redirect_options: SecurityPolicyRuleRedirectOptions
    def __init__(self, action: _Optional[str] = ..., description: _Optional[str] = ..., header_action: _Optional[_Union[SecurityPolicyRuleHttpHeaderAction, _Mapping]] = ..., kind: _Optional[str] = ..., match: _Optional[_Union[SecurityPolicyRuleMatcher, _Mapping]] = ..., network_match: _Optional[_Union[SecurityPolicyRuleNetworkMatcher, _Mapping]] = ..., preconfigured_waf_config: _Optional[_Union[SecurityPolicyRulePreconfiguredWafConfig, _Mapping]] = ..., preview: bool = ..., priority: _Optional[int] = ..., rate_limit_options: _Optional[_Union[SecurityPolicyRuleRateLimitOptions, _Mapping]] = ..., redirect_options: _Optional[_Union[SecurityPolicyRuleRedirectOptions, _Mapping]] = ...) -> None: ...

class SecurityPolicyRuleHttpHeaderAction(_message.Message):
    __slots__ = ("request_headers_to_adds",)
    REQUEST_HEADERS_TO_ADDS_FIELD_NUMBER: _ClassVar[int]
    request_headers_to_adds: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRuleHttpHeaderActionHttpHeaderOption]
    def __init__(self, request_headers_to_adds: _Optional[_Iterable[_Union[SecurityPolicyRuleHttpHeaderActionHttpHeaderOption, _Mapping]]] = ...) -> None: ...

class SecurityPolicyRuleHttpHeaderActionHttpHeaderOption(_message.Message):
    __slots__ = ("header_name", "header_value")
    HEADER_NAME_FIELD_NUMBER: _ClassVar[int]
    HEADER_VALUE_FIELD_NUMBER: _ClassVar[int]
    header_name: str
    header_value: str
    def __init__(self, header_name: _Optional[str] = ..., header_value: _Optional[str] = ...) -> None: ...

class SecurityPolicyRuleMatcher(_message.Message):
    __slots__ = ("config", "expr", "expr_options", "versioned_expr")
    class VersionedExpr(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_VERSIONED_EXPR: _ClassVar[SecurityPolicyRuleMatcher.VersionedExpr]
        SRC_IPS_V1: _ClassVar[SecurityPolicyRuleMatcher.VersionedExpr]
    UNDEFINED_VERSIONED_EXPR: SecurityPolicyRuleMatcher.VersionedExpr
    SRC_IPS_V1: SecurityPolicyRuleMatcher.VersionedExpr
    CONFIG_FIELD_NUMBER: _ClassVar[int]
    EXPR_FIELD_NUMBER: _ClassVar[int]
    EXPR_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    VERSIONED_EXPR_FIELD_NUMBER: _ClassVar[int]
    config: SecurityPolicyRuleMatcherConfig
    expr: Expr
    expr_options: SecurityPolicyRuleMatcherExprOptions
    versioned_expr: str
    def __init__(self, config: _Optional[_Union[SecurityPolicyRuleMatcherConfig, _Mapping]] = ..., expr: _Optional[_Union[Expr, _Mapping]] = ..., expr_options: _Optional[_Union[SecurityPolicyRuleMatcherExprOptions, _Mapping]] = ..., versioned_expr: _Optional[str] = ...) -> None: ...

class SecurityPolicyRuleMatcherConfig(_message.Message):
    __slots__ = ("src_ip_ranges",)
    SRC_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    src_ip_ranges: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, src_ip_ranges: _Optional[_Iterable[str]] = ...) -> None: ...

class SecurityPolicyRuleMatcherExprOptions(_message.Message):
    __slots__ = ("recaptcha_options",)
    RECAPTCHA_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    recaptcha_options: SecurityPolicyRuleMatcherExprOptionsRecaptchaOptions
    def __init__(self, recaptcha_options: _Optional[_Union[SecurityPolicyRuleMatcherExprOptionsRecaptchaOptions, _Mapping]] = ...) -> None: ...

class SecurityPolicyRuleMatcherExprOptionsRecaptchaOptions(_message.Message):
    __slots__ = ("action_token_site_keys", "session_token_site_keys")
    ACTION_TOKEN_SITE_KEYS_FIELD_NUMBER: _ClassVar[int]
    SESSION_TOKEN_SITE_KEYS_FIELD_NUMBER: _ClassVar[int]
    action_token_site_keys: _containers.RepeatedScalarFieldContainer[str]
    session_token_site_keys: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, action_token_site_keys: _Optional[_Iterable[str]] = ..., session_token_site_keys: _Optional[_Iterable[str]] = ...) -> None: ...

class SecurityPolicyRuleNetworkMatcher(_message.Message):
    __slots__ = ("dest_ip_ranges", "dest_ports", "ip_protocols", "src_asns", "src_ip_ranges", "src_ports", "src_region_codes", "user_defined_fields")
    DEST_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    DEST_PORTS_FIELD_NUMBER: _ClassVar[int]
    IP_PROTOCOLS_FIELD_NUMBER: _ClassVar[int]
    SRC_ASNS_FIELD_NUMBER: _ClassVar[int]
    SRC_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    SRC_PORTS_FIELD_NUMBER: _ClassVar[int]
    SRC_REGION_CODES_FIELD_NUMBER: _ClassVar[int]
    USER_DEFINED_FIELDS_FIELD_NUMBER: _ClassVar[int]
    dest_ip_ranges: _containers.RepeatedScalarFieldContainer[str]
    dest_ports: _containers.RepeatedScalarFieldContainer[str]
    ip_protocols: _containers.RepeatedScalarFieldContainer[str]
    src_asns: _containers.RepeatedScalarFieldContainer[int]
    src_ip_ranges: _containers.RepeatedScalarFieldContainer[str]
    src_ports: _containers.RepeatedScalarFieldContainer[str]
    src_region_codes: _containers.RepeatedScalarFieldContainer[str]
    user_defined_fields: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRuleNetworkMatcherUserDefinedFieldMatch]
    def __init__(self, dest_ip_ranges: _Optional[_Iterable[str]] = ..., dest_ports: _Optional[_Iterable[str]] = ..., ip_protocols: _Optional[_Iterable[str]] = ..., src_asns: _Optional[_Iterable[int]] = ..., src_ip_ranges: _Optional[_Iterable[str]] = ..., src_ports: _Optional[_Iterable[str]] = ..., src_region_codes: _Optional[_Iterable[str]] = ..., user_defined_fields: _Optional[_Iterable[_Union[SecurityPolicyRuleNetworkMatcherUserDefinedFieldMatch, _Mapping]]] = ...) -> None: ...

class SecurityPolicyRuleNetworkMatcherUserDefinedFieldMatch(_message.Message):
    __slots__ = ("name", "values")
    NAME_FIELD_NUMBER: _ClassVar[int]
    VALUES_FIELD_NUMBER: _ClassVar[int]
    name: str
    values: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, name: _Optional[str] = ..., values: _Optional[_Iterable[str]] = ...) -> None: ...

class SecurityPolicyRulePreconfiguredWafConfig(_message.Message):
    __slots__ = ("exclusions",)
    EXCLUSIONS_FIELD_NUMBER: _ClassVar[int]
    exclusions: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRulePreconfiguredWafConfigExclusion]
    def __init__(self, exclusions: _Optional[_Iterable[_Union[SecurityPolicyRulePreconfiguredWafConfigExclusion, _Mapping]]] = ...) -> None: ...

class SecurityPolicyRulePreconfiguredWafConfigExclusion(_message.Message):
    __slots__ = ("request_cookies_to_exclude", "request_headers_to_exclude", "request_query_params_to_exclude", "request_uris_to_exclude", "target_rule_ids", "target_rule_set")
    REQUEST_COOKIES_TO_EXCLUDE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_HEADERS_TO_EXCLUDE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_QUERY_PARAMS_TO_EXCLUDE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_URIS_TO_EXCLUDE_FIELD_NUMBER: _ClassVar[int]
    TARGET_RULE_IDS_FIELD_NUMBER: _ClassVar[int]
    TARGET_RULE_SET_FIELD_NUMBER: _ClassVar[int]
    request_cookies_to_exclude: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams]
    request_headers_to_exclude: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams]
    request_query_params_to_exclude: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams]
    request_uris_to_exclude: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams]
    target_rule_ids: _containers.RepeatedScalarFieldContainer[str]
    target_rule_set: str
    def __init__(self, request_cookies_to_exclude: _Optional[_Iterable[_Union[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams, _Mapping]]] = ..., request_headers_to_exclude: _Optional[_Iterable[_Union[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams, _Mapping]]] = ..., request_query_params_to_exclude: _Optional[_Iterable[_Union[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams, _Mapping]]] = ..., request_uris_to_exclude: _Optional[_Iterable[_Union[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams, _Mapping]]] = ..., target_rule_ids: _Optional[_Iterable[str]] = ..., target_rule_set: _Optional[str] = ...) -> None: ...

class SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams(_message.Message):
    __slots__ = ("op", "val")
    class Op(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_OP: _ClassVar[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op]
        CONTAINS: _ClassVar[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op]
        ENDS_WITH: _ClassVar[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op]
        EQUALS: _ClassVar[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op]
        EQUALS_ANY: _ClassVar[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op]
        STARTS_WITH: _ClassVar[SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op]
    UNDEFINED_OP: SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op
    CONTAINS: SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op
    ENDS_WITH: SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op
    EQUALS: SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op
    EQUALS_ANY: SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op
    STARTS_WITH: SecurityPolicyRulePreconfiguredWafConfigExclusionFieldParams.Op
    OP_FIELD_NUMBER: _ClassVar[int]
    VAL_FIELD_NUMBER: _ClassVar[int]
    op: str
    val: str
    def __init__(self, op: _Optional[str] = ..., val: _Optional[str] = ...) -> None: ...

class SecurityPolicyRuleRateLimitOptions(_message.Message):
    __slots__ = ("ban_duration_sec", "ban_threshold", "conform_action", "enforce_on_key", "enforce_on_key_configs", "enforce_on_key_name", "exceed_action", "exceed_redirect_options", "rate_limit_threshold")
    class EnforceOnKey(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ENFORCE_ON_KEY: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        ALL: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        HTTP_COOKIE: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        HTTP_HEADER: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        HTTP_PATH: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        IP: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        REGION_CODE: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        SNI: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        TLS_JA3_FINGERPRINT: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        TLS_JA4_FINGERPRINT: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        USER_IP: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
        XFF_IP: _ClassVar[SecurityPolicyRuleRateLimitOptions.EnforceOnKey]
    UNDEFINED_ENFORCE_ON_KEY: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    ALL: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    HTTP_COOKIE: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    HTTP_HEADER: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    HTTP_PATH: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    IP: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    REGION_CODE: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    SNI: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    TLS_JA3_FINGERPRINT: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    TLS_JA4_FINGERPRINT: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    USER_IP: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    XFF_IP: SecurityPolicyRuleRateLimitOptions.EnforceOnKey
    BAN_DURATION_SEC_FIELD_NUMBER: _ClassVar[int]
    BAN_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    CONFORM_ACTION_FIELD_NUMBER: _ClassVar[int]
    ENFORCE_ON_KEY_FIELD_NUMBER: _ClassVar[int]
    ENFORCE_ON_KEY_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    ENFORCE_ON_KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    EXCEED_ACTION_FIELD_NUMBER: _ClassVar[int]
    EXCEED_REDIRECT_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    RATE_LIMIT_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    ban_duration_sec: int
    ban_threshold: SecurityPolicyRuleRateLimitOptionsThreshold
    conform_action: str
    enforce_on_key: str
    enforce_on_key_configs: _containers.RepeatedCompositeFieldContainer[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig]
    enforce_on_key_name: str
    exceed_action: str
    exceed_redirect_options: SecurityPolicyRuleRedirectOptions
    rate_limit_threshold: SecurityPolicyRuleRateLimitOptionsThreshold
    def __init__(self, ban_duration_sec: _Optional[int] = ..., ban_threshold: _Optional[_Union[SecurityPolicyRuleRateLimitOptionsThreshold, _Mapping]] = ..., conform_action: _Optional[str] = ..., enforce_on_key: _Optional[str] = ..., enforce_on_key_configs: _Optional[_Iterable[_Union[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig, _Mapping]]] = ..., enforce_on_key_name: _Optional[str] = ..., exceed_action: _Optional[str] = ..., exceed_redirect_options: _Optional[_Union[SecurityPolicyRuleRedirectOptions, _Mapping]] = ..., rate_limit_threshold: _Optional[_Union[SecurityPolicyRuleRateLimitOptionsThreshold, _Mapping]] = ...) -> None: ...

class SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig(_message.Message):
    __slots__ = ("enforce_on_key_name", "enforce_on_key_type")
    class EnforceOnKeyType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ENFORCE_ON_KEY_TYPE: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        ALL: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        HTTP_COOKIE: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        HTTP_HEADER: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        HTTP_PATH: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        IP: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        REGION_CODE: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        SNI: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        TLS_JA3_FINGERPRINT: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        TLS_JA4_FINGERPRINT: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        USER_IP: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
        XFF_IP: _ClassVar[SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType]
    UNDEFINED_ENFORCE_ON_KEY_TYPE: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    ALL: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    HTTP_COOKIE: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    HTTP_HEADER: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    HTTP_PATH: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    IP: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    REGION_CODE: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    SNI: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    TLS_JA3_FINGERPRINT: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    TLS_JA4_FINGERPRINT: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    USER_IP: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    XFF_IP: SecurityPolicyRuleRateLimitOptionsEnforceOnKeyConfig.EnforceOnKeyType
    ENFORCE_ON_KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    ENFORCE_ON_KEY_TYPE_FIELD_NUMBER: _ClassVar[int]
    enforce_on_key_name: str
    enforce_on_key_type: str
    def __init__(self, enforce_on_key_name: _Optional[str] = ..., enforce_on_key_type: _Optional[str] = ...) -> None: ...

class SecurityPolicyRuleRateLimitOptionsThreshold(_message.Message):
    __slots__ = ("count", "interval_sec")
    COUNT_FIELD_NUMBER: _ClassVar[int]
    INTERVAL_SEC_FIELD_NUMBER: _ClassVar[int]
    count: int
    interval_sec: int
    def __init__(self, count: _Optional[int] = ..., interval_sec: _Optional[int] = ...) -> None: ...

class SecurityPolicyRuleRedirectOptions(_message.Message):
    __slots__ = ("target", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[SecurityPolicyRuleRedirectOptions.Type]
        EXTERNAL_302: _ClassVar[SecurityPolicyRuleRedirectOptions.Type]
        GOOGLE_RECAPTCHA: _ClassVar[SecurityPolicyRuleRedirectOptions.Type]
    UNDEFINED_TYPE: SecurityPolicyRuleRedirectOptions.Type
    EXTERNAL_302: SecurityPolicyRuleRedirectOptions.Type
    GOOGLE_RECAPTCHA: SecurityPolicyRuleRedirectOptions.Type
    TARGET_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    target: str
    type: str
    def __init__(self, target: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class SecurityPolicyUserDefinedField(_message.Message):
    __slots__ = ("base", "mask", "name", "offset", "size")
    class Base(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_BASE: _ClassVar[SecurityPolicyUserDefinedField.Base]
        IPV4: _ClassVar[SecurityPolicyUserDefinedField.Base]
        IPV6: _ClassVar[SecurityPolicyUserDefinedField.Base]
        TCP: _ClassVar[SecurityPolicyUserDefinedField.Base]
        UDP: _ClassVar[SecurityPolicyUserDefinedField.Base]
    UNDEFINED_BASE: SecurityPolicyUserDefinedField.Base
    IPV4: SecurityPolicyUserDefinedField.Base
    IPV6: SecurityPolicyUserDefinedField.Base
    TCP: SecurityPolicyUserDefinedField.Base
    UDP: SecurityPolicyUserDefinedField.Base
    BASE_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    OFFSET_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    base: str
    mask: str
    name: str
    offset: int
    size: int
    def __init__(self, base: _Optional[str] = ..., mask: _Optional[str] = ..., name: _Optional[str] = ..., offset: _Optional[int] = ..., size: _Optional[int] = ...) -> None: ...

class SecuritySettings(_message.Message):
    __slots__ = ("aws_v4_authentication", "client_tls_policy", "subject_alt_names")
    AWS_V4_AUTHENTICATION_FIELD_NUMBER: _ClassVar[int]
    CLIENT_TLS_POLICY_FIELD_NUMBER: _ClassVar[int]
    SUBJECT_ALT_NAMES_FIELD_NUMBER: _ClassVar[int]
    aws_v4_authentication: AWSV4Signature
    client_tls_policy: str
    subject_alt_names: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, aws_v4_authentication: _Optional[_Union[AWSV4Signature, _Mapping]] = ..., client_tls_policy: _Optional[str] = ..., subject_alt_names: _Optional[_Iterable[str]] = ...) -> None: ...

class SendDiagnosticInterruptInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SendDiagnosticInterruptInstanceResponse(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class SerialPortOutput(_message.Message):
    __slots__ = ("contents", "kind", "next", "self_link", "start")
    CONTENTS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    contents: str
    kind: str
    next: int
    self_link: str
    start: int
    def __init__(self, contents: _Optional[str] = ..., kind: _Optional[str] = ..., next: _Optional[int] = ..., self_link: _Optional[str] = ..., start: _Optional[int] = ...) -> None: ...

class ServerBinding(_message.Message):
    __slots__ = ("type",)
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[ServerBinding.Type]
        RESTART_NODE_ON_ANY_SERVER: _ClassVar[ServerBinding.Type]
        RESTART_NODE_ON_MINIMAL_SERVERS: _ClassVar[ServerBinding.Type]
        SERVER_BINDING_TYPE_UNSPECIFIED: _ClassVar[ServerBinding.Type]
    UNDEFINED_TYPE: ServerBinding.Type
    RESTART_NODE_ON_ANY_SERVER: ServerBinding.Type
    RESTART_NODE_ON_MINIMAL_SERVERS: ServerBinding.Type
    SERVER_BINDING_TYPE_UNSPECIFIED: ServerBinding.Type
    TYPE_FIELD_NUMBER: _ClassVar[int]
    type: str
    def __init__(self, type: _Optional[str] = ...) -> None: ...

class ServiceAccount(_message.Message):
    __slots__ = ("email", "scopes")
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    SCOPES_FIELD_NUMBER: _ClassVar[int]
    email: str
    scopes: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, email: _Optional[str] = ..., scopes: _Optional[_Iterable[str]] = ...) -> None: ...

class ServiceAttachment(_message.Message):
    __slots__ = ("connected_endpoints", "connection_preference", "consumer_accept_lists", "consumer_reject_lists", "creation_timestamp", "description", "domain_names", "enable_proxy_protocol", "fingerprint", "id", "kind", "name", "nat_subnets", "producer_forwarding_rule", "propagated_connection_limit", "psc_service_attachment_id", "reconcile_connections", "region", "self_link", "target_service")
    class ConnectionPreference(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CONNECTION_PREFERENCE: _ClassVar[ServiceAttachment.ConnectionPreference]
        ACCEPT_AUTOMATIC: _ClassVar[ServiceAttachment.ConnectionPreference]
        ACCEPT_MANUAL: _ClassVar[ServiceAttachment.ConnectionPreference]
        CONNECTION_PREFERENCE_UNSPECIFIED: _ClassVar[ServiceAttachment.ConnectionPreference]
    UNDEFINED_CONNECTION_PREFERENCE: ServiceAttachment.ConnectionPreference
    ACCEPT_AUTOMATIC: ServiceAttachment.ConnectionPreference
    ACCEPT_MANUAL: ServiceAttachment.ConnectionPreference
    CONNECTION_PREFERENCE_UNSPECIFIED: ServiceAttachment.ConnectionPreference
    CONNECTED_ENDPOINTS_FIELD_NUMBER: _ClassVar[int]
    CONNECTION_PREFERENCE_FIELD_NUMBER: _ClassVar[int]
    CONSUMER_ACCEPT_LISTS_FIELD_NUMBER: _ClassVar[int]
    CONSUMER_REJECT_LISTS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_NAMES_FIELD_NUMBER: _ClassVar[int]
    ENABLE_PROXY_PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NAT_SUBNETS_FIELD_NUMBER: _ClassVar[int]
    PRODUCER_FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    PROPAGATED_CONNECTION_LIMIT_FIELD_NUMBER: _ClassVar[int]
    PSC_SERVICE_ATTACHMENT_ID_FIELD_NUMBER: _ClassVar[int]
    RECONCILE_CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    TARGET_SERVICE_FIELD_NUMBER: _ClassVar[int]
    connected_endpoints: _containers.RepeatedCompositeFieldContainer[ServiceAttachmentConnectedEndpoint]
    connection_preference: str
    consumer_accept_lists: _containers.RepeatedCompositeFieldContainer[ServiceAttachmentConsumerProjectLimit]
    consumer_reject_lists: _containers.RepeatedScalarFieldContainer[str]
    creation_timestamp: str
    description: str
    domain_names: _containers.RepeatedScalarFieldContainer[str]
    enable_proxy_protocol: bool
    fingerprint: str
    id: int
    kind: str
    name: str
    nat_subnets: _containers.RepeatedScalarFieldContainer[str]
    producer_forwarding_rule: str
    propagated_connection_limit: int
    psc_service_attachment_id: Uint128
    reconcile_connections: bool
    region: str
    self_link: str
    target_service: str
    def __init__(self, connected_endpoints: _Optional[_Iterable[_Union[ServiceAttachmentConnectedEndpoint, _Mapping]]] = ..., connection_preference: _Optional[str] = ..., consumer_accept_lists: _Optional[_Iterable[_Union[ServiceAttachmentConsumerProjectLimit, _Mapping]]] = ..., consumer_reject_lists: _Optional[_Iterable[str]] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., domain_names: _Optional[_Iterable[str]] = ..., enable_proxy_protocol: bool = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., nat_subnets: _Optional[_Iterable[str]] = ..., producer_forwarding_rule: _Optional[str] = ..., propagated_connection_limit: _Optional[int] = ..., psc_service_attachment_id: _Optional[_Union[Uint128, _Mapping]] = ..., reconcile_connections: bool = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., target_service: _Optional[str] = ...) -> None: ...

class ServiceAttachmentAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ServiceAttachmentsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ServiceAttachmentsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, ServiceAttachmentsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, ServiceAttachmentsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ServiceAttachmentConnectedEndpoint(_message.Message):
    __slots__ = ("consumer_network", "endpoint", "propagated_connection_count", "psc_connection_id", "status")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[ServiceAttachmentConnectedEndpoint.Status]
        ACCEPTED: _ClassVar[ServiceAttachmentConnectedEndpoint.Status]
        CLOSED: _ClassVar[ServiceAttachmentConnectedEndpoint.Status]
        NEEDS_ATTENTION: _ClassVar[ServiceAttachmentConnectedEndpoint.Status]
        PENDING: _ClassVar[ServiceAttachmentConnectedEndpoint.Status]
        REJECTED: _ClassVar[ServiceAttachmentConnectedEndpoint.Status]
        STATUS_UNSPECIFIED: _ClassVar[ServiceAttachmentConnectedEndpoint.Status]
    UNDEFINED_STATUS: ServiceAttachmentConnectedEndpoint.Status
    ACCEPTED: ServiceAttachmentConnectedEndpoint.Status
    CLOSED: ServiceAttachmentConnectedEndpoint.Status
    NEEDS_ATTENTION: ServiceAttachmentConnectedEndpoint.Status
    PENDING: ServiceAttachmentConnectedEndpoint.Status
    REJECTED: ServiceAttachmentConnectedEndpoint.Status
    STATUS_UNSPECIFIED: ServiceAttachmentConnectedEndpoint.Status
    CONSUMER_NETWORK_FIELD_NUMBER: _ClassVar[int]
    ENDPOINT_FIELD_NUMBER: _ClassVar[int]
    PROPAGATED_CONNECTION_COUNT_FIELD_NUMBER: _ClassVar[int]
    PSC_CONNECTION_ID_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    consumer_network: str
    endpoint: str
    propagated_connection_count: int
    psc_connection_id: int
    status: str
    def __init__(self, consumer_network: _Optional[str] = ..., endpoint: _Optional[str] = ..., propagated_connection_count: _Optional[int] = ..., psc_connection_id: _Optional[int] = ..., status: _Optional[str] = ...) -> None: ...

class ServiceAttachmentConsumerProjectLimit(_message.Message):
    __slots__ = ("connection_limit", "network_url", "project_id_or_num")
    CONNECTION_LIMIT_FIELD_NUMBER: _ClassVar[int]
    NETWORK_URL_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_OR_NUM_FIELD_NUMBER: _ClassVar[int]
    connection_limit: int
    network_url: str
    project_id_or_num: str
    def __init__(self, connection_limit: _Optional[int] = ..., network_url: _Optional[str] = ..., project_id_or_num: _Optional[str] = ...) -> None: ...

class ServiceAttachmentList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[ServiceAttachment]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[ServiceAttachment, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ServiceAttachmentsScopedList(_message.Message):
    __slots__ = ("service_attachments", "warning")
    SERVICE_ATTACHMENTS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    service_attachments: _containers.RepeatedCompositeFieldContainer[ServiceAttachment]
    warning: Warning
    def __init__(self, service_attachments: _Optional[_Iterable[_Union[ServiceAttachment, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SetBackendServiceTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_ssl_proxies_set_backend_service_request_resource", "target_ssl_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXIES_SET_BACKEND_SERVICE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_ssl_proxies_set_backend_service_request_resource: TargetSslProxiesSetBackendServiceRequest
    target_ssl_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_ssl_proxies_set_backend_service_request_resource: _Optional[_Union[TargetSslProxiesSetBackendServiceRequest, _Mapping]] = ..., target_ssl_proxy: _Optional[str] = ...) -> None: ...

class SetBackendServiceTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_tcp_proxies_set_backend_service_request_resource", "target_tcp_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXIES_SET_BACKEND_SERVICE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_tcp_proxies_set_backend_service_request_resource: TargetTcpProxiesSetBackendServiceRequest
    target_tcp_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_tcp_proxies_set_backend_service_request_resource: _Optional[_Union[TargetTcpProxiesSetBackendServiceRequest, _Mapping]] = ..., target_tcp_proxy: _Optional[str] = ...) -> None: ...

class SetBackupTargetPoolRequest(_message.Message):
    __slots__ = ("failover_ratio", "project", "region", "request_id", "target_pool", "target_reference_resource")
    FAILOVER_RATIO_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    TARGET_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    failover_ratio: float
    project: str
    region: str
    request_id: str
    target_pool: str
    target_reference_resource: TargetReference
    def __init__(self, failover_ratio: _Optional[float] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_pool: _Optional[str] = ..., target_reference_resource: _Optional[_Union[TargetReference, _Mapping]] = ...) -> None: ...

class SetCertificateMapTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_https_proxies_set_certificate_map_request_resource", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXIES_SET_CERTIFICATE_MAP_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_https_proxies_set_certificate_map_request_resource: TargetHttpsProxiesSetCertificateMapRequest
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxies_set_certificate_map_request_resource: _Optional[_Union[TargetHttpsProxiesSetCertificateMapRequest, _Mapping]] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class SetCertificateMapTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_ssl_proxies_set_certificate_map_request_resource", "target_ssl_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXIES_SET_CERTIFICATE_MAP_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_ssl_proxies_set_certificate_map_request_resource: TargetSslProxiesSetCertificateMapRequest
    target_ssl_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_ssl_proxies_set_certificate_map_request_resource: _Optional[_Union[TargetSslProxiesSetCertificateMapRequest, _Mapping]] = ..., target_ssl_proxy: _Optional[str] = ...) -> None: ...

class SetCloudArmorTierProjectRequest(_message.Message):
    __slots__ = ("project", "projects_set_cloud_armor_tier_request_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PROJECTS_SET_CLOUD_ARMOR_TIER_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    projects_set_cloud_armor_tier_request_resource: ProjectsSetCloudArmorTierRequest
    request_id: str
    def __init__(self, project: _Optional[str] = ..., projects_set_cloud_armor_tier_request_resource: _Optional[_Union[ProjectsSetCloudArmorTierRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class SetCommonInstanceMetadataOperationMetadata(_message.Message):
    __slots__ = ("client_operation_id", "per_location_operations")
    class PerLocationOperationsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo, _Mapping]] = ...) -> None: ...
    CLIENT_OPERATION_ID_FIELD_NUMBER: _ClassVar[int]
    PER_LOCATION_OPERATIONS_FIELD_NUMBER: _ClassVar[int]
    client_operation_id: str
    per_location_operations: _containers.MessageMap[str, SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo]
    def __init__(self, client_operation_id: _Optional[str] = ..., per_location_operations: _Optional[_Mapping[str, SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo]] = ...) -> None: ...

class SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo(_message.Message):
    __slots__ = ("error", "state")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State]
        ABANDONED: _ClassVar[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State]
        DONE: _ClassVar[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State]
        FAILED: _ClassVar[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State]
        PROPAGATED: _ClassVar[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State]
        PROPAGATING: _ClassVar[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State]
        UNSPECIFIED: _ClassVar[SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State]
    UNDEFINED_STATE: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State
    ABANDONED: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State
    DONE: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State
    FAILED: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State
    PROPAGATED: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State
    PROPAGATING: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State
    UNSPECIFIED: SetCommonInstanceMetadataOperationMetadataPerLocationOperationInfo.State
    ERROR_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    error: Status
    state: str
    def __init__(self, error: _Optional[_Union[Status, _Mapping]] = ..., state: _Optional[str] = ...) -> None: ...

class SetCommonInstanceMetadataProjectRequest(_message.Message):
    __slots__ = ("metadata_resource", "project", "request_id")
    METADATA_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    metadata_resource: Metadata
    project: str
    request_id: str
    def __init__(self, metadata_resource: _Optional[_Union[Metadata, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class SetDefaultNetworkTierProjectRequest(_message.Message):
    __slots__ = ("project", "projects_set_default_network_tier_request_resource", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PROJECTS_SET_DEFAULT_NETWORK_TIER_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    projects_set_default_network_tier_request_resource: ProjectsSetDefaultNetworkTierRequest
    request_id: str
    def __init__(self, project: _Optional[str] = ..., projects_set_default_network_tier_request_resource: _Optional[_Union[ProjectsSetDefaultNetworkTierRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class SetDeletionProtectionInstanceRequest(_message.Message):
    __slots__ = ("deletion_protection", "project", "request_id", "resource", "zone")
    DELETION_PROTECTION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    deletion_protection: bool
    project: str
    request_id: str
    resource: str
    zone: str
    def __init__(self, deletion_protection: bool = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetDiskAutoDeleteInstanceRequest(_message.Message):
    __slots__ = ("auto_delete", "device_name", "instance", "project", "request_id", "zone")
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    DEVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    auto_delete: bool
    device_name: str
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, auto_delete: bool = ..., device_name: _Optional[str] = ..., instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetEdgeSecurityPolicyBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket", "project", "request_id", "security_policy_reference_resource")
    BACKEND_BUCKET_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_bucket: str
    project: str
    request_id: str
    security_policy_reference_resource: SecurityPolicyReference
    def __init__(self, backend_bucket: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_reference_resource: _Optional[_Union[SecurityPolicyReference, _Mapping]] = ...) -> None: ...

class SetEdgeSecurityPolicyBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "request_id", "security_policy_reference_resource")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    request_id: str
    security_policy_reference_resource: SecurityPolicyReference
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_reference_resource: _Optional[_Union[SecurityPolicyReference, _Mapping]] = ...) -> None: ...

class SetIamPolicyBackendBucketRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyBackendServiceRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyDiskRequest(_message.Message):
    __slots__ = ("project", "resource", "zone", "zone_set_policy_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    zone: str
    zone_set_policy_request_resource: ZoneSetPolicyRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_policy_request_resource: _Optional[_Union[ZoneSetPolicyRequest, _Mapping]] = ...) -> None: ...

class SetIamPolicyFirewallPolicyRequest(_message.Message):
    __slots__ = ("global_organization_set_policy_request_resource", "resource")
    GLOBAL_ORGANIZATION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_organization_set_policy_request_resource: GlobalOrganizationSetPolicyRequest
    resource: str
    def __init__(self, global_organization_set_policy_request_resource: _Optional[_Union[GlobalOrganizationSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyImageRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyInstanceRequest(_message.Message):
    __slots__ = ("project", "resource", "zone", "zone_set_policy_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    zone: str
    zone_set_policy_request_resource: ZoneSetPolicyRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_policy_request_resource: _Optional[_Union[ZoneSetPolicyRequest, _Mapping]] = ...) -> None: ...

class SetIamPolicyInstanceTemplateRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyInstantSnapshotRequest(_message.Message):
    __slots__ = ("project", "resource", "zone", "zone_set_policy_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    zone: str
    zone_set_policy_request_resource: ZoneSetPolicyRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_policy_request_resource: _Optional[_Union[ZoneSetPolicyRequest, _Mapping]] = ...) -> None: ...

class SetIamPolicyLicenseRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyMachineImageRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyNetworkAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyNodeGroupRequest(_message.Message):
    __slots__ = ("project", "resource", "zone", "zone_set_policy_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    zone: str
    zone_set_policy_request_resource: ZoneSetPolicyRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_policy_request_resource: _Optional[_Union[ZoneSetPolicyRequest, _Mapping]] = ...) -> None: ...

class SetIamPolicyNodeTemplateRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyRegionBackendServiceRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyRegionDiskRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyRegionInstantSnapshotRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyReservationRequest(_message.Message):
    __slots__ = ("project", "resource", "zone", "zone_set_policy_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    zone: str
    zone_set_policy_request_resource: ZoneSetPolicyRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_policy_request_resource: _Optional[_Union[ZoneSetPolicyRequest, _Mapping]] = ...) -> None: ...

class SetIamPolicyResourcePolicyRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyServiceAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicySnapshotRequest(_message.Message):
    __slots__ = ("global_set_policy_request_resource", "project", "resource")
    GLOBAL_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_policy_request_resource: GlobalSetPolicyRequest
    project: str
    resource: str
    def __init__(self, global_set_policy_request_resource: _Optional[_Union[GlobalSetPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetIamPolicyStoragePoolRequest(_message.Message):
    __slots__ = ("project", "resource", "zone", "zone_set_policy_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    zone: str
    zone_set_policy_request_resource: ZoneSetPolicyRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_policy_request_resource: _Optional[_Union[ZoneSetPolicyRequest, _Mapping]] = ...) -> None: ...

class SetIamPolicySubnetworkRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_policy_request_resource", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_policy_request_resource: RegionSetPolicyRequest
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_policy_request_resource: _Optional[_Union[RegionSetPolicyRequest, _Mapping]] = ..., resource: _Optional[str] = ...) -> None: ...

class SetInstanceTemplateInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_set_instance_template_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_SET_INSTANCE_TEMPLATE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_set_instance_template_request_resource: InstanceGroupManagersSetInstanceTemplateRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_set_instance_template_request_resource: _Optional[_Union[InstanceGroupManagersSetInstanceTemplateRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetInstanceTemplateRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_set_template_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_SET_TEMPLATE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_set_template_request_resource: RegionInstanceGroupManagersSetTemplateRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_set_template_request_resource: _Optional[_Union[RegionInstanceGroupManagersSetTemplateRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class SetLabelsAddressRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsDiskRequest(_message.Message):
    __slots__ = ("project", "request_id", "resource", "zone", "zone_set_labels_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    resource: str
    zone: str
    zone_set_labels_request_resource: ZoneSetLabelsRequest
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_labels_request_resource: _Optional[_Union[ZoneSetLabelsRequest, _Mapping]] = ...) -> None: ...

class SetLabelsExternalVpnGatewayRequest(_message.Message):
    __slots__ = ("global_set_labels_request_resource", "project", "resource")
    GLOBAL_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_labels_request_resource: GlobalSetLabelsRequest
    project: str
    resource: str
    def __init__(self, global_set_labels_request_resource: _Optional[_Union[GlobalSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsForwardingRuleRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsGlobalAddressRequest(_message.Message):
    __slots__ = ("global_set_labels_request_resource", "project", "resource")
    GLOBAL_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_labels_request_resource: GlobalSetLabelsRequest
    project: str
    resource: str
    def __init__(self, global_set_labels_request_resource: _Optional[_Union[GlobalSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsGlobalForwardingRuleRequest(_message.Message):
    __slots__ = ("global_set_labels_request_resource", "project", "resource")
    GLOBAL_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_labels_request_resource: GlobalSetLabelsRequest
    project: str
    resource: str
    def __init__(self, global_set_labels_request_resource: _Optional[_Union[GlobalSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsImageRequest(_message.Message):
    __slots__ = ("global_set_labels_request_resource", "project", "resource")
    GLOBAL_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_labels_request_resource: GlobalSetLabelsRequest
    project: str
    resource: str
    def __init__(self, global_set_labels_request_resource: _Optional[_Union[GlobalSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_set_labels_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_set_labels_request_resource: InstancesSetLabelsRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_set_labels_request_resource: _Optional[_Union[InstancesSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetLabelsInstantSnapshotRequest(_message.Message):
    __slots__ = ("project", "request_id", "resource", "zone", "zone_set_labels_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    ZONE_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    resource: str
    zone: str
    zone_set_labels_request_resource: ZoneSetLabelsRequest
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ..., zone: _Optional[str] = ..., zone_set_labels_request_resource: _Optional[_Union[ZoneSetLabelsRequest, _Mapping]] = ...) -> None: ...

class SetLabelsInterconnectAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsInterconnectRequest(_message.Message):
    __slots__ = ("global_set_labels_request_resource", "project", "resource")
    GLOBAL_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_labels_request_resource: GlobalSetLabelsRequest
    project: str
    resource: str
    def __init__(self, global_set_labels_request_resource: _Optional[_Union[GlobalSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsRegionDiskRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsRegionInstantSnapshotRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsRegionSecurityPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsSecurityPolicyRequest(_message.Message):
    __slots__ = ("global_set_labels_request_resource", "project", "resource")
    GLOBAL_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_labels_request_resource: GlobalSetLabelsRequest
    project: str
    resource: str
    def __init__(self, global_set_labels_request_resource: _Optional[_Union[GlobalSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsSnapshotRequest(_message.Message):
    __slots__ = ("global_set_labels_request_resource", "project", "resource")
    GLOBAL_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    global_set_labels_request_resource: GlobalSetLabelsRequest
    project: str
    resource: str
    def __init__(self, global_set_labels_request_resource: _Optional[_Union[GlobalSetLabelsRequest, _Mapping]] = ..., project: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsTargetVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetLabelsVpnTunnelRequest(_message.Message):
    __slots__ = ("project", "region", "region_set_labels_request_resource", "request_id", "resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_SET_LABELS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_set_labels_request_resource: RegionSetLabelsRequest
    request_id: str
    resource: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_set_labels_request_resource: _Optional[_Union[RegionSetLabelsRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., resource: _Optional[str] = ...) -> None: ...

class SetMachineResourcesInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_set_machine_resources_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_SET_MACHINE_RESOURCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_set_machine_resources_request_resource: InstancesSetMachineResourcesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_set_machine_resources_request_resource: _Optional[_Union[InstancesSetMachineResourcesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetMachineTypeInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_set_machine_type_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_SET_MACHINE_TYPE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_set_machine_type_request_resource: InstancesSetMachineTypeRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_set_machine_type_request_resource: _Optional[_Union[InstancesSetMachineTypeRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetMetadataInstanceRequest(_message.Message):
    __slots__ = ("instance", "metadata_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    METADATA_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    metadata_resource: Metadata
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., metadata_resource: _Optional[_Union[Metadata, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetMinCpuPlatformInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_set_min_cpu_platform_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_SET_MIN_CPU_PLATFORM_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_set_min_cpu_platform_request_resource: InstancesSetMinCpuPlatformRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_set_min_cpu_platform_request_resource: _Optional[_Union[InstancesSetMinCpuPlatformRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetNameInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_set_name_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_SET_NAME_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_set_name_request_resource: InstancesSetNameRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_set_name_request_resource: _Optional[_Union[InstancesSetNameRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetNamedPortsInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group", "instance_groups_set_named_ports_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUPS_SET_NAMED_PORTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group: str
    instance_groups_set_named_ports_request_resource: InstanceGroupsSetNamedPortsRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group: _Optional[str] = ..., instance_groups_set_named_ports_request_resource: _Optional[_Union[InstanceGroupsSetNamedPortsRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetNamedPortsRegionInstanceGroupRequest(_message.Message):
    __slots__ = ("instance_group", "project", "region", "region_instance_groups_set_named_ports_request_resource", "request_id")
    INSTANCE_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUPS_SET_NAMED_PORTS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group: str
    project: str
    region: str
    region_instance_groups_set_named_ports_request_resource: RegionInstanceGroupsSetNamedPortsRequest
    request_id: str
    def __init__(self, instance_group: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_groups_set_named_ports_request_resource: _Optional[_Union[RegionInstanceGroupsSetNamedPortsRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class SetNodeTemplateNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "node_groups_set_node_template_request_resource", "project", "request_id", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUPS_SET_NODE_TEMPLATE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    node_groups_set_node_template_request_resource: NodeGroupsSetNodeTemplateRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., node_groups_set_node_template_request_resource: _Optional[_Union[NodeGroupsSetNodeTemplateRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetPrivateIpGoogleAccessSubnetworkRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "subnetwork", "subnetworks_set_private_ip_google_access_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORKS_SET_PRIVATE_IP_GOOGLE_ACCESS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    subnetwork: str
    subnetworks_set_private_ip_google_access_request_resource: SubnetworksSetPrivateIpGoogleAccessRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., subnetwork: _Optional[str] = ..., subnetworks_set_private_ip_google_access_request_resource: _Optional[_Union[SubnetworksSetPrivateIpGoogleAccessRequest, _Mapping]] = ...) -> None: ...

class SetProxyHeaderTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_ssl_proxies_set_proxy_header_request_resource", "target_ssl_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXIES_SET_PROXY_HEADER_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_ssl_proxies_set_proxy_header_request_resource: TargetSslProxiesSetProxyHeaderRequest
    target_ssl_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_ssl_proxies_set_proxy_header_request_resource: _Optional[_Union[TargetSslProxiesSetProxyHeaderRequest, _Mapping]] = ..., target_ssl_proxy: _Optional[str] = ...) -> None: ...

class SetProxyHeaderTargetTcpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_tcp_proxies_set_proxy_header_request_resource", "target_tcp_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXIES_SET_PROXY_HEADER_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_TCP_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_tcp_proxies_set_proxy_header_request_resource: TargetTcpProxiesSetProxyHeaderRequest
    target_tcp_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_tcp_proxies_set_proxy_header_request_resource: _Optional[_Union[TargetTcpProxiesSetProxyHeaderRequest, _Mapping]] = ..., target_tcp_proxy: _Optional[str] = ...) -> None: ...

class SetQuicOverrideTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_https_proxies_set_quic_override_request_resource", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXIES_SET_QUIC_OVERRIDE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_https_proxies_set_quic_override_request_resource: TargetHttpsProxiesSetQuicOverrideRequest
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxies_set_quic_override_request_resource: _Optional[_Union[TargetHttpsProxiesSetQuicOverrideRequest, _Mapping]] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class SetSchedulingInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "scheduling_resource", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    scheduling_resource: Scheduling
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., scheduling_resource: _Optional[_Union[Scheduling, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class SetSecurityPolicyBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "request_id", "security_policy_reference_resource")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    request_id: str
    security_policy_reference_resource: SecurityPolicyReference
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_reference_resource: _Optional[_Union[SecurityPolicyReference, _Mapping]] = ...) -> None: ...

class SetSecurityPolicyInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_set_security_policy_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_SET_SECURITY_POLICY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_set_security_policy_request_resource: InstancesSetSecurityPolicyRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_set_security_policy_request_resource: _Optional[_Union[InstancesSetSecurityPolicyRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetSecurityPolicyRegionBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "project", "region", "request_id", "security_policy_reference_resource")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    project: str
    region: str
    request_id: str
    security_policy_reference_resource: SecurityPolicyReference
    def __init__(self, backend_service: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_reference_resource: _Optional[_Union[SecurityPolicyReference, _Mapping]] = ...) -> None: ...

class SetSecurityPolicyTargetInstanceRequest(_message.Message):
    __slots__ = ("project", "request_id", "security_policy_reference_resource", "target_instance", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    security_policy_reference_resource: SecurityPolicyReference
    target_instance: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_reference_resource: _Optional[_Union[SecurityPolicyReference, _Mapping]] = ..., target_instance: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetSecurityPolicyTargetPoolRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "security_policy_reference_resource", "target_pool")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_POOL_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    security_policy_reference_resource: SecurityPolicyReference
    target_pool: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., security_policy_reference_resource: _Optional[_Union[SecurityPolicyReference, _Mapping]] = ..., target_pool: _Optional[str] = ...) -> None: ...

class SetServiceAccountInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_set_service_account_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_SET_SERVICE_ACCOUNT_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_set_service_account_request_resource: InstancesSetServiceAccountRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_set_service_account_request_resource: _Optional[_Union[InstancesSetServiceAccountRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetShieldedInstanceIntegrityPolicyInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "shielded_instance_integrity_policy_resource", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SHIELDED_INSTANCE_INTEGRITY_POLICY_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    shielded_instance_integrity_policy_resource: ShieldedInstanceIntegrityPolicy
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., shielded_instance_integrity_policy_resource: _Optional[_Union[ShieldedInstanceIntegrityPolicy, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class SetSslCertificatesRegionTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "region", "region_target_https_proxies_set_ssl_certificates_request_resource", "request_id", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_TARGET_HTTPS_PROXIES_SET_SSL_CERTIFICATES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_target_https_proxies_set_ssl_certificates_request_resource: RegionTargetHttpsProxiesSetSslCertificatesRequest
    request_id: str
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_target_https_proxies_set_ssl_certificates_request_resource: _Optional[_Union[RegionTargetHttpsProxiesSetSslCertificatesRequest, _Mapping]] = ..., request_id: _Optional[str] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class SetSslCertificatesTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_https_proxies_set_ssl_certificates_request_resource", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXIES_SET_SSL_CERTIFICATES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_https_proxies_set_ssl_certificates_request_resource: TargetHttpsProxiesSetSslCertificatesRequest
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxies_set_ssl_certificates_request_resource: _Optional[_Union[TargetHttpsProxiesSetSslCertificatesRequest, _Mapping]] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class SetSslCertificatesTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_ssl_proxies_set_ssl_certificates_request_resource", "target_ssl_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXIES_SET_SSL_CERTIFICATES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_ssl_proxies_set_ssl_certificates_request_resource: TargetSslProxiesSetSslCertificatesRequest
    target_ssl_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_ssl_proxies_set_ssl_certificates_request_resource: _Optional[_Union[TargetSslProxiesSetSslCertificatesRequest, _Mapping]] = ..., target_ssl_proxy: _Optional[str] = ...) -> None: ...

class SetSslPolicyTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "ssl_policy_reference_resource", "target_https_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    ssl_policy_reference_resource: SslPolicyReference
    target_https_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy_reference_resource: _Optional[_Union[SslPolicyReference, _Mapping]] = ..., target_https_proxy: _Optional[str] = ...) -> None: ...

class SetSslPolicyTargetSslProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "ssl_policy_reference_resource", "target_ssl_proxy")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TARGET_SSL_PROXY_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    ssl_policy_reference_resource: SslPolicyReference
    target_ssl_proxy: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., ssl_policy_reference_resource: _Optional[_Union[SslPolicyReference, _Mapping]] = ..., target_ssl_proxy: _Optional[str] = ...) -> None: ...

class SetTagsInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "tags_resource", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TAGS_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    tags_resource: Tags
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., tags_resource: _Optional[_Union[Tags, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class SetTargetForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "project", "region", "request_id", "target_reference_resource")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    project: str
    region: str
    request_id: str
    target_reference_resource: TargetReference
    def __init__(self, forwarding_rule: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_reference_resource: _Optional[_Union[TargetReference, _Mapping]] = ...) -> None: ...

class SetTargetGlobalForwardingRuleRequest(_message.Message):
    __slots__ = ("forwarding_rule", "project", "request_id", "target_reference_resource")
    FORWARDING_RULE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    forwarding_rule: str
    project: str
    request_id: str
    target_reference_resource: TargetReference
    def __init__(self, forwarding_rule: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_reference_resource: _Optional[_Union[TargetReference, _Mapping]] = ...) -> None: ...

class SetTargetPoolsInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_set_target_pools_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_SET_TARGET_POOLS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_set_target_pools_request_resource: InstanceGroupManagersSetTargetPoolsRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_set_target_pools_request_resource: _Optional[_Union[InstanceGroupManagersSetTargetPoolsRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SetTargetPoolsRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_set_target_pools_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_SET_TARGET_POOLS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_set_target_pools_request_resource: RegionInstanceGroupManagersSetTargetPoolsRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_set_target_pools_request_resource: _Optional[_Union[RegionInstanceGroupManagersSetTargetPoolsRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class SetUrlMapRegionTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_http_proxy", "url_map_reference_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_http_proxy: str
    url_map_reference_resource: UrlMapReference
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_http_proxy: _Optional[str] = ..., url_map_reference_resource: _Optional[_Union[UrlMapReference, _Mapping]] = ...) -> None: ...

class SetUrlMapRegionTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "target_https_proxy", "url_map_reference_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    target_https_proxy: str
    url_map_reference_resource: UrlMapReference
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy: _Optional[str] = ..., url_map_reference_resource: _Optional[_Union[UrlMapReference, _Mapping]] = ...) -> None: ...

class SetUrlMapTargetHttpProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_http_proxy", "url_map_reference_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTP_PROXY_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_http_proxy: str
    url_map_reference_resource: UrlMapReference
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_http_proxy: _Optional[str] = ..., url_map_reference_resource: _Optional[_Union[UrlMapReference, _Mapping]] = ...) -> None: ...

class SetUrlMapTargetHttpsProxyRequest(_message.Message):
    __slots__ = ("project", "request_id", "target_https_proxy", "url_map_reference_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_HTTPS_PROXY_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_REFERENCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    target_https_proxy: str
    url_map_reference_resource: UrlMapReference
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., target_https_proxy: _Optional[str] = ..., url_map_reference_resource: _Optional[_Union[UrlMapReference, _Mapping]] = ...) -> None: ...

class SetUsageExportBucketProjectRequest(_message.Message):
    __slots__ = ("project", "request_id", "usage_export_location_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    USAGE_EXPORT_LOCATION_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    usage_export_location_resource: UsageExportLocation
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., usage_export_location_resource: _Optional[_Union[UsageExportLocation, _Mapping]] = ...) -> None: ...

class ShareSettings(_message.Message):
    __slots__ = ("project_map", "share_type")
    class ShareType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SHARE_TYPE: _ClassVar[ShareSettings.ShareType]
        LOCAL: _ClassVar[ShareSettings.ShareType]
        ORGANIZATION: _ClassVar[ShareSettings.ShareType]
        SHARE_TYPE_UNSPECIFIED: _ClassVar[ShareSettings.ShareType]
        SPECIFIC_PROJECTS: _ClassVar[ShareSettings.ShareType]
    UNDEFINED_SHARE_TYPE: ShareSettings.ShareType
    LOCAL: ShareSettings.ShareType
    ORGANIZATION: ShareSettings.ShareType
    SHARE_TYPE_UNSPECIFIED: ShareSettings.ShareType
    SPECIFIC_PROJECTS: ShareSettings.ShareType
    class ProjectMapEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ShareSettingsProjectConfig
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ShareSettingsProjectConfig, _Mapping]] = ...) -> None: ...
    PROJECT_MAP_FIELD_NUMBER: _ClassVar[int]
    SHARE_TYPE_FIELD_NUMBER: _ClassVar[int]
    project_map: _containers.MessageMap[str, ShareSettingsProjectConfig]
    share_type: str
    def __init__(self, project_map: _Optional[_Mapping[str, ShareSettingsProjectConfig]] = ..., share_type: _Optional[str] = ...) -> None: ...

class ShareSettingsProjectConfig(_message.Message):
    __slots__ = ("project_id",)
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    project_id: str
    def __init__(self, project_id: _Optional[str] = ...) -> None: ...

class ShieldedInstanceConfig(_message.Message):
    __slots__ = ("enable_integrity_monitoring", "enable_secure_boot", "enable_vtpm")
    ENABLE_INTEGRITY_MONITORING_FIELD_NUMBER: _ClassVar[int]
    ENABLE_SECURE_BOOT_FIELD_NUMBER: _ClassVar[int]
    ENABLE_VTPM_FIELD_NUMBER: _ClassVar[int]
    enable_integrity_monitoring: bool
    enable_secure_boot: bool
    enable_vtpm: bool
    def __init__(self, enable_integrity_monitoring: bool = ..., enable_secure_boot: bool = ..., enable_vtpm: bool = ...) -> None: ...

class ShieldedInstanceIdentity(_message.Message):
    __slots__ = ("encryption_key", "kind", "signing_key")
    ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    SIGNING_KEY_FIELD_NUMBER: _ClassVar[int]
    encryption_key: ShieldedInstanceIdentityEntry
    kind: str
    signing_key: ShieldedInstanceIdentityEntry
    def __init__(self, encryption_key: _Optional[_Union[ShieldedInstanceIdentityEntry, _Mapping]] = ..., kind: _Optional[str] = ..., signing_key: _Optional[_Union[ShieldedInstanceIdentityEntry, _Mapping]] = ...) -> None: ...

class ShieldedInstanceIdentityEntry(_message.Message):
    __slots__ = ("ek_cert", "ek_pub")
    EK_CERT_FIELD_NUMBER: _ClassVar[int]
    EK_PUB_FIELD_NUMBER: _ClassVar[int]
    ek_cert: str
    ek_pub: str
    def __init__(self, ek_cert: _Optional[str] = ..., ek_pub: _Optional[str] = ...) -> None: ...

class ShieldedInstanceIntegrityPolicy(_message.Message):
    __slots__ = ("update_auto_learn_policy",)
    UPDATE_AUTO_LEARN_POLICY_FIELD_NUMBER: _ClassVar[int]
    update_auto_learn_policy: bool
    def __init__(self, update_auto_learn_policy: bool = ...) -> None: ...

class SignedUrlKey(_message.Message):
    __slots__ = ("key_name", "key_value")
    KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    KEY_VALUE_FIELD_NUMBER: _ClassVar[int]
    key_name: str
    key_value: str
    def __init__(self, key_name: _Optional[str] = ..., key_value: _Optional[str] = ...) -> None: ...

class SimulateMaintenanceEventInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "with_extended_notifications", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    WITH_EXTENDED_NOTIFICATIONS_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    with_extended_notifications: bool
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., with_extended_notifications: bool = ..., zone: _Optional[str] = ...) -> None: ...

class SimulateMaintenanceEventNodeGroupRequest(_message.Message):
    __slots__ = ("node_group", "node_groups_simulate_maintenance_event_request_resource", "project", "request_id", "zone")
    NODE_GROUP_FIELD_NUMBER: _ClassVar[int]
    NODE_GROUPS_SIMULATE_MAINTENANCE_EVENT_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    node_group: str
    node_groups_simulate_maintenance_event_request_resource: NodeGroupsSimulateMaintenanceEventRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, node_group: _Optional[str] = ..., node_groups_simulate_maintenance_event_request_resource: _Optional[_Union[NodeGroupsSimulateMaintenanceEventRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class Snapshot(_message.Message):
    __slots__ = ("architecture", "auto_created", "chain_name", "creation_size_bytes", "creation_timestamp", "description", "disk_size_gb", "download_bytes", "enable_confidential_compute", "guest_os_features", "id", "kind", "label_fingerprint", "labels", "license_codes", "licenses", "location_hint", "name", "satisfies_pzi", "satisfies_pzs", "self_link", "snapshot_encryption_key", "snapshot_type", "source_disk", "source_disk_encryption_key", "source_disk_for_recovery_checkpoint", "source_disk_id", "source_instant_snapshot", "source_instant_snapshot_encryption_key", "source_instant_snapshot_id", "source_snapshot_schedule_policy", "source_snapshot_schedule_policy_id", "status", "storage_bytes", "storage_bytes_status", "storage_locations")
    class Architecture(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ARCHITECTURE: _ClassVar[Snapshot.Architecture]
        ARCHITECTURE_UNSPECIFIED: _ClassVar[Snapshot.Architecture]
        ARM64: _ClassVar[Snapshot.Architecture]
        X86_64: _ClassVar[Snapshot.Architecture]
    UNDEFINED_ARCHITECTURE: Snapshot.Architecture
    ARCHITECTURE_UNSPECIFIED: Snapshot.Architecture
    ARM64: Snapshot.Architecture
    X86_64: Snapshot.Architecture
    class SnapshotType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SNAPSHOT_TYPE: _ClassVar[Snapshot.SnapshotType]
        ARCHIVE: _ClassVar[Snapshot.SnapshotType]
        STANDARD: _ClassVar[Snapshot.SnapshotType]
    UNDEFINED_SNAPSHOT_TYPE: Snapshot.SnapshotType
    ARCHIVE: Snapshot.SnapshotType
    STANDARD: Snapshot.SnapshotType
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Snapshot.Status]
        CREATING: _ClassVar[Snapshot.Status]
        DELETING: _ClassVar[Snapshot.Status]
        FAILED: _ClassVar[Snapshot.Status]
        READY: _ClassVar[Snapshot.Status]
        UPLOADING: _ClassVar[Snapshot.Status]
    UNDEFINED_STATUS: Snapshot.Status
    CREATING: Snapshot.Status
    DELETING: Snapshot.Status
    FAILED: Snapshot.Status
    READY: Snapshot.Status
    UPLOADING: Snapshot.Status
    class StorageBytesStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STORAGE_BYTES_STATUS: _ClassVar[Snapshot.StorageBytesStatus]
        UPDATING: _ClassVar[Snapshot.StorageBytesStatus]
        UP_TO_DATE: _ClassVar[Snapshot.StorageBytesStatus]
    UNDEFINED_STORAGE_BYTES_STATUS: Snapshot.StorageBytesStatus
    UPDATING: Snapshot.StorageBytesStatus
    UP_TO_DATE: Snapshot.StorageBytesStatus
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ARCHITECTURE_FIELD_NUMBER: _ClassVar[int]
    AUTO_CREATED_FIELD_NUMBER: _ClassVar[int]
    CHAIN_NAME_FIELD_NUMBER: _ClassVar[int]
    CREATION_SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISK_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    DOWNLOAD_BYTES_FIELD_NUMBER: _ClassVar[int]
    ENABLE_CONFIDENTIAL_COMPUTE_FIELD_NUMBER: _ClassVar[int]
    GUEST_OS_FEATURES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LICENSE_CODES_FIELD_NUMBER: _ClassVar[int]
    LICENSES_FIELD_NUMBER: _ClassVar[int]
    LOCATION_HINT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZI_FIELD_NUMBER: _ClassVar[int]
    SATISFIES_PZS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_TYPE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_FOR_RECOVERY_CHECKPOINT_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANT_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANT_SNAPSHOT_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_INSTANT_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_SCHEDULE_POLICY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SNAPSHOT_SCHEDULE_POLICY_ID_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_BYTES_FIELD_NUMBER: _ClassVar[int]
    STORAGE_BYTES_STATUS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    architecture: str
    auto_created: bool
    chain_name: str
    creation_size_bytes: int
    creation_timestamp: str
    description: str
    disk_size_gb: int
    download_bytes: int
    enable_confidential_compute: bool
    guest_os_features: _containers.RepeatedCompositeFieldContainer[GuestOsFeature]
    id: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    license_codes: _containers.RepeatedScalarFieldContainer[int]
    licenses: _containers.RepeatedScalarFieldContainer[str]
    location_hint: str
    name: str
    satisfies_pzi: bool
    satisfies_pzs: bool
    self_link: str
    snapshot_encryption_key: CustomerEncryptionKey
    snapshot_type: str
    source_disk: str
    source_disk_encryption_key: CustomerEncryptionKey
    source_disk_for_recovery_checkpoint: str
    source_disk_id: str
    source_instant_snapshot: str
    source_instant_snapshot_encryption_key: CustomerEncryptionKey
    source_instant_snapshot_id: str
    source_snapshot_schedule_policy: str
    source_snapshot_schedule_policy_id: str
    status: str
    storage_bytes: int
    storage_bytes_status: str
    storage_locations: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, architecture: _Optional[str] = ..., auto_created: bool = ..., chain_name: _Optional[str] = ..., creation_size_bytes: _Optional[int] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., disk_size_gb: _Optional[int] = ..., download_bytes: _Optional[int] = ..., enable_confidential_compute: bool = ..., guest_os_features: _Optional[_Iterable[_Union[GuestOsFeature, _Mapping]]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., license_codes: _Optional[_Iterable[int]] = ..., licenses: _Optional[_Iterable[str]] = ..., location_hint: _Optional[str] = ..., name: _Optional[str] = ..., satisfies_pzi: bool = ..., satisfies_pzs: bool = ..., self_link: _Optional[str] = ..., snapshot_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., snapshot_type: _Optional[str] = ..., source_disk: _Optional[str] = ..., source_disk_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_disk_for_recovery_checkpoint: _Optional[str] = ..., source_disk_id: _Optional[str] = ..., source_instant_snapshot: _Optional[str] = ..., source_instant_snapshot_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_instant_snapshot_id: _Optional[str] = ..., source_snapshot_schedule_policy: _Optional[str] = ..., source_snapshot_schedule_policy_id: _Optional[str] = ..., status: _Optional[str] = ..., storage_bytes: _Optional[int] = ..., storage_bytes_status: _Optional[str] = ..., storage_locations: _Optional[_Iterable[str]] = ...) -> None: ...

class SnapshotList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Snapshot]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Snapshot, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SnapshotSettings(_message.Message):
    __slots__ = ("storage_location",)
    STORAGE_LOCATION_FIELD_NUMBER: _ClassVar[int]
    storage_location: SnapshotSettingsStorageLocationSettings
    def __init__(self, storage_location: _Optional[_Union[SnapshotSettingsStorageLocationSettings, _Mapping]] = ...) -> None: ...

class SnapshotSettingsStorageLocationSettings(_message.Message):
    __slots__ = ("locations", "policy")
    class Policy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_POLICY: _ClassVar[SnapshotSettingsStorageLocationSettings.Policy]
        LOCAL_REGION: _ClassVar[SnapshotSettingsStorageLocationSettings.Policy]
        NEAREST_MULTI_REGION: _ClassVar[SnapshotSettingsStorageLocationSettings.Policy]
        SPECIFIC_LOCATIONS: _ClassVar[SnapshotSettingsStorageLocationSettings.Policy]
        STORAGE_LOCATION_POLICY_UNSPECIFIED: _ClassVar[SnapshotSettingsStorageLocationSettings.Policy]
    UNDEFINED_POLICY: SnapshotSettingsStorageLocationSettings.Policy
    LOCAL_REGION: SnapshotSettingsStorageLocationSettings.Policy
    NEAREST_MULTI_REGION: SnapshotSettingsStorageLocationSettings.Policy
    SPECIFIC_LOCATIONS: SnapshotSettingsStorageLocationSettings.Policy
    STORAGE_LOCATION_POLICY_UNSPECIFIED: SnapshotSettingsStorageLocationSettings.Policy
    class LocationsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: SnapshotSettingsStorageLocationSettingsStorageLocationPreference
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[SnapshotSettingsStorageLocationSettingsStorageLocationPreference, _Mapping]] = ...) -> None: ...
    LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    POLICY_FIELD_NUMBER: _ClassVar[int]
    locations: _containers.MessageMap[str, SnapshotSettingsStorageLocationSettingsStorageLocationPreference]
    policy: str
    def __init__(self, locations: _Optional[_Mapping[str, SnapshotSettingsStorageLocationSettingsStorageLocationPreference]] = ..., policy: _Optional[str] = ...) -> None: ...

class SnapshotSettingsStorageLocationSettingsStorageLocationPreference(_message.Message):
    __slots__ = ("name",)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class SourceDiskEncryptionKey(_message.Message):
    __slots__ = ("disk_encryption_key", "source_disk")
    DISK_ENCRYPTION_KEY_FIELD_NUMBER: _ClassVar[int]
    SOURCE_DISK_FIELD_NUMBER: _ClassVar[int]
    disk_encryption_key: CustomerEncryptionKey
    source_disk: str
    def __init__(self, disk_encryption_key: _Optional[_Union[CustomerEncryptionKey, _Mapping]] = ..., source_disk: _Optional[str] = ...) -> None: ...

class SourceInstanceParams(_message.Message):
    __slots__ = ("disk_configs",)
    DISK_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    disk_configs: _containers.RepeatedCompositeFieldContainer[DiskInstantiationConfig]
    def __init__(self, disk_configs: _Optional[_Iterable[_Union[DiskInstantiationConfig, _Mapping]]] = ...) -> None: ...

class SourceInstanceProperties(_message.Message):
    __slots__ = ("can_ip_forward", "deletion_protection", "description", "disks", "guest_accelerators", "key_revocation_action_type", "labels", "machine_type", "metadata", "min_cpu_platform", "network_interfaces", "scheduling", "service_accounts", "tags")
    class KeyRevocationActionType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_KEY_REVOCATION_ACTION_TYPE: _ClassVar[SourceInstanceProperties.KeyRevocationActionType]
        KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED: _ClassVar[SourceInstanceProperties.KeyRevocationActionType]
        NONE: _ClassVar[SourceInstanceProperties.KeyRevocationActionType]
        STOP: _ClassVar[SourceInstanceProperties.KeyRevocationActionType]
    UNDEFINED_KEY_REVOCATION_ACTION_TYPE: SourceInstanceProperties.KeyRevocationActionType
    KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED: SourceInstanceProperties.KeyRevocationActionType
    NONE: SourceInstanceProperties.KeyRevocationActionType
    STOP: SourceInstanceProperties.KeyRevocationActionType
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CAN_IP_FORWARD_FIELD_NUMBER: _ClassVar[int]
    DELETION_PROTECTION_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DISKS_FIELD_NUMBER: _ClassVar[int]
    GUEST_ACCELERATORS_FIELD_NUMBER: _ClassVar[int]
    KEY_REVOCATION_ACTION_TYPE_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    MIN_CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACES_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    can_ip_forward: bool
    deletion_protection: bool
    description: str
    disks: _containers.RepeatedCompositeFieldContainer[SavedAttachedDisk]
    guest_accelerators: _containers.RepeatedCompositeFieldContainer[AcceleratorConfig]
    key_revocation_action_type: str
    labels: _containers.ScalarMap[str, str]
    machine_type: str
    metadata: Metadata
    min_cpu_platform: str
    network_interfaces: _containers.RepeatedCompositeFieldContainer[NetworkInterface]
    scheduling: Scheduling
    service_accounts: _containers.RepeatedCompositeFieldContainer[ServiceAccount]
    tags: Tags
    def __init__(self, can_ip_forward: bool = ..., deletion_protection: bool = ..., description: _Optional[str] = ..., disks: _Optional[_Iterable[_Union[SavedAttachedDisk, _Mapping]]] = ..., guest_accelerators: _Optional[_Iterable[_Union[AcceleratorConfig, _Mapping]]] = ..., key_revocation_action_type: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., machine_type: _Optional[str] = ..., metadata: _Optional[_Union[Metadata, _Mapping]] = ..., min_cpu_platform: _Optional[str] = ..., network_interfaces: _Optional[_Iterable[_Union[NetworkInterface, _Mapping]]] = ..., scheduling: _Optional[_Union[Scheduling, _Mapping]] = ..., service_accounts: _Optional[_Iterable[_Union[ServiceAccount, _Mapping]]] = ..., tags: _Optional[_Union[Tags, _Mapping]] = ...) -> None: ...

class SslCertificate(_message.Message):
    __slots__ = ("certificate", "creation_timestamp", "description", "expire_time", "id", "kind", "managed", "name", "private_key", "region", "self_link", "self_managed", "subject_alternative_names", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[SslCertificate.Type]
        MANAGED: _ClassVar[SslCertificate.Type]
        SELF_MANAGED: _ClassVar[SslCertificate.Type]
        TYPE_UNSPECIFIED: _ClassVar[SslCertificate.Type]
    UNDEFINED_TYPE: SslCertificate.Type
    MANAGED: SslCertificate.Type
    SELF_MANAGED: SslCertificate.Type
    TYPE_UNSPECIFIED: SslCertificate.Type
    CERTIFICATE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    EXPIRE_TIME_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MANAGED_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_KEY_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_MANAGED_FIELD_NUMBER: _ClassVar[int]
    SUBJECT_ALTERNATIVE_NAMES_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    certificate: str
    creation_timestamp: str
    description: str
    expire_time: str
    id: int
    kind: str
    managed: SslCertificateManagedSslCertificate
    name: str
    private_key: str
    region: str
    self_link: str
    self_managed: SslCertificateSelfManagedSslCertificate
    subject_alternative_names: _containers.RepeatedScalarFieldContainer[str]
    type: str
    def __init__(self, certificate: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., expire_time: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., managed: _Optional[_Union[SslCertificateManagedSslCertificate, _Mapping]] = ..., name: _Optional[str] = ..., private_key: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., self_managed: _Optional[_Union[SslCertificateSelfManagedSslCertificate, _Mapping]] = ..., subject_alternative_names: _Optional[_Iterable[str]] = ..., type: _Optional[str] = ...) -> None: ...

class SslCertificateAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: SslCertificatesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[SslCertificatesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, SslCertificatesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, SslCertificatesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SslCertificateList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[SslCertificate]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[SslCertificate, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SslCertificateManagedSslCertificate(_message.Message):
    __slots__ = ("domain_status", "domains", "status")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[SslCertificateManagedSslCertificate.Status]
        ACTIVE: _ClassVar[SslCertificateManagedSslCertificate.Status]
        MANAGED_CERTIFICATE_STATUS_UNSPECIFIED: _ClassVar[SslCertificateManagedSslCertificate.Status]
        PROVISIONING: _ClassVar[SslCertificateManagedSslCertificate.Status]
        PROVISIONING_FAILED: _ClassVar[SslCertificateManagedSslCertificate.Status]
        PROVISIONING_FAILED_PERMANENTLY: _ClassVar[SslCertificateManagedSslCertificate.Status]
        RENEWAL_FAILED: _ClassVar[SslCertificateManagedSslCertificate.Status]
    UNDEFINED_STATUS: SslCertificateManagedSslCertificate.Status
    ACTIVE: SslCertificateManagedSslCertificate.Status
    MANAGED_CERTIFICATE_STATUS_UNSPECIFIED: SslCertificateManagedSslCertificate.Status
    PROVISIONING: SslCertificateManagedSslCertificate.Status
    PROVISIONING_FAILED: SslCertificateManagedSslCertificate.Status
    PROVISIONING_FAILED_PERMANENTLY: SslCertificateManagedSslCertificate.Status
    RENEWAL_FAILED: SslCertificateManagedSslCertificate.Status
    class DomainStatusEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DOMAIN_STATUS_FIELD_NUMBER: _ClassVar[int]
    DOMAINS_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    domain_status: _containers.ScalarMap[str, str]
    domains: _containers.RepeatedScalarFieldContainer[str]
    status: str
    def __init__(self, domain_status: _Optional[_Mapping[str, str]] = ..., domains: _Optional[_Iterable[str]] = ..., status: _Optional[str] = ...) -> None: ...

class SslCertificateSelfManagedSslCertificate(_message.Message):
    __slots__ = ("certificate", "private_key")
    CERTIFICATE_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_KEY_FIELD_NUMBER: _ClassVar[int]
    certificate: str
    private_key: str
    def __init__(self, certificate: _Optional[str] = ..., private_key: _Optional[str] = ...) -> None: ...

class SslCertificatesScopedList(_message.Message):
    __slots__ = ("ssl_certificates", "warning")
    SSL_CERTIFICATES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    ssl_certificates: _containers.RepeatedCompositeFieldContainer[SslCertificate]
    warning: Warning
    def __init__(self, ssl_certificates: _Optional[_Iterable[_Union[SslCertificate, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SslPoliciesAggregatedList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: SslPoliciesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[SslPoliciesScopedList, _Mapping]] = ...) -> None: ...
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.MessageMap[str, SslPoliciesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Mapping[str, SslPoliciesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SslPoliciesList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[SslPolicy]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[SslPolicy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SslPoliciesListAvailableFeaturesResponse(_message.Message):
    __slots__ = ("features",)
    FEATURES_FIELD_NUMBER: _ClassVar[int]
    features: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, features: _Optional[_Iterable[str]] = ...) -> None: ...

class SslPoliciesScopedList(_message.Message):
    __slots__ = ("ssl_policies", "warning")
    SSL_POLICIES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    ssl_policies: _containers.RepeatedCompositeFieldContainer[SslPolicy]
    warning: Warning
    def __init__(self, ssl_policies: _Optional[_Iterable[_Union[SslPolicy, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SslPolicy(_message.Message):
    __slots__ = ("creation_timestamp", "custom_features", "description", "enabled_features", "fingerprint", "id", "kind", "min_tls_version", "name", "profile", "region", "self_link", "warnings")
    class MinTlsVersion(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MIN_TLS_VERSION: _ClassVar[SslPolicy.MinTlsVersion]
        TLS_1_0: _ClassVar[SslPolicy.MinTlsVersion]
        TLS_1_1: _ClassVar[SslPolicy.MinTlsVersion]
        TLS_1_2: _ClassVar[SslPolicy.MinTlsVersion]
    UNDEFINED_MIN_TLS_VERSION: SslPolicy.MinTlsVersion
    TLS_1_0: SslPolicy.MinTlsVersion
    TLS_1_1: SslPolicy.MinTlsVersion
    TLS_1_2: SslPolicy.MinTlsVersion
    class Profile(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROFILE: _ClassVar[SslPolicy.Profile]
        COMPATIBLE: _ClassVar[SslPolicy.Profile]
        CUSTOM: _ClassVar[SslPolicy.Profile]
        MODERN: _ClassVar[SslPolicy.Profile]
        RESTRICTED: _ClassVar[SslPolicy.Profile]
    UNDEFINED_PROFILE: SslPolicy.Profile
    COMPATIBLE: SslPolicy.Profile
    CUSTOM: SslPolicy.Profile
    MODERN: SslPolicy.Profile
    RESTRICTED: SslPolicy.Profile
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_FEATURES_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ENABLED_FEATURES_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MIN_TLS_VERSION_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROFILE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNINGS_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    custom_features: _containers.RepeatedScalarFieldContainer[str]
    description: str
    enabled_features: _containers.RepeatedScalarFieldContainer[str]
    fingerprint: str
    id: int
    kind: str
    min_tls_version: str
    name: str
    profile: str
    region: str
    self_link: str
    warnings: _containers.RepeatedCompositeFieldContainer[Warnings]
    def __init__(self, creation_timestamp: _Optional[str] = ..., custom_features: _Optional[_Iterable[str]] = ..., description: _Optional[str] = ..., enabled_features: _Optional[_Iterable[str]] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., min_tls_version: _Optional[str] = ..., name: _Optional[str] = ..., profile: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., warnings: _Optional[_Iterable[_Union[Warnings, _Mapping]]] = ...) -> None: ...

class SslPolicyReference(_message.Message):
    __slots__ = ("ssl_policy",)
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    ssl_policy: str
    def __init__(self, ssl_policy: _Optional[str] = ...) -> None: ...

class StartAsyncReplicationDiskRequest(_message.Message):
    __slots__ = ("disk", "disks_start_async_replication_request_resource", "project", "request_id", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    DISKS_START_ASYNC_REPLICATION_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    disks_start_async_replication_request_resource: DisksStartAsyncReplicationRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., disks_start_async_replication_request_resource: _Optional[_Union[DisksStartAsyncReplicationRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StartAsyncReplicationRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region", "region_disks_start_async_replication_request_resource", "request_id")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_DISKS_START_ASYNC_REPLICATION_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    region_disks_start_async_replication_request_resource: RegionDisksStartAsyncReplicationRequest
    request_id: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_disks_start_async_replication_request_resource: _Optional[_Union[RegionDisksStartAsyncReplicationRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class StartInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StartInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_start_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_START_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_start_instances_request_resource: InstanceGroupManagersStartInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_start_instances_request_resource: _Optional[_Union[InstanceGroupManagersStartInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StartInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_start_instances_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_START_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_start_instances_request_resource: RegionInstanceGroupManagersStartInstancesRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_start_instances_request_resource: _Optional[_Union[RegionInstanceGroupManagersStartInstancesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class StartWithEncryptionKeyInstanceRequest(_message.Message):
    __slots__ = ("instance", "instances_start_with_encryption_key_request_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_START_WITH_ENCRYPTION_KEY_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instances_start_with_encryption_key_request_resource: InstancesStartWithEncryptionKeyRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instances_start_with_encryption_key_request_resource: _Optional[_Union[InstancesStartWithEncryptionKeyRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StatefulPolicy(_message.Message):
    __slots__ = ("preserved_state",)
    PRESERVED_STATE_FIELD_NUMBER: _ClassVar[int]
    preserved_state: StatefulPolicyPreservedState
    def __init__(self, preserved_state: _Optional[_Union[StatefulPolicyPreservedState, _Mapping]] = ...) -> None: ...

class StatefulPolicyPreservedState(_message.Message):
    __slots__ = ("disks", "external_i_ps", "internal_i_ps")
    class DisksEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: StatefulPolicyPreservedStateDiskDevice
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[StatefulPolicyPreservedStateDiskDevice, _Mapping]] = ...) -> None: ...
    class ExternalIPsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: StatefulPolicyPreservedStateNetworkIp
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[StatefulPolicyPreservedStateNetworkIp, _Mapping]] = ...) -> None: ...
    class InternalIPsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: StatefulPolicyPreservedStateNetworkIp
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[StatefulPolicyPreservedStateNetworkIp, _Mapping]] = ...) -> None: ...
    DISKS_FIELD_NUMBER: _ClassVar[int]
    EXTERNAL_I_PS_FIELD_NUMBER: _ClassVar[int]
    INTERNAL_I_PS_FIELD_NUMBER: _ClassVar[int]
    disks: _containers.MessageMap[str, StatefulPolicyPreservedStateDiskDevice]
    external_i_ps: _containers.MessageMap[str, StatefulPolicyPreservedStateNetworkIp]
    internal_i_ps: _containers.MessageMap[str, StatefulPolicyPreservedStateNetworkIp]
    def __init__(self, disks: _Optional[_Mapping[str, StatefulPolicyPreservedStateDiskDevice]] = ..., external_i_ps: _Optional[_Mapping[str, StatefulPolicyPreservedStateNetworkIp]] = ..., internal_i_ps: _Optional[_Mapping[str, StatefulPolicyPreservedStateNetworkIp]] = ...) -> None: ...

class StatefulPolicyPreservedStateDiskDevice(_message.Message):
    __slots__ = ("auto_delete",)
    class AutoDelete(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AUTO_DELETE: _ClassVar[StatefulPolicyPreservedStateDiskDevice.AutoDelete]
        NEVER: _ClassVar[StatefulPolicyPreservedStateDiskDevice.AutoDelete]
        ON_PERMANENT_INSTANCE_DELETION: _ClassVar[StatefulPolicyPreservedStateDiskDevice.AutoDelete]
    UNDEFINED_AUTO_DELETE: StatefulPolicyPreservedStateDiskDevice.AutoDelete
    NEVER: StatefulPolicyPreservedStateDiskDevice.AutoDelete
    ON_PERMANENT_INSTANCE_DELETION: StatefulPolicyPreservedStateDiskDevice.AutoDelete
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    auto_delete: str
    def __init__(self, auto_delete: _Optional[str] = ...) -> None: ...

class StatefulPolicyPreservedStateNetworkIp(_message.Message):
    __slots__ = ("auto_delete",)
    class AutoDelete(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AUTO_DELETE: _ClassVar[StatefulPolicyPreservedStateNetworkIp.AutoDelete]
        NEVER: _ClassVar[StatefulPolicyPreservedStateNetworkIp.AutoDelete]
        ON_PERMANENT_INSTANCE_DELETION: _ClassVar[StatefulPolicyPreservedStateNetworkIp.AutoDelete]
    UNDEFINED_AUTO_DELETE: StatefulPolicyPreservedStateNetworkIp.AutoDelete
    NEVER: StatefulPolicyPreservedStateNetworkIp.AutoDelete
    ON_PERMANENT_INSTANCE_DELETION: StatefulPolicyPreservedStateNetworkIp.AutoDelete
    AUTO_DELETE_FIELD_NUMBER: _ClassVar[int]
    auto_delete: str
    def __init__(self, auto_delete: _Optional[str] = ...) -> None: ...

class Status(_message.Message):
    __slots__ = ("code", "details", "message")
    CODE_FIELD_NUMBER: _ClassVar[int]
    DETAILS_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    code: int
    details: _containers.RepeatedCompositeFieldContainer[_any_pb2.Any]
    message: str
    def __init__(self, code: _Optional[int] = ..., details: _Optional[_Iterable[_Union[_any_pb2.Any, _Mapping]]] = ..., message: _Optional[str] = ...) -> None: ...

class StopAsyncReplicationDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "request_id", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    request_id: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StopAsyncReplicationRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "project", "region", "request_id")
    DISK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disk: str
    project: str
    region: str
    request_id: str
    def __init__(self, disk: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class StopGroupAsyncReplicationDiskRequest(_message.Message):
    __slots__ = ("disks_stop_group_async_replication_resource_resource", "project", "request_id", "zone")
    DISKS_STOP_GROUP_ASYNC_REPLICATION_RESOURCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disks_stop_group_async_replication_resource_resource: DisksStopGroupAsyncReplicationResource
    project: str
    request_id: str
    zone: str
    def __init__(self, disks_stop_group_async_replication_resource_resource: _Optional[_Union[DisksStopGroupAsyncReplicationResource, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StopGroupAsyncReplicationRegionDiskRequest(_message.Message):
    __slots__ = ("disks_stop_group_async_replication_resource_resource", "project", "region", "request_id")
    DISKS_STOP_GROUP_ASYNC_REPLICATION_RESOURCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    disks_stop_group_async_replication_resource_resource: DisksStopGroupAsyncReplicationResource
    project: str
    region: str
    request_id: str
    def __init__(self, disks_stop_group_async_replication_resource_resource: _Optional[_Union[DisksStopGroupAsyncReplicationResource, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class StopInstanceRequest(_message.Message):
    __slots__ = ("discard_local_ssd", "instance", "project", "request_id", "zone")
    DISCARD_LOCAL_SSD_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    discard_local_ssd: bool
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, discard_local_ssd: bool = ..., instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StopInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_stop_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_STOP_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_stop_instances_request_resource: InstanceGroupManagersStopInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_stop_instances_request_resource: _Optional[_Union[InstanceGroupManagersStopInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StopInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_stop_instances_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_STOP_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_stop_instances_request_resource: RegionInstanceGroupManagersStopInstancesRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_stop_instances_request_resource: _Optional[_Union[RegionInstanceGroupManagersStopInstancesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class StoragePool(_message.Message):
    __slots__ = ("capacity_provisioning_type", "creation_timestamp", "description", "id", "kind", "label_fingerprint", "labels", "name", "performance_provisioning_type", "pool_provisioned_capacity_gb", "pool_provisioned_iops", "pool_provisioned_throughput", "resource_status", "self_link", "self_link_with_id", "state", "status", "storage_pool_type", "zone")
    class CapacityProvisioningType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CAPACITY_PROVISIONING_TYPE: _ClassVar[StoragePool.CapacityProvisioningType]
    UNDEFINED_CAPACITY_PROVISIONING_TYPE: StoragePool.CapacityProvisioningType
    class PerformanceProvisioningType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PERFORMANCE_PROVISIONING_TYPE: _ClassVar[StoragePool.PerformanceProvisioningType]
    UNDEFINED_PERFORMANCE_PROVISIONING_TYPE: StoragePool.PerformanceProvisioningType
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[StoragePool.State]
        CREATING: _ClassVar[StoragePool.State]
        DELETING: _ClassVar[StoragePool.State]
        FAILED: _ClassVar[StoragePool.State]
        READY: _ClassVar[StoragePool.State]
    UNDEFINED_STATE: StoragePool.State
    CREATING: StoragePool.State
    DELETING: StoragePool.State
    FAILED: StoragePool.State
    READY: StoragePool.State
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CAPACITY_PROVISIONING_TYPE_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PERFORMANCE_PROVISIONING_TYPE_FIELD_NUMBER: _ClassVar[int]
    POOL_PROVISIONED_CAPACITY_GB_FIELD_NUMBER: _ClassVar[int]
    POOL_PROVISIONED_IOPS_FIELD_NUMBER: _ClassVar[int]
    POOL_PROVISIONED_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_TYPE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    capacity_provisioning_type: str
    creation_timestamp: str
    description: str
    id: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    name: str
    performance_provisioning_type: str
    pool_provisioned_capacity_gb: int
    pool_provisioned_iops: int
    pool_provisioned_throughput: int
    resource_status: StoragePoolResourceStatus
    self_link: str
    self_link_with_id: str
    state: str
    status: StoragePoolResourceStatus
    storage_pool_type: str
    zone: str
    def __init__(self, capacity_provisioning_type: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., performance_provisioning_type: _Optional[str] = ..., pool_provisioned_capacity_gb: _Optional[int] = ..., pool_provisioned_iops: _Optional[int] = ..., pool_provisioned_throughput: _Optional[int] = ..., resource_status: _Optional[_Union[StoragePoolResourceStatus, _Mapping]] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., state: _Optional[str] = ..., status: _Optional[_Union[StoragePoolResourceStatus, _Mapping]] = ..., storage_pool_type: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class StoragePoolAggregatedList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: StoragePoolsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[StoragePoolsScopedList, _Mapping]] = ...) -> None: ...
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.MessageMap[str, StoragePoolsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Mapping[str, StoragePoolsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class StoragePoolDisk(_message.Message):
    __slots__ = ("attached_instances", "creation_timestamp", "disk", "name", "provisioned_iops", "provisioned_throughput", "resource_policies", "size_gb", "status", "type", "used_bytes")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[StoragePoolDisk.Status]
        CREATING: _ClassVar[StoragePoolDisk.Status]
        DELETING: _ClassVar[StoragePoolDisk.Status]
        FAILED: _ClassVar[StoragePoolDisk.Status]
        READY: _ClassVar[StoragePoolDisk.Status]
        RESTORING: _ClassVar[StoragePoolDisk.Status]
        UNAVAILABLE: _ClassVar[StoragePoolDisk.Status]
    UNDEFINED_STATUS: StoragePoolDisk.Status
    CREATING: StoragePoolDisk.Status
    DELETING: StoragePoolDisk.Status
    FAILED: StoragePoolDisk.Status
    READY: StoragePoolDisk.Status
    RESTORING: StoragePoolDisk.Status
    UNAVAILABLE: StoragePoolDisk.Status
    ATTACHED_INSTANCES_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DISK_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROVISIONED_IOPS_FIELD_NUMBER: _ClassVar[int]
    PROVISIONED_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_POLICIES_FIELD_NUMBER: _ClassVar[int]
    SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    USED_BYTES_FIELD_NUMBER: _ClassVar[int]
    attached_instances: _containers.RepeatedScalarFieldContainer[str]
    creation_timestamp: str
    disk: str
    name: str
    provisioned_iops: int
    provisioned_throughput: int
    resource_policies: _containers.RepeatedScalarFieldContainer[str]
    size_gb: int
    status: str
    type: str
    used_bytes: int
    def __init__(self, attached_instances: _Optional[_Iterable[str]] = ..., creation_timestamp: _Optional[str] = ..., disk: _Optional[str] = ..., name: _Optional[str] = ..., provisioned_iops: _Optional[int] = ..., provisioned_throughput: _Optional[int] = ..., resource_policies: _Optional[_Iterable[str]] = ..., size_gb: _Optional[int] = ..., status: _Optional[str] = ..., type: _Optional[str] = ..., used_bytes: _Optional[int] = ...) -> None: ...

class StoragePoolList(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.RepeatedCompositeFieldContainer[StoragePool]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[StoragePool, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class StoragePoolListDisks(_message.Message):
    __slots__ = ("etag", "id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    ETAG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    etag: str
    id: str
    items: _containers.RepeatedCompositeFieldContainer[StoragePoolDisk]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, etag: _Optional[str] = ..., id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[StoragePoolDisk, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class StoragePoolResourceStatus(_message.Message):
    __slots__ = ("disk_count", "last_resize_timestamp", "max_total_provisioned_disk_capacity_gb", "pool_used_capacity_bytes", "pool_used_iops", "pool_used_throughput", "pool_user_written_bytes", "total_provisioned_disk_capacity_gb", "total_provisioned_disk_iops", "total_provisioned_disk_throughput")
    DISK_COUNT_FIELD_NUMBER: _ClassVar[int]
    LAST_RESIZE_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    MAX_TOTAL_PROVISIONED_DISK_CAPACITY_GB_FIELD_NUMBER: _ClassVar[int]
    POOL_USED_CAPACITY_BYTES_FIELD_NUMBER: _ClassVar[int]
    POOL_USED_IOPS_FIELD_NUMBER: _ClassVar[int]
    POOL_USED_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    POOL_USER_WRITTEN_BYTES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_PROVISIONED_DISK_CAPACITY_GB_FIELD_NUMBER: _ClassVar[int]
    TOTAL_PROVISIONED_DISK_IOPS_FIELD_NUMBER: _ClassVar[int]
    TOTAL_PROVISIONED_DISK_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    disk_count: int
    last_resize_timestamp: str
    max_total_provisioned_disk_capacity_gb: int
    pool_used_capacity_bytes: int
    pool_used_iops: int
    pool_used_throughput: int
    pool_user_written_bytes: int
    total_provisioned_disk_capacity_gb: int
    total_provisioned_disk_iops: int
    total_provisioned_disk_throughput: int
    def __init__(self, disk_count: _Optional[int] = ..., last_resize_timestamp: _Optional[str] = ..., max_total_provisioned_disk_capacity_gb: _Optional[int] = ..., pool_used_capacity_bytes: _Optional[int] = ..., pool_used_iops: _Optional[int] = ..., pool_used_throughput: _Optional[int] = ..., pool_user_written_bytes: _Optional[int] = ..., total_provisioned_disk_capacity_gb: _Optional[int] = ..., total_provisioned_disk_iops: _Optional[int] = ..., total_provisioned_disk_throughput: _Optional[int] = ...) -> None: ...

class StoragePoolType(_message.Message):
    __slots__ = ("creation_timestamp", "deprecated", "description", "id", "kind", "max_pool_provisioned_capacity_gb", "max_pool_provisioned_iops", "max_pool_provisioned_throughput", "min_pool_provisioned_capacity_gb", "min_pool_provisioned_iops", "min_pool_provisioned_throughput", "min_size_gb", "name", "self_link", "self_link_with_id", "supported_disk_types", "zone")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    MAX_POOL_PROVISIONED_CAPACITY_GB_FIELD_NUMBER: _ClassVar[int]
    MAX_POOL_PROVISIONED_IOPS_FIELD_NUMBER: _ClassVar[int]
    MAX_POOL_PROVISIONED_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    MIN_POOL_PROVISIONED_CAPACITY_GB_FIELD_NUMBER: _ClassVar[int]
    MIN_POOL_PROVISIONED_IOPS_FIELD_NUMBER: _ClassVar[int]
    MIN_POOL_PROVISIONED_THROUGHPUT_FIELD_NUMBER: _ClassVar[int]
    MIN_SIZE_GB_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    SUPPORTED_DISK_TYPES_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    deprecated: DeprecationStatus
    description: str
    id: int
    kind: str
    max_pool_provisioned_capacity_gb: int
    max_pool_provisioned_iops: int
    max_pool_provisioned_throughput: int
    min_pool_provisioned_capacity_gb: int
    min_pool_provisioned_iops: int
    min_pool_provisioned_throughput: int
    min_size_gb: int
    name: str
    self_link: str
    self_link_with_id: str
    supported_disk_types: _containers.RepeatedScalarFieldContainer[str]
    zone: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., max_pool_provisioned_capacity_gb: _Optional[int] = ..., max_pool_provisioned_iops: _Optional[int] = ..., max_pool_provisioned_throughput: _Optional[int] = ..., min_pool_provisioned_capacity_gb: _Optional[int] = ..., min_pool_provisioned_iops: _Optional[int] = ..., min_pool_provisioned_throughput: _Optional[int] = ..., min_size_gb: _Optional[int] = ..., name: _Optional[str] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., supported_disk_types: _Optional[_Iterable[str]] = ..., zone: _Optional[str] = ...) -> None: ...

class StoragePoolTypeAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: StoragePoolTypesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[StoragePoolTypesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, StoragePoolTypesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, StoragePoolTypesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class StoragePoolTypeList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[StoragePoolType]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[StoragePoolType, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class StoragePoolTypesScopedList(_message.Message):
    __slots__ = ("storage_pool_types", "warning")
    STORAGE_POOL_TYPES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    storage_pool_types: _containers.RepeatedCompositeFieldContainer[StoragePoolType]
    warning: Warning
    def __init__(self, storage_pool_types: _Optional[_Iterable[_Union[StoragePoolType, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class StoragePoolsScopedList(_message.Message):
    __slots__ = ("storage_pools", "warning")
    STORAGE_POOLS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    storage_pools: _containers.RepeatedCompositeFieldContainer[StoragePool]
    warning: Warning
    def __init__(self, storage_pools: _Optional[_Iterable[_Union[StoragePool, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class Subnetwork(_message.Message):
    __slots__ = ("creation_timestamp", "description", "enable_flow_logs", "external_ipv6_prefix", "fingerprint", "gateway_address", "id", "internal_ipv6_prefix", "ip_cidr_range", "ipv6_access_type", "ipv6_cidr_range", "kind", "log_config", "name", "network", "private_ip_google_access", "private_ipv6_google_access", "purpose", "region", "reserved_internal_range", "role", "secondary_ip_ranges", "self_link", "stack_type", "state")
    class Ipv6AccessType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IPV6_ACCESS_TYPE: _ClassVar[Subnetwork.Ipv6AccessType]
        EXTERNAL: _ClassVar[Subnetwork.Ipv6AccessType]
        INTERNAL: _ClassVar[Subnetwork.Ipv6AccessType]
        UNSPECIFIED_IPV6_ACCESS_TYPE: _ClassVar[Subnetwork.Ipv6AccessType]
    UNDEFINED_IPV6_ACCESS_TYPE: Subnetwork.Ipv6AccessType
    EXTERNAL: Subnetwork.Ipv6AccessType
    INTERNAL: Subnetwork.Ipv6AccessType
    UNSPECIFIED_IPV6_ACCESS_TYPE: Subnetwork.Ipv6AccessType
    class PrivateIpv6GoogleAccess(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS: _ClassVar[Subnetwork.PrivateIpv6GoogleAccess]
        DISABLE_GOOGLE_ACCESS: _ClassVar[Subnetwork.PrivateIpv6GoogleAccess]
        ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE: _ClassVar[Subnetwork.PrivateIpv6GoogleAccess]
        ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE: _ClassVar[Subnetwork.PrivateIpv6GoogleAccess]
    UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS: Subnetwork.PrivateIpv6GoogleAccess
    DISABLE_GOOGLE_ACCESS: Subnetwork.PrivateIpv6GoogleAccess
    ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE: Subnetwork.PrivateIpv6GoogleAccess
    ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE: Subnetwork.PrivateIpv6GoogleAccess
    class Purpose(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PURPOSE: _ClassVar[Subnetwork.Purpose]
        GLOBAL_MANAGED_PROXY: _ClassVar[Subnetwork.Purpose]
        INTERNAL_HTTPS_LOAD_BALANCER: _ClassVar[Subnetwork.Purpose]
        PEER_MIGRATION: _ClassVar[Subnetwork.Purpose]
        PRIVATE: _ClassVar[Subnetwork.Purpose]
        PRIVATE_NAT: _ClassVar[Subnetwork.Purpose]
        PRIVATE_RFC_1918: _ClassVar[Subnetwork.Purpose]
        PRIVATE_SERVICE_CONNECT: _ClassVar[Subnetwork.Purpose]
        REGIONAL_MANAGED_PROXY: _ClassVar[Subnetwork.Purpose]
    UNDEFINED_PURPOSE: Subnetwork.Purpose
    GLOBAL_MANAGED_PROXY: Subnetwork.Purpose
    INTERNAL_HTTPS_LOAD_BALANCER: Subnetwork.Purpose
    PEER_MIGRATION: Subnetwork.Purpose
    PRIVATE: Subnetwork.Purpose
    PRIVATE_NAT: Subnetwork.Purpose
    PRIVATE_RFC_1918: Subnetwork.Purpose
    PRIVATE_SERVICE_CONNECT: Subnetwork.Purpose
    REGIONAL_MANAGED_PROXY: Subnetwork.Purpose
    class Role(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ROLE: _ClassVar[Subnetwork.Role]
        ACTIVE: _ClassVar[Subnetwork.Role]
        BACKUP: _ClassVar[Subnetwork.Role]
    UNDEFINED_ROLE: Subnetwork.Role
    ACTIVE: Subnetwork.Role
    BACKUP: Subnetwork.Role
    class StackType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STACK_TYPE: _ClassVar[Subnetwork.StackType]
        IPV4_IPV6: _ClassVar[Subnetwork.StackType]
        IPV4_ONLY: _ClassVar[Subnetwork.StackType]
        IPV6_ONLY: _ClassVar[Subnetwork.StackType]
        UNSPECIFIED_STACK_TYPE: _ClassVar[Subnetwork.StackType]
    UNDEFINED_STACK_TYPE: Subnetwork.StackType
    IPV4_IPV6: Subnetwork.StackType
    IPV4_ONLY: Subnetwork.StackType
    IPV6_ONLY: Subnetwork.StackType
    UNSPECIFIED_STACK_TYPE: Subnetwork.StackType
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[Subnetwork.State]
        DRAINING: _ClassVar[Subnetwork.State]
        READY: _ClassVar[Subnetwork.State]
    UNDEFINED_STATE: Subnetwork.State
    DRAINING: Subnetwork.State
    READY: Subnetwork.State
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ENABLE_FLOW_LOGS_FIELD_NUMBER: _ClassVar[int]
    EXTERNAL_IPV6_PREFIX_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    GATEWAY_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INTERNAL_IPV6_PREFIX_FIELD_NUMBER: _ClassVar[int]
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    IPV6_ACCESS_TYPE_FIELD_NUMBER: _ClassVar[int]
    IPV6_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOG_CONFIG_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_IP_GOOGLE_ACCESS_FIELD_NUMBER: _ClassVar[int]
    PRIVATE_IPV6_GOOGLE_ACCESS_FIELD_NUMBER: _ClassVar[int]
    PURPOSE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESERVED_INTERNAL_RANGE_FIELD_NUMBER: _ClassVar[int]
    ROLE_FIELD_NUMBER: _ClassVar[int]
    SECONDARY_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STACK_TYPE_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    enable_flow_logs: bool
    external_ipv6_prefix: str
    fingerprint: str
    gateway_address: str
    id: int
    internal_ipv6_prefix: str
    ip_cidr_range: str
    ipv6_access_type: str
    ipv6_cidr_range: str
    kind: str
    log_config: SubnetworkLogConfig
    name: str
    network: str
    private_ip_google_access: bool
    private_ipv6_google_access: str
    purpose: str
    region: str
    reserved_internal_range: str
    role: str
    secondary_ip_ranges: _containers.RepeatedCompositeFieldContainer[SubnetworkSecondaryRange]
    self_link: str
    stack_type: str
    state: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., enable_flow_logs: bool = ..., external_ipv6_prefix: _Optional[str] = ..., fingerprint: _Optional[str] = ..., gateway_address: _Optional[str] = ..., id: _Optional[int] = ..., internal_ipv6_prefix: _Optional[str] = ..., ip_cidr_range: _Optional[str] = ..., ipv6_access_type: _Optional[str] = ..., ipv6_cidr_range: _Optional[str] = ..., kind: _Optional[str] = ..., log_config: _Optional[_Union[SubnetworkLogConfig, _Mapping]] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., private_ip_google_access: bool = ..., private_ipv6_google_access: _Optional[str] = ..., purpose: _Optional[str] = ..., region: _Optional[str] = ..., reserved_internal_range: _Optional[str] = ..., role: _Optional[str] = ..., secondary_ip_ranges: _Optional[_Iterable[_Union[SubnetworkSecondaryRange, _Mapping]]] = ..., self_link: _Optional[str] = ..., stack_type: _Optional[str] = ..., state: _Optional[str] = ...) -> None: ...

class SubnetworkAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: SubnetworksScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[SubnetworksScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, SubnetworksScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, SubnetworksScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SubnetworkList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Subnetwork]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Subnetwork, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SubnetworkLogConfig(_message.Message):
    __slots__ = ("aggregation_interval", "enable", "filter_expr", "flow_sampling", "metadata", "metadata_fields")
    class AggregationInterval(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_AGGREGATION_INTERVAL: _ClassVar[SubnetworkLogConfig.AggregationInterval]
        INTERVAL_10_MIN: _ClassVar[SubnetworkLogConfig.AggregationInterval]
        INTERVAL_15_MIN: _ClassVar[SubnetworkLogConfig.AggregationInterval]
        INTERVAL_1_MIN: _ClassVar[SubnetworkLogConfig.AggregationInterval]
        INTERVAL_30_SEC: _ClassVar[SubnetworkLogConfig.AggregationInterval]
        INTERVAL_5_MIN: _ClassVar[SubnetworkLogConfig.AggregationInterval]
        INTERVAL_5_SEC: _ClassVar[SubnetworkLogConfig.AggregationInterval]
    UNDEFINED_AGGREGATION_INTERVAL: SubnetworkLogConfig.AggregationInterval
    INTERVAL_10_MIN: SubnetworkLogConfig.AggregationInterval
    INTERVAL_15_MIN: SubnetworkLogConfig.AggregationInterval
    INTERVAL_1_MIN: SubnetworkLogConfig.AggregationInterval
    INTERVAL_30_SEC: SubnetworkLogConfig.AggregationInterval
    INTERVAL_5_MIN: SubnetworkLogConfig.AggregationInterval
    INTERVAL_5_SEC: SubnetworkLogConfig.AggregationInterval
    class Metadata(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_METADATA: _ClassVar[SubnetworkLogConfig.Metadata]
        CUSTOM_METADATA: _ClassVar[SubnetworkLogConfig.Metadata]
        EXCLUDE_ALL_METADATA: _ClassVar[SubnetworkLogConfig.Metadata]
        INCLUDE_ALL_METADATA: _ClassVar[SubnetworkLogConfig.Metadata]
    UNDEFINED_METADATA: SubnetworkLogConfig.Metadata
    CUSTOM_METADATA: SubnetworkLogConfig.Metadata
    EXCLUDE_ALL_METADATA: SubnetworkLogConfig.Metadata
    INCLUDE_ALL_METADATA: SubnetworkLogConfig.Metadata
    AGGREGATION_INTERVAL_FIELD_NUMBER: _ClassVar[int]
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    FILTER_EXPR_FIELD_NUMBER: _ClassVar[int]
    FLOW_SAMPLING_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELDS_FIELD_NUMBER: _ClassVar[int]
    aggregation_interval: str
    enable: bool
    filter_expr: str
    flow_sampling: float
    metadata: str
    metadata_fields: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, aggregation_interval: _Optional[str] = ..., enable: bool = ..., filter_expr: _Optional[str] = ..., flow_sampling: _Optional[float] = ..., metadata: _Optional[str] = ..., metadata_fields: _Optional[_Iterable[str]] = ...) -> None: ...

class SubnetworkSecondaryRange(_message.Message):
    __slots__ = ("ip_cidr_range", "range_name", "reserved_internal_range")
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    RANGE_NAME_FIELD_NUMBER: _ClassVar[int]
    RESERVED_INTERNAL_RANGE_FIELD_NUMBER: _ClassVar[int]
    ip_cidr_range: str
    range_name: str
    reserved_internal_range: str
    def __init__(self, ip_cidr_range: _Optional[str] = ..., range_name: _Optional[str] = ..., reserved_internal_range: _Optional[str] = ...) -> None: ...

class SubnetworksExpandIpCidrRangeRequest(_message.Message):
    __slots__ = ("ip_cidr_range",)
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    ip_cidr_range: str
    def __init__(self, ip_cidr_range: _Optional[str] = ...) -> None: ...

class SubnetworksScopedList(_message.Message):
    __slots__ = ("subnetworks", "warning")
    SUBNETWORKS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    subnetworks: _containers.RepeatedCompositeFieldContainer[Subnetwork]
    warning: Warning
    def __init__(self, subnetworks: _Optional[_Iterable[_Union[Subnetwork, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class SubnetworksSetPrivateIpGoogleAccessRequest(_message.Message):
    __slots__ = ("private_ip_google_access",)
    PRIVATE_IP_GOOGLE_ACCESS_FIELD_NUMBER: _ClassVar[int]
    private_ip_google_access: bool
    def __init__(self, private_ip_google_access: bool = ...) -> None: ...

class Subsetting(_message.Message):
    __slots__ = ("policy",)
    class Policy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_POLICY: _ClassVar[Subsetting.Policy]
        CONSISTENT_HASH_SUBSETTING: _ClassVar[Subsetting.Policy]
        NONE: _ClassVar[Subsetting.Policy]
    UNDEFINED_POLICY: Subsetting.Policy
    CONSISTENT_HASH_SUBSETTING: Subsetting.Policy
    NONE: Subsetting.Policy
    POLICY_FIELD_NUMBER: _ClassVar[int]
    policy: str
    def __init__(self, policy: _Optional[str] = ...) -> None: ...

class SuspendInstanceRequest(_message.Message):
    __slots__ = ("discard_local_ssd", "instance", "project", "request_id", "zone")
    DISCARD_LOCAL_SSD_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    discard_local_ssd: bool
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, discard_local_ssd: bool = ..., instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SuspendInstancesInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_suspend_instances_request_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_SUSPEND_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_suspend_instances_request_resource: InstanceGroupManagersSuspendInstancesRequest
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_suspend_instances_request_resource: _Optional[_Union[InstanceGroupManagersSuspendInstancesRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class SuspendInstancesRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_managers_suspend_instances_request_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGERS_SUSPEND_INSTANCES_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_managers_suspend_instances_request_resource: RegionInstanceGroupManagersSuspendInstancesRequest
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_managers_suspend_instances_request_resource: _Optional[_Union[RegionInstanceGroupManagersSuspendInstancesRequest, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class SwitchToCustomModeNetworkRequest(_message.Message):
    __slots__ = ("network", "project", "request_id")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network: str
    project: str
    request_id: str
    def __init__(self, network: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class TCPHealthCheck(_message.Message):
    __slots__ = ("port", "port_name", "port_specification", "proxy_header", "request", "response")
    class PortSpecification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PORT_SPECIFICATION: _ClassVar[TCPHealthCheck.PortSpecification]
        USE_FIXED_PORT: _ClassVar[TCPHealthCheck.PortSpecification]
        USE_NAMED_PORT: _ClassVar[TCPHealthCheck.PortSpecification]
        USE_SERVING_PORT: _ClassVar[TCPHealthCheck.PortSpecification]
    UNDEFINED_PORT_SPECIFICATION: TCPHealthCheck.PortSpecification
    USE_FIXED_PORT: TCPHealthCheck.PortSpecification
    USE_NAMED_PORT: TCPHealthCheck.PortSpecification
    USE_SERVING_PORT: TCPHealthCheck.PortSpecification
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[TCPHealthCheck.ProxyHeader]
        NONE: _ClassVar[TCPHealthCheck.ProxyHeader]
        PROXY_V1: _ClassVar[TCPHealthCheck.ProxyHeader]
    UNDEFINED_PROXY_HEADER: TCPHealthCheck.ProxyHeader
    NONE: TCPHealthCheck.ProxyHeader
    PROXY_V1: TCPHealthCheck.ProxyHeader
    PORT_FIELD_NUMBER: _ClassVar[int]
    PORT_NAME_FIELD_NUMBER: _ClassVar[int]
    PORT_SPECIFICATION_FIELD_NUMBER: _ClassVar[int]
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    REQUEST_FIELD_NUMBER: _ClassVar[int]
    RESPONSE_FIELD_NUMBER: _ClassVar[int]
    port: int
    port_name: str
    port_specification: str
    proxy_header: str
    request: str
    response: str
    def __init__(self, port: _Optional[int] = ..., port_name: _Optional[str] = ..., port_specification: _Optional[str] = ..., proxy_header: _Optional[str] = ..., request: _Optional[str] = ..., response: _Optional[str] = ...) -> None: ...

class Tags(_message.Message):
    __slots__ = ("fingerprint", "items")
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    fingerprint: str
    items: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, fingerprint: _Optional[str] = ..., items: _Optional[_Iterable[str]] = ...) -> None: ...

class TargetGrpcProxy(_message.Message):
    __slots__ = ("creation_timestamp", "description", "fingerprint", "id", "kind", "name", "self_link", "self_link_with_id", "url_map", "validate_for_proxyless")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_WITH_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    VALIDATE_FOR_PROXYLESS_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    fingerprint: str
    id: int
    kind: str
    name: str
    self_link: str
    self_link_with_id: str
    url_map: str
    validate_for_proxyless: bool
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., self_link: _Optional[str] = ..., self_link_with_id: _Optional[str] = ..., url_map: _Optional[str] = ..., validate_for_proxyless: bool = ...) -> None: ...

class TargetGrpcProxyList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetGrpcProxy]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetGrpcProxy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetHttpProxiesScopedList(_message.Message):
    __slots__ = ("target_http_proxies", "warning")
    TARGET_HTTP_PROXIES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    target_http_proxies: _containers.RepeatedCompositeFieldContainer[TargetHttpProxy]
    warning: Warning
    def __init__(self, target_http_proxies: _Optional[_Iterable[_Union[TargetHttpProxy, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetHttpProxy(_message.Message):
    __slots__ = ("creation_timestamp", "description", "fingerprint", "http_keep_alive_timeout_sec", "id", "kind", "name", "proxy_bind", "region", "self_link", "url_map")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    HTTP_KEEP_ALIVE_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROXY_BIND_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    fingerprint: str
    http_keep_alive_timeout_sec: int
    id: int
    kind: str
    name: str
    proxy_bind: bool
    region: str
    self_link: str
    url_map: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., http_keep_alive_timeout_sec: _Optional[int] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., proxy_bind: bool = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., url_map: _Optional[str] = ...) -> None: ...

class TargetHttpProxyAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: TargetHttpProxiesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[TargetHttpProxiesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, TargetHttpProxiesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, TargetHttpProxiesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ...) -> None: ...

class TargetHttpProxyList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetHttpProxy]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetHttpProxy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetHttpsProxiesScopedList(_message.Message):
    __slots__ = ("target_https_proxies", "warning")
    TARGET_HTTPS_PROXIES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    target_https_proxies: _containers.RepeatedCompositeFieldContainer[TargetHttpsProxy]
    warning: Warning
    def __init__(self, target_https_proxies: _Optional[_Iterable[_Union[TargetHttpsProxy, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetHttpsProxiesSetCertificateMapRequest(_message.Message):
    __slots__ = ("certificate_map",)
    CERTIFICATE_MAP_FIELD_NUMBER: _ClassVar[int]
    certificate_map: str
    def __init__(self, certificate_map: _Optional[str] = ...) -> None: ...

class TargetHttpsProxiesSetQuicOverrideRequest(_message.Message):
    __slots__ = ("quic_override",)
    class QuicOverride(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_QUIC_OVERRIDE: _ClassVar[TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride]
        DISABLE: _ClassVar[TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride]
        ENABLE: _ClassVar[TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride]
        NONE: _ClassVar[TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride]
    UNDEFINED_QUIC_OVERRIDE: TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride
    DISABLE: TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride
    ENABLE: TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride
    NONE: TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride
    QUIC_OVERRIDE_FIELD_NUMBER: _ClassVar[int]
    quic_override: str
    def __init__(self, quic_override: _Optional[str] = ...) -> None: ...

class TargetHttpsProxiesSetSslCertificatesRequest(_message.Message):
    __slots__ = ("ssl_certificates",)
    SSL_CERTIFICATES_FIELD_NUMBER: _ClassVar[int]
    ssl_certificates: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, ssl_certificates: _Optional[_Iterable[str]] = ...) -> None: ...

class TargetHttpsProxy(_message.Message):
    __slots__ = ("authorization_policy", "certificate_map", "creation_timestamp", "description", "fingerprint", "http_keep_alive_timeout_sec", "id", "kind", "name", "proxy_bind", "quic_override", "region", "self_link", "server_tls_policy", "ssl_certificates", "ssl_policy", "tls_early_data", "url_map")
    class QuicOverride(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_QUIC_OVERRIDE: _ClassVar[TargetHttpsProxy.QuicOverride]
        DISABLE: _ClassVar[TargetHttpsProxy.QuicOverride]
        ENABLE: _ClassVar[TargetHttpsProxy.QuicOverride]
        NONE: _ClassVar[TargetHttpsProxy.QuicOverride]
    UNDEFINED_QUIC_OVERRIDE: TargetHttpsProxy.QuicOverride
    DISABLE: TargetHttpsProxy.QuicOverride
    ENABLE: TargetHttpsProxy.QuicOverride
    NONE: TargetHttpsProxy.QuicOverride
    class TlsEarlyData(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TLS_EARLY_DATA: _ClassVar[TargetHttpsProxy.TlsEarlyData]
        DISABLED: _ClassVar[TargetHttpsProxy.TlsEarlyData]
        PERMISSIVE: _ClassVar[TargetHttpsProxy.TlsEarlyData]
        STRICT: _ClassVar[TargetHttpsProxy.TlsEarlyData]
        UNRESTRICTED: _ClassVar[TargetHttpsProxy.TlsEarlyData]
    UNDEFINED_TLS_EARLY_DATA: TargetHttpsProxy.TlsEarlyData
    DISABLED: TargetHttpsProxy.TlsEarlyData
    PERMISSIVE: TargetHttpsProxy.TlsEarlyData
    STRICT: TargetHttpsProxy.TlsEarlyData
    UNRESTRICTED: TargetHttpsProxy.TlsEarlyData
    AUTHORIZATION_POLICY_FIELD_NUMBER: _ClassVar[int]
    CERTIFICATE_MAP_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    HTTP_KEEP_ALIVE_TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROXY_BIND_FIELD_NUMBER: _ClassVar[int]
    QUIC_OVERRIDE_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SERVER_TLS_POLICY_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATES_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    TLS_EARLY_DATA_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    authorization_policy: str
    certificate_map: str
    creation_timestamp: str
    description: str
    fingerprint: str
    http_keep_alive_timeout_sec: int
    id: int
    kind: str
    name: str
    proxy_bind: bool
    quic_override: str
    region: str
    self_link: str
    server_tls_policy: str
    ssl_certificates: _containers.RepeatedScalarFieldContainer[str]
    ssl_policy: str
    tls_early_data: str
    url_map: str
    def __init__(self, authorization_policy: _Optional[str] = ..., certificate_map: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., http_keep_alive_timeout_sec: _Optional[int] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., proxy_bind: bool = ..., quic_override: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., server_tls_policy: _Optional[str] = ..., ssl_certificates: _Optional[_Iterable[str]] = ..., ssl_policy: _Optional[str] = ..., tls_early_data: _Optional[str] = ..., url_map: _Optional[str] = ...) -> None: ...

class TargetHttpsProxyAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: TargetHttpsProxiesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[TargetHttpsProxiesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, TargetHttpsProxiesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, TargetHttpsProxiesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetHttpsProxyList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetHttpsProxy]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetHttpsProxy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetInstance(_message.Message):
    __slots__ = ("creation_timestamp", "description", "id", "instance", "kind", "name", "nat_policy", "network", "security_policy", "self_link", "zone")
    class NatPolicy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_NAT_POLICY: _ClassVar[TargetInstance.NatPolicy]
        NO_NAT: _ClassVar[TargetInstance.NatPolicy]
    UNDEFINED_NAT_POLICY: TargetInstance.NatPolicy
    NO_NAT: TargetInstance.NatPolicy
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NAT_POLICY_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    id: int
    instance: str
    kind: str
    name: str
    nat_policy: str
    network: str
    security_policy: str
    self_link: str
    zone: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., instance: _Optional[str] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., nat_policy: _Optional[str] = ..., network: _Optional[str] = ..., security_policy: _Optional[str] = ..., self_link: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class TargetInstanceAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: TargetInstancesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[TargetInstancesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, TargetInstancesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, TargetInstancesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetInstanceList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetInstance]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetInstance, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetInstancesScopedList(_message.Message):
    __slots__ = ("target_instances", "warning")
    TARGET_INSTANCES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    target_instances: _containers.RepeatedCompositeFieldContainer[TargetInstance]
    warning: Warning
    def __init__(self, target_instances: _Optional[_Iterable[_Union[TargetInstance, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetPool(_message.Message):
    __slots__ = ("backup_pool", "creation_timestamp", "description", "failover_ratio", "health_checks", "id", "instances", "kind", "name", "region", "security_policy", "self_link", "session_affinity")
    class SessionAffinity(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_SESSION_AFFINITY: _ClassVar[TargetPool.SessionAffinity]
        CLIENT_IP: _ClassVar[TargetPool.SessionAffinity]
        CLIENT_IP_NO_DESTINATION: _ClassVar[TargetPool.SessionAffinity]
        CLIENT_IP_PORT_PROTO: _ClassVar[TargetPool.SessionAffinity]
        CLIENT_IP_PROTO: _ClassVar[TargetPool.SessionAffinity]
        GENERATED_COOKIE: _ClassVar[TargetPool.SessionAffinity]
        HEADER_FIELD: _ClassVar[TargetPool.SessionAffinity]
        HTTP_COOKIE: _ClassVar[TargetPool.SessionAffinity]
        NONE: _ClassVar[TargetPool.SessionAffinity]
        STRONG_COOKIE_AFFINITY: _ClassVar[TargetPool.SessionAffinity]
    UNDEFINED_SESSION_AFFINITY: TargetPool.SessionAffinity
    CLIENT_IP: TargetPool.SessionAffinity
    CLIENT_IP_NO_DESTINATION: TargetPool.SessionAffinity
    CLIENT_IP_PORT_PROTO: TargetPool.SessionAffinity
    CLIENT_IP_PROTO: TargetPool.SessionAffinity
    GENERATED_COOKIE: TargetPool.SessionAffinity
    HEADER_FIELD: TargetPool.SessionAffinity
    HTTP_COOKIE: TargetPool.SessionAffinity
    NONE: TargetPool.SessionAffinity
    STRONG_COOKIE_AFFINITY: TargetPool.SessionAffinity
    BACKUP_POOL_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FAILOVER_RATIO_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECKS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SECURITY_POLICY_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SESSION_AFFINITY_FIELD_NUMBER: _ClassVar[int]
    backup_pool: str
    creation_timestamp: str
    description: str
    failover_ratio: float
    health_checks: _containers.RepeatedScalarFieldContainer[str]
    id: int
    instances: _containers.RepeatedScalarFieldContainer[str]
    kind: str
    name: str
    region: str
    security_policy: str
    self_link: str
    session_affinity: str
    def __init__(self, backup_pool: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., failover_ratio: _Optional[float] = ..., health_checks: _Optional[_Iterable[str]] = ..., id: _Optional[int] = ..., instances: _Optional[_Iterable[str]] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., security_policy: _Optional[str] = ..., self_link: _Optional[str] = ..., session_affinity: _Optional[str] = ...) -> None: ...

class TargetPoolAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: TargetPoolsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[TargetPoolsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, TargetPoolsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, TargetPoolsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetPoolInstanceHealth(_message.Message):
    __slots__ = ("health_status", "kind")
    HEALTH_STATUS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    health_status: _containers.RepeatedCompositeFieldContainer[HealthStatus]
    kind: str
    def __init__(self, health_status: _Optional[_Iterable[_Union[HealthStatus, _Mapping]]] = ..., kind: _Optional[str] = ...) -> None: ...

class TargetPoolList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetPool]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetPool, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetPoolsAddHealthCheckRequest(_message.Message):
    __slots__ = ("health_checks",)
    HEALTH_CHECKS_FIELD_NUMBER: _ClassVar[int]
    health_checks: _containers.RepeatedCompositeFieldContainer[HealthCheckReference]
    def __init__(self, health_checks: _Optional[_Iterable[_Union[HealthCheckReference, _Mapping]]] = ...) -> None: ...

class TargetPoolsAddInstanceRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[InstanceReference]
    def __init__(self, instances: _Optional[_Iterable[_Union[InstanceReference, _Mapping]]] = ...) -> None: ...

class TargetPoolsRemoveHealthCheckRequest(_message.Message):
    __slots__ = ("health_checks",)
    HEALTH_CHECKS_FIELD_NUMBER: _ClassVar[int]
    health_checks: _containers.RepeatedCompositeFieldContainer[HealthCheckReference]
    def __init__(self, health_checks: _Optional[_Iterable[_Union[HealthCheckReference, _Mapping]]] = ...) -> None: ...

class TargetPoolsRemoveInstanceRequest(_message.Message):
    __slots__ = ("instances",)
    INSTANCES_FIELD_NUMBER: _ClassVar[int]
    instances: _containers.RepeatedCompositeFieldContainer[InstanceReference]
    def __init__(self, instances: _Optional[_Iterable[_Union[InstanceReference, _Mapping]]] = ...) -> None: ...

class TargetPoolsScopedList(_message.Message):
    __slots__ = ("target_pools", "warning")
    TARGET_POOLS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    target_pools: _containers.RepeatedCompositeFieldContainer[TargetPool]
    warning: Warning
    def __init__(self, target_pools: _Optional[_Iterable[_Union[TargetPool, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetReference(_message.Message):
    __slots__ = ("target",)
    TARGET_FIELD_NUMBER: _ClassVar[int]
    target: str
    def __init__(self, target: _Optional[str] = ...) -> None: ...

class TargetSslProxiesSetBackendServiceRequest(_message.Message):
    __slots__ = ("service",)
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    service: str
    def __init__(self, service: _Optional[str] = ...) -> None: ...

class TargetSslProxiesSetCertificateMapRequest(_message.Message):
    __slots__ = ("certificate_map",)
    CERTIFICATE_MAP_FIELD_NUMBER: _ClassVar[int]
    certificate_map: str
    def __init__(self, certificate_map: _Optional[str] = ...) -> None: ...

class TargetSslProxiesSetProxyHeaderRequest(_message.Message):
    __slots__ = ("proxy_header",)
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[TargetSslProxiesSetProxyHeaderRequest.ProxyHeader]
        NONE: _ClassVar[TargetSslProxiesSetProxyHeaderRequest.ProxyHeader]
        PROXY_V1: _ClassVar[TargetSslProxiesSetProxyHeaderRequest.ProxyHeader]
    UNDEFINED_PROXY_HEADER: TargetSslProxiesSetProxyHeaderRequest.ProxyHeader
    NONE: TargetSslProxiesSetProxyHeaderRequest.ProxyHeader
    PROXY_V1: TargetSslProxiesSetProxyHeaderRequest.ProxyHeader
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    proxy_header: str
    def __init__(self, proxy_header: _Optional[str] = ...) -> None: ...

class TargetSslProxiesSetSslCertificatesRequest(_message.Message):
    __slots__ = ("ssl_certificates",)
    SSL_CERTIFICATES_FIELD_NUMBER: _ClassVar[int]
    ssl_certificates: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, ssl_certificates: _Optional[_Iterable[str]] = ...) -> None: ...

class TargetSslProxy(_message.Message):
    __slots__ = ("certificate_map", "creation_timestamp", "description", "id", "kind", "name", "proxy_header", "self_link", "service", "ssl_certificates", "ssl_policy")
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[TargetSslProxy.ProxyHeader]
        NONE: _ClassVar[TargetSslProxy.ProxyHeader]
        PROXY_V1: _ClassVar[TargetSslProxy.ProxyHeader]
    UNDEFINED_PROXY_HEADER: TargetSslProxy.ProxyHeader
    NONE: TargetSslProxy.ProxyHeader
    PROXY_V1: TargetSslProxy.ProxyHeader
    CERTIFICATE_MAP_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    SSL_CERTIFICATES_FIELD_NUMBER: _ClassVar[int]
    SSL_POLICY_FIELD_NUMBER: _ClassVar[int]
    certificate_map: str
    creation_timestamp: str
    description: str
    id: int
    kind: str
    name: str
    proxy_header: str
    self_link: str
    service: str
    ssl_certificates: _containers.RepeatedScalarFieldContainer[str]
    ssl_policy: str
    def __init__(self, certificate_map: _Optional[str] = ..., creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., proxy_header: _Optional[str] = ..., self_link: _Optional[str] = ..., service: _Optional[str] = ..., ssl_certificates: _Optional[_Iterable[str]] = ..., ssl_policy: _Optional[str] = ...) -> None: ...

class TargetSslProxyList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetSslProxy]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetSslProxy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetTcpProxiesScopedList(_message.Message):
    __slots__ = ("target_tcp_proxies", "warning")
    TARGET_TCP_PROXIES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    target_tcp_proxies: _containers.RepeatedCompositeFieldContainer[TargetTcpProxy]
    warning: Warning
    def __init__(self, target_tcp_proxies: _Optional[_Iterable[_Union[TargetTcpProxy, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetTcpProxiesSetBackendServiceRequest(_message.Message):
    __slots__ = ("service",)
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    service: str
    def __init__(self, service: _Optional[str] = ...) -> None: ...

class TargetTcpProxiesSetProxyHeaderRequest(_message.Message):
    __slots__ = ("proxy_header",)
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader]
        NONE: _ClassVar[TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader]
        PROXY_V1: _ClassVar[TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader]
    UNDEFINED_PROXY_HEADER: TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader
    NONE: TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader
    PROXY_V1: TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    proxy_header: str
    def __init__(self, proxy_header: _Optional[str] = ...) -> None: ...

class TargetTcpProxy(_message.Message):
    __slots__ = ("creation_timestamp", "description", "id", "kind", "name", "proxy_bind", "proxy_header", "region", "self_link", "service")
    class ProxyHeader(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PROXY_HEADER: _ClassVar[TargetTcpProxy.ProxyHeader]
        NONE: _ClassVar[TargetTcpProxy.ProxyHeader]
        PROXY_V1: _ClassVar[TargetTcpProxy.ProxyHeader]
    UNDEFINED_PROXY_HEADER: TargetTcpProxy.ProxyHeader
    NONE: TargetTcpProxy.ProxyHeader
    PROXY_V1: TargetTcpProxy.ProxyHeader
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROXY_BIND_FIELD_NUMBER: _ClassVar[int]
    PROXY_HEADER_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    id: int
    kind: str
    name: str
    proxy_bind: bool
    proxy_header: str
    region: str
    self_link: str
    service: str
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., proxy_bind: bool = ..., proxy_header: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., service: _Optional[str] = ...) -> None: ...

class TargetTcpProxyAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: TargetTcpProxiesScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[TargetTcpProxiesScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, TargetTcpProxiesScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, TargetTcpProxiesScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetTcpProxyList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetTcpProxy]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetTcpProxy, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetVpnGateway(_message.Message):
    __slots__ = ("creation_timestamp", "description", "forwarding_rules", "id", "kind", "label_fingerprint", "labels", "name", "network", "region", "self_link", "status", "tunnels")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[TargetVpnGateway.Status]
        CREATING: _ClassVar[TargetVpnGateway.Status]
        DELETING: _ClassVar[TargetVpnGateway.Status]
        FAILED: _ClassVar[TargetVpnGateway.Status]
        READY: _ClassVar[TargetVpnGateway.Status]
    UNDEFINED_STATUS: TargetVpnGateway.Status
    CREATING: TargetVpnGateway.Status
    DELETING: TargetVpnGateway.Status
    FAILED: TargetVpnGateway.Status
    READY: TargetVpnGateway.Status
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FORWARDING_RULES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TUNNELS_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    forwarding_rules: _containers.RepeatedScalarFieldContainer[str]
    id: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    name: str
    network: str
    region: str
    self_link: str
    status: str
    tunnels: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., forwarding_rules: _Optional[_Iterable[str]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ..., tunnels: _Optional[_Iterable[str]] = ...) -> None: ...

class TargetVpnGatewayAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: TargetVpnGatewaysScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[TargetVpnGatewaysScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, TargetVpnGatewaysScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, TargetVpnGatewaysScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetVpnGatewayList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[TargetVpnGateway]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TargetVpnGateway, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TargetVpnGatewaysScopedList(_message.Message):
    __slots__ = ("target_vpn_gateways", "warning")
    TARGET_VPN_GATEWAYS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    target_vpn_gateways: _containers.RepeatedCompositeFieldContainer[TargetVpnGateway]
    warning: Warning
    def __init__(self, target_vpn_gateways: _Optional[_Iterable[_Union[TargetVpnGateway, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class TestFailure(_message.Message):
    __slots__ = ("actual_output_url", "actual_redirect_response_code", "actual_service", "expected_output_url", "expected_redirect_response_code", "expected_service", "headers", "host", "path")
    ACTUAL_OUTPUT_URL_FIELD_NUMBER: _ClassVar[int]
    ACTUAL_REDIRECT_RESPONSE_CODE_FIELD_NUMBER: _ClassVar[int]
    ACTUAL_SERVICE_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_OUTPUT_URL_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_REDIRECT_RESPONSE_CODE_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_SERVICE_FIELD_NUMBER: _ClassVar[int]
    HEADERS_FIELD_NUMBER: _ClassVar[int]
    HOST_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    actual_output_url: str
    actual_redirect_response_code: int
    actual_service: str
    expected_output_url: str
    expected_redirect_response_code: int
    expected_service: str
    headers: _containers.RepeatedCompositeFieldContainer[UrlMapTestHeader]
    host: str
    path: str
    def __init__(self, actual_output_url: _Optional[str] = ..., actual_redirect_response_code: _Optional[int] = ..., actual_service: _Optional[str] = ..., expected_output_url: _Optional[str] = ..., expected_redirect_response_code: _Optional[int] = ..., expected_service: _Optional[str] = ..., headers: _Optional[_Iterable[_Union[UrlMapTestHeader, _Mapping]]] = ..., host: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class TestIamPermissionsBackendBucketRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsBackendServiceRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsDiskRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class TestIamPermissionsExternalVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsFirewallPolicyRequest(_message.Message):
    __slots__ = ("resource", "test_permissions_request_resource")
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsImageRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsInstanceRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class TestIamPermissionsInstanceTemplateRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsInstantSnapshotRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class TestIamPermissionsLicenseCodeRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsLicenseRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsMachineImageRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsNetworkAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsNetworkEndpointGroupRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class TestIamPermissionsNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsNodeGroupRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class TestIamPermissionsNodeTemplateRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsPacketMirroringRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsRegionBackendServiceRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsRegionDiskRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsRegionInstantSnapshotRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsRegionNetworkFirewallPolicyRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsReservationRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class TestIamPermissionsResourcePolicyRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsServiceAttachmentRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsSnapshotRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsStoragePoolRequest(_message.Message):
    __slots__ = ("project", "resource", "test_permissions_request_resource", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    zone: str
    def __init__(self, project: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class TestIamPermissionsSubnetworkRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestIamPermissionsVpnGatewayRequest(_message.Message):
    __slots__ = ("project", "region", "resource", "test_permissions_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    TEST_PERMISSIONS_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    resource: str
    test_permissions_request_resource: TestPermissionsRequest
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., resource: _Optional[str] = ..., test_permissions_request_resource: _Optional[_Union[TestPermissionsRequest, _Mapping]] = ...) -> None: ...

class TestPermissionsRequest(_message.Message):
    __slots__ = ("permissions",)
    PERMISSIONS_FIELD_NUMBER: _ClassVar[int]
    permissions: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, permissions: _Optional[_Iterable[str]] = ...) -> None: ...

class TestPermissionsResponse(_message.Message):
    __slots__ = ("permissions",)
    PERMISSIONS_FIELD_NUMBER: _ClassVar[int]
    permissions: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, permissions: _Optional[_Iterable[str]] = ...) -> None: ...

class Uint128(_message.Message):
    __slots__ = ("high", "low")
    HIGH_FIELD_NUMBER: _ClassVar[int]
    LOW_FIELD_NUMBER: _ClassVar[int]
    high: int
    low: int
    def __init__(self, high: _Optional[int] = ..., low: _Optional[int] = ...) -> None: ...

class UpcomingMaintenance(_message.Message):
    __slots__ = ("can_reschedule", "latest_window_start_time", "maintenance_status", "type", "window_end_time", "window_start_time")
    class MaintenanceStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MAINTENANCE_STATUS: _ClassVar[UpcomingMaintenance.MaintenanceStatus]
        ONGOING: _ClassVar[UpcomingMaintenance.MaintenanceStatus]
        PENDING: _ClassVar[UpcomingMaintenance.MaintenanceStatus]
        UNKNOWN: _ClassVar[UpcomingMaintenance.MaintenanceStatus]
    UNDEFINED_MAINTENANCE_STATUS: UpcomingMaintenance.MaintenanceStatus
    ONGOING: UpcomingMaintenance.MaintenanceStatus
    PENDING: UpcomingMaintenance.MaintenanceStatus
    UNKNOWN: UpcomingMaintenance.MaintenanceStatus
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[UpcomingMaintenance.Type]
        SCHEDULED: _ClassVar[UpcomingMaintenance.Type]
        UNKNOWN_TYPE: _ClassVar[UpcomingMaintenance.Type]
        UNSCHEDULED: _ClassVar[UpcomingMaintenance.Type]
    UNDEFINED_TYPE: UpcomingMaintenance.Type
    SCHEDULED: UpcomingMaintenance.Type
    UNKNOWN_TYPE: UpcomingMaintenance.Type
    UNSCHEDULED: UpcomingMaintenance.Type
    CAN_RESCHEDULE_FIELD_NUMBER: _ClassVar[int]
    LATEST_WINDOW_START_TIME_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_STATUS_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    WINDOW_END_TIME_FIELD_NUMBER: _ClassVar[int]
    WINDOW_START_TIME_FIELD_NUMBER: _ClassVar[int]
    can_reschedule: bool
    latest_window_start_time: str
    maintenance_status: str
    type: str
    window_end_time: str
    window_start_time: str
    def __init__(self, can_reschedule: bool = ..., latest_window_start_time: _Optional[str] = ..., maintenance_status: _Optional[str] = ..., type: _Optional[str] = ..., window_end_time: _Optional[str] = ..., window_start_time: _Optional[str] = ...) -> None: ...

class UpdateAccessConfigInstanceRequest(_message.Message):
    __slots__ = ("access_config_resource", "instance", "network_interface", "project", "request_id", "zone")
    ACCESS_CONFIG_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    access_config_resource: AccessConfig
    instance: str
    network_interface: str
    project: str
    request_id: str
    zone: str
    def __init__(self, access_config_resource: _Optional[_Union[AccessConfig, _Mapping]] = ..., instance: _Optional[str] = ..., network_interface: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "autoscaler_resource", "project", "request_id", "zone")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    AUTOSCALER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    autoscaler_resource: Autoscaler
    project: str
    request_id: str
    zone: str
    def __init__(self, autoscaler: _Optional[str] = ..., autoscaler_resource: _Optional[_Union[Autoscaler, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateBackendBucketRequest(_message.Message):
    __slots__ = ("backend_bucket", "backend_bucket_resource", "project", "request_id")
    BACKEND_BUCKET_FIELD_NUMBER: _ClassVar[int]
    BACKEND_BUCKET_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_bucket: str
    backend_bucket_resource: BackendBucket
    project: str
    request_id: str
    def __init__(self, backend_bucket: _Optional[str] = ..., backend_bucket_resource: _Optional[_Union[BackendBucket, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "backend_service_resource", "project", "request_id")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    BACKEND_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    backend_service_resource: BackendService
    project: str
    request_id: str
    def __init__(self, backend_service: _Optional[str] = ..., backend_service_resource: _Optional[_Union[BackendService, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateDiskRequest(_message.Message):
    __slots__ = ("disk", "disk_resource", "paths", "project", "request_id", "update_mask", "zone")
    DISK_FIELD_NUMBER: _ClassVar[int]
    DISK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PATHS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disk: str
    disk_resource: Disk
    paths: str
    project: str
    request_id: str
    update_mask: str
    zone: str
    def __init__(self, disk: _Optional[str] = ..., disk_resource: _Optional[_Union[Disk, _Mapping]] = ..., paths: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., update_mask: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateDisplayDeviceInstanceRequest(_message.Message):
    __slots__ = ("display_device_resource", "instance", "project", "request_id", "zone")
    DISPLAY_DEVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    display_device_resource: DisplayDevice
    instance: str
    project: str
    request_id: str
    zone: str
    def __init__(self, display_device_resource: _Optional[_Union[DisplayDevice, _Mapping]] = ..., instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateFirewallRequest(_message.Message):
    __slots__ = ("firewall", "firewall_resource", "project", "request_id")
    FIREWALL_FIELD_NUMBER: _ClassVar[int]
    FIREWALL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    firewall: str
    firewall_resource: Firewall
    project: str
    request_id: str
    def __init__(self, firewall: _Optional[str] = ..., firewall_resource: _Optional[_Union[Firewall, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "health_check_resource", "project", "request_id")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    health_check_resource: HealthCheck
    project: str
    request_id: str
    def __init__(self, health_check: _Optional[str] = ..., health_check_resource: _Optional[_Union[HealthCheck, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateInstanceRequest(_message.Message):
    __slots__ = ("instance", "instance_resource", "minimal_action", "most_disruptive_allowed_action", "project", "request_id", "zone")
    class MinimalAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MINIMAL_ACTION: _ClassVar[UpdateInstanceRequest.MinimalAction]
    UNDEFINED_MINIMAL_ACTION: UpdateInstanceRequest.MinimalAction
    class MostDisruptiveAllowedAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: _ClassVar[UpdateInstanceRequest.MostDisruptiveAllowedAction]
    UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION: UpdateInstanceRequest.MostDisruptiveAllowedAction
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    MINIMAL_ACTION_FIELD_NUMBER: _ClassVar[int]
    MOST_DISRUPTIVE_ALLOWED_ACTION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    instance_resource: Instance
    minimal_action: str
    most_disruptive_allowed_action: str
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., instance_resource: _Optional[_Union[Instance, _Mapping]] = ..., minimal_action: _Optional[str] = ..., most_disruptive_allowed_action: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateNetworkInterfaceInstanceRequest(_message.Message):
    __slots__ = ("instance", "network_interface", "network_interface_resource", "project", "request_id", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    network_interface: str
    network_interface_resource: NetworkInterface
    project: str
    request_id: str
    zone: str
    def __init__(self, instance: _Optional[str] = ..., network_interface: _Optional[str] = ..., network_interface_resource: _Optional[_Union[NetworkInterface, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdatePeeringNetworkRequest(_message.Message):
    __slots__ = ("network", "networks_update_peering_request_resource", "project", "request_id")
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    NETWORKS_UPDATE_PEERING_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    network: str
    networks_update_peering_request_resource: NetworksUpdatePeeringRequest
    project: str
    request_id: str
    def __init__(self, network: _Optional[str] = ..., networks_update_peering_request_resource: _Optional[_Union[NetworksUpdatePeeringRequest, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdatePerInstanceConfigsInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "instance_group_managers_update_per_instance_configs_req_resource", "project", "request_id", "zone")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_GROUP_MANAGERS_UPDATE_PER_INSTANCE_CONFIGS_REQ_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    instance_group_managers_update_per_instance_configs_req_resource: InstanceGroupManagersUpdatePerInstanceConfigsReq
    project: str
    request_id: str
    zone: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., instance_group_managers_update_per_instance_configs_req_resource: _Optional[_Union[InstanceGroupManagersUpdatePerInstanceConfigsReq, _Mapping]] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest(_message.Message):
    __slots__ = ("instance_group_manager", "project", "region", "region_instance_group_manager_update_instance_config_req_resource", "request_id")
    INSTANCE_GROUP_MANAGER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_INSTANCE_GROUP_MANAGER_UPDATE_INSTANCE_CONFIG_REQ_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    instance_group_manager: str
    project: str
    region: str
    region_instance_group_manager_update_instance_config_req_resource: RegionInstanceGroupManagerUpdateInstanceConfigReq
    request_id: str
    def __init__(self, instance_group_manager: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., region_instance_group_manager_update_instance_config_req_resource: _Optional[_Union[RegionInstanceGroupManagerUpdateInstanceConfigReq, _Mapping]] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateRegionAutoscalerRequest(_message.Message):
    __slots__ = ("autoscaler", "autoscaler_resource", "project", "region", "request_id")
    AUTOSCALER_FIELD_NUMBER: _ClassVar[int]
    AUTOSCALER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    autoscaler: str
    autoscaler_resource: Autoscaler
    project: str
    region: str
    request_id: str
    def __init__(self, autoscaler: _Optional[str] = ..., autoscaler_resource: _Optional[_Union[Autoscaler, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateRegionBackendServiceRequest(_message.Message):
    __slots__ = ("backend_service", "backend_service_resource", "project", "region", "request_id")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    BACKEND_SERVICE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    backend_service_resource: BackendService
    project: str
    region: str
    request_id: str
    def __init__(self, backend_service: _Optional[str] = ..., backend_service_resource: _Optional[_Union[BackendService, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateRegionCommitmentRequest(_message.Message):
    __slots__ = ("commitment", "commitment_resource", "paths", "project", "region", "request_id", "update_mask")
    COMMITMENT_FIELD_NUMBER: _ClassVar[int]
    COMMITMENT_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PATHS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    commitment: str
    commitment_resource: Commitment
    paths: str
    project: str
    region: str
    request_id: str
    update_mask: str
    def __init__(self, commitment: _Optional[str] = ..., commitment_resource: _Optional[_Union[Commitment, _Mapping]] = ..., paths: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., update_mask: _Optional[str] = ...) -> None: ...

class UpdateRegionDiskRequest(_message.Message):
    __slots__ = ("disk", "disk_resource", "paths", "project", "region", "request_id", "update_mask")
    DISK_FIELD_NUMBER: _ClassVar[int]
    DISK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PATHS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    disk: str
    disk_resource: Disk
    paths: str
    project: str
    region: str
    request_id: str
    update_mask: str
    def __init__(self, disk: _Optional[str] = ..., disk_resource: _Optional[_Union[Disk, _Mapping]] = ..., paths: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., update_mask: _Optional[str] = ...) -> None: ...

class UpdateRegionHealthCheckRequest(_message.Message):
    __slots__ = ("health_check", "health_check_resource", "project", "region", "request_id")
    HEALTH_CHECK_FIELD_NUMBER: _ClassVar[int]
    HEALTH_CHECK_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    health_check: str
    health_check_resource: HealthCheck
    project: str
    region: str
    request_id: str
    def __init__(self, health_check: _Optional[str] = ..., health_check_resource: _Optional[_Union[HealthCheck, _Mapping]] = ..., project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class UpdateRegionUrlMapRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "url_map", "url_map_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    url_map: str
    url_map_resource: UrlMap
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map: _Optional[str] = ..., url_map_resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class UpdateReservationRequest(_message.Message):
    __slots__ = ("paths", "project", "request_id", "reservation", "reservation_resource", "update_mask", "zone")
    PATHS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_FIELD_NUMBER: _ClassVar[int]
    RESERVATION_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    paths: str
    project: str
    request_id: str
    reservation: str
    reservation_resource: Reservation
    update_mask: str
    zone: str
    def __init__(self, paths: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., reservation: _Optional[str] = ..., reservation_resource: _Optional[_Union[Reservation, _Mapping]] = ..., update_mask: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateRouterRequest(_message.Message):
    __slots__ = ("project", "region", "request_id", "router", "router_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    ROUTER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    request_id: str
    router: str
    router_resource: Router
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ..., router: _Optional[str] = ..., router_resource: _Optional[_Union[Router, _Mapping]] = ...) -> None: ...

class UpdateShieldedInstanceConfigInstanceRequest(_message.Message):
    __slots__ = ("instance", "project", "request_id", "shielded_instance_config_resource", "zone")
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SHIELDED_INSTANCE_CONFIG_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    instance: str
    project: str
    request_id: str
    shielded_instance_config_resource: ShieldedInstanceConfig
    zone: str
    def __init__(self, instance: _Optional[str] = ..., project: _Optional[str] = ..., request_id: _Optional[str] = ..., shielded_instance_config_resource: _Optional[_Union[ShieldedInstanceConfig, _Mapping]] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateStoragePoolRequest(_message.Message):
    __slots__ = ("project", "request_id", "storage_pool", "storage_pool_resource", "update_mask", "zone")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_FIELD_NUMBER: _ClassVar[int]
    STORAGE_POOL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    storage_pool: str
    storage_pool_resource: StoragePool
    update_mask: str
    zone: str
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., storage_pool: _Optional[str] = ..., storage_pool_resource: _Optional[_Union[StoragePool, _Mapping]] = ..., update_mask: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class UpdateUrlMapRequest(_message.Message):
    __slots__ = ("project", "request_id", "url_map", "url_map_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    request_id: str
    url_map: str
    url_map_resource: UrlMap
    def __init__(self, project: _Optional[str] = ..., request_id: _Optional[str] = ..., url_map: _Optional[str] = ..., url_map_resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class UrlMap(_message.Message):
    __slots__ = ("creation_timestamp", "default_custom_error_response_policy", "default_route_action", "default_service", "default_url_redirect", "description", "fingerprint", "header_action", "host_rules", "id", "kind", "name", "path_matchers", "region", "self_link", "tests")
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_CUSTOM_ERROR_RESPONSE_POLICY_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_ROUTE_ACTION_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_SERVICE_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_URL_REDIRECT_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    HEADER_ACTION_FIELD_NUMBER: _ClassVar[int]
    HOST_RULES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PATH_MATCHERS_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    TESTS_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    default_custom_error_response_policy: CustomErrorResponsePolicy
    default_route_action: HttpRouteAction
    default_service: str
    default_url_redirect: HttpRedirectAction
    description: str
    fingerprint: str
    header_action: HttpHeaderAction
    host_rules: _containers.RepeatedCompositeFieldContainer[HostRule]
    id: int
    kind: str
    name: str
    path_matchers: _containers.RepeatedCompositeFieldContainer[PathMatcher]
    region: str
    self_link: str
    tests: _containers.RepeatedCompositeFieldContainer[UrlMapTest]
    def __init__(self, creation_timestamp: _Optional[str] = ..., default_custom_error_response_policy: _Optional[_Union[CustomErrorResponsePolicy, _Mapping]] = ..., default_route_action: _Optional[_Union[HttpRouteAction, _Mapping]] = ..., default_service: _Optional[str] = ..., default_url_redirect: _Optional[_Union[HttpRedirectAction, _Mapping]] = ..., description: _Optional[str] = ..., fingerprint: _Optional[str] = ..., header_action: _Optional[_Union[HttpHeaderAction, _Mapping]] = ..., host_rules: _Optional[_Iterable[_Union[HostRule, _Mapping]]] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., path_matchers: _Optional[_Iterable[_Union[PathMatcher, _Mapping]]] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., tests: _Optional[_Iterable[_Union[UrlMapTest, _Mapping]]] = ...) -> None: ...

class UrlMapList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[UrlMap]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[UrlMap, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class UrlMapReference(_message.Message):
    __slots__ = ("url_map",)
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    url_map: str
    def __init__(self, url_map: _Optional[str] = ...) -> None: ...

class UrlMapTest(_message.Message):
    __slots__ = ("description", "expected_output_url", "expected_redirect_response_code", "headers", "host", "path", "service")
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_OUTPUT_URL_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_REDIRECT_RESPONSE_CODE_FIELD_NUMBER: _ClassVar[int]
    HEADERS_FIELD_NUMBER: _ClassVar[int]
    HOST_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    description: str
    expected_output_url: str
    expected_redirect_response_code: int
    headers: _containers.RepeatedCompositeFieldContainer[UrlMapTestHeader]
    host: str
    path: str
    service: str
    def __init__(self, description: _Optional[str] = ..., expected_output_url: _Optional[str] = ..., expected_redirect_response_code: _Optional[int] = ..., headers: _Optional[_Iterable[_Union[UrlMapTestHeader, _Mapping]]] = ..., host: _Optional[str] = ..., path: _Optional[str] = ..., service: _Optional[str] = ...) -> None: ...

class UrlMapTestHeader(_message.Message):
    __slots__ = ("name", "value")
    NAME_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    name: str
    value: str
    def __init__(self, name: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class UrlMapValidationResult(_message.Message):
    __slots__ = ("load_errors", "load_succeeded", "test_failures", "test_passed")
    LOAD_ERRORS_FIELD_NUMBER: _ClassVar[int]
    LOAD_SUCCEEDED_FIELD_NUMBER: _ClassVar[int]
    TEST_FAILURES_FIELD_NUMBER: _ClassVar[int]
    TEST_PASSED_FIELD_NUMBER: _ClassVar[int]
    load_errors: _containers.RepeatedScalarFieldContainer[str]
    load_succeeded: bool
    test_failures: _containers.RepeatedCompositeFieldContainer[TestFailure]
    test_passed: bool
    def __init__(self, load_errors: _Optional[_Iterable[str]] = ..., load_succeeded: bool = ..., test_failures: _Optional[_Iterable[_Union[TestFailure, _Mapping]]] = ..., test_passed: bool = ...) -> None: ...

class UrlMapsAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: UrlMapsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[UrlMapsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, UrlMapsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, UrlMapsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class UrlMapsScopedList(_message.Message):
    __slots__ = ("url_maps", "warning")
    URL_MAPS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    url_maps: _containers.RepeatedCompositeFieldContainer[UrlMap]
    warning: Warning
    def __init__(self, url_maps: _Optional[_Iterable[_Union[UrlMap, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class UrlMapsValidateRequest(_message.Message):
    __slots__ = ("load_balancing_schemes", "resource")
    class LoadBalancingSchemes(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_LOAD_BALANCING_SCHEMES: _ClassVar[UrlMapsValidateRequest.LoadBalancingSchemes]
        EXTERNAL: _ClassVar[UrlMapsValidateRequest.LoadBalancingSchemes]
        EXTERNAL_MANAGED: _ClassVar[UrlMapsValidateRequest.LoadBalancingSchemes]
        LOAD_BALANCING_SCHEME_UNSPECIFIED: _ClassVar[UrlMapsValidateRequest.LoadBalancingSchemes]
    UNDEFINED_LOAD_BALANCING_SCHEMES: UrlMapsValidateRequest.LoadBalancingSchemes
    EXTERNAL: UrlMapsValidateRequest.LoadBalancingSchemes
    EXTERNAL_MANAGED: UrlMapsValidateRequest.LoadBalancingSchemes
    LOAD_BALANCING_SCHEME_UNSPECIFIED: UrlMapsValidateRequest.LoadBalancingSchemes
    LOAD_BALANCING_SCHEMES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_FIELD_NUMBER: _ClassVar[int]
    load_balancing_schemes: _containers.RepeatedScalarFieldContainer[str]
    resource: UrlMap
    def __init__(self, load_balancing_schemes: _Optional[_Iterable[str]] = ..., resource: _Optional[_Union[UrlMap, _Mapping]] = ...) -> None: ...

class UrlMapsValidateResponse(_message.Message):
    __slots__ = ("result",)
    RESULT_FIELD_NUMBER: _ClassVar[int]
    result: UrlMapValidationResult
    def __init__(self, result: _Optional[_Union[UrlMapValidationResult, _Mapping]] = ...) -> None: ...

class UrlRewrite(_message.Message):
    __slots__ = ("host_rewrite", "path_prefix_rewrite", "path_template_rewrite")
    HOST_REWRITE_FIELD_NUMBER: _ClassVar[int]
    PATH_PREFIX_REWRITE_FIELD_NUMBER: _ClassVar[int]
    PATH_TEMPLATE_REWRITE_FIELD_NUMBER: _ClassVar[int]
    host_rewrite: str
    path_prefix_rewrite: str
    path_template_rewrite: str
    def __init__(self, host_rewrite: _Optional[str] = ..., path_prefix_rewrite: _Optional[str] = ..., path_template_rewrite: _Optional[str] = ...) -> None: ...

class UsableSubnetwork(_message.Message):
    __slots__ = ("external_ipv6_prefix", "internal_ipv6_prefix", "ip_cidr_range", "ipv6_access_type", "network", "purpose", "role", "secondary_ip_ranges", "stack_type", "subnetwork")
    class Ipv6AccessType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_IPV6_ACCESS_TYPE: _ClassVar[UsableSubnetwork.Ipv6AccessType]
        EXTERNAL: _ClassVar[UsableSubnetwork.Ipv6AccessType]
        INTERNAL: _ClassVar[UsableSubnetwork.Ipv6AccessType]
    UNDEFINED_IPV6_ACCESS_TYPE: UsableSubnetwork.Ipv6AccessType
    EXTERNAL: UsableSubnetwork.Ipv6AccessType
    INTERNAL: UsableSubnetwork.Ipv6AccessType
    class Purpose(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_PURPOSE: _ClassVar[UsableSubnetwork.Purpose]
        GLOBAL_MANAGED_PROXY: _ClassVar[UsableSubnetwork.Purpose]
        INTERNAL_HTTPS_LOAD_BALANCER: _ClassVar[UsableSubnetwork.Purpose]
        PEER_MIGRATION: _ClassVar[UsableSubnetwork.Purpose]
        PRIVATE: _ClassVar[UsableSubnetwork.Purpose]
        PRIVATE_NAT: _ClassVar[UsableSubnetwork.Purpose]
        PRIVATE_RFC_1918: _ClassVar[UsableSubnetwork.Purpose]
        PRIVATE_SERVICE_CONNECT: _ClassVar[UsableSubnetwork.Purpose]
        REGIONAL_MANAGED_PROXY: _ClassVar[UsableSubnetwork.Purpose]
    UNDEFINED_PURPOSE: UsableSubnetwork.Purpose
    GLOBAL_MANAGED_PROXY: UsableSubnetwork.Purpose
    INTERNAL_HTTPS_LOAD_BALANCER: UsableSubnetwork.Purpose
    PEER_MIGRATION: UsableSubnetwork.Purpose
    PRIVATE: UsableSubnetwork.Purpose
    PRIVATE_NAT: UsableSubnetwork.Purpose
    PRIVATE_RFC_1918: UsableSubnetwork.Purpose
    PRIVATE_SERVICE_CONNECT: UsableSubnetwork.Purpose
    REGIONAL_MANAGED_PROXY: UsableSubnetwork.Purpose
    class Role(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_ROLE: _ClassVar[UsableSubnetwork.Role]
        ACTIVE: _ClassVar[UsableSubnetwork.Role]
        BACKUP: _ClassVar[UsableSubnetwork.Role]
    UNDEFINED_ROLE: UsableSubnetwork.Role
    ACTIVE: UsableSubnetwork.Role
    BACKUP: UsableSubnetwork.Role
    class StackType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STACK_TYPE: _ClassVar[UsableSubnetwork.StackType]
        IPV4_IPV6: _ClassVar[UsableSubnetwork.StackType]
        IPV4_ONLY: _ClassVar[UsableSubnetwork.StackType]
        IPV6_ONLY: _ClassVar[UsableSubnetwork.StackType]
    UNDEFINED_STACK_TYPE: UsableSubnetwork.StackType
    IPV4_IPV6: UsableSubnetwork.StackType
    IPV4_ONLY: UsableSubnetwork.StackType
    IPV6_ONLY: UsableSubnetwork.StackType
    EXTERNAL_IPV6_PREFIX_FIELD_NUMBER: _ClassVar[int]
    INTERNAL_IPV6_PREFIX_FIELD_NUMBER: _ClassVar[int]
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    IPV6_ACCESS_TYPE_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    PURPOSE_FIELD_NUMBER: _ClassVar[int]
    ROLE_FIELD_NUMBER: _ClassVar[int]
    SECONDARY_IP_RANGES_FIELD_NUMBER: _ClassVar[int]
    STACK_TYPE_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    external_ipv6_prefix: str
    internal_ipv6_prefix: str
    ip_cidr_range: str
    ipv6_access_type: str
    network: str
    purpose: str
    role: str
    secondary_ip_ranges: _containers.RepeatedCompositeFieldContainer[UsableSubnetworkSecondaryRange]
    stack_type: str
    subnetwork: str
    def __init__(self, external_ipv6_prefix: _Optional[str] = ..., internal_ipv6_prefix: _Optional[str] = ..., ip_cidr_range: _Optional[str] = ..., ipv6_access_type: _Optional[str] = ..., network: _Optional[str] = ..., purpose: _Optional[str] = ..., role: _Optional[str] = ..., secondary_ip_ranges: _Optional[_Iterable[_Union[UsableSubnetworkSecondaryRange, _Mapping]]] = ..., stack_type: _Optional[str] = ..., subnetwork: _Optional[str] = ...) -> None: ...

class UsableSubnetworkSecondaryRange(_message.Message):
    __slots__ = ("ip_cidr_range", "range_name")
    IP_CIDR_RANGE_FIELD_NUMBER: _ClassVar[int]
    RANGE_NAME_FIELD_NUMBER: _ClassVar[int]
    ip_cidr_range: str
    range_name: str
    def __init__(self, ip_cidr_range: _Optional[str] = ..., range_name: _Optional[str] = ...) -> None: ...

class UsableSubnetworksAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[UsableSubnetwork]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[UsableSubnetwork, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class UsageExportLocation(_message.Message):
    __slots__ = ("bucket_name", "report_name_prefix")
    BUCKET_NAME_FIELD_NUMBER: _ClassVar[int]
    REPORT_NAME_PREFIX_FIELD_NUMBER: _ClassVar[int]
    bucket_name: str
    report_name_prefix: str
    def __init__(self, bucket_name: _Optional[str] = ..., report_name_prefix: _Optional[str] = ...) -> None: ...

class ValidateRegionUrlMapRequest(_message.Message):
    __slots__ = ("project", "region", "region_url_maps_validate_request_resource", "url_map")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REGION_URL_MAPS_VALIDATE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    project: str
    region: str
    region_url_maps_validate_request_resource: RegionUrlMapsValidateRequest
    url_map: str
    def __init__(self, project: _Optional[str] = ..., region: _Optional[str] = ..., region_url_maps_validate_request_resource: _Optional[_Union[RegionUrlMapsValidateRequest, _Mapping]] = ..., url_map: _Optional[str] = ...) -> None: ...

class ValidateUrlMapRequest(_message.Message):
    __slots__ = ("project", "url_map", "url_maps_validate_request_resource")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    URL_MAP_FIELD_NUMBER: _ClassVar[int]
    URL_MAPS_VALIDATE_REQUEST_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project: str
    url_map: str
    url_maps_validate_request_resource: UrlMapsValidateRequest
    def __init__(self, project: _Optional[str] = ..., url_map: _Optional[str] = ..., url_maps_validate_request_resource: _Optional[_Union[UrlMapsValidateRequest, _Mapping]] = ...) -> None: ...

class VmEndpointNatMappings(_message.Message):
    __slots__ = ("instance_name", "interface_nat_mappings")
    INSTANCE_NAME_FIELD_NUMBER: _ClassVar[int]
    INTERFACE_NAT_MAPPINGS_FIELD_NUMBER: _ClassVar[int]
    instance_name: str
    interface_nat_mappings: _containers.RepeatedCompositeFieldContainer[VmEndpointNatMappingsInterfaceNatMappings]
    def __init__(self, instance_name: _Optional[str] = ..., interface_nat_mappings: _Optional[_Iterable[_Union[VmEndpointNatMappingsInterfaceNatMappings, _Mapping]]] = ...) -> None: ...

class VmEndpointNatMappingsInterfaceNatMappings(_message.Message):
    __slots__ = ("drain_nat_ip_port_ranges", "nat_ip_port_ranges", "num_total_drain_nat_ports", "num_total_nat_ports", "rule_mappings", "source_alias_ip_range", "source_virtual_ip")
    DRAIN_NAT_IP_PORT_RANGES_FIELD_NUMBER: _ClassVar[int]
    NAT_IP_PORT_RANGES_FIELD_NUMBER: _ClassVar[int]
    NUM_TOTAL_DRAIN_NAT_PORTS_FIELD_NUMBER: _ClassVar[int]
    NUM_TOTAL_NAT_PORTS_FIELD_NUMBER: _ClassVar[int]
    RULE_MAPPINGS_FIELD_NUMBER: _ClassVar[int]
    SOURCE_ALIAS_IP_RANGE_FIELD_NUMBER: _ClassVar[int]
    SOURCE_VIRTUAL_IP_FIELD_NUMBER: _ClassVar[int]
    drain_nat_ip_port_ranges: _containers.RepeatedScalarFieldContainer[str]
    nat_ip_port_ranges: _containers.RepeatedScalarFieldContainer[str]
    num_total_drain_nat_ports: int
    num_total_nat_ports: int
    rule_mappings: _containers.RepeatedCompositeFieldContainer[VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings]
    source_alias_ip_range: str
    source_virtual_ip: str
    def __init__(self, drain_nat_ip_port_ranges: _Optional[_Iterable[str]] = ..., nat_ip_port_ranges: _Optional[_Iterable[str]] = ..., num_total_drain_nat_ports: _Optional[int] = ..., num_total_nat_ports: _Optional[int] = ..., rule_mappings: _Optional[_Iterable[_Union[VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings, _Mapping]]] = ..., source_alias_ip_range: _Optional[str] = ..., source_virtual_ip: _Optional[str] = ...) -> None: ...

class VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings(_message.Message):
    __slots__ = ("drain_nat_ip_port_ranges", "nat_ip_port_ranges", "num_total_drain_nat_ports", "num_total_nat_ports", "rule_number")
    DRAIN_NAT_IP_PORT_RANGES_FIELD_NUMBER: _ClassVar[int]
    NAT_IP_PORT_RANGES_FIELD_NUMBER: _ClassVar[int]
    NUM_TOTAL_DRAIN_NAT_PORTS_FIELD_NUMBER: _ClassVar[int]
    NUM_TOTAL_NAT_PORTS_FIELD_NUMBER: _ClassVar[int]
    RULE_NUMBER_FIELD_NUMBER: _ClassVar[int]
    drain_nat_ip_port_ranges: _containers.RepeatedScalarFieldContainer[str]
    nat_ip_port_ranges: _containers.RepeatedScalarFieldContainer[str]
    num_total_drain_nat_ports: int
    num_total_nat_ports: int
    rule_number: int
    def __init__(self, drain_nat_ip_port_ranges: _Optional[_Iterable[str]] = ..., nat_ip_port_ranges: _Optional[_Iterable[str]] = ..., num_total_drain_nat_ports: _Optional[int] = ..., num_total_nat_ports: _Optional[int] = ..., rule_number: _Optional[int] = ...) -> None: ...

class VmEndpointNatMappingsList(_message.Message):
    __slots__ = ("id", "kind", "next_page_token", "result", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    kind: str
    next_page_token: str
    result: _containers.RepeatedCompositeFieldContainer[VmEndpointNatMappings]
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., result: _Optional[_Iterable[_Union[VmEndpointNatMappings, _Mapping]]] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class VpnGateway(_message.Message):
    __slots__ = ("creation_timestamp", "description", "gateway_ip_version", "id", "kind", "label_fingerprint", "labels", "name", "network", "region", "self_link", "stack_type", "vpn_interfaces")
    class GatewayIpVersion(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_GATEWAY_IP_VERSION: _ClassVar[VpnGateway.GatewayIpVersion]
        IPV4: _ClassVar[VpnGateway.GatewayIpVersion]
        IPV6: _ClassVar[VpnGateway.GatewayIpVersion]
    UNDEFINED_GATEWAY_IP_VERSION: VpnGateway.GatewayIpVersion
    IPV4: VpnGateway.GatewayIpVersion
    IPV6: VpnGateway.GatewayIpVersion
    class StackType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STACK_TYPE: _ClassVar[VpnGateway.StackType]
        IPV4_IPV6: _ClassVar[VpnGateway.StackType]
        IPV4_ONLY: _ClassVar[VpnGateway.StackType]
        IPV6_ONLY: _ClassVar[VpnGateway.StackType]
    UNDEFINED_STACK_TYPE: VpnGateway.StackType
    IPV4_IPV6: VpnGateway.StackType
    IPV4_ONLY: VpnGateway.StackType
    IPV6_ONLY: VpnGateway.StackType
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    GATEWAY_IP_VERSION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STACK_TYPE_FIELD_NUMBER: _ClassVar[int]
    VPN_INTERFACES_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    gateway_ip_version: str
    id: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    name: str
    network: str
    region: str
    self_link: str
    stack_type: str
    vpn_interfaces: _containers.RepeatedCompositeFieldContainer[VpnGatewayVpnGatewayInterface]
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., gateway_ip_version: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., name: _Optional[str] = ..., network: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., stack_type: _Optional[str] = ..., vpn_interfaces: _Optional[_Iterable[_Union[VpnGatewayVpnGatewayInterface, _Mapping]]] = ...) -> None: ...

class VpnGatewayAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: VpnGatewaysScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[VpnGatewaysScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, VpnGatewaysScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, VpnGatewaysScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class VpnGatewayList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[VpnGateway]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[VpnGateway, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class VpnGatewayStatus(_message.Message):
    __slots__ = ("vpn_connections",)
    VPN_CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    vpn_connections: _containers.RepeatedCompositeFieldContainer[VpnGatewayStatusVpnConnection]
    def __init__(self, vpn_connections: _Optional[_Iterable[_Union[VpnGatewayStatusVpnConnection, _Mapping]]] = ...) -> None: ...

class VpnGatewayStatusHighAvailabilityRequirementState(_message.Message):
    __slots__ = ("state", "unsatisfied_reason")
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATE: _ClassVar[VpnGatewayStatusHighAvailabilityRequirementState.State]
        CONNECTION_REDUNDANCY_MET: _ClassVar[VpnGatewayStatusHighAvailabilityRequirementState.State]
        CONNECTION_REDUNDANCY_NOT_MET: _ClassVar[VpnGatewayStatusHighAvailabilityRequirementState.State]
    UNDEFINED_STATE: VpnGatewayStatusHighAvailabilityRequirementState.State
    CONNECTION_REDUNDANCY_MET: VpnGatewayStatusHighAvailabilityRequirementState.State
    CONNECTION_REDUNDANCY_NOT_MET: VpnGatewayStatusHighAvailabilityRequirementState.State
    class UnsatisfiedReason(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_UNSATISFIED_REASON: _ClassVar[VpnGatewayStatusHighAvailabilityRequirementState.UnsatisfiedReason]
        INCOMPLETE_TUNNELS_COVERAGE: _ClassVar[VpnGatewayStatusHighAvailabilityRequirementState.UnsatisfiedReason]
    UNDEFINED_UNSATISFIED_REASON: VpnGatewayStatusHighAvailabilityRequirementState.UnsatisfiedReason
    INCOMPLETE_TUNNELS_COVERAGE: VpnGatewayStatusHighAvailabilityRequirementState.UnsatisfiedReason
    STATE_FIELD_NUMBER: _ClassVar[int]
    UNSATISFIED_REASON_FIELD_NUMBER: _ClassVar[int]
    state: str
    unsatisfied_reason: str
    def __init__(self, state: _Optional[str] = ..., unsatisfied_reason: _Optional[str] = ...) -> None: ...

class VpnGatewayStatusTunnel(_message.Message):
    __slots__ = ("local_gateway_interface", "peer_gateway_interface", "tunnel_url")
    LOCAL_GATEWAY_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    PEER_GATEWAY_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    TUNNEL_URL_FIELD_NUMBER: _ClassVar[int]
    local_gateway_interface: int
    peer_gateway_interface: int
    tunnel_url: str
    def __init__(self, local_gateway_interface: _Optional[int] = ..., peer_gateway_interface: _Optional[int] = ..., tunnel_url: _Optional[str] = ...) -> None: ...

class VpnGatewayStatusVpnConnection(_message.Message):
    __slots__ = ("peer_external_gateway", "peer_gcp_gateway", "state", "tunnels")
    PEER_EXTERNAL_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    PEER_GCP_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TUNNELS_FIELD_NUMBER: _ClassVar[int]
    peer_external_gateway: str
    peer_gcp_gateway: str
    state: VpnGatewayStatusHighAvailabilityRequirementState
    tunnels: _containers.RepeatedCompositeFieldContainer[VpnGatewayStatusTunnel]
    def __init__(self, peer_external_gateway: _Optional[str] = ..., peer_gcp_gateway: _Optional[str] = ..., state: _Optional[_Union[VpnGatewayStatusHighAvailabilityRequirementState, _Mapping]] = ..., tunnels: _Optional[_Iterable[_Union[VpnGatewayStatusTunnel, _Mapping]]] = ...) -> None: ...

class VpnGatewayVpnGatewayInterface(_message.Message):
    __slots__ = ("id", "interconnect_attachment", "ip_address", "ipv6_address")
    ID_FIELD_NUMBER: _ClassVar[int]
    INTERCONNECT_ATTACHMENT_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    IPV6_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    id: int
    interconnect_attachment: str
    ip_address: str
    ipv6_address: str
    def __init__(self, id: _Optional[int] = ..., interconnect_attachment: _Optional[str] = ..., ip_address: _Optional[str] = ..., ipv6_address: _Optional[str] = ...) -> None: ...

class VpnGatewaysGetStatusResponse(_message.Message):
    __slots__ = ("result",)
    RESULT_FIELD_NUMBER: _ClassVar[int]
    result: VpnGatewayStatus
    def __init__(self, result: _Optional[_Union[VpnGatewayStatus, _Mapping]] = ...) -> None: ...

class VpnGatewaysScopedList(_message.Message):
    __slots__ = ("vpn_gateways", "warning")
    VPN_GATEWAYS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    vpn_gateways: _containers.RepeatedCompositeFieldContainer[VpnGateway]
    warning: Warning
    def __init__(self, vpn_gateways: _Optional[_Iterable[_Union[VpnGateway, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class VpnTunnel(_message.Message):
    __slots__ = ("creation_timestamp", "description", "detailed_status", "id", "ike_version", "kind", "label_fingerprint", "labels", "local_traffic_selector", "name", "peer_external_gateway", "peer_external_gateway_interface", "peer_gcp_gateway", "peer_ip", "region", "remote_traffic_selector", "router", "self_link", "shared_secret", "shared_secret_hash", "status", "target_vpn_gateway", "vpn_gateway", "vpn_gateway_interface")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[VpnTunnel.Status]
        ALLOCATING_RESOURCES: _ClassVar[VpnTunnel.Status]
        AUTHORIZATION_ERROR: _ClassVar[VpnTunnel.Status]
        DEPROVISIONING: _ClassVar[VpnTunnel.Status]
        ESTABLISHED: _ClassVar[VpnTunnel.Status]
        FAILED: _ClassVar[VpnTunnel.Status]
        FIRST_HANDSHAKE: _ClassVar[VpnTunnel.Status]
        NEGOTIATION_FAILURE: _ClassVar[VpnTunnel.Status]
        NETWORK_ERROR: _ClassVar[VpnTunnel.Status]
        NO_INCOMING_PACKETS: _ClassVar[VpnTunnel.Status]
        PROVISIONING: _ClassVar[VpnTunnel.Status]
        REJECTED: _ClassVar[VpnTunnel.Status]
        STOPPED: _ClassVar[VpnTunnel.Status]
        WAITING_FOR_FULL_CONFIG: _ClassVar[VpnTunnel.Status]
    UNDEFINED_STATUS: VpnTunnel.Status
    ALLOCATING_RESOURCES: VpnTunnel.Status
    AUTHORIZATION_ERROR: VpnTunnel.Status
    DEPROVISIONING: VpnTunnel.Status
    ESTABLISHED: VpnTunnel.Status
    FAILED: VpnTunnel.Status
    FIRST_HANDSHAKE: VpnTunnel.Status
    NEGOTIATION_FAILURE: VpnTunnel.Status
    NETWORK_ERROR: VpnTunnel.Status
    NO_INCOMING_PACKETS: VpnTunnel.Status
    PROVISIONING: VpnTunnel.Status
    REJECTED: VpnTunnel.Status
    STOPPED: VpnTunnel.Status
    WAITING_FOR_FULL_CONFIG: VpnTunnel.Status
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DETAILED_STATUS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    IKE_VERSION_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    LOCAL_TRAFFIC_SELECTOR_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PEER_EXTERNAL_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    PEER_EXTERNAL_GATEWAY_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    PEER_GCP_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    PEER_IP_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REMOTE_TRAFFIC_SELECTOR_FIELD_NUMBER: _ClassVar[int]
    ROUTER_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    SHARED_SECRET_FIELD_NUMBER: _ClassVar[int]
    SHARED_SECRET_HASH_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TARGET_VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    VPN_GATEWAY_FIELD_NUMBER: _ClassVar[int]
    VPN_GATEWAY_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    creation_timestamp: str
    description: str
    detailed_status: str
    id: int
    ike_version: int
    kind: str
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    local_traffic_selector: _containers.RepeatedScalarFieldContainer[str]
    name: str
    peer_external_gateway: str
    peer_external_gateway_interface: int
    peer_gcp_gateway: str
    peer_ip: str
    region: str
    remote_traffic_selector: _containers.RepeatedScalarFieldContainer[str]
    router: str
    self_link: str
    shared_secret: str
    shared_secret_hash: str
    status: str
    target_vpn_gateway: str
    vpn_gateway: str
    vpn_gateway_interface: int
    def __init__(self, creation_timestamp: _Optional[str] = ..., description: _Optional[str] = ..., detailed_status: _Optional[str] = ..., id: _Optional[int] = ..., ike_version: _Optional[int] = ..., kind: _Optional[str] = ..., label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ..., local_traffic_selector: _Optional[_Iterable[str]] = ..., name: _Optional[str] = ..., peer_external_gateway: _Optional[str] = ..., peer_external_gateway_interface: _Optional[int] = ..., peer_gcp_gateway: _Optional[str] = ..., peer_ip: _Optional[str] = ..., region: _Optional[str] = ..., remote_traffic_selector: _Optional[_Iterable[str]] = ..., router: _Optional[str] = ..., self_link: _Optional[str] = ..., shared_secret: _Optional[str] = ..., shared_secret_hash: _Optional[str] = ..., status: _Optional[str] = ..., target_vpn_gateway: _Optional[str] = ..., vpn_gateway: _Optional[str] = ..., vpn_gateway_interface: _Optional[int] = ...) -> None: ...

class VpnTunnelAggregatedList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "unreachables", "warning")
    class ItemsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: VpnTunnelsScopedList
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[VpnTunnelsScopedList, _Mapping]] = ...) -> None: ...
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    UNREACHABLES_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.MessageMap[str, VpnTunnelsScopedList]
    kind: str
    next_page_token: str
    self_link: str
    unreachables: _containers.RepeatedScalarFieldContainer[str]
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Mapping[str, VpnTunnelsScopedList]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., unreachables: _Optional[_Iterable[str]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class VpnTunnelList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[VpnTunnel]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[VpnTunnel, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class VpnTunnelsScopedList(_message.Message):
    __slots__ = ("vpn_tunnels", "warning")
    VPN_TUNNELS_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    vpn_tunnels: _containers.RepeatedCompositeFieldContainer[VpnTunnel]
    warning: Warning
    def __init__(self, vpn_tunnels: _Optional[_Iterable[_Union[VpnTunnel, _Mapping]]] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class WafExpressionSet(_message.Message):
    __slots__ = ("aliases", "expressions", "id")
    ALIASES_FIELD_NUMBER: _ClassVar[int]
    EXPRESSIONS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    aliases: _containers.RepeatedScalarFieldContainer[str]
    expressions: _containers.RepeatedCompositeFieldContainer[WafExpressionSetExpression]
    id: str
    def __init__(self, aliases: _Optional[_Iterable[str]] = ..., expressions: _Optional[_Iterable[_Union[WafExpressionSetExpression, _Mapping]]] = ..., id: _Optional[str] = ...) -> None: ...

class WafExpressionSetExpression(_message.Message):
    __slots__ = ("id", "sensitivity")
    ID_FIELD_NUMBER: _ClassVar[int]
    SENSITIVITY_FIELD_NUMBER: _ClassVar[int]
    id: str
    sensitivity: int
    def __init__(self, id: _Optional[str] = ..., sensitivity: _Optional[int] = ...) -> None: ...

class WaitGlobalOperationRequest(_message.Message):
    __slots__ = ("operation", "project")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class WaitRegionOperationRequest(_message.Message):
    __slots__ = ("operation", "project", "region")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    region: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ..., region: _Optional[str] = ...) -> None: ...

class WaitZoneOperationRequest(_message.Message):
    __slots__ = ("operation", "project", "zone")
    OPERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    operation: str
    project: str
    zone: str
    def __init__(self, operation: _Optional[str] = ..., project: _Optional[str] = ..., zone: _Optional[str] = ...) -> None: ...

class Warning(_message.Message):
    __slots__ = ("code", "data", "message")
    class Code(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CODE: _ClassVar[Warning.Code]
        CLEANUP_FAILED: _ClassVar[Warning.Code]
        DEPRECATED_RESOURCE_USED: _ClassVar[Warning.Code]
        DEPRECATED_TYPE_USED: _ClassVar[Warning.Code]
        DISK_SIZE_LARGER_THAN_IMAGE_SIZE: _ClassVar[Warning.Code]
        EXPERIMENTAL_TYPE_USED: _ClassVar[Warning.Code]
        EXTERNAL_API_WARNING: _ClassVar[Warning.Code]
        FIELD_VALUE_OVERRIDEN: _ClassVar[Warning.Code]
        INJECTED_KERNELS_DEPRECATED: _ClassVar[Warning.Code]
        INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB: _ClassVar[Warning.Code]
        LARGE_DEPLOYMENT_WARNING: _ClassVar[Warning.Code]
        LIST_OVERHEAD_QUOTA_EXCEED: _ClassVar[Warning.Code]
        MISSING_TYPE_DEPENDENCY: _ClassVar[Warning.Code]
        NEXT_HOP_ADDRESS_NOT_ASSIGNED: _ClassVar[Warning.Code]
        NEXT_HOP_CANNOT_IP_FORWARD: _ClassVar[Warning.Code]
        NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE: _ClassVar[Warning.Code]
        NEXT_HOP_INSTANCE_NOT_FOUND: _ClassVar[Warning.Code]
        NEXT_HOP_INSTANCE_NOT_ON_NETWORK: _ClassVar[Warning.Code]
        NEXT_HOP_NOT_RUNNING: _ClassVar[Warning.Code]
        NOT_CRITICAL_ERROR: _ClassVar[Warning.Code]
        NO_RESULTS_ON_PAGE: _ClassVar[Warning.Code]
        PARTIAL_SUCCESS: _ClassVar[Warning.Code]
        QUOTA_INFO_UNAVAILABLE: _ClassVar[Warning.Code]
        REQUIRED_TOS_AGREEMENT: _ClassVar[Warning.Code]
        RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING: _ClassVar[Warning.Code]
        RESOURCE_NOT_DELETED: _ClassVar[Warning.Code]
        SCHEMA_VALIDATION_IGNORED: _ClassVar[Warning.Code]
        SINGLE_INSTANCE_PROPERTY_TEMPLATE: _ClassVar[Warning.Code]
        UNDECLARED_PROPERTIES: _ClassVar[Warning.Code]
        UNREACHABLE: _ClassVar[Warning.Code]
    UNDEFINED_CODE: Warning.Code
    CLEANUP_FAILED: Warning.Code
    DEPRECATED_RESOURCE_USED: Warning.Code
    DEPRECATED_TYPE_USED: Warning.Code
    DISK_SIZE_LARGER_THAN_IMAGE_SIZE: Warning.Code
    EXPERIMENTAL_TYPE_USED: Warning.Code
    EXTERNAL_API_WARNING: Warning.Code
    FIELD_VALUE_OVERRIDEN: Warning.Code
    INJECTED_KERNELS_DEPRECATED: Warning.Code
    INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB: Warning.Code
    LARGE_DEPLOYMENT_WARNING: Warning.Code
    LIST_OVERHEAD_QUOTA_EXCEED: Warning.Code
    MISSING_TYPE_DEPENDENCY: Warning.Code
    NEXT_HOP_ADDRESS_NOT_ASSIGNED: Warning.Code
    NEXT_HOP_CANNOT_IP_FORWARD: Warning.Code
    NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE: Warning.Code
    NEXT_HOP_INSTANCE_NOT_FOUND: Warning.Code
    NEXT_HOP_INSTANCE_NOT_ON_NETWORK: Warning.Code
    NEXT_HOP_NOT_RUNNING: Warning.Code
    NOT_CRITICAL_ERROR: Warning.Code
    NO_RESULTS_ON_PAGE: Warning.Code
    PARTIAL_SUCCESS: Warning.Code
    QUOTA_INFO_UNAVAILABLE: Warning.Code
    REQUIRED_TOS_AGREEMENT: Warning.Code
    RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING: Warning.Code
    RESOURCE_NOT_DELETED: Warning.Code
    SCHEMA_VALIDATION_IGNORED: Warning.Code
    SINGLE_INSTANCE_PROPERTY_TEMPLATE: Warning.Code
    UNDECLARED_PROPERTIES: Warning.Code
    UNREACHABLE: Warning.Code
    CODE_FIELD_NUMBER: _ClassVar[int]
    DATA_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    code: str
    data: _containers.RepeatedCompositeFieldContainer[Data]
    message: str
    def __init__(self, code: _Optional[str] = ..., data: _Optional[_Iterable[_Union[Data, _Mapping]]] = ..., message: _Optional[str] = ...) -> None: ...

class Warnings(_message.Message):
    __slots__ = ("code", "data", "message")
    class Code(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_CODE: _ClassVar[Warnings.Code]
        CLEANUP_FAILED: _ClassVar[Warnings.Code]
        DEPRECATED_RESOURCE_USED: _ClassVar[Warnings.Code]
        DEPRECATED_TYPE_USED: _ClassVar[Warnings.Code]
        DISK_SIZE_LARGER_THAN_IMAGE_SIZE: _ClassVar[Warnings.Code]
        EXPERIMENTAL_TYPE_USED: _ClassVar[Warnings.Code]
        EXTERNAL_API_WARNING: _ClassVar[Warnings.Code]
        FIELD_VALUE_OVERRIDEN: _ClassVar[Warnings.Code]
        INJECTED_KERNELS_DEPRECATED: _ClassVar[Warnings.Code]
        INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB: _ClassVar[Warnings.Code]
        LARGE_DEPLOYMENT_WARNING: _ClassVar[Warnings.Code]
        LIST_OVERHEAD_QUOTA_EXCEED: _ClassVar[Warnings.Code]
        MISSING_TYPE_DEPENDENCY: _ClassVar[Warnings.Code]
        NEXT_HOP_ADDRESS_NOT_ASSIGNED: _ClassVar[Warnings.Code]
        NEXT_HOP_CANNOT_IP_FORWARD: _ClassVar[Warnings.Code]
        NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE: _ClassVar[Warnings.Code]
        NEXT_HOP_INSTANCE_NOT_FOUND: _ClassVar[Warnings.Code]
        NEXT_HOP_INSTANCE_NOT_ON_NETWORK: _ClassVar[Warnings.Code]
        NEXT_HOP_NOT_RUNNING: _ClassVar[Warnings.Code]
        NOT_CRITICAL_ERROR: _ClassVar[Warnings.Code]
        NO_RESULTS_ON_PAGE: _ClassVar[Warnings.Code]
        PARTIAL_SUCCESS: _ClassVar[Warnings.Code]
        QUOTA_INFO_UNAVAILABLE: _ClassVar[Warnings.Code]
        REQUIRED_TOS_AGREEMENT: _ClassVar[Warnings.Code]
        RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING: _ClassVar[Warnings.Code]
        RESOURCE_NOT_DELETED: _ClassVar[Warnings.Code]
        SCHEMA_VALIDATION_IGNORED: _ClassVar[Warnings.Code]
        SINGLE_INSTANCE_PROPERTY_TEMPLATE: _ClassVar[Warnings.Code]
        UNDECLARED_PROPERTIES: _ClassVar[Warnings.Code]
        UNREACHABLE: _ClassVar[Warnings.Code]
    UNDEFINED_CODE: Warnings.Code
    CLEANUP_FAILED: Warnings.Code
    DEPRECATED_RESOURCE_USED: Warnings.Code
    DEPRECATED_TYPE_USED: Warnings.Code
    DISK_SIZE_LARGER_THAN_IMAGE_SIZE: Warnings.Code
    EXPERIMENTAL_TYPE_USED: Warnings.Code
    EXTERNAL_API_WARNING: Warnings.Code
    FIELD_VALUE_OVERRIDEN: Warnings.Code
    INJECTED_KERNELS_DEPRECATED: Warnings.Code
    INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB: Warnings.Code
    LARGE_DEPLOYMENT_WARNING: Warnings.Code
    LIST_OVERHEAD_QUOTA_EXCEED: Warnings.Code
    MISSING_TYPE_DEPENDENCY: Warnings.Code
    NEXT_HOP_ADDRESS_NOT_ASSIGNED: Warnings.Code
    NEXT_HOP_CANNOT_IP_FORWARD: Warnings.Code
    NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE: Warnings.Code
    NEXT_HOP_INSTANCE_NOT_FOUND: Warnings.Code
    NEXT_HOP_INSTANCE_NOT_ON_NETWORK: Warnings.Code
    NEXT_HOP_NOT_RUNNING: Warnings.Code
    NOT_CRITICAL_ERROR: Warnings.Code
    NO_RESULTS_ON_PAGE: Warnings.Code
    PARTIAL_SUCCESS: Warnings.Code
    QUOTA_INFO_UNAVAILABLE: Warnings.Code
    REQUIRED_TOS_AGREEMENT: Warnings.Code
    RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING: Warnings.Code
    RESOURCE_NOT_DELETED: Warnings.Code
    SCHEMA_VALIDATION_IGNORED: Warnings.Code
    SINGLE_INSTANCE_PROPERTY_TEMPLATE: Warnings.Code
    UNDECLARED_PROPERTIES: Warnings.Code
    UNREACHABLE: Warnings.Code
    CODE_FIELD_NUMBER: _ClassVar[int]
    DATA_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    code: str
    data: _containers.RepeatedCompositeFieldContainer[Data]
    message: str
    def __init__(self, code: _Optional[str] = ..., data: _Optional[_Iterable[_Union[Data, _Mapping]]] = ..., message: _Optional[str] = ...) -> None: ...

class WeightedBackendService(_message.Message):
    __slots__ = ("backend_service", "header_action", "weight")
    BACKEND_SERVICE_FIELD_NUMBER: _ClassVar[int]
    HEADER_ACTION_FIELD_NUMBER: _ClassVar[int]
    WEIGHT_FIELD_NUMBER: _ClassVar[int]
    backend_service: str
    header_action: HttpHeaderAction
    weight: int
    def __init__(self, backend_service: _Optional[str] = ..., header_action: _Optional[_Union[HttpHeaderAction, _Mapping]] = ..., weight: _Optional[int] = ...) -> None: ...

class WithdrawPublicAdvertisedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_advertised_prefix", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_ADVERTISED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_advertised_prefix: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_advertised_prefix: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class WithdrawPublicDelegatedPrefixeRequest(_message.Message):
    __slots__ = ("project", "public_delegated_prefix", "region", "request_id")
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PUBLIC_DELEGATED_PREFIX_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    project: str
    public_delegated_prefix: str
    region: str
    request_id: str
    def __init__(self, project: _Optional[str] = ..., public_delegated_prefix: _Optional[str] = ..., region: _Optional[str] = ..., request_id: _Optional[str] = ...) -> None: ...

class XpnHostList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Project]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Project, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class XpnResourceId(_message.Message):
    __slots__ = ("id", "type")
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_TYPE: _ClassVar[XpnResourceId.Type]
        PROJECT: _ClassVar[XpnResourceId.Type]
        XPN_RESOURCE_TYPE_UNSPECIFIED: _ClassVar[XpnResourceId.Type]
    UNDEFINED_TYPE: XpnResourceId.Type
    PROJECT: XpnResourceId.Type
    XPN_RESOURCE_TYPE_UNSPECIFIED: XpnResourceId.Type
    ID_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    id: str
    type: str
    def __init__(self, id: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class Zone(_message.Message):
    __slots__ = ("available_cpu_platforms", "creation_timestamp", "deprecated", "description", "id", "kind", "name", "region", "self_link", "status", "supports_pzs")
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNDEFINED_STATUS: _ClassVar[Zone.Status]
        DOWN: _ClassVar[Zone.Status]
        UP: _ClassVar[Zone.Status]
    UNDEFINED_STATUS: Zone.Status
    DOWN: Zone.Status
    UP: Zone.Status
    AVAILABLE_CPU_PLATFORMS_FIELD_NUMBER: _ClassVar[int]
    CREATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    DEPRECATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUPPORTS_PZS_FIELD_NUMBER: _ClassVar[int]
    available_cpu_platforms: _containers.RepeatedScalarFieldContainer[str]
    creation_timestamp: str
    deprecated: DeprecationStatus
    description: str
    id: int
    kind: str
    name: str
    region: str
    self_link: str
    status: str
    supports_pzs: bool
    def __init__(self, available_cpu_platforms: _Optional[_Iterable[str]] = ..., creation_timestamp: _Optional[str] = ..., deprecated: _Optional[_Union[DeprecationStatus, _Mapping]] = ..., description: _Optional[str] = ..., id: _Optional[int] = ..., kind: _Optional[str] = ..., name: _Optional[str] = ..., region: _Optional[str] = ..., self_link: _Optional[str] = ..., status: _Optional[str] = ..., supports_pzs: bool = ...) -> None: ...

class ZoneList(_message.Message):
    __slots__ = ("id", "items", "kind", "next_page_token", "self_link", "warning")
    ID_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SELF_LINK_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    id: str
    items: _containers.RepeatedCompositeFieldContainer[Zone]
    kind: str
    next_page_token: str
    self_link: str
    warning: Warning
    def __init__(self, id: _Optional[str] = ..., items: _Optional[_Iterable[_Union[Zone, _Mapping]]] = ..., kind: _Optional[str] = ..., next_page_token: _Optional[str] = ..., self_link: _Optional[str] = ..., warning: _Optional[_Union[Warning, _Mapping]] = ...) -> None: ...

class ZoneSetLabelsRequest(_message.Message):
    __slots__ = ("label_fingerprint", "labels")
    class LabelsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    LABEL_FINGERPRINT_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    label_fingerprint: str
    labels: _containers.ScalarMap[str, str]
    def __init__(self, label_fingerprint: _Optional[str] = ..., labels: _Optional[_Mapping[str, str]] = ...) -> None: ...

class ZoneSetPolicyRequest(_message.Message):
    __slots__ = ("bindings", "etag", "policy")
    BINDINGS_FIELD_NUMBER: _ClassVar[int]
    ETAG_FIELD_NUMBER: _ClassVar[int]
    POLICY_FIELD_NUMBER: _ClassVar[int]
    bindings: _containers.RepeatedCompositeFieldContainer[Binding]
    etag: str
    policy: Policy
    def __init__(self, bindings: _Optional[_Iterable[_Union[Binding, _Mapping]]] = ..., etag: _Optional[str] = ..., policy: _Optional[_Union[Policy, _Mapping]] = ...) -> None: ...
