from google.api import annotations_pb2 as _annotations_pb2
from google.api import client_pb2 as _client_pb2
from google.api import field_behavior_pb2 as _field_behavior_pb2
from google.api import resource_pb2 as _resource_pb2
from google.privacy.dlp.v2 import storage_pb2 as _storage_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf import field_mask_pb2 as _field_mask_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.rpc import status_pb2 as _status_pb2
from google.type import date_pb2 as _date_pb2
from google.type import dayofweek_pb2 as _dayofweek_pb2
from google.type import timeofday_pb2 as _timeofday_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union
DESCRIPTOR: _descriptor.FileDescriptor

class TransformationResultStatusType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    STATE_TYPE_UNSPECIFIED: _ClassVar[TransformationResultStatusType]
    INVALID_TRANSFORM: _ClassVar[TransformationResultStatusType]
    BIGQUERY_MAX_ROW_SIZE_EXCEEDED: _ClassVar[TransformationResultStatusType]
    METADATA_UNRETRIEVABLE: _ClassVar[TransformationResultStatusType]
    SUCCESS: _ClassVar[TransformationResultStatusType]

class TransformationContainerType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    TRANSFORM_UNKNOWN_CONTAINER: _ClassVar[TransformationContainerType]
    TRANSFORM_BODY: _ClassVar[TransformationContainerType]
    TRANSFORM_METADATA: _ClassVar[TransformationContainerType]
    TRANSFORM_TABLE: _ClassVar[TransformationContainerType]

class TransformationType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    TRANSFORMATION_TYPE_UNSPECIFIED: _ClassVar[TransformationType]
    RECORD_SUPPRESSION: _ClassVar[TransformationType]
    REPLACE_VALUE: _ClassVar[TransformationType]
    REPLACE_DICTIONARY: _ClassVar[TransformationType]
    REDACT: _ClassVar[TransformationType]
    CHARACTER_MASK: _ClassVar[TransformationType]
    CRYPTO_REPLACE_FFX_FPE: _ClassVar[TransformationType]
    FIXED_SIZE_BUCKETING: _ClassVar[TransformationType]
    BUCKETING: _ClassVar[TransformationType]
    REPLACE_WITH_INFO_TYPE: _ClassVar[TransformationType]
    TIME_PART: _ClassVar[TransformationType]
    CRYPTO_HASH: _ClassVar[TransformationType]
    DATE_SHIFT: _ClassVar[TransformationType]
    CRYPTO_DETERMINISTIC_CONFIG: _ClassVar[TransformationType]
    REDACT_IMAGE: _ClassVar[TransformationType]

class ProfileGeneration(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    PROFILE_GENERATION_UNSPECIFIED: _ClassVar[ProfileGeneration]
    PROFILE_GENERATION_NEW: _ClassVar[ProfileGeneration]
    PROFILE_GENERATION_UPDATE: _ClassVar[ProfileGeneration]

class BigQueryTableTypeCollection(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    BIG_QUERY_COLLECTION_UNSPECIFIED: _ClassVar[BigQueryTableTypeCollection]
    BIG_QUERY_COLLECTION_ALL_TYPES: _ClassVar[BigQueryTableTypeCollection]
    BIG_QUERY_COLLECTION_ONLY_SUPPORTED_TYPES: _ClassVar[BigQueryTableTypeCollection]

class BigQueryTableType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    BIG_QUERY_TABLE_TYPE_UNSPECIFIED: _ClassVar[BigQueryTableType]
    BIG_QUERY_TABLE_TYPE_TABLE: _ClassVar[BigQueryTableType]
    BIG_QUERY_TABLE_TYPE_EXTERNAL_BIG_LAKE: _ClassVar[BigQueryTableType]
    BIG_QUERY_TABLE_TYPE_SNAPSHOT: _ClassVar[BigQueryTableType]

class DataProfileUpdateFrequency(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    UPDATE_FREQUENCY_UNSPECIFIED: _ClassVar[DataProfileUpdateFrequency]
    UPDATE_FREQUENCY_NEVER: _ClassVar[DataProfileUpdateFrequency]
    UPDATE_FREQUENCY_DAILY: _ClassVar[DataProfileUpdateFrequency]
    UPDATE_FREQUENCY_MONTHLY: _ClassVar[DataProfileUpdateFrequency]

class BigQueryTableModification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    TABLE_MODIFICATION_UNSPECIFIED: _ClassVar[BigQueryTableModification]
    TABLE_MODIFIED_TIMESTAMP: _ClassVar[BigQueryTableModification]

class BigQuerySchemaModification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    SCHEMA_MODIFICATION_UNSPECIFIED: _ClassVar[BigQuerySchemaModification]
    SCHEMA_NEW_COLUMNS: _ClassVar[BigQuerySchemaModification]
    SCHEMA_REMOVED_COLUMNS: _ClassVar[BigQuerySchemaModification]

class RelationalOperator(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    RELATIONAL_OPERATOR_UNSPECIFIED: _ClassVar[RelationalOperator]
    EQUAL_TO: _ClassVar[RelationalOperator]
    NOT_EQUAL_TO: _ClassVar[RelationalOperator]
    GREATER_THAN: _ClassVar[RelationalOperator]
    LESS_THAN: _ClassVar[RelationalOperator]
    GREATER_THAN_OR_EQUALS: _ClassVar[RelationalOperator]
    LESS_THAN_OR_EQUALS: _ClassVar[RelationalOperator]
    EXISTS: _ClassVar[RelationalOperator]

class MatchingType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    MATCHING_TYPE_UNSPECIFIED: _ClassVar[MatchingType]
    MATCHING_TYPE_FULL_MATCH: _ClassVar[MatchingType]
    MATCHING_TYPE_PARTIAL_MATCH: _ClassVar[MatchingType]
    MATCHING_TYPE_INVERSE_MATCH: _ClassVar[MatchingType]

class ContentOption(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    CONTENT_UNSPECIFIED: _ClassVar[ContentOption]
    CONTENT_TEXT: _ClassVar[ContentOption]
    CONTENT_IMAGE: _ClassVar[ContentOption]

class MetadataType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    METADATATYPE_UNSPECIFIED: _ClassVar[MetadataType]
    STORAGE_METADATA: _ClassVar[MetadataType]

class InfoTypeSupportedBy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    ENUM_TYPE_UNSPECIFIED: _ClassVar[InfoTypeSupportedBy]
    INSPECT: _ClassVar[InfoTypeSupportedBy]
    RISK_ANALYSIS: _ClassVar[InfoTypeSupportedBy]

class DlpJobType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    DLP_JOB_TYPE_UNSPECIFIED: _ClassVar[DlpJobType]
    INSPECT_JOB: _ClassVar[DlpJobType]
    RISK_ANALYSIS_JOB: _ClassVar[DlpJobType]

class StoredInfoTypeState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    STORED_INFO_TYPE_STATE_UNSPECIFIED: _ClassVar[StoredInfoTypeState]
    PENDING: _ClassVar[StoredInfoTypeState]
    READY: _ClassVar[StoredInfoTypeState]
    FAILED: _ClassVar[StoredInfoTypeState]
    INVALID: _ClassVar[StoredInfoTypeState]

class ResourceVisibility(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    RESOURCE_VISIBILITY_UNSPECIFIED: _ClassVar[ResourceVisibility]
    RESOURCE_VISIBILITY_PUBLIC: _ClassVar[ResourceVisibility]
    RESOURCE_VISIBILITY_INCONCLUSIVE: _ClassVar[ResourceVisibility]
    RESOURCE_VISIBILITY_RESTRICTED: _ClassVar[ResourceVisibility]

class EncryptionStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    ENCRYPTION_STATUS_UNSPECIFIED: _ClassVar[EncryptionStatus]
    ENCRYPTION_GOOGLE_MANAGED: _ClassVar[EncryptionStatus]
    ENCRYPTION_CUSTOMER_MANAGED: _ClassVar[EncryptionStatus]

class NullPercentageLevel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    NULL_PERCENTAGE_LEVEL_UNSPECIFIED: _ClassVar[NullPercentageLevel]
    NULL_PERCENTAGE_VERY_LOW: _ClassVar[NullPercentageLevel]
    NULL_PERCENTAGE_LOW: _ClassVar[NullPercentageLevel]
    NULL_PERCENTAGE_MEDIUM: _ClassVar[NullPercentageLevel]
    NULL_PERCENTAGE_HIGH: _ClassVar[NullPercentageLevel]

class UniquenessScoreLevel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    UNIQUENESS_SCORE_LEVEL_UNSPECIFIED: _ClassVar[UniquenessScoreLevel]
    UNIQUENESS_SCORE_LOW: _ClassVar[UniquenessScoreLevel]
    UNIQUENESS_SCORE_MEDIUM: _ClassVar[UniquenessScoreLevel]
    UNIQUENESS_SCORE_HIGH: _ClassVar[UniquenessScoreLevel]

class ConnectionState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    CONNECTION_STATE_UNSPECIFIED: _ClassVar[ConnectionState]
    MISSING_CREDENTIALS: _ClassVar[ConnectionState]
    AVAILABLE: _ClassVar[ConnectionState]
    ERROR: _ClassVar[ConnectionState]
STATE_TYPE_UNSPECIFIED: TransformationResultStatusType
INVALID_TRANSFORM: TransformationResultStatusType
BIGQUERY_MAX_ROW_SIZE_EXCEEDED: TransformationResultStatusType
METADATA_UNRETRIEVABLE: TransformationResultStatusType
SUCCESS: TransformationResultStatusType
TRANSFORM_UNKNOWN_CONTAINER: TransformationContainerType
TRANSFORM_BODY: TransformationContainerType
TRANSFORM_METADATA: TransformationContainerType
TRANSFORM_TABLE: TransformationContainerType
TRANSFORMATION_TYPE_UNSPECIFIED: TransformationType
RECORD_SUPPRESSION: TransformationType
REPLACE_VALUE: TransformationType
REPLACE_DICTIONARY: TransformationType
REDACT: TransformationType
CHARACTER_MASK: TransformationType
CRYPTO_REPLACE_FFX_FPE: TransformationType
FIXED_SIZE_BUCKETING: TransformationType
BUCKETING: TransformationType
REPLACE_WITH_INFO_TYPE: TransformationType
TIME_PART: TransformationType
CRYPTO_HASH: TransformationType
DATE_SHIFT: TransformationType
CRYPTO_DETERMINISTIC_CONFIG: TransformationType
REDACT_IMAGE: TransformationType
PROFILE_GENERATION_UNSPECIFIED: ProfileGeneration
PROFILE_GENERATION_NEW: ProfileGeneration
PROFILE_GENERATION_UPDATE: ProfileGeneration
BIG_QUERY_COLLECTION_UNSPECIFIED: BigQueryTableTypeCollection
BIG_QUERY_COLLECTION_ALL_TYPES: BigQueryTableTypeCollection
BIG_QUERY_COLLECTION_ONLY_SUPPORTED_TYPES: BigQueryTableTypeCollection
BIG_QUERY_TABLE_TYPE_UNSPECIFIED: BigQueryTableType
BIG_QUERY_TABLE_TYPE_TABLE: BigQueryTableType
BIG_QUERY_TABLE_TYPE_EXTERNAL_BIG_LAKE: BigQueryTableType
BIG_QUERY_TABLE_TYPE_SNAPSHOT: BigQueryTableType
UPDATE_FREQUENCY_UNSPECIFIED: DataProfileUpdateFrequency
UPDATE_FREQUENCY_NEVER: DataProfileUpdateFrequency
UPDATE_FREQUENCY_DAILY: DataProfileUpdateFrequency
UPDATE_FREQUENCY_MONTHLY: DataProfileUpdateFrequency
TABLE_MODIFICATION_UNSPECIFIED: BigQueryTableModification
TABLE_MODIFIED_TIMESTAMP: BigQueryTableModification
SCHEMA_MODIFICATION_UNSPECIFIED: BigQuerySchemaModification
SCHEMA_NEW_COLUMNS: BigQuerySchemaModification
SCHEMA_REMOVED_COLUMNS: BigQuerySchemaModification
RELATIONAL_OPERATOR_UNSPECIFIED: RelationalOperator
EQUAL_TO: RelationalOperator
NOT_EQUAL_TO: RelationalOperator
GREATER_THAN: RelationalOperator
LESS_THAN: RelationalOperator
GREATER_THAN_OR_EQUALS: RelationalOperator
LESS_THAN_OR_EQUALS: RelationalOperator
EXISTS: RelationalOperator
MATCHING_TYPE_UNSPECIFIED: MatchingType
MATCHING_TYPE_FULL_MATCH: MatchingType
MATCHING_TYPE_PARTIAL_MATCH: MatchingType
MATCHING_TYPE_INVERSE_MATCH: MatchingType
CONTENT_UNSPECIFIED: ContentOption
CONTENT_TEXT: ContentOption
CONTENT_IMAGE: ContentOption
METADATATYPE_UNSPECIFIED: MetadataType
STORAGE_METADATA: MetadataType
ENUM_TYPE_UNSPECIFIED: InfoTypeSupportedBy
INSPECT: InfoTypeSupportedBy
RISK_ANALYSIS: InfoTypeSupportedBy
DLP_JOB_TYPE_UNSPECIFIED: DlpJobType
INSPECT_JOB: DlpJobType
RISK_ANALYSIS_JOB: DlpJobType
STORED_INFO_TYPE_STATE_UNSPECIFIED: StoredInfoTypeState
PENDING: StoredInfoTypeState
READY: StoredInfoTypeState
FAILED: StoredInfoTypeState
INVALID: StoredInfoTypeState
RESOURCE_VISIBILITY_UNSPECIFIED: ResourceVisibility
RESOURCE_VISIBILITY_PUBLIC: ResourceVisibility
RESOURCE_VISIBILITY_INCONCLUSIVE: ResourceVisibility
RESOURCE_VISIBILITY_RESTRICTED: ResourceVisibility
ENCRYPTION_STATUS_UNSPECIFIED: EncryptionStatus
ENCRYPTION_GOOGLE_MANAGED: EncryptionStatus
ENCRYPTION_CUSTOMER_MANAGED: EncryptionStatus
NULL_PERCENTAGE_LEVEL_UNSPECIFIED: NullPercentageLevel
NULL_PERCENTAGE_VERY_LOW: NullPercentageLevel
NULL_PERCENTAGE_LOW: NullPercentageLevel
NULL_PERCENTAGE_MEDIUM: NullPercentageLevel
NULL_PERCENTAGE_HIGH: NullPercentageLevel
UNIQUENESS_SCORE_LEVEL_UNSPECIFIED: UniquenessScoreLevel
UNIQUENESS_SCORE_LOW: UniquenessScoreLevel
UNIQUENESS_SCORE_MEDIUM: UniquenessScoreLevel
UNIQUENESS_SCORE_HIGH: UniquenessScoreLevel
CONNECTION_STATE_UNSPECIFIED: ConnectionState
MISSING_CREDENTIALS: ConnectionState
AVAILABLE: ConnectionState
ERROR: ConnectionState

class ExcludeInfoTypes(_message.Message):
    __slots__ = ('info_types',)
    INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    info_types: _containers.RepeatedCompositeFieldContainer[_storage_pb2.InfoType]

    def __init__(self, info_types: _Optional[_Iterable[_Union[_storage_pb2.InfoType, _Mapping]]]=...) -> None:
        ...

class ExcludeByHotword(_message.Message):
    __slots__ = ('hotword_regex', 'proximity')
    HOTWORD_REGEX_FIELD_NUMBER: _ClassVar[int]
    PROXIMITY_FIELD_NUMBER: _ClassVar[int]
    hotword_regex: _storage_pb2.CustomInfoType.Regex
    proximity: _storage_pb2.CustomInfoType.DetectionRule.Proximity

    def __init__(self, hotword_regex: _Optional[_Union[_storage_pb2.CustomInfoType.Regex, _Mapping]]=..., proximity: _Optional[_Union[_storage_pb2.CustomInfoType.DetectionRule.Proximity, _Mapping]]=...) -> None:
        ...

class ExclusionRule(_message.Message):
    __slots__ = ('dictionary', 'regex', 'exclude_info_types', 'exclude_by_hotword', 'matching_type')
    DICTIONARY_FIELD_NUMBER: _ClassVar[int]
    REGEX_FIELD_NUMBER: _ClassVar[int]
    EXCLUDE_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    EXCLUDE_BY_HOTWORD_FIELD_NUMBER: _ClassVar[int]
    MATCHING_TYPE_FIELD_NUMBER: _ClassVar[int]
    dictionary: _storage_pb2.CustomInfoType.Dictionary
    regex: _storage_pb2.CustomInfoType.Regex
    exclude_info_types: ExcludeInfoTypes
    exclude_by_hotword: ExcludeByHotword
    matching_type: MatchingType

    def __init__(self, dictionary: _Optional[_Union[_storage_pb2.CustomInfoType.Dictionary, _Mapping]]=..., regex: _Optional[_Union[_storage_pb2.CustomInfoType.Regex, _Mapping]]=..., exclude_info_types: _Optional[_Union[ExcludeInfoTypes, _Mapping]]=..., exclude_by_hotword: _Optional[_Union[ExcludeByHotword, _Mapping]]=..., matching_type: _Optional[_Union[MatchingType, str]]=...) -> None:
        ...

class InspectionRule(_message.Message):
    __slots__ = ('hotword_rule', 'exclusion_rule')
    HOTWORD_RULE_FIELD_NUMBER: _ClassVar[int]
    EXCLUSION_RULE_FIELD_NUMBER: _ClassVar[int]
    hotword_rule: _storage_pb2.CustomInfoType.DetectionRule.HotwordRule
    exclusion_rule: ExclusionRule

    def __init__(self, hotword_rule: _Optional[_Union[_storage_pb2.CustomInfoType.DetectionRule.HotwordRule, _Mapping]]=..., exclusion_rule: _Optional[_Union[ExclusionRule, _Mapping]]=...) -> None:
        ...

class InspectionRuleSet(_message.Message):
    __slots__ = ('info_types', 'rules')
    INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    RULES_FIELD_NUMBER: _ClassVar[int]
    info_types: _containers.RepeatedCompositeFieldContainer[_storage_pb2.InfoType]
    rules: _containers.RepeatedCompositeFieldContainer[InspectionRule]

    def __init__(self, info_types: _Optional[_Iterable[_Union[_storage_pb2.InfoType, _Mapping]]]=..., rules: _Optional[_Iterable[_Union[InspectionRule, _Mapping]]]=...) -> None:
        ...

class InspectConfig(_message.Message):
    __slots__ = ('info_types', 'min_likelihood', 'min_likelihood_per_info_type', 'limits', 'include_quote', 'exclude_info_types', 'custom_info_types', 'content_options', 'rule_set')

    class InfoTypeLikelihood(_message.Message):
        __slots__ = ('info_type', 'min_likelihood')
        INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
        MIN_LIKELIHOOD_FIELD_NUMBER: _ClassVar[int]
        info_type: _storage_pb2.InfoType
        min_likelihood: _storage_pb2.Likelihood

        def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., min_likelihood: _Optional[_Union[_storage_pb2.Likelihood, str]]=...) -> None:
            ...

    class FindingLimits(_message.Message):
        __slots__ = ('max_findings_per_item', 'max_findings_per_request', 'max_findings_per_info_type')

        class InfoTypeLimit(_message.Message):
            __slots__ = ('info_type', 'max_findings')
            INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
            MAX_FINDINGS_FIELD_NUMBER: _ClassVar[int]
            info_type: _storage_pb2.InfoType
            max_findings: int

            def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., max_findings: _Optional[int]=...) -> None:
                ...
        MAX_FINDINGS_PER_ITEM_FIELD_NUMBER: _ClassVar[int]
        MAX_FINDINGS_PER_REQUEST_FIELD_NUMBER: _ClassVar[int]
        MAX_FINDINGS_PER_INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
        max_findings_per_item: int
        max_findings_per_request: int
        max_findings_per_info_type: _containers.RepeatedCompositeFieldContainer[InspectConfig.FindingLimits.InfoTypeLimit]

        def __init__(self, max_findings_per_item: _Optional[int]=..., max_findings_per_request: _Optional[int]=..., max_findings_per_info_type: _Optional[_Iterable[_Union[InspectConfig.FindingLimits.InfoTypeLimit, _Mapping]]]=...) -> None:
            ...
    INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    MIN_LIKELIHOOD_FIELD_NUMBER: _ClassVar[int]
    MIN_LIKELIHOOD_PER_INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    LIMITS_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_QUOTE_FIELD_NUMBER: _ClassVar[int]
    EXCLUDE_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    CONTENT_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    RULE_SET_FIELD_NUMBER: _ClassVar[int]
    info_types: _containers.RepeatedCompositeFieldContainer[_storage_pb2.InfoType]
    min_likelihood: _storage_pb2.Likelihood
    min_likelihood_per_info_type: _containers.RepeatedCompositeFieldContainer[InspectConfig.InfoTypeLikelihood]
    limits: InspectConfig.FindingLimits
    include_quote: bool
    exclude_info_types: bool
    custom_info_types: _containers.RepeatedCompositeFieldContainer[_storage_pb2.CustomInfoType]
    content_options: _containers.RepeatedScalarFieldContainer[ContentOption]
    rule_set: _containers.RepeatedCompositeFieldContainer[InspectionRuleSet]

    def __init__(self, info_types: _Optional[_Iterable[_Union[_storage_pb2.InfoType, _Mapping]]]=..., min_likelihood: _Optional[_Union[_storage_pb2.Likelihood, str]]=..., min_likelihood_per_info_type: _Optional[_Iterable[_Union[InspectConfig.InfoTypeLikelihood, _Mapping]]]=..., limits: _Optional[_Union[InspectConfig.FindingLimits, _Mapping]]=..., include_quote: bool=..., exclude_info_types: bool=..., custom_info_types: _Optional[_Iterable[_Union[_storage_pb2.CustomInfoType, _Mapping]]]=..., content_options: _Optional[_Iterable[_Union[ContentOption, str]]]=..., rule_set: _Optional[_Iterable[_Union[InspectionRuleSet, _Mapping]]]=...) -> None:
        ...

class ByteContentItem(_message.Message):
    __slots__ = ('type', 'data')

    class BytesType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        BYTES_TYPE_UNSPECIFIED: _ClassVar[ByteContentItem.BytesType]
        IMAGE: _ClassVar[ByteContentItem.BytesType]
        IMAGE_JPEG: _ClassVar[ByteContentItem.BytesType]
        IMAGE_BMP: _ClassVar[ByteContentItem.BytesType]
        IMAGE_PNG: _ClassVar[ByteContentItem.BytesType]
        IMAGE_SVG: _ClassVar[ByteContentItem.BytesType]
        TEXT_UTF8: _ClassVar[ByteContentItem.BytesType]
        WORD_DOCUMENT: _ClassVar[ByteContentItem.BytesType]
        PDF: _ClassVar[ByteContentItem.BytesType]
        POWERPOINT_DOCUMENT: _ClassVar[ByteContentItem.BytesType]
        EXCEL_DOCUMENT: _ClassVar[ByteContentItem.BytesType]
        AVRO: _ClassVar[ByteContentItem.BytesType]
        CSV: _ClassVar[ByteContentItem.BytesType]
        TSV: _ClassVar[ByteContentItem.BytesType]
        AUDIO: _ClassVar[ByteContentItem.BytesType]
        VIDEO: _ClassVar[ByteContentItem.BytesType]
        EXECUTABLE: _ClassVar[ByteContentItem.BytesType]
    BYTES_TYPE_UNSPECIFIED: ByteContentItem.BytesType
    IMAGE: ByteContentItem.BytesType
    IMAGE_JPEG: ByteContentItem.BytesType
    IMAGE_BMP: ByteContentItem.BytesType
    IMAGE_PNG: ByteContentItem.BytesType
    IMAGE_SVG: ByteContentItem.BytesType
    TEXT_UTF8: ByteContentItem.BytesType
    WORD_DOCUMENT: ByteContentItem.BytesType
    PDF: ByteContentItem.BytesType
    POWERPOINT_DOCUMENT: ByteContentItem.BytesType
    EXCEL_DOCUMENT: ByteContentItem.BytesType
    AVRO: ByteContentItem.BytesType
    CSV: ByteContentItem.BytesType
    TSV: ByteContentItem.BytesType
    AUDIO: ByteContentItem.BytesType
    VIDEO: ByteContentItem.BytesType
    EXECUTABLE: ByteContentItem.BytesType
    TYPE_FIELD_NUMBER: _ClassVar[int]
    DATA_FIELD_NUMBER: _ClassVar[int]
    type: ByteContentItem.BytesType
    data: bytes

    def __init__(self, type: _Optional[_Union[ByteContentItem.BytesType, str]]=..., data: _Optional[bytes]=...) -> None:
        ...

class ContentItem(_message.Message):
    __slots__ = ('value', 'table', 'byte_item')
    VALUE_FIELD_NUMBER: _ClassVar[int]
    TABLE_FIELD_NUMBER: _ClassVar[int]
    BYTE_ITEM_FIELD_NUMBER: _ClassVar[int]
    value: str
    table: Table
    byte_item: ByteContentItem

    def __init__(self, value: _Optional[str]=..., table: _Optional[_Union[Table, _Mapping]]=..., byte_item: _Optional[_Union[ByteContentItem, _Mapping]]=...) -> None:
        ...

class Table(_message.Message):
    __slots__ = ('headers', 'rows')

    class Row(_message.Message):
        __slots__ = ('values',)
        VALUES_FIELD_NUMBER: _ClassVar[int]
        values: _containers.RepeatedCompositeFieldContainer[Value]

        def __init__(self, values: _Optional[_Iterable[_Union[Value, _Mapping]]]=...) -> None:
            ...
    HEADERS_FIELD_NUMBER: _ClassVar[int]
    ROWS_FIELD_NUMBER: _ClassVar[int]
    headers: _containers.RepeatedCompositeFieldContainer[_storage_pb2.FieldId]
    rows: _containers.RepeatedCompositeFieldContainer[Table.Row]

    def __init__(self, headers: _Optional[_Iterable[_Union[_storage_pb2.FieldId, _Mapping]]]=..., rows: _Optional[_Iterable[_Union[Table.Row, _Mapping]]]=...) -> None:
        ...

class InspectResult(_message.Message):
    __slots__ = ('findings', 'findings_truncated')
    FINDINGS_FIELD_NUMBER: _ClassVar[int]
    FINDINGS_TRUNCATED_FIELD_NUMBER: _ClassVar[int]
    findings: _containers.RepeatedCompositeFieldContainer[Finding]
    findings_truncated: bool

    def __init__(self, findings: _Optional[_Iterable[_Union[Finding, _Mapping]]]=..., findings_truncated: bool=...) -> None:
        ...

class Finding(_message.Message):
    __slots__ = ('name', 'quote', 'info_type', 'likelihood', 'location', 'create_time', 'quote_info', 'resource_name', 'trigger_name', 'labels', 'job_create_time', 'job_name', 'finding_id')

    class LabelsEntry(_message.Message):
        __slots__ = ('key', 'value')
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str

        def __init__(self, key: _Optional[str]=..., value: _Optional[str]=...) -> None:
            ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    QUOTE_FIELD_NUMBER: _ClassVar[int]
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    LIKELIHOOD_FIELD_NUMBER: _ClassVar[int]
    LOCATION_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    QUOTE_INFO_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_NAME_FIELD_NUMBER: _ClassVar[int]
    TRIGGER_NAME_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    JOB_CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    JOB_NAME_FIELD_NUMBER: _ClassVar[int]
    FINDING_ID_FIELD_NUMBER: _ClassVar[int]
    name: str
    quote: str
    info_type: _storage_pb2.InfoType
    likelihood: _storage_pb2.Likelihood
    location: Location
    create_time: _timestamp_pb2.Timestamp
    quote_info: QuoteInfo
    resource_name: str
    trigger_name: str
    labels: _containers.ScalarMap[str, str]
    job_create_time: _timestamp_pb2.Timestamp
    job_name: str
    finding_id: str

    def __init__(self, name: _Optional[str]=..., quote: _Optional[str]=..., info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., likelihood: _Optional[_Union[_storage_pb2.Likelihood, str]]=..., location: _Optional[_Union[Location, _Mapping]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., quote_info: _Optional[_Union[QuoteInfo, _Mapping]]=..., resource_name: _Optional[str]=..., trigger_name: _Optional[str]=..., labels: _Optional[_Mapping[str, str]]=..., job_create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., job_name: _Optional[str]=..., finding_id: _Optional[str]=...) -> None:
        ...

class Location(_message.Message):
    __slots__ = ('byte_range', 'codepoint_range', 'content_locations', 'container')
    BYTE_RANGE_FIELD_NUMBER: _ClassVar[int]
    CODEPOINT_RANGE_FIELD_NUMBER: _ClassVar[int]
    CONTENT_LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    CONTAINER_FIELD_NUMBER: _ClassVar[int]
    byte_range: Range
    codepoint_range: Range
    content_locations: _containers.RepeatedCompositeFieldContainer[ContentLocation]
    container: Container

    def __init__(self, byte_range: _Optional[_Union[Range, _Mapping]]=..., codepoint_range: _Optional[_Union[Range, _Mapping]]=..., content_locations: _Optional[_Iterable[_Union[ContentLocation, _Mapping]]]=..., container: _Optional[_Union[Container, _Mapping]]=...) -> None:
        ...

class ContentLocation(_message.Message):
    __slots__ = ('container_name', 'record_location', 'image_location', 'document_location', 'metadata_location', 'container_timestamp', 'container_version')
    CONTAINER_NAME_FIELD_NUMBER: _ClassVar[int]
    RECORD_LOCATION_FIELD_NUMBER: _ClassVar[int]
    IMAGE_LOCATION_FIELD_NUMBER: _ClassVar[int]
    DOCUMENT_LOCATION_FIELD_NUMBER: _ClassVar[int]
    METADATA_LOCATION_FIELD_NUMBER: _ClassVar[int]
    CONTAINER_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CONTAINER_VERSION_FIELD_NUMBER: _ClassVar[int]
    container_name: str
    record_location: RecordLocation
    image_location: ImageLocation
    document_location: DocumentLocation
    metadata_location: MetadataLocation
    container_timestamp: _timestamp_pb2.Timestamp
    container_version: str

    def __init__(self, container_name: _Optional[str]=..., record_location: _Optional[_Union[RecordLocation, _Mapping]]=..., image_location: _Optional[_Union[ImageLocation, _Mapping]]=..., document_location: _Optional[_Union[DocumentLocation, _Mapping]]=..., metadata_location: _Optional[_Union[MetadataLocation, _Mapping]]=..., container_timestamp: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., container_version: _Optional[str]=...) -> None:
        ...

class MetadataLocation(_message.Message):
    __slots__ = ('type', 'storage_label')
    TYPE_FIELD_NUMBER: _ClassVar[int]
    STORAGE_LABEL_FIELD_NUMBER: _ClassVar[int]
    type: MetadataType
    storage_label: StorageMetadataLabel

    def __init__(self, type: _Optional[_Union[MetadataType, str]]=..., storage_label: _Optional[_Union[StorageMetadataLabel, _Mapping]]=...) -> None:
        ...

class StorageMetadataLabel(_message.Message):
    __slots__ = ('key',)
    KEY_FIELD_NUMBER: _ClassVar[int]
    key: str

    def __init__(self, key: _Optional[str]=...) -> None:
        ...

class DocumentLocation(_message.Message):
    __slots__ = ('file_offset',)
    FILE_OFFSET_FIELD_NUMBER: _ClassVar[int]
    file_offset: int

    def __init__(self, file_offset: _Optional[int]=...) -> None:
        ...

class RecordLocation(_message.Message):
    __slots__ = ('record_key', 'field_id', 'table_location')
    RECORD_KEY_FIELD_NUMBER: _ClassVar[int]
    FIELD_ID_FIELD_NUMBER: _ClassVar[int]
    TABLE_LOCATION_FIELD_NUMBER: _ClassVar[int]
    record_key: _storage_pb2.RecordKey
    field_id: _storage_pb2.FieldId
    table_location: TableLocation

    def __init__(self, record_key: _Optional[_Union[_storage_pb2.RecordKey, _Mapping]]=..., field_id: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., table_location: _Optional[_Union[TableLocation, _Mapping]]=...) -> None:
        ...

class TableLocation(_message.Message):
    __slots__ = ('row_index',)
    ROW_INDEX_FIELD_NUMBER: _ClassVar[int]
    row_index: int

    def __init__(self, row_index: _Optional[int]=...) -> None:
        ...

class Container(_message.Message):
    __slots__ = ('type', 'project_id', 'full_path', 'root_path', 'relative_path', 'update_time', 'version')
    TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    FULL_PATH_FIELD_NUMBER: _ClassVar[int]
    ROOT_PATH_FIELD_NUMBER: _ClassVar[int]
    RELATIVE_PATH_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    type: str
    project_id: str
    full_path: str
    root_path: str
    relative_path: str
    update_time: _timestamp_pb2.Timestamp
    version: str

    def __init__(self, type: _Optional[str]=..., project_id: _Optional[str]=..., full_path: _Optional[str]=..., root_path: _Optional[str]=..., relative_path: _Optional[str]=..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., version: _Optional[str]=...) -> None:
        ...

class Range(_message.Message):
    __slots__ = ('start', 'end')
    START_FIELD_NUMBER: _ClassVar[int]
    END_FIELD_NUMBER: _ClassVar[int]
    start: int
    end: int

    def __init__(self, start: _Optional[int]=..., end: _Optional[int]=...) -> None:
        ...

class ImageLocation(_message.Message):
    __slots__ = ('bounding_boxes',)
    BOUNDING_BOXES_FIELD_NUMBER: _ClassVar[int]
    bounding_boxes: _containers.RepeatedCompositeFieldContainer[BoundingBox]

    def __init__(self, bounding_boxes: _Optional[_Iterable[_Union[BoundingBox, _Mapping]]]=...) -> None:
        ...

class BoundingBox(_message.Message):
    __slots__ = ('top', 'left', 'width', 'height')
    TOP_FIELD_NUMBER: _ClassVar[int]
    LEFT_FIELD_NUMBER: _ClassVar[int]
    WIDTH_FIELD_NUMBER: _ClassVar[int]
    HEIGHT_FIELD_NUMBER: _ClassVar[int]
    top: int
    left: int
    width: int
    height: int

    def __init__(self, top: _Optional[int]=..., left: _Optional[int]=..., width: _Optional[int]=..., height: _Optional[int]=...) -> None:
        ...

class RedactImageRequest(_message.Message):
    __slots__ = ('parent', 'location_id', 'inspect_config', 'image_redaction_configs', 'include_findings', 'byte_item')

    class ImageRedactionConfig(_message.Message):
        __slots__ = ('info_type', 'redact_all_text', 'redaction_color')
        INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
        REDACT_ALL_TEXT_FIELD_NUMBER: _ClassVar[int]
        REDACTION_COLOR_FIELD_NUMBER: _ClassVar[int]
        info_type: _storage_pb2.InfoType
        redact_all_text: bool
        redaction_color: Color

        def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., redact_all_text: bool=..., redaction_color: _Optional[_Union[Color, _Mapping]]=...) -> None:
            ...
    PARENT_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    INSPECT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    IMAGE_REDACTION_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_FINDINGS_FIELD_NUMBER: _ClassVar[int]
    BYTE_ITEM_FIELD_NUMBER: _ClassVar[int]
    parent: str
    location_id: str
    inspect_config: InspectConfig
    image_redaction_configs: _containers.RepeatedCompositeFieldContainer[RedactImageRequest.ImageRedactionConfig]
    include_findings: bool
    byte_item: ByteContentItem

    def __init__(self, parent: _Optional[str]=..., location_id: _Optional[str]=..., inspect_config: _Optional[_Union[InspectConfig, _Mapping]]=..., image_redaction_configs: _Optional[_Iterable[_Union[RedactImageRequest.ImageRedactionConfig, _Mapping]]]=..., include_findings: bool=..., byte_item: _Optional[_Union[ByteContentItem, _Mapping]]=...) -> None:
        ...

class Color(_message.Message):
    __slots__ = ('red', 'green', 'blue')
    RED_FIELD_NUMBER: _ClassVar[int]
    GREEN_FIELD_NUMBER: _ClassVar[int]
    BLUE_FIELD_NUMBER: _ClassVar[int]
    red: float
    green: float
    blue: float

    def __init__(self, red: _Optional[float]=..., green: _Optional[float]=..., blue: _Optional[float]=...) -> None:
        ...

class RedactImageResponse(_message.Message):
    __slots__ = ('redacted_image', 'extracted_text', 'inspect_result')
    REDACTED_IMAGE_FIELD_NUMBER: _ClassVar[int]
    EXTRACTED_TEXT_FIELD_NUMBER: _ClassVar[int]
    INSPECT_RESULT_FIELD_NUMBER: _ClassVar[int]
    redacted_image: bytes
    extracted_text: str
    inspect_result: InspectResult

    def __init__(self, redacted_image: _Optional[bytes]=..., extracted_text: _Optional[str]=..., inspect_result: _Optional[_Union[InspectResult, _Mapping]]=...) -> None:
        ...

class DeidentifyContentRequest(_message.Message):
    __slots__ = ('parent', 'deidentify_config', 'inspect_config', 'item', 'inspect_template_name', 'deidentify_template_name', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    DEIDENTIFY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    INSPECT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    ITEM_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_NAME_FIELD_NUMBER: _ClassVar[int]
    DEIDENTIFY_TEMPLATE_NAME_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    deidentify_config: DeidentifyConfig
    inspect_config: InspectConfig
    item: ContentItem
    inspect_template_name: str
    deidentify_template_name: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., deidentify_config: _Optional[_Union[DeidentifyConfig, _Mapping]]=..., inspect_config: _Optional[_Union[InspectConfig, _Mapping]]=..., item: _Optional[_Union[ContentItem, _Mapping]]=..., inspect_template_name: _Optional[str]=..., deidentify_template_name: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class DeidentifyContentResponse(_message.Message):
    __slots__ = ('item', 'overview')
    ITEM_FIELD_NUMBER: _ClassVar[int]
    OVERVIEW_FIELD_NUMBER: _ClassVar[int]
    item: ContentItem
    overview: TransformationOverview

    def __init__(self, item: _Optional[_Union[ContentItem, _Mapping]]=..., overview: _Optional[_Union[TransformationOverview, _Mapping]]=...) -> None:
        ...

class ReidentifyContentRequest(_message.Message):
    __slots__ = ('parent', 'reidentify_config', 'inspect_config', 'item', 'inspect_template_name', 'reidentify_template_name', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    REIDENTIFY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    INSPECT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    ITEM_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_NAME_FIELD_NUMBER: _ClassVar[int]
    REIDENTIFY_TEMPLATE_NAME_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    reidentify_config: DeidentifyConfig
    inspect_config: InspectConfig
    item: ContentItem
    inspect_template_name: str
    reidentify_template_name: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., reidentify_config: _Optional[_Union[DeidentifyConfig, _Mapping]]=..., inspect_config: _Optional[_Union[InspectConfig, _Mapping]]=..., item: _Optional[_Union[ContentItem, _Mapping]]=..., inspect_template_name: _Optional[str]=..., reidentify_template_name: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ReidentifyContentResponse(_message.Message):
    __slots__ = ('item', 'overview')
    ITEM_FIELD_NUMBER: _ClassVar[int]
    OVERVIEW_FIELD_NUMBER: _ClassVar[int]
    item: ContentItem
    overview: TransformationOverview

    def __init__(self, item: _Optional[_Union[ContentItem, _Mapping]]=..., overview: _Optional[_Union[TransformationOverview, _Mapping]]=...) -> None:
        ...

class InspectContentRequest(_message.Message):
    __slots__ = ('parent', 'inspect_config', 'item', 'inspect_template_name', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    INSPECT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    ITEM_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_NAME_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    inspect_config: InspectConfig
    item: ContentItem
    inspect_template_name: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., inspect_config: _Optional[_Union[InspectConfig, _Mapping]]=..., item: _Optional[_Union[ContentItem, _Mapping]]=..., inspect_template_name: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class InspectContentResponse(_message.Message):
    __slots__ = ('result',)
    RESULT_FIELD_NUMBER: _ClassVar[int]
    result: InspectResult

    def __init__(self, result: _Optional[_Union[InspectResult, _Mapping]]=...) -> None:
        ...

class OutputStorageConfig(_message.Message):
    __slots__ = ('table', 'output_schema')

    class OutputSchema(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        OUTPUT_SCHEMA_UNSPECIFIED: _ClassVar[OutputStorageConfig.OutputSchema]
        BASIC_COLUMNS: _ClassVar[OutputStorageConfig.OutputSchema]
        GCS_COLUMNS: _ClassVar[OutputStorageConfig.OutputSchema]
        DATASTORE_COLUMNS: _ClassVar[OutputStorageConfig.OutputSchema]
        BIG_QUERY_COLUMNS: _ClassVar[OutputStorageConfig.OutputSchema]
        ALL_COLUMNS: _ClassVar[OutputStorageConfig.OutputSchema]
    OUTPUT_SCHEMA_UNSPECIFIED: OutputStorageConfig.OutputSchema
    BASIC_COLUMNS: OutputStorageConfig.OutputSchema
    GCS_COLUMNS: OutputStorageConfig.OutputSchema
    DATASTORE_COLUMNS: OutputStorageConfig.OutputSchema
    BIG_QUERY_COLUMNS: OutputStorageConfig.OutputSchema
    ALL_COLUMNS: OutputStorageConfig.OutputSchema
    TABLE_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_SCHEMA_FIELD_NUMBER: _ClassVar[int]
    table: _storage_pb2.BigQueryTable
    output_schema: OutputStorageConfig.OutputSchema

    def __init__(self, table: _Optional[_Union[_storage_pb2.BigQueryTable, _Mapping]]=..., output_schema: _Optional[_Union[OutputStorageConfig.OutputSchema, str]]=...) -> None:
        ...

class InfoTypeStats(_message.Message):
    __slots__ = ('info_type', 'count')
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    COUNT_FIELD_NUMBER: _ClassVar[int]
    info_type: _storage_pb2.InfoType
    count: int

    def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., count: _Optional[int]=...) -> None:
        ...

class InspectDataSourceDetails(_message.Message):
    __slots__ = ('requested_options', 'result')

    class RequestedOptions(_message.Message):
        __slots__ = ('snapshot_inspect_template', 'job_config')
        SNAPSHOT_INSPECT_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
        JOB_CONFIG_FIELD_NUMBER: _ClassVar[int]
        snapshot_inspect_template: InspectTemplate
        job_config: InspectJobConfig

        def __init__(self, snapshot_inspect_template: _Optional[_Union[InspectTemplate, _Mapping]]=..., job_config: _Optional[_Union[InspectJobConfig, _Mapping]]=...) -> None:
            ...

    class Result(_message.Message):
        __slots__ = ('processed_bytes', 'total_estimated_bytes', 'info_type_stats', 'num_rows_processed', 'hybrid_stats')
        PROCESSED_BYTES_FIELD_NUMBER: _ClassVar[int]
        TOTAL_ESTIMATED_BYTES_FIELD_NUMBER: _ClassVar[int]
        INFO_TYPE_STATS_FIELD_NUMBER: _ClassVar[int]
        NUM_ROWS_PROCESSED_FIELD_NUMBER: _ClassVar[int]
        HYBRID_STATS_FIELD_NUMBER: _ClassVar[int]
        processed_bytes: int
        total_estimated_bytes: int
        info_type_stats: _containers.RepeatedCompositeFieldContainer[InfoTypeStats]
        num_rows_processed: int
        hybrid_stats: HybridInspectStatistics

        def __init__(self, processed_bytes: _Optional[int]=..., total_estimated_bytes: _Optional[int]=..., info_type_stats: _Optional[_Iterable[_Union[InfoTypeStats, _Mapping]]]=..., num_rows_processed: _Optional[int]=..., hybrid_stats: _Optional[_Union[HybridInspectStatistics, _Mapping]]=...) -> None:
            ...
    REQUESTED_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    requested_options: InspectDataSourceDetails.RequestedOptions
    result: InspectDataSourceDetails.Result

    def __init__(self, requested_options: _Optional[_Union[InspectDataSourceDetails.RequestedOptions, _Mapping]]=..., result: _Optional[_Union[InspectDataSourceDetails.Result, _Mapping]]=...) -> None:
        ...

class DataProfileBigQueryRowSchema(_message.Message):
    __slots__ = ('table_profile', 'column_profile', 'file_store_profile')
    TABLE_PROFILE_FIELD_NUMBER: _ClassVar[int]
    COLUMN_PROFILE_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_PROFILE_FIELD_NUMBER: _ClassVar[int]
    table_profile: TableDataProfile
    column_profile: ColumnDataProfile
    file_store_profile: FileStoreDataProfile

    def __init__(self, table_profile: _Optional[_Union[TableDataProfile, _Mapping]]=..., column_profile: _Optional[_Union[ColumnDataProfile, _Mapping]]=..., file_store_profile: _Optional[_Union[FileStoreDataProfile, _Mapping]]=...) -> None:
        ...

class HybridInspectStatistics(_message.Message):
    __slots__ = ('processed_count', 'aborted_count', 'pending_count')
    PROCESSED_COUNT_FIELD_NUMBER: _ClassVar[int]
    ABORTED_COUNT_FIELD_NUMBER: _ClassVar[int]
    PENDING_COUNT_FIELD_NUMBER: _ClassVar[int]
    processed_count: int
    aborted_count: int
    pending_count: int

    def __init__(self, processed_count: _Optional[int]=..., aborted_count: _Optional[int]=..., pending_count: _Optional[int]=...) -> None:
        ...

class ActionDetails(_message.Message):
    __slots__ = ('deidentify_details',)
    DEIDENTIFY_DETAILS_FIELD_NUMBER: _ClassVar[int]
    deidentify_details: DeidentifyDataSourceDetails

    def __init__(self, deidentify_details: _Optional[_Union[DeidentifyDataSourceDetails, _Mapping]]=...) -> None:
        ...

class DeidentifyDataSourceStats(_message.Message):
    __slots__ = ('transformed_bytes', 'transformation_count', 'transformation_error_count')
    TRANSFORMED_BYTES_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMATION_COUNT_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMATION_ERROR_COUNT_FIELD_NUMBER: _ClassVar[int]
    transformed_bytes: int
    transformation_count: int
    transformation_error_count: int

    def __init__(self, transformed_bytes: _Optional[int]=..., transformation_count: _Optional[int]=..., transformation_error_count: _Optional[int]=...) -> None:
        ...

class DeidentifyDataSourceDetails(_message.Message):
    __slots__ = ('requested_options', 'deidentify_stats')

    class RequestedDeidentifyOptions(_message.Message):
        __slots__ = ('snapshot_deidentify_template', 'snapshot_structured_deidentify_template', 'snapshot_image_redact_template')
        SNAPSHOT_DEIDENTIFY_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_STRUCTURED_DEIDENTIFY_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_IMAGE_REDACT_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
        snapshot_deidentify_template: DeidentifyTemplate
        snapshot_structured_deidentify_template: DeidentifyTemplate
        snapshot_image_redact_template: DeidentifyTemplate

        def __init__(self, snapshot_deidentify_template: _Optional[_Union[DeidentifyTemplate, _Mapping]]=..., snapshot_structured_deidentify_template: _Optional[_Union[DeidentifyTemplate, _Mapping]]=..., snapshot_image_redact_template: _Optional[_Union[DeidentifyTemplate, _Mapping]]=...) -> None:
            ...
    REQUESTED_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    DEIDENTIFY_STATS_FIELD_NUMBER: _ClassVar[int]
    requested_options: DeidentifyDataSourceDetails.RequestedDeidentifyOptions
    deidentify_stats: DeidentifyDataSourceStats

    def __init__(self, requested_options: _Optional[_Union[DeidentifyDataSourceDetails.RequestedDeidentifyOptions, _Mapping]]=..., deidentify_stats: _Optional[_Union[DeidentifyDataSourceStats, _Mapping]]=...) -> None:
        ...

class InfoTypeDescription(_message.Message):
    __slots__ = ('name', 'display_name', 'supported_by', 'description', 'versions', 'categories', 'sensitivity_score')
    NAME_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    SUPPORTED_BY_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    VERSIONS_FIELD_NUMBER: _ClassVar[int]
    CATEGORIES_FIELD_NUMBER: _ClassVar[int]
    SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
    name: str
    display_name: str
    supported_by: _containers.RepeatedScalarFieldContainer[InfoTypeSupportedBy]
    description: str
    versions: _containers.RepeatedCompositeFieldContainer[VersionDescription]
    categories: _containers.RepeatedCompositeFieldContainer[InfoTypeCategory]
    sensitivity_score: _storage_pb2.SensitivityScore

    def __init__(self, name: _Optional[str]=..., display_name: _Optional[str]=..., supported_by: _Optional[_Iterable[_Union[InfoTypeSupportedBy, str]]]=..., description: _Optional[str]=..., versions: _Optional[_Iterable[_Union[VersionDescription, _Mapping]]]=..., categories: _Optional[_Iterable[_Union[InfoTypeCategory, _Mapping]]]=..., sensitivity_score: _Optional[_Union[_storage_pb2.SensitivityScore, _Mapping]]=...) -> None:
        ...

class InfoTypeCategory(_message.Message):
    __slots__ = ('location_category', 'industry_category', 'type_category')

    class LocationCategory(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        LOCATION_UNSPECIFIED: _ClassVar[InfoTypeCategory.LocationCategory]
        GLOBAL: _ClassVar[InfoTypeCategory.LocationCategory]
        ARGENTINA: _ClassVar[InfoTypeCategory.LocationCategory]
        ARMENIA: _ClassVar[InfoTypeCategory.LocationCategory]
        AUSTRALIA: _ClassVar[InfoTypeCategory.LocationCategory]
        AZERBAIJAN: _ClassVar[InfoTypeCategory.LocationCategory]
        BELARUS: _ClassVar[InfoTypeCategory.LocationCategory]
        BELGIUM: _ClassVar[InfoTypeCategory.LocationCategory]
        BRAZIL: _ClassVar[InfoTypeCategory.LocationCategory]
        CANADA: _ClassVar[InfoTypeCategory.LocationCategory]
        CHILE: _ClassVar[InfoTypeCategory.LocationCategory]
        CHINA: _ClassVar[InfoTypeCategory.LocationCategory]
        COLOMBIA: _ClassVar[InfoTypeCategory.LocationCategory]
        CROATIA: _ClassVar[InfoTypeCategory.LocationCategory]
        DENMARK: _ClassVar[InfoTypeCategory.LocationCategory]
        FRANCE: _ClassVar[InfoTypeCategory.LocationCategory]
        FINLAND: _ClassVar[InfoTypeCategory.LocationCategory]
        GERMANY: _ClassVar[InfoTypeCategory.LocationCategory]
        HONG_KONG: _ClassVar[InfoTypeCategory.LocationCategory]
        INDIA: _ClassVar[InfoTypeCategory.LocationCategory]
        INDONESIA: _ClassVar[InfoTypeCategory.LocationCategory]
        IRELAND: _ClassVar[InfoTypeCategory.LocationCategory]
        ISRAEL: _ClassVar[InfoTypeCategory.LocationCategory]
        ITALY: _ClassVar[InfoTypeCategory.LocationCategory]
        JAPAN: _ClassVar[InfoTypeCategory.LocationCategory]
        KAZAKHSTAN: _ClassVar[InfoTypeCategory.LocationCategory]
        KOREA: _ClassVar[InfoTypeCategory.LocationCategory]
        MEXICO: _ClassVar[InfoTypeCategory.LocationCategory]
        THE_NETHERLANDS: _ClassVar[InfoTypeCategory.LocationCategory]
        NEW_ZEALAND: _ClassVar[InfoTypeCategory.LocationCategory]
        NORWAY: _ClassVar[InfoTypeCategory.LocationCategory]
        PARAGUAY: _ClassVar[InfoTypeCategory.LocationCategory]
        PERU: _ClassVar[InfoTypeCategory.LocationCategory]
        POLAND: _ClassVar[InfoTypeCategory.LocationCategory]
        PORTUGAL: _ClassVar[InfoTypeCategory.LocationCategory]
        RUSSIA: _ClassVar[InfoTypeCategory.LocationCategory]
        SINGAPORE: _ClassVar[InfoTypeCategory.LocationCategory]
        SOUTH_AFRICA: _ClassVar[InfoTypeCategory.LocationCategory]
        SPAIN: _ClassVar[InfoTypeCategory.LocationCategory]
        SWEDEN: _ClassVar[InfoTypeCategory.LocationCategory]
        SWITZERLAND: _ClassVar[InfoTypeCategory.LocationCategory]
        TAIWAN: _ClassVar[InfoTypeCategory.LocationCategory]
        THAILAND: _ClassVar[InfoTypeCategory.LocationCategory]
        TURKEY: _ClassVar[InfoTypeCategory.LocationCategory]
        UKRAINE: _ClassVar[InfoTypeCategory.LocationCategory]
        UNITED_KINGDOM: _ClassVar[InfoTypeCategory.LocationCategory]
        UNITED_STATES: _ClassVar[InfoTypeCategory.LocationCategory]
        URUGUAY: _ClassVar[InfoTypeCategory.LocationCategory]
        UZBEKISTAN: _ClassVar[InfoTypeCategory.LocationCategory]
        VENEZUELA: _ClassVar[InfoTypeCategory.LocationCategory]
        INTERNAL: _ClassVar[InfoTypeCategory.LocationCategory]
    LOCATION_UNSPECIFIED: InfoTypeCategory.LocationCategory
    GLOBAL: InfoTypeCategory.LocationCategory
    ARGENTINA: InfoTypeCategory.LocationCategory
    ARMENIA: InfoTypeCategory.LocationCategory
    AUSTRALIA: InfoTypeCategory.LocationCategory
    AZERBAIJAN: InfoTypeCategory.LocationCategory
    BELARUS: InfoTypeCategory.LocationCategory
    BELGIUM: InfoTypeCategory.LocationCategory
    BRAZIL: InfoTypeCategory.LocationCategory
    CANADA: InfoTypeCategory.LocationCategory
    CHILE: InfoTypeCategory.LocationCategory
    CHINA: InfoTypeCategory.LocationCategory
    COLOMBIA: InfoTypeCategory.LocationCategory
    CROATIA: InfoTypeCategory.LocationCategory
    DENMARK: InfoTypeCategory.LocationCategory
    FRANCE: InfoTypeCategory.LocationCategory
    FINLAND: InfoTypeCategory.LocationCategory
    GERMANY: InfoTypeCategory.LocationCategory
    HONG_KONG: InfoTypeCategory.LocationCategory
    INDIA: InfoTypeCategory.LocationCategory
    INDONESIA: InfoTypeCategory.LocationCategory
    IRELAND: InfoTypeCategory.LocationCategory
    ISRAEL: InfoTypeCategory.LocationCategory
    ITALY: InfoTypeCategory.LocationCategory
    JAPAN: InfoTypeCategory.LocationCategory
    KAZAKHSTAN: InfoTypeCategory.LocationCategory
    KOREA: InfoTypeCategory.LocationCategory
    MEXICO: InfoTypeCategory.LocationCategory
    THE_NETHERLANDS: InfoTypeCategory.LocationCategory
    NEW_ZEALAND: InfoTypeCategory.LocationCategory
    NORWAY: InfoTypeCategory.LocationCategory
    PARAGUAY: InfoTypeCategory.LocationCategory
    PERU: InfoTypeCategory.LocationCategory
    POLAND: InfoTypeCategory.LocationCategory
    PORTUGAL: InfoTypeCategory.LocationCategory
    RUSSIA: InfoTypeCategory.LocationCategory
    SINGAPORE: InfoTypeCategory.LocationCategory
    SOUTH_AFRICA: InfoTypeCategory.LocationCategory
    SPAIN: InfoTypeCategory.LocationCategory
    SWEDEN: InfoTypeCategory.LocationCategory
    SWITZERLAND: InfoTypeCategory.LocationCategory
    TAIWAN: InfoTypeCategory.LocationCategory
    THAILAND: InfoTypeCategory.LocationCategory
    TURKEY: InfoTypeCategory.LocationCategory
    UKRAINE: InfoTypeCategory.LocationCategory
    UNITED_KINGDOM: InfoTypeCategory.LocationCategory
    UNITED_STATES: InfoTypeCategory.LocationCategory
    URUGUAY: InfoTypeCategory.LocationCategory
    UZBEKISTAN: InfoTypeCategory.LocationCategory
    VENEZUELA: InfoTypeCategory.LocationCategory
    INTERNAL: InfoTypeCategory.LocationCategory

    class IndustryCategory(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        INDUSTRY_UNSPECIFIED: _ClassVar[InfoTypeCategory.IndustryCategory]
        FINANCE: _ClassVar[InfoTypeCategory.IndustryCategory]
        HEALTH: _ClassVar[InfoTypeCategory.IndustryCategory]
        TELECOMMUNICATIONS: _ClassVar[InfoTypeCategory.IndustryCategory]
    INDUSTRY_UNSPECIFIED: InfoTypeCategory.IndustryCategory
    FINANCE: InfoTypeCategory.IndustryCategory
    HEALTH: InfoTypeCategory.IndustryCategory
    TELECOMMUNICATIONS: InfoTypeCategory.IndustryCategory

    class TypeCategory(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        TYPE_UNSPECIFIED: _ClassVar[InfoTypeCategory.TypeCategory]
        PII: _ClassVar[InfoTypeCategory.TypeCategory]
        SPII: _ClassVar[InfoTypeCategory.TypeCategory]
        DEMOGRAPHIC: _ClassVar[InfoTypeCategory.TypeCategory]
        CREDENTIAL: _ClassVar[InfoTypeCategory.TypeCategory]
        GOVERNMENT_ID: _ClassVar[InfoTypeCategory.TypeCategory]
        DOCUMENT: _ClassVar[InfoTypeCategory.TypeCategory]
        CONTEXTUAL_INFORMATION: _ClassVar[InfoTypeCategory.TypeCategory]
    TYPE_UNSPECIFIED: InfoTypeCategory.TypeCategory
    PII: InfoTypeCategory.TypeCategory
    SPII: InfoTypeCategory.TypeCategory
    DEMOGRAPHIC: InfoTypeCategory.TypeCategory
    CREDENTIAL: InfoTypeCategory.TypeCategory
    GOVERNMENT_ID: InfoTypeCategory.TypeCategory
    DOCUMENT: InfoTypeCategory.TypeCategory
    CONTEXTUAL_INFORMATION: InfoTypeCategory.TypeCategory
    LOCATION_CATEGORY_FIELD_NUMBER: _ClassVar[int]
    INDUSTRY_CATEGORY_FIELD_NUMBER: _ClassVar[int]
    TYPE_CATEGORY_FIELD_NUMBER: _ClassVar[int]
    location_category: InfoTypeCategory.LocationCategory
    industry_category: InfoTypeCategory.IndustryCategory
    type_category: InfoTypeCategory.TypeCategory

    def __init__(self, location_category: _Optional[_Union[InfoTypeCategory.LocationCategory, str]]=..., industry_category: _Optional[_Union[InfoTypeCategory.IndustryCategory, str]]=..., type_category: _Optional[_Union[InfoTypeCategory.TypeCategory, str]]=...) -> None:
        ...

class VersionDescription(_message.Message):
    __slots__ = ('version', 'description')
    VERSION_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    version: str
    description: str

    def __init__(self, version: _Optional[str]=..., description: _Optional[str]=...) -> None:
        ...

class ListInfoTypesRequest(_message.Message):
    __slots__ = ('parent', 'language_code', 'filter', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    LANGUAGE_CODE_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    language_code: str
    filter: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., language_code: _Optional[str]=..., filter: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ListInfoTypesResponse(_message.Message):
    __slots__ = ('info_types',)
    INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    info_types: _containers.RepeatedCompositeFieldContainer[InfoTypeDescription]

    def __init__(self, info_types: _Optional[_Iterable[_Union[InfoTypeDescription, _Mapping]]]=...) -> None:
        ...

class RiskAnalysisJobConfig(_message.Message):
    __slots__ = ('privacy_metric', 'source_table', 'actions')
    PRIVACY_METRIC_FIELD_NUMBER: _ClassVar[int]
    SOURCE_TABLE_FIELD_NUMBER: _ClassVar[int]
    ACTIONS_FIELD_NUMBER: _ClassVar[int]
    privacy_metric: PrivacyMetric
    source_table: _storage_pb2.BigQueryTable
    actions: _containers.RepeatedCompositeFieldContainer[Action]

    def __init__(self, privacy_metric: _Optional[_Union[PrivacyMetric, _Mapping]]=..., source_table: _Optional[_Union[_storage_pb2.BigQueryTable, _Mapping]]=..., actions: _Optional[_Iterable[_Union[Action, _Mapping]]]=...) -> None:
        ...

class QuasiId(_message.Message):
    __slots__ = ('field', 'info_type', 'custom_tag', 'inferred')
    FIELD_FIELD_NUMBER: _ClassVar[int]
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_TAG_FIELD_NUMBER: _ClassVar[int]
    INFERRED_FIELD_NUMBER: _ClassVar[int]
    field: _storage_pb2.FieldId
    info_type: _storage_pb2.InfoType
    custom_tag: str
    inferred: _empty_pb2.Empty

    def __init__(self, field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., custom_tag: _Optional[str]=..., inferred: _Optional[_Union[_empty_pb2.Empty, _Mapping]]=...) -> None:
        ...

class StatisticalTable(_message.Message):
    __slots__ = ('table', 'quasi_ids', 'relative_frequency')

    class QuasiIdentifierField(_message.Message):
        __slots__ = ('field', 'custom_tag')
        FIELD_FIELD_NUMBER: _ClassVar[int]
        CUSTOM_TAG_FIELD_NUMBER: _ClassVar[int]
        field: _storage_pb2.FieldId
        custom_tag: str

        def __init__(self, field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., custom_tag: _Optional[str]=...) -> None:
            ...
    TABLE_FIELD_NUMBER: _ClassVar[int]
    QUASI_IDS_FIELD_NUMBER: _ClassVar[int]
    RELATIVE_FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    table: _storage_pb2.BigQueryTable
    quasi_ids: _containers.RepeatedCompositeFieldContainer[StatisticalTable.QuasiIdentifierField]
    relative_frequency: _storage_pb2.FieldId

    def __init__(self, table: _Optional[_Union[_storage_pb2.BigQueryTable, _Mapping]]=..., quasi_ids: _Optional[_Iterable[_Union[StatisticalTable.QuasiIdentifierField, _Mapping]]]=..., relative_frequency: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=...) -> None:
        ...

class PrivacyMetric(_message.Message):
    __slots__ = ('numerical_stats_config', 'categorical_stats_config', 'k_anonymity_config', 'l_diversity_config', 'k_map_estimation_config', 'delta_presence_estimation_config')

    class NumericalStatsConfig(_message.Message):
        __slots__ = ('field',)
        FIELD_FIELD_NUMBER: _ClassVar[int]
        field: _storage_pb2.FieldId

        def __init__(self, field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=...) -> None:
            ...

    class CategoricalStatsConfig(_message.Message):
        __slots__ = ('field',)
        FIELD_FIELD_NUMBER: _ClassVar[int]
        field: _storage_pb2.FieldId

        def __init__(self, field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=...) -> None:
            ...

    class KAnonymityConfig(_message.Message):
        __slots__ = ('quasi_ids', 'entity_id')
        QUASI_IDS_FIELD_NUMBER: _ClassVar[int]
        ENTITY_ID_FIELD_NUMBER: _ClassVar[int]
        quasi_ids: _containers.RepeatedCompositeFieldContainer[_storage_pb2.FieldId]
        entity_id: _storage_pb2.EntityId

        def __init__(self, quasi_ids: _Optional[_Iterable[_Union[_storage_pb2.FieldId, _Mapping]]]=..., entity_id: _Optional[_Union[_storage_pb2.EntityId, _Mapping]]=...) -> None:
            ...

    class LDiversityConfig(_message.Message):
        __slots__ = ('quasi_ids', 'sensitive_attribute')
        QUASI_IDS_FIELD_NUMBER: _ClassVar[int]
        SENSITIVE_ATTRIBUTE_FIELD_NUMBER: _ClassVar[int]
        quasi_ids: _containers.RepeatedCompositeFieldContainer[_storage_pb2.FieldId]
        sensitive_attribute: _storage_pb2.FieldId

        def __init__(self, quasi_ids: _Optional[_Iterable[_Union[_storage_pb2.FieldId, _Mapping]]]=..., sensitive_attribute: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=...) -> None:
            ...

    class KMapEstimationConfig(_message.Message):
        __slots__ = ('quasi_ids', 'region_code', 'auxiliary_tables')

        class TaggedField(_message.Message):
            __slots__ = ('field', 'info_type', 'custom_tag', 'inferred')
            FIELD_FIELD_NUMBER: _ClassVar[int]
            INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
            CUSTOM_TAG_FIELD_NUMBER: _ClassVar[int]
            INFERRED_FIELD_NUMBER: _ClassVar[int]
            field: _storage_pb2.FieldId
            info_type: _storage_pb2.InfoType
            custom_tag: str
            inferred: _empty_pb2.Empty

            def __init__(self, field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., custom_tag: _Optional[str]=..., inferred: _Optional[_Union[_empty_pb2.Empty, _Mapping]]=...) -> None:
                ...

        class AuxiliaryTable(_message.Message):
            __slots__ = ('table', 'quasi_ids', 'relative_frequency')

            class QuasiIdField(_message.Message):
                __slots__ = ('field', 'custom_tag')
                FIELD_FIELD_NUMBER: _ClassVar[int]
                CUSTOM_TAG_FIELD_NUMBER: _ClassVar[int]
                field: _storage_pb2.FieldId
                custom_tag: str

                def __init__(self, field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., custom_tag: _Optional[str]=...) -> None:
                    ...
            TABLE_FIELD_NUMBER: _ClassVar[int]
            QUASI_IDS_FIELD_NUMBER: _ClassVar[int]
            RELATIVE_FREQUENCY_FIELD_NUMBER: _ClassVar[int]
            table: _storage_pb2.BigQueryTable
            quasi_ids: _containers.RepeatedCompositeFieldContainer[PrivacyMetric.KMapEstimationConfig.AuxiliaryTable.QuasiIdField]
            relative_frequency: _storage_pb2.FieldId

            def __init__(self, table: _Optional[_Union[_storage_pb2.BigQueryTable, _Mapping]]=..., quasi_ids: _Optional[_Iterable[_Union[PrivacyMetric.KMapEstimationConfig.AuxiliaryTable.QuasiIdField, _Mapping]]]=..., relative_frequency: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=...) -> None:
                ...
        QUASI_IDS_FIELD_NUMBER: _ClassVar[int]
        REGION_CODE_FIELD_NUMBER: _ClassVar[int]
        AUXILIARY_TABLES_FIELD_NUMBER: _ClassVar[int]
        quasi_ids: _containers.RepeatedCompositeFieldContainer[PrivacyMetric.KMapEstimationConfig.TaggedField]
        region_code: str
        auxiliary_tables: _containers.RepeatedCompositeFieldContainer[PrivacyMetric.KMapEstimationConfig.AuxiliaryTable]

        def __init__(self, quasi_ids: _Optional[_Iterable[_Union[PrivacyMetric.KMapEstimationConfig.TaggedField, _Mapping]]]=..., region_code: _Optional[str]=..., auxiliary_tables: _Optional[_Iterable[_Union[PrivacyMetric.KMapEstimationConfig.AuxiliaryTable, _Mapping]]]=...) -> None:
            ...

    class DeltaPresenceEstimationConfig(_message.Message):
        __slots__ = ('quasi_ids', 'region_code', 'auxiliary_tables')
        QUASI_IDS_FIELD_NUMBER: _ClassVar[int]
        REGION_CODE_FIELD_NUMBER: _ClassVar[int]
        AUXILIARY_TABLES_FIELD_NUMBER: _ClassVar[int]
        quasi_ids: _containers.RepeatedCompositeFieldContainer[QuasiId]
        region_code: str
        auxiliary_tables: _containers.RepeatedCompositeFieldContainer[StatisticalTable]

        def __init__(self, quasi_ids: _Optional[_Iterable[_Union[QuasiId, _Mapping]]]=..., region_code: _Optional[str]=..., auxiliary_tables: _Optional[_Iterable[_Union[StatisticalTable, _Mapping]]]=...) -> None:
            ...
    NUMERICAL_STATS_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CATEGORICAL_STATS_CONFIG_FIELD_NUMBER: _ClassVar[int]
    K_ANONYMITY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    L_DIVERSITY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    K_MAP_ESTIMATION_CONFIG_FIELD_NUMBER: _ClassVar[int]
    DELTA_PRESENCE_ESTIMATION_CONFIG_FIELD_NUMBER: _ClassVar[int]
    numerical_stats_config: PrivacyMetric.NumericalStatsConfig
    categorical_stats_config: PrivacyMetric.CategoricalStatsConfig
    k_anonymity_config: PrivacyMetric.KAnonymityConfig
    l_diversity_config: PrivacyMetric.LDiversityConfig
    k_map_estimation_config: PrivacyMetric.KMapEstimationConfig
    delta_presence_estimation_config: PrivacyMetric.DeltaPresenceEstimationConfig

    def __init__(self, numerical_stats_config: _Optional[_Union[PrivacyMetric.NumericalStatsConfig, _Mapping]]=..., categorical_stats_config: _Optional[_Union[PrivacyMetric.CategoricalStatsConfig, _Mapping]]=..., k_anonymity_config: _Optional[_Union[PrivacyMetric.KAnonymityConfig, _Mapping]]=..., l_diversity_config: _Optional[_Union[PrivacyMetric.LDiversityConfig, _Mapping]]=..., k_map_estimation_config: _Optional[_Union[PrivacyMetric.KMapEstimationConfig, _Mapping]]=..., delta_presence_estimation_config: _Optional[_Union[PrivacyMetric.DeltaPresenceEstimationConfig, _Mapping]]=...) -> None:
        ...

class AnalyzeDataSourceRiskDetails(_message.Message):
    __slots__ = ('requested_privacy_metric', 'requested_source_table', 'numerical_stats_result', 'categorical_stats_result', 'k_anonymity_result', 'l_diversity_result', 'k_map_estimation_result', 'delta_presence_estimation_result', 'requested_options')

    class NumericalStatsResult(_message.Message):
        __slots__ = ('min_value', 'max_value', 'quantile_values')
        MIN_VALUE_FIELD_NUMBER: _ClassVar[int]
        MAX_VALUE_FIELD_NUMBER: _ClassVar[int]
        QUANTILE_VALUES_FIELD_NUMBER: _ClassVar[int]
        min_value: Value
        max_value: Value
        quantile_values: _containers.RepeatedCompositeFieldContainer[Value]

        def __init__(self, min_value: _Optional[_Union[Value, _Mapping]]=..., max_value: _Optional[_Union[Value, _Mapping]]=..., quantile_values: _Optional[_Iterable[_Union[Value, _Mapping]]]=...) -> None:
            ...

    class CategoricalStatsResult(_message.Message):
        __slots__ = ('value_frequency_histogram_buckets',)

        class CategoricalStatsHistogramBucket(_message.Message):
            __slots__ = ('value_frequency_lower_bound', 'value_frequency_upper_bound', 'bucket_size', 'bucket_values', 'bucket_value_count')
            VALUE_FREQUENCY_LOWER_BOUND_FIELD_NUMBER: _ClassVar[int]
            VALUE_FREQUENCY_UPPER_BOUND_FIELD_NUMBER: _ClassVar[int]
            BUCKET_SIZE_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUES_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUE_COUNT_FIELD_NUMBER: _ClassVar[int]
            value_frequency_lower_bound: int
            value_frequency_upper_bound: int
            bucket_size: int
            bucket_values: _containers.RepeatedCompositeFieldContainer[ValueFrequency]
            bucket_value_count: int

            def __init__(self, value_frequency_lower_bound: _Optional[int]=..., value_frequency_upper_bound: _Optional[int]=..., bucket_size: _Optional[int]=..., bucket_values: _Optional[_Iterable[_Union[ValueFrequency, _Mapping]]]=..., bucket_value_count: _Optional[int]=...) -> None:
                ...
        VALUE_FREQUENCY_HISTOGRAM_BUCKETS_FIELD_NUMBER: _ClassVar[int]
        value_frequency_histogram_buckets: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.CategoricalStatsResult.CategoricalStatsHistogramBucket]

        def __init__(self, value_frequency_histogram_buckets: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.CategoricalStatsResult.CategoricalStatsHistogramBucket, _Mapping]]]=...) -> None:
            ...

    class KAnonymityResult(_message.Message):
        __slots__ = ('equivalence_class_histogram_buckets',)

        class KAnonymityEquivalenceClass(_message.Message):
            __slots__ = ('quasi_ids_values', 'equivalence_class_size')
            QUASI_IDS_VALUES_FIELD_NUMBER: _ClassVar[int]
            EQUIVALENCE_CLASS_SIZE_FIELD_NUMBER: _ClassVar[int]
            quasi_ids_values: _containers.RepeatedCompositeFieldContainer[Value]
            equivalence_class_size: int

            def __init__(self, quasi_ids_values: _Optional[_Iterable[_Union[Value, _Mapping]]]=..., equivalence_class_size: _Optional[int]=...) -> None:
                ...

        class KAnonymityHistogramBucket(_message.Message):
            __slots__ = ('equivalence_class_size_lower_bound', 'equivalence_class_size_upper_bound', 'bucket_size', 'bucket_values', 'bucket_value_count')
            EQUIVALENCE_CLASS_SIZE_LOWER_BOUND_FIELD_NUMBER: _ClassVar[int]
            EQUIVALENCE_CLASS_SIZE_UPPER_BOUND_FIELD_NUMBER: _ClassVar[int]
            BUCKET_SIZE_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUES_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUE_COUNT_FIELD_NUMBER: _ClassVar[int]
            equivalence_class_size_lower_bound: int
            equivalence_class_size_upper_bound: int
            bucket_size: int
            bucket_values: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.KAnonymityResult.KAnonymityEquivalenceClass]
            bucket_value_count: int

            def __init__(self, equivalence_class_size_lower_bound: _Optional[int]=..., equivalence_class_size_upper_bound: _Optional[int]=..., bucket_size: _Optional[int]=..., bucket_values: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.KAnonymityResult.KAnonymityEquivalenceClass, _Mapping]]]=..., bucket_value_count: _Optional[int]=...) -> None:
                ...
        EQUIVALENCE_CLASS_HISTOGRAM_BUCKETS_FIELD_NUMBER: _ClassVar[int]
        equivalence_class_histogram_buckets: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.KAnonymityResult.KAnonymityHistogramBucket]

        def __init__(self, equivalence_class_histogram_buckets: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.KAnonymityResult.KAnonymityHistogramBucket, _Mapping]]]=...) -> None:
            ...

    class LDiversityResult(_message.Message):
        __slots__ = ('sensitive_value_frequency_histogram_buckets',)

        class LDiversityEquivalenceClass(_message.Message):
            __slots__ = ('quasi_ids_values', 'equivalence_class_size', 'num_distinct_sensitive_values', 'top_sensitive_values')
            QUASI_IDS_VALUES_FIELD_NUMBER: _ClassVar[int]
            EQUIVALENCE_CLASS_SIZE_FIELD_NUMBER: _ClassVar[int]
            NUM_DISTINCT_SENSITIVE_VALUES_FIELD_NUMBER: _ClassVar[int]
            TOP_SENSITIVE_VALUES_FIELD_NUMBER: _ClassVar[int]
            quasi_ids_values: _containers.RepeatedCompositeFieldContainer[Value]
            equivalence_class_size: int
            num_distinct_sensitive_values: int
            top_sensitive_values: _containers.RepeatedCompositeFieldContainer[ValueFrequency]

            def __init__(self, quasi_ids_values: _Optional[_Iterable[_Union[Value, _Mapping]]]=..., equivalence_class_size: _Optional[int]=..., num_distinct_sensitive_values: _Optional[int]=..., top_sensitive_values: _Optional[_Iterable[_Union[ValueFrequency, _Mapping]]]=...) -> None:
                ...

        class LDiversityHistogramBucket(_message.Message):
            __slots__ = ('sensitive_value_frequency_lower_bound', 'sensitive_value_frequency_upper_bound', 'bucket_size', 'bucket_values', 'bucket_value_count')
            SENSITIVE_VALUE_FREQUENCY_LOWER_BOUND_FIELD_NUMBER: _ClassVar[int]
            SENSITIVE_VALUE_FREQUENCY_UPPER_BOUND_FIELD_NUMBER: _ClassVar[int]
            BUCKET_SIZE_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUES_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUE_COUNT_FIELD_NUMBER: _ClassVar[int]
            sensitive_value_frequency_lower_bound: int
            sensitive_value_frequency_upper_bound: int
            bucket_size: int
            bucket_values: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.LDiversityResult.LDiversityEquivalenceClass]
            bucket_value_count: int

            def __init__(self, sensitive_value_frequency_lower_bound: _Optional[int]=..., sensitive_value_frequency_upper_bound: _Optional[int]=..., bucket_size: _Optional[int]=..., bucket_values: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.LDiversityResult.LDiversityEquivalenceClass, _Mapping]]]=..., bucket_value_count: _Optional[int]=...) -> None:
                ...
        SENSITIVE_VALUE_FREQUENCY_HISTOGRAM_BUCKETS_FIELD_NUMBER: _ClassVar[int]
        sensitive_value_frequency_histogram_buckets: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.LDiversityResult.LDiversityHistogramBucket]

        def __init__(self, sensitive_value_frequency_histogram_buckets: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.LDiversityResult.LDiversityHistogramBucket, _Mapping]]]=...) -> None:
            ...

    class KMapEstimationResult(_message.Message):
        __slots__ = ('k_map_estimation_histogram',)

        class KMapEstimationQuasiIdValues(_message.Message):
            __slots__ = ('quasi_ids_values', 'estimated_anonymity')
            QUASI_IDS_VALUES_FIELD_NUMBER: _ClassVar[int]
            ESTIMATED_ANONYMITY_FIELD_NUMBER: _ClassVar[int]
            quasi_ids_values: _containers.RepeatedCompositeFieldContainer[Value]
            estimated_anonymity: int

            def __init__(self, quasi_ids_values: _Optional[_Iterable[_Union[Value, _Mapping]]]=..., estimated_anonymity: _Optional[int]=...) -> None:
                ...

        class KMapEstimationHistogramBucket(_message.Message):
            __slots__ = ('min_anonymity', 'max_anonymity', 'bucket_size', 'bucket_values', 'bucket_value_count')
            MIN_ANONYMITY_FIELD_NUMBER: _ClassVar[int]
            MAX_ANONYMITY_FIELD_NUMBER: _ClassVar[int]
            BUCKET_SIZE_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUES_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUE_COUNT_FIELD_NUMBER: _ClassVar[int]
            min_anonymity: int
            max_anonymity: int
            bucket_size: int
            bucket_values: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.KMapEstimationResult.KMapEstimationQuasiIdValues]
            bucket_value_count: int

            def __init__(self, min_anonymity: _Optional[int]=..., max_anonymity: _Optional[int]=..., bucket_size: _Optional[int]=..., bucket_values: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.KMapEstimationResult.KMapEstimationQuasiIdValues, _Mapping]]]=..., bucket_value_count: _Optional[int]=...) -> None:
                ...
        K_MAP_ESTIMATION_HISTOGRAM_FIELD_NUMBER: _ClassVar[int]
        k_map_estimation_histogram: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.KMapEstimationResult.KMapEstimationHistogramBucket]

        def __init__(self, k_map_estimation_histogram: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.KMapEstimationResult.KMapEstimationHistogramBucket, _Mapping]]]=...) -> None:
            ...

    class DeltaPresenceEstimationResult(_message.Message):
        __slots__ = ('delta_presence_estimation_histogram',)

        class DeltaPresenceEstimationQuasiIdValues(_message.Message):
            __slots__ = ('quasi_ids_values', 'estimated_probability')
            QUASI_IDS_VALUES_FIELD_NUMBER: _ClassVar[int]
            ESTIMATED_PROBABILITY_FIELD_NUMBER: _ClassVar[int]
            quasi_ids_values: _containers.RepeatedCompositeFieldContainer[Value]
            estimated_probability: float

            def __init__(self, quasi_ids_values: _Optional[_Iterable[_Union[Value, _Mapping]]]=..., estimated_probability: _Optional[float]=...) -> None:
                ...

        class DeltaPresenceEstimationHistogramBucket(_message.Message):
            __slots__ = ('min_probability', 'max_probability', 'bucket_size', 'bucket_values', 'bucket_value_count')
            MIN_PROBABILITY_FIELD_NUMBER: _ClassVar[int]
            MAX_PROBABILITY_FIELD_NUMBER: _ClassVar[int]
            BUCKET_SIZE_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUES_FIELD_NUMBER: _ClassVar[int]
            BUCKET_VALUE_COUNT_FIELD_NUMBER: _ClassVar[int]
            min_probability: float
            max_probability: float
            bucket_size: int
            bucket_values: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.DeltaPresenceEstimationResult.DeltaPresenceEstimationQuasiIdValues]
            bucket_value_count: int

            def __init__(self, min_probability: _Optional[float]=..., max_probability: _Optional[float]=..., bucket_size: _Optional[int]=..., bucket_values: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.DeltaPresenceEstimationResult.DeltaPresenceEstimationQuasiIdValues, _Mapping]]]=..., bucket_value_count: _Optional[int]=...) -> None:
                ...
        DELTA_PRESENCE_ESTIMATION_HISTOGRAM_FIELD_NUMBER: _ClassVar[int]
        delta_presence_estimation_histogram: _containers.RepeatedCompositeFieldContainer[AnalyzeDataSourceRiskDetails.DeltaPresenceEstimationResult.DeltaPresenceEstimationHistogramBucket]

        def __init__(self, delta_presence_estimation_histogram: _Optional[_Iterable[_Union[AnalyzeDataSourceRiskDetails.DeltaPresenceEstimationResult.DeltaPresenceEstimationHistogramBucket, _Mapping]]]=...) -> None:
            ...

    class RequestedRiskAnalysisOptions(_message.Message):
        __slots__ = ('job_config',)
        JOB_CONFIG_FIELD_NUMBER: _ClassVar[int]
        job_config: RiskAnalysisJobConfig

        def __init__(self, job_config: _Optional[_Union[RiskAnalysisJobConfig, _Mapping]]=...) -> None:
            ...
    REQUESTED_PRIVACY_METRIC_FIELD_NUMBER: _ClassVar[int]
    REQUESTED_SOURCE_TABLE_FIELD_NUMBER: _ClassVar[int]
    NUMERICAL_STATS_RESULT_FIELD_NUMBER: _ClassVar[int]
    CATEGORICAL_STATS_RESULT_FIELD_NUMBER: _ClassVar[int]
    K_ANONYMITY_RESULT_FIELD_NUMBER: _ClassVar[int]
    L_DIVERSITY_RESULT_FIELD_NUMBER: _ClassVar[int]
    K_MAP_ESTIMATION_RESULT_FIELD_NUMBER: _ClassVar[int]
    DELTA_PRESENCE_ESTIMATION_RESULT_FIELD_NUMBER: _ClassVar[int]
    REQUESTED_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    requested_privacy_metric: PrivacyMetric
    requested_source_table: _storage_pb2.BigQueryTable
    numerical_stats_result: AnalyzeDataSourceRiskDetails.NumericalStatsResult
    categorical_stats_result: AnalyzeDataSourceRiskDetails.CategoricalStatsResult
    k_anonymity_result: AnalyzeDataSourceRiskDetails.KAnonymityResult
    l_diversity_result: AnalyzeDataSourceRiskDetails.LDiversityResult
    k_map_estimation_result: AnalyzeDataSourceRiskDetails.KMapEstimationResult
    delta_presence_estimation_result: AnalyzeDataSourceRiskDetails.DeltaPresenceEstimationResult
    requested_options: AnalyzeDataSourceRiskDetails.RequestedRiskAnalysisOptions

    def __init__(self, requested_privacy_metric: _Optional[_Union[PrivacyMetric, _Mapping]]=..., requested_source_table: _Optional[_Union[_storage_pb2.BigQueryTable, _Mapping]]=..., numerical_stats_result: _Optional[_Union[AnalyzeDataSourceRiskDetails.NumericalStatsResult, _Mapping]]=..., categorical_stats_result: _Optional[_Union[AnalyzeDataSourceRiskDetails.CategoricalStatsResult, _Mapping]]=..., k_anonymity_result: _Optional[_Union[AnalyzeDataSourceRiskDetails.KAnonymityResult, _Mapping]]=..., l_diversity_result: _Optional[_Union[AnalyzeDataSourceRiskDetails.LDiversityResult, _Mapping]]=..., k_map_estimation_result: _Optional[_Union[AnalyzeDataSourceRiskDetails.KMapEstimationResult, _Mapping]]=..., delta_presence_estimation_result: _Optional[_Union[AnalyzeDataSourceRiskDetails.DeltaPresenceEstimationResult, _Mapping]]=..., requested_options: _Optional[_Union[AnalyzeDataSourceRiskDetails.RequestedRiskAnalysisOptions, _Mapping]]=...) -> None:
        ...

class ValueFrequency(_message.Message):
    __slots__ = ('value', 'count')
    VALUE_FIELD_NUMBER: _ClassVar[int]
    COUNT_FIELD_NUMBER: _ClassVar[int]
    value: Value
    count: int

    def __init__(self, value: _Optional[_Union[Value, _Mapping]]=..., count: _Optional[int]=...) -> None:
        ...

class Value(_message.Message):
    __slots__ = ('integer_value', 'float_value', 'string_value', 'boolean_value', 'timestamp_value', 'time_value', 'date_value', 'day_of_week_value')
    INTEGER_VALUE_FIELD_NUMBER: _ClassVar[int]
    FLOAT_VALUE_FIELD_NUMBER: _ClassVar[int]
    STRING_VALUE_FIELD_NUMBER: _ClassVar[int]
    BOOLEAN_VALUE_FIELD_NUMBER: _ClassVar[int]
    TIMESTAMP_VALUE_FIELD_NUMBER: _ClassVar[int]
    TIME_VALUE_FIELD_NUMBER: _ClassVar[int]
    DATE_VALUE_FIELD_NUMBER: _ClassVar[int]
    DAY_OF_WEEK_VALUE_FIELD_NUMBER: _ClassVar[int]
    integer_value: int
    float_value: float
    string_value: str
    boolean_value: bool
    timestamp_value: _timestamp_pb2.Timestamp
    time_value: _timeofday_pb2.TimeOfDay
    date_value: _date_pb2.Date
    day_of_week_value: _dayofweek_pb2.DayOfWeek

    def __init__(self, integer_value: _Optional[int]=..., float_value: _Optional[float]=..., string_value: _Optional[str]=..., boolean_value: bool=..., timestamp_value: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., time_value: _Optional[_Union[_timeofday_pb2.TimeOfDay, _Mapping]]=..., date_value: _Optional[_Union[_date_pb2.Date, _Mapping]]=..., day_of_week_value: _Optional[_Union[_dayofweek_pb2.DayOfWeek, str]]=...) -> None:
        ...

class QuoteInfo(_message.Message):
    __slots__ = ('date_time',)
    DATE_TIME_FIELD_NUMBER: _ClassVar[int]
    date_time: DateTime

    def __init__(self, date_time: _Optional[_Union[DateTime, _Mapping]]=...) -> None:
        ...

class DateTime(_message.Message):
    __slots__ = ('date', 'day_of_week', 'time', 'time_zone')

    class TimeZone(_message.Message):
        __slots__ = ('offset_minutes',)
        OFFSET_MINUTES_FIELD_NUMBER: _ClassVar[int]
        offset_minutes: int

        def __init__(self, offset_minutes: _Optional[int]=...) -> None:
            ...
    DATE_FIELD_NUMBER: _ClassVar[int]
    DAY_OF_WEEK_FIELD_NUMBER: _ClassVar[int]
    TIME_FIELD_NUMBER: _ClassVar[int]
    TIME_ZONE_FIELD_NUMBER: _ClassVar[int]
    date: _date_pb2.Date
    day_of_week: _dayofweek_pb2.DayOfWeek
    time: _timeofday_pb2.TimeOfDay
    time_zone: DateTime.TimeZone

    def __init__(self, date: _Optional[_Union[_date_pb2.Date, _Mapping]]=..., day_of_week: _Optional[_Union[_dayofweek_pb2.DayOfWeek, str]]=..., time: _Optional[_Union[_timeofday_pb2.TimeOfDay, _Mapping]]=..., time_zone: _Optional[_Union[DateTime.TimeZone, _Mapping]]=...) -> None:
        ...

class DeidentifyConfig(_message.Message):
    __slots__ = ('info_type_transformations', 'record_transformations', 'image_transformations', 'transformation_error_handling')
    INFO_TYPE_TRANSFORMATIONS_FIELD_NUMBER: _ClassVar[int]
    RECORD_TRANSFORMATIONS_FIELD_NUMBER: _ClassVar[int]
    IMAGE_TRANSFORMATIONS_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMATION_ERROR_HANDLING_FIELD_NUMBER: _ClassVar[int]
    info_type_transformations: InfoTypeTransformations
    record_transformations: RecordTransformations
    image_transformations: ImageTransformations
    transformation_error_handling: TransformationErrorHandling

    def __init__(self, info_type_transformations: _Optional[_Union[InfoTypeTransformations, _Mapping]]=..., record_transformations: _Optional[_Union[RecordTransformations, _Mapping]]=..., image_transformations: _Optional[_Union[ImageTransformations, _Mapping]]=..., transformation_error_handling: _Optional[_Union[TransformationErrorHandling, _Mapping]]=...) -> None:
        ...

class ImageTransformations(_message.Message):
    __slots__ = ('transforms',)

    class ImageTransformation(_message.Message):
        __slots__ = ('selected_info_types', 'all_info_types', 'all_text', 'redaction_color')

        class SelectedInfoTypes(_message.Message):
            __slots__ = ('info_types',)
            INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
            info_types: _containers.RepeatedCompositeFieldContainer[_storage_pb2.InfoType]

            def __init__(self, info_types: _Optional[_Iterable[_Union[_storage_pb2.InfoType, _Mapping]]]=...) -> None:
                ...

        class AllInfoTypes(_message.Message):
            __slots__ = ()

            def __init__(self) -> None:
                ...

        class AllText(_message.Message):
            __slots__ = ()

            def __init__(self) -> None:
                ...
        SELECTED_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
        ALL_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
        ALL_TEXT_FIELD_NUMBER: _ClassVar[int]
        REDACTION_COLOR_FIELD_NUMBER: _ClassVar[int]
        selected_info_types: ImageTransformations.ImageTransformation.SelectedInfoTypes
        all_info_types: ImageTransformations.ImageTransformation.AllInfoTypes
        all_text: ImageTransformations.ImageTransformation.AllText
        redaction_color: Color

        def __init__(self, selected_info_types: _Optional[_Union[ImageTransformations.ImageTransformation.SelectedInfoTypes, _Mapping]]=..., all_info_types: _Optional[_Union[ImageTransformations.ImageTransformation.AllInfoTypes, _Mapping]]=..., all_text: _Optional[_Union[ImageTransformations.ImageTransformation.AllText, _Mapping]]=..., redaction_color: _Optional[_Union[Color, _Mapping]]=...) -> None:
            ...
    TRANSFORMS_FIELD_NUMBER: _ClassVar[int]
    transforms: _containers.RepeatedCompositeFieldContainer[ImageTransformations.ImageTransformation]

    def __init__(self, transforms: _Optional[_Iterable[_Union[ImageTransformations.ImageTransformation, _Mapping]]]=...) -> None:
        ...

class TransformationErrorHandling(_message.Message):
    __slots__ = ('throw_error', 'leave_untransformed')

    class ThrowError(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...

    class LeaveUntransformed(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...
    THROW_ERROR_FIELD_NUMBER: _ClassVar[int]
    LEAVE_UNTRANSFORMED_FIELD_NUMBER: _ClassVar[int]
    throw_error: TransformationErrorHandling.ThrowError
    leave_untransformed: TransformationErrorHandling.LeaveUntransformed

    def __init__(self, throw_error: _Optional[_Union[TransformationErrorHandling.ThrowError, _Mapping]]=..., leave_untransformed: _Optional[_Union[TransformationErrorHandling.LeaveUntransformed, _Mapping]]=...) -> None:
        ...

class PrimitiveTransformation(_message.Message):
    __slots__ = ('replace_config', 'redact_config', 'character_mask_config', 'crypto_replace_ffx_fpe_config', 'fixed_size_bucketing_config', 'bucketing_config', 'replace_with_info_type_config', 'time_part_config', 'crypto_hash_config', 'date_shift_config', 'crypto_deterministic_config', 'replace_dictionary_config')
    REPLACE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    REDACT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CHARACTER_MASK_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CRYPTO_REPLACE_FFX_FPE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    FIXED_SIZE_BUCKETING_CONFIG_FIELD_NUMBER: _ClassVar[int]
    BUCKETING_CONFIG_FIELD_NUMBER: _ClassVar[int]
    REPLACE_WITH_INFO_TYPE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    TIME_PART_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CRYPTO_HASH_CONFIG_FIELD_NUMBER: _ClassVar[int]
    DATE_SHIFT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CRYPTO_DETERMINISTIC_CONFIG_FIELD_NUMBER: _ClassVar[int]
    REPLACE_DICTIONARY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    replace_config: ReplaceValueConfig
    redact_config: RedactConfig
    character_mask_config: CharacterMaskConfig
    crypto_replace_ffx_fpe_config: CryptoReplaceFfxFpeConfig
    fixed_size_bucketing_config: FixedSizeBucketingConfig
    bucketing_config: BucketingConfig
    replace_with_info_type_config: ReplaceWithInfoTypeConfig
    time_part_config: TimePartConfig
    crypto_hash_config: CryptoHashConfig
    date_shift_config: DateShiftConfig
    crypto_deterministic_config: CryptoDeterministicConfig
    replace_dictionary_config: ReplaceDictionaryConfig

    def __init__(self, replace_config: _Optional[_Union[ReplaceValueConfig, _Mapping]]=..., redact_config: _Optional[_Union[RedactConfig, _Mapping]]=..., character_mask_config: _Optional[_Union[CharacterMaskConfig, _Mapping]]=..., crypto_replace_ffx_fpe_config: _Optional[_Union[CryptoReplaceFfxFpeConfig, _Mapping]]=..., fixed_size_bucketing_config: _Optional[_Union[FixedSizeBucketingConfig, _Mapping]]=..., bucketing_config: _Optional[_Union[BucketingConfig, _Mapping]]=..., replace_with_info_type_config: _Optional[_Union[ReplaceWithInfoTypeConfig, _Mapping]]=..., time_part_config: _Optional[_Union[TimePartConfig, _Mapping]]=..., crypto_hash_config: _Optional[_Union[CryptoHashConfig, _Mapping]]=..., date_shift_config: _Optional[_Union[DateShiftConfig, _Mapping]]=..., crypto_deterministic_config: _Optional[_Union[CryptoDeterministicConfig, _Mapping]]=..., replace_dictionary_config: _Optional[_Union[ReplaceDictionaryConfig, _Mapping]]=...) -> None:
        ...

class TimePartConfig(_message.Message):
    __slots__ = ('part_to_extract',)

    class TimePart(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        TIME_PART_UNSPECIFIED: _ClassVar[TimePartConfig.TimePart]
        YEAR: _ClassVar[TimePartConfig.TimePart]
        MONTH: _ClassVar[TimePartConfig.TimePart]
        DAY_OF_MONTH: _ClassVar[TimePartConfig.TimePart]
        DAY_OF_WEEK: _ClassVar[TimePartConfig.TimePart]
        WEEK_OF_YEAR: _ClassVar[TimePartConfig.TimePart]
        HOUR_OF_DAY: _ClassVar[TimePartConfig.TimePart]
    TIME_PART_UNSPECIFIED: TimePartConfig.TimePart
    YEAR: TimePartConfig.TimePart
    MONTH: TimePartConfig.TimePart
    DAY_OF_MONTH: TimePartConfig.TimePart
    DAY_OF_WEEK: TimePartConfig.TimePart
    WEEK_OF_YEAR: TimePartConfig.TimePart
    HOUR_OF_DAY: TimePartConfig.TimePart
    PART_TO_EXTRACT_FIELD_NUMBER: _ClassVar[int]
    part_to_extract: TimePartConfig.TimePart

    def __init__(self, part_to_extract: _Optional[_Union[TimePartConfig.TimePart, str]]=...) -> None:
        ...

class CryptoHashConfig(_message.Message):
    __slots__ = ('crypto_key',)
    CRYPTO_KEY_FIELD_NUMBER: _ClassVar[int]
    crypto_key: CryptoKey

    def __init__(self, crypto_key: _Optional[_Union[CryptoKey, _Mapping]]=...) -> None:
        ...

class CryptoDeterministicConfig(_message.Message):
    __slots__ = ('crypto_key', 'surrogate_info_type', 'context')
    CRYPTO_KEY_FIELD_NUMBER: _ClassVar[int]
    SURROGATE_INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    crypto_key: CryptoKey
    surrogate_info_type: _storage_pb2.InfoType
    context: _storage_pb2.FieldId

    def __init__(self, crypto_key: _Optional[_Union[CryptoKey, _Mapping]]=..., surrogate_info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., context: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=...) -> None:
        ...

class ReplaceValueConfig(_message.Message):
    __slots__ = ('new_value',)
    NEW_VALUE_FIELD_NUMBER: _ClassVar[int]
    new_value: Value

    def __init__(self, new_value: _Optional[_Union[Value, _Mapping]]=...) -> None:
        ...

class ReplaceDictionaryConfig(_message.Message):
    __slots__ = ('word_list',)
    WORD_LIST_FIELD_NUMBER: _ClassVar[int]
    word_list: _storage_pb2.CustomInfoType.Dictionary.WordList

    def __init__(self, word_list: _Optional[_Union[_storage_pb2.CustomInfoType.Dictionary.WordList, _Mapping]]=...) -> None:
        ...

class ReplaceWithInfoTypeConfig(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class RedactConfig(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class CharsToIgnore(_message.Message):
    __slots__ = ('characters_to_skip', 'common_characters_to_ignore')

    class CommonCharsToIgnore(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        COMMON_CHARS_TO_IGNORE_UNSPECIFIED: _ClassVar[CharsToIgnore.CommonCharsToIgnore]
        NUMERIC: _ClassVar[CharsToIgnore.CommonCharsToIgnore]
        ALPHA_UPPER_CASE: _ClassVar[CharsToIgnore.CommonCharsToIgnore]
        ALPHA_LOWER_CASE: _ClassVar[CharsToIgnore.CommonCharsToIgnore]
        PUNCTUATION: _ClassVar[CharsToIgnore.CommonCharsToIgnore]
        WHITESPACE: _ClassVar[CharsToIgnore.CommonCharsToIgnore]
    COMMON_CHARS_TO_IGNORE_UNSPECIFIED: CharsToIgnore.CommonCharsToIgnore
    NUMERIC: CharsToIgnore.CommonCharsToIgnore
    ALPHA_UPPER_CASE: CharsToIgnore.CommonCharsToIgnore
    ALPHA_LOWER_CASE: CharsToIgnore.CommonCharsToIgnore
    PUNCTUATION: CharsToIgnore.CommonCharsToIgnore
    WHITESPACE: CharsToIgnore.CommonCharsToIgnore
    CHARACTERS_TO_SKIP_FIELD_NUMBER: _ClassVar[int]
    COMMON_CHARACTERS_TO_IGNORE_FIELD_NUMBER: _ClassVar[int]
    characters_to_skip: str
    common_characters_to_ignore: CharsToIgnore.CommonCharsToIgnore

    def __init__(self, characters_to_skip: _Optional[str]=..., common_characters_to_ignore: _Optional[_Union[CharsToIgnore.CommonCharsToIgnore, str]]=...) -> None:
        ...

class CharacterMaskConfig(_message.Message):
    __slots__ = ('masking_character', 'number_to_mask', 'reverse_order', 'characters_to_ignore')
    MASKING_CHARACTER_FIELD_NUMBER: _ClassVar[int]
    NUMBER_TO_MASK_FIELD_NUMBER: _ClassVar[int]
    REVERSE_ORDER_FIELD_NUMBER: _ClassVar[int]
    CHARACTERS_TO_IGNORE_FIELD_NUMBER: _ClassVar[int]
    masking_character: str
    number_to_mask: int
    reverse_order: bool
    characters_to_ignore: _containers.RepeatedCompositeFieldContainer[CharsToIgnore]

    def __init__(self, masking_character: _Optional[str]=..., number_to_mask: _Optional[int]=..., reverse_order: bool=..., characters_to_ignore: _Optional[_Iterable[_Union[CharsToIgnore, _Mapping]]]=...) -> None:
        ...

class FixedSizeBucketingConfig(_message.Message):
    __slots__ = ('lower_bound', 'upper_bound', 'bucket_size')
    LOWER_BOUND_FIELD_NUMBER: _ClassVar[int]
    UPPER_BOUND_FIELD_NUMBER: _ClassVar[int]
    BUCKET_SIZE_FIELD_NUMBER: _ClassVar[int]
    lower_bound: Value
    upper_bound: Value
    bucket_size: float

    def __init__(self, lower_bound: _Optional[_Union[Value, _Mapping]]=..., upper_bound: _Optional[_Union[Value, _Mapping]]=..., bucket_size: _Optional[float]=...) -> None:
        ...

class BucketingConfig(_message.Message):
    __slots__ = ('buckets',)

    class Bucket(_message.Message):
        __slots__ = ('min', 'max', 'replacement_value')
        MIN_FIELD_NUMBER: _ClassVar[int]
        MAX_FIELD_NUMBER: _ClassVar[int]
        REPLACEMENT_VALUE_FIELD_NUMBER: _ClassVar[int]
        min: Value
        max: Value
        replacement_value: Value

        def __init__(self, min: _Optional[_Union[Value, _Mapping]]=..., max: _Optional[_Union[Value, _Mapping]]=..., replacement_value: _Optional[_Union[Value, _Mapping]]=...) -> None:
            ...
    BUCKETS_FIELD_NUMBER: _ClassVar[int]
    buckets: _containers.RepeatedCompositeFieldContainer[BucketingConfig.Bucket]

    def __init__(self, buckets: _Optional[_Iterable[_Union[BucketingConfig.Bucket, _Mapping]]]=...) -> None:
        ...

class CryptoReplaceFfxFpeConfig(_message.Message):
    __slots__ = ('crypto_key', 'context', 'common_alphabet', 'custom_alphabet', 'radix', 'surrogate_info_type')

    class FfxCommonNativeAlphabet(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        FFX_COMMON_NATIVE_ALPHABET_UNSPECIFIED: _ClassVar[CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet]
        NUMERIC: _ClassVar[CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet]
        HEXADECIMAL: _ClassVar[CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet]
        UPPER_CASE_ALPHA_NUMERIC: _ClassVar[CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet]
        ALPHA_NUMERIC: _ClassVar[CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet]
    FFX_COMMON_NATIVE_ALPHABET_UNSPECIFIED: CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet
    NUMERIC: CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet
    HEXADECIMAL: CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet
    UPPER_CASE_ALPHA_NUMERIC: CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet
    ALPHA_NUMERIC: CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet
    CRYPTO_KEY_FIELD_NUMBER: _ClassVar[int]
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    COMMON_ALPHABET_FIELD_NUMBER: _ClassVar[int]
    CUSTOM_ALPHABET_FIELD_NUMBER: _ClassVar[int]
    RADIX_FIELD_NUMBER: _ClassVar[int]
    SURROGATE_INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    crypto_key: CryptoKey
    context: _storage_pb2.FieldId
    common_alphabet: CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet
    custom_alphabet: str
    radix: int
    surrogate_info_type: _storage_pb2.InfoType

    def __init__(self, crypto_key: _Optional[_Union[CryptoKey, _Mapping]]=..., context: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., common_alphabet: _Optional[_Union[CryptoReplaceFfxFpeConfig.FfxCommonNativeAlphabet, str]]=..., custom_alphabet: _Optional[str]=..., radix: _Optional[int]=..., surrogate_info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=...) -> None:
        ...

class CryptoKey(_message.Message):
    __slots__ = ('transient', 'unwrapped', 'kms_wrapped')
    TRANSIENT_FIELD_NUMBER: _ClassVar[int]
    UNWRAPPED_FIELD_NUMBER: _ClassVar[int]
    KMS_WRAPPED_FIELD_NUMBER: _ClassVar[int]
    transient: TransientCryptoKey
    unwrapped: UnwrappedCryptoKey
    kms_wrapped: KmsWrappedCryptoKey

    def __init__(self, transient: _Optional[_Union[TransientCryptoKey, _Mapping]]=..., unwrapped: _Optional[_Union[UnwrappedCryptoKey, _Mapping]]=..., kms_wrapped: _Optional[_Union[KmsWrappedCryptoKey, _Mapping]]=...) -> None:
        ...

class TransientCryptoKey(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class UnwrappedCryptoKey(_message.Message):
    __slots__ = ('key',)
    KEY_FIELD_NUMBER: _ClassVar[int]
    key: bytes

    def __init__(self, key: _Optional[bytes]=...) -> None:
        ...

class KmsWrappedCryptoKey(_message.Message):
    __slots__ = ('wrapped_key', 'crypto_key_name')
    WRAPPED_KEY_FIELD_NUMBER: _ClassVar[int]
    CRYPTO_KEY_NAME_FIELD_NUMBER: _ClassVar[int]
    wrapped_key: bytes
    crypto_key_name: str

    def __init__(self, wrapped_key: _Optional[bytes]=..., crypto_key_name: _Optional[str]=...) -> None:
        ...

class DateShiftConfig(_message.Message):
    __slots__ = ('upper_bound_days', 'lower_bound_days', 'context', 'crypto_key')
    UPPER_BOUND_DAYS_FIELD_NUMBER: _ClassVar[int]
    LOWER_BOUND_DAYS_FIELD_NUMBER: _ClassVar[int]
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    CRYPTO_KEY_FIELD_NUMBER: _ClassVar[int]
    upper_bound_days: int
    lower_bound_days: int
    context: _storage_pb2.FieldId
    crypto_key: CryptoKey

    def __init__(self, upper_bound_days: _Optional[int]=..., lower_bound_days: _Optional[int]=..., context: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., crypto_key: _Optional[_Union[CryptoKey, _Mapping]]=...) -> None:
        ...

class InfoTypeTransformations(_message.Message):
    __slots__ = ('transformations',)

    class InfoTypeTransformation(_message.Message):
        __slots__ = ('info_types', 'primitive_transformation')
        INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
        PRIMITIVE_TRANSFORMATION_FIELD_NUMBER: _ClassVar[int]
        info_types: _containers.RepeatedCompositeFieldContainer[_storage_pb2.InfoType]
        primitive_transformation: PrimitiveTransformation

        def __init__(self, info_types: _Optional[_Iterable[_Union[_storage_pb2.InfoType, _Mapping]]]=..., primitive_transformation: _Optional[_Union[PrimitiveTransformation, _Mapping]]=...) -> None:
            ...
    TRANSFORMATIONS_FIELD_NUMBER: _ClassVar[int]
    transformations: _containers.RepeatedCompositeFieldContainer[InfoTypeTransformations.InfoTypeTransformation]

    def __init__(self, transformations: _Optional[_Iterable[_Union[InfoTypeTransformations.InfoTypeTransformation, _Mapping]]]=...) -> None:
        ...

class FieldTransformation(_message.Message):
    __slots__ = ('fields', 'condition', 'primitive_transformation', 'info_type_transformations')
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    CONDITION_FIELD_NUMBER: _ClassVar[int]
    PRIMITIVE_TRANSFORMATION_FIELD_NUMBER: _ClassVar[int]
    INFO_TYPE_TRANSFORMATIONS_FIELD_NUMBER: _ClassVar[int]
    fields: _containers.RepeatedCompositeFieldContainer[_storage_pb2.FieldId]
    condition: RecordCondition
    primitive_transformation: PrimitiveTransformation
    info_type_transformations: InfoTypeTransformations

    def __init__(self, fields: _Optional[_Iterable[_Union[_storage_pb2.FieldId, _Mapping]]]=..., condition: _Optional[_Union[RecordCondition, _Mapping]]=..., primitive_transformation: _Optional[_Union[PrimitiveTransformation, _Mapping]]=..., info_type_transformations: _Optional[_Union[InfoTypeTransformations, _Mapping]]=...) -> None:
        ...

class RecordTransformations(_message.Message):
    __slots__ = ('field_transformations', 'record_suppressions')
    FIELD_TRANSFORMATIONS_FIELD_NUMBER: _ClassVar[int]
    RECORD_SUPPRESSIONS_FIELD_NUMBER: _ClassVar[int]
    field_transformations: _containers.RepeatedCompositeFieldContainer[FieldTransformation]
    record_suppressions: _containers.RepeatedCompositeFieldContainer[RecordSuppression]

    def __init__(self, field_transformations: _Optional[_Iterable[_Union[FieldTransformation, _Mapping]]]=..., record_suppressions: _Optional[_Iterable[_Union[RecordSuppression, _Mapping]]]=...) -> None:
        ...

class RecordSuppression(_message.Message):
    __slots__ = ('condition',)
    CONDITION_FIELD_NUMBER: _ClassVar[int]
    condition: RecordCondition

    def __init__(self, condition: _Optional[_Union[RecordCondition, _Mapping]]=...) -> None:
        ...

class RecordCondition(_message.Message):
    __slots__ = ('expressions',)

    class Condition(_message.Message):
        __slots__ = ('field', 'operator', 'value')
        FIELD_FIELD_NUMBER: _ClassVar[int]
        OPERATOR_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        field: _storage_pb2.FieldId
        operator: RelationalOperator
        value: Value

        def __init__(self, field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., operator: _Optional[_Union[RelationalOperator, str]]=..., value: _Optional[_Union[Value, _Mapping]]=...) -> None:
            ...

    class Conditions(_message.Message):
        __slots__ = ('conditions',)
        CONDITIONS_FIELD_NUMBER: _ClassVar[int]
        conditions: _containers.RepeatedCompositeFieldContainer[RecordCondition.Condition]

        def __init__(self, conditions: _Optional[_Iterable[_Union[RecordCondition.Condition, _Mapping]]]=...) -> None:
            ...

    class Expressions(_message.Message):
        __slots__ = ('logical_operator', 'conditions')

        class LogicalOperator(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            LOGICAL_OPERATOR_UNSPECIFIED: _ClassVar[RecordCondition.Expressions.LogicalOperator]
            AND: _ClassVar[RecordCondition.Expressions.LogicalOperator]
        LOGICAL_OPERATOR_UNSPECIFIED: RecordCondition.Expressions.LogicalOperator
        AND: RecordCondition.Expressions.LogicalOperator
        LOGICAL_OPERATOR_FIELD_NUMBER: _ClassVar[int]
        CONDITIONS_FIELD_NUMBER: _ClassVar[int]
        logical_operator: RecordCondition.Expressions.LogicalOperator
        conditions: RecordCondition.Conditions

        def __init__(self, logical_operator: _Optional[_Union[RecordCondition.Expressions.LogicalOperator, str]]=..., conditions: _Optional[_Union[RecordCondition.Conditions, _Mapping]]=...) -> None:
            ...
    EXPRESSIONS_FIELD_NUMBER: _ClassVar[int]
    expressions: RecordCondition.Expressions

    def __init__(self, expressions: _Optional[_Union[RecordCondition.Expressions, _Mapping]]=...) -> None:
        ...

class TransformationOverview(_message.Message):
    __slots__ = ('transformed_bytes', 'transformation_summaries')
    TRANSFORMED_BYTES_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMATION_SUMMARIES_FIELD_NUMBER: _ClassVar[int]
    transformed_bytes: int
    transformation_summaries: _containers.RepeatedCompositeFieldContainer[TransformationSummary]

    def __init__(self, transformed_bytes: _Optional[int]=..., transformation_summaries: _Optional[_Iterable[_Union[TransformationSummary, _Mapping]]]=...) -> None:
        ...

class TransformationSummary(_message.Message):
    __slots__ = ('info_type', 'field', 'transformation', 'field_transformations', 'record_suppress', 'results', 'transformed_bytes')

    class TransformationResultCode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        TRANSFORMATION_RESULT_CODE_UNSPECIFIED: _ClassVar[TransformationSummary.TransformationResultCode]
        SUCCESS: _ClassVar[TransformationSummary.TransformationResultCode]
        ERROR: _ClassVar[TransformationSummary.TransformationResultCode]
    TRANSFORMATION_RESULT_CODE_UNSPECIFIED: TransformationSummary.TransformationResultCode
    SUCCESS: TransformationSummary.TransformationResultCode
    ERROR: TransformationSummary.TransformationResultCode

    class SummaryResult(_message.Message):
        __slots__ = ('count', 'code', 'details')
        COUNT_FIELD_NUMBER: _ClassVar[int]
        CODE_FIELD_NUMBER: _ClassVar[int]
        DETAILS_FIELD_NUMBER: _ClassVar[int]
        count: int
        code: TransformationSummary.TransformationResultCode
        details: str

        def __init__(self, count: _Optional[int]=..., code: _Optional[_Union[TransformationSummary.TransformationResultCode, str]]=..., details: _Optional[str]=...) -> None:
            ...
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    FIELD_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMATION_FIELD_NUMBER: _ClassVar[int]
    FIELD_TRANSFORMATIONS_FIELD_NUMBER: _ClassVar[int]
    RECORD_SUPPRESS_FIELD_NUMBER: _ClassVar[int]
    RESULTS_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMED_BYTES_FIELD_NUMBER: _ClassVar[int]
    info_type: _storage_pb2.InfoType
    field: _storage_pb2.FieldId
    transformation: PrimitiveTransformation
    field_transformations: _containers.RepeatedCompositeFieldContainer[FieldTransformation]
    record_suppress: RecordSuppression
    results: _containers.RepeatedCompositeFieldContainer[TransformationSummary.SummaryResult]
    transformed_bytes: int

    def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., field: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., transformation: _Optional[_Union[PrimitiveTransformation, _Mapping]]=..., field_transformations: _Optional[_Iterable[_Union[FieldTransformation, _Mapping]]]=..., record_suppress: _Optional[_Union[RecordSuppression, _Mapping]]=..., results: _Optional[_Iterable[_Union[TransformationSummary.SummaryResult, _Mapping]]]=..., transformed_bytes: _Optional[int]=...) -> None:
        ...

class TransformationDescription(_message.Message):
    __slots__ = ('type', 'description', 'condition', 'info_type')
    TYPE_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    CONDITION_FIELD_NUMBER: _ClassVar[int]
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    type: TransformationType
    description: str
    condition: str
    info_type: _storage_pb2.InfoType

    def __init__(self, type: _Optional[_Union[TransformationType, str]]=..., description: _Optional[str]=..., condition: _Optional[str]=..., info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=...) -> None:
        ...

class TransformationDetails(_message.Message):
    __slots__ = ('resource_name', 'container_name', 'transformation', 'status_details', 'transformed_bytes', 'transformation_location')
    RESOURCE_NAME_FIELD_NUMBER: _ClassVar[int]
    CONTAINER_NAME_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMATION_FIELD_NUMBER: _ClassVar[int]
    STATUS_DETAILS_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMED_BYTES_FIELD_NUMBER: _ClassVar[int]
    TRANSFORMATION_LOCATION_FIELD_NUMBER: _ClassVar[int]
    resource_name: str
    container_name: str
    transformation: _containers.RepeatedCompositeFieldContainer[TransformationDescription]
    status_details: TransformationResultStatus
    transformed_bytes: int
    transformation_location: TransformationLocation

    def __init__(self, resource_name: _Optional[str]=..., container_name: _Optional[str]=..., transformation: _Optional[_Iterable[_Union[TransformationDescription, _Mapping]]]=..., status_details: _Optional[_Union[TransformationResultStatus, _Mapping]]=..., transformed_bytes: _Optional[int]=..., transformation_location: _Optional[_Union[TransformationLocation, _Mapping]]=...) -> None:
        ...

class TransformationLocation(_message.Message):
    __slots__ = ('finding_id', 'record_transformation', 'container_type')
    FINDING_ID_FIELD_NUMBER: _ClassVar[int]
    RECORD_TRANSFORMATION_FIELD_NUMBER: _ClassVar[int]
    CONTAINER_TYPE_FIELD_NUMBER: _ClassVar[int]
    finding_id: str
    record_transformation: RecordTransformation
    container_type: TransformationContainerType

    def __init__(self, finding_id: _Optional[str]=..., record_transformation: _Optional[_Union[RecordTransformation, _Mapping]]=..., container_type: _Optional[_Union[TransformationContainerType, str]]=...) -> None:
        ...

class RecordTransformation(_message.Message):
    __slots__ = ('field_id', 'container_timestamp', 'container_version')
    FIELD_ID_FIELD_NUMBER: _ClassVar[int]
    CONTAINER_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    CONTAINER_VERSION_FIELD_NUMBER: _ClassVar[int]
    field_id: _storage_pb2.FieldId
    container_timestamp: _timestamp_pb2.Timestamp
    container_version: str

    def __init__(self, field_id: _Optional[_Union[_storage_pb2.FieldId, _Mapping]]=..., container_timestamp: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., container_version: _Optional[str]=...) -> None:
        ...

class TransformationResultStatus(_message.Message):
    __slots__ = ('result_status_type', 'details')
    RESULT_STATUS_TYPE_FIELD_NUMBER: _ClassVar[int]
    DETAILS_FIELD_NUMBER: _ClassVar[int]
    result_status_type: TransformationResultStatusType
    details: _status_pb2.Status

    def __init__(self, result_status_type: _Optional[_Union[TransformationResultStatusType, str]]=..., details: _Optional[_Union[_status_pb2.Status, _Mapping]]=...) -> None:
        ...

class TransformationDetailsStorageConfig(_message.Message):
    __slots__ = ('table',)
    TABLE_FIELD_NUMBER: _ClassVar[int]
    table: _storage_pb2.BigQueryTable

    def __init__(self, table: _Optional[_Union[_storage_pb2.BigQueryTable, _Mapping]]=...) -> None:
        ...

class Schedule(_message.Message):
    __slots__ = ('recurrence_period_duration',)
    RECURRENCE_PERIOD_DURATION_FIELD_NUMBER: _ClassVar[int]
    recurrence_period_duration: _duration_pb2.Duration

    def __init__(self, recurrence_period_duration: _Optional[_Union[_duration_pb2.Duration, _Mapping]]=...) -> None:
        ...

class Manual(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class InspectTemplate(_message.Message):
    __slots__ = ('name', 'display_name', 'description', 'create_time', 'update_time', 'inspect_config')
    NAME_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    INSPECT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    name: str
    display_name: str
    description: str
    create_time: _timestamp_pb2.Timestamp
    update_time: _timestamp_pb2.Timestamp
    inspect_config: InspectConfig

    def __init__(self, name: _Optional[str]=..., display_name: _Optional[str]=..., description: _Optional[str]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., inspect_config: _Optional[_Union[InspectConfig, _Mapping]]=...) -> None:
        ...

class DeidentifyTemplate(_message.Message):
    __slots__ = ('name', 'display_name', 'description', 'create_time', 'update_time', 'deidentify_config')
    NAME_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    DEIDENTIFY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    name: str
    display_name: str
    description: str
    create_time: _timestamp_pb2.Timestamp
    update_time: _timestamp_pb2.Timestamp
    deidentify_config: DeidentifyConfig

    def __init__(self, name: _Optional[str]=..., display_name: _Optional[str]=..., description: _Optional[str]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., deidentify_config: _Optional[_Union[DeidentifyConfig, _Mapping]]=...) -> None:
        ...

class Error(_message.Message):
    __slots__ = ('details', 'timestamps', 'extra_info')

    class ErrorExtraInfo(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        ERROR_INFO_UNSPECIFIED: _ClassVar[Error.ErrorExtraInfo]
        IMAGE_SCAN_UNAVAILABLE_IN_REGION: _ClassVar[Error.ErrorExtraInfo]
        FILE_STORE_CLUSTER_UNSUPPORTED: _ClassVar[Error.ErrorExtraInfo]
    ERROR_INFO_UNSPECIFIED: Error.ErrorExtraInfo
    IMAGE_SCAN_UNAVAILABLE_IN_REGION: Error.ErrorExtraInfo
    FILE_STORE_CLUSTER_UNSUPPORTED: Error.ErrorExtraInfo
    DETAILS_FIELD_NUMBER: _ClassVar[int]
    TIMESTAMPS_FIELD_NUMBER: _ClassVar[int]
    EXTRA_INFO_FIELD_NUMBER: _ClassVar[int]
    details: _status_pb2.Status
    timestamps: _containers.RepeatedCompositeFieldContainer[_timestamp_pb2.Timestamp]
    extra_info: Error.ErrorExtraInfo

    def __init__(self, details: _Optional[_Union[_status_pb2.Status, _Mapping]]=..., timestamps: _Optional[_Iterable[_Union[_timestamp_pb2.Timestamp, _Mapping]]]=..., extra_info: _Optional[_Union[Error.ErrorExtraInfo, str]]=...) -> None:
        ...

class JobTrigger(_message.Message):
    __slots__ = ('name', 'display_name', 'description', 'inspect_job', 'triggers', 'errors', 'create_time', 'update_time', 'last_run_time', 'status')

    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        STATUS_UNSPECIFIED: _ClassVar[JobTrigger.Status]
        HEALTHY: _ClassVar[JobTrigger.Status]
        PAUSED: _ClassVar[JobTrigger.Status]
        CANCELLED: _ClassVar[JobTrigger.Status]
    STATUS_UNSPECIFIED: JobTrigger.Status
    HEALTHY: JobTrigger.Status
    PAUSED: JobTrigger.Status
    CANCELLED: JobTrigger.Status

    class Trigger(_message.Message):
        __slots__ = ('schedule', 'manual')
        SCHEDULE_FIELD_NUMBER: _ClassVar[int]
        MANUAL_FIELD_NUMBER: _ClassVar[int]
        schedule: Schedule
        manual: Manual

        def __init__(self, schedule: _Optional[_Union[Schedule, _Mapping]]=..., manual: _Optional[_Union[Manual, _Mapping]]=...) -> None:
            ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    INSPECT_JOB_FIELD_NUMBER: _ClassVar[int]
    TRIGGERS_FIELD_NUMBER: _ClassVar[int]
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    LAST_RUN_TIME_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    name: str
    display_name: str
    description: str
    inspect_job: InspectJobConfig
    triggers: _containers.RepeatedCompositeFieldContainer[JobTrigger.Trigger]
    errors: _containers.RepeatedCompositeFieldContainer[Error]
    create_time: _timestamp_pb2.Timestamp
    update_time: _timestamp_pb2.Timestamp
    last_run_time: _timestamp_pb2.Timestamp
    status: JobTrigger.Status

    def __init__(self, name: _Optional[str]=..., display_name: _Optional[str]=..., description: _Optional[str]=..., inspect_job: _Optional[_Union[InspectJobConfig, _Mapping]]=..., triggers: _Optional[_Iterable[_Union[JobTrigger.Trigger, _Mapping]]]=..., errors: _Optional[_Iterable[_Union[Error, _Mapping]]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., last_run_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., status: _Optional[_Union[JobTrigger.Status, str]]=...) -> None:
        ...

class Action(_message.Message):
    __slots__ = ('save_findings', 'pub_sub', 'publish_summary_to_cscc', 'publish_findings_to_cloud_data_catalog', 'deidentify', 'job_notification_emails', 'publish_to_stackdriver')

    class SaveFindings(_message.Message):
        __slots__ = ('output_config',)
        OUTPUT_CONFIG_FIELD_NUMBER: _ClassVar[int]
        output_config: OutputStorageConfig

        def __init__(self, output_config: _Optional[_Union[OutputStorageConfig, _Mapping]]=...) -> None:
            ...

    class PublishToPubSub(_message.Message):
        __slots__ = ('topic',)
        TOPIC_FIELD_NUMBER: _ClassVar[int]
        topic: str

        def __init__(self, topic: _Optional[str]=...) -> None:
            ...

    class PublishSummaryToCscc(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...

    class PublishFindingsToCloudDataCatalog(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...

    class Deidentify(_message.Message):
        __slots__ = ('transformation_config', 'transformation_details_storage_config', 'cloud_storage_output', 'file_types_to_transform')
        TRANSFORMATION_CONFIG_FIELD_NUMBER: _ClassVar[int]
        TRANSFORMATION_DETAILS_STORAGE_CONFIG_FIELD_NUMBER: _ClassVar[int]
        CLOUD_STORAGE_OUTPUT_FIELD_NUMBER: _ClassVar[int]
        FILE_TYPES_TO_TRANSFORM_FIELD_NUMBER: _ClassVar[int]
        transformation_config: TransformationConfig
        transformation_details_storage_config: TransformationDetailsStorageConfig
        cloud_storage_output: str
        file_types_to_transform: _containers.RepeatedScalarFieldContainer[_storage_pb2.FileType]

        def __init__(self, transformation_config: _Optional[_Union[TransformationConfig, _Mapping]]=..., transformation_details_storage_config: _Optional[_Union[TransformationDetailsStorageConfig, _Mapping]]=..., cloud_storage_output: _Optional[str]=..., file_types_to_transform: _Optional[_Iterable[_Union[_storage_pb2.FileType, str]]]=...) -> None:
            ...

    class JobNotificationEmails(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...

    class PublishToStackdriver(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...
    SAVE_FINDINGS_FIELD_NUMBER: _ClassVar[int]
    PUB_SUB_FIELD_NUMBER: _ClassVar[int]
    PUBLISH_SUMMARY_TO_CSCC_FIELD_NUMBER: _ClassVar[int]
    PUBLISH_FINDINGS_TO_CLOUD_DATA_CATALOG_FIELD_NUMBER: _ClassVar[int]
    DEIDENTIFY_FIELD_NUMBER: _ClassVar[int]
    JOB_NOTIFICATION_EMAILS_FIELD_NUMBER: _ClassVar[int]
    PUBLISH_TO_STACKDRIVER_FIELD_NUMBER: _ClassVar[int]
    save_findings: Action.SaveFindings
    pub_sub: Action.PublishToPubSub
    publish_summary_to_cscc: Action.PublishSummaryToCscc
    publish_findings_to_cloud_data_catalog: Action.PublishFindingsToCloudDataCatalog
    deidentify: Action.Deidentify
    job_notification_emails: Action.JobNotificationEmails
    publish_to_stackdriver: Action.PublishToStackdriver

    def __init__(self, save_findings: _Optional[_Union[Action.SaveFindings, _Mapping]]=..., pub_sub: _Optional[_Union[Action.PublishToPubSub, _Mapping]]=..., publish_summary_to_cscc: _Optional[_Union[Action.PublishSummaryToCscc, _Mapping]]=..., publish_findings_to_cloud_data_catalog: _Optional[_Union[Action.PublishFindingsToCloudDataCatalog, _Mapping]]=..., deidentify: _Optional[_Union[Action.Deidentify, _Mapping]]=..., job_notification_emails: _Optional[_Union[Action.JobNotificationEmails, _Mapping]]=..., publish_to_stackdriver: _Optional[_Union[Action.PublishToStackdriver, _Mapping]]=...) -> None:
        ...

class TransformationConfig(_message.Message):
    __slots__ = ('deidentify_template', 'structured_deidentify_template', 'image_redact_template')
    DEIDENTIFY_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    STRUCTURED_DEIDENTIFY_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    IMAGE_REDACT_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    deidentify_template: str
    structured_deidentify_template: str
    image_redact_template: str

    def __init__(self, deidentify_template: _Optional[str]=..., structured_deidentify_template: _Optional[str]=..., image_redact_template: _Optional[str]=...) -> None:
        ...

class CreateInspectTemplateRequest(_message.Message):
    __slots__ = ('parent', 'inspect_template', 'template_id', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    TEMPLATE_ID_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    inspect_template: InspectTemplate
    template_id: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., inspect_template: _Optional[_Union[InspectTemplate, _Mapping]]=..., template_id: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class UpdateInspectTemplateRequest(_message.Message):
    __slots__ = ('name', 'inspect_template', 'update_mask')
    NAME_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    name: str
    inspect_template: InspectTemplate
    update_mask: _field_mask_pb2.FieldMask

    def __init__(self, name: _Optional[str]=..., inspect_template: _Optional[_Union[InspectTemplate, _Mapping]]=..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]]=...) -> None:
        ...

class GetInspectTemplateRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListInspectTemplatesRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ListInspectTemplatesResponse(_message.Message):
    __slots__ = ('inspect_templates', 'next_page_token')
    INSPECT_TEMPLATES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    inspect_templates: _containers.RepeatedCompositeFieldContainer[InspectTemplate]
    next_page_token: str

    def __init__(self, inspect_templates: _Optional[_Iterable[_Union[InspectTemplate, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class DeleteInspectTemplateRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class CreateJobTriggerRequest(_message.Message):
    __slots__ = ('parent', 'job_trigger', 'trigger_id', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    JOB_TRIGGER_FIELD_NUMBER: _ClassVar[int]
    TRIGGER_ID_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    job_trigger: JobTrigger
    trigger_id: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., job_trigger: _Optional[_Union[JobTrigger, _Mapping]]=..., trigger_id: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ActivateJobTriggerRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class UpdateJobTriggerRequest(_message.Message):
    __slots__ = ('name', 'job_trigger', 'update_mask')
    NAME_FIELD_NUMBER: _ClassVar[int]
    JOB_TRIGGER_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    name: str
    job_trigger: JobTrigger
    update_mask: _field_mask_pb2.FieldMask

    def __init__(self, name: _Optional[str]=..., job_trigger: _Optional[_Union[JobTrigger, _Mapping]]=..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]]=...) -> None:
        ...

class GetJobTriggerRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class CreateDiscoveryConfigRequest(_message.Message):
    __slots__ = ('parent', 'discovery_config', 'config_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    DISCOVERY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CONFIG_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    discovery_config: DiscoveryConfig
    config_id: str

    def __init__(self, parent: _Optional[str]=..., discovery_config: _Optional[_Union[DiscoveryConfig, _Mapping]]=..., config_id: _Optional[str]=...) -> None:
        ...

class UpdateDiscoveryConfigRequest(_message.Message):
    __slots__ = ('name', 'discovery_config', 'update_mask')
    NAME_FIELD_NUMBER: _ClassVar[int]
    DISCOVERY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    name: str
    discovery_config: DiscoveryConfig
    update_mask: _field_mask_pb2.FieldMask

    def __init__(self, name: _Optional[str]=..., discovery_config: _Optional[_Union[DiscoveryConfig, _Mapping]]=..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]]=...) -> None:
        ...

class GetDiscoveryConfigRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListDiscoveryConfigsRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=...) -> None:
        ...

class ListDiscoveryConfigsResponse(_message.Message):
    __slots__ = ('discovery_configs', 'next_page_token')
    DISCOVERY_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    discovery_configs: _containers.RepeatedCompositeFieldContainer[DiscoveryConfig]
    next_page_token: str

    def __init__(self, discovery_configs: _Optional[_Iterable[_Union[DiscoveryConfig, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class DeleteDiscoveryConfigRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class CreateDlpJobRequest(_message.Message):
    __slots__ = ('parent', 'inspect_job', 'risk_job', 'job_id', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    INSPECT_JOB_FIELD_NUMBER: _ClassVar[int]
    RISK_JOB_FIELD_NUMBER: _ClassVar[int]
    JOB_ID_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    inspect_job: InspectJobConfig
    risk_job: RiskAnalysisJobConfig
    job_id: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., inspect_job: _Optional[_Union[InspectJobConfig, _Mapping]]=..., risk_job: _Optional[_Union[RiskAnalysisJobConfig, _Mapping]]=..., job_id: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ListJobTriggersRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'filter', 'type', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    filter: str
    type: DlpJobType
    location_id: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., filter: _Optional[str]=..., type: _Optional[_Union[DlpJobType, str]]=..., location_id: _Optional[str]=...) -> None:
        ...

class ListJobTriggersResponse(_message.Message):
    __slots__ = ('job_triggers', 'next_page_token')
    JOB_TRIGGERS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    job_triggers: _containers.RepeatedCompositeFieldContainer[JobTrigger]
    next_page_token: str

    def __init__(self, job_triggers: _Optional[_Iterable[_Union[JobTrigger, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class DeleteJobTriggerRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class InspectJobConfig(_message.Message):
    __slots__ = ('storage_config', 'inspect_config', 'inspect_template_name', 'actions')
    STORAGE_CONFIG_FIELD_NUMBER: _ClassVar[int]
    INSPECT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_NAME_FIELD_NUMBER: _ClassVar[int]
    ACTIONS_FIELD_NUMBER: _ClassVar[int]
    storage_config: _storage_pb2.StorageConfig
    inspect_config: InspectConfig
    inspect_template_name: str
    actions: _containers.RepeatedCompositeFieldContainer[Action]

    def __init__(self, storage_config: _Optional[_Union[_storage_pb2.StorageConfig, _Mapping]]=..., inspect_config: _Optional[_Union[InspectConfig, _Mapping]]=..., inspect_template_name: _Optional[str]=..., actions: _Optional[_Iterable[_Union[Action, _Mapping]]]=...) -> None:
        ...

class DataProfileAction(_message.Message):
    __slots__ = ('export_data', 'pub_sub_notification', 'publish_to_chronicle', 'publish_to_scc', 'tag_resources')

    class EventType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        EVENT_TYPE_UNSPECIFIED: _ClassVar[DataProfileAction.EventType]
        NEW_PROFILE: _ClassVar[DataProfileAction.EventType]
        CHANGED_PROFILE: _ClassVar[DataProfileAction.EventType]
        SCORE_INCREASED: _ClassVar[DataProfileAction.EventType]
        ERROR_CHANGED: _ClassVar[DataProfileAction.EventType]
    EVENT_TYPE_UNSPECIFIED: DataProfileAction.EventType
    NEW_PROFILE: DataProfileAction.EventType
    CHANGED_PROFILE: DataProfileAction.EventType
    SCORE_INCREASED: DataProfileAction.EventType
    ERROR_CHANGED: DataProfileAction.EventType

    class Export(_message.Message):
        __slots__ = ('profile_table',)
        PROFILE_TABLE_FIELD_NUMBER: _ClassVar[int]
        profile_table: _storage_pb2.BigQueryTable

        def __init__(self, profile_table: _Optional[_Union[_storage_pb2.BigQueryTable, _Mapping]]=...) -> None:
            ...

    class PubSubNotification(_message.Message):
        __slots__ = ('topic', 'event', 'pubsub_condition', 'detail_of_message')

        class DetailLevel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            DETAIL_LEVEL_UNSPECIFIED: _ClassVar[DataProfileAction.PubSubNotification.DetailLevel]
            TABLE_PROFILE: _ClassVar[DataProfileAction.PubSubNotification.DetailLevel]
            RESOURCE_NAME: _ClassVar[DataProfileAction.PubSubNotification.DetailLevel]
            FILE_STORE_PROFILE: _ClassVar[DataProfileAction.PubSubNotification.DetailLevel]
        DETAIL_LEVEL_UNSPECIFIED: DataProfileAction.PubSubNotification.DetailLevel
        TABLE_PROFILE: DataProfileAction.PubSubNotification.DetailLevel
        RESOURCE_NAME: DataProfileAction.PubSubNotification.DetailLevel
        FILE_STORE_PROFILE: DataProfileAction.PubSubNotification.DetailLevel
        TOPIC_FIELD_NUMBER: _ClassVar[int]
        EVENT_FIELD_NUMBER: _ClassVar[int]
        PUBSUB_CONDITION_FIELD_NUMBER: _ClassVar[int]
        DETAIL_OF_MESSAGE_FIELD_NUMBER: _ClassVar[int]
        topic: str
        event: DataProfileAction.EventType
        pubsub_condition: DataProfilePubSubCondition
        detail_of_message: DataProfileAction.PubSubNotification.DetailLevel

        def __init__(self, topic: _Optional[str]=..., event: _Optional[_Union[DataProfileAction.EventType, str]]=..., pubsub_condition: _Optional[_Union[DataProfilePubSubCondition, _Mapping]]=..., detail_of_message: _Optional[_Union[DataProfileAction.PubSubNotification.DetailLevel, str]]=...) -> None:
            ...

    class PublishToChronicle(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...

    class PublishToSecurityCommandCenter(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...

    class TagResources(_message.Message):
        __slots__ = ('tag_conditions', 'profile_generations_to_tag', 'lower_data_risk_to_low')

        class TagCondition(_message.Message):
            __slots__ = ('tag', 'sensitivity_score')
            TAG_FIELD_NUMBER: _ClassVar[int]
            SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
            tag: DataProfileAction.TagResources.TagValue
            sensitivity_score: _storage_pb2.SensitivityScore

            def __init__(self, tag: _Optional[_Union[DataProfileAction.TagResources.TagValue, _Mapping]]=..., sensitivity_score: _Optional[_Union[_storage_pb2.SensitivityScore, _Mapping]]=...) -> None:
                ...

        class TagValue(_message.Message):
            __slots__ = ('namespaced_value',)
            NAMESPACED_VALUE_FIELD_NUMBER: _ClassVar[int]
            namespaced_value: str

            def __init__(self, namespaced_value: _Optional[str]=...) -> None:
                ...
        TAG_CONDITIONS_FIELD_NUMBER: _ClassVar[int]
        PROFILE_GENERATIONS_TO_TAG_FIELD_NUMBER: _ClassVar[int]
        LOWER_DATA_RISK_TO_LOW_FIELD_NUMBER: _ClassVar[int]
        tag_conditions: _containers.RepeatedCompositeFieldContainer[DataProfileAction.TagResources.TagCondition]
        profile_generations_to_tag: _containers.RepeatedScalarFieldContainer[ProfileGeneration]
        lower_data_risk_to_low: bool

        def __init__(self, tag_conditions: _Optional[_Iterable[_Union[DataProfileAction.TagResources.TagCondition, _Mapping]]]=..., profile_generations_to_tag: _Optional[_Iterable[_Union[ProfileGeneration, str]]]=..., lower_data_risk_to_low: bool=...) -> None:
            ...
    EXPORT_DATA_FIELD_NUMBER: _ClassVar[int]
    PUB_SUB_NOTIFICATION_FIELD_NUMBER: _ClassVar[int]
    PUBLISH_TO_CHRONICLE_FIELD_NUMBER: _ClassVar[int]
    PUBLISH_TO_SCC_FIELD_NUMBER: _ClassVar[int]
    TAG_RESOURCES_FIELD_NUMBER: _ClassVar[int]
    export_data: DataProfileAction.Export
    pub_sub_notification: DataProfileAction.PubSubNotification
    publish_to_chronicle: DataProfileAction.PublishToChronicle
    publish_to_scc: DataProfileAction.PublishToSecurityCommandCenter
    tag_resources: DataProfileAction.TagResources

    def __init__(self, export_data: _Optional[_Union[DataProfileAction.Export, _Mapping]]=..., pub_sub_notification: _Optional[_Union[DataProfileAction.PubSubNotification, _Mapping]]=..., publish_to_chronicle: _Optional[_Union[DataProfileAction.PublishToChronicle, _Mapping]]=..., publish_to_scc: _Optional[_Union[DataProfileAction.PublishToSecurityCommandCenter, _Mapping]]=..., tag_resources: _Optional[_Union[DataProfileAction.TagResources, _Mapping]]=...) -> None:
        ...

class DataProfileJobConfig(_message.Message):
    __slots__ = ('location', 'project_id', 'other_cloud_starting_location', 'inspect_templates', 'data_profile_actions')
    LOCATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    OTHER_CLOUD_STARTING_LOCATION_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATES_FIELD_NUMBER: _ClassVar[int]
    DATA_PROFILE_ACTIONS_FIELD_NUMBER: _ClassVar[int]
    location: DataProfileLocation
    project_id: str
    other_cloud_starting_location: OtherCloudDiscoveryStartingLocation
    inspect_templates: _containers.RepeatedScalarFieldContainer[str]
    data_profile_actions: _containers.RepeatedCompositeFieldContainer[DataProfileAction]

    def __init__(self, location: _Optional[_Union[DataProfileLocation, _Mapping]]=..., project_id: _Optional[str]=..., other_cloud_starting_location: _Optional[_Union[OtherCloudDiscoveryStartingLocation, _Mapping]]=..., inspect_templates: _Optional[_Iterable[str]]=..., data_profile_actions: _Optional[_Iterable[_Union[DataProfileAction, _Mapping]]]=...) -> None:
        ...

class BigQueryRegex(_message.Message):
    __slots__ = ('project_id_regex', 'dataset_id_regex', 'table_id_regex')
    PROJECT_ID_REGEX_FIELD_NUMBER: _ClassVar[int]
    DATASET_ID_REGEX_FIELD_NUMBER: _ClassVar[int]
    TABLE_ID_REGEX_FIELD_NUMBER: _ClassVar[int]
    project_id_regex: str
    dataset_id_regex: str
    table_id_regex: str

    def __init__(self, project_id_regex: _Optional[str]=..., dataset_id_regex: _Optional[str]=..., table_id_regex: _Optional[str]=...) -> None:
        ...

class BigQueryRegexes(_message.Message):
    __slots__ = ('patterns',)
    PATTERNS_FIELD_NUMBER: _ClassVar[int]
    patterns: _containers.RepeatedCompositeFieldContainer[BigQueryRegex]

    def __init__(self, patterns: _Optional[_Iterable[_Union[BigQueryRegex, _Mapping]]]=...) -> None:
        ...

class BigQueryTableTypes(_message.Message):
    __slots__ = ('types',)
    TYPES_FIELD_NUMBER: _ClassVar[int]
    types: _containers.RepeatedScalarFieldContainer[BigQueryTableType]

    def __init__(self, types: _Optional[_Iterable[_Union[BigQueryTableType, str]]]=...) -> None:
        ...

class Disabled(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class DataProfileLocation(_message.Message):
    __slots__ = ('organization_id', 'folder_id')
    ORGANIZATION_ID_FIELD_NUMBER: _ClassVar[int]
    FOLDER_ID_FIELD_NUMBER: _ClassVar[int]
    organization_id: int
    folder_id: int

    def __init__(self, organization_id: _Optional[int]=..., folder_id: _Optional[int]=...) -> None:
        ...

class DiscoveryConfig(_message.Message):
    __slots__ = ('name', 'display_name', 'org_config', 'other_cloud_starting_location', 'inspect_templates', 'actions', 'targets', 'errors', 'create_time', 'update_time', 'last_run_time', 'status')

    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        STATUS_UNSPECIFIED: _ClassVar[DiscoveryConfig.Status]
        RUNNING: _ClassVar[DiscoveryConfig.Status]
        PAUSED: _ClassVar[DiscoveryConfig.Status]
    STATUS_UNSPECIFIED: DiscoveryConfig.Status
    RUNNING: DiscoveryConfig.Status
    PAUSED: DiscoveryConfig.Status

    class OrgConfig(_message.Message):
        __slots__ = ('location', 'project_id')
        LOCATION_FIELD_NUMBER: _ClassVar[int]
        PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
        location: DiscoveryStartingLocation
        project_id: str

        def __init__(self, location: _Optional[_Union[DiscoveryStartingLocation, _Mapping]]=..., project_id: _Optional[str]=...) -> None:
            ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    ORG_CONFIG_FIELD_NUMBER: _ClassVar[int]
    OTHER_CLOUD_STARTING_LOCATION_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATES_FIELD_NUMBER: _ClassVar[int]
    ACTIONS_FIELD_NUMBER: _ClassVar[int]
    TARGETS_FIELD_NUMBER: _ClassVar[int]
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    LAST_RUN_TIME_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    name: str
    display_name: str
    org_config: DiscoveryConfig.OrgConfig
    other_cloud_starting_location: OtherCloudDiscoveryStartingLocation
    inspect_templates: _containers.RepeatedScalarFieldContainer[str]
    actions: _containers.RepeatedCompositeFieldContainer[DataProfileAction]
    targets: _containers.RepeatedCompositeFieldContainer[DiscoveryTarget]
    errors: _containers.RepeatedCompositeFieldContainer[Error]
    create_time: _timestamp_pb2.Timestamp
    update_time: _timestamp_pb2.Timestamp
    last_run_time: _timestamp_pb2.Timestamp
    status: DiscoveryConfig.Status

    def __init__(self, name: _Optional[str]=..., display_name: _Optional[str]=..., org_config: _Optional[_Union[DiscoveryConfig.OrgConfig, _Mapping]]=..., other_cloud_starting_location: _Optional[_Union[OtherCloudDiscoveryStartingLocation, _Mapping]]=..., inspect_templates: _Optional[_Iterable[str]]=..., actions: _Optional[_Iterable[_Union[DataProfileAction, _Mapping]]]=..., targets: _Optional[_Iterable[_Union[DiscoveryTarget, _Mapping]]]=..., errors: _Optional[_Iterable[_Union[Error, _Mapping]]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., last_run_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., status: _Optional[_Union[DiscoveryConfig.Status, str]]=...) -> None:
        ...

class DiscoveryTarget(_message.Message):
    __slots__ = ('big_query_target', 'cloud_sql_target', 'secrets_target', 'cloud_storage_target', 'other_cloud_target')
    BIG_QUERY_TARGET_FIELD_NUMBER: _ClassVar[int]
    CLOUD_SQL_TARGET_FIELD_NUMBER: _ClassVar[int]
    SECRETS_TARGET_FIELD_NUMBER: _ClassVar[int]
    CLOUD_STORAGE_TARGET_FIELD_NUMBER: _ClassVar[int]
    OTHER_CLOUD_TARGET_FIELD_NUMBER: _ClassVar[int]
    big_query_target: BigQueryDiscoveryTarget
    cloud_sql_target: CloudSqlDiscoveryTarget
    secrets_target: SecretsDiscoveryTarget
    cloud_storage_target: CloudStorageDiscoveryTarget
    other_cloud_target: OtherCloudDiscoveryTarget

    def __init__(self, big_query_target: _Optional[_Union[BigQueryDiscoveryTarget, _Mapping]]=..., cloud_sql_target: _Optional[_Union[CloudSqlDiscoveryTarget, _Mapping]]=..., secrets_target: _Optional[_Union[SecretsDiscoveryTarget, _Mapping]]=..., cloud_storage_target: _Optional[_Union[CloudStorageDiscoveryTarget, _Mapping]]=..., other_cloud_target: _Optional[_Union[OtherCloudDiscoveryTarget, _Mapping]]=...) -> None:
        ...

class BigQueryDiscoveryTarget(_message.Message):
    __slots__ = ('filter', 'conditions', 'cadence', 'disabled')
    FILTER_FIELD_NUMBER: _ClassVar[int]
    CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    CADENCE_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    filter: DiscoveryBigQueryFilter
    conditions: DiscoveryBigQueryConditions
    cadence: DiscoveryGenerationCadence
    disabled: Disabled

    def __init__(self, filter: _Optional[_Union[DiscoveryBigQueryFilter, _Mapping]]=..., conditions: _Optional[_Union[DiscoveryBigQueryConditions, _Mapping]]=..., cadence: _Optional[_Union[DiscoveryGenerationCadence, _Mapping]]=..., disabled: _Optional[_Union[Disabled, _Mapping]]=...) -> None:
        ...

class DiscoveryBigQueryFilter(_message.Message):
    __slots__ = ('tables', 'other_tables', 'table_reference')

    class AllOtherBigQueryTables(_message.Message):
        __slots__ = ()

        def __init__(self) -> None:
            ...
    TABLES_FIELD_NUMBER: _ClassVar[int]
    OTHER_TABLES_FIELD_NUMBER: _ClassVar[int]
    TABLE_REFERENCE_FIELD_NUMBER: _ClassVar[int]
    tables: BigQueryTableCollection
    other_tables: DiscoveryBigQueryFilter.AllOtherBigQueryTables
    table_reference: _storage_pb2.TableReference

    def __init__(self, tables: _Optional[_Union[BigQueryTableCollection, _Mapping]]=..., other_tables: _Optional[_Union[DiscoveryBigQueryFilter.AllOtherBigQueryTables, _Mapping]]=..., table_reference: _Optional[_Union[_storage_pb2.TableReference, _Mapping]]=...) -> None:
        ...

class BigQueryTableCollection(_message.Message):
    __slots__ = ('include_regexes',)
    INCLUDE_REGEXES_FIELD_NUMBER: _ClassVar[int]
    include_regexes: BigQueryRegexes

    def __init__(self, include_regexes: _Optional[_Union[BigQueryRegexes, _Mapping]]=...) -> None:
        ...

class DiscoveryBigQueryConditions(_message.Message):
    __slots__ = ('created_after', 'types', 'type_collection', 'or_conditions')

    class OrConditions(_message.Message):
        __slots__ = ('min_row_count', 'min_age')
        MIN_ROW_COUNT_FIELD_NUMBER: _ClassVar[int]
        MIN_AGE_FIELD_NUMBER: _ClassVar[int]
        min_row_count: int
        min_age: _duration_pb2.Duration

        def __init__(self, min_row_count: _Optional[int]=..., min_age: _Optional[_Union[_duration_pb2.Duration, _Mapping]]=...) -> None:
            ...
    CREATED_AFTER_FIELD_NUMBER: _ClassVar[int]
    TYPES_FIELD_NUMBER: _ClassVar[int]
    TYPE_COLLECTION_FIELD_NUMBER: _ClassVar[int]
    OR_CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    created_after: _timestamp_pb2.Timestamp
    types: BigQueryTableTypes
    type_collection: BigQueryTableTypeCollection
    or_conditions: DiscoveryBigQueryConditions.OrConditions

    def __init__(self, created_after: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., types: _Optional[_Union[BigQueryTableTypes, _Mapping]]=..., type_collection: _Optional[_Union[BigQueryTableTypeCollection, str]]=..., or_conditions: _Optional[_Union[DiscoveryBigQueryConditions.OrConditions, _Mapping]]=...) -> None:
        ...

class DiscoveryGenerationCadence(_message.Message):
    __slots__ = ('schema_modified_cadence', 'table_modified_cadence', 'inspect_template_modified_cadence', 'refresh_frequency')
    SCHEMA_MODIFIED_CADENCE_FIELD_NUMBER: _ClassVar[int]
    TABLE_MODIFIED_CADENCE_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_MODIFIED_CADENCE_FIELD_NUMBER: _ClassVar[int]
    REFRESH_FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    schema_modified_cadence: DiscoverySchemaModifiedCadence
    table_modified_cadence: DiscoveryTableModifiedCadence
    inspect_template_modified_cadence: DiscoveryInspectTemplateModifiedCadence
    refresh_frequency: DataProfileUpdateFrequency

    def __init__(self, schema_modified_cadence: _Optional[_Union[DiscoverySchemaModifiedCadence, _Mapping]]=..., table_modified_cadence: _Optional[_Union[DiscoveryTableModifiedCadence, _Mapping]]=..., inspect_template_modified_cadence: _Optional[_Union[DiscoveryInspectTemplateModifiedCadence, _Mapping]]=..., refresh_frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=...) -> None:
        ...

class DiscoveryTableModifiedCadence(_message.Message):
    __slots__ = ('types', 'frequency')
    TYPES_FIELD_NUMBER: _ClassVar[int]
    FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    types: _containers.RepeatedScalarFieldContainer[BigQueryTableModification]
    frequency: DataProfileUpdateFrequency

    def __init__(self, types: _Optional[_Iterable[_Union[BigQueryTableModification, str]]]=..., frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=...) -> None:
        ...

class DiscoverySchemaModifiedCadence(_message.Message):
    __slots__ = ('types', 'frequency')
    TYPES_FIELD_NUMBER: _ClassVar[int]
    FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    types: _containers.RepeatedScalarFieldContainer[BigQuerySchemaModification]
    frequency: DataProfileUpdateFrequency

    def __init__(self, types: _Optional[_Iterable[_Union[BigQuerySchemaModification, str]]]=..., frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=...) -> None:
        ...

class DiscoveryInspectTemplateModifiedCadence(_message.Message):
    __slots__ = ('frequency',)
    FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    frequency: DataProfileUpdateFrequency

    def __init__(self, frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=...) -> None:
        ...

class CloudSqlDiscoveryTarget(_message.Message):
    __slots__ = ('filter', 'conditions', 'generation_cadence', 'disabled')
    FILTER_FIELD_NUMBER: _ClassVar[int]
    CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    GENERATION_CADENCE_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    filter: DiscoveryCloudSqlFilter
    conditions: DiscoveryCloudSqlConditions
    generation_cadence: DiscoveryCloudSqlGenerationCadence
    disabled: Disabled

    def __init__(self, filter: _Optional[_Union[DiscoveryCloudSqlFilter, _Mapping]]=..., conditions: _Optional[_Union[DiscoveryCloudSqlConditions, _Mapping]]=..., generation_cadence: _Optional[_Union[DiscoveryCloudSqlGenerationCadence, _Mapping]]=..., disabled: _Optional[_Union[Disabled, _Mapping]]=...) -> None:
        ...

class DiscoveryCloudSqlFilter(_message.Message):
    __slots__ = ('collection', 'others', 'database_resource_reference')
    COLLECTION_FIELD_NUMBER: _ClassVar[int]
    OTHERS_FIELD_NUMBER: _ClassVar[int]
    DATABASE_RESOURCE_REFERENCE_FIELD_NUMBER: _ClassVar[int]
    collection: DatabaseResourceCollection
    others: AllOtherDatabaseResources
    database_resource_reference: DatabaseResourceReference

    def __init__(self, collection: _Optional[_Union[DatabaseResourceCollection, _Mapping]]=..., others: _Optional[_Union[AllOtherDatabaseResources, _Mapping]]=..., database_resource_reference: _Optional[_Union[DatabaseResourceReference, _Mapping]]=...) -> None:
        ...

class DatabaseResourceCollection(_message.Message):
    __slots__ = ('include_regexes',)
    INCLUDE_REGEXES_FIELD_NUMBER: _ClassVar[int]
    include_regexes: DatabaseResourceRegexes

    def __init__(self, include_regexes: _Optional[_Union[DatabaseResourceRegexes, _Mapping]]=...) -> None:
        ...

class DatabaseResourceRegexes(_message.Message):
    __slots__ = ('patterns',)
    PATTERNS_FIELD_NUMBER: _ClassVar[int]
    patterns: _containers.RepeatedCompositeFieldContainer[DatabaseResourceRegex]

    def __init__(self, patterns: _Optional[_Iterable[_Union[DatabaseResourceRegex, _Mapping]]]=...) -> None:
        ...

class DatabaseResourceRegex(_message.Message):
    __slots__ = ('project_id_regex', 'instance_regex', 'database_regex', 'database_resource_name_regex')
    PROJECT_ID_REGEX_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_REGEX_FIELD_NUMBER: _ClassVar[int]
    DATABASE_REGEX_FIELD_NUMBER: _ClassVar[int]
    DATABASE_RESOURCE_NAME_REGEX_FIELD_NUMBER: _ClassVar[int]
    project_id_regex: str
    instance_regex: str
    database_regex: str
    database_resource_name_regex: str

    def __init__(self, project_id_regex: _Optional[str]=..., instance_regex: _Optional[str]=..., database_regex: _Optional[str]=..., database_resource_name_regex: _Optional[str]=...) -> None:
        ...

class AllOtherDatabaseResources(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class DatabaseResourceReference(_message.Message):
    __slots__ = ('project_id', 'instance', 'database', 'database_resource')
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    INSTANCE_FIELD_NUMBER: _ClassVar[int]
    DATABASE_FIELD_NUMBER: _ClassVar[int]
    DATABASE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    project_id: str
    instance: str
    database: str
    database_resource: str

    def __init__(self, project_id: _Optional[str]=..., instance: _Optional[str]=..., database: _Optional[str]=..., database_resource: _Optional[str]=...) -> None:
        ...

class DiscoveryCloudSqlConditions(_message.Message):
    __slots__ = ('database_engines', 'types')

    class DatabaseEngine(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        DATABASE_ENGINE_UNSPECIFIED: _ClassVar[DiscoveryCloudSqlConditions.DatabaseEngine]
        ALL_SUPPORTED_DATABASE_ENGINES: _ClassVar[DiscoveryCloudSqlConditions.DatabaseEngine]
        MYSQL: _ClassVar[DiscoveryCloudSqlConditions.DatabaseEngine]
        POSTGRES: _ClassVar[DiscoveryCloudSqlConditions.DatabaseEngine]
    DATABASE_ENGINE_UNSPECIFIED: DiscoveryCloudSqlConditions.DatabaseEngine
    ALL_SUPPORTED_DATABASE_ENGINES: DiscoveryCloudSqlConditions.DatabaseEngine
    MYSQL: DiscoveryCloudSqlConditions.DatabaseEngine
    POSTGRES: DiscoveryCloudSqlConditions.DatabaseEngine

    class DatabaseResourceType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        DATABASE_RESOURCE_TYPE_UNSPECIFIED: _ClassVar[DiscoveryCloudSqlConditions.DatabaseResourceType]
        DATABASE_RESOURCE_TYPE_ALL_SUPPORTED_TYPES: _ClassVar[DiscoveryCloudSqlConditions.DatabaseResourceType]
        DATABASE_RESOURCE_TYPE_TABLE: _ClassVar[DiscoveryCloudSqlConditions.DatabaseResourceType]
    DATABASE_RESOURCE_TYPE_UNSPECIFIED: DiscoveryCloudSqlConditions.DatabaseResourceType
    DATABASE_RESOURCE_TYPE_ALL_SUPPORTED_TYPES: DiscoveryCloudSqlConditions.DatabaseResourceType
    DATABASE_RESOURCE_TYPE_TABLE: DiscoveryCloudSqlConditions.DatabaseResourceType
    DATABASE_ENGINES_FIELD_NUMBER: _ClassVar[int]
    TYPES_FIELD_NUMBER: _ClassVar[int]
    database_engines: _containers.RepeatedScalarFieldContainer[DiscoveryCloudSqlConditions.DatabaseEngine]
    types: _containers.RepeatedScalarFieldContainer[DiscoveryCloudSqlConditions.DatabaseResourceType]

    def __init__(self, database_engines: _Optional[_Iterable[_Union[DiscoveryCloudSqlConditions.DatabaseEngine, str]]]=..., types: _Optional[_Iterable[_Union[DiscoveryCloudSqlConditions.DatabaseResourceType, str]]]=...) -> None:
        ...

class DiscoveryCloudSqlGenerationCadence(_message.Message):
    __slots__ = ('schema_modified_cadence', 'refresh_frequency', 'inspect_template_modified_cadence')

    class SchemaModifiedCadence(_message.Message):
        __slots__ = ('types', 'frequency')

        class CloudSqlSchemaModification(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            SQL_SCHEMA_MODIFICATION_UNSPECIFIED: _ClassVar[DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification]
            NEW_COLUMNS: _ClassVar[DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification]
            REMOVED_COLUMNS: _ClassVar[DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification]
        SQL_SCHEMA_MODIFICATION_UNSPECIFIED: DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification
        NEW_COLUMNS: DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification
        REMOVED_COLUMNS: DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification
        TYPES_FIELD_NUMBER: _ClassVar[int]
        FREQUENCY_FIELD_NUMBER: _ClassVar[int]
        types: _containers.RepeatedScalarFieldContainer[DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification]
        frequency: DataProfileUpdateFrequency

        def __init__(self, types: _Optional[_Iterable[_Union[DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence.CloudSqlSchemaModification, str]]]=..., frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=...) -> None:
            ...
    SCHEMA_MODIFIED_CADENCE_FIELD_NUMBER: _ClassVar[int]
    REFRESH_FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_MODIFIED_CADENCE_FIELD_NUMBER: _ClassVar[int]
    schema_modified_cadence: DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence
    refresh_frequency: DataProfileUpdateFrequency
    inspect_template_modified_cadence: DiscoveryInspectTemplateModifiedCadence

    def __init__(self, schema_modified_cadence: _Optional[_Union[DiscoveryCloudSqlGenerationCadence.SchemaModifiedCadence, _Mapping]]=..., refresh_frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=..., inspect_template_modified_cadence: _Optional[_Union[DiscoveryInspectTemplateModifiedCadence, _Mapping]]=...) -> None:
        ...

class SecretsDiscoveryTarget(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class CloudStorageDiscoveryTarget(_message.Message):
    __slots__ = ('filter', 'conditions', 'generation_cadence', 'disabled')
    FILTER_FIELD_NUMBER: _ClassVar[int]
    CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    GENERATION_CADENCE_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    filter: DiscoveryCloudStorageFilter
    conditions: DiscoveryFileStoreConditions
    generation_cadence: DiscoveryCloudStorageGenerationCadence
    disabled: Disabled

    def __init__(self, filter: _Optional[_Union[DiscoveryCloudStorageFilter, _Mapping]]=..., conditions: _Optional[_Union[DiscoveryFileStoreConditions, _Mapping]]=..., generation_cadence: _Optional[_Union[DiscoveryCloudStorageGenerationCadence, _Mapping]]=..., disabled: _Optional[_Union[Disabled, _Mapping]]=...) -> None:
        ...

class DiscoveryCloudStorageFilter(_message.Message):
    __slots__ = ('collection', 'cloud_storage_resource_reference', 'others')
    COLLECTION_FIELD_NUMBER: _ClassVar[int]
    CLOUD_STORAGE_RESOURCE_REFERENCE_FIELD_NUMBER: _ClassVar[int]
    OTHERS_FIELD_NUMBER: _ClassVar[int]
    collection: FileStoreCollection
    cloud_storage_resource_reference: CloudStorageResourceReference
    others: AllOtherResources

    def __init__(self, collection: _Optional[_Union[FileStoreCollection, _Mapping]]=..., cloud_storage_resource_reference: _Optional[_Union[CloudStorageResourceReference, _Mapping]]=..., others: _Optional[_Union[AllOtherResources, _Mapping]]=...) -> None:
        ...

class FileStoreCollection(_message.Message):
    __slots__ = ('include_regexes',)
    INCLUDE_REGEXES_FIELD_NUMBER: _ClassVar[int]
    include_regexes: FileStoreRegexes

    def __init__(self, include_regexes: _Optional[_Union[FileStoreRegexes, _Mapping]]=...) -> None:
        ...

class FileStoreRegexes(_message.Message):
    __slots__ = ('patterns',)
    PATTERNS_FIELD_NUMBER: _ClassVar[int]
    patterns: _containers.RepeatedCompositeFieldContainer[FileStoreRegex]

    def __init__(self, patterns: _Optional[_Iterable[_Union[FileStoreRegex, _Mapping]]]=...) -> None:
        ...

class FileStoreRegex(_message.Message):
    __slots__ = ('cloud_storage_regex',)
    CLOUD_STORAGE_REGEX_FIELD_NUMBER: _ClassVar[int]
    cloud_storage_regex: CloudStorageRegex

    def __init__(self, cloud_storage_regex: _Optional[_Union[CloudStorageRegex, _Mapping]]=...) -> None:
        ...

class CloudStorageRegex(_message.Message):
    __slots__ = ('project_id_regex', 'bucket_name_regex')
    PROJECT_ID_REGEX_FIELD_NUMBER: _ClassVar[int]
    BUCKET_NAME_REGEX_FIELD_NUMBER: _ClassVar[int]
    project_id_regex: str
    bucket_name_regex: str

    def __init__(self, project_id_regex: _Optional[str]=..., bucket_name_regex: _Optional[str]=...) -> None:
        ...

class CloudStorageResourceReference(_message.Message):
    __slots__ = ('bucket_name', 'project_id')
    BUCKET_NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    bucket_name: str
    project_id: str

    def __init__(self, bucket_name: _Optional[str]=..., project_id: _Optional[str]=...) -> None:
        ...

class DiscoveryCloudStorageGenerationCadence(_message.Message):
    __slots__ = ('refresh_frequency', 'inspect_template_modified_cadence')
    REFRESH_FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_MODIFIED_CADENCE_FIELD_NUMBER: _ClassVar[int]
    refresh_frequency: DataProfileUpdateFrequency
    inspect_template_modified_cadence: DiscoveryInspectTemplateModifiedCadence

    def __init__(self, refresh_frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=..., inspect_template_modified_cadence: _Optional[_Union[DiscoveryInspectTemplateModifiedCadence, _Mapping]]=...) -> None:
        ...

class DiscoveryCloudStorageConditions(_message.Message):
    __slots__ = ('included_object_attributes', 'included_bucket_attributes')

    class CloudStorageObjectAttribute(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        CLOUD_STORAGE_OBJECT_ATTRIBUTE_UNSPECIFIED: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        ALL_SUPPORTED_OBJECTS: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        STANDARD: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        NEARLINE: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        COLDLINE: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        ARCHIVE: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        REGIONAL: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        MULTI_REGIONAL: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
        DURABLE_REDUCED_AVAILABILITY: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
    CLOUD_STORAGE_OBJECT_ATTRIBUTE_UNSPECIFIED: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    ALL_SUPPORTED_OBJECTS: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    STANDARD: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    NEARLINE: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    COLDLINE: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    ARCHIVE: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    REGIONAL: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    MULTI_REGIONAL: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute
    DURABLE_REDUCED_AVAILABILITY: DiscoveryCloudStorageConditions.CloudStorageObjectAttribute

    class CloudStorageBucketAttribute(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        CLOUD_STORAGE_BUCKET_ATTRIBUTE_UNSPECIFIED: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageBucketAttribute]
        ALL_SUPPORTED_BUCKETS: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageBucketAttribute]
        AUTOCLASS_DISABLED: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageBucketAttribute]
        AUTOCLASS_ENABLED: _ClassVar[DiscoveryCloudStorageConditions.CloudStorageBucketAttribute]
    CLOUD_STORAGE_BUCKET_ATTRIBUTE_UNSPECIFIED: DiscoveryCloudStorageConditions.CloudStorageBucketAttribute
    ALL_SUPPORTED_BUCKETS: DiscoveryCloudStorageConditions.CloudStorageBucketAttribute
    AUTOCLASS_DISABLED: DiscoveryCloudStorageConditions.CloudStorageBucketAttribute
    AUTOCLASS_ENABLED: DiscoveryCloudStorageConditions.CloudStorageBucketAttribute
    INCLUDED_OBJECT_ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    INCLUDED_BUCKET_ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    included_object_attributes: _containers.RepeatedScalarFieldContainer[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute]
    included_bucket_attributes: _containers.RepeatedScalarFieldContainer[DiscoveryCloudStorageConditions.CloudStorageBucketAttribute]

    def __init__(self, included_object_attributes: _Optional[_Iterable[_Union[DiscoveryCloudStorageConditions.CloudStorageObjectAttribute, str]]]=..., included_bucket_attributes: _Optional[_Iterable[_Union[DiscoveryCloudStorageConditions.CloudStorageBucketAttribute, str]]]=...) -> None:
        ...

class DiscoveryFileStoreConditions(_message.Message):
    __slots__ = ('created_after', 'min_age', 'cloud_storage_conditions')
    CREATED_AFTER_FIELD_NUMBER: _ClassVar[int]
    MIN_AGE_FIELD_NUMBER: _ClassVar[int]
    CLOUD_STORAGE_CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    created_after: _timestamp_pb2.Timestamp
    min_age: _duration_pb2.Duration
    cloud_storage_conditions: DiscoveryCloudStorageConditions

    def __init__(self, created_after: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., min_age: _Optional[_Union[_duration_pb2.Duration, _Mapping]]=..., cloud_storage_conditions: _Optional[_Union[DiscoveryCloudStorageConditions, _Mapping]]=...) -> None:
        ...

class OtherCloudDiscoveryTarget(_message.Message):
    __slots__ = ('data_source_type', 'filter', 'conditions', 'generation_cadence', 'disabled')
    DATA_SOURCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    GENERATION_CADENCE_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    data_source_type: DataSourceType
    filter: DiscoveryOtherCloudFilter
    conditions: DiscoveryOtherCloudConditions
    generation_cadence: DiscoveryOtherCloudGenerationCadence
    disabled: Disabled

    def __init__(self, data_source_type: _Optional[_Union[DataSourceType, _Mapping]]=..., filter: _Optional[_Union[DiscoveryOtherCloudFilter, _Mapping]]=..., conditions: _Optional[_Union[DiscoveryOtherCloudConditions, _Mapping]]=..., generation_cadence: _Optional[_Union[DiscoveryOtherCloudGenerationCadence, _Mapping]]=..., disabled: _Optional[_Union[Disabled, _Mapping]]=...) -> None:
        ...

class DiscoveryOtherCloudFilter(_message.Message):
    __slots__ = ('collection', 'single_resource', 'others')
    COLLECTION_FIELD_NUMBER: _ClassVar[int]
    SINGLE_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    OTHERS_FIELD_NUMBER: _ClassVar[int]
    collection: OtherCloudResourceCollection
    single_resource: OtherCloudSingleResourceReference
    others: AllOtherResources

    def __init__(self, collection: _Optional[_Union[OtherCloudResourceCollection, _Mapping]]=..., single_resource: _Optional[_Union[OtherCloudSingleResourceReference, _Mapping]]=..., others: _Optional[_Union[AllOtherResources, _Mapping]]=...) -> None:
        ...

class OtherCloudResourceCollection(_message.Message):
    __slots__ = ('include_regexes',)
    INCLUDE_REGEXES_FIELD_NUMBER: _ClassVar[int]
    include_regexes: OtherCloudResourceRegexes

    def __init__(self, include_regexes: _Optional[_Union[OtherCloudResourceRegexes, _Mapping]]=...) -> None:
        ...

class OtherCloudResourceRegexes(_message.Message):
    __slots__ = ('patterns',)
    PATTERNS_FIELD_NUMBER: _ClassVar[int]
    patterns: _containers.RepeatedCompositeFieldContainer[OtherCloudResourceRegex]

    def __init__(self, patterns: _Optional[_Iterable[_Union[OtherCloudResourceRegex, _Mapping]]]=...) -> None:
        ...

class OtherCloudResourceRegex(_message.Message):
    __slots__ = ('amazon_s3_bucket_regex',)
    AMAZON_S3_BUCKET_REGEX_FIELD_NUMBER: _ClassVar[int]
    amazon_s3_bucket_regex: AmazonS3BucketRegex

    def __init__(self, amazon_s3_bucket_regex: _Optional[_Union[AmazonS3BucketRegex, _Mapping]]=...) -> None:
        ...

class AwsAccountRegex(_message.Message):
    __slots__ = ('account_id_regex',)
    ACCOUNT_ID_REGEX_FIELD_NUMBER: _ClassVar[int]
    account_id_regex: str

    def __init__(self, account_id_regex: _Optional[str]=...) -> None:
        ...

class AmazonS3BucketRegex(_message.Message):
    __slots__ = ('aws_account_regex', 'bucket_name_regex')
    AWS_ACCOUNT_REGEX_FIELD_NUMBER: _ClassVar[int]
    BUCKET_NAME_REGEX_FIELD_NUMBER: _ClassVar[int]
    aws_account_regex: AwsAccountRegex
    bucket_name_regex: str

    def __init__(self, aws_account_regex: _Optional[_Union[AwsAccountRegex, _Mapping]]=..., bucket_name_regex: _Optional[str]=...) -> None:
        ...

class OtherCloudSingleResourceReference(_message.Message):
    __slots__ = ('amazon_s3_bucket',)
    AMAZON_S3_BUCKET_FIELD_NUMBER: _ClassVar[int]
    amazon_s3_bucket: AmazonS3Bucket

    def __init__(self, amazon_s3_bucket: _Optional[_Union[AmazonS3Bucket, _Mapping]]=...) -> None:
        ...

class AwsAccount(_message.Message):
    __slots__ = ('account_id',)
    ACCOUNT_ID_FIELD_NUMBER: _ClassVar[int]
    account_id: str

    def __init__(self, account_id: _Optional[str]=...) -> None:
        ...

class AmazonS3Bucket(_message.Message):
    __slots__ = ('aws_account', 'bucket_name')
    AWS_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    BUCKET_NAME_FIELD_NUMBER: _ClassVar[int]
    aws_account: AwsAccount
    bucket_name: str

    def __init__(self, aws_account: _Optional[_Union[AwsAccount, _Mapping]]=..., bucket_name: _Optional[str]=...) -> None:
        ...

class DiscoveryOtherCloudConditions(_message.Message):
    __slots__ = ('min_age', 'amazon_s3_bucket_conditions')
    MIN_AGE_FIELD_NUMBER: _ClassVar[int]
    AMAZON_S3_BUCKET_CONDITIONS_FIELD_NUMBER: _ClassVar[int]
    min_age: _duration_pb2.Duration
    amazon_s3_bucket_conditions: AmazonS3BucketConditions

    def __init__(self, min_age: _Optional[_Union[_duration_pb2.Duration, _Mapping]]=..., amazon_s3_bucket_conditions: _Optional[_Union[AmazonS3BucketConditions, _Mapping]]=...) -> None:
        ...

class AmazonS3BucketConditions(_message.Message):
    __slots__ = ('bucket_types', 'object_storage_classes')

    class BucketType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        TYPE_UNSPECIFIED: _ClassVar[AmazonS3BucketConditions.BucketType]
        TYPE_ALL_SUPPORTED: _ClassVar[AmazonS3BucketConditions.BucketType]
        TYPE_GENERAL_PURPOSE: _ClassVar[AmazonS3BucketConditions.BucketType]
    TYPE_UNSPECIFIED: AmazonS3BucketConditions.BucketType
    TYPE_ALL_SUPPORTED: AmazonS3BucketConditions.BucketType
    TYPE_GENERAL_PURPOSE: AmazonS3BucketConditions.BucketType

    class ObjectStorageClass(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        UNSPECIFIED: _ClassVar[AmazonS3BucketConditions.ObjectStorageClass]
        ALL_SUPPORTED_CLASSES: _ClassVar[AmazonS3BucketConditions.ObjectStorageClass]
        STANDARD: _ClassVar[AmazonS3BucketConditions.ObjectStorageClass]
        STANDARD_INFREQUENT_ACCESS: _ClassVar[AmazonS3BucketConditions.ObjectStorageClass]
        GLACIER_INSTANT_RETRIEVAL: _ClassVar[AmazonS3BucketConditions.ObjectStorageClass]
        INTELLIGENT_TIERING: _ClassVar[AmazonS3BucketConditions.ObjectStorageClass]
    UNSPECIFIED: AmazonS3BucketConditions.ObjectStorageClass
    ALL_SUPPORTED_CLASSES: AmazonS3BucketConditions.ObjectStorageClass
    STANDARD: AmazonS3BucketConditions.ObjectStorageClass
    STANDARD_INFREQUENT_ACCESS: AmazonS3BucketConditions.ObjectStorageClass
    GLACIER_INSTANT_RETRIEVAL: AmazonS3BucketConditions.ObjectStorageClass
    INTELLIGENT_TIERING: AmazonS3BucketConditions.ObjectStorageClass
    BUCKET_TYPES_FIELD_NUMBER: _ClassVar[int]
    OBJECT_STORAGE_CLASSES_FIELD_NUMBER: _ClassVar[int]
    bucket_types: _containers.RepeatedScalarFieldContainer[AmazonS3BucketConditions.BucketType]
    object_storage_classes: _containers.RepeatedScalarFieldContainer[AmazonS3BucketConditions.ObjectStorageClass]

    def __init__(self, bucket_types: _Optional[_Iterable[_Union[AmazonS3BucketConditions.BucketType, str]]]=..., object_storage_classes: _Optional[_Iterable[_Union[AmazonS3BucketConditions.ObjectStorageClass, str]]]=...) -> None:
        ...

class DiscoveryOtherCloudGenerationCadence(_message.Message):
    __slots__ = ('refresh_frequency', 'inspect_template_modified_cadence')
    REFRESH_FREQUENCY_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_MODIFIED_CADENCE_FIELD_NUMBER: _ClassVar[int]
    refresh_frequency: DataProfileUpdateFrequency
    inspect_template_modified_cadence: DiscoveryInspectTemplateModifiedCadence

    def __init__(self, refresh_frequency: _Optional[_Union[DataProfileUpdateFrequency, str]]=..., inspect_template_modified_cadence: _Optional[_Union[DiscoveryInspectTemplateModifiedCadence, _Mapping]]=...) -> None:
        ...

class DiscoveryStartingLocation(_message.Message):
    __slots__ = ('organization_id', 'folder_id')
    ORGANIZATION_ID_FIELD_NUMBER: _ClassVar[int]
    FOLDER_ID_FIELD_NUMBER: _ClassVar[int]
    organization_id: int
    folder_id: int

    def __init__(self, organization_id: _Optional[int]=..., folder_id: _Optional[int]=...) -> None:
        ...

class OtherCloudDiscoveryStartingLocation(_message.Message):
    __slots__ = ('aws_location',)

    class AwsDiscoveryStartingLocation(_message.Message):
        __slots__ = ('account_id', 'all_asset_inventory_assets')
        ACCOUNT_ID_FIELD_NUMBER: _ClassVar[int]
        ALL_ASSET_INVENTORY_ASSETS_FIELD_NUMBER: _ClassVar[int]
        account_id: str
        all_asset_inventory_assets: bool

        def __init__(self, account_id: _Optional[str]=..., all_asset_inventory_assets: bool=...) -> None:
            ...
    AWS_LOCATION_FIELD_NUMBER: _ClassVar[int]
    aws_location: OtherCloudDiscoveryStartingLocation.AwsDiscoveryStartingLocation

    def __init__(self, aws_location: _Optional[_Union[OtherCloudDiscoveryStartingLocation.AwsDiscoveryStartingLocation, _Mapping]]=...) -> None:
        ...

class AllOtherResources(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class DlpJob(_message.Message):
    __slots__ = ('name', 'type', 'state', 'risk_details', 'inspect_details', 'create_time', 'start_time', 'end_time', 'last_modified', 'job_trigger_name', 'errors', 'action_details')

    class JobState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        JOB_STATE_UNSPECIFIED: _ClassVar[DlpJob.JobState]
        PENDING: _ClassVar[DlpJob.JobState]
        RUNNING: _ClassVar[DlpJob.JobState]
        DONE: _ClassVar[DlpJob.JobState]
        CANCELED: _ClassVar[DlpJob.JobState]
        FAILED: _ClassVar[DlpJob.JobState]
        ACTIVE: _ClassVar[DlpJob.JobState]
    JOB_STATE_UNSPECIFIED: DlpJob.JobState
    PENDING: DlpJob.JobState
    RUNNING: DlpJob.JobState
    DONE: DlpJob.JobState
    CANCELED: DlpJob.JobState
    FAILED: DlpJob.JobState
    ACTIVE: DlpJob.JobState
    NAME_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    RISK_DETAILS_FIELD_NUMBER: _ClassVar[int]
    INSPECT_DETAILS_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    END_TIME_FIELD_NUMBER: _ClassVar[int]
    LAST_MODIFIED_FIELD_NUMBER: _ClassVar[int]
    JOB_TRIGGER_NAME_FIELD_NUMBER: _ClassVar[int]
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    ACTION_DETAILS_FIELD_NUMBER: _ClassVar[int]
    name: str
    type: DlpJobType
    state: DlpJob.JobState
    risk_details: AnalyzeDataSourceRiskDetails
    inspect_details: InspectDataSourceDetails
    create_time: _timestamp_pb2.Timestamp
    start_time: _timestamp_pb2.Timestamp
    end_time: _timestamp_pb2.Timestamp
    last_modified: _timestamp_pb2.Timestamp
    job_trigger_name: str
    errors: _containers.RepeatedCompositeFieldContainer[Error]
    action_details: _containers.RepeatedCompositeFieldContainer[ActionDetails]

    def __init__(self, name: _Optional[str]=..., type: _Optional[_Union[DlpJobType, str]]=..., state: _Optional[_Union[DlpJob.JobState, str]]=..., risk_details: _Optional[_Union[AnalyzeDataSourceRiskDetails, _Mapping]]=..., inspect_details: _Optional[_Union[InspectDataSourceDetails, _Mapping]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., start_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., end_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., last_modified: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., job_trigger_name: _Optional[str]=..., errors: _Optional[_Iterable[_Union[Error, _Mapping]]]=..., action_details: _Optional[_Iterable[_Union[ActionDetails, _Mapping]]]=...) -> None:
        ...

class GetDlpJobRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListDlpJobsRequest(_message.Message):
    __slots__ = ('parent', 'filter', 'page_size', 'page_token', 'type', 'order_by', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    filter: str
    page_size: int
    page_token: str
    type: DlpJobType
    order_by: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., filter: _Optional[str]=..., page_size: _Optional[int]=..., page_token: _Optional[str]=..., type: _Optional[_Union[DlpJobType, str]]=..., order_by: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ListDlpJobsResponse(_message.Message):
    __slots__ = ('jobs', 'next_page_token')
    JOBS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    jobs: _containers.RepeatedCompositeFieldContainer[DlpJob]
    next_page_token: str

    def __init__(self, jobs: _Optional[_Iterable[_Union[DlpJob, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class CancelDlpJobRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class FinishDlpJobRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class DeleteDlpJobRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class CreateDeidentifyTemplateRequest(_message.Message):
    __slots__ = ('parent', 'deidentify_template', 'template_id', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    DEIDENTIFY_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    TEMPLATE_ID_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    deidentify_template: DeidentifyTemplate
    template_id: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., deidentify_template: _Optional[_Union[DeidentifyTemplate, _Mapping]]=..., template_id: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class UpdateDeidentifyTemplateRequest(_message.Message):
    __slots__ = ('name', 'deidentify_template', 'update_mask')
    NAME_FIELD_NUMBER: _ClassVar[int]
    DEIDENTIFY_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    name: str
    deidentify_template: DeidentifyTemplate
    update_mask: _field_mask_pb2.FieldMask

    def __init__(self, name: _Optional[str]=..., deidentify_template: _Optional[_Union[DeidentifyTemplate, _Mapping]]=..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]]=...) -> None:
        ...

class GetDeidentifyTemplateRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListDeidentifyTemplatesRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ListDeidentifyTemplatesResponse(_message.Message):
    __slots__ = ('deidentify_templates', 'next_page_token')
    DEIDENTIFY_TEMPLATES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    deidentify_templates: _containers.RepeatedCompositeFieldContainer[DeidentifyTemplate]
    next_page_token: str

    def __init__(self, deidentify_templates: _Optional[_Iterable[_Union[DeidentifyTemplate, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class DeleteDeidentifyTemplateRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class LargeCustomDictionaryConfig(_message.Message):
    __slots__ = ('output_path', 'cloud_storage_file_set', 'big_query_field')
    OUTPUT_PATH_FIELD_NUMBER: _ClassVar[int]
    CLOUD_STORAGE_FILE_SET_FIELD_NUMBER: _ClassVar[int]
    BIG_QUERY_FIELD_FIELD_NUMBER: _ClassVar[int]
    output_path: _storage_pb2.CloudStoragePath
    cloud_storage_file_set: _storage_pb2.CloudStorageFileSet
    big_query_field: _storage_pb2.BigQueryField

    def __init__(self, output_path: _Optional[_Union[_storage_pb2.CloudStoragePath, _Mapping]]=..., cloud_storage_file_set: _Optional[_Union[_storage_pb2.CloudStorageFileSet, _Mapping]]=..., big_query_field: _Optional[_Union[_storage_pb2.BigQueryField, _Mapping]]=...) -> None:
        ...

class LargeCustomDictionaryStats(_message.Message):
    __slots__ = ('approx_num_phrases',)
    APPROX_NUM_PHRASES_FIELD_NUMBER: _ClassVar[int]
    approx_num_phrases: int

    def __init__(self, approx_num_phrases: _Optional[int]=...) -> None:
        ...

class StoredInfoTypeConfig(_message.Message):
    __slots__ = ('display_name', 'description', 'large_custom_dictionary', 'dictionary', 'regex')
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    LARGE_CUSTOM_DICTIONARY_FIELD_NUMBER: _ClassVar[int]
    DICTIONARY_FIELD_NUMBER: _ClassVar[int]
    REGEX_FIELD_NUMBER: _ClassVar[int]
    display_name: str
    description: str
    large_custom_dictionary: LargeCustomDictionaryConfig
    dictionary: _storage_pb2.CustomInfoType.Dictionary
    regex: _storage_pb2.CustomInfoType.Regex

    def __init__(self, display_name: _Optional[str]=..., description: _Optional[str]=..., large_custom_dictionary: _Optional[_Union[LargeCustomDictionaryConfig, _Mapping]]=..., dictionary: _Optional[_Union[_storage_pb2.CustomInfoType.Dictionary, _Mapping]]=..., regex: _Optional[_Union[_storage_pb2.CustomInfoType.Regex, _Mapping]]=...) -> None:
        ...

class StoredInfoTypeStats(_message.Message):
    __slots__ = ('large_custom_dictionary',)
    LARGE_CUSTOM_DICTIONARY_FIELD_NUMBER: _ClassVar[int]
    large_custom_dictionary: LargeCustomDictionaryStats

    def __init__(self, large_custom_dictionary: _Optional[_Union[LargeCustomDictionaryStats, _Mapping]]=...) -> None:
        ...

class StoredInfoTypeVersion(_message.Message):
    __slots__ = ('config', 'create_time', 'state', 'errors', 'stats')
    CONFIG_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    STATS_FIELD_NUMBER: _ClassVar[int]
    config: StoredInfoTypeConfig
    create_time: _timestamp_pb2.Timestamp
    state: StoredInfoTypeState
    errors: _containers.RepeatedCompositeFieldContainer[Error]
    stats: StoredInfoTypeStats

    def __init__(self, config: _Optional[_Union[StoredInfoTypeConfig, _Mapping]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., state: _Optional[_Union[StoredInfoTypeState, str]]=..., errors: _Optional[_Iterable[_Union[Error, _Mapping]]]=..., stats: _Optional[_Union[StoredInfoTypeStats, _Mapping]]=...) -> None:
        ...

class StoredInfoType(_message.Message):
    __slots__ = ('name', 'current_version', 'pending_versions')
    NAME_FIELD_NUMBER: _ClassVar[int]
    CURRENT_VERSION_FIELD_NUMBER: _ClassVar[int]
    PENDING_VERSIONS_FIELD_NUMBER: _ClassVar[int]
    name: str
    current_version: StoredInfoTypeVersion
    pending_versions: _containers.RepeatedCompositeFieldContainer[StoredInfoTypeVersion]

    def __init__(self, name: _Optional[str]=..., current_version: _Optional[_Union[StoredInfoTypeVersion, _Mapping]]=..., pending_versions: _Optional[_Iterable[_Union[StoredInfoTypeVersion, _Mapping]]]=...) -> None:
        ...

class CreateStoredInfoTypeRequest(_message.Message):
    __slots__ = ('parent', 'config', 'stored_info_type_id', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    CONFIG_FIELD_NUMBER: _ClassVar[int]
    STORED_INFO_TYPE_ID_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    config: StoredInfoTypeConfig
    stored_info_type_id: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., config: _Optional[_Union[StoredInfoTypeConfig, _Mapping]]=..., stored_info_type_id: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class UpdateStoredInfoTypeRequest(_message.Message):
    __slots__ = ('name', 'config', 'update_mask')
    NAME_FIELD_NUMBER: _ClassVar[int]
    CONFIG_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    name: str
    config: StoredInfoTypeConfig
    update_mask: _field_mask_pb2.FieldMask

    def __init__(self, name: _Optional[str]=..., config: _Optional[_Union[StoredInfoTypeConfig, _Mapping]]=..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]]=...) -> None:
        ...

class GetStoredInfoTypeRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListStoredInfoTypesRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'location_id')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    LOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    location_id: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., location_id: _Optional[str]=...) -> None:
        ...

class ListStoredInfoTypesResponse(_message.Message):
    __slots__ = ('stored_info_types', 'next_page_token')
    STORED_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    stored_info_types: _containers.RepeatedCompositeFieldContainer[StoredInfoType]
    next_page_token: str

    def __init__(self, stored_info_types: _Optional[_Iterable[_Union[StoredInfoType, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class DeleteStoredInfoTypeRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class HybridInspectJobTriggerRequest(_message.Message):
    __slots__ = ('name', 'hybrid_item')
    NAME_FIELD_NUMBER: _ClassVar[int]
    HYBRID_ITEM_FIELD_NUMBER: _ClassVar[int]
    name: str
    hybrid_item: HybridContentItem

    def __init__(self, name: _Optional[str]=..., hybrid_item: _Optional[_Union[HybridContentItem, _Mapping]]=...) -> None:
        ...

class HybridInspectDlpJobRequest(_message.Message):
    __slots__ = ('name', 'hybrid_item')
    NAME_FIELD_NUMBER: _ClassVar[int]
    HYBRID_ITEM_FIELD_NUMBER: _ClassVar[int]
    name: str
    hybrid_item: HybridContentItem

    def __init__(self, name: _Optional[str]=..., hybrid_item: _Optional[_Union[HybridContentItem, _Mapping]]=...) -> None:
        ...

class HybridContentItem(_message.Message):
    __slots__ = ('item', 'finding_details')
    ITEM_FIELD_NUMBER: _ClassVar[int]
    FINDING_DETAILS_FIELD_NUMBER: _ClassVar[int]
    item: ContentItem
    finding_details: HybridFindingDetails

    def __init__(self, item: _Optional[_Union[ContentItem, _Mapping]]=..., finding_details: _Optional[_Union[HybridFindingDetails, _Mapping]]=...) -> None:
        ...

class HybridFindingDetails(_message.Message):
    __slots__ = ('container_details', 'file_offset', 'row_offset', 'table_options', 'labels')

    class LabelsEntry(_message.Message):
        __slots__ = ('key', 'value')
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str

        def __init__(self, key: _Optional[str]=..., value: _Optional[str]=...) -> None:
            ...
    CONTAINER_DETAILS_FIELD_NUMBER: _ClassVar[int]
    FILE_OFFSET_FIELD_NUMBER: _ClassVar[int]
    ROW_OFFSET_FIELD_NUMBER: _ClassVar[int]
    TABLE_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    container_details: Container
    file_offset: int
    row_offset: int
    table_options: _storage_pb2.TableOptions
    labels: _containers.ScalarMap[str, str]

    def __init__(self, container_details: _Optional[_Union[Container, _Mapping]]=..., file_offset: _Optional[int]=..., row_offset: _Optional[int]=..., table_options: _Optional[_Union[_storage_pb2.TableOptions, _Mapping]]=..., labels: _Optional[_Mapping[str, str]]=...) -> None:
        ...

class HybridInspectResponse(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class ListProjectDataProfilesRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'filter')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    filter: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., filter: _Optional[str]=...) -> None:
        ...

class ListProjectDataProfilesResponse(_message.Message):
    __slots__ = ('project_data_profiles', 'next_page_token')
    PROJECT_DATA_PROFILES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    project_data_profiles: _containers.RepeatedCompositeFieldContainer[ProjectDataProfile]
    next_page_token: str

    def __init__(self, project_data_profiles: _Optional[_Iterable[_Union[ProjectDataProfile, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class ListTableDataProfilesRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'filter')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    filter: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., filter: _Optional[str]=...) -> None:
        ...

class ListTableDataProfilesResponse(_message.Message):
    __slots__ = ('table_data_profiles', 'next_page_token')
    TABLE_DATA_PROFILES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    table_data_profiles: _containers.RepeatedCompositeFieldContainer[TableDataProfile]
    next_page_token: str

    def __init__(self, table_data_profiles: _Optional[_Iterable[_Union[TableDataProfile, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class ListColumnDataProfilesRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'filter')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    filter: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., filter: _Optional[str]=...) -> None:
        ...

class ListColumnDataProfilesResponse(_message.Message):
    __slots__ = ('column_data_profiles', 'next_page_token')
    COLUMN_DATA_PROFILES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    column_data_profiles: _containers.RepeatedCompositeFieldContainer[ColumnDataProfile]
    next_page_token: str

    def __init__(self, column_data_profiles: _Optional[_Iterable[_Union[ColumnDataProfile, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class DataRiskLevel(_message.Message):
    __slots__ = ('score',)

    class DataRiskLevelScore(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        RISK_SCORE_UNSPECIFIED: _ClassVar[DataRiskLevel.DataRiskLevelScore]
        RISK_LOW: _ClassVar[DataRiskLevel.DataRiskLevelScore]
        RISK_UNKNOWN: _ClassVar[DataRiskLevel.DataRiskLevelScore]
        RISK_MODERATE: _ClassVar[DataRiskLevel.DataRiskLevelScore]
        RISK_HIGH: _ClassVar[DataRiskLevel.DataRiskLevelScore]
    RISK_SCORE_UNSPECIFIED: DataRiskLevel.DataRiskLevelScore
    RISK_LOW: DataRiskLevel.DataRiskLevelScore
    RISK_UNKNOWN: DataRiskLevel.DataRiskLevelScore
    RISK_MODERATE: DataRiskLevel.DataRiskLevelScore
    RISK_HIGH: DataRiskLevel.DataRiskLevelScore
    SCORE_FIELD_NUMBER: _ClassVar[int]
    score: DataRiskLevel.DataRiskLevelScore

    def __init__(self, score: _Optional[_Union[DataRiskLevel.DataRiskLevelScore, str]]=...) -> None:
        ...

class ProjectDataProfile(_message.Message):
    __slots__ = ('name', 'project_id', 'profile_last_generated', 'sensitivity_score', 'data_risk_level', 'profile_status', 'table_data_profile_count', 'file_store_data_profile_count')
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    PROFILE_LAST_GENERATED_FIELD_NUMBER: _ClassVar[int]
    SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
    DATA_RISK_LEVEL_FIELD_NUMBER: _ClassVar[int]
    PROFILE_STATUS_FIELD_NUMBER: _ClassVar[int]
    TABLE_DATA_PROFILE_COUNT_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_DATA_PROFILE_COUNT_FIELD_NUMBER: _ClassVar[int]
    name: str
    project_id: str
    profile_last_generated: _timestamp_pb2.Timestamp
    sensitivity_score: _storage_pb2.SensitivityScore
    data_risk_level: DataRiskLevel
    profile_status: ProfileStatus
    table_data_profile_count: int
    file_store_data_profile_count: int

    def __init__(self, name: _Optional[str]=..., project_id: _Optional[str]=..., profile_last_generated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., sensitivity_score: _Optional[_Union[_storage_pb2.SensitivityScore, _Mapping]]=..., data_risk_level: _Optional[_Union[DataRiskLevel, _Mapping]]=..., profile_status: _Optional[_Union[ProfileStatus, _Mapping]]=..., table_data_profile_count: _Optional[int]=..., file_store_data_profile_count: _Optional[int]=...) -> None:
        ...

class DataProfileConfigSnapshot(_message.Message):
    __slots__ = ('inspect_config', 'data_profile_job', 'discovery_config', 'inspect_template_name', 'inspect_template_modified_time')
    INSPECT_CONFIG_FIELD_NUMBER: _ClassVar[int]
    DATA_PROFILE_JOB_FIELD_NUMBER: _ClassVar[int]
    DISCOVERY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_NAME_FIELD_NUMBER: _ClassVar[int]
    INSPECT_TEMPLATE_MODIFIED_TIME_FIELD_NUMBER: _ClassVar[int]
    inspect_config: InspectConfig
    data_profile_job: DataProfileJobConfig
    discovery_config: DiscoveryConfig
    inspect_template_name: str
    inspect_template_modified_time: _timestamp_pb2.Timestamp

    def __init__(self, inspect_config: _Optional[_Union[InspectConfig, _Mapping]]=..., data_profile_job: _Optional[_Union[DataProfileJobConfig, _Mapping]]=..., discovery_config: _Optional[_Union[DiscoveryConfig, _Mapping]]=..., inspect_template_name: _Optional[str]=..., inspect_template_modified_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=...) -> None:
        ...

class TableDataProfile(_message.Message):
    __slots__ = ('name', 'data_source_type', 'project_data_profile', 'dataset_project_id', 'dataset_location', 'dataset_id', 'table_id', 'full_resource', 'profile_status', 'state', 'sensitivity_score', 'data_risk_level', 'predicted_info_types', 'other_info_types', 'config_snapshot', 'last_modified_time', 'expiration_time', 'scanned_column_count', 'failed_column_count', 'table_size_bytes', 'row_count', 'encryption_status', 'resource_visibility', 'profile_last_generated', 'resource_labels', 'create_time')

    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        STATE_UNSPECIFIED: _ClassVar[TableDataProfile.State]
        RUNNING: _ClassVar[TableDataProfile.State]
        DONE: _ClassVar[TableDataProfile.State]
    STATE_UNSPECIFIED: TableDataProfile.State
    RUNNING: TableDataProfile.State
    DONE: TableDataProfile.State

    class ResourceLabelsEntry(_message.Message):
        __slots__ = ('key', 'value')
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str

        def __init__(self, key: _Optional[str]=..., value: _Optional[str]=...) -> None:
            ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    DATA_SOURCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_DATA_PROFILE_FIELD_NUMBER: _ClassVar[int]
    DATASET_PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    DATASET_LOCATION_FIELD_NUMBER: _ClassVar[int]
    DATASET_ID_FIELD_NUMBER: _ClassVar[int]
    TABLE_ID_FIELD_NUMBER: _ClassVar[int]
    FULL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROFILE_STATUS_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
    DATA_RISK_LEVEL_FIELD_NUMBER: _ClassVar[int]
    PREDICTED_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    OTHER_INFO_TYPES_FIELD_NUMBER: _ClassVar[int]
    CONFIG_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    LAST_MODIFIED_TIME_FIELD_NUMBER: _ClassVar[int]
    EXPIRATION_TIME_FIELD_NUMBER: _ClassVar[int]
    SCANNED_COLUMN_COUNT_FIELD_NUMBER: _ClassVar[int]
    FAILED_COLUMN_COUNT_FIELD_NUMBER: _ClassVar[int]
    TABLE_SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    ROW_COUNT_FIELD_NUMBER: _ClassVar[int]
    ENCRYPTION_STATUS_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_VISIBILITY_FIELD_NUMBER: _ClassVar[int]
    PROFILE_LAST_GENERATED_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_LABELS_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    name: str
    data_source_type: DataSourceType
    project_data_profile: str
    dataset_project_id: str
    dataset_location: str
    dataset_id: str
    table_id: str
    full_resource: str
    profile_status: ProfileStatus
    state: TableDataProfile.State
    sensitivity_score: _storage_pb2.SensitivityScore
    data_risk_level: DataRiskLevel
    predicted_info_types: _containers.RepeatedCompositeFieldContainer[InfoTypeSummary]
    other_info_types: _containers.RepeatedCompositeFieldContainer[OtherInfoTypeSummary]
    config_snapshot: DataProfileConfigSnapshot
    last_modified_time: _timestamp_pb2.Timestamp
    expiration_time: _timestamp_pb2.Timestamp
    scanned_column_count: int
    failed_column_count: int
    table_size_bytes: int
    row_count: int
    encryption_status: EncryptionStatus
    resource_visibility: ResourceVisibility
    profile_last_generated: _timestamp_pb2.Timestamp
    resource_labels: _containers.ScalarMap[str, str]
    create_time: _timestamp_pb2.Timestamp

    def __init__(self, name: _Optional[str]=..., data_source_type: _Optional[_Union[DataSourceType, _Mapping]]=..., project_data_profile: _Optional[str]=..., dataset_project_id: _Optional[str]=..., dataset_location: _Optional[str]=..., dataset_id: _Optional[str]=..., table_id: _Optional[str]=..., full_resource: _Optional[str]=..., profile_status: _Optional[_Union[ProfileStatus, _Mapping]]=..., state: _Optional[_Union[TableDataProfile.State, str]]=..., sensitivity_score: _Optional[_Union[_storage_pb2.SensitivityScore, _Mapping]]=..., data_risk_level: _Optional[_Union[DataRiskLevel, _Mapping]]=..., predicted_info_types: _Optional[_Iterable[_Union[InfoTypeSummary, _Mapping]]]=..., other_info_types: _Optional[_Iterable[_Union[OtherInfoTypeSummary, _Mapping]]]=..., config_snapshot: _Optional[_Union[DataProfileConfigSnapshot, _Mapping]]=..., last_modified_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., expiration_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., scanned_column_count: _Optional[int]=..., failed_column_count: _Optional[int]=..., table_size_bytes: _Optional[int]=..., row_count: _Optional[int]=..., encryption_status: _Optional[_Union[EncryptionStatus, str]]=..., resource_visibility: _Optional[_Union[ResourceVisibility, str]]=..., profile_last_generated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., resource_labels: _Optional[_Mapping[str, str]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=...) -> None:
        ...

class ProfileStatus(_message.Message):
    __slots__ = ('status', 'timestamp')
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    status: _status_pb2.Status
    timestamp: _timestamp_pb2.Timestamp

    def __init__(self, status: _Optional[_Union[_status_pb2.Status, _Mapping]]=..., timestamp: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=...) -> None:
        ...

class InfoTypeSummary(_message.Message):
    __slots__ = ('info_type', 'estimated_prevalence')
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    ESTIMATED_PREVALENCE_FIELD_NUMBER: _ClassVar[int]
    info_type: _storage_pb2.InfoType
    estimated_prevalence: int

    def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., estimated_prevalence: _Optional[int]=...) -> None:
        ...

class OtherInfoTypeSummary(_message.Message):
    __slots__ = ('info_type', 'estimated_prevalence', 'excluded_from_analysis')
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    ESTIMATED_PREVALENCE_FIELD_NUMBER: _ClassVar[int]
    EXCLUDED_FROM_ANALYSIS_FIELD_NUMBER: _ClassVar[int]
    info_type: _storage_pb2.InfoType
    estimated_prevalence: int
    excluded_from_analysis: bool

    def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=..., estimated_prevalence: _Optional[int]=..., excluded_from_analysis: bool=...) -> None:
        ...

class ColumnDataProfile(_message.Message):
    __slots__ = ('name', 'profile_status', 'state', 'profile_last_generated', 'table_data_profile', 'table_full_resource', 'dataset_project_id', 'dataset_location', 'dataset_id', 'table_id', 'column', 'sensitivity_score', 'data_risk_level', 'column_info_type', 'other_matches', 'estimated_null_percentage', 'estimated_uniqueness_score', 'free_text_score', 'column_type', 'policy_state')

    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        STATE_UNSPECIFIED: _ClassVar[ColumnDataProfile.State]
        RUNNING: _ClassVar[ColumnDataProfile.State]
        DONE: _ClassVar[ColumnDataProfile.State]
    STATE_UNSPECIFIED: ColumnDataProfile.State
    RUNNING: ColumnDataProfile.State
    DONE: ColumnDataProfile.State

    class ColumnDataType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        COLUMN_DATA_TYPE_UNSPECIFIED: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_INT64: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_BOOL: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_FLOAT64: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_STRING: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_BYTES: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_TIMESTAMP: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_DATE: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_TIME: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_DATETIME: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_GEOGRAPHY: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_NUMERIC: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_RECORD: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_BIGNUMERIC: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_JSON: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_INTERVAL: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_RANGE_DATE: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_RANGE_DATETIME: _ClassVar[ColumnDataProfile.ColumnDataType]
        TYPE_RANGE_TIMESTAMP: _ClassVar[ColumnDataProfile.ColumnDataType]
    COLUMN_DATA_TYPE_UNSPECIFIED: ColumnDataProfile.ColumnDataType
    TYPE_INT64: ColumnDataProfile.ColumnDataType
    TYPE_BOOL: ColumnDataProfile.ColumnDataType
    TYPE_FLOAT64: ColumnDataProfile.ColumnDataType
    TYPE_STRING: ColumnDataProfile.ColumnDataType
    TYPE_BYTES: ColumnDataProfile.ColumnDataType
    TYPE_TIMESTAMP: ColumnDataProfile.ColumnDataType
    TYPE_DATE: ColumnDataProfile.ColumnDataType
    TYPE_TIME: ColumnDataProfile.ColumnDataType
    TYPE_DATETIME: ColumnDataProfile.ColumnDataType
    TYPE_GEOGRAPHY: ColumnDataProfile.ColumnDataType
    TYPE_NUMERIC: ColumnDataProfile.ColumnDataType
    TYPE_RECORD: ColumnDataProfile.ColumnDataType
    TYPE_BIGNUMERIC: ColumnDataProfile.ColumnDataType
    TYPE_JSON: ColumnDataProfile.ColumnDataType
    TYPE_INTERVAL: ColumnDataProfile.ColumnDataType
    TYPE_RANGE_DATE: ColumnDataProfile.ColumnDataType
    TYPE_RANGE_DATETIME: ColumnDataProfile.ColumnDataType
    TYPE_RANGE_TIMESTAMP: ColumnDataProfile.ColumnDataType

    class ColumnPolicyState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        COLUMN_POLICY_STATE_UNSPECIFIED: _ClassVar[ColumnDataProfile.ColumnPolicyState]
        COLUMN_POLICY_TAGGED: _ClassVar[ColumnDataProfile.ColumnPolicyState]
    COLUMN_POLICY_STATE_UNSPECIFIED: ColumnDataProfile.ColumnPolicyState
    COLUMN_POLICY_TAGGED: ColumnDataProfile.ColumnPolicyState
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROFILE_STATUS_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    PROFILE_LAST_GENERATED_FIELD_NUMBER: _ClassVar[int]
    TABLE_DATA_PROFILE_FIELD_NUMBER: _ClassVar[int]
    TABLE_FULL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    DATASET_PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    DATASET_LOCATION_FIELD_NUMBER: _ClassVar[int]
    DATASET_ID_FIELD_NUMBER: _ClassVar[int]
    TABLE_ID_FIELD_NUMBER: _ClassVar[int]
    COLUMN_FIELD_NUMBER: _ClassVar[int]
    SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
    DATA_RISK_LEVEL_FIELD_NUMBER: _ClassVar[int]
    COLUMN_INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    OTHER_MATCHES_FIELD_NUMBER: _ClassVar[int]
    ESTIMATED_NULL_PERCENTAGE_FIELD_NUMBER: _ClassVar[int]
    ESTIMATED_UNIQUENESS_SCORE_FIELD_NUMBER: _ClassVar[int]
    FREE_TEXT_SCORE_FIELD_NUMBER: _ClassVar[int]
    COLUMN_TYPE_FIELD_NUMBER: _ClassVar[int]
    POLICY_STATE_FIELD_NUMBER: _ClassVar[int]
    name: str
    profile_status: ProfileStatus
    state: ColumnDataProfile.State
    profile_last_generated: _timestamp_pb2.Timestamp
    table_data_profile: str
    table_full_resource: str
    dataset_project_id: str
    dataset_location: str
    dataset_id: str
    table_id: str
    column: str
    sensitivity_score: _storage_pb2.SensitivityScore
    data_risk_level: DataRiskLevel
    column_info_type: InfoTypeSummary
    other_matches: _containers.RepeatedCompositeFieldContainer[OtherInfoTypeSummary]
    estimated_null_percentage: NullPercentageLevel
    estimated_uniqueness_score: UniquenessScoreLevel
    free_text_score: float
    column_type: ColumnDataProfile.ColumnDataType
    policy_state: ColumnDataProfile.ColumnPolicyState

    def __init__(self, name: _Optional[str]=..., profile_status: _Optional[_Union[ProfileStatus, _Mapping]]=..., state: _Optional[_Union[ColumnDataProfile.State, str]]=..., profile_last_generated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., table_data_profile: _Optional[str]=..., table_full_resource: _Optional[str]=..., dataset_project_id: _Optional[str]=..., dataset_location: _Optional[str]=..., dataset_id: _Optional[str]=..., table_id: _Optional[str]=..., column: _Optional[str]=..., sensitivity_score: _Optional[_Union[_storage_pb2.SensitivityScore, _Mapping]]=..., data_risk_level: _Optional[_Union[DataRiskLevel, _Mapping]]=..., column_info_type: _Optional[_Union[InfoTypeSummary, _Mapping]]=..., other_matches: _Optional[_Iterable[_Union[OtherInfoTypeSummary, _Mapping]]]=..., estimated_null_percentage: _Optional[_Union[NullPercentageLevel, str]]=..., estimated_uniqueness_score: _Optional[_Union[UniquenessScoreLevel, str]]=..., free_text_score: _Optional[float]=..., column_type: _Optional[_Union[ColumnDataProfile.ColumnDataType, str]]=..., policy_state: _Optional[_Union[ColumnDataProfile.ColumnPolicyState, str]]=...) -> None:
        ...

class FileStoreDataProfile(_message.Message):
    __slots__ = ('name', 'data_source_type', 'project_data_profile', 'project_id', 'file_store_location', 'data_storage_locations', 'location_type', 'file_store_path', 'full_resource', 'config_snapshot', 'profile_status', 'state', 'profile_last_generated', 'resource_visibility', 'sensitivity_score', 'data_risk_level', 'create_time', 'last_modified_time', 'file_cluster_summaries', 'resource_attributes', 'resource_labels', 'file_store_info_type_summaries', 'file_store_is_empty')

    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        STATE_UNSPECIFIED: _ClassVar[FileStoreDataProfile.State]
        RUNNING: _ClassVar[FileStoreDataProfile.State]
        DONE: _ClassVar[FileStoreDataProfile.State]
    STATE_UNSPECIFIED: FileStoreDataProfile.State
    RUNNING: FileStoreDataProfile.State
    DONE: FileStoreDataProfile.State

    class ResourceAttributesEntry(_message.Message):
        __slots__ = ('key', 'value')
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: Value

        def __init__(self, key: _Optional[str]=..., value: _Optional[_Union[Value, _Mapping]]=...) -> None:
            ...

    class ResourceLabelsEntry(_message.Message):
        __slots__ = ('key', 'value')
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str

        def __init__(self, key: _Optional[str]=..., value: _Optional[str]=...) -> None:
            ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    DATA_SOURCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_DATA_PROFILE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_LOCATION_FIELD_NUMBER: _ClassVar[int]
    DATA_STORAGE_LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    LOCATION_TYPE_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_PATH_FIELD_NUMBER: _ClassVar[int]
    FULL_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    CONFIG_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
    PROFILE_STATUS_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    PROFILE_LAST_GENERATED_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_VISIBILITY_FIELD_NUMBER: _ClassVar[int]
    SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
    DATA_RISK_LEVEL_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    LAST_MODIFIED_TIME_FIELD_NUMBER: _ClassVar[int]
    FILE_CLUSTER_SUMMARIES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_LABELS_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_INFO_TYPE_SUMMARIES_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_IS_EMPTY_FIELD_NUMBER: _ClassVar[int]
    name: str
    data_source_type: DataSourceType
    project_data_profile: str
    project_id: str
    file_store_location: str
    data_storage_locations: _containers.RepeatedScalarFieldContainer[str]
    location_type: str
    file_store_path: str
    full_resource: str
    config_snapshot: DataProfileConfigSnapshot
    profile_status: ProfileStatus
    state: FileStoreDataProfile.State
    profile_last_generated: _timestamp_pb2.Timestamp
    resource_visibility: ResourceVisibility
    sensitivity_score: _storage_pb2.SensitivityScore
    data_risk_level: DataRiskLevel
    create_time: _timestamp_pb2.Timestamp
    last_modified_time: _timestamp_pb2.Timestamp
    file_cluster_summaries: _containers.RepeatedCompositeFieldContainer[FileClusterSummary]
    resource_attributes: _containers.MessageMap[str, Value]
    resource_labels: _containers.ScalarMap[str, str]
    file_store_info_type_summaries: _containers.RepeatedCompositeFieldContainer[FileStoreInfoTypeSummary]
    file_store_is_empty: bool

    def __init__(self, name: _Optional[str]=..., data_source_type: _Optional[_Union[DataSourceType, _Mapping]]=..., project_data_profile: _Optional[str]=..., project_id: _Optional[str]=..., file_store_location: _Optional[str]=..., data_storage_locations: _Optional[_Iterable[str]]=..., location_type: _Optional[str]=..., file_store_path: _Optional[str]=..., full_resource: _Optional[str]=..., config_snapshot: _Optional[_Union[DataProfileConfigSnapshot, _Mapping]]=..., profile_status: _Optional[_Union[ProfileStatus, _Mapping]]=..., state: _Optional[_Union[FileStoreDataProfile.State, str]]=..., profile_last_generated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., resource_visibility: _Optional[_Union[ResourceVisibility, str]]=..., sensitivity_score: _Optional[_Union[_storage_pb2.SensitivityScore, _Mapping]]=..., data_risk_level: _Optional[_Union[DataRiskLevel, _Mapping]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., last_modified_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., file_cluster_summaries: _Optional[_Iterable[_Union[FileClusterSummary, _Mapping]]]=..., resource_attributes: _Optional[_Mapping[str, Value]]=..., resource_labels: _Optional[_Mapping[str, str]]=..., file_store_info_type_summaries: _Optional[_Iterable[_Union[FileStoreInfoTypeSummary, _Mapping]]]=..., file_store_is_empty: bool=...) -> None:
        ...

class FileStoreInfoTypeSummary(_message.Message):
    __slots__ = ('info_type',)
    INFO_TYPE_FIELD_NUMBER: _ClassVar[int]
    info_type: _storage_pb2.InfoType

    def __init__(self, info_type: _Optional[_Union[_storage_pb2.InfoType, _Mapping]]=...) -> None:
        ...

class FileExtensionInfo(_message.Message):
    __slots__ = ('file_extension',)
    FILE_EXTENSION_FIELD_NUMBER: _ClassVar[int]
    file_extension: str

    def __init__(self, file_extension: _Optional[str]=...) -> None:
        ...

class FileClusterSummary(_message.Message):
    __slots__ = ('file_cluster_type', 'file_store_info_type_summaries', 'sensitivity_score', 'data_risk_level', 'errors', 'file_extensions_scanned', 'file_extensions_seen', 'no_files_exist')
    FILE_CLUSTER_TYPE_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_INFO_TYPE_SUMMARIES_FIELD_NUMBER: _ClassVar[int]
    SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
    DATA_RISK_LEVEL_FIELD_NUMBER: _ClassVar[int]
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    FILE_EXTENSIONS_SCANNED_FIELD_NUMBER: _ClassVar[int]
    FILE_EXTENSIONS_SEEN_FIELD_NUMBER: _ClassVar[int]
    NO_FILES_EXIST_FIELD_NUMBER: _ClassVar[int]
    file_cluster_type: FileClusterType
    file_store_info_type_summaries: _containers.RepeatedCompositeFieldContainer[FileStoreInfoTypeSummary]
    sensitivity_score: _storage_pb2.SensitivityScore
    data_risk_level: DataRiskLevel
    errors: _containers.RepeatedCompositeFieldContainer[Error]
    file_extensions_scanned: _containers.RepeatedCompositeFieldContainer[FileExtensionInfo]
    file_extensions_seen: _containers.RepeatedCompositeFieldContainer[FileExtensionInfo]
    no_files_exist: bool

    def __init__(self, file_cluster_type: _Optional[_Union[FileClusterType, _Mapping]]=..., file_store_info_type_summaries: _Optional[_Iterable[_Union[FileStoreInfoTypeSummary, _Mapping]]]=..., sensitivity_score: _Optional[_Union[_storage_pb2.SensitivityScore, _Mapping]]=..., data_risk_level: _Optional[_Union[DataRiskLevel, _Mapping]]=..., errors: _Optional[_Iterable[_Union[Error, _Mapping]]]=..., file_extensions_scanned: _Optional[_Iterable[_Union[FileExtensionInfo, _Mapping]]]=..., file_extensions_seen: _Optional[_Iterable[_Union[FileExtensionInfo, _Mapping]]]=..., no_files_exist: bool=...) -> None:
        ...

class GetProjectDataProfileRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class GetFileStoreDataProfileRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListFileStoreDataProfilesRequest(_message.Message):
    __slots__ = ('parent', 'page_token', 'page_size', 'order_by', 'filter')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_token: str
    page_size: int
    order_by: str
    filter: str

    def __init__(self, parent: _Optional[str]=..., page_token: _Optional[str]=..., page_size: _Optional[int]=..., order_by: _Optional[str]=..., filter: _Optional[str]=...) -> None:
        ...

class ListFileStoreDataProfilesResponse(_message.Message):
    __slots__ = ('file_store_data_profiles', 'next_page_token')
    FILE_STORE_DATA_PROFILES_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    file_store_data_profiles: _containers.RepeatedCompositeFieldContainer[FileStoreDataProfile]
    next_page_token: str

    def __init__(self, file_store_data_profiles: _Optional[_Iterable[_Union[FileStoreDataProfile, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class DeleteFileStoreDataProfileRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class GetTableDataProfileRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class GetColumnDataProfileRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class DataProfilePubSubCondition(_message.Message):
    __slots__ = ('expressions',)

    class ProfileScoreBucket(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        PROFILE_SCORE_BUCKET_UNSPECIFIED: _ClassVar[DataProfilePubSubCondition.ProfileScoreBucket]
        HIGH: _ClassVar[DataProfilePubSubCondition.ProfileScoreBucket]
        MEDIUM_OR_HIGH: _ClassVar[DataProfilePubSubCondition.ProfileScoreBucket]
    PROFILE_SCORE_BUCKET_UNSPECIFIED: DataProfilePubSubCondition.ProfileScoreBucket
    HIGH: DataProfilePubSubCondition.ProfileScoreBucket
    MEDIUM_OR_HIGH: DataProfilePubSubCondition.ProfileScoreBucket

    class PubSubCondition(_message.Message):
        __slots__ = ('minimum_risk_score', 'minimum_sensitivity_score')
        MINIMUM_RISK_SCORE_FIELD_NUMBER: _ClassVar[int]
        MINIMUM_SENSITIVITY_SCORE_FIELD_NUMBER: _ClassVar[int]
        minimum_risk_score: DataProfilePubSubCondition.ProfileScoreBucket
        minimum_sensitivity_score: DataProfilePubSubCondition.ProfileScoreBucket

        def __init__(self, minimum_risk_score: _Optional[_Union[DataProfilePubSubCondition.ProfileScoreBucket, str]]=..., minimum_sensitivity_score: _Optional[_Union[DataProfilePubSubCondition.ProfileScoreBucket, str]]=...) -> None:
            ...

    class PubSubExpressions(_message.Message):
        __slots__ = ('logical_operator', 'conditions')

        class PubSubLogicalOperator(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            LOGICAL_OPERATOR_UNSPECIFIED: _ClassVar[DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator]
            OR: _ClassVar[DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator]
            AND: _ClassVar[DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator]
        LOGICAL_OPERATOR_UNSPECIFIED: DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator
        OR: DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator
        AND: DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator
        LOGICAL_OPERATOR_FIELD_NUMBER: _ClassVar[int]
        CONDITIONS_FIELD_NUMBER: _ClassVar[int]
        logical_operator: DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator
        conditions: _containers.RepeatedCompositeFieldContainer[DataProfilePubSubCondition.PubSubCondition]

        def __init__(self, logical_operator: _Optional[_Union[DataProfilePubSubCondition.PubSubExpressions.PubSubLogicalOperator, str]]=..., conditions: _Optional[_Iterable[_Union[DataProfilePubSubCondition.PubSubCondition, _Mapping]]]=...) -> None:
            ...
    EXPRESSIONS_FIELD_NUMBER: _ClassVar[int]
    expressions: DataProfilePubSubCondition.PubSubExpressions

    def __init__(self, expressions: _Optional[_Union[DataProfilePubSubCondition.PubSubExpressions, _Mapping]]=...) -> None:
        ...

class DataProfilePubSubMessage(_message.Message):
    __slots__ = ('profile', 'file_store_profile', 'event')
    PROFILE_FIELD_NUMBER: _ClassVar[int]
    FILE_STORE_PROFILE_FIELD_NUMBER: _ClassVar[int]
    EVENT_FIELD_NUMBER: _ClassVar[int]
    profile: TableDataProfile
    file_store_profile: FileStoreDataProfile
    event: DataProfileAction.EventType

    def __init__(self, profile: _Optional[_Union[TableDataProfile, _Mapping]]=..., file_store_profile: _Optional[_Union[FileStoreDataProfile, _Mapping]]=..., event: _Optional[_Union[DataProfileAction.EventType, str]]=...) -> None:
        ...

class CreateConnectionRequest(_message.Message):
    __slots__ = ('parent', 'connection')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    CONNECTION_FIELD_NUMBER: _ClassVar[int]
    parent: str
    connection: Connection

    def __init__(self, parent: _Optional[str]=..., connection: _Optional[_Union[Connection, _Mapping]]=...) -> None:
        ...

class GetConnectionRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListConnectionsRequest(_message.Message):
    __slots__ = ('parent', 'page_size', 'page_token', 'filter')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_size: int
    page_token: str
    filter: str

    def __init__(self, parent: _Optional[str]=..., page_size: _Optional[int]=..., page_token: _Optional[str]=..., filter: _Optional[str]=...) -> None:
        ...

class SearchConnectionsRequest(_message.Message):
    __slots__ = ('parent', 'page_size', 'page_token', 'filter')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_size: int
    page_token: str
    filter: str

    def __init__(self, parent: _Optional[str]=..., page_size: _Optional[int]=..., page_token: _Optional[str]=..., filter: _Optional[str]=...) -> None:
        ...

class ListConnectionsResponse(_message.Message):
    __slots__ = ('connections', 'next_page_token')
    CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    connections: _containers.RepeatedCompositeFieldContainer[Connection]
    next_page_token: str

    def __init__(self, connections: _Optional[_Iterable[_Union[Connection, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class SearchConnectionsResponse(_message.Message):
    __slots__ = ('connections', 'next_page_token')
    CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    connections: _containers.RepeatedCompositeFieldContainer[Connection]
    next_page_token: str

    def __init__(self, connections: _Optional[_Iterable[_Union[Connection, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class UpdateConnectionRequest(_message.Message):
    __slots__ = ('name', 'connection', 'update_mask')
    NAME_FIELD_NUMBER: _ClassVar[int]
    CONNECTION_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    name: str
    connection: Connection
    update_mask: _field_mask_pb2.FieldMask

    def __init__(self, name: _Optional[str]=..., connection: _Optional[_Union[Connection, _Mapping]]=..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]]=...) -> None:
        ...

class DeleteConnectionRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class Connection(_message.Message):
    __slots__ = ('name', 'state', 'errors', 'cloud_sql')
    NAME_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    ERRORS_FIELD_NUMBER: _ClassVar[int]
    CLOUD_SQL_FIELD_NUMBER: _ClassVar[int]
    name: str
    state: ConnectionState
    errors: _containers.RepeatedCompositeFieldContainer[Error]
    cloud_sql: CloudSqlProperties

    def __init__(self, name: _Optional[str]=..., state: _Optional[_Union[ConnectionState, str]]=..., errors: _Optional[_Iterable[_Union[Error, _Mapping]]]=..., cloud_sql: _Optional[_Union[CloudSqlProperties, _Mapping]]=...) -> None:
        ...

class SecretManagerCredential(_message.Message):
    __slots__ = ('username', 'password_secret_version_name')
    USERNAME_FIELD_NUMBER: _ClassVar[int]
    PASSWORD_SECRET_VERSION_NAME_FIELD_NUMBER: _ClassVar[int]
    username: str
    password_secret_version_name: str

    def __init__(self, username: _Optional[str]=..., password_secret_version_name: _Optional[str]=...) -> None:
        ...

class CloudSqlIamCredential(_message.Message):
    __slots__ = ()

    def __init__(self) -> None:
        ...

class CloudSqlProperties(_message.Message):
    __slots__ = ('connection_name', 'username_password', 'cloud_sql_iam', 'max_connections', 'database_engine')

    class DatabaseEngine(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        DATABASE_ENGINE_UNKNOWN: _ClassVar[CloudSqlProperties.DatabaseEngine]
        DATABASE_ENGINE_MYSQL: _ClassVar[CloudSqlProperties.DatabaseEngine]
        DATABASE_ENGINE_POSTGRES: _ClassVar[CloudSqlProperties.DatabaseEngine]
    DATABASE_ENGINE_UNKNOWN: CloudSqlProperties.DatabaseEngine
    DATABASE_ENGINE_MYSQL: CloudSqlProperties.DatabaseEngine
    DATABASE_ENGINE_POSTGRES: CloudSqlProperties.DatabaseEngine
    CONNECTION_NAME_FIELD_NUMBER: _ClassVar[int]
    USERNAME_PASSWORD_FIELD_NUMBER: _ClassVar[int]
    CLOUD_SQL_IAM_FIELD_NUMBER: _ClassVar[int]
    MAX_CONNECTIONS_FIELD_NUMBER: _ClassVar[int]
    DATABASE_ENGINE_FIELD_NUMBER: _ClassVar[int]
    connection_name: str
    username_password: SecretManagerCredential
    cloud_sql_iam: CloudSqlIamCredential
    max_connections: int
    database_engine: CloudSqlProperties.DatabaseEngine

    def __init__(self, connection_name: _Optional[str]=..., username_password: _Optional[_Union[SecretManagerCredential, _Mapping]]=..., cloud_sql_iam: _Optional[_Union[CloudSqlIamCredential, _Mapping]]=..., max_connections: _Optional[int]=..., database_engine: _Optional[_Union[CloudSqlProperties.DatabaseEngine, str]]=...) -> None:
        ...

class DeleteTableDataProfileRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class DataSourceType(_message.Message):
    __slots__ = ('data_source',)
    DATA_SOURCE_FIELD_NUMBER: _ClassVar[int]
    data_source: str

    def __init__(self, data_source: _Optional[str]=...) -> None:
        ...

class FileClusterType(_message.Message):
    __slots__ = ('cluster',)

    class Cluster(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        CLUSTER_UNSPECIFIED: _ClassVar[FileClusterType.Cluster]
        CLUSTER_UNKNOWN: _ClassVar[FileClusterType.Cluster]
        CLUSTER_TEXT: _ClassVar[FileClusterType.Cluster]
        CLUSTER_STRUCTURED_DATA: _ClassVar[FileClusterType.Cluster]
        CLUSTER_SOURCE_CODE: _ClassVar[FileClusterType.Cluster]
        CLUSTER_RICH_DOCUMENT: _ClassVar[FileClusterType.Cluster]
        CLUSTER_IMAGE: _ClassVar[FileClusterType.Cluster]
        CLUSTER_ARCHIVE: _ClassVar[FileClusterType.Cluster]
        CLUSTER_MULTIMEDIA: _ClassVar[FileClusterType.Cluster]
        CLUSTER_EXECUTABLE: _ClassVar[FileClusterType.Cluster]
    CLUSTER_UNSPECIFIED: FileClusterType.Cluster
    CLUSTER_UNKNOWN: FileClusterType.Cluster
    CLUSTER_TEXT: FileClusterType.Cluster
    CLUSTER_STRUCTURED_DATA: FileClusterType.Cluster
    CLUSTER_SOURCE_CODE: FileClusterType.Cluster
    CLUSTER_RICH_DOCUMENT: FileClusterType.Cluster
    CLUSTER_IMAGE: FileClusterType.Cluster
    CLUSTER_ARCHIVE: FileClusterType.Cluster
    CLUSTER_MULTIMEDIA: FileClusterType.Cluster
    CLUSTER_EXECUTABLE: FileClusterType.Cluster
    CLUSTER_FIELD_NUMBER: _ClassVar[int]
    cluster: FileClusterType.Cluster

    def __init__(self, cluster: _Optional[_Union[FileClusterType.Cluster, str]]=...) -> None:
        ...