from google.api import field_behavior_pb2 as _field_behavior_pb2
from google.api import resource_pb2 as _resource_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union
DESCRIPTOR: _descriptor.FileDescriptor

class VulnerabilityReport(_message.Message):
    __slots__ = ('name', 'vulnerabilities', 'update_time')

    class Vulnerability(_message.Message):
        __slots__ = ('details', 'installed_inventory_item_ids', 'available_inventory_item_ids', 'create_time', 'update_time', 'items')

        class Details(_message.Message):
            __slots__ = ('cve', 'cvss_v2_score', 'cvss_v3', 'severity', 'description', 'references')

            class Reference(_message.Message):
                __slots__ = ('url', 'source')
                URL_FIELD_NUMBER: _ClassVar[int]
                SOURCE_FIELD_NUMBER: _ClassVar[int]
                url: str
                source: str

                def __init__(self, url: _Optional[str]=..., source: _Optional[str]=...) -> None:
                    ...
            CVE_FIELD_NUMBER: _ClassVar[int]
            CVSS_V2_SCORE_FIELD_NUMBER: _ClassVar[int]
            CVSS_V3_FIELD_NUMBER: _ClassVar[int]
            SEVERITY_FIELD_NUMBER: _ClassVar[int]
            DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
            REFERENCES_FIELD_NUMBER: _ClassVar[int]
            cve: str
            cvss_v2_score: float
            cvss_v3: CVSSv3
            severity: str
            description: str
            references: _containers.RepeatedCompositeFieldContainer[VulnerabilityReport.Vulnerability.Details.Reference]

            def __init__(self, cve: _Optional[str]=..., cvss_v2_score: _Optional[float]=..., cvss_v3: _Optional[_Union[CVSSv3, _Mapping]]=..., severity: _Optional[str]=..., description: _Optional[str]=..., references: _Optional[_Iterable[_Union[VulnerabilityReport.Vulnerability.Details.Reference, _Mapping]]]=...) -> None:
                ...

        class Item(_message.Message):
            __slots__ = ('installed_inventory_item_id', 'available_inventory_item_id', 'fixed_cpe_uri', 'upstream_fix')
            INSTALLED_INVENTORY_ITEM_ID_FIELD_NUMBER: _ClassVar[int]
            AVAILABLE_INVENTORY_ITEM_ID_FIELD_NUMBER: _ClassVar[int]
            FIXED_CPE_URI_FIELD_NUMBER: _ClassVar[int]
            UPSTREAM_FIX_FIELD_NUMBER: _ClassVar[int]
            installed_inventory_item_id: str
            available_inventory_item_id: str
            fixed_cpe_uri: str
            upstream_fix: str

            def __init__(self, installed_inventory_item_id: _Optional[str]=..., available_inventory_item_id: _Optional[str]=..., fixed_cpe_uri: _Optional[str]=..., upstream_fix: _Optional[str]=...) -> None:
                ...
        DETAILS_FIELD_NUMBER: _ClassVar[int]
        INSTALLED_INVENTORY_ITEM_IDS_FIELD_NUMBER: _ClassVar[int]
        AVAILABLE_INVENTORY_ITEM_IDS_FIELD_NUMBER: _ClassVar[int]
        CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
        UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
        ITEMS_FIELD_NUMBER: _ClassVar[int]
        details: VulnerabilityReport.Vulnerability.Details
        installed_inventory_item_ids: _containers.RepeatedScalarFieldContainer[str]
        available_inventory_item_ids: _containers.RepeatedScalarFieldContainer[str]
        create_time: _timestamp_pb2.Timestamp
        update_time: _timestamp_pb2.Timestamp
        items: _containers.RepeatedCompositeFieldContainer[VulnerabilityReport.Vulnerability.Item]

        def __init__(self, details: _Optional[_Union[VulnerabilityReport.Vulnerability.Details, _Mapping]]=..., installed_inventory_item_ids: _Optional[_Iterable[str]]=..., available_inventory_item_ids: _Optional[_Iterable[str]]=..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=..., items: _Optional[_Iterable[_Union[VulnerabilityReport.Vulnerability.Item, _Mapping]]]=...) -> None:
            ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    VULNERABILITIES_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    name: str
    vulnerabilities: _containers.RepeatedCompositeFieldContainer[VulnerabilityReport.Vulnerability]
    update_time: _timestamp_pb2.Timestamp

    def __init__(self, name: _Optional[str]=..., vulnerabilities: _Optional[_Iterable[_Union[VulnerabilityReport.Vulnerability, _Mapping]]]=..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=...) -> None:
        ...

class GetVulnerabilityReportRequest(_message.Message):
    __slots__ = ('name',)
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str

    def __init__(self, name: _Optional[str]=...) -> None:
        ...

class ListVulnerabilityReportsRequest(_message.Message):
    __slots__ = ('parent', 'page_size', 'page_token', 'filter')
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    parent: str
    page_size: int
    page_token: str
    filter: str

    def __init__(self, parent: _Optional[str]=..., page_size: _Optional[int]=..., page_token: _Optional[str]=..., filter: _Optional[str]=...) -> None:
        ...

class ListVulnerabilityReportsResponse(_message.Message):
    __slots__ = ('vulnerability_reports', 'next_page_token')
    VULNERABILITY_REPORTS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    vulnerability_reports: _containers.RepeatedCompositeFieldContainer[VulnerabilityReport]
    next_page_token: str

    def __init__(self, vulnerability_reports: _Optional[_Iterable[_Union[VulnerabilityReport, _Mapping]]]=..., next_page_token: _Optional[str]=...) -> None:
        ...

class CVSSv3(_message.Message):
    __slots__ = ('base_score', 'exploitability_score', 'impact_score', 'attack_vector', 'attack_complexity', 'privileges_required', 'user_interaction', 'scope', 'confidentiality_impact', 'integrity_impact', 'availability_impact')

    class AttackVector(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        ATTACK_VECTOR_UNSPECIFIED: _ClassVar[CVSSv3.AttackVector]
        ATTACK_VECTOR_NETWORK: _ClassVar[CVSSv3.AttackVector]
        ATTACK_VECTOR_ADJACENT: _ClassVar[CVSSv3.AttackVector]
        ATTACK_VECTOR_LOCAL: _ClassVar[CVSSv3.AttackVector]
        ATTACK_VECTOR_PHYSICAL: _ClassVar[CVSSv3.AttackVector]
    ATTACK_VECTOR_UNSPECIFIED: CVSSv3.AttackVector
    ATTACK_VECTOR_NETWORK: CVSSv3.AttackVector
    ATTACK_VECTOR_ADJACENT: CVSSv3.AttackVector
    ATTACK_VECTOR_LOCAL: CVSSv3.AttackVector
    ATTACK_VECTOR_PHYSICAL: CVSSv3.AttackVector

    class AttackComplexity(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        ATTACK_COMPLEXITY_UNSPECIFIED: _ClassVar[CVSSv3.AttackComplexity]
        ATTACK_COMPLEXITY_LOW: _ClassVar[CVSSv3.AttackComplexity]
        ATTACK_COMPLEXITY_HIGH: _ClassVar[CVSSv3.AttackComplexity]
    ATTACK_COMPLEXITY_UNSPECIFIED: CVSSv3.AttackComplexity
    ATTACK_COMPLEXITY_LOW: CVSSv3.AttackComplexity
    ATTACK_COMPLEXITY_HIGH: CVSSv3.AttackComplexity

    class PrivilegesRequired(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        PRIVILEGES_REQUIRED_UNSPECIFIED: _ClassVar[CVSSv3.PrivilegesRequired]
        PRIVILEGES_REQUIRED_NONE: _ClassVar[CVSSv3.PrivilegesRequired]
        PRIVILEGES_REQUIRED_LOW: _ClassVar[CVSSv3.PrivilegesRequired]
        PRIVILEGES_REQUIRED_HIGH: _ClassVar[CVSSv3.PrivilegesRequired]
    PRIVILEGES_REQUIRED_UNSPECIFIED: CVSSv3.PrivilegesRequired
    PRIVILEGES_REQUIRED_NONE: CVSSv3.PrivilegesRequired
    PRIVILEGES_REQUIRED_LOW: CVSSv3.PrivilegesRequired
    PRIVILEGES_REQUIRED_HIGH: CVSSv3.PrivilegesRequired

    class UserInteraction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        USER_INTERACTION_UNSPECIFIED: _ClassVar[CVSSv3.UserInteraction]
        USER_INTERACTION_NONE: _ClassVar[CVSSv3.UserInteraction]
        USER_INTERACTION_REQUIRED: _ClassVar[CVSSv3.UserInteraction]
    USER_INTERACTION_UNSPECIFIED: CVSSv3.UserInteraction
    USER_INTERACTION_NONE: CVSSv3.UserInteraction
    USER_INTERACTION_REQUIRED: CVSSv3.UserInteraction

    class Scope(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        SCOPE_UNSPECIFIED: _ClassVar[CVSSv3.Scope]
        SCOPE_UNCHANGED: _ClassVar[CVSSv3.Scope]
        SCOPE_CHANGED: _ClassVar[CVSSv3.Scope]
    SCOPE_UNSPECIFIED: CVSSv3.Scope
    SCOPE_UNCHANGED: CVSSv3.Scope
    SCOPE_CHANGED: CVSSv3.Scope

    class Impact(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        IMPACT_UNSPECIFIED: _ClassVar[CVSSv3.Impact]
        IMPACT_HIGH: _ClassVar[CVSSv3.Impact]
        IMPACT_LOW: _ClassVar[CVSSv3.Impact]
        IMPACT_NONE: _ClassVar[CVSSv3.Impact]
    IMPACT_UNSPECIFIED: CVSSv3.Impact
    IMPACT_HIGH: CVSSv3.Impact
    IMPACT_LOW: CVSSv3.Impact
    IMPACT_NONE: CVSSv3.Impact
    BASE_SCORE_FIELD_NUMBER: _ClassVar[int]
    EXPLOITABILITY_SCORE_FIELD_NUMBER: _ClassVar[int]
    IMPACT_SCORE_FIELD_NUMBER: _ClassVar[int]
    ATTACK_VECTOR_FIELD_NUMBER: _ClassVar[int]
    ATTACK_COMPLEXITY_FIELD_NUMBER: _ClassVar[int]
    PRIVILEGES_REQUIRED_FIELD_NUMBER: _ClassVar[int]
    USER_INTERACTION_FIELD_NUMBER: _ClassVar[int]
    SCOPE_FIELD_NUMBER: _ClassVar[int]
    CONFIDENTIALITY_IMPACT_FIELD_NUMBER: _ClassVar[int]
    INTEGRITY_IMPACT_FIELD_NUMBER: _ClassVar[int]
    AVAILABILITY_IMPACT_FIELD_NUMBER: _ClassVar[int]
    base_score: float
    exploitability_score: float
    impact_score: float
    attack_vector: CVSSv3.AttackVector
    attack_complexity: CVSSv3.AttackComplexity
    privileges_required: CVSSv3.PrivilegesRequired
    user_interaction: CVSSv3.UserInteraction
    scope: CVSSv3.Scope
    confidentiality_impact: CVSSv3.Impact
    integrity_impact: CVSSv3.Impact
    availability_impact: CVSSv3.Impact

    def __init__(self, base_score: _Optional[float]=..., exploitability_score: _Optional[float]=..., impact_score: _Optional[float]=..., attack_vector: _Optional[_Union[CVSSv3.AttackVector, str]]=..., attack_complexity: _Optional[_Union[CVSSv3.AttackComplexity, str]]=..., privileges_required: _Optional[_Union[CVSSv3.PrivilegesRequired, str]]=..., user_interaction: _Optional[_Union[CVSSv3.UserInteraction, str]]=..., scope: _Optional[_Union[CVSSv3.Scope, str]]=..., confidentiality_impact: _Optional[_Union[CVSSv3.Impact, str]]=..., integrity_impact: _Optional[_Union[CVSSv3.Impact, str]]=..., availability_impact: _Optional[_Union[CVSSv3.Impact, str]]=...) -> None:
        ...