from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.devtools.containeranalysis.v1beta1.common import common_pb2 as _common_pb2
from google.devtools.containeranalysis.v1beta1.cvss import cvss_pb2 as _cvss_pb2
from google.devtools.containeranalysis.v1beta1.package import package_pb2 as _package_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union
DESCRIPTOR: _descriptor.FileDescriptor

class Severity(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    SEVERITY_UNSPECIFIED: _ClassVar[Severity]
    MINIMAL: _ClassVar[Severity]
    LOW: _ClassVar[Severity]
    MEDIUM: _ClassVar[Severity]
    HIGH: _ClassVar[Severity]
    CRITICAL: _ClassVar[Severity]
SEVERITY_UNSPECIFIED: Severity
MINIMAL: Severity
LOW: Severity
MEDIUM: Severity
HIGH: Severity
CRITICAL: Severity

class Vulnerability(_message.Message):
    __slots__ = ('cvss_score', 'severity', 'details', 'cvss_v3', 'windows_details', 'source_update_time')

    class Detail(_message.Message):
        __slots__ = ('cpe_uri', 'package', 'min_affected_version', 'max_affected_version', 'severity_name', 'description', 'fixed_location', 'package_type', 'is_obsolete', 'source_update_time')
        CPE_URI_FIELD_NUMBER: _ClassVar[int]
        PACKAGE_FIELD_NUMBER: _ClassVar[int]
        MIN_AFFECTED_VERSION_FIELD_NUMBER: _ClassVar[int]
        MAX_AFFECTED_VERSION_FIELD_NUMBER: _ClassVar[int]
        SEVERITY_NAME_FIELD_NUMBER: _ClassVar[int]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        FIXED_LOCATION_FIELD_NUMBER: _ClassVar[int]
        PACKAGE_TYPE_FIELD_NUMBER: _ClassVar[int]
        IS_OBSOLETE_FIELD_NUMBER: _ClassVar[int]
        SOURCE_UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
        cpe_uri: str
        package: str
        min_affected_version: _package_pb2.Version
        max_affected_version: _package_pb2.Version
        severity_name: str
        description: str
        fixed_location: VulnerabilityLocation
        package_type: str
        is_obsolete: bool
        source_update_time: _timestamp_pb2.Timestamp

        def __init__(self, cpe_uri: _Optional[str]=..., package: _Optional[str]=..., min_affected_version: _Optional[_Union[_package_pb2.Version, _Mapping]]=..., max_affected_version: _Optional[_Union[_package_pb2.Version, _Mapping]]=..., severity_name: _Optional[str]=..., description: _Optional[str]=..., fixed_location: _Optional[_Union[VulnerabilityLocation, _Mapping]]=..., package_type: _Optional[str]=..., is_obsolete: bool=..., source_update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=...) -> None:
            ...

    class WindowsDetail(_message.Message):
        __slots__ = ('cpe_uri', 'name', 'description', 'fixing_kbs')

        class KnowledgeBase(_message.Message):
            __slots__ = ('name', 'url')
            NAME_FIELD_NUMBER: _ClassVar[int]
            URL_FIELD_NUMBER: _ClassVar[int]
            name: str
            url: str

            def __init__(self, name: _Optional[str]=..., url: _Optional[str]=...) -> None:
                ...
        CPE_URI_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        FIXING_KBS_FIELD_NUMBER: _ClassVar[int]
        cpe_uri: str
        name: str
        description: str
        fixing_kbs: _containers.RepeatedCompositeFieldContainer[Vulnerability.WindowsDetail.KnowledgeBase]

        def __init__(self, cpe_uri: _Optional[str]=..., name: _Optional[str]=..., description: _Optional[str]=..., fixing_kbs: _Optional[_Iterable[_Union[Vulnerability.WindowsDetail.KnowledgeBase, _Mapping]]]=...) -> None:
            ...
    CVSS_SCORE_FIELD_NUMBER: _ClassVar[int]
    SEVERITY_FIELD_NUMBER: _ClassVar[int]
    DETAILS_FIELD_NUMBER: _ClassVar[int]
    CVSS_V3_FIELD_NUMBER: _ClassVar[int]
    WINDOWS_DETAILS_FIELD_NUMBER: _ClassVar[int]
    SOURCE_UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    cvss_score: float
    severity: Severity
    details: _containers.RepeatedCompositeFieldContainer[Vulnerability.Detail]
    cvss_v3: _cvss_pb2.CVSSv3
    windows_details: _containers.RepeatedCompositeFieldContainer[Vulnerability.WindowsDetail]
    source_update_time: _timestamp_pb2.Timestamp

    def __init__(self, cvss_score: _Optional[float]=..., severity: _Optional[_Union[Severity, str]]=..., details: _Optional[_Iterable[_Union[Vulnerability.Detail, _Mapping]]]=..., cvss_v3: _Optional[_Union[_cvss_pb2.CVSSv3, _Mapping]]=..., windows_details: _Optional[_Iterable[_Union[Vulnerability.WindowsDetail, _Mapping]]]=..., source_update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]]=...) -> None:
        ...

class Details(_message.Message):
    __slots__ = ('type', 'severity', 'cvss_score', 'package_issue', 'short_description', 'long_description', 'related_urls', 'effective_severity')
    TYPE_FIELD_NUMBER: _ClassVar[int]
    SEVERITY_FIELD_NUMBER: _ClassVar[int]
    CVSS_SCORE_FIELD_NUMBER: _ClassVar[int]
    PACKAGE_ISSUE_FIELD_NUMBER: _ClassVar[int]
    SHORT_DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    LONG_DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    RELATED_URLS_FIELD_NUMBER: _ClassVar[int]
    EFFECTIVE_SEVERITY_FIELD_NUMBER: _ClassVar[int]
    type: str
    severity: Severity
    cvss_score: float
    package_issue: _containers.RepeatedCompositeFieldContainer[PackageIssue]
    short_description: str
    long_description: str
    related_urls: _containers.RepeatedCompositeFieldContainer[_common_pb2.RelatedUrl]
    effective_severity: Severity

    def __init__(self, type: _Optional[str]=..., severity: _Optional[_Union[Severity, str]]=..., cvss_score: _Optional[float]=..., package_issue: _Optional[_Iterable[_Union[PackageIssue, _Mapping]]]=..., short_description: _Optional[str]=..., long_description: _Optional[str]=..., related_urls: _Optional[_Iterable[_Union[_common_pb2.RelatedUrl, _Mapping]]]=..., effective_severity: _Optional[_Union[Severity, str]]=...) -> None:
        ...

class PackageIssue(_message.Message):
    __slots__ = ('affected_location', 'fixed_location', 'severity_name')
    AFFECTED_LOCATION_FIELD_NUMBER: _ClassVar[int]
    FIXED_LOCATION_FIELD_NUMBER: _ClassVar[int]
    SEVERITY_NAME_FIELD_NUMBER: _ClassVar[int]
    affected_location: VulnerabilityLocation
    fixed_location: VulnerabilityLocation
    severity_name: str

    def __init__(self, affected_location: _Optional[_Union[VulnerabilityLocation, _Mapping]]=..., fixed_location: _Optional[_Union[VulnerabilityLocation, _Mapping]]=..., severity_name: _Optional[str]=...) -> None:
        ...

class VulnerabilityLocation(_message.Message):
    __slots__ = ('cpe_uri', 'package', 'version')
    CPE_URI_FIELD_NUMBER: _ClassVar[int]
    PACKAGE_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    cpe_uri: str
    package: str
    version: _package_pb2.Version

    def __init__(self, cpe_uri: _Optional[str]=..., package: _Optional[str]=..., version: _Optional[_Union[_package_pb2.Version, _Mapping]]=...) -> None:
        ...